<?php require_once ("Secure_area.php");
// require_once (APPPATH."libraries/ofc-library/open-flash-chart.php");

class Analyses extends Secure_area 
{	
	function __construct()
	{
		parent::__construct('Analyses');
		$this->load->helper('report');
	}
	
	//Initial report listing screen
	function index()
	{
		$mode_menu = 'analyses';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
	}

	function _get_common_report_data()
	{
		$data = array();
		$data['report_date_range_simple'] = get_simple_date_ranges();
		$data['years'] = get_years(1);
		$data['months'] = get_months(1);
		$data['days'] = get_days();
		$data['selected_month']=date('n');
		$data['selected_day']=date('d',strtotime('-1 second',strtotime('+1 month',strtotime(date('m').'/01/'.date('Y').' 00:00:00'))));
		$data['selected_year']=date('Y');
		$data['daily_day']=date('d');

		// вземам си БРАНДОВЕ
			$data['brands'] = array('0' => $this->lang->line('reports_all_brands'));
			foreach ($this->BiSOFT_Model->get_brands()->result() as $brand)
				{ $data['brands'][$brand->client_id] = character_limiter($brand->name,70); }
				
		// вземам си всички КЛИЕНТИ
			$data['customers'] = array('0' => $this->lang->line('reports_all_clients'));
			foreach ($this->Customer->get_all()->result() as $customer)
				{ 
					$company_name = $customer->company_name;
					if(strlen($company_name)>70) { $company_name = substr($company_name,0,68).' ...'; }
					$data['customers'][$customer->bisoft_id] = $company_name; 
				}

		// вземам си всички МАГАЗИНИ
			$data['consignees'] = array('0' => $this->lang->line('reports_all_consis'));
			foreach ($this->Consignee->get_all()->result() as $consignee)
				{ $data['consignees'][$consignee->bisoft_id] = character_limiter($consignee->company_name,70); }

		// вземам си всички ДОСТАВЧИЦИ
			$data['suppliers'] = array('0' => $this->lang->line('reports_all_suppliers'));
			foreach ($this->Supplier->get_all()->result() as $supplier)
				{ 
					$company_name = $supplier->company_name;
					if(strlen($company_name)>70) { $company_name = substr($company_name,0,68).' ...'; }
					$data['suppliers'][$supplier->bisoft_id] = $company_name; 
				}
	
	return $data;
	}

	

/* ----------------------------------------- PERIOD FOR ANALYSE ------------------------------ */

	function period_analyses()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'analyses';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['clients'] = $this->lang->line('reports_analyse');
		$this->load->view("analyses/period_analyses",$data);	
	}

/* -------------------------------------------- PROFIT ANALYSE ------------------------------ */
	function analyse_profits($start_date, $end_date, $type, $items_arr, $brand, $customer, $consignee, $supplier, 
									 $join_groups=0, $export_excel=0)
	{
		$this->load->model('analyses/Profits');
		$model = $this->Profits;

		$items = explode("%20",$items_arr);
		$ved_1 = date('ym', strtotime($start_date));
		$ved_2 = date('ym', strtotime($end_date));
		$all_qty = $all_suma = $all_total = $all_vat = $all_profit = 0;
		$tabular_data = $gr_qty = $gr_suma = $gr_tax = array();

		$all_months = array(
							'0' => '',
							'1' => 'януари',
							'2' => 'февруари',
							'3' => 'март',
							'4' => 'април',
							'5' => 'май',
							'6' => 'юни',
							'7' => 'юли',
							'8' => 'август',
							'9' => 'септември',
						  '10' => 'октомври',
						  '11' => 'ноември',
						  '12' => 'декември' );

		$limit = count($items);
		for($k=0;$k<$limit;$k++)
		{  $item_i = $items[$k];
			if($item_i>0 or $item_i=='styler' or $item_i=='vitality' or 
								 $item_i=='macka'  or $item_i=='fenotag' or 
                         $item_i=='ties'   or $item_i=='bowties' or 
                         $item_i=='belts'  or $item_i=='old' or 
                         $item_i=='accs'   or $item_i=='oldaccs' or 
                         $item_i=='all')
			{
				$vedom = $ved_1;
				if($ved_2 >= $ved_1) // само ако диапазонът е нормален ...
				{
				 do
					{	$report_data = $model->getData(array(
																'vedom'		=> $vedom,
																'item'		=> $item_i,
																'brand'		=> $brand,
																'customer'	=> $customer,
																'consignee'	=> $consignee,
																'supplier'	=> $supplier,
															 'join_groups' => $join_groups,
																'type'		=> $type	) );

						foreach($report_data as $row)
							{
								$document 	= $this->BiSOFT_Model->get_document_title_id($row['mode_id']);
								
								$inum = $row['item_number'];
								$item_info  = $this->Item->get_item_info($inum);
								$sklad_info = $this->Item->get_sklad_info($inum,0);
								$item_name  = $item_info->name;
								
									$gr_name = '<< ТАЗИ ГРУПА НЯМА НАИМНОВАНИЕ ?! >>';
									$gr_inum = 1000*substr($inum,0,-3);
									
									if($gr_inum>999 and $gr_inum<99000)
									{
										$gr_inum_limit = $gr_inum+999;
										if($this->Item->exists_in_items($gr_inum)) 
											{ $gr_name = $this->Item->get_name($gr_inum); }
									}
									
								$cost_price = 0;
								if($sklad_info and $type!='invoice') {$cost_price = $sklad_info->cost;}
								$qty_sold	= $row['all_qty'];
								$all_sum		= $row['subtotal'];
								$tax			= 0; if($row['tax']>0 and $type=='invoice') {$tax=$row['tax'];}

								// клиенти / доставчици
								$now_client = '';
								if($customer>0 and $consignee==0 and $supplier==0)		 
									{ $now_client=$this->Customer->get_info_by_bisoft_id($row['client_id'])->company_name; }
								elseif($consignee>0 and $customer==0 and $supplier==0) 
									{ $now_client=$this->Consignee->get_info_by_bisoft_id($row['client_id'])->company_name; }
								elseif($supplier>0 and $customer==0 and $consignee==0) 
									{ $now_client=$this->Supplier->get_info_by_bisoft_id($row['supplier_id'])->company_name; }

								// дати и периоди ...
								$nowYear = '20'.substr($vedom,0,2);
                     // $nowMonth = $all_months[(int)substr($vedom,-2)];
								$nowMonth = substr($vedom,-2);
								$nowVedom = $nowYear.' - '.$nowMonth;

								$profit	 = '';
								if ($cost_price > 0) 
											{ 
												$cost_price	= to_currency_no_money($cost_price);				
												$cost_amount = to_currency_no_money($cost_price * $qty_sold);
												$profit = to_currency_no_money($all_sum - $cost_amount);
												$all_profit += ($all_sum - $cost_amount);
											}
										else 
											{ 
												$cost_price = '';
												$cost_amount = ''; 
											}

								if($join_groups) // ПО ГРУПИ
								{
									if( isset($gr_qty[$gr_inum])  ) {$gr_qty[$gr_inum]+=$qty_sold;}
									else {$gr_qty[$gr_inum]=$qty_sold;}
									
									if( isset($gr_suma[$gr_inum]) ) {$gr_suma[$gr_inum]+=$row['subtotal'];}
									else {$gr_suma[$gr_inum]=$row['subtotal'];}
																	
									if( isset($gr_tax[$gr_inum]) ) {$gr_tax[$gr_inum]+=$tax;}
									else {$gr_tax[$gr_inum]=$tax;}

									if(!isset($tabular_data[$gr_inum]))
                           {
                              $tabular_data[$gr_inum] = array(
                                 'ved'  => $nowVedom,  			// 1
                                 'inum' => $gr_inum,  			// 2
                                 'name' => $gr_name,				// 3
                                 'qty'  => $qty_sold, // $gr_qty[$gr_inum],	// 4
                                 'suma' => $row['subtotal'], // $gr_suma[$gr_inum],	// 5
                                 'tax'  => $tax, // $gr_tax[$gr_inum],	// 6
                               'client' => $now_client,			// 7
                                 'mode' => $row['mode_id'] 		// 8
                                                      );
                           }
                           else
                           {
                              $tabular_data[$gr_inum]['qty']   += $qty_sold;        // $gr_qty[$gr_inum];
                              $tabular_data[$gr_inum]['suma']  += $row['subtotal']; // $gr_suma[$gr_inum];
                              $tabular_data[$gr_inum]['tax']   += $tax;             // $gr_tax[$gr_inum];
                           }

								}
								else // НЕ ПО ГРУПИ
								{
                           if(!isset($tabular_data[$inum]))
                           {
                              $tabular_data[$inum] = array(
                                 'ved'  => $nowVedom,  			// 1
                                 'inum' => $inum,  				// 2
                                 'name' => $item_name,			// 3
                                 'qty'  => $row['all_qty'],    // $qty_sold,				// 4
                                 'suma' => $row['subtotal'],	// 5
                                 'tax'  => $tax,					// 6
                               'client' => $now_client,			// 7
                                 'mode' => $row['mode_id'] 		// 8
                                                      );
                           }
                           else
                           {
                              $tabular_data[$inum]['qty']   += $row['all_qty']; // $qty_sold;
                              $tabular_data[$inum]['suma']  += $row['subtotal'];
                              $tabular_data[$inum]['tax']   += $tax;
                           }
                           
								}

							} // end of foreach($report_data

						// пресмятаме края на диапазона ...
						$vedom++;
						if ( ($vedom-100*round($vedom/100,0))==13 ) { $vedom+=88;} // нежно преминава в другата година ...
					} while ($vedom <= $ved_2);
				}
				else // Диапазонът е ГРЕШЕН ...
				{
					echo 'ERROR Period Range ?!?';
					die();
				}

			} // end of if item_i > 0
		} // end of for($k=0 ...

		$summary_data = array(
			"reports_quantity"	=> $all_qty,
			"reports_subtotal"	=> $all_suma,
			"reports_vat"			=> $all_vat,
			"reports_total"  		=> $all_total
									);

		$start_period	= $all_months[(int)date('m', strtotime($start_date))].' '.date('Y', strtotime($start_date));
		$end_period		= $all_months[(int)date('m', strtotime($end_date))].' '.date('Y', strtotime($end_date));
		$title_add		= $this->lang->line('reports_SALES');
		
			switch ($type) 
				{
               case 'manu':		$title_add = $this->lang->line('common_STARTSGP'); break;
               case 'recv':		$title_add = $this->lang->line('reports_RECV'); break;
               case 'all_recv':	$title_add = $this->lang->line('reports_MANU_RECV'); break;
               case 'shop_sale':	$title_add = $this->lang->line('reports_SHOP_SALES'); break;
               case 'all_sale':	$title_add = $this->lang->line('reports_ALL_SALES'); break;
               case 'online':		$title_add = $this->lang->line('reports_ONLINE_SALES'); break;
               case 'invoice':	$title_add = $this->lang->line('reports_INVOICES'); break;
				}
				
		if($items_arr=='macka') { $title_add .=' << МАСКИ >>'; }
		elseif($items_arr=='fenotag') { $title_add .=' << FENOTAGS >>'; }
				
		if($join_groups) { $title_add .= '<br> << ПО ГРУПИ >>';}

		$data = array(
			"title" 		=> $this->lang->line('reports_ANALYSE').' '.$title_add,
			"subtitle"	=> $this->lang->line('reports_date_period').': '.$start_period.' - '.$end_period,
			"headers"	=> $model->getDataColumns($type),
			"data"		=> $tabular_data,
		"summary_data" => $summary_data,
			  "all_qty" => $all_qty,
			 "all_suma" => $all_suma,
			  "all_vat" => $all_vat,
				  "mode" => $type,
				"brand"	=> $brand,
			"customer"	=> $customer,
			"consignee"	=> $consignee,
			"supplier"	=> $supplier,
		 "join_groups" => $join_groups,
		"export_excel" => $export_excel );
		
	$this->load->view("analyses/tabular_profits",$data);
	}
	
	
/* ----------------------------------------- PERIOD FOR ONLINES ANALYSE ------------------------------ */

	function period_onlines_analyses()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'analyses_onlines';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['clients'] = $this->lang->line('reports_analyse');
		$this->load->view("analyses/period_onlines_analyses",$data);	
	}	
	
/* ----------------------------------- ANALYSE ONLINES --------------------------- */
	function analyse_onlines( $start_date, $end_date, $type, $items_arr, $join_groups=0, $export_excel=0 )
	{
		$this->load->model('analyses/Profits');
		$model = $this->Profits;

		$items = explode("%20",$items_arr);
		$ved_1 = date('ym', strtotime($start_date));
		$ved_2 = date('ym', strtotime($end_date));
		$all_qty = $all_suma = $all_total = $all_vat = $all_profit = 0;
		$tabular_data = $gr_qty = $gr_suma = $gr_tax = array();

		$all_months = array(
							'0' => '',
							'1' => 'януари',
							'2' => 'февруари',
							'3' => 'март',
							'4' => 'април',
							'5' => 'май',
							'6' => 'юни',
							'7' => 'юли',
							'8' => 'август',
							'9' => 'септември',
						  '10' => 'октомври',
						  '11' => 'ноември',
						  '12' => 'декември' );
				  
		$limit = count($items);
		$non_saled = $saled_items = array();
		$all_online_items = $model->get_allOnlineItems();
								
		
		for($k=0;$k<$limit;$k++)
		{  $item_i = $items[$k];
			if($item_i>0 or $item_i=='all')
			{
				$vedom = $ved_1;
				if($ved_2 >= $ved_1) // само ако диапазонът е нормален ...
				{
				 do
					{	$report_data = $model->getOnlinesData(array(
																'vedom'		=> $vedom,
																'item'		=> $item_i,
															 'join_groups' => $join_groups,
																'type'		=> $type	) );
										
						if($type=="onlines")
						{
							foreach($report_data as $row)
								{
									$document 	= $this->BiSOFT_Model->get_document_title_id($row['mode_id']);
									
									$inum = $row['item_number'];
									$item_name = '';
									$item_info  = $this->Item->get_item_info($inum);
									if($item_info) {$item_name = $item_info->name;}
									
									$instock = 0;
									$sklad_info = $this->Item->get_sklad_info($inum,0);
									if($sklad_info) {$instock = (int) $sklad_info->qty;}
									
									
										$gr_name = '<< ТАЗИ ГРУПА НЯМА НАИМНОВАНИЕ ?! >>';
										$gr_inum = 1000*substr($inum,0,-3);
										
										if($gr_inum>999 and $gr_inum<99000)
										{
											$gr_inum_limit = $gr_inum+999;
											if($this->Item->exists_in_items($gr_inum)) 
												{ $gr_name = $this->Item->get_name($gr_inum); }
										}

									$qty_sold	= $row['all_qty'];
									$all_sum		= $row['subtotal'];

									// дати и периоди ...
									$nowYear = '20'.substr($vedom,0,2);
									// $nowMonth = $all_months[(int)substr($vedom,-2)];
									$nowMonth = substr($vedom,-2);
									$nowVedom = $nowYear.' - '.$nowMonth;

									if($join_groups) // ПО ГРУПИ
									{
										if(isset($gr_qty[$gr_inum]) and $gr_inum) {$gr_qty[$gr_inum]+=$qty_sold;}
										else {$gr_qty[$gr_inum]=$qty_sold;}
										
										if(isset($gr_suma[$gr_inum]) and $gr_inum) {$gr_suma[$gr_inum]+=$row['subtotal'];}
										else {$gr_suma[$gr_inum]=$row['subtotal'];}

										$tabular_data[$gr_inum] = array(
											'inum' => $gr_inum,  			// 1
											'name' => $gr_name,				// 2
											'qty'  => $gr_qty[$gr_inum],	// 3
											'suma' => $gr_suma[$gr_inum],	// 4
										'instock' => '' );
									}
									else // НЕ ПО ГРУПИ
									{
										$tabular_data[$inum] = array(
											'inum' => $inum,  				// 1
											'name' => $item_name,			// 2
											'qty'  => $qty_sold,				// 3
											'suma' => $row['subtotal'],	// 4
										'instock' => $instock );
									}
																
									$all_qty   += $row['all_qty'];
									$all_suma  += $row['subtotal'];
									$all_total += $row['subtotal'];
										
								} // end of foreach($report_data
							} // if($type=="onlines")
							elseif($type=="nosales")										
							{
								foreach($report_data as $row)
								{
									$inum = $row['item_number'];
									if( !in_array($inum,$saled_items) )
										{ $saled_items[]=$inum; }
								}

							} // elseif($type=="nosales")
							
						// пресмятаме края на диапазона ...
						$vedom++;
						if ( ($vedom-100*round($vedom/100,0))==13 ) { $vedom+=88;} // преминава в другата година ...
					} while ($vedom <= $ved_2);
				}
				else // Диапазонът е ГРЕШЕН ...
				{
					echo 'ERROR Period Range ?!?';
					die();
				}

			} // end of if item_i > 0
		} // end of for($k=0 ...						  
						  
						  
		if($type=="nosales")
		{
			foreach($all_online_items as $any)
			{
				$inum = $any['item_number'];
				if( !in_array($inum,$saled_items) )
					{ 
						$item_info  = $this->Item->get_item_info($inum);
						$sklad_info = $this->Item->get_sklad_info($inum,0);
						$item_name  = $item_info->name;
									
						$tabular_data[$inum] = array(
									'inum' => $inum,  		// 1
									'name' => $item_name,	// 2
									'qty'  => 0,				// 3
									'suma' => 0,				// 4
								'instock' => (int)$sklad_info->qty );
					}
			}
		}
			
		$summary_data = array(
			"reports_quantity"	=> $all_qty,
			"reports_subtotal"	=> $all_suma,
			"reports_vat"			=> $all_vat,
			"reports_total"  		=> $all_total );
									
		$start_period	= $all_months[(int)date('m', strtotime($start_date))].' '.date('Y', strtotime($start_date));
		$end_period		= $all_months[(int)date('m', strtotime($end_date))].' '.date('Y', strtotime($end_date));

		$subtitle = ' - '.$this->lang->line('reports_ONLINE_SALES');
		if($type=='nosales') {$subtitle = ' - '.$this->lang->line('reports_nosales');}
		
		$data = array(
			"title" 		=> $this->lang->line('reports_ANALYSE').$subtitle,
			"subtitle"	=> $this->lang->line('reports_date_period').': '.$start_period.' - '.$end_period,
			"headers"	=> $model->getOnlinesColumns($join_groups),
			"data"		=> $tabular_data,
			  "all_qty" => $all_qty,
			 "all_suma" => $all_suma,
			  "all_vat" => $all_vat,
				  "mode" => $type,
		 "join_groups" => $join_groups,
		"export_excel" => $export_excel
							);
	
	$this->load->view("analyses/tabular_onlines",$data);
	}


	function view_item($inum=0)
	{
		$data['location']	= 0;
				$data['user_id']	= $this->BiSOFT_Model->get_person();
				$data['status'] 	= $data['inum'] = $inum;
				$data['item_online'] = $item_online = $this->OnLine->get_online_item($inum);

				$data['valutas'] = array(
					'1' => 'BGN',
					'2' => 'EUR',
					'3' => 'GBP',
					'4' => 'USD');
				
				foreach ( $this->Item->get_collections()->result() as $collection)
					{ $collections[$collection->key] = $collection->collection_bg; }
					
				$data['collection']  = $item_online->coll;
				$data['collections'] = $collections;
				
				foreach ( $this->Item->get_category()->result() as $category)
					{ $categories[$category->cat_id] = $category->category_bg; }
					
				$data['category'] 	= $item_online->cat;
				$data['categories']  = $categories; 
				
				$colors=array('0'=>'няма');
				foreach ( $this->Item->get_colors()->result() as $color)
					{ $colors[$color->rgb] = $color->color_bg; }
					
				$data['color']  = ($item_online->color_id) ? $item_online->color_id : 0;
				$data['colors'] = $colors;

			$this->load->view("analyses/view_item",$data);
	}

/* ------------------------------------------------ КРАЙ ---------------------------------------- */
} ?>
