<?php require_once ("Secure_area.php");

class BiSOFT extends Secure_area 
{
	function __construct()
	{
		parent::__construct('BiSOFT');
		$this->load->library('Bisoft_lib');
	}
	
	function index()
	{
		$mode = 'BiSOFT';
		$this->BiSOFT_Model->set_user_mode($mode);
		$this->bisoft_settings();
	}

	
	function view()
	{
		$data = array();	
		$this->load->view("test", $data);
	}

	
	function view_UC()
	{
		$data['controller_name']=strtolower(get_class());
		$this->load->view("bisoft/under_construction", $data);
	}

	function bisoft_settings()
	{
		$user = $this->BiSOFT_Model->get_user();
		if ($user>0 and $user<6 ) 
			{ 
				$mode_menu = 'bisoft';
				$this->BiSOFT_Model->set_mode_menu($mode_menu);
				$this->load->view("bisoft/bisoft_view", null);
			}
	return false;
	}


	function save()
	{
		$batch_save_data=array(
		'company'=>$this->input->post('company'),
		'version'=>$this->input->post('version')
		);
		
		if( $this->BiSOFT_Model->batch_save( $batch_save_data ) )
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('config_saved_successfully')));
		}
		else
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('config_saved_unsuccessfully')));
	
		}
	}

	public function print_blanka()
	{
//		$handle = printer_open();
//		printer_close($handle);
	}

	public function print_setup()
	{
//	var_dump(printer_list(PRINTER_ENUM_LOCAL | PRINTER_ENUM_SHARED));

	}


	function change_YEAR_date_input()
	{
	$mode_year = $this->input->post("mode_year");
	$this->BiSOFT_Model->clear_user_modes();

	if ($mode_year > date ('Y'))	
			{ $this->BiSOFT_Model->set_user_year(date('Y')); }
	else  { $this->BiSOFT_Model->set_user_year($mode_year); }

	return true;
	}


	function upgrade_bisoft()
	{
	if ( file_exists ($_SERVER['DOCUMENT_ROOT']."/bisoft_data/install/upgrader.php") )
		{ header("Location: ../../../bisoft_data/install/upgrader.php"); }
	}
	
	function upgrade_eShop()
	{
	if ( file_exists ($_SERVER['DOCUMENT_ROOT']."/bisoft_data/install/upgrader.php") )
		{ header("Location: ../../../bisoft_data/install/upgrader.php"); }
	}

	
//- --------------------------------- SEARCHES ------------------------------------- //

	function customer_search()
	{
		$suggestions = $this->BiSOFT_Model->get_customer_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}
	
	function customer_select()
	{
	
		echo 'select client';
		die();
	}

//- --------------------------------- SESSIONS ------------------------------------- //

	function show_sessions()
	{
	$this->load->model('Sessions_view');
		$model = $this->Sessions_view;
		$tabular_data = array();
		$report_data = $model->getData(array());

		foreach($report_data as $row)
		{
		   $tabular_data[] = array(
					'iP' => anchor('https://www.whois.com/whois/'.$row['ip_address'],  // link
						$row['ip_address'], array('target' => '_blank') ),
						
					'activity' => date('d.m.Y H:i:s',$row['last_activity']),
					
					'del_sess' => anchor('BiSOFT/delete_session/'.$row['session_id'],  // link
						substr($row['session_id'],0,12).'..' ),
						
					'udata' => $row['user_data']
										);
		}

		$data = array(
					"title" 			=> $this->lang->line('reports_sessions'),
					"subtitle" 		=> anchor('BiSOFT/delete_all_sessions', 'delete all sessions'),
					"headers" 		=> $model->getDataColumns(),
					"data" 			=> $tabular_data
					);

	$this->load->view("bisoft/sessions_view", $data);
	}


	function delete_session($session_id)
	{
	$this->BiSOFT_Model->delete_session($session_id);
	$this->show_sessions();
	}


	function delete_all_sessions()
	{
	$this->BiSOFT_Model->delete_all_sessions();
	$this->show_sessions();
	}

// ------------------------------- import SKLAD ----------------------------------//

	function do_import_sklad()
	{

	$msg = "sklad_import";
	$failCodes = null;
	$successCode = null;
	// $sklad = base_url().'sklad.xls';


	if ($_FILES['file_path']['error']!=UPLOAD_ERR_OK)
	{	$msg = $this->lang->line('recvs_file_failed');  
 		$this->_refresh();
		echo "<div class='error_message'>".$msg."</div>";
		return false;}

	else { 	  $location = $this->Employee->get_logged_in_employee_info()->location;
		
		  $this->load->library('spreadsheetexcelreader');
		  $this->spreadsheetexcelreader->store_extended_info = false;
		  $success = $this->spreadsheetexcelreader->read($_FILES['file_path']['tmp_name']);

		  $rowCount = $this->spreadsheetexcelreader->rowcount(0);
	
	if ($rowCount > 1) {
	for($i = 2; $i<=$rowCount; $i++){

	  $sklad_code 	= $this->spreadsheetexcelreader->val($i, 'A');
	  $sklad_id 	= $this->Sklad->get_sklad_id($sklad_code);
	
	$qty_1 = $this->spreadsheetexcelreader->val($i,'D'); $qty_1=str_replace(array('0', ' '), '', $qty_1);
	$qty_2 = $this->spreadsheetexcelreader->val($i,'E'); $qty_2=str_replace(array('0', ' '), '', $qty_2);
	$qty_3 = $this->spreadsheetexcelreader->val($i,'F'); $qty_3=str_replace(array('0', ' '), '', $qty_3);
	$qty_4 = $this->spreadsheetexcelreader->val($i,'G'); $qty_4=str_replace(array('0', ' '), '', $qty_4);
	$qty_5 = $this->spreadsheetexcelreader->val($i,'H'); $qty_5=str_replace(array('0', ' '), '', $qty_5);
	$qty_6 = $this->spreadsheetexcelreader->val($i,'I'); $qty_6=str_replace(array('0', ' '), '', $qty_6);
	$qty_7 = $this->spreadsheetexcelreader->val($i,'J'); $qty_7=str_replace(array('0', ' '), '', $qty_7);
	$qty_8 = $this->spreadsheetexcelreader->val($i,'K'); $qty_8=str_replace(array('0', ' '), '', $qty_8);
	$qty_9 = $this->spreadsheetexcelreader->val($i,'L'); $qty_9=str_replace(array('0', ' '), '', $qty_9);

	$key_yes = 1;

	  $sklad_data  = array(
		'sklad_number'	=> $this->spreadsheetexcelreader->val($i, 'A'),
		'name'		=> $this->spreadsheetexcelreader->val($i, 'B'),



	      'quantity'=> $this->spreadsheetexcelreader->val($i, 'M'),
		'qty_1'	=> $qty_1,
		'qty_2'	=> $qty_2,
		'qty_3'	=> $qty_3,
		'qty_4'	=> $qty_4,
		'qty_5'	=> $qty_5,
		'qty_6'	=> $qty_6,
		'qty_7'	=> $qty_7,
		'qty_8'	=> $qty_8,
		'qty_9'	=> $qty_9,
	       'qty_max'=> '',

		'unit_price'	=> $this->spreadsheetexcelreader->val($i, 'N'),
		'location'	=> '9',
		'reorder_level'	=> '0'
		);


	  $size_range = $qty_1 + $qty_2 + $qty_3 + $qty_4 + $qty_5 + $qty_6 +
			$qty_7 + $qty_8 + $qty_9;

	if ($size_range == 0) 
		{ $sklad_data['allow_sizes'] = '0';}
	else	{ $sklad_data['allow_sizes'] = '1';
		  $sklad_data['sklad_size_group'] = 'S';}


		// update of DataBase sklads - работи !!!
		   if (!$this->Sklad->save($sklad_data,$sklad_id)) { $failCodes[] = $sklad_code; }
// --------------------------------------- loop
	      } //  #3  End of every sklad row  FOR i= ----------------------------
	   }

	}  //  #2 if row >1


 	$success = true;

	if(count($failCodes) > 1)
	{  $msg = $this->lang->line('sklads_error_import') . count($failCodes) ."): ".implode(", ", $failCodes); $success = false;} 
	else { $msg = $this->lang->line('sklads_successful_import');}


	if ($key_yes ==1 ) { $data = array ('success'=> $msg);}
		      else { $data = array ('error'  => $msg);}


	$this->load->view('bisoft/test',$data);

	}
/* =========================== PURE EXCEL 2003 IMPORT ==========================*/
//	 * Display form: Import data from an excel file
//	 * author: Bisser Alexiev Feb-2014

	function items_import()  // excel_xls_import BEST WORKING ...
	{
		$this->load->view("bisoft/items_import", null);
	}


	/**
	 * Read data from excel file -> save it to database
	 * author: Bisser Alexiev Nov-2013
	 */
    function do_items_import()  // xls_import
    	{

	$msg = "items_importing";
	$failCodes = null;
	$successCode = null;


	if ($_FILES['file_path']['error']!=UPLOAD_ERR_OK)
	{	$msg = $this->lang->line('recvs_file_failed');  
 		$this->_refresh();
		echo "<div class='error_message'>".$msg."</div>";
		return false;}

	else { 	  $location = $this->Employee->get_logged_in_employee_info()->location;
		
		  $this->load->library('spreadsheetexcelreader');
		  $this->spreadsheetexcelreader->store_extended_info = false;
		  $success = $this->spreadsheetexcelreader->read($_FILES['file_path']['tmp_name']);

		  $rowCount = $this->spreadsheetexcelreader->rowcount(0);
	
	if ($rowCount > 1) {
	for($i = 2; $i<=$rowCount; $i++){

	  $item_code 	= $this->spreadsheetexcelreader->val($i, 'A');
	  $item_id 	= $this->Item->get_item_id($item_code);

	$qty_1 = $this->spreadsheetexcelreader->val($i,'D'); $qty_1=str_replace(array('0', ' '), '', $qty_1);
	$qty_2 = $this->spreadsheetexcelreader->val($i,'E'); $qty_2=str_replace(array('0', ' '), '', $qty_2);
	$qty_3 = $this->spreadsheetexcelreader->val($i,'F'); $qty_3=str_replace(array('0', ' '), '', $qty_3);
	$qty_4 = $this->spreadsheetexcelreader->val($i,'G'); $qty_4=str_replace(array('0', ' '), '', $qty_4);
	$qty_5 = $this->spreadsheetexcelreader->val($i,'H'); $qty_5=str_replace(array('0', ' '), '', $qty_5);
	$qty_6 = $this->spreadsheetexcelreader->val($i,'I'); $qty_6=str_replace(array('0', ' '), '', $qty_6);
	$qty_7 = $this->spreadsheetexcelreader->val($i,'J'); $qty_7=str_replace(array('0', ' '), '', $qty_7);
	$qty_8 = $this->spreadsheetexcelreader->val($i,'K'); $qty_8=str_replace(array('0', ' '), '', $qty_8);
	$qty_9 = $this->spreadsheetexcelreader->val($i,'L'); $qty_9=str_replace(array('0', ' '), '', $qty_9);
	
	  $item_data = array(
		'item_number'	=> $this->spreadsheetexcelreader->val($i, 'A'),
		'name'		=> $this->spreadsheetexcelreader->val($i, 'B'),

	      'quantity'=> $this->spreadsheetexcelreader->val($i, 'M'),
		'qty_1'	=> $qty_1,
		'qty_2'	=> $qty_2,
		'qty_3'	=> $qty_3,
		'qty_4'	=> $qty_4,
		'qty_5'	=> $qty_5,
		'qty_6'	=> $qty_6,
		'qty_7'	=> $qty_7,
		'qty_8'	=> $qty_8,
		'qty_9'	=> $qty_9,
	       'qty_max'=> '',

		'unit_price'	=> $this->spreadsheetexcelreader->val($i, 'N'),
		'location'	=> $location,
		'reorder_level'	=> '0'
		);


	  $size_range = $qty_1 + $qty_2 + $qty_3 + $qty_4 + $qty_5 + $qty_6 +
			$qty_7 + $qty_8 + $qty_9;

	if ($size_range == 0) 
		{ $item_data['allow_sizes'] = '0';}
	else	{ $item_data['allow_sizes'] = '1';
		  $item_data['item_size_group'] = 'S';}


		// update of DataBase sklads - работи !!!
		   if (!$this->Item->save($item_data,$item_id)) { $failCodes[] = $item_code; }
// --------------------------------------- loop
	      } //  #3  End of every item row  FOR i= ----------------------------
	   }

	}  //  #2 if row >1


 	$success = true;

	if(count($failCodes) > 1)
	{  $msg = $this->lang->line('items_error_import') . count($failCodes) ."): ".implode(", ", $failCodes); $success = false;} 
	else { $msg = $this->lang->line('items_successful_import');}


	if ($key_yes ==1 ) { $data = array ('success'=> $msg);}
		      else { $data = array ('error'  => $msg);}


	$this->load->view('bisoft/test',$data);


  } // end #0 of Items Import

//--------------------------------------------------------------------------

	function import_bisoft_file_test()
	{



// $now_dir = getcwd();


	$now_dir = base_url() . 'BiSOFT/DB/';



	  $this->load->library('spreadsheetexcelreader');
	  $this->spreadsheetexcelreader->store_extended_info = false;

		// defines a specific file to open ...
//		$my_openFile = base_url().'BiSOFT/DB/suppliers.xls';

		$my_openDir = base_url().'BiSOFT/DB/suppliers.xls';
		$my_openFile = 'suppliers.xls';

		$my_fileArray = array (
							 			array ('file_dir' => $my_openDir),
										array('file_name' => 'suppliers.xls'),
									 );

echo '<br><br><br><br><br><br><br><br>...';





/*	  $success  = $this->spreadsheetexcelreader->read($my_fileArray['file_dir']['file_name']);
	  $rowCount = $this->spreadsheetexcelreader->rowcount(0);

*/

// $msg = $my_openFile . ' >>>  success:' . $success . ' >>> rows:' . $rowCount;

$msg = $my_fileArray;

// $msg = $_FILES['file_path']['tmp_name'];


		// defines error or success message.
		$view_path = 'bisoft/index';
		$data = array ('info'=> $msg, 'view_path'=> $view_path);
	// and there we go ...
		$this->load->view("bisoft/test_array", $data);
	}

	function serial_input()
	{
		include "phpSerial.php";

		// Let's start the class
		$serial = new phpSerial;

		// First we must specify the device. This works on both linux and windows (if
		// your linux serial device is /dev/ttyS0 for COM1, etc)
		$serial->deviceSet("COM1");

		// Then we need to open it
		$serial->deviceOpen();

		// To write into
		$serial->sendMessage("Hello !");

		// Or to read from
		$read = $serial->readPort();

		// If you want to change the configuration, the device must be closed
		$serial->deviceClose();

		// We can change the baud rate
		$serial->confBaudRate(2400);

		// etc...
		}


}
?>
