<?php require_once ("Person_controller.php");

class Consignees extends Person_controller
{
	function __construct()
	{
		parent::__construct('Consignees');
	}
	
	function index()
	{
		$this->BiSOFT_Model->clear_production();
		$mode_menu = 'consignees';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);

		$config['base_url'] = site_url('/consignees/index');
		$config['total_rows'] = $this->Consignee->count_all();
		$config['per_page'] = 40;
		$config['num_links'] = 5;
		$config['uri_segment'] = 3;
		$this->pagination->initialize($config);

		$data['modes_years']=array();
		$limit_year=date('y')-13; // установява тек.година-13 или от 2014г.
		for($k=0;$k<$limit_year;$k++)
		{
			$data['modes_years'][date("Y")-$k] = date("Y")-$k;
		}
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		
		$data['controller_name']=strtolower(get_class());
		$data['form_width']=$this->get_form_width();
		$data['manage_table']=get_consignee_manage_table( $this->Consignee->get_all(), $this );
		//  $config['per_page'], $this->uri->segment( $config['uri_segment'] )
		$this->load->view('consignees/manage',$data);
	}

	function refresh($data=array())
	{
		$config['base_url'] = site_url('/consignees/index');
		$config['total_rows'] = $this->Consignee->count_all();
		$config['per_page'] = 40;
		$config['num_links'] = 5;
		$config['uri_segment'] = 3;
		$this->pagination->initialize($config);

		$data['modes_years']=array();
		$limit_year=date('y')-13; // установява тек.година-13 или от 2014г.
		for($k=0;$k<$limit_year;$k++)
		{
			$data['modes_years'][date("Y")-$k] = date("Y")-$k;
		}
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		
		$data['controller_name']=strtolower(get_class());
		$data['form_width']=$this->get_form_width();
		$data['manage_table']=get_consignee_manage_table( $this->Consignee->get_all( $config['per_page'], $this->uri->segment( $config['uri_segment'] ) ), $this );
		$this->load->view('consignees/manage',$data);
	}

	function change_YEAR()
	{
		$mode_year = $this->input->post("mode_year");
		if ($mode_year > date ('Y'))	
				{ $this->BiSOFT_Model->set_user_year(date('Y')); }
		else  { $this->BiSOFT_Model->set_user_year($mode_year); }

		$this->BiSOFT_Model->set_user_mode('consi_report');
		$this->BiSOFT_Model->set_user_date();

	$this->refresh();
	}

	/*	Returns consignee table data rows. This will be called with AJAX. */
	function search()
	{
		$search=$this->input->post('search');
		$data_rows=get_consignee_manage_table_data_rows($this->Consignee->search($search),$this);
		echo $data_rows;
	}
	
	/* Gives search suggestions based on what is being searched for */
	function suggest()
	{
		$suggestions = $this->Consignee->get_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}
	
	/*  Loads the consignee edit form  */
	function view($consignee_id=-1)
	{
		$data['user_id']=$this->BiSOFT_Model->get_person();
		$data['person_info']	= $this->Consignee->get_info($consignee_id);
		$last_number = $this->Consignee->get_max_bisoft_id();

		if ( $consignee_id != -1 )
			{ $data['bisoft_id']	= $data['person_info']->bisoft_id;}
		else
			{ $data['bisoft_id']	= 1 + $last_number;}
			
		$data['consignee_id'] = $consignee_id;
		
		$data['modes_prices']=array(
				0  => $this->lang->line('sales_unit_price'),
				1	=> $this->lang->line('sales_price').'-I',
				2	=> $this->lang->line('sales_price').'-II',
				3	=> $this->lang->line('sales_price').'-III',
				4	=> $this->lang->line('sales_price').'-IV',
				5	=> $this->lang->line('sales_price').'-V' );
				
		$data['modes_clients']=array(
				'shop'	=> 'магазин',
				'comis'	=> 'комисионер',
				'distro'	=> 'дистрибутор',
				'outlet'	=> 'outlet' );

	$this->load->view("consignees/form",$data);
	}
	
	/*	Inserts/updates a consignee */
	function save($person_id=-1)
	{
		$first_name = mb_convert_case($this->input->post('first_name'),MB_CASE_TITLE,"UTF-8");
		$last_name  = mb_convert_case($this->input->post('last_name'),MB_CASE_TITLE,"UTF-8");
      $city       = mb_convert_case($this->input->post('city'),MB_CASE_TITLE,"UTF-8");
      $city = trim(str_replace('Гр.', '', $city ));
      $city = trim(str_replace('С.', 'с. ', $city ));
		
		$person_data = array(
			'bisoft_id'=>$this->input->post('bisoft_id'),
			'first_name'=>$first_name,
			'last_name'=>$last_name,
			'company'=>$this->input->post('company_name'),
			'email'=>$this->input->post('email'),
			'phone_number'=>$this->input->post('phone_number'),
			'address'=>$this->input->post('address'),
			'country' => mb_convert_case($this->input->post('country'),MB_CASE_TITLE,"UTF-8"),
			'city'	 => $city,
			'location'=>$this->input->post('bisoft_id'),
			'comments'=>$this->input->post('comments') );
			
		$consignee_data=array(
			'bisoft_id'=>$this->input->post('bisoft_id'),
			'company_name'=>$this->input->post('company_name'),
			'company_person'=>"$first_name $last_name",
			'account_number'=>$this->input->post('account_number'),
			'status'=>$this->input->post('modes_clients'),
			'price_group'=>$this->input->post('price_group'),
			'discount'=>$this->input->post('discount'),
			'commision'=>$this->input->post('commision'),
			'commision_L'=>$this->input->post('commision_L'), // само за Магазини
			'taxable'=>($this->input->post('taxable')=='') ? 0: 1,
			'deleted'=>($this->input->post('deleted')=='') ? 0: 1 );
				
		if($this->Consignee->save($person_data,$consignee_data,$person_id))
		{
			//New consignee
			if($person_id==-1)
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('consignees_successful_adding').' '.
				$consignee_data['company_name'],'person_id'=>$consignee_data['person_id']));
			}
			else //previous consignee
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('consignees_successful_updating').' '.
				$consignee_data['company_name'],'person_id'=>$person_id));
			}
		}
		else//failure
		{	
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('consignees_error_adding_updating').' '.
			"$first_name $last_name",'person_id'=>$person_id));
		}
	}
	
	
	/* This deletes consignees from the consignees table */
   function delete()
	{
		$consignees_to_delete=$this->input->post('ids');
		
		if($this->Consignee->delete_list($consignees_to_delete))
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('consignees_successful_deleted').' '.
			count($consignees_to_delete).' '.$this->lang->line('consignees_one_or_multiple')));
		}
		else
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('consignees_cannot_be_deleted')));
		}
	}
	
	/*	Gets one row for a consignee manage table. This is called using AJAX to update one row. */
	function get_row()
	{
		$person_id = $this->input->post('row_id');
		$data_row=get_consignee_data_row($this->Consignee->get_info($person_id),$this);
		echo $data_row;
	}
	
	
	function search_item($client_id)
	{
		$item_number = $this->input->post('item_number');
		$this->vedom($client_id,$item_number);
	}

// ------------------------------------------- ВЕДОМОСТИ И СКЛАД ----------------------------------- //

	function vedom($bisoft_id=-1,$item_number=0) 
	{
		$location = $this->BiSOFT_Model->get_location();
		$data['location'] 	= $location;
		$data['controller_name']=strtolower(get_class());
		$data['vedom_pack'] 	= $this->BiSOFT_Model->get_vedom();
		$data['vedom_year'] 	= $this->BiSOFT_Model->get_user_mode_year();
		$data['client_id'] 	= $bisoft_id;
		$data['client_info']	= $this->Consignee->get_info_by_bisoft_id($bisoft_id);
		$data['item_number'] = ($item_number) ? $item_number : '';
		// зарежда размерите ...
		$data['size_grid']	= $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table']	= $this->BiSOFT_Model->get_sizes('grid_2');

	$this->load->view("consignees/vedom_details",$data);
	}


	function sklad($bisoft_id=-1, $qty_key=1) 
	{
		$location = $this->BiSOFT_Model->get_location();
		$data['location'] = $location;
		$data['bisoft_id'] = $bisoft_id;
		$data['vedom_pack'] = $this->BiSOFT_Model->get_vedom();
		$data['vedom_year'] = $this->BiSOFT_Model->get_user_mode_year();
		$data['client_id'] = $bisoft_id;
		$data['client_info']=$this->Consignee->get_info_by_bisoft_id($bisoft_id);

		$data['qty_key']=$qty_key; // пуска само реални артикули
		// зарежда размерите ...
		$data['size_grid']= $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table']= $this->BiSOFT_Model->get_sizes('grid_2');

	$this->load->view("consignees/sklad_details",$data);
	}


	function sklad_print($bisoft_id=-1) 
	{
		$location = $this->BiSOFT_Model->get_location();
		$data['location']   = $location;
		$data['bisoft_id']  = $bisoft_id;
		$data['vedom_pack'] = $this->BiSOFT_Model->get_vedom();
		$data['vedom_year'] = $this->BiSOFT_Model->get_user_mode_year();
		$data['client_id']  = $bisoft_id;
		$data['client_info']= $this->Consignee->get_info_by_bisoft_id($bisoft_id);
		// зарежда размерите ...
		$data['size_grid']  = $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table'] = $this->BiSOFT_Model->get_sizes('grid_2');

	$this->load->view("consignees/sklad_print",$data);
	}


	function find_consignee_info()
	{
		$bisoft_id=$this->input->post('scan_item_number');
	}


	function sklad_return($bisoft_id)
	{
	$db_vedom = 'V'.date('ym', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));

	$client_id 	 = $bisoft_id;
	$client_name = $this->Consignee->get_info_by_bisoft_id($client_id)->company_name;

	$person_info = $this->Employee->get_logged_in_employee_info();
	$employee_id = $this->BiSOFT_Model->get_person();
	$employee	 =	$this->Employee->get_info($employee_id)->first_name .' '. 
								$this->Employee->get_info($employee_id)->last_name;

	//Зареждаме данни за Базата с Връщането на Стока ...
	$mode = 'consi_return';
	$mode_id 	= $this->BiSOFT_Model->get_pay_group($mode);			 // index-a 'Е', 'SE' ..
	$doc_date 	= $this->BiSOFT_Model->get_user_mode_date();
	$doc_name	= $this->BiSOFT_Model->get_document_title($mode);	 // това си е вече заглавието...
	$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...

	$all_total	= 0; $total_qty = 0; $line = 1;

		// зареждам основните параметри на Главния документ ......
		$document_data = array(
				'mode'				=> $mode,
				'mode_id'			=> $mode_id,
				'mode_price'		=> 1,
				'doc_number'		=> $doc_number,
				'doc_date' 			=> $doc_date,
				'total_discount'	=> 0,
				'taxed'				=> 0,
				'total_taxes'		=> 0,
				'pay_type'			=> $this->lang->line('reports_returns'),
				'supplier_id'		=> $client_id,
				'supplier'			=> $client_name,
				'client_id'			=> $client_id,
				'client'				=> $client_name,
				'employee_id'		=> $employee_id,
				'employee'			=> $employee,
				'location'			=> $bisoft_id 
									);

			//------------------------ записва в Базите Данни ---------------------- //
			$this->db->trans_start(); // --> отваря запис към БАЗАТА ...-->> 
			// вкарва данните от Документа в Месечната База Данни ... //
			$this->db->insert( $db_vedom, $document_data);
			$doc_id = $this->db->insert_id();  // от тук си взимам номерчето на документа


		foreach($this->Inventory->get_sklad_for_client( $bisoft_id, 0 )->result_array() as $row)
			{
			$item_number = $row['item_number'];
			if ($this->Item->exists_by_number_gpr($item_number) and abs($row['quantity']) > 0 )
				{
					$item_id 	= $this->Item->get_item_id($item_number);
					$item_info 	= $this->Item->get_info($item_id, 1);

					$qty_1 	= -abs($row['qty_1']); if($qty_1==0){$qty_1='';}
					$qty_2 	= -abs($row['qty_2']); if($qty_2==0){$qty_2='';}
					$qty_3 	= -abs($row['qty_3']); if($qty_3==0){$qty_3='';}
					$qty_4 	= -abs($row['qty_4']); if($qty_4==0){$qty_4='';}
					$qty_5 	= -abs($row['qty_5']); if($qty_5==0){$qty_5='';}
					$qty_6 	= -abs($row['qty_6']); if($qty_6==0){$qty_6='';}
					$qty_7 	= -abs($row['qty_7']); if($qty_7==0){$qty_7='';}
					$qty_8 	= -abs($row['qty_8']); if($qty_8==0){$qty_8='';}
					$qty_9 	= -abs($row['qty_9']); if($qty_9==0){$qty_9='';}
					$qty_max = -abs($row['qty_max']); if($qty_max==0){$qty_max='';}

					$item_data = array(
							'doc_id'  		=> $doc_id,
							'line'  			=> $line,
							'mode_id'		=> $mode_id,
							'mode_price'	=> 1,
							'doc_number'	=> $doc_number,
							'doc_date' 		=> $doc_date,
							'item_id' 		=> $item_id,
							'item_number' 	=> $item_number,
							'item_name' 	=> $row['name'],
							'qty_1' => $qty_1,
							'qty_2' => $qty_2,
							'qty_3' => $qty_3,
							'qty_4' => $qty_4,
							'qty_5' => $qty_5,
							'qty_6' => $qty_6,
							'qty_7' => $qty_7,
							'qty_8' => $qty_8,
							'qty_9' => $qty_9,
							'qty_max'  => $qty_max,
							'item_qty' => -abs($row['quantity']),
							'item_unit_price' => abs($row['unit_price']),
							'item_discount' => 0,
							'item_taxes' 	 => 0,
							'supplier_id'		=> $client_id,
							'supplier'			=> $client_name,
							'client_id'			=> $client_id,
							'client'				=> $client_name,
							'location'			=> $bisoft_id 
											);

					// вкарваме във Ведомостта ...
					$this->db->insert( $db_vedom.'_items', $item_data);

					$qty_1 = $row['qty_1'] + $item_info->qty_1; if($qty_1==0){$qty_1='';}
					$qty_2 = $row['qty_2'] + $item_info->qty_2; if($qty_2==0){$qty_2='';}
					$qty_3 = $row['qty_3'] + $item_info->qty_3; if($qty_3==0){$qty_3='';}
					$qty_4 = $row['qty_4'] + $item_info->qty_4; if($qty_4==0){$qty_4='';}
					$qty_5 = $row['qty_5'] + $item_info->qty_5; if($qty_5==0){$qty_5='';}
					$qty_6 = $row['qty_6'] + $item_info->qty_6; if($qty_6==0){$qty_6='';}
					$qty_7 = $row['qty_7'] + $item_info->qty_7; if($qty_7==0){$qty_7='';}
					$qty_8 = $row['qty_8'] + $item_info->qty_8; if($qty_8==0){$qty_8='';}
					$qty_9 = $row['qty_9'] + $item_info->qty_9; if($qty_9==0){$qty_9='';}
					$qty_max = $row['qty_max'] + $item_info->qty_max; if($qty_max==0){$qty_max='';}

					$item_to_items = array(
							'qty_1' => $qty_1,
							'qty_2' => $qty_2,
							'qty_3' => $qty_3,
							'qty_4' => $qty_4,
							'qty_5' => $qty_5,
							'qty_6' => $qty_6,
							'qty_7' => $qty_7,
							'qty_8' => $qty_8,
							'qty_9' => $qty_9,
							'qty_max'  => $qty_max,
							'quantity' => $row['quantity']+$item_info->quantity
											);

					$total_qty 	+= $row['quantity'];
					$all_total 	+= round($row['quantity']*$row['unit_price'],2);

					$this->Item->save($item_to_items,$item_id);

					$document_data = array(
							'total_qty'			=> -abs($total_qty),
							'total_sum'			=> -abs($all_total),
							'pay_amount'		=> -abs($all_total),
							'total_discount'	=> '',
							'pay_group'			=> '',
							'taxed'				=> 0,
							'comment'			=> 'returned stock',
							'location'			=> $bisoft_id
															);

					// Актуализирам Базата с Общите Данни ....
					$this->db->where('doc_id', $doc_id);
					$this->db->update( $db_vedom, $document_data);

				$line++;
				} // END of exists_by_number_gpr($item_number)

			// най сетне изтриваме от shops артикула ...
			$this->Inventory->delete_item_from_sklad( $bisoft_id, $item_number );
			}
			
	$this->db->trans_complete();
	$this->sklad($bisoft_id);
	}





/* =========================== BISOFT (EXCEL 2003) DIRECT IMPORT MODULE =========================*/
	/**
	 * Display form: Import data from an excel file
	 * author: Bisser Alexiev Feb.2014
	 */
  function bisoft_import($myFile='consignees.bls')
	{
	$msg = "do_bisoft_import_from_consignees.bls";
	$failCodes = null;
	$successCode = null;
   $location = $this->Employee->get_logged_in_employee_info()->location;
	$view_path = 'consignees/refresh';

	// get BiSOFT path
	$this->CI =& get_instance();
	$bisoft_path = $this->CI->BiSOFT_Model->get_path();

// error_reporting(E_ALL ^ E_NOTICE);

// require_once 'bisoft_reader.php';
//$data_file = new Spreadsheetexcelreader("consignees.xls", false);
// base_url().'BiSOFT/DB'
//	chdir (base_url().'BiSOFT');
//	$now_dir = getcwd();

		$this->load->library('spreadsheetexcelreader');
      $this->spreadsheetexcelreader->setOutputEncoding('CP1251'); // Set output Encoding

	$sRoot = $_SERVER['DOCUMENT_ROOT'];
	$file_to_read = $sRoot.'/'.$bisoft_path.'/DB/'.$myFile;

	if (!is_readable($file_to_read))
     	{ // ГРЕШКА - връщаме се в началото на controller-a ...
			$msg = $this->lang->line('common_error_import');
			$data['error'] = $msg;
		 	$this->refresh($data);
     	}

		else 
		{ // тук вече зарежда нормално от BiSOFT ... - >

		$data_file = new Spreadsheetexcelreader($file_to_read, false);

			$rowCount = $data_file->rowcount(0);
//			$colCount = $data_file->colcount(0);
//        $rows = $data_file->sheets[0]['cells'];
//        $rowCount = count($data_file->sheets[0]['cells']);

      if($rowCount > 1)
		{  // #2 if row > 1

			for($i = 2; $i<=$rowCount; $i++) 
			{  // #3 for i=1 and on ...
			$consignee_code 	= $data_file->val( $i, 'A');
			$consignee_id 		= $this->Consignee->get_info($consignee_code);

			$first_last_name = $data_file->val($i, 'K');

// обработвам за глупави знаци ...
	$first_last_name = character_limiter(str_replace(array('=', '-', '_', '/', '|', '\\', '#', '№', '.', ',', '@', '&', '!', '$', '*', '(', ')', '~'), ' ', $first_last_name),30);

		list ($firstname, $lastname) = explode(' ', $first_last_name.' _');
				$firstname = trim($firstname);
				$lastname  = trim(str_replace(array('_'), '', $lastname));


	$consignee_number = intval( $consignee_code );

	$key_yes = 1;
	$bisoft_id  = intval( $consignee_code );

	if ($this->Consignee->bisoft_id_exists($bisoft_id)) { $key_yes = 0;}

	// проверявам за Данъчна регистрация ...
	$taxable = '1';


	  $person_data = array(
		'bisoft_id'			=> $bisoft_id,
		'company'	  		=> $data_file->val( $i, 'B'),
		'city'	  	  		=> $data_file->val( $i, 'C'),
		'address'	  		=> $data_file->val( $i, 'D'),
		'phone_number'		=> $data_file->val( $i, 'E'),
		'location'			=> $data_file->val( $i, 'P'),
		'country'	  		=> 'България',
		'first_name'		=> $firstname,
		'last_name'			=> $lastname,
		);


	  $consignee_data = array(
		'bisoft_id'			=> $bisoft_id,
		'company_name'		=> $data_file->val( $i, 'B'),
		'company_person'	=> $first_last_name,
		'account_number'	=> $data_file->val( $i, 'I'),
		'bank'				=> $data_file->val( $i, 'F'),
		'bank_account'    => $data_file->val( $i, 'G'),
		'discount'			=> 100 * $data_file->val( $i, 'Q'),
		'price_group'		=> $data_file->val( $i, 'P'),
		'taxable'			=> $taxable,
		'location'			=> null,
		);

					// updates of DataBase consignees & People
					if ($key_yes == 1 and $bisoft_id > 0)
					{
					  if(!$this->Consignee->save( $person_data, $consignee_data))
						{ $failCodes[] = 'BiSOFT:'.$consignee_code; }
					}

				}  // 3

			}  //  #2 if row >1
			else { 
						$msg = 'Your upload file has no data or not in supported format.';
						$data['error'] = $msg;
					 	$this->refresh($data);
					return false;
					}  // end #2 may STOP if file error ?!?!?

		}  // end #1

		// defines error or success message.
		if(count($failCodes) > 1)
		{  $msg = $this->lang->line('recvs_error_import') . count($failCodes) ."): ".implode(", ",$failCodes); 
			$data['error'] = $msg;} // ГРЕШКА (човешка :(
		else {
				$msg = $this->lang->line('recvs_successful_import');
				$data['success'] = $msg;}  // УСПЕХ !!!

	$this->refresh($data);
	} // end #0 of BiSOFT Import
// ==================================== End of Import BiSOFT ================================ //




// ====================================== CSV Importer =================================/
//	 * Display form: Import data from an CSV file
//	 * author: Bisser Alexiev Dec-2013     времено СПРЯН - но РАБОТИ за  Еталон CSV

	function csv_import()
	{
		$this->load->view("consignees/csv_import", null);
	}

	function do_csv_import()
	{
		$msg = 'do_csv_import';
		$failCodes = array();
		if ($_FILES['file_path']['error']!=UPLOAD_ERR_OK)
		{
			$msg = $this->lang->line('items_excel_import_failed');
			echo json_encode( array('success'=>false,'message'=>$msg) );
			return;
		}
		else
		{
			if (($handle = fopen($_FILES['file_path']['tmp_name'], "r")) !== FALSE)
			{
				//Skip first row
				fgetcsv($handle);
				
				$i=1;
				while (($data = fgetcsv($handle)) !== FALSE) 
				{
// My stuff
				$first_last_name = $data[10];
				list($firstname, $lastname) = explode(' ', $first_last_name);
				$consignee_number = intval( $data[0] );

					$person_data = array(
					'first_name'=> trim($firstname),
					'last_name'=> trim($lastname),
					'phone_number'=>$data[4],
					'address'=>$data[3],
					'city'=>$data[2],
					'country'=> 'България',
					'comments'=>$data[11]
					);
					
					$consignee_data=array(
					'account_number'=>$data[8]=='' ? null:$data[8],
					'company_name'=>$data[1],
					'bank'=>$data[5],
					'bank_account'=>$data[6],
					'discount'=>$data[16],
					'taxable'=>$data[14]=='' ? 0:1,
					);
					
					if(!$this->Consignee->save($person_data,$consignee_data))
					{	
						$failCodes[] = $i;
					}
					
					$i++;
				}
			}
			else 
			{
				echo json_encode( array('success'=>false,'message'=>'Your upload file has no data or not in supported format.') );
				return;
			}
		}

		$success = true;
		if(count($failCodes) > 1)
		{
			$msg = "Most consignees imported. But some were not, here is list of their CODE (" .count($failCodes) ."): ".implode(", ", $failCodes);
			$success = false;
		}
		else
		{
			$msg = "Import Consignees successful";
		}

		echo json_encode( array('success'=>$success,'message'=>$msg) );
	}
	
// ====================================== END CSV Importer =================================/



//	get the width for the add/edit form
	function get_form_width()
	{			
		return 360;
	}
}
?>
