<?php require_once ("Person_controller.php");

class Employees extends Person_controller
{
	function __construct()
	{
		parent::__construct('Employees');
	}
	
	function index()
	{
		$mode_menu = 'employees';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$config['base_url'] = site_url('/employees/index');
		$config['total_rows'] = $this->Employee->count_all();
		$config['per_page'] = 100;
		$config['uri_segment'] = 3;
		$this->pagination->initialize($config);
		
		$data=array();
		$data['controller_name']=get_class(); // 'Employees'; // strtolower(get_class()); //
		$data['controller_title']=strtolower(get_class());
		$data['form_width']=$this->get_form_width();

		$selected_employees = $this->Employee->get_operators( $config['per_page'], $this->uri->segment( $config['uri_segment'] ) );
		$data['manage_table']=get_people_manage_table( $selected_employees , $this );
		$this->load->view('people/manage',$data);
	}
	
	/* Returns employee table data rows. This will be called with AJAX. */
	function search()
	{
		$search=$this->input->post('search');
		$data_rows=get_people_manage_table_data_rows($this->Employee->search($search),$this);
		echo $data_rows;
	}
	
	/* Gives search suggestions based on what is being searched for */
	function suggest()
	{
		$suggestions = $this->Employee->get_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}
	
	function get_row()
	{
		$person_id = $this->input->post('row_id');
		$person = $this->Employee->get_info($person_id);
		$data_row = get_person_data_row($person,$this);
		echo $data_row;
	}
	
	/*	Loads the employee edit form */
	function view($employee_id=-1)
	{
		$data['person_info']=$this->Employee->get_info($employee_id);
		$data['all_modules']=$this->Module->get_all_modules();
		$this->load->view("employees/form",$data);
	}
	
	/* Inserts or updates an employee */
	function save($person_id=-1)
	{
		$location=trim($this->input->post('location'));
		if($location=='' or empty($location)) {$location=0;}
		
		$person_data = array(
		'first_name'=>$this->input->post('first_name'),
		'last_name'=>$this->input->post('last_name'),
		'location'=>$location );
		if($person_id!='-1') {$person_data['person_id']=$person_id;}
		
		$permission_data = $this->input->post("permissions")!=false ? $this->input->post("permissions"):array();
		
		//Password has been changed OR first time password set
		if($this->input->post('password')!='')
		{
			$employee_data=array(
			'username'=>$this->input->post('username'),
			'password'=>md5($this->input->post('password')),
			'location'=>$location );
		}
		else //Password not changed
		{  $employee_data=array('username'=>$this->input->post('username'));}
		if($person_id!='-1') {$employee_data['person_id']=$person_id;}

		if($this->Employee->save($person_data,$employee_data,$permission_data,$person_id,$location))
		{
			//New employee
			if($person_id==-1)
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('employees_successful_adding').' '.
				$person_data['first_name'].' '.$person_data['last_name'],'person_id'=>$employee_data['person_id']));
			}
			else //previous employee
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('employees_successful_updating').' '.
				$person_data['first_name'].' '.$person_data['last_name'],'person_id'=>$employee_data['person_id']));
			}
		}
		else//failure
		{	
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('employees_error_adding_updating').' '.
			$person_data['first_name'].' '.$person_data['last_name'],'person_id'=>-1));
		}
	}
	
	
	/*	This deletes employees from the employees table */
	function delete()
	{
		$employees_to_delete=$this->input->post('ids');
		if($employees_to_delete)
			{ $success = $this->Employee->delete_list($employees_to_delete);}
		else 
			{ $success = 0;}
		/*	
		if($success)
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('employees_successful_deleted').' '.
			count($employees_to_delete).' '.$this->lang->line('employees_one_or_multiple')));
		}
		else
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('employees_cannot_be_deleted')));
		}
		*/
	$this->index();
	}
	

	/* get the width for the add/edit form */
	function get_form_width()
	{
		return 650;
	}
	
}
?>
