<?php require_once ("Secure_area.php");
		require_once ("interfaces/iData_controller.php");

class Giftcards extends Secure_area implements iData_controller
{
	function __construct()
	{
		parent::__construct('Giftcards');
	}

	function index()
	{
      $mode_menu = 'giftcards';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = array();
      $data['user_id']	= $user_id = $this->BiSOFT_Model->get_person();
		// вземам си всички КАТЕГОРИИ
		$data['category']   = $this->BiSOFT_Model->get_mode_assort();
		$data['categories'] = $this->Giftcard->get_all_categories('all');

		$config['base_url'] = site_url('/giftcards/index');
		$config['total_rows'] = $this->Giftcard->count_category($data['category']);
		$config['per_page'] = '300';
		$config['num_links'] = 2;
		$config['uri_segment'] = 3;
		$this->pagination->initialize($config);
		
		$data['controller_name']=strtolower(get_class());
		$data['form_width']=$this->get_form_width();
		$data['form_height']=$this->get_form_height();
		$data['manage_table']=get_giftcards_manage_table( $this->Giftcard->get_cat_gifts( $data['category'], $config['per_page'], $this->uri->segment( $config['uri_segment'] ) ), $this );
		$this->load->view('giftcards/manage',$data);
	}
	
	function change_category()
	{
		$category = $this->input->post("gift_category");
		$this->BiSOFT_Model->set_mode_assort($category);
	$this->index();
	}

	function search()
	{
		$search=$this->input->post('search');
		$data_rows=get_giftcards_manage_table_data_rows($this->Giftcard->search($search),$this);
		echo $data_rows;
	}

	/*	Gives search suggestions based on what is being searched for */
	function suggest()
	{
		$suggestions = $this->Giftcard->get_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}

	function get_row()
	{
		$giftcard_id = $this->input->post('row_id');
		$data_row=get_giftcard_data_row($this->Giftcard->get_info($giftcard_id),$this);
		echo $data_row;
	}

	function view($giftcard_id='-1')
	{
      $data['user_id'] = $user_id = $this->BiSOFT_Model->get_person();
      $data['location'] = $location = $this->BiSOFT_Model->get_location();
		$data['giftcard_info']=$this->Giftcard->get_info($giftcard_id);
		
		// вземам си всички КАТЕГОРИИ
		$data['categories'] = $this->Giftcard->get_all_categories();
		$data['category']   = $this->BiSOFT_Model->get_mode_assort();
		if(!$data['category'] or !isset($data['category'])) {$data['category'] = 'vip10';}
		if($giftcard_id!='-1') 
         {
            $data['category'] = $data['giftcard_info']->type;
            $data['giftcard_id']=$data['giftcard_info']->giftcard_id;
         }
      else // нова карта
         {
            $data['giftcard_id']='-1';
            $data['giftcard_info']->gift_num=$data['giftcard_info']->total=
                $data['giftcard_info']->value=$data['giftcard_info']->cost='0';
            if($data['category']=='vip10') {$data['giftcard_info']->procent='10';}
            elseif($data['category']=='vip15') {$data['giftcard_info']->procent='15';}
            elseif($data['category']=='vip20') {$data['giftcard_info']->procent='20';}
            elseif($data['category']=='vip30') {$data['giftcard_info']->procent='30';}
            elseif($data['category']=='vip40') {$data['giftcard_info']->procent='40';}
            elseif($data['category']=='giftcard' or $data['category']=='promo') 
                 {$data['giftcard_info']->procent='0';}
            else {$data['giftcard_info']->procent='10';}
         }
		
	$this->load->view("giftcards/form",$data);
	}
	
	function save($giftcard_id=-1)
	{
		$success = 1;
		$giftcard_number = trim(strtoupper($this->input->post('giftcard_number')));
		if( strlen($giftcard_number)<8 ) {$success=0;}
		
		if($success)
		{
			$total = $this->input->post('total');
			if(null==$total) {$total=0;}
			$giftcard_data = array(
					'gift_num'=>$this->input->post('gift_num'),
					'giftcard_number'=>$giftcard_number,
					'type'=>$this->input->post('gift_category'),
					'procent'=>$this->input->post('procent'),
					'cost'=>$this->input->post('cost'),
					'value'=>$this->input->post('value'),
					'date_start'=>date('Y-m-d',strtotime($this->input->post('date_start'))),
					'owner'=>$this->input->post('owner'),
					'uguomu'=>$this->input->post('email'),
					'mobile'=>$this->input->post('mobile'),
					'total'=>$total );

			$success *= $this->Giftcard->save($giftcard_data, $giftcard_id);
		}
		
		if($success)
		{
			//New giftcard
			if($giftcard_id==-1)
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('giftcards_successful_adding').' '.
				$giftcard_data['giftcard_number'],'giftcard_id'=>$giftcard_data['giftcard_id']));
				$giftcard_id = $giftcard_data['giftcard_id'];
			}
			else //previous giftcard
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('giftcards_successful_updating').' '.
				$giftcard_data['giftcard_number'],'giftcard_id'=>$giftcard_id));
			}
		}
		else//failure
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('giftcards_error_adding_updating').' '.
			$giftcard_data['giftcard_number'],'giftcard_id'=>-1));
		}

	}


	function delete()
	{
		$giftcards_to_delete=$this->input->post('ids');
	
		if($this->Giftcard->delete_list($giftcards_to_delete))
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('giftcards_successful_deleted').' '.
			count($giftcards_to_delete).' '.$this->lang->line('giftcards_one_or_multiple')));
		}
		else
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('giftcards_cannot_be_deleted')));
		}
	}
		
	public function show_giftcard_history($giftcard=0,$start_date=0,$end_date=0)
	{
		echo $giftcard;
		echo '<br>';
		echo $start_date.' - '.$start_date;
	
	}
	
	
	public function print_vedom()	
	{
		$top_value = 200;
		$export_excel = 0;
		$sale_type = 'giftcards';
		$cat = $this->BiSOFT_Model->get_mode_assort();
		$all_gifts = $this->Giftcard->get_all_over_200($cat,$top_value);
		
		$this->load->model('reports/Summary_sales');
		$model = $this->Summary_sales;
		
		$tabular_data = array();
		$all_qty = $all_suma = $all_vat = $all_total = 0;
		
		foreach($all_gifts as $gift)
		{
			$gift_info = $this->Giftcard->get_giftcard_by_code($gift['giftcard_number']);
			$discount  = $gift['type'].'%'; // $gift_info->procent.'%';

			$tabular_data[] = array(
				'giftcard' => $gift['giftcard_number'],
				'owner' => $gift['owner'],
				'dsc'	  => $discount,
				'type'  => $gift['type'],
				'total' => $gift['total'] );

			$all_total += $gift['total'];
		}
			
			$data = array(
				"title" => $this->lang->line('reports_sales_summary_report').' > 200лв.',
				"subtitle" => '',
				"headers" => $model->getDataColumns($sale_type),
				"data" => $tabular_data,
				
				"all_qty"  => 0,
				"all_suma" => to_dot($all_total),
				"all_vat"  => 0,
				"all_total"  => to_dot($all_total),
				"start_date" => 0,
				"end_date"   => 0,
			
				"export_excel" => $export_excel );

	$this->load->view("reports/tabular_sum_giftcards",$data);
	}
	
	
	/*	get the width for the add/edit form */
	function get_form_width()
	 { return 615;}
	 
	function get_form_height()
	 { return 480;}
	 
	 
} ?>
