<?php require_once ("Secure_area.php");

class Invoices extends Secure_area
{
	function __construct()
	{
		parent::__construct('Invoices');
		$this->load->library('Invoice_lib');
	}

	function index()
	{  // Фактури САМО за '0'-та //
		if($this->BiSOFT_Model->get_location()) {redirect('Home');}
		
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'invoices';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		$this->_reload();
	}

	function change_mode()
	{
		$mode = $this->input->post("mode");
		$this->invoice_lib->set_mode($mode);
		$this->BiSOFT_Model->set_user_mode($mode);
	$this->_reload();
	}
	
	function change_FIRMA()
	{
		$firma_id = $this->input->post("mode_firma");
		$this->invoice_lib->set_firma($firma_id);
		$this->invoice_lib->clear_mode_price();
	$this->_reload();
	}

	function show_hide_DATE()
	{
		if ( !$this->invoice_lib->get_dateKey() ) 
				{ $this->invoice_lib->set_dateKey(); }
		else	{ $this->invoice_lib->clear_dateKey(); } 
	$this->_reload();
	}

	function change_YEAR()
	{
		$c_day = date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_month = date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_year = $this->input->post("mode_year");
		  $m_limit = $this->BiSOFT_Model->get_month_limit($c_month,$c_year);
		  if($c_day>$m_limit) {$c_day=$m_limit;}	  
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);
		$this->BiSOFT_Model->set_user_year($c_year);
	$this->_reload();
	}

	function change_MONTH()
	{
		$c_day = date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_month = $this->input->post("mode_month");
		$c_year = date('y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		  $m_limit = $this->BiSOFT_Model->get_month_limit($c_month,$c_year);
		  if($c_day>$m_limit) {$c_day=$m_limit;}  
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);
	$this->_reload();
	}

	function change_DAY()
	{
		$c_day = $this->input->post("mode_day");
		$c_month = date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_year = date('y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		  $m_limit = $this->BiSOFT_Model->get_month_limit($c_month,$c_year);
		  if($c_day>$m_limit) {$c_day=$m_limit;}
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);
	$this->_reload();
	}

	function change_PRICE()
	{
		$mode_price = $this->input->post("mode_price");
		$this->invoice_lib->set_mode_price($mode_price);
		$this->BiSOFT_Model->set_user_price($mode_price);
	$this->_reload();
	}

	function change_VALUTA()
	{
		$valuta = $this->input->post("modes_valutas");
		$this->invoice_lib->set_mode_valuta($valuta);
	$this->_reload();
	}
	
	function change_RATE()
	{
		$rate = $this->input->post("rate");
		$this->invoice_lib->set_rate($rate);
	$this->_reload();
	}

	function change_PRINTON()
	{
		$mode_print = $this->input->post("mode_print");
		$this->invoice_lib->set_mode_print($mode_print);
	$this->_reload();
	}

	function change_PAYMENT()
	{
		$payment_type = $this->input->post("payment_type");
		$this->invoice_lib->set_mode_payment($payment_type);
	$this->_reload();
	}

	public function search()
	{
		$invoice_item = $this->input->post("search");
		$data=array();
		$mode = $this->invoice_lib->get_mode();
		$firma = $this->invoice_lib->get_firma();
		$customer = $this->invoice_lib->get_customer();
		$qty = 1;
		
		if($firma==0 or $customer=='-1')
		{ $data['error']=$this->lang->line('sales_unable_to_add_firma_item');}
		elseif($this->invoice_lib->is_valid_invoice_item_number($invoice_item,$mode))
		{
			if(!$this->invoice_lib->add_invoice_item($invoice_item,$qty,0,0))
			{ $data['error']=$this->lang->line('sales_unable_to_add_invoice_item');}
		}
		else
		{ $data['error']=$this->lang->line('sales_unable_to_add_invoice_item');}

	$this->_reload($data);
	}
	
	function item_search()
	{
		$suggestions = $this->Item->get_item_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		$suggestions = array_merge($suggestions, $this->Item_kit->get_item_kit_search_suggestions($this->input->post('q'),$this->input->post('limit')));
		echo implode("\n",$suggestions);
	}

	function customer_search()
	{
		$suggestions = $this->Customer->get_customer_search_suggestions($this->input->post('q'),$this->input->post('limit'),1);
		echo implode("\n",$suggestions);
	}

	function select_customer()
	{
		$customer_id = $this->input->post("customer");
		$this->invoice_lib->set_customer($customer_id);
	$this->_reload();
	}

	function remove_customer()
	{
		$this->invoice_lib->remove_customer();
	$this->_reload();
	}

	function select_consignee()
	{
		$consignee_id = $this->input->post("mode_consi");
		$this->invoice_lib->set_consignee($consignee_id);
	$this->_reload();
	}

	function remove_consignee()
	{
		$this->invoice_lib->remove_consignee();
	$this->_reload();
	}

	function set_comment() 
	{
 	  $this->invoice_lib->set_comment($this->input->post('comment'));
	}
	
	function set_email_receipt()
	{
 	  $this->invoice_lib->set_email_receipt($this->input->post('email_receipt'));
	}

	// Multiple Payments
	function add_payment()
	{		
		$data = array();
		$this->form_validation->set_rules( 'amount_tendered', 'lang:sales_amount_tendered', 'numeric' );

		$payment_type = $this->input->post('payment_type');
		$this->invoice_lib->set_mode_payment($payment_type);

		$mode_print = $this->input->post("mode_print");
		$this->invoice_lib->set_mode_print($mode_print);
		
		$is_paid = 0; // ВИНАГИ НЕПЛАТЕНА //
		if($payment_type!='непл') {$is_paid = 1;}
		$this->invoice_lib->set_is_paid($is_paid);
		
		$payment_amount = $this->input->post('amount_tendered');
		
		if ( !$this->invoice_lib->add_payment( $payment_type, $payment_amount, $is_paid ) )
			{ $data['error']='Unable to Add Payment! Please try again!';}

	$this->_reload($data);
	}

	// Delete Multiple Payments
	function delete_payment( $payment_id )
	{
		$this->invoice_lib->delete_payment( $payment_id );
		$this->_reload();
	}

	
	
	function add($invoice_item)
	{
		$data=array();
		$mode = $this->invoice_lib->get_mode();
		// $invoice_item = $this->input->post("item");
		$qty = 1;

		if ($this->invoice_lib->is_valid_invoice_item_number($invoice_item,$mode)) // test for invoice item
		{
			if(!$this->invoice_lib->add_invoice_item($invoice_item,$qty))
			{ $data['error']=$this->lang->line('sales_unable_to_add_item');}
		}

	$this->_reload($data);
	}


	function edit_item($line,$invKey,$rate)
	{
		$data= array();
		$mode_price = $this->BiSOFT_Model->get_user_mode_price();
		$mode = $this->invoice_lib->get_mode();

		// ИМЕТО НА АРТИКУЛА --------------- //
		$item_name_bg = $this->input->post("name_bg");
		$item_name_en = $this->input->post("name_en");
		
		// ЦЕНИ ---------------------------- //
		if($invKey)
			{ 
				$price_en = $this->input->post("price_en");
				if(!is_numeric($price_en)) { str_replace(',', '.', $price_en);$price_en = round($price_en,7);}
				$price = round($rate*$price_en,7);
			}
		else	
			{  $price = $this->input->post("price");}

		if($mode_price==0) 
			{$this->form_validation->set_rules('price', 'lang:items_price', 'required|numeric');}

		if (!is_numeric($price)) { str_replace(',', '.', $price); $price = round($price,7);}
		if ($mode == 'offer') 
			{ $price = abs($price);}
		elseif ($mode=='invoice_di')
			{ $price = abs($price);}
		elseif ($mode=='invoice_ki')
			{ $price = -abs($price);}

		// ОТСТЪПКИ ----------------------- //
		$item_discount	= $this->input->post("discount");
		if ( $item_discount == '') { $item_discount = 0;}
		if (!is_numeric($item_discount)) 
			{ str_replace(',', '.', $item_discount);
			  str_replace('%', '', $item_discount);}

		// КОЛИЧЕСТВО --------------------- //
		$this->form_validation->set_rules('quantity', 'lang:items_quantity', 'required|numeric');
		if ($mode=='invoice_ki' or $mode=='invoice_di') 
			{ $quantity = abs($this->input->post("quantity"));}
		else 
			{ $quantity = $this->input->post("quantity");}

		if ($this->form_validation->run() != FALSE)
			{ $this->invoice_lib->edit_item($line,$item_name_bg,$item_name_en,$quantity,$item_discount,$price);}
		else
			{ $data['error']=$this->lang->line('sales_error_editing_item');}

	$this->_reload($data);
	}
	

	function delete_item($item_number)
	{
		$this->invoice_lib->delete_item($item_number);
		$this->_reload();
	}

	function clientData()
	{
		$bisoft_id = 0;
		$customer_id = $this->invoice_lib->get_customer();
		$cust_info=$this->Customer->get_info($customer_id);
		if($cust_info) {$bisoft_id = $cust_info->bisoft_id;}
		$comment = $this->invoice_lib->get_comment();
		
		if($bisoft_id==1000)
		{
			$name 	= $this->invoice_lib->get_client_name();
			$surname = $this->invoice_lib->get_client_surname();
			$address = $this->invoice_lib->get_client_data();
			$account_number = $this->invoice_lib->get_order();
		}
		else // нормален Клиент
		{
			$name 	= $cust_info->first_name;
			$surname = $cust_info->last_name;
			$address = $cust_info->address;
			$account_number = $cust_info->account_number;
		}		
			
			$data = array(
			'customer_id' => $customer_id,
			  'bisoft_id' => $bisoft_id,
		  'company_name' => $cust_info->company_name,
		'account_number' => $account_number,
		 		 'address' => $address,
					 'name' => $name,
				 'surname' => $surname,
				 'comment' => $comment );

		$this->load->view("invoices/client_data",$data);
	}
	

	function save_clientData()
	{
		$bisoft_id = $success = 0;
		$customer_id = $this->invoice_lib->get_customer();
		$cust_info = $this->Customer->get_info($customer_id);
		if($cust_info) {$bisoft_id = $cust_info->bisoft_id;$person_id = $cust_info->person_id;}

		if($bisoft_id and $person_id)
		{
			$new_id 	= $this->input->post('account_number');
			$name 	= $this->input->post('name');
			$surname	= $this->input->post('surname');
			$address = $this->input->post('address');
			$comment = $this->input->post('comment');
		
			if($bisoft_id!=1000)
			{
				$person_data = array(
					'bisoft_id'		=> $bisoft_id,
					'person_id'		=> $person_id,
					'first_name'	=> $name,
					'last_name'		=> $surname,
					'address'		=> $address );
							
				$customer_data=array(
					'bisoft_id'		=>	$bisoft_id,
					'person_id'		=>	$person_id,
				 'company_person' => $name.' '.$surname,
				 'account_number' => ($new_id=='') ? null : $new_id );
				
				$success = $this->Customer->save($person_data,$customer_data,$person_id);
			}

			$this->invoice_lib->set_order($new_id);
			$this->invoice_lib->set_client_name($name);
			$this->invoice_lib->set_client_surname($surname);
			$this->invoice_lib->set_client_data($address);
			$this->invoice_lib->set_comment($comment);
		}

		echo json_encode(array('success'=>true,
										'message'=>$this->lang->line('items_successful_updating') ));
	}
	
	
	/* =================== COMPLETE ================== */
	function complete()
	{
		sleep(1);
		$location = $this->BiSOFT_Model->get_location();
		$person_report = 1;
		if(!$this->Employee->has_permission('reports',$this->Employee->get_logged_in_employee_info()->person_id))
			{ $person_report = 0; }

		$data['mode'] = $mode = $this->invoice_lib->get_mode();
		$firma = $this->invoice_lib->get_firma();			
			
		$data['cart']= $this->invoice_lib->get_cart();
		$data['mode_price'] = $this->invoice_lib->get_mode_price();
		$data['subtotal']	= $this->invoice_lib->get_subtotal($mode);
	
		// определям ДДС-то ....
		$taxed = 0;
		$mode_price			= $data['mode_price'];
		if ( $mode_price == 'vat') { $taxed = 1;}
		$data['taxed']		= $taxed;

		$data['tax_VAT']	= $this->invoice_lib->get_tax_VAT($mode,$taxed);
		$data['currency']	= $this->config->item('currency_symbol');
		$data['all_qty']	= $this->invoice_lib->get_all_qty();

			//изтегля и разпределя атрибутите на документа  ..
			$doc_date = date('Y-m-d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
			$data['transaction_time']= date('Y-m-d');

			$vedom		= $this->BiSOFT_Model->get_vedom($mode);
			$doc_number	= $this->BiSOFT_Model->get_document_number($mode,$firma); // взима НОВ номер ...
			$doc_name	= $this->BiSOFT_Model->get_document_title($mode);

		$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
		$emp_info=$this->Employee->get_info($employee_id);
		$data['employee']=$emp_info->first_name.' '.$emp_info->last_name;

		$data['amount_change']=to_currency($this->invoice_lib->get_amount_due($mode,$taxed) * -1);
		$data['payments']=$this->invoice_lib->get_payments();
		
		// Определям КЛИЕНТА
		$bisoft_id = $add_vat = 0;
		$customer_id=$this->invoice_lib->get_customer();

				if($customer_id!=-1)
				{
					if(is_numeric($customer_id))
						{
							$cust_info=$this->Customer->get_info($customer_id);
							$bisoft_id=$cust_info->bisoft_id;
							
							if($bisoft_id==1000)  // НАСЕЛЕНИЕ
							{
								$cName 	 = $this->invoice_lib->get_client_name();
								$cSurname = $this->invoice_lib->get_client_surname();
								$data['customer'] = $cName.' '.$cSurname;
								$data['customer_company'] = $cName.' '.$cSurname; // $customer_id;
								$data['customer_discount']=0;
							}
							else // другите фирми
							{
								$data['customer']=$cust_info->company_person;
								$data['customer_company']=$cust_info->company_name;
								$data['customer_discount']=$cust_info->discount;
							}
						}
					else // Online Client
						{
							$bisoft_id=1000000;
								$data['customer']=$customer_id;
								$data['customer_company']=$customer_id;
								$data['customer_discount']=0;
						}
				}
				else 
				{ $data['customer_discount']=0;}

		$customer_discount = $data['customer_discount'];
		$data['total'] = to_currency_no_money($this->invoice_lib->get_total($mode,$customer_discount,$taxed));	

		$comment = $this->invoice_lib->get_comment();
		
		//SAVE sale to database
		$data['doc_id'] = $this->Invoice->save(
												$data['cart'], 
												$mode, 
												$data['all_qty'], 
												$data['subtotal'],
												$doc_number, 
												$doc_name,	
												$bisoft_id,
												$data['customer_company'], 
												$customer_discount, 
												$employee_id, 
												$data['payments'], 
												$comment);

		$doc_id = $data['doc_id'];

		if ($doc_id == 'doc-1')
		{ $data['error_message'] = $this->lang->line('sales_transaction_failed');}
		else
		{
			if ($this->invoice_lib->get_email_receipt() && !empty($cust_info->email))
			{
				$this->load->library('email');
				$config['mailtype'] = 'html';				
				$this->email->initialize($config);
				$this->email->from($this->config->item('email'), $this->config->item('company'));
				$this->email->to($cust_info->email); 
				$this->email->subject($this->lang->line('sales_receipt'));
				$this->email->message($this->load->view("invoices/receipt_email",$data, true));	
				$this->email->send();
			}
		}

		// определяме Ведомостта и вид на ПЕЧАТ...
		$vedomPack	= 'V'.date('ym', strtotime($doc_date));
		$print_type = $this->invoice_lib->get_mode_print();
		$backNoKey	= false;

		$this->invoice_lib->clear_all();
		$this->BiSOFT_Model->clear_user_modes();

		$this->invoice($doc_id,$vedomPack,$print_type,$mode);
	//	require_once(APPPATH."plugins/bisoft/blanka_invoices_print.php");
	}


// ----------------------------------------- специално за ФАКТУРИ -----------------------------------//
	function invoice($doc_id,$vedomPack,$print_type,$mode)
	{
		$user_id = $this->BiSOFT_Model->get_person();
		$this->load->library('bisoft_lib');
		$data['location'] = $location = $this->BiSOFT_Model->get_location();
			
		$document_info = $this->BiSOFT_Model->get_info_for_invoice($doc_id,$vedomPack)->row_array();

		$data['firma'] = $firma  = $document_info['location'];
		$doc_id = $document_info['doc_id'];

		$user_mode = $this->BiSOFT_Model->get_user_mode();
		if($user_mode=='kaca_invoice_in') {$data['kacaKey']=1;}

		$mode = $document_info['mode'];
		$this->BiSOFT_Model->set_user_mode($mode);
		
		//изтегля и разпределя атрибутите на документа  ..
		$vedom		= $this->BiSOFT_Model->get_vedom($mode);
		$doc_name	= $this->BiSOFT_Model->get_document_title($mode);
		$doc_number	= $document_info['doc_number'];
		$doc_date 	= $document_info['doc_date'];

		$this->bisoft_lib->set_mode($mode);
		$this->bisoft_lib->copy_entire_invoice($doc_number,$vedomPack,$firma);

		$data['mode']		= $document_info['mode'];
		$data['mode_id']	= $document_info['mode_id'];
		$data['taxed']		= $document_info['taxed'];
		$taxed				= $data['taxed'];

		$data['cart']		= $this->bisoft_lib->get_cart();
		$data['all_qty']	= $this->bisoft_lib->get_all_qty();

		$data['payments']	= $document_info['pay_type'];
		$data['subtotal']	= to_currency_no_money($this->bisoft_lib->get_invoice_subtotal());

		$data['transaction_time']= $document_info['doc_date'];
		$bisoft_id = $document_info['client_id'];
		$emp_info=$this->Employee->get_info($document_info['employee_id']);
		$data['payment_type']	= $document_info['pay_type'];
		$data['bank_account'] 	= $document_info['mode_price'];
		$data['currency']			= $document_info['currency'];
		$data['currency_rate']	= $document_info['currency_rate'];
		$data['employee_id']		= $document_info['employee_id'];
		$data['employee']			= $this->Employee->get_id_names($data['employee_id']);
		$data['location']			= 0;

		if($bisoft_id > 0)
		{
			$data['customer']=$data['customer_address']=$data['customer_city']=$data['customer_country']=$data['customer_data']='';
			if($bisoft_id == 1000) // НАСЕЛЕНИЕ
			{
				$data['customer_company']=$document_info['client'];
				$data['customer_data']=isset($document_info['client_data']) ? $document_info['client_data'] : '';
				$data['comment']=$document_info['comment'];
				$data['customer_account_number']=$document_info['order_id'];
				$data['customer_taxable']=1;
			}
			elseif($bisoft_id == 1000000)  // случаен клиент
			{
				$data['customer_company']=$document_info['client'];
				$data['customer_address']=$document_info['comment'];
				$data['customer_account_number']=$document_info['order_id'];
				$data['customer_taxable']=1;
			}
			else // нормален Клиент от БД
			{
				$cust_info=$this->Customer->get_info_by_bisoft_id($bisoft_id);
				if($cust_info)
					{
						$data['customer']=$cust_info->company_person;
						$data['customer_company']=$cust_info->company_name;
						$data['customer_account_number']=$cust_info->account_number;
						$data['customer_taxable']=$cust_info->taxable;
						$cust_address = $this->Person->get_info($cust_info->person_id);
						if($cust_address)
						{
							$data['customer_address']=$cust_address->address;
							if(!empty($cust_address->city)) {$data['customer_city']=$cust_address->city;}
							if(!empty($cust_address->country)) {$data['customer_country']=$cust_address->country;}
						} // if($cust_address)
               }
			} // нормален Клиент от БД
		}

		$customer_discount = 0;
		$data['customer_discount'] = $customer_discount;

		$data['total']		= to_currency_no_money( $this->bisoft_lib->get_invoice_total($mode,$taxed) );
		$data['tax_VAT']	= to_currency_no_money( $this->bisoft_lib->get_tax_VAT($mode,$taxed) );
		$data['order_id'] = $document_info['order_id']; // само за Ki и Di //
		$data['comment']  = $document_info['comment']; // за Invoices //

		$data['receipt_name'] 	= $doc_name;
		$data['receipt_number'] = $doc_number;
		$data['receipt_date'] 	= date('d.m.Y', strtotime($data['transaction_time']));
		$data['receipt_time'] 	= date('d.m.Y H:i:s');
		$data['print_date'] 		= date('H:i / d.m.Y', strtotime($document_info['date_start']));
		$data['bisoft_id'] 		= $bisoft_id;
		$data['vedomPack'] 		= 'V'.date('ym', strtotime($doc_date));
		
		$data['controller_name'] = 'Invoices';
		$data['backNoKey'] = 0;

		if($print_type=='invoices') {$this->load->view("bisoft/print_invoice",$data);}
		else {$this->load->view("bisoft/print_factura",$data);}

      $this->bisoft_lib->clear_all();
	}


	function print_to($mode)
	{
		// тук трябва да е друго нещо ...
		$this->complete();
	}


	function edit($doc_id,$vedomPack,$print_type,$mode)
	{
		$data = array();
		$data['vedomPack'] = $vedomPack;
		$data['print_type'] = $print_type;

		$data['doc_info'] = $this->Invoice->get_info($doc_id,$vedomPack)->row_array();

		if($mode=='shop_sale' or $mode=='shop_return')
		{
			// вземам си всички КОНСИГНАТОРИ
			$data['customers'] = array();
			foreach ($this->Consignee->get_all()->result() as $consignee)
				{ $data['customers'][$consignee->bisoft_id] = $consignee->company_name;}
		}
		else
		{
			// вземам си всички КЛИЕНТИ
			$data['customers'] = array('' => $this->lang->line('reports_edit_noclient'));
			foreach ($this->Customer->get_all()->result() as $customer)
				{ $data['customers'][$customer->bisoft_id] = $customer->company_name;}
		}

		// вземам си всички ОПЕРАТОРИ
		$data['employees'] = array();
		foreach ($this->Employee->get_operators()->result() as $employee)
			{ $data['employees'][$employee->person_id] = $employee->first_name . ' '. $employee->last_name;}

		$data['mode'] = $data['doc_info']['mode'];
		$data['location'] = $data['doc_info']['location'];
		$data['type_docs'] = array(
			'sale' 			=> $this->lang->line('sales_sale'),
			'sale_return' 	=> $this->lang->line('sales_return_sale'),
			'shop_sale' 	=> $this->lang->line('sales_shop_sale'),
			'shop_return' 	=> $this->lang->line('sales_shop_return')
											);
		
	$this->load->view('invoices/edit', $data);
	}
	

	function edit_invoice($doc_id,$vedomPack,$print_type,$mode)
	{
		$data = array();
		$data['vedomPack'] = $vedomPack;
		$data['print_type'] = $print_type;

		// вземам си всички КЛИЕНТИ
		$data['customers'] = array('' => $this->lang->line('reports_edit_noclient'));
		foreach ($this->Customer->get_all()->result() as $customer)
			{ $data['customers'][$customer->bisoft_id] = character_limiter($customer->company_name,45); }
			
// вземам си всички КЛИЕНТИ в list
	$data['custs'] = "";
	foreach ($this->Customer->get_all()->result() as $cust)
		{ $data['custs'] .= "<option value='".character_limiter($cust->company_name,45)."' id='c".$cust->bisoft_id."'>\n"; }

		// вземам си всички ОПЕРАТОРИ
		$data['employees'] = array();
		foreach ($this->Employee->get_operators()->result() as $employee)
			{ $data['employees'][$employee->person_id] = $employee->first_name . ' '. $employee->last_name;}

		$data['doc_info'] = $this->Invoice->get_info($doc_id,$vedomPack)->row_array();

		$data['mode'] = $data['doc_info']['mode'];
		$data['type_docs'] = array(
			'invoice' 		=> $this->lang->line('sales_receipt_invoice'),
			'invoice_ki' 	=> $this->lang->line('sales_receipt_invoice_ki'),
			'invoice_di' 	=> $this->lang->line('sales_receipt_invoice_di'),
			'invoice_pr' 	=> $this->lang->line('sales_receipt_invoice_pr'),
			'proforma' 		=> $this->lang->line('sales_receipt_proforma') );

		$firma = $data['doc_info']['location'];
		$firmas = array('0'=>$this->config->item('company'),'2'=>$this->config->item('2_company') );
		$data['firma'] = $firmas[ $firma ];
				
		$data['bank'] = $data['doc_info']['mode_price'];
		if($firma=='2')
		{
			$data['banks'] = array(
				'1' => $this->config->item('2_my_bank_account'),
				'2' => $this->config->item('2_my_bank_account_2')	);
		}
		else
		{
			$data['banks'] = array(
				'1' => $this->config->item('my_bank_account'),
				'2' => $this->config->item('my_bank_account_2'),
				'3' => $this->config->item('my_bank_account_3') );
		}
		
		$data['pay_groups'] = array(
			'P' 	=> $this->lang->line('kaca_cash'),
			'T' 	=> $this->lang->line('kaca_by_bank'),
			'NP' 	=> $this->lang->line('kaca_post_transfer'),
			'H'	=> $this->lang->line('kaca_notpaid'),
			'HT'	=> $this->lang->line('kaca_notpaid_bank'),
			'Ex'	=> $this->lang->line('kaca_export'),
			'ExV'	=> $this->lang->line('kaca_export_vat'),
			'PP'	=> $this->lang->line('kaca_paypal') );

		$data['all_currency'] = array(
			'1' => 'BGN',
			'2' => 'EUR',
			'3' => 'GBP',
			'4' => 'USD',
			'5' => 'RON' );
	
	$this->load->view('invoices/edit_invoice', $data);
	}
	

	function save($doc_id, $vedomPack, $mode)
	{
		$doc_date 		= $this->input->post('doc_date');
		$vedomPack_new	= 'V'. date('ym', strtotime($doc_date));

		$mode = $this->input->post('type_doc');
		$mode_id = $this->BiSOFT_Model->get_pay_group( $mode );
		$line_id = date('ym', strtotime($doc_date)).str_pad($doc_id, 4, "0", STR_PAD_LEFT);

		// дата на плащане
		$pay_date = $this->input->post('pay_date');
		if($pay_date=="1970-01-01" or $pay_date=="0000-00-00" or $pay_date=="01.01.1970" or $pay_date==null) {$pay_date=null;}
		else { $pay_date=date('Y-m-d', strtotime($pay_date)); }
		// Плащанията ...
		$pay_vat = 0;
		$pay_sale = $this->input->post('pay_sale');

		$taxed = 0;
		$total_sum 	 = $this->input->post('total_sum');
		$pay_amount  = $this->input->post('pay_amount');
		$total_taxes = $this->input->post('total_taxes');
		if($total_taxes!=0) {$taxed = 1;}
		
		$valuta = '1';
		$valuta_rate = '1.00000';
		if($taxed) {$pay_vat = $this->input->post('pay_vat');}
		
		if($pay_sale==0 and $pay_vat==0) { $pay_date = null; }
		
		$employee_id = $this->input->post('employee_id');
		$employee	=	$this->Employee->get_names($employee_id);
		
		$bank_mode	= 1;
		$order_id	= '';

		$client_id = $this->input->post('client_id') ? $this->input->post('client_id') : 0;
		if( !$client_id ) { $client = '';}
		else { $client = $this->Customer->get_info_by_bisoft_id($this->input->post('client_id'))->company_name;}

		if ( $mode=='invoice' or $mode=='invoice_ki' or $mode=='invoice_di' or $mode=='invoice_pr' or $mode=='proforma') 
			{ 
				if ( $this->input->post('bank')==2 ) { $bank_mode	= 2;}
				elseif ( $this->input->post('bank')==3 ) { $bank_mode	= 3;}
				$valuta = $this->input->post('currency');
				$valuta_rate = $this->input->post('currency_rate');

				// добавка на фактури към Кредитно и Дебитно Известия.
				if ( $mode=='invoice_ki' or $mode=='invoice_di')
					{ $order_id = $this->input->post('order_id');}
			}
			
		$doc_data = array(
					'doc_date' 		=> date('Y-m-d', strtotime($doc_date)),
					'mode' 			=> $mode,
					'mode_id' 		=> $mode_id,
					'mode_price'	=> $bank_mode,
					'client_id' 	=> $client_id,
					'client' 		=> $client,
					'total_qty' 	=> $this->input->post('total_qty'),
					'total_sum' 	=> $this->input->post('total_sum'),
					'pay_group'		=> $this->input->post('pay_group'),
					'pay_type' 		=> $this->input->post('pay_type'),
					'pay_amount'	=> $this->input->post('pay_amount'),
					'pay_sale'		=> $pay_sale,
					'pay_vat' 		=> $pay_vat,
					'pay_date'		=> $pay_date,

					'currency'		=> $valuta,
					'currency_rate'=> $valuta_rate,

					'taxed' 			=> $taxed,
					'total_taxes' 	=> $total_taxes,
					'employee_id' 	=> $employee_id,
						'order_id' 	=> $order_id,
					'employee' 		=> $employee,
					'comment' 		=> $this->input->post('comment') );

		$items_data = array(
					'doc_date' 		=> date('Y-m-d', strtotime($doc_date)),
					'mode_id' 		=> $mode_id,
					'item_taxes' 	=> $taxed,
					'client_id' 	=> $client_id );

		/* ============================    ========================= */
		if ($vedomPack==$vedomPack_new)
		{ // действа САМО при ДАТА в същия месец //

			// актуализира items ...
			$vedomItems = $vedomPack.'_items';
			if ($this->Invoice->update($doc_data, $doc_id, $vedomPack) and 
				 $this->Invoice->update_items($items_data, $doc_id, $vedomItems) )
				{ echo json_encode(array(	'success'=>true,
													'line_id'=>$line_id,
													'mode_id'=>$mode_id,
													'total'=>to_dot($total_sum),
													'taxes'=>to_dot($total_taxes),
													'amount'=>to_dot($pay_amount),
													'message'=>'За да актуализирате общите сборове, моля освежете страницата - REFRESH !!!' )
										);
				}
			else
				{ echo json_encode(array(	'success'=>false,
													'line_id'=>$line_id,
													'mode_id'=>$mode_id,
													'message'=>$this->lang->line('sales_unsuccessfully_updated') )
										);
				}
		}
		else // действа САМО при промяна на ДАТА //
		{
			// актуализира items ...
			$vedomItems = $vedomPack.'_items';
			$this->Invoice->update_items($items_data, $doc_id, $vedomItems);

			// премества items ...
			$vedomItems_new = $vedomPack_new.'_items';
			$this->BiSOFT_Model->set_user_date(date('Y-m-d H:i:s',strtotime($doc_date)));
			$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
			$doc_data['doc_number'] = $doc_number;

			$this->db->trans_start(); // --> отваря запис към БАЗАТА ...-->> 
				// вкарва данните от Документа в Месечната База Данни ... //
				$this->db->insert( $vedomPack_new, $doc_data);
				$newdoc_id = $this->db->insert_id();

				$old_item_data = $this->Invoice->get_sale_items($doc_id,$vedomPack);
				foreach($old_item_data->result_array() as $line=>$item)
				{
					$item['doc_id'] = $newdoc_id;
					$item['doc_number'] = $doc_number;
					$item['doc_date'] = date('Y-m-d', strtotime($doc_date));
					$this->db->insert($vedomItems_new,$item);
				}

			$this->db->trans_complete();

			$this->delete($doc_id,$vedomPack); // маха всичко старо //
			echo json_encode(array(	'success'=>true,
											'line_id'=>$line_id,
											'mode_id'=>$mode_id,
											'message'=>$this->lang->line('sales_successfully_moved') )
								  );
		}

	} // край
	
	
	
	
	function edit_line_item($doc_id, $line, $vedomPack)
	{
		$data = array();
		$data['vedomPack'] = $vedomPack;
		$data['line'] = $line;
		$data['item_info'] = $this->Invoice->get_info_line($doc_id, $line, $vedomPack)->row_array();
	$this->load->view('invoices/edit_line_item', $data);
	}
	
	/* ------------ New Row -------------- */
	function add_row($vedomPack,$doc_id)
	{
		$line = 1;
		do { $line++; }
		while ( $this->Invoice->exists_line_item($vedomPack,$doc_id,$line) );
		
		// формираме нов ред +1
		$doc_idx = $doc_id.substr($vedomPack,-4).str_pad($line, 3, "0", STR_PAD_LEFT);

		$data = array();
		$data['vedomPack'] = $vedomPack;
		$data['line'] = $line;
		$data['doc_idx'] = $doc_idx;

	$this->load->view('invoices/new_invoice_item', $data);
	}
	
	function save_new_item($doc_idx)
	{
		$line   = (int)substr($doc_idx,-3);
		$doc_id = (int)substr($doc_idx,0,-7);
		$vedom  = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom;

		$success = 0; 
		$mode_id = 'F';
		$line_id = $line;
		$data = array();
		$doc_info = $this->Invoice->get_doc_info($vedomPack,$doc_id);
		if($doc_info)
		{
			$taxed = $doc_info->taxed;
			$client_id = $doc_info->client_id;
			$doc_number = $doc_info->doc_number;
			$doc_date = $doc_info->doc_date;
			$mode_id  = $doc_info->mode_id;

				$inum  = $this->input->post('item_number');
				$name  = $this->input->post('item_name');
				$iname = $this->input->post('invoice_name');
				$qty   = $this->input->post('item_qty');
				$price = $this->input->post('item_unit_price');
				$dsc   = $this->input->post('item_discount');
				
			$line_id = $line;

			$data = array(
					'doc_id' => $doc_id,
					  'line' => $line,
				  'mode_id' => $mode_id,
			  'doc_number' => $doc_number,
			    'doc_date' => $doc_date,
			 'item_number' => $inum,
			   'item_name' => $name,
			'invoice_name' => $iname,
				 'item_qty' => $qty,
		'item_unit_price' => $price,
		  'item_discount' => $dsc,
			  'item_taxes' => $taxed,
					 'brand' => 1,
			   'client_id' => $client_id,
			     'deleted' => 0,
				 'location' => 0 );
				 
			$success = $this->Invoice->add_line_item($data, $vedomPack, $doc_id, $line );
			if($success) 
				{ 
					$totals = $this->Invoice->recalc_invoice($vedomPack,$doc_id); 
					$total_sum = $totals['total_sum'];
					$total_taxes = $totals['total_vat'];
					$pay_amount = $totals['amount_doc'];
				}
		}
		
		if($success)
			{
				$calc_data = $this->BiSOFT_Model->recalc_document($doc_idx);
				
				echo json_encode(array(
					'success'	=> true,
					'doc_row'	=> $doc_id.$vedom,
					'line'		=> $line,
					'line_id'	=> $doc_id.$vedom.str_pad($line, 3, "0", STR_PAD_LEFT),
					
					'qty_doc'   => $calc_data['qty_doc'],
					'sum_doc'   => $calc_data['sum_doc'],
					'all_doc'   => $calc_data['all_doc'],
					'tax_doc'   => $calc_data['tax_doc'],
				  'amount_doc' => $calc_data['amount_doc'],
					'cost_doc'  => $calc_data['cost_doc'],
					
					'total_qty' => $calc_data['total_qty'],
					'total_vat' => $calc_data['total_vat'],				
					'total_sum' => $calc_data['total_sum'],
					'total_all' => $calc_data['total_pay'],
				  'total_cost' => $calc_data['total_cost'],				
	
					'message'	=> $this->lang->line('reports_edit_line_success').' натиснете REFRESH !' ));										
										
			}
		else
			{ echo json_encode(array(
					'success'	=> false,
					'doc_row'	=> $doc_id.$vedom,
					'line'		=> $line,
					'line_id'	=> $doc_id.$vedom.str_pad($line, 3, "0", STR_PAD_LEFT),
					'message'	=> $this->lang->line('reports_edit_line_unsuccess')));
			}

	}


	function delete($doc_id,$vedomPack)
	{
		$data = array();

		if ($this->Invoice->delete($doc_id,$vedomPack))
			{ $data['success'] = $this->lang->line('sales_delete_successful');}
		else
			{ $data['error'] = $this->lang->line('sales_delete_unsuccessful');}

	$this->load->view('invoices/delete', $data);
	}
	

	function delete_line_item($doc_id, $line, $vedomPack)
	{ $this->Invoice->delete_line_item($doc_id, $line, $vedomPack);}



	// ================= AJAX edit vedom line ... ======================== //
	function edit_invoice_item($doc_idx)
	{
		$line   = (int)substr($doc_idx,-3);
		$doc_id = (int)substr($doc_idx,0,-7);
		$vedom  = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom;
			
		$data = array();
		$data['vedom'] = $vedom;
		$data['vedomPack'] = $vedomPack;
		$data['line'] = $line;
		$data['doc_idx'] 	 = $doc_idx;
		$data['item_info'] = $item_info = $this->BiSOFT_Model->get_doc_item($doc_idx);
		
	$this->load->view('invoices/edit_invoice_item', $data);
	}
	
	
	function save_invoice_item($doc_idx)
	{
		$line   = (int)substr($doc_idx,-3);
		$doc_id = (int)substr($doc_idx,0,-7);
		$vedom  = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom;
			
		$to_delete = $this->input->post('deleted');
		
		$qty = (int)$this->input->post('item_qty');
		$price = (float)$this->input->post('item_unit_price');
		$discount = (int)$this->input->post('item_discount');
		$costsale = round($price*(100-$discount)/100,7);

		$items_data = array(
			'doc_id' => $doc_id,
			'line' 	=> $line,
			'item_number' 			=> $this->input->post('item_number'),
			'item_name' 			=> $this->input->post('item_name'),
			'invoice_name' 		=> $this->input->post('invoice_name'),
			'item_qty' 				=> $qty,
			'item_unit_price' 	=> $price,
			'item_discount' 		=> $discount,
			'costsale' 				=> $costsale,
			'deleted' 				=> $to_delete );

		if ($this->BiSOFT_Model->update_line_item($items_data,$doc_idx))
			{
				$calc_data = $this->BiSOFT_Model->recalc_document($doc_idx);
				
				echo json_encode(array(
					'success'	=> true,
					'doc_row'	=> $doc_id.$vedom,
					'line'		=> $line,
					'line_id'	=> $doc_id.$vedom.str_pad($line, 3, "0", STR_PAD_LEFT),
					
					'qty_doc'   => $calc_data['qty_doc'],
					'sum_doc'   => $calc_data['sum_doc'],
					'all_doc'   => $calc_data['all_doc'],
					'tax_doc'   => $calc_data['tax_doc'],
				  'amount_doc' => $calc_data['amount_doc'],
					'cost_doc'  => $calc_data['cost_doc'],
					
					'total_qty' => $calc_data['total_qty'],
					'total_vat' => $calc_data['total_vat'],				
					'total_sum' => $calc_data['total_sum'],
					'total_all' => $calc_data['total_pay'],
				  'total_cost' => $calc_data['total_cost'],				
	
					'message'	=> $this->lang->line('reports_edit_line_success')));
			}
		else
			{ 	echo json_encode(array(
					'success'	=> false,
					'doc_row'	=> $doc_id.$vedom,
					'line'		=> $line,
					'line_id'	=> $doc_id.$vedom.str_pad($line, 3, "0", STR_PAD_LEFT),
					'message'	=> $this->lang->line('reports_edit_line_unsuccess')));
			}
	}


	function get_document_row()
	{
		$row_id = $this->input->post('row_id');
			$line = (int)substr($row_id,-3);
			$doc_idx = substr($row_id,0,-3);
				$vedom = substr($doc_idx,-4);
				$doc_id = substr($doc_idx,0,-4);
				
		$doc_info  = $this->BiSOFT_Model->get_info_for_invoice($doc_id,'V'.$vedom)->row();
		$item_info = $this->BiSOFT_Model->get_factura_item($vedom,$doc_id,$line);
		if($item_info->deleted == 0)
			{
				$item=array(
				 'controller' => 'Invoices',
					  'vedom'  => $vedom,
				    'mode_id' => $item_info->mode_id,
				    'doc_id'  => $item_info->doc_id,
					 'doc_num' => $item_info->doc_number,
						 'line' => $line,
						 'inum' => $item_info->item_number,
						 'name' => $item_info->item_name,
					 'name_en' => $item_info->invoice_name,	 
						 
					   'price' => $item_info->item_unit_price,
						  'qty' => $item_info->item_qty,
						  'dsc' => $item_info->item_discount,					  

						  'tax' => $item_info->item_taxes,
						  'val' => $doc_info->currency,
						 'rate' => $doc_info->currency_rate );

				$data_row = get_invoice_row( $item , 'Invoices' );
				echo $data_row;
			}
			else {echo '';}
	}
	
	
	
	
	function save_line_item($doc_id, $line, $vedomPack)
	{
		$items_data = array(
			'item_number' 			=> $this->input->post('item_number'),
			'item_name' 			=> $this->input->post('item_name'),
			'item_unit_price' 	=> $this->input->post('item_unit_price'),
			'item_discount' 		=> $this->input->post('item_discount'),
			'item_qty' 				=> $this->input->post('item_qty'),

			'qty_1' 				=> $this->input->post('qty_1'),
			'qty_2' 				=> $this->input->post('qty_2'),
			'qty_3' 				=> $this->input->post('qty_3'),
			'qty_4' 				=> $this->input->post('qty_4'),
			'qty_5' 				=> $this->input->post('qty_5'),
			'qty_6' 				=> $this->input->post('qty_6'),
			'qty_7' 				=> $this->input->post('qty_7'),
			'qty_8' 				=> $this->input->post('qty_8'),
			'qty_9' 				=> $this->input->post('qty_9'),
			'qty_max'			=> $this->input->post('qty_max')
							);

		if ($this->Invoice->update_line_item($items_data, $doc_id, $line, $vedomPack))
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('reports_edit_line_success')));
		}
		else
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('reports_edit_line_unsuccess')));
		}
	}

	
	function _payments_cover_total()
	{
		$total_payments = 0;
		foreach($this->invoice_lib->get_payments() as $payment)
			{ $total_payments += $payment['payment_amount'];}

	return true;
	}
	
	
	function cancel_invoice()
	{
		$this->invoice_lib->clear_all();
		$this->_reload();
	}
	

// ---------------------------------  SUSPEND ---------------------------------- //
	function suspend()
	{
		$location = $this->BiSOFT_Model->get_location();
		$data['mode']		= $mode = $this->invoice_lib->get_mode();
		$data['location'] = $location;

		$customer_discount = 0;
		$taxed = 0;

		$data['cart']		= $this->invoice_lib->get_cart();
		$data['subtotal']	= to_currency_no_money($this->invoice_lib->get_subtotal($mode));
		$data['taxes']		= $this->invoice_lib->get_taxes();
		$data['tax_VAT']	= to_currency_no_money($this->invoice_lib->get_tax_VAT($mode,$taxed));
		$data['total']		= to_currency_no_money($this->invoice_lib->get_total($mode,$customer_discount,$taxed));
		$data['currency']	= ' лв.'; // $this->config->currency_symbol;
		$data['all_qty']	= $this->invoice_lib->get_all_qty();

		//изтегля и разпределя атрибутите на документа  ..
			$vedom		= $this->BiSOFT_Model->get_vedom($mode);
			$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
			$doc_name	= $this->BiSOFT_Model->get_document_title($mode);
			$doc_date 	= date('Y-m-d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));

		$data['transaction_time']= date('Y-m-d');

		$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
		$emp_info=$this->Employee->get_info($employee_id);
		$data['employee']=$emp_info->first_name.' '.$emp_info->last_name;

		$comment = $this->input->post('comment');	
			if ($comment==0) { $comment = '';}

		$payment_type = $this->input->post('payment_type');
		$data['payment_type']=$this->input->post('payment_type');

		//Multiple payments
		$data['payments']=$this->invoice_lib->get_payments($mode);
		$data['amount_change']=to_currency($this->invoice_lib->get_amount_due($mode,$taxed) * -1);
		$data['payments_total']= $this->invoice_lib->get_payments_total($mode);
		$data['amount_due']	= $this->invoice_lib->get_amount_due($mode,$taxed);
		$data['payments']		= $this->invoice_lib->get_payments($mode);

		$customer_id=$this->invoice_lib->get_customer();
		$bisoft_id = 0;

		if($customer_id!=-1)
		{
			$cust_info=$this->Customer->get_info($customer_id);
			$bisoft_id=$cust_info->bisoft_id;
			$data['customer']=$cust_info->company_person;
			$data['customer_email']=$cust_info->email;
			$data['customer_company']=$cust_info->company_name;
			$data['customer_discount']=$cust_info->discount;
			$data['customer_account_number']=$cust_info->account_number;
			$data['customer_address']=''; // $cust_info->city.', '.$cust_info->address;
		} else {	$data['customer_discount'] = 0;}

		$customer_discount = $data['customer_discount'];

		$total_payments = 0;
		foreach($data['payments'] as $payment)
			{ $total_payments += $payment['payment_amount'];}

		//SAVE sale to database
		$data['doc_id'] = $this->Suspended->save_invoice(
													$data['cart'], 
													$mode, 
													$data['all_qty'], 
													$data['subtotal'],
													$doc_number, 
													$doc_name,	
													$bisoft_id, 
													$data['customer_discount'], 
													$employee_id, 
													$data['payments'], 
													$comment);

		if ($data['doc_id'] == 'doc-1')
			{ $data['error_message'] = $this->lang->line('sales_transaction_failed');}

	$this->invoice_lib->clear_all();
	$this->_reload(array('success' => $this->lang->line('sales_successfully_suspended_sale')));
	}
	

	function suspended()
	{
		$data = array();
		$data['suspended'] = $this->Suspended->get_all()->result_array();
	$this->load->view('invoices/suspended', $data);
	}
	
	function unsuspend()
	{
		$doc_id = $this->input->post('suspended_doc_id');
		$this->invoice_lib->clear_all();
		$this->invoice_lib->copy_entire_suspended_invoice($doc_id);
		$this->Suspended->delete($doc_id);
  	$this->_reload();
	}


	
	
/* =========================== REALEN START ================================== */
	function _reload($data=array())
	{
		$person_info = $this->Employee->get_logged_in_employee_info();
		$location 	 = $this->BiSOFT_Model->get_location();
		$key_CKP  	 = $this->BiSOFT_Model->get_version_ckp();
		$person_mode = $this->BiSOFT_Model->get_user_mode();
		
		// да си определим фирмата 
		$firma_key = $this->BiSOFT_Model->get_firma_key();
			$styler_key = $firma_key['styler'];
			$hanna_key  = $firma_key['hanna'];

		$person_report = 1;
		if(!$this->Employee->has_permission('reports',$this->Employee->get_logged_in_employee_info()->person_id))
			{ $person_report = 0; }
		$data['person_report'] = $person_report;

		$data['dateKey'] = $dateKey = $this->invoice_lib->get_dateKey();

		// зарежда количката ...
		$data['cart']	= $this->invoice_lib->get_cart();

		// зарежда размерите ...
		$data['size_grid']= $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table']= $this->BiSOFT_Model->get_sizes('grid_3');
		$data['size_table_top']= $this->BiSOFT_Model->get_sizes('grid_4');

		$mode = $this->invoice_lib->get_mode();
		$this->BiSOFT_Model->set_user_mode($mode);
		
		// определяме за коя фирма ?!
		$data['firma'] = $firma = $this->invoice_lib->get_firma();
		$data['modes_firmas'] = array(
			   '0' => '--- '.$this->lang->line('common_select_company').' ---', // ИЗБЕРЕТЕ ФИРМА 
				'1' => $this->config->item('company'),
				'2' => $this->config->item('2_company') );
				
		// $this->config->item('vat') - ИМА ли ДДС Регистрация ФИРМАТА ???
		$firma_vat = $this->config->item('vat');
		if($data['firma']==2) {$firma_vat = $this->config->item('2_vat');}
		$data['firma_vat']=$firma_vat;
		
		// mode prices
		$data['mode_price'] = $mode_price = $this->invoice_lib->get_mode_price();
		if ($firma_vat==1)
			{
				$data['modes_prices'] = array(
					100	=> $this->lang->line('sales_price_vat'),
					99		=> $this->lang->line('sales_price_no_vat'),
					102	=> $this->lang->line('sales_export_vat'),
					101	=> $this->lang->line('sales_export_no_vat') );
			}
		else
			{
				$data['modes_prices'] = array(
					99		=> $this->lang->line('sales_price_no_vat'),
					101	=> $this->lang->line('sales_export_no_vat') );
			}

		// Валути ...
		$data['mode_valuta'] = $valuta = $this->invoice_lib->get_mode_valuta();
		$data['modes_valutas'] = array(  2 => 'EUR',
													3 => 'GBP',
													4 => 'USD',
													5 => 'RON' );
													
		$data['rate'] = $this->invoice_lib->get_rate();
		
		if((int)$data['rate']==1 and $styler_key) // само за STYLER ?!
			{ 
				if($valuta==2) { $this->invoice_lib->set_rate(1.95583);}
				if($valuta==5) { $this->invoice_lib->set_rate(0.41666);} // при курс на RON=2.4 BGN
			}
		
		// No документ
		$data['new_doc_No'] = $new_doc_No = $this->BiSOFT_Model->get_document_number($mode,$firma,1); // проверява check=1
		if ( $location == 0 ) //тук се вкарат документите, с които работи само БАЗАТА
		{
			$new_doc_show = '';if($firma>0){$new_doc_show = ' № '.$new_doc_No;}
			if ( !$key_CKP )
			{
				$data['modes']=array(
					'invoice'		=> $this->lang->line('sales_invoice').$new_doc_show,
					'proforma'		=> $this->lang->line('sales_proforma'),
					'invoice_ki'	=> $this->lang->line('sales_invoice_ki'),
					'invoice_di'	=> $this->lang->line('sales_invoice_di'),
					'invoice_pr'	=> $this->lang->line('sales_invoice_pr')
			//		'offer'			=> $this->lang->line('sales_offer')	
					);
			}
			else
			{
				$data['modes']=array(
					'proforma'		=> $this->lang->line('sales_proforma')
			//		'offer'			=> $this->lang->line('sales_offer')	
					);
			}
		}
		else 	{$data['modes']=array();} // с които работят само МАГАЗИНИТЕ

		$data['modes_years']=array();
		for($k=0;$k<2;$k++) // установява само тек. и предходна година.
			{ $data['modes_years'][date("Y")-$k] = date("Y")-$k;}
		
		$data['modes_months'] = array(
			'01' => $this->lang->line('cal_january'),
			'02' => $this->lang->line('cal_february'),
			'03' => $this->lang->line('cal_march'),
			'04' => $this->lang->line('cal_april'),
			'05' => $this->lang->line('cal_mayl'),
			'06' => $this->lang->line('cal_june'),
			'07' => $this->lang->line('cal_july'),
			'08' => $this->lang->line('cal_august'),
			'09' => $this->lang->line('cal_september'),
			'10' => $this->lang->line('cal_october'),
			'11' => $this->lang->line('cal_november'),
			'12' => $this->lang->line('cal_december')	);

		$data['mode']			= $mode;
		$data['mode_day']		= (int) date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['mode_month']	= (int) date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		$data['cur_date']		= date('d.m.Y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));

		$m_limit = $this->BiSOFT_Model->get_month_limit($data['mode_month'],$data['mode_year']);
		$data['modes_days'] = array();
		for($k=1;$k<=$m_limit;$k++) { $data['modes_days'][$k]=$k;}
		
		$data['location']		= $location;
		$data['subtotal']		= to_currency_no_money($this->invoice_lib->get_subtotal($mode));

		$bisoft_id = $data['customer_add_vat'] = 0;
		$customer_id = $this->invoice_lib->get_customer();
		if( $customer_id != -1)
			{	$bisoft_id=1000000;$data['customer_address']='';
					if(is_numeric($customer_id))
						{
						$bisoft_id=$customer_id;
						$cust_info=$this->Customer->get_info($customer_id);
							$data['customer']=$cust_info->company_person;
							$data['customer_email']=$cust_info->email;
							$data['customer_company']=$cust_info->company_name;
							$data['customer_discount']=$cust_info->discount;
							$data['customer_account_number']=$cust_info->account_number;
							$data['customer_price']=$cust_info->price_group;
							$data['customer_add_vat']=$cust_info->add_vat;

						}
					else // случаен клиент
						{
							$data['customer']='';
							$data['customer_company']=$customer_id;
							$data['customer_discount']=0;
							$data['customer_email']='';
							$data['customer_account_number']='';
							$data['customer_price']=2;
						}
			} 
			else 
			{	$data['customer_discount'] = 0;}

		$customer_discount = 0;
		$this->BiSOFT_Model->set_mode_location($location);
		$this->BiSOFT_Model->set_user_client(0);
				
		// определям ДДС-то ....
		$taxed = 0;
		if ( $mode_price == 100 or $mode_price == 102) { $taxed = 1;}
		$data['taxed'] = $taxed;
		
		$invKey = 0;
		if ( $mode_price > 100) 
			{  
				$data['invKey'] = $invKey = 1;
				$data['mode_print'] = 'invoices';
			}
		else
			{	$data['invKey'] = $invKey = 0;
				$data['mode_print'] = 'prices';
			}

		$data['tax_VAT']		= to_currency_no_money($this->invoice_lib->get_tax_VAT($mode,$taxed));
		$data['currency']		= $this->config->item('currency_symbol');

		$data['all_qty']		= $this->invoice_lib->get_all_qty();
		$data['items_module_allowed'] = $this->Employee->has_permission('items', $person_info->person_id);
		$data['comment'] 		= $this->invoice_lib->get_comment();
		$data['email_receipt'] = $this->invoice_lib->get_email_receipt();
		$data['payments_total']= $this->invoice_lib->get_payments_total($mode);
		$data['amount_due']	= $this->invoice_lib->get_amount_due($mode,$taxed);
		$data['payments']		= $this->invoice_lib->get_payments();
		$data['payments_cover_total'] = $this->_payments_cover_total();
		$data['total']	= to_currency_no_money($this->invoice_lib->get_total($mode,$customer_discount,$taxed));

		$data['payment_key'] = $this->invoice_lib->get_mode_payment($styler_key);
		if($styler_key)
		{
			$data['payment_options'] = array(
					$this->lang->line('sales_not_paid') 	 	=> $this->lang->line('sales_not_paid'),
					$this->lang->line('sales_cash') 			 	=> $this->lang->line('sales_cash'),
					$this->lang->line('sales_by_bank') 		 	=> $this->lang->line('sales_by_bank'),
					$this->lang->line('sales_by_bank').'2'  	=> $this->lang->line('sales_by_bank').'-2',
					$this->lang->line('sales_post_transfer')  => $this->lang->line('sales_post_transfer') );
		}
		else
		{
			$data['payment_options'] = array(
					$this->lang->line('sales_by_bank') 		 => $this->lang->line('sales_by_bank'),
					$this->lang->line('sales_by_bank').'2'  => $this->lang->line('sales_by_bank').'-2',
					$this->lang->line('sales_cash') 			 => $this->lang->line('sales_cash'),
					$this->lang->line('sales_not_paid') 	 => $this->lang->line('sales_not_paid')	);
		}
				
		// дали е платена фактурата ?
		$data['is_paid'] = $this->invoice_lib->get_is_paid();
		if($data['is_paid']=='-1')
		{ 
			$is_paid = 1; if($styler_key) {$is_paid=0;}
			$this->invoice_lib->set_is_paid($is_paid);
			$data['is_paid'] = $is_paid;
		}
		$data['paid_range'] = array(
			'1' => $this->lang->line('invoice_paid'),
			'0' => $this->lang->line('invoice_not_paid') );

		if (isset($info)) 	{ $data['info'] = $info;}
		if (isset($success)) { $data['success'] = $success;}
		if (isset($error)) 	{ $data['error'] = $error;}
		
		$data['controller_name']=strtolower(get_class());

	$this->load->view("invoices/register",$data);
	}

}
?>
