<?php require_once ("Secure_area.php");
		require_once ("interfaces/iData_controller.php");
		
class Items extends Secure_area implements iData_controller
{
	function __construct()
	{ parent::__construct('Items');$this->load->library('Label_lib'); }

	function index($list='0')
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'items';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		$data=array('list'=>$list);

		$this->refresh($data);
	}

	function refresh($data=array())
	{
		$location = $data['location'] = $this->Employee->get_logged_in_employee_info()->location;
		if($location!=0) {$this->BiSOFT_Model->set_user_client($location);}
		$skl = $data['skl'] = $this->BiSOFT_Model->get_user_mode_client();
			
			// вземам си всички КОЛЕКЦИИ
			$data['collection'] = $this->BiSOFT_Model->get_mode_mat();
			$data['collections'] = array('0' => '-- '.$this->lang->line('items_all_collections').' --');
			foreach ($this->Item->get_collections()->result() as $collection)
			{ $data['collections'][$collection->key] = $collection->collection_bg;}

			// вземам си всички КАТЕГОРИИ
			$data['category'] = $this->BiSOFT_Model->get_mode_assort();
			$data['categories'] = array('0' => '-- '.$this->lang->line('items_all_categories').' --');
			foreach ($this->Item->get_item_categories()->result() as $category)
			{ $data['categories'][$category->cat_id] = $category->category_bg;}		
		
		// вземам си всички СКЛАДОВЕ		
		if($location==0)
			{
				$data['consignee']  = $this->BiSOFT_Model->get_user_mode_client();
				$data['consignees'] = array('0' => '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$this->lang->line('items_title_header'));
				foreach ($this->Item->get_all_consignees()->result() as $consignee)
				{ $data['consignees'][$consignee->bisoft_id] = ' ( '.$consignee->bisoft_id.' ) - '.character_limiter($consignee->company_name,32);}
				if($skl==0){$data['sklad_title']=$this->lang->line('items_title_header');}
				else{$data['sklad_title']=$this->lang->line('items_sklad').$data['consignees'][$skl];}
			}
		else
			{	
				$data['sklad_title'] = $this->lang->line('items_sklad').' '.$skl.' - '.$this->Consignee->get_consi_name($location);
				$data['consignee']  = $location;
				$data['consignees'] = array($location=>$data['sklad_title'] );
			}

		$data['modes_years']=array();
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		$limit_year=5; // date('y')-13; ... преди установяваше тек.година-13 или от 2014г.
		for($k=0;$k<$limit_year;$k++)
			{ $data['modes_years'][date("Y")-$k] = date("Y")-$k;}

		$data['controller_name'] = strtolower(get_class());
		$data['form_width'] = $this->get_form_width();
		$config['base_url'] = site_url('/items/index');

		// New Pagination
		$config['per_page'] = 25;
		$all_records = $this->Item->get_pages($data['skl'],$data['category'],$data['collection']);
		$data['pages'] = ceil($all_records/$config['per_page']);
		$page_offset = 0;
		if(!isset($data['page'])) {$data['page']=1;}
		else{$page_offset = $config['per_page'] * ($data['page']-1);}

		$data['size_grid']  = $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table'] = $this->BiSOFT_Model->get_sizes('grid_2');
		$data['key_print']  = 0;
		$data['manage_table'] = get_items_manage_table( $this->Item->get_real_sklad($data['skl'],$data['category'],$data['collection'],$config['per_page'], $page_offset ), $this ); // $this->uri->segment( $config['uri_segment'] )
	$this->load->view('items/manage',$data);
	}
	
	function pages($page=1)
	{
		$data=array( 'page' => $page );
		$this->refresh($data);
	}
	
	function change_collection()
	{
		$collection = $this->input->post("item_collection");
		$this->BiSOFT_Model->set_mode_mat($collection);  // използвам mat за колекции ?!
		$this->refresh();
	}	
	
	function change_item_category()
	{
		$category = $this->input->post("item_category");
		$this->BiSOFT_Model->set_mode_assort($category);
		$this->refresh();
	}
	
	function change_sklad()
	{
		$sklad = $this->input->post("item_sklad");
		$this->BiSOFT_Model->set_user_client($sklad);
		$this->refresh();
	}
	
	function change_YEAR()
	{
		$mode_year = $this->input->post("mode_year");
		if ($mode_year > date ('Y'))	
				{ $this->BiSOFT_Model->set_user_year(date('Y')); }
		else  { $this->BiSOFT_Model->set_user_year($mode_year); }
		$this->refresh();
	}

	function find_item_info()
	{
		$item_number=$this->input->post('scan_item_number');
		echo json_encode($this->Item->find_item_info($item_number));
	}

	function search()
	{
		$search=$this->input->post('search');
		$data_rows=get_items_manage_table_data_rows($this->Item->search($search),$this);
		echo $data_rows;
	}


	function suggest()
	{
		$suggestions = $this->Item->get_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}
	
	function item_search()
	{
		$suggestions = $this->Item->get_item_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}
	

	function suggest_category()
	{
		$suggestions = $this->Item->get_category_suggestions($this->input->post('q'));
		echo implode("\n",$suggestions);
	}

	function get_row()
	{
		$item_id = $this->input->post('row_id');
		if($item_id>0){$data_row=get_item_data_row($this->Item->get_sklad_idx($item_id),$this);echo $data_row;}	
	}

	
	
/* ============================================= DIALOG BOXES ============================ */ 	
	function view($item_id=-1)
	{
		$data['item_id']  = $item_id;
		$data['user_id']	= $user_id = $this->BiSOFT_Model->get_person();
		$data['location'] = $location = $this->Employee->get_logged_in_employee_info()->location;
		$data['inum']= $data['skl'] = $skl = 0; $data['name']='';
		$data['skl_info'] = $data['item_info'] = array();
		
		if($item_id>0)
		{	
			$data['skl_info']   = $skl_info = $this->Item->get_sklad_idx($item_id);
			$data['inum'] 		  = $skl_info->inum;
			$data['skl'] = $skl = $skl_info->skl;
			$data['item_info']  = $this->Item->get_item_info($data['inum']);
			$data['sgp_info']   = $this->Item->get_sklad_info($data['inum'],0);
			
			$data['pattern'] = 0; $data['pattern_MK'] = '001';
			if($this->Item->exists_pattern($data['inum']))
         {
           $patt_info = $this->Item->get_info_pattern($data['inum']);
           $data['pattern'] = $patt_info->patt;
           $data['pattern_MK'] = $patt_info->MK;
         }
		}

		if($location!=0 and $skl_info->qty==0 and $data['inum']>0) 
			{redirect('items/view_sale/'.$data['inum']);}

		// събира всички останали dropdowns ...
		$data = $this->Item->get_all_dropdowns($data);

		if ( $skl==0 and $location==0) 
			{ $this->load->view("items/form",$data);}
		elseif ( $skl!=0 and $location==0) 
			{ $this->load->view("items/form_shop",$data);} // form_shop
		elseif ( $user_id<6 and $skl!=0) 
			{ $this->load->view("items/form",$data);}
		elseif ( $skl==7 and $location==7) 
			{ $this->load->view("items/form",$data);} // красю ...
		else 
			{ $this->load->view("items/form_shop",$data);} // form_sale това виждат магазините ?!
	}

	
	
	function view_sale($item_number)
	{
		$data['skl']  = $this->BiSOFT_Model->get_location();
		$data['inum'] = $item_number;		
		$data['name'] = $this->Item->get_name($item_number);
		$data['skl_info']= $this->Item->get_sklad_info($item_number,$data['skl']);
		$data['item_info'] = $this->Item->get_item_info($item_number);
		// събира всички останали dropdowns ...
		$data = $this->Item->get_all_dropdowns($data);	
	$this->load->view("items/form_sale",$data);
	}
	
	// View ITEM for PRODUCTION ....
	function view_manu($item_number)
	{
		$data['location']	 = $this->BiSOFT_Model->get_location();
		$data['user_id']	 = $this->BiSOFT_Model->get_person();
		$data['status']	 = $item_number;
		$data['item_info'] = $this->Item->get_info_from_sgp($item_number);
		$data['skl_info']  = $this->Item->get_sklad_info($item_number,0);
		// събира всички останали dropdowns ...
		$data = $this->Item->get_all_dropdowns($data);

	$this->load->view("items/form_manu",$data);
	}
	
	// -------------------------- специално за НАШИ Магазини ---------------------------------------- //
	function view_shop($item_id)
	{
		$user_id = $this->BiSOFT_Model->get_person();
		$data['user_id']	= $user_id;
		$data['status']	= $item_id;
	   $data['item_info'] = $this->Item->get_info_from_shop($item_id);
		$data['location'] = $data['item_info']->location;
		$item_number 		= $data['item_info']->item_number;
	   $data['sgp_info']	= $this->Item->get_info_from_sgp($item_number);
		// събира всички останали dropdowns ...
		$data = $this->Item->get_all_dropdowns($data);

	$this->load->view("items/form_shop",$data);
	}
	
	
	//BiSOFT Inventory Details
	function count_details($inum)
	{
		$data['user_id']	= $this->BiSOFT_Model->get_person();
		$location=$data['location']=$this->Employee->get_logged_in_employee_info()->location;
		$skl = $data['skl'] = $this->BiSOFT_Model->get_user_mode_client();		
		$data['skl_info'] = $skl_info = $this->Item->get_sklad_info($inum,$skl);
		$data['inum'] = $inum;
		$data['item_id'] = $skl_info->item_id;
		$data['name'] = $this->Item->get_name($inum);
		$data['item_info'] = $this->Item->get_item_info($inum);
		$data['vedom_pack']	= $this->BiSOFT_Model->get_vedom();
		$data['vedom_year']	= $this->BiSOFT_Model->get_user_mode_year();
	$this->load->view("items/count_details",$data);
	}


	//BiSOFT Test Item flow
	function test_item($inum=-1)
	{
	
die();
		$data['location']		= $location;
		$data['vedom_pack']	= $this->BiSOFT_Model->get_vedom();
		$data['vedom_year']	= $this->BiSOFT_Model->get_user_mode_year();
		$data['item_info']	=$this->Item->get_from_sklad($inum);
		$data['item_R_info']	=$this->Item->get_from_R_sklad($inum);
	$this->load->view("items/test_item",$data);
	}

	//BiSOFT Test Item flow
	function test_item_save_R($item_number=-1)
	{
		$location = $this->BiSOFT_Model->get_location();
		if (!$location)
			{ $item_id = $this->Item->get_info_from_sgp($item_number)->item_id;}
		else
			{ $item_id = $this->Item->get_from_sklad($item_number)->item_id;}
		$allow_sizes = $this->Item->get_info($item_id)->allow_sizes;

		if($allow_sizes)
			{
				$item_R_data = array(
					'item_id'=> $item_id,
					'item_number'=> $item_number,

					'quantity'=>$this->input->post('R_all_qty'),
					'qty_1' => ($this->input->post('R_qty_1')!=0) ? $this->input->post('R_qty_1') : '',
					'qty_2' => ($this->input->post('R_qty_2')!=0) ? $this->input->post('R_qty_2') : '',
					'qty_3' => ($this->input->post('R_qty_3')!=0) ? $this->input->post('R_qty_3') : '',
					'qty_4' => ($this->input->post('R_qty_4')!=0) ? $this->input->post('R_qty_4') : '',
					'qty_5' => ($this->input->post('R_qty_5')!=0) ? $this->input->post('R_qty_5') : '',
					'qty_6' => ($this->input->post('R_qty_6')!=0) ? $this->input->post('R_qty_6') : '',
					'qty_7' => ($this->input->post('R_qty_7')!=0) ? $this->input->post('R_qty_7') : '',
					'qty_8' => ($this->input->post('R_qty_8')!=0) ? $this->input->post('R_qty_8') : '',
					'qty_9' => ($this->input->post('R_qty_9')!=0) ? $this->input->post('R_qty_9') : '',
					'qty_max'=> ($this->input->post('R_qty_max')!=0) ? $this->input->post('R_qty_max') : '',

					'date_start' => date('Y-m-d', strtotime( $this->input->post('date_R'))),
					'date_end' 	 => date('Y-m-d', strtotime( $this->input->post('date_SKL')))
											);
			}
		else
			{
				$item_R_data = array(
					'item_id'=> $item_id,
					'item_number'=> $item_number,

					'quantity'=>$this->input->post('R_qty'),

					'date_start' => date('Y-m-d', strtotime( $this->input->post('date_R'))),
					'date_end' 	 => date('Y-m-d', strtotime( $this->input->post('date_SKL')))
											);
			}

		// запис в R базата ...
		if ( $this->Item->save_R($item_R_data,$item_id) )
			{ 	// Удачно регистриране ...
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('items_successful_updating').' '.
				$item_R_data['item_number']));
			}
		else
			{
				echo json_encode(array('success'=>false,'message'=>$this->lang->line('items_error_adding_updating').' '.
				$item_R_data['item_number']));
			}

	} //============================================= BiSOFT



	//BiSOFT Inventory Details
	function shop_details($item_id)
	{
		$data['vedom_pack'] = $this->BiSOFT_Model->get_vedom();
		$data['vedom_year'] = $this->BiSOFT_Model->get_user_mode_year();
		$data['item_info']  = $this->Item->get_info_from_shop($item_id);
		$data['location']   = $data['item_info']->location;
	$this->load->view("items/shop_details",$data);
	} //------------------------------------------- BiSOFT


	//BiSOFT Inventory Tracking NOT WORKING AT THE MOMENT ---------------------->>
	function inventory($item_id=-1)
	{
		$data['location']  = $this->BiSOFT_Model->get_location();
		$data['item_info'] = $this->Item->get_info($item_id);
	$this->load->view("items/inventory",$data);
	}


   // saves items attributes
	function save($item_id='-1')
	{
		$success=1;
		$location = $this->Employee->get_logged_in_employee_info()->location;
		$user_id  = $this->BiSOFT_Model->get_person();
		$skl_info = $this->Item->get_sklad_idx($item_id);
	
		// размерите ...
		$allow_sizes = $this->input->post('allow_sizes');
		$qty = $this->input->post('quantity');
		$q1 = $q2 = $q3 = $q4 = $q5 = $q6 = $q7 = $q8 = $q9 = $q10 = '';
		
		if($allow_sizes) // and $allow_sizes!='105'
		{
			$qty=0;
			
			if($this->input->post('qty_1')!=0)
			{ $q1 = $this->input->post('qty_1'); $qty += (int)$this->input->post('qty_1'); }
			
			if($this->input->post('qty_2')!=0)
			{ $q2 = $this->input->post('qty_2'); $qty += (int)$this->input->post('qty_2'); }
			
			if($this->input->post('qty_3')!=0)
			{ $q3 = $this->input->post('qty_3'); $qty += (int)$this->input->post('qty_3'); }
			
			if($this->input->post('qty_4')!=0)
			{ $q4 = $this->input->post('qty_4'); $qty += (int)$this->input->post('qty_4'); }
			
			if($this->input->post('qty_5')!=0)
			{ $q5 = $this->input->post('qty_5'); $qty += (int)$this->input->post('qty_5'); }
			
			if($this->input->post('qty_6')!=0)
			{ $q6 = $this->input->post('qty_6'); $qty += (int)$this->input->post('qty_6'); }
			
			if($this->input->post('qty_7')!=0)
			{ $q7 = $this->input->post('qty_7'); $qty += (int)$this->input->post('qty_7'); }
			
			if($this->input->post('qty_8')!=0)
			{ $q8 = $this->input->post('qty_8'); $qty += (int)$this->input->post('qty_8'); }
			
			if($this->input->post('qty_9')!=0)
			{ $q9 = $this->input->post('qty_9'); $qty += (int)$this->input->post('qty_9'); }

			if($this->input->post('qty_10')!=0)
			{ $q10 = $this->input->post('qty_10'); $qty += (int)$this->input->post('qty_10'); }
		}
		
      $item_care = $this->input->post('item_care');
      if(!$item_care) {$item_care='gDLHU';}
		
		$input_data=array('item_id'=>$item_id,'inum'=>$this->input->post('item_number'),
								'name'=>$this->input->post('name'),'qty'=>$qty,
								'q1'=>$q1,'q2'=>$q2,'q3'=>$q3,'q4'=>$q4,'q5'=>$q5,
								'q6'=>$q6,'q7'=>$q7,'q8'=>$q8,'q9'=>$q9,'q10'=>$q10,
								'qmin'=>$this->input->post('qmin'),'qmax'=>$this->input->post('qmax'),
								'cat'=>$this->Item->get_cat_id($this->input->post('categories')),
								'category'=>$this->input->post('categories'),
								'coll'=>$this->input->post('collections'),
								'allow'=>$allow_sizes,
								'kit_1'=>$this->input->post('kit_1'),
								'kit_2'=>$this->input->post('kit_2'),
								'kit_3'=>$this->input->post('kit_3'),
								'price'  => $this->input->post('price'),
								'price_2'=> $this->input->post('price_2'),
								'price_3'=> $this->input->post('price_3'),
								'price_4'=> $this->input->post('price_4'),
								'price_5'=> $this->input->post('price_5'),
								'price_6'=> $this->input->post('price_6'),
								'cost'=> $this->input->post('cost'),
								'dsc'=>intval($this->input->post('discount')),
								'opis'=>$this->input->post('description'),
								'supplier'=>$this->input->post('supplier'),
								'contents'=>$this->input->post('item_contents'),
								'item_care'=>$item_care,
								'color'=>$this->input->post('colors'),
								'currency'=>$this->input->post('item_currency'),
								'pattern'=>$this->input->post('pattern'),
								'pattern_MK'=>$this->input->post('pattern_MK'),
								'del'=>($this->input->post('deleted')!=0) ? 1 : 0
								);
							
		$result = $this->Item->save_sklad_pack($input_data);
		$success *= $result['success'];

		if($success)
		{
			//New item
			if($item_id==-1)
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('items_successful_adding').
				' '.$input_data['inum'].' '.$input_data['name'],'item_id'=>$item_id) );
			}
			else //previous item
			{
				//правя си служебно -> ИЗРАВНИТЕЛНА БЕЛЕЖКА
				$inum = $input_data['inum'];
				
				$quantity = $skl_info ? $qty - $skl_info->qty : $qty;
				$new_qty  = $qty - $skl_info->qty;

				if($new_qty!=0 and ($user_id>1 and $user_id<11)) // без мен само :)
				{
					$mode ='balance'; $mode_id = 'BL';
					$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
					$emp_info=$this->Employee->get_info($employee_id);
					$employee_name=$emp_info->first_name.' '.$emp_info->last_name;
					$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
					$doc_date = date('Y-m-d');

						// обслужвам си '0'-те ...
						$qb1 = (int)$q1 - intval($skl_info->q1); if($qb1==0) {$qb1='';}
						$qb2 = (int)$q2 - intval($skl_info->q2); if($qb2==0) {$qb2='';}
						$qb3 = (int)$q3 - intval($skl_info->q3); if($qb3==0) {$qb3='';}
						$qb4 = (int)$q4 - intval($skl_info->q4); if($qb4==0) {$qb4='';}
						$qb5 = (int)$q5 - intval($skl_info->q5); if($qb5==0) {$qb5='';}
						$qb6 = (int)$q6 - intval($skl_info->q6); if($qb6==0) {$qb6='';}
						$qb7 = (int)$q7 - intval($skl_info->q7); if($qb7==0) {$qb7='';}
						$qb8 = (int)$q8 - intval($skl_info->q8); if($qb8==0) {$qb8='';}
						$qb9 = (int)$q9 - intval($skl_info->q9); if($qb9==0) {$qb9='';}
					  $qb10 = (int)$q10- intval($skl_info->q10); if($qb10==0) {$qb10='';}

						$total_sum = $quantity * $this->input->post('price');

						// зареждам основните параметри на Главния документ ......
						$docs_data = array(
								'mode'				=> $mode,
								'mode_id'			=> $mode_id,
								'doc_number'		=> $doc_number,
								'doc_date' 			=> $doc_date,
								'total_qty'			=> $quantity,
								'total_sum'			=> $total_sum,
								'total_discount'	=> 0,
								'pay_group'			=> '',
								'pay_type'			=> '',
								'pay_amount'		=> $total_sum,
								'client_id'			=> $skl_info->skl,
								'employee_id'		=> $employee_id,
								'employee'			=> $employee_name,
								'comment'			=> $this->lang->line('items_manually_editing_of_quantity').' ('.$new_qty.')',
								'location'			=> $skl_info->skl );

						// записва в БД Инвентар и си взима номерче ...
						$doc_id = $this->Inventory->insert_docs($docs_data);

						// зареждам параметрите на items документа ......
						$inv_data = array(
							'doc_id'			=> $doc_id,
							'line'			=> 1,
							'mode_id' 		=> $mode_id,
							'doc_number' 	=> $doc_number,
							'doc_date' 		=> $doc_date,
							'item_number'	=> $inum,
							'item_name'		=> $quantity.','.$qb1.','.$qb2.','.$qb3.
																 ','.$qb4.','.$qb5.','.$qb6.
																 ','.$qb7.','.$qb8.','.$qb9.','.$qb10,
							'item_qty'		=> $quantity,
						'item_unit_price'	=> $this->input->post('price'),
						'item_discount'	=> 0,
							'item_taxes'	=> 0,
							'client_id'		=> $skl_info->skl,
							'location'		=> $skl_info->skl );

						// записва в БД Инвентар Артикула ...
						$this->Inventory->insert_docs_items($inv_data);
					}  // край на '$qty_to_change != 0'
					
			// Удачно регистриране ...
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('items_successful_updating').
			' '.$input_data['inum'].' '.$input_data['name'],'item_id'=>$item_id));
			}
		}
		else //failure
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('items_error_adding_updating').
			' '.$input_data['inum'].' '.$input_data['name'],'item_id'=>-1));
		}

	}
	
	
	function save_shop_item($item_id=-1)
	{	
		$success=1;
		$location  = $this->Employee->get_logged_in_employee_info()->location;
		$user_id   = $this->BiSOFT_Model->get_person();
		$skl_info  = $this->Item->get_sklad_idx($item_id);
		$inum		  = $skl_info->inum;
		$item_info = $this->Item->get_item_info($inum);

		// размерите ...
		$allow_sizes = $this->input->post('allow_sizes');
		$qty = $this->input->post('quantity');
		$q1 = $q2 = $q3 = $q4 = $q5 = $q6 = $q7 = $q8 = $q9 = $q10 = '';
		
		if($allow_sizes) // and $allow_sizes!='105'
		{
			$qty=0;
			
			if($this->input->post('qty_1')!=0)
			{ $q1 = $this->input->post('qty_1'); $qty += (int)$this->input->post('qty_1'); }
			
			if($this->input->post('qty_2')!=0)
			{ $q2 = $this->input->post('qty_2'); $qty += (int)$this->input->post('qty_2'); }
			
			if($this->input->post('qty_3')!=0)
			{ $q3 = $this->input->post('qty_3'); $qty += (int)$this->input->post('qty_3'); }
			
			if($this->input->post('qty_4')!=0)
			{ $q4 = $this->input->post('qty_4'); $qty += (int)$this->input->post('qty_4'); }
			
			if($this->input->post('qty_5')!=0)
			{ $q5 = $this->input->post('qty_5'); $qty += (int)$this->input->post('qty_5'); }
			
			if($this->input->post('qty_6')!=0)
			{ $q6 = $this->input->post('qty_6'); $qty += (int)$this->input->post('qty_6'); }
			
			if($this->input->post('qty_7')!=0)
			{ $q7 = $this->input->post('qty_7'); $qty += (int)$this->input->post('qty_7'); }
			
			if($this->input->post('qty_8')!=0)
			{ $q8 = $this->input->post('qty_8'); $qty += (int)$this->input->post('qty_8'); }
			
			if($this->input->post('qty_9')!=0)
			{ $q9 = $this->input->post('qty_9'); $qty += (int)$this->input->post('qty_9'); }

			if($this->input->post('qty_10')!=0)
			{ $q10 = $this->input->post('qty_10'); $qty += (int)$this->input->post('qty_10'); }
		}

		$input_data=array('item_id'=>$item_id,'inum'=>$this->input->post('item_number'),
								'name'=>$this->input->post('name'),'qty'=>$qty,
								'q1'=>$q1,'q2'=>$q2,'q3'=>$q3,'q4'=>$q4,'q5'=>$q5,
								'q6'=>$q6,'q7'=>$q7,'q8'=>$q8,'q9'=>$q9,'q10'=>$q10,
								'qmin'=>$item_info->qmin,'qmax'=>$item_info->qmax,
								'cat'=>$this->Item->get_cat_id($item_info->category),
								'category'=>$item_info->category,
								'coll'=>$item_info->collection,
								'allow'=>$allow_sizes,
								'kit_1'=>$item_info->kit_1,
								'kit_2'=>$item_info->kit_2,
								'kit_3'=>$item_info->kit_3,
								'price'  => $this->input->post('price'),
								'price_2'=> $this->input->post('price_2'),
								'price_3'=> $this->input->post('price_3'),
								'price_4'=> $this->input->post('price_4'),
								'price_5'=> $this->input->post('price_5'),
								'price_6'=> 0,
								'cost'=> $this->input->post('cost'),
								'dsc'=>intval($this->input->post('discount')),
								'opis'=>$item_info->description,
								'contents'=>$item_info->item_contents,
								'color'=>$item_info->item_color,
								'currency'=>$item_info->item_currency,
								'pattern'=>$this->Item->get_info_pattern($inum),
								'del'=>($this->input->post('deleted')!=0) ? 1 : 0
								);
							
		$result = $this->Item->save_sklad_pack($input_data);
		$success *= $result['success'];

		if($success)
		{	
				//правя си служебно -> ИЗРАВНИТЕЛНА БЕЛЕЖКА
				$inum = $input_data['inum'];
				
				$quantity = $skl_info ? $qty - $skl_info->qty : $qty;
				$new_qty  = $qty - $skl_info->qty;

				if($new_qty!=0 and ($user_id>1 and $user_id<6)) // без мен само :)
				{
					$mode ='balance'; $mode_id = 'BL';
					$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
					$emp_info=$this->Employee->get_info($employee_id);
					$employee_name=$emp_info->first_name.' '.$emp_info->last_name;
					$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
					$doc_date = date('Y-m-d');

							// обслужвам си '0'-те ...
						$qb1 = (int)$q1 - intval($skl_info->q1); if($qb1==0) {$qb1='';}
						$qb2 = (int)$q2 - intval($skl_info->q2); if($qb2==0) {$qb2='';}
						$qb3 = (int)$q3 - intval($skl_info->q3); if($qb3==0) {$qb3='';}
						$qb4 = (int)$q4 - intval($skl_info->q4); if($qb4==0) {$qb4='';}
						$qb5 = (int)$q5 - intval($skl_info->q5); if($qb5==0) {$qb5='';}
						$qb6 = (int)$q6 - intval($skl_info->q6); if($qb6==0) {$qb6='';}
						$qb7 = (int)$q7 - intval($skl_info->q7); if($qb7==0) {$qb7='';}
						$qb8 = (int)$q8 - intval($skl_info->q8); if($qb8==0) {$qb8='';}
						$qb9 = (int)$q9 - intval($skl_info->q9); if($qb9==0) {$qb9='';}
					  $qb10 = (int)$q10- intval($skl_info->q10); if($qb10==0) {$qb10='';}

						$total_sum = $quantity * $this->input->post('price');

						// зареждам основните параметри на Главния документ ......
						$docs_data = array(
								'mode'				=> $mode,
								'mode_id'			=> $mode_id,
								'doc_number'		=> $doc_number,
								'doc_date' 			=> $doc_date,
								'total_qty'			=> $quantity,
								'total_sum'			=> $total_sum,
								'total_discount'	=> 0,
								'pay_group'			=> '',
								'pay_type'			=> '',
								'pay_amount'		=> $total_sum,
								'client_id'			=> $skl_info->skl,
								'employee_id'		=> $employee_id,
								'employee'			=> $employee_name,
								'comment'			=> $this->lang->line('items_manually_editing_of_quantity').' ('.$new_qty.')',
								'location'			=> $skl_info->skl );

						// записва в БД Инвентар и си взима номерче ...
						$doc_id = $this->Inventory->insert_docs($docs_data);

						// зареждам параметрите на items документа ......
						$inv_data = array(
							'doc_id'			=> $doc_id,
							'line'			=> 1,
							'mode_id' 		=> $mode_id,
							'doc_number' 	=> $doc_number,
							'doc_date' 		=> $doc_date,
							'item_number'	=> $inum,
							'item_name'		=> $quantity.','.$qb1.','.$qb2.','.$qb3.
																 ','.$qb4.','.$qb5.','.$qb6.
																 ','.$qb7.','.$qb8.','.$qb9.','.$qb10,
							'item_qty'		=> $quantity,
						'item_unit_price'	=> $this->input->post('price'),
						'item_discount'	=> 0,
							'item_taxes'	=> 0,
							'client_id'		=> $skl_info->skl,
							'location'		=> $skl_info->skl );

						// записва в БД Инвентар Артикула ...
						$this->Inventory->insert_docs_items($inv_data);
					}  // край на '$qty_to_change != 0'
		
			// Удачно регистриране ...
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('items_successful_updating').
			' '.$input_data['inum'].' '.$input_data['name'],'item_id'=>$item_id));	
		}
		else //failure
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('items_error_adding_updating').
			' '.$input_data['inum'].' '.$input_data['name'],'item_id'=>-1));
		}	
	}

	
   // print item label
   public function print_label($inum=0,$qty=0,$q1='',$q2='',$q3='',$q4='',$q5='',
                                              $q6='',$q7='',$q8='',$q9='',$q10='',$lang='bg')
   {
		$firma_key = $this->BiSOFT_Model->get_firma_key();
		if(!$firma_key['styler']) { redirect(BISOFT);} // правено САМО за STYLER //

      if(empty($lang) or $lang=='bg' or $lang=='BG') {$lang='bg';}
      else {$lang='en';}
      
      $all_qty = $qty;
      $firstLabel = 1;
      $proba = 0;

      // размери
      $allow_sizes = $this->Item->get_allow_sizes($inum);
      if($allow_sizes and $qty>0)
      {  
         $size=0;
         if($q1) 
            {  $size=1;$cnt=$q1;
               do { 
                     $data=array(
                  'firstLabel' => $firstLabel,
                        'inum' => $inum,
                     'all_qty' => $all_qty,
                         'qty' => $q1,
                        'size' => $size,
                       'proba' => $proba,
                        'lang' => $lang );
               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;
						}
						while($cnt!=0);
            }
         if($q2) 
            {  $size=2;$cnt=$q2;
               do { 
                     $data=array(
                  'firstLabel' => $firstLabel,
                        'inum' => $inum,
                     'all_qty' => $all_qty,
                        'qty' => $q2,
                        'size' => $size,
                        'proba' => $proba,
                        'lang' => $lang );
               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;}
               while($cnt!=0);
            }
         if($q3) 
            {  $size=3;$cnt=$q3;
               do { 
                     $data=array(
                  'firstLabel' => $firstLabel,
                        'inum' => $inum,
                     'all_qty' => $all_qty,
                        'qty' => $q3,
                        'size' => $size,
                        'proba' => $proba,
                        'lang' => $lang );
               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;}
               while($cnt!=0);
            }
         if($q4) 
            {  $size=4;$cnt=$q4;
               do { 
                     $data=array(
                  'firstLabel' => $firstLabel,
                        'inum' => $inum,
                     'all_qty' => $all_qty,
                        'qty' => $q4,
                        'size' => $size,
                        'proba' => $proba,
                        'lang' => $lang );
               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;}
               while($cnt!=0);
            }
         if($q5) 
            {  $size=5;$cnt=$q5;
               do { 
                     $data=array(
                  'firstLabel' => $firstLabel,
                        'inum' => $inum,
                     'all_qty' => $all_qty,
                         'qty' => $q5,
                        'size' => $size,
                        'proba' => $proba,
                        'lang' => $lang );
               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;}
               while($cnt!=0);
            }
         if($q6) 
            {  $size=6;$cnt=$q6;
               do { 
                     $data=array(
                  'firstLabel' => $firstLabel,
                        'inum' => $inum,
                     'all_qty' => $all_qty,
                         'qty' => $q6,
                        'size' => $size,
                        'proba' => $proba,
                        'lang' => $lang );
               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;}
               while($cnt!=0);
            }
         if($q7) 
            {  $size=7;$cnt=$q7;
               do { 
                     $data=array(
                  'firstLabel' => $firstLabel,
                        'inum' => $inum,
                     'all_qty' => $all_qty,
                         'qty' => $q7,
                        'size' => $size,
                        'proba' => $proba,
                        'lang' => $lang );
               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;}
               while($cnt!=0);
            }
         if($q8) 
            {  $size=8;$cnt=$q8;
               do { 
                     $data=array(
                  'firstLabel' => $firstLabel,
                        'inum' => $inum,
                     'all_qty' => $all_qty,
                         'qty' => $q8,
                        'size' => $size,
                        'proba' => $proba,
                        'lang' => $lang );
               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;}
               while($cnt!=0);
            }
         if($q9) 
            {  $size=9;$cnt=$q9;
               do { 
                     $data=array(
                  'firstLabel' => $firstLabel,
                        'inum' => $inum,
                     'all_qty' => $all_qty,
                        'qty' => $q9,
                        'size' => $size,
                        'proba' => $proba,
                        'lang' => $lang );
               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;}
               while($cnt!=0);
            }
         if($q10) 
            {  $size=10;$cnt=$q10;
               do { 
                     $data=array(
                  'firstLabel' => $firstLabel,
                        'inum' => $inum,
                     'all_qty' => $all_qty,
                        'qty'  => $q10,
                        'size' => $size,
                        'proba' => $proba,
                        'lang' => $lang );
               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;}
               while($cnt!=0);
            }
      }
      else 
      {  
         $size = 0;$firstLabel=1;$cnt=$qty;
         do { 
               $data=array(
            'firstLabel' => $firstLabel,
                  'inum' => $inum,
               'all_qty' => $all_qty,
                   'qty' => $qty,
                  'size' => $size,
                  'proba' => $proba,
                  'lang' => $lang );

               $this->load->view("labels/item_label",$data);$firstLabel=0;$cnt--;}
               while($cnt!=0);
      }

   }
	
	
	function bulk_edit()
	{
		$data = array();

// ДА СЕ НАПРАВИ В БЪДЕЩЕ ... //		
// echo 'to be continued ...';		
// die();		

		$data['item_info'] = array();
		// събира всички останали dropdowns ...
		$data = $this->Item->get_all_dropdowns($data);
	//	$data['collection'] = $data['category'] = $data['color'] = $data['allow_sizes'] = -1;

	$this->load->view("items/form_bulk", $data);
	}


	function bulk_update()
	{
		$location = $this->BiSOFT_Model->get_location();
		$items_to_update = $this->input->post('item_ids');
		$item_data = array();

		foreach($_POST as $key=>$value)
		{
			//This field is nullable, so treat it differently
			if ($value!='' and !(in_array($key, array('item_ids', 'collections', 'categories', 'colors'))))
				{ $item_data["$key"]=$value;}
		}
			if ($this->input->post('collections') != '-1') { $item_data['collection'] = $this->input->post('collections');}
			if ($this->input->post('categories') != '-1') { $item_data['category'] = $this->input->post('categories');}
			if ($this->input->post('colors') != '-1') { $item_data['item_color'] = $this->input->post('colors');}
			if ($this->input->post('allow_sizes') != '-1') { $item_data['allow_sizes'] = $this->input->post('allow_sizes');}


		//Item data could be empty if tax information is being updated
		if(empty($item_data) || $this->Item->update_multiple($item_data,$items_to_update))
			{ echo json_encode(array('success'=>true,'message'=>$this->lang->line('items_successful_bulk_edit'))); }
		else
			{ echo json_encode(array('success'=>false,'message'=>$this->lang->line('items_error_updating_multiple'))); }
	}



	function delete()
	{
		$location = $this->Employee->get_logged_in_employee_info()->location;
		$items_to_delete=$this->input->post('ids');

		if($this->Item->delete_list($items_to_delete))
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('items_successful_deleted').' '.
			count($items_to_delete).' '.$this->lang->line('items_one_or_multiple')));
		}
		else
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('items_cannot_be_deleted')));
		}
	}
	

/* =========================== BISOFT (EXCEL 2003) DIRECT IMPORT MODULE =========================*/

	/**
	 * Display form: Import data from an excel file
	 * author: Bisser Alexiev Feb.2014
	 */

	function excel()  // excel_xls
	{
		$data = file_get_contents("import_items.xls");
		$name = 'import_items.xls';
		force_download($name, $data);
	}


	function bisoft_import_items()  // excel_xls_import BEST WORKING ...
   {
		$msg = "do_bisoft_import_from_items.bls";
		$failCodes = null;
		$successCode = null;
		$location = $this->BiSOFT_Model->get_location(); // това за сега нашето положение
		$view_path = 'items/refresh';


// import GPR ======================================================= //

			$myFile='_GPR.bls';

		// get BiSOFT path
		$this->CI =& get_instance();
		$bisoft_path = $this->CI->BiSOFT_Model->get_path();

		$this->load->library('spreadsheetexcelreader');
      $this->spreadsheetexcelreader->setOutputEncoding('CP1251'); // Set output Encoding

	$sRoot = $_SERVER['DOCUMENT_ROOT'];
	$file_to_read = $sRoot.'/'.$bisoft_path.'/DB/'.$myFile;


// Load GPR from BiSOFT ....
	if (!is_readable($file_to_read))
     	{ // ГРЕШКА - връщаме се в началото на controller-a ...
			$msg = $this->lang->line('common_error_import');
			$data['error'] = $msg;
			$this->refresh($data);
     	}

	else 
	{ // тук вече зарежда нормално от BiSOFT GPR ... - >

		$data_file = new Spreadsheetexcelreader($file_to_read, false);

		$rowCount = $data_file->rowcount(0);


      if($rowCount > 1)
		{  // #2 if row > 1

			for($i = 5; $i<=$rowCount; $i++) 
			{  // #3 for i=1 and on ...

	  $item_code 	= intval( $data_file->val($i, 'A') );
	  $item_id 		= $this->Item->get_item_id($item_code);

		$item_contents = $data_file->val($i, 'F');
			if($item_contents == 0 or empty($item_contents)) {$item_contents = '';}

		$description = $data_file->val($i, 'I');
			if($description == 0 or empty($description)) {$description = '';}

	  $item_data = array(
		'item_number'	=> $item_code,
				 'name'	=> $data_file->val($i, 'B'),

	       'quantity'	=> 0,
		 'allow_sizes' => 0,

		'cost_price'	=> $data_file->val($i, 'N'),
		'unit_price'	=> $data_file->val($i, 'E'),
		'unit_price_2'	=> $data_file->val($i, 'O'),
		'unit_price_3'	=> $data_file->val($i, 'P'),
		'unit_price_4'	=> $data_file->val($i, 'Q'),
	  'item_currency'	=> $data_file->val($i, 'F'),

		'item_contents'=> $item_contents,
		'description'	=> $description,

		'location'		=> $location
							);

			// update of DataBase sklads - работи !!!
				if ($item_code > 0)
				{
					if (!$this->Item->save( $item_data, $item_id )) { $failCodes[] = $item_code; }
				}

			// counter here ...
//			$info = 'import: 50% ......';
//			echo "<div class='info_msg'>".$info."</div>";
// --------------------------------------- loop
	      } //  #3  End of every item row  FOR i= ...
	   }
	}  //  #2 if row >1



// import SKLAD-9 ======================================================= //

			$myFile='_SKLAD9.bls';

	$sRoot = $_SERVER['DOCUMENT_ROOT'];
	$file_to_read = $sRoot.'/'.$bisoft_path.'/DB/'.$myFile;


// Load SKLAD-9 from BiSOFT ....
	if (!is_readable($file_to_read))
     	{ // ГРЕШКА - връщаме се в началото на controller-a ...
			$msg = $this->lang->line('common_error_import');
			$data['error'] = $msg;
			$this->refresh($data);
     	}

	else 
	{ // тук вече зарежда нормално от BiSOFT SKLAD-a ... - >

		$data_file = new Spreadsheetexcelreader($file_to_read, false);

		$rowCount = $data_file->rowcount(0);
//			$colCount = $data_file->colcount(0);
//        $rows = $data_file->sheets[0]['cells'];
//        $rowCount = count($data_file->sheets[0]['cells']);

      if($rowCount > 1)
		{  // #2 if row > 1

			for($i = 5; $i<=$rowCount; $i++) 
			{  // #3 for i=1 and on ...

	  $item_code 	= intval( $data_file->val($i, 'A') );
	  $item_id 		= $this->Item->get_item_id($item_code);
	  $item_data 	= array();

			$qty_1 = $data_file->val($i,'D');
			$qty_2 = $data_file->val($i,'E');
			$qty_3 = $data_file->val($i,'F');
			$qty_4 = $data_file->val($i,'G');
			$qty_5 = $data_file->val($i,'H');
			$qty_6 = $data_file->val($i,'I');
			$qty_7 = $data_file->val($i,'J');
			$qty_8 = $data_file->val($i,'K');
			$qty_9 = $data_file->val($i,'L');

		$size_range = 	$qty_1 + $qty_2 + $qty_3 + $qty_4 + $qty_5 + $qty_6 +	$qty_7 + $qty_8 + $qty_9;

		$allow_sizes = 0;

			if ($size_range > 0) 
				{	$allow_sizes = 'S';}

			if($qty_1==0) {$qty_1='';}
			if($qty_2==0) {$qty_2='';}
			if($qty_3==0) {$qty_3='';}
			if($qty_4==0) {$qty_4='';}
			if($qty_5==0) {$qty_5='';}
			if($qty_6==0) {$qty_6='';}
			if($qty_7==0) {$qty_7='';}
			if($qty_8==0) {$qty_8='';}
			if($qty_9==0) {$qty_9='';}
			$qty_max = '';

	  $item_data = array(
		'item_number'	=> $item_code,
				'name'	=> $data_file->val($i, 'B'),

	      'quantity'	=> $data_file->val($i, 'M'),
				'qty_1'	=> $qty_1,
				'qty_2'	=> $qty_2,
				'qty_3'	=> $qty_3,
				'qty_4'	=> $qty_4,
				'qty_5'	=> $qty_5,
				'qty_6'	=> $qty_6,
				'qty_7'	=> $qty_7,
				'qty_8'	=> $qty_8,
				'qty_9'	=> $qty_9,
			 'qty_max'	=> $qty_max,

		 'allow_sizes' => $allow_sizes,
		'unit_price'	=> $data_file->val($i, 'N'),
		'unit_price_2'	=> $data_file->val($i, 'O'),
		'unit_price_3'	=> $data_file->val($i, 'P'),
		'unit_price_4'	=> $data_file->val($i, 'Q'),
	'item_currency'	=> $data_file->val($i, 'R'),
		'location'		=> $location
							);

			// update of DataBase sklads - работи !!!
				if ($item_code > 0)
				{
					if (!$this->Item->save( $item_data, $item_id )) { $failCodes[] = $item_code; }
				}

			// counter here ...
//			$info = 'import: 50% ......';
//			echo "<div class='info_msg'>".$info."</div>";
// --------------------------------------- loop
	      } //  #3  End of every item row  FOR i= ...
	   }
	}  //  #2 if row >1




		if(count($failCodes) > 1)
		{  $msg = $this->lang->line('items_error_import') . count($failCodes) ."): ".implode(", ",$failCodes); 
			$data['error'] = $msg;} // ГРЕШКА (човешка :(
		else {
				$msg = $this->lang->line('items_successful_import');
				$data['success'] = $msg;}  // УСПЕХ !!!

	$this->refresh($data);
	} // end #0 of BiSOFT Import

//--------------------------------------------- ВЕДОМОСТИ ----------------------------- //

	function bisoft_import_vedoms()
	{
		$data = array();

		$months = array (
			'01' => $this->lang->line('cal_january'),
			'02' => $this->lang->line('cal_february'),
			'03' => $this->lang->line('cal_march'),
			'04' => $this->lang->line('cal_april'),
			'05' => $this->lang->line('cal_mayl'),
			'06' => $this->lang->line('cal_june'),
			'07' => $this->lang->line('cal_july'),
			'08' => $this->lang->line('cal_august'),
			'09' => $this->lang->line('cal_september'),
			'10' => $this->lang->line('cal_october'),
			'11' => $this->lang->line('cal_november'),
			'12' => $this->lang->line('cal_december'),
						);

		$years = array();
		for($k=0;$k<5;$k++)
		{
			$years[date("y")-$k] = date("Y")-$k;
		}

		$data = array(
			'months' 			=> $months,
			'years' 				=> $years,
			'selected_month'	=> date('n'),
			'selected_year'	=> date('y'),
			'include_invoices'	=> true );

	$this->load->view("items/vedoms_import", $data);
	}


	function do_bisoft_import_vedoms()  // excel_xls_import BEST WORKING ...
   {
		$msg = "vedoms_import.bls";
		$failCodes = null;
		$successCode = null;
		$location = $this->BiSOFT_Model->get_location();
		$view_path = 'items/refresh';

		// get BiSOFT path
		$this->CI =& get_instance();
		$bisoft_path = $this->CI->BiSOFT_Model->get_path();

		$this->load->library('spreadsheetexcelreader');
      $this->spreadsheetexcelreader->setOutputEncoding('CP1251'); // Set output Encoding

			// определя месеца и годината за извадка ..... :)
			if (isset($_POST['month_id']))  { $month_id = $_POST['month_id']; }
			if (isset($_POST['year_id']) )  { $year_id  = $_POST['year_id']; }

			$include_invoices = 0;
			if (isset($_POST['include_invoices']) )  
						{ $include_invoices  = $_POST['include_invoices']; }

			$myPeriod = $year_id . $month_id;
			// да се ползава и другаде ....


	$myVedom = '_09VS' . $myPeriod . '.bls';
	$sRoot = $_SERVER['DOCUMENT_ROOT'];
	$vedom_to_read = $sRoot.'/'.$bisoft_path.'/VEDOM/'.$myVedom;


// Load VEDOM from BiSOFT ....
	if (!is_readable($vedom_to_read))
     	{ // ГРЕШКА - връщаме се в началото на controller-a ...
			$msg = $this->lang->line('common_error_import');
			$data['error'] = $msg;
			$this->refresh($data);
     	}

	else 
	{ // тук вече зарежда нормално от BiSOFT VEDOM на SKLAD-a ... - >

		$data_file = new Spreadsheetexcelreader($vedom_to_read, false);
		$rowCount = $data_file->rowcount(0);

		$lastDoc 	= -1;
		$total_qty	= 0;
		$total_sum	= 0;
		$pay_group	= '';
		$pay_type	= '';
			$doc_id = 0;
			$doc_id = 0;
		$sale_doc_id   = 0;
		$sale_recv_type = 0;
		  $currLine = 0;


		if($rowCount > 1)
		{  // #2 if row > 1
			$this->db->trans_start(); // --> отваря запис към БАЗАТА ...-->> 

			for($i = 2; $i<=$rowCount; $i++) 
			{  // #3 for i=1 and on ...

			  $doc_number 		= intval( $data_file->val($i, 'A') );
			  $doc_date 		= $data_file->val($i, 'B');
			  $mode_id			= $data_file->val($i, 'V');
			  $mode				= $this->BiSOFT_Model->get_mode_symbol($mode_id);
			  $client_id		= intval( $data_file->val($i, 'W')); // много ВАЖНО Определям Клиента кой е .


				// определяме къде да вкараме данните ...
				$vedom_YEAR = intval( '20'.substr($myPeriod,0,2) );
				$vedom_period = 'V'.$myPeriod;

				$vedom_to_push	= $vedom_period;
				$vedom_item_to_push	= $vedom_period . '_items';
					$doc_location = $location;

			switch ($mode_id) 
				{
				case 'SE':
								$doc_location = $client_id;
								break; 

				case 'C':	$doc_location = $client_id;
								break; 

				case 'BC':	$sale_recv_type = 'doc_id';
								$doc_location = $client_id;
								break;
				}
			// край на определяне на ведомостта ...


					// сега оглеждаме артикула на реда ...
				  $item_code 	= intval( $data_file->val($i, 'C') );
				  $item_id 		= $this->Item->get_item_id($item_code);

				  $item_data 	= array(
						'item_number'	=> intval( $data_file->val($i, 'C') ),
						'name'			=> $data_file->val($i, 'D'),
						'unit_price'	=> $data_file->val($i, 'Q'),
						'location'		=> $location );

		// update of DataBase sklads
			if ($item_code > 0)
			{
				if (!$this->Item->save( $item_data, $item_id )) { $failCodes[] = $item_code; }
			}

			$qty_1 = $data_file->val($i,'F'); if($qty_1==0) {$qty_1='';}
			$qty_2 = $data_file->val($i,'G'); if($qty_2==0) {$qty_2='';}
			$qty_3 = $data_file->val($i,'H'); if($qty_3==0) {$qty_3='';}
			$qty_4 = $data_file->val($i,'I'); if($qty_4==0) {$qty_4='';}
			$qty_5 = $data_file->val($i,'J'); if($qty_5==0) {$qty_5='';}
			$qty_6 = $data_file->val($i,'K'); if($qty_6==0) {$qty_6='';}
			$qty_7 = $data_file->val($i,'L'); if($qty_7==0) {$qty_7='';}
			$qty_8 = $data_file->val($i,'M'); if($qty_8==0) {$qty_8='';}
			$qty_9 = $data_file->val($i,'N'); if($qty_9==0) {$qty_9='';}
			$qty_max = '';

			// смятам КОЛИЧЕСТВОТО .....
			$quantity_in	= $data_file->val($i, 'O');
			$quantity_out	= $data_file->val($i, 'P');

				$quantity = 0;
				if ( abs($quantity_in)  > 0 ) { $quantity = intval($quantity_in); }
				if ( abs($quantity_out) > 0 ) { $quantity = intval($quantity_out);}

			$total_qty += $quantity; // накрая го събирам към общото кол-во ...

			// оправям 'Върнатата Стока'
			if ($mode_id == 'E' and $total_qty < 0 ) {$mode_id = 'BE';}
			if ($mode_id == 'D' and $total_qty < 0 ) {$mode_id = 'BD';}


			// смятам СТОЙНОСТТА .....
				$unit_price	= $data_file->val($i, 'Q');
				$discount	= 100 * abs($data_file->val($i, 'R'));

				$unit_value	= round( $unit_price * $quantity * (100 - $discount) / 100, 2);

			$total_sum	+= $unit_value; // изчислявам стойността на всеки артикул ...

			$currDoc		= intval($data_file->val($i, 'A'));


		// тук зарежда основната база за всеки НОВ документ ....
		if ( $currDoc != $lastDoc ) 
		{ 
				// това трябва да се ползва и другаде за ДАТИ !!! //
				$currDate		= 86400 * ($data_file->val($i, 'B') - 25569); // .............. DATES .......
				$currClient 	= $data_file->val($i, 'X');
				$currEmployee	= $data_file->val($i, 'AJ');

		$total_qty	= $data_file->val($i, 'AG');
		$total_sum	= $data_file->val($i, 'AD');

		// тук се определя и плащане и pay-group ...
		$pay_group	= '';
		$pay_type	= '';

		$pay_key	= $data_file->val($i, 'AB');

		if ($pay_key == 'H') { $pay_group = 'H'; $pay_type = $this->lang->line('sales_not_paid');}
		if ($pay_key == 'P' or $pay_key == 'K') { $pay_group = 'P'; $pay_type = $this->lang->line('sales_cash');}
		if ($pay_key == 'B' or $pay_key == 'BC') { $pay_group = 'BC'; $pay_type = $this->lang->line('sales_returned_goods');}
		if ($pay_key == 'T' or $pay_key == 'T1' or $pay_key == 'T2') { $pay_group = 'T'; $pay_type = $this->lang->line('sales_by_bank');}

		if ($pay_key == 'неплатено') { $pay_group = 'H'; $pay_type = $this->lang->line('sales_not_paid');}
		if ($pay_key == 'в брой') { $pay_group = 'P'; $pay_type = $this->lang->line('sales_cash');}
		if ($pay_key == 'върната стока') { $pay_group = 'BC'; $pay_type = $this->lang->line('sales_returned_goods');}
		if ($pay_key == 'пл.нареждане') { $pay_group = 'T'; $pay_type = $this->lang->line('sales_by_bank');}

		$currLine 	= 0;

		$vedom_data = array(
				'mode'		  		=> $mode,
				'mode_id'	  		=> $mode_id,
				'doc_number'		=> $currDoc,
				'doc_date' 			=> date('Y-m-d', $currDate),

				'total_qty'			=> $total_qty,
				'total_sum'			=> $total_sum,
				'total_discount'	=> 0,
				'taxed'				=> 0,
				'total_taxes'		=> 0,
				'pay_group'			=> $pay_group,
				'pay_type'			=> $pay_type,
				'pay_amount'		=> $total_sum,

				'employee_id'		=> '',
				'employee'			=> $currEmployee,
				'client_id'			=> $client_id,
				'client'				=> $currClient,
				'comment'			=> '',
				'location'			=> $doc_location );

		//------------------------ записва в Базите Данни ---------------------- //
		$key_to_push = 0;

			// вкарва данните на Основния Документ в База Данни ... //
			if ( $item_id > 0 and $doc_number > 0 )
			{
				if ( !$this->Item->exists_doc_number( $doc_number, $vedom_to_push) ) // това се случва при НОВ НОМЕР ?!
				{ 
					$this->db->insert( $vedom_to_push, $vedom_data);
					$sale_doc_id = $this->db->insert_id();  // от тук си взимам номерчето на документа

					// зареждаме НОМЕРА на Документа в Базата с Номерата на всички Ведомости ...
					$nowVedom = $this->BiSOFT_Model->get_vedom_place_index($mode_id);
					$vedom_number_data = array( $nowVedom => $doc_number );
					$success = $this->BiSOFT_Model->set_vedom_number($vedom_number_data,$vedom_period);

					$key_to_push = 1;
				}
				else  // когато съществува такъв номер само update-ваме ...
				{
					$this->db->where('doc_number', $doc_number);
					$success = $this->db->update( $vedom_to_push, $vedom_data);

					$key_to_push = 0;
				}
			}

		}
			$currLine += 1;

			// оправям 'Върнатата Стока'
			if ($mode_id == 'E' and $quantity < 0 ) {$mode_id = 'BE';}
			if ($mode_id == 'D' and $quantity < 0 ) {$mode_id = 'BD';}

			// обработвам и самия Артикул ....
		  $vedom_item_data = array(
				'doc_id'				=> $sale_doc_id,
				'line'				=> $currLine,
				'mode_id'			=> $mode_id,
				'doc_number'		=> $currDoc,
				'doc_date'			=> date('Y-m-d', $currDate),
				'item_number'		=> $item_code,
				'item_name'			=> $data_file->val($i, 'D'),
				'item_id'			=> $item_id,

				'item_qty'	=> $quantity,
				'qty_1'		=> $qty_1,
				'qty_2'		=> $qty_2,
				'qty_3'		=> $qty_3,
				'qty_4'		=> $qty_4,
				'qty_5'		=> $qty_5,
				'qty_6'		=> $qty_6,
				'qty_7'		=> $qty_7,
				'qty_8'		=> $qty_8,
				'qty_9'		=> $qty_9,
				'qty_max'	=> $qty_max,

				'item_unit_price' => $unit_price,
				'item_discount' 	=> $discount,
				'item_taxes'		=> 0,
				'client_id'			=> $client_id,
				'client'				=> $currClient,
				'location'			=> $doc_location );

			// вкарва данните на Артикула в Базата ... //
			if ($item_code > 0 and $doc_number > 0)
			{
				if ( $key_to_push == 1 ) 
					{ $this->db->insert( $vedom_item_to_push, $vedom_item_data); }
				else
					{
				/*	  $this->db->where('doc_number', $doc_number);
					  $this->db->where('item_number', $item_code);
					  $this->db->where('line', $currLine);
					  $this->db->update( $vedom_item_to_push, $vedom_item_data);
				*/
					}
			}

			$lastDoc = $currDoc;
// --------------------------------------- loop
	      } //  #3  End of every item row  FOR i= ----------------------------
	   }
		$this->db->trans_complete();
	}

// -------------------------------------------- end of vedom import --------------------------------------

	if ($include_invoices == 1)
	{
// --------------------------------------- ВЕДОМОСТИ ФАКТУРИ -------------------------------------

		// get BiSOFT path
		$this->CI =& get_instance();
		$bisoft_path = $this->CI->BiSOFT_Model->get_path();

	$myFac = '_VFAC' . $myPeriod . '.bls';
	$sRoot = $_SERVER['DOCUMENT_ROOT'];
	$vedom_to_read = $sRoot.'/'.$bisoft_path.'/VEDOM/'.$myFac;


// Load FAC VEDOM from BiSOFT ....
	if (!is_readable($vedom_to_read))
     	{ // ГРЕШКА - връщаме се в началото на controller-a ...
			$msg = $this->lang->line('common_error_import');
			$data = array ('error'  => $msg, 'view_path'=> $view_path);
 			$this->load->view('msg_box',$data);
			return false;
     	}

	else 
	{ // тук вече зарежда нормално от BiSOFT VEDOM на SKLAD-a ... - >

		$data_file = new Spreadsheetexcelreader($vedom_to_read, false);
		$rowCount = $data_file->rowcount(0);

		$lastDoc 	= -1;
		$total_qty	= 0;
		$total_sum	= 0;
		$pay_group	= 'P';
		$pay_type	= '';
			$doc_id = 0;
		  $currLine = 0;


		if($rowCount > 1)
		{  // #2 if row > 1
			$this->db->trans_start(); // --> отваря запис към БАЗАТА ...-->> 

			for($i = 2; $i<=$rowCount; $i++) 
			{  // #3 for i=1 and on ...

			  $doc_number 		= intval( $data_file->val($i, 'A') );
			  $doc_date 		= $data_file->val($i, 'B');

				// определяме къде да вкараме данните ...
				$vedom_YEAR = intval( '20'.substr($myPeriod,0,2) );
				$vedom_period = 'V'.$myPeriod;

				$vedom_to_push	= $vedom_period;
				$vedom_item_to_push	= $vedom_period . '_items';

					// тегли от своята база за фактури само ...
				  $item_code 	= intval( $data_file->val($i, 'C') );
				  $item_id 		= $this->Item->get_item_id_invoice_db($item_code);

				  $item_data 	= array(
						'item_number'	=> intval( $data_file->val($i, 'C') ),
						'name'			=> $data_file->val($i, 'D'),
						'unit_price'	=> $data_file->val($i, 'Q'),
						'location'		=> $location );

		// update of DataBase invoice_db - за фактури само !!!
			if ($item_code > 0)
			{
				if (!$this->Item->save_invoice_db( $item_data, $item_id )) { $failCodes[] = $item_code; }
			}

				$quantity	= intval( $data_file->val($i, 'F') );
				$unit_price	= round( $data_file->val($i, 'G'), 4);

			$currDoc = intval($data_file->val($i, 'A'));


		// тук зарежда основната база за всеки НОВ документ ....
		if ( $currDoc != $lastDoc ) 
		{ 
				// това трябва да се ползва и другаде за ДАТИ !!! //
				$currDate		= 86400 * ($data_file->val($i, 'B') - 25569);
				$currClient 	= $data_file->val($i, 'L');
				$currEmployee	= '';
				$currTypeDoc 	= $data_file->val($i, 'S');

		$mode_id	= 'F';  // само че може да е: Ki Di Pr  ?!?!!??.... 
		if ($currTypeDoc == 'Кредитно Известие') { $mode_id = 'Ki';}
		if ($currTypeDoc == 'Дебитно Известие') { $mode_id = 'Di';}
		if ($currTypeDoc == 'Протокол') { $mode_id = 'Pr';}

 	   $mode	= $this->BiSOFT_Model->get_mode_symbol($mode_id);

		$total_qty	= 0;
		$total_sum	= round( $data_file->val($i, 'P'), 4);
		$total_tax	= round( $data_file->val($i, 'Q'), 4);
		$total_all	= round( $data_file->val($i, 'R'), 4);

		$taxed_key = 1;
		if ($total_all > 0 and $total_sum == 0) 
			{ $total_sum = $total_all; $total_tax=0; $taxed_key = 0;} // това е за export Invoices

		$total_amount = $total_sum + $total_tax;

		$pay_group		= $data_file->val($i, 'J');
			if (	$pay_group == 'T') 
				{ 	$pay_type = $this->lang->line('sales_by_bank') .': '. to_currency(floatval($total_amount));}
			else 
				{ 	$pay_group = 'P'; 
					$pay_type = $this->lang->line('sales_cash') .': '. to_currency(floatval($total_amount));}

		$currLine 	= 0;

		$vedom_data = array(
				'mode'		  		=> $mode,
				'mode_id'	  		=> $mode_id,
				'doc_number'		=> $currDoc,
				'doc_date' 			=> date('Y-m-d', $currDate),

				'total_qty'			=> $total_qty,
				'total_sum'			=> $total_sum,
				'total_discount'	=> 0,
				'taxed'				=> $taxed_key,
				'total_taxes'		=> $total_tax,
				'pay_group'			=> $pay_group,
				'pay_type'			=> $pay_type,
				'pay_amount'		=> $total_amount,

				'employee_id'		=> '',
				'employee'			=> '',
				'client_id'			=> intval( $data_file->val($i, 'I')),
				'client'				=> $currClient,
				'comment'			=> $data_file->val($i, 'N'),
				'location'			=> $location );

		//------------------------ записва в Базите Данни ---------------------- //

			// вкарва данните на Основния Документ в База Данни ... //
			if ($item_code > 0 and $doc_number > 0)
			{
				$this->db->insert( $vedom_to_push, $vedom_data);
				$invoice_id = $this->db->insert_id();  // от тук си взимам номерчето на документа

					// зареждаме НОМЕРА на Документа в Базата с Номерата на всички Ведомости ...
					$nowVedom = $this->BiSOFT_Model->get_vedom_place_index($mode_id);
					$vedom_number_data = array( $nowVedom => $doc_number );
					$success = $this->BiSOFT_Model->set_vedom_number( $vedom_number_data, $vedom_period);
			}

		}
		$currLine += 1;

// echo '<br><br><br><br>'.$invoice_id;

		if (!isset($invoice_id)) { $invoice_id = 0;}

			// обработвам и самия Артикул ....
		  $vedom_item_data = array(
				'doc_id'				=> $invoice_id,
				'line'				=> $currLine,
				'mode_id'			=> $mode_id,
				'doc_number'		=> $currDoc,
				'doc_date'			=> date('Y-m-d', $currDate),
				'item_number'		=> $item_code,
				'item_name'			=> $data_file->val($i, 'D'),
				'item_id'			=> $item_id,

				'item_qty'	=> $quantity,
				'qty_1'		=> '',
				'qty_2'		=> '',
				'qty_3'		=> '',
				'qty_4'		=> '',
				'qty_5'		=> '',
				'qty_6'		=> '',
				'qty_7'		=> '',
				'qty_8'		=> '',
				'qty_9'		=> '',
				'qty_max'	=> '',

				'item_unit_price' => $unit_price,
				'item_discount' 	=> $data_file->val($i, 'K'),
				'item_taxes'		=> 0,
				'client_id'			=> intval( $data_file->val($i, 'I')),
				'client'				=> $currClient,
				'location'			=> $location );

			// вкарва данните на Артикула в Базата ... //
			if ($item_code > 0 and $doc_number > 0)
			{
				$this->db->insert( $vedom_item_to_push, $vedom_item_data);
			}

			$lastDoc = $currDoc;
// --------------------------------------- loop
	      } //  #3  End of every item row  FOR i= ----------------------------
	   }
		$this->db->trans_complete();
	}

// -------------------------------------------- end of ФАКТУРИ import --------------------------------------
 } // затваря check box за фактурите ....


		if(count($failCodes) > 1)
		{  $msg = $this->lang->line('items_error_import') . count($failCodes) ."): ".implode(", ",$failCodes); 
			$data['error'] = $msg;} // ГРЕШКА (човешка :(
		else {
				$msg = $this->lang->line('items_successful_import');
				$data['success'] = $msg;}  // УСПЕХ !!!

	$this->refresh($data);
	} // end #0 of BiSOFT Import

// --------------------------------------------------------------------------



/* =========================== BISOFT IMPORT MAGAZINI =========================*/

	function bisoft_import_shops()  // МАГАЗИНИ ...
   {
		$msg = "bisoft_import_shops";
		$failCodes = null;
		$successCode = null;
		$location = $this->BiSOFT_Model->get_location(); // това за сега е нашето положение

			$myFile = '_MC' . substr( 1000000 + $location, 1, 6 ) . '.bls';

		// get BiSOFT path
		$this->CI =& get_instance();
		$bisoft_path = $this->CI->BiSOFT_Model->get_path();

		$this->load->library('spreadsheetexcelreader');
      $this->spreadsheetexcelreader->setOutputEncoding('CP1251'); // Set output Encoding

	$sRoot = $_SERVER['DOCUMENT_ROOT'];
	$file_to_read = $sRoot.'/'.$bisoft_path.'/KLIENT/'.$myFile;


// Load KLIENT DELO from BiSOFT ....
	if (!is_readable($file_to_read))
     	{ // ГРЕШКА - връщаме се в началото на controller-a ...
			$msg = $this->lang->line('common_error_import');
			$data['error'] = $msg;
			$this->refresh($data);
     	}

	else 
	{ // тук вече зарежда нормално от BiSOFT  ... - >

		$data_file = new Spreadsheetexcelreader($file_to_read, false);

		$rowCount = $data_file->rowcount(0);

      if($rowCount > 1)
		{  // #2 if row > 1

			for($i = 5; $i<=$rowCount; $i++) 
			{  // #3 for i=1 and on ...

	  $item_code 	= intval( $data_file->val($i, 'A') );
	  $item_id 		= $this->Item->get_item_id($item_code);
	  $item_data 	= array();

			$qty_1 = $data_file->val($i,'D');
			$qty_2 = $data_file->val($i,'E');
			$qty_3 = $data_file->val($i,'F');
			$qty_4 = $data_file->val($i,'G');
			$qty_5 = $data_file->val($i,'H');
			$qty_6 = $data_file->val($i,'I');
			$qty_7 = $data_file->val($i,'J');
			$qty_8 = $data_file->val($i,'K');
			$qty_9 = $data_file->val($i,'L');

		$size_range = 	$qty_1 + $qty_2 + $qty_3 + $qty_4 + $qty_5 + $qty_6 +	$qty_7 + $qty_8 + $qty_9;

		$allow_sizes = 0;

			if ($size_range > 0) 
				{	$allow_sizes = 'S';}

			if($qty_1==0) {$qty_1='';}
			if($qty_2==0) {$qty_2='';}
			if($qty_3==0) {$qty_3='';}
			if($qty_4==0) {$qty_4='';}
			if($qty_5==0) {$qty_5='';}
			if($qty_6==0) {$qty_6='';}
			if($qty_7==0) {$qty_7='';}
			if($qty_8==0) {$qty_8='';}
			if($qty_9==0) {$qty_9='';}
			$qty_max = '';

	  $item_data = array(
		'item_number'	=> $item_code,
				'name'	=> $data_file->val($i, 'B'),

	      'quantity'	=> $data_file->val($i, 'M'),
				'qty_1'	=> $qty_1,
				'qty_2'	=> $qty_2,
				'qty_3'	=> $qty_3,
				'qty_4'	=> $qty_4,
				'qty_5'	=> $qty_5,
				'qty_6'	=> $qty_6,
				'qty_7'	=> $qty_7,
				'qty_8'	=> $qty_8,
				'qty_9'	=> $qty_9,
			 'qty_max'	=> $qty_max,

		 'allow_sizes' => $allow_sizes,
		'unit_price'	=> $data_file->val($i, 'N'),  // N
		'unit_price_2'	=> $data_file->val($i, 'O'),
		'unit_price_3'	=> $data_file->val($i, 'P'),  // P
		'unit_price_4'	=> $data_file->val($i, 'Q'),
	'item_currency'	=> $data_file->val($i, 'R'),
		'location'		=> $location
							);

			// update of DataBase sklads - работи !!!
				if ($item_code > 0)
				{
					if (!$this->Item->save( $item_data, $item_id )) { $failCodes[] = $item_code; }
				}

			// counter here ...
//			$info = 'import: 50% ......';
//			echo "<div class='info_msg'>".$info."</div>";
// --------------------------------------- loop
	      } //  #3  End of every item row  FOR i= ...
	   }
	}  //  #2 if row >1


		if(count($failCodes) > 1)
		{  $msg = $this->lang->line('items_error_import') . count($failCodes) ."): ".implode(", ",$failCodes); 
			$data['error'] = $msg;} // ГРЕШКА (човешка :(
		else {
				$msg = $this->lang->line('items_successful_import');
				$data['success'] = $msg;}  // УСПЕХ !!!

	$this->refresh($data);
	} // end #0 of BiSOFT Import

// -----------------------------------------------------------------------------

	function bisoft_import_shops_vedoms()  // ВЕДОМОСТИ НА МАГАЗИНИТЕ ...
   {

	}

	function items_rebuild_from_old()
   {
		$success = 1;
		$limit = 30;
		
		$all_items = $this->Item->get_all_items_from_shops($limit);
		
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html lang="en-US" xmlns="http://www.w3.org/1999/xhtml" dir="ltr">
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
</head>
<body style="margin-left:20px;">';		

echo '<b>'.$cat_name.'</b>';
echo '<br>';

		foreach($all_items as $row=>$item)
		{
			$item_number = $item['item_number'];
		//	$group = (int) substr($item_number,0,-3);
			$item_id = $item['item_id'];
			
			$item_info = $this->Item->get_info($this->Item->get_item_number($item_number), 1);
		
			$category = $item_info->category;
			$collection = $item_info->collection;
			$allow_sizes = $item_info->allow_sizes;
			
			$item_data = array(
						'item_id' => $item_id,
				  'item_number' => $item_number,
					  'category' => $category,
					'collection' => $collection,
				  'allow_sizes' => $allow_sizes
								  );
					 
		print_r($item_data);	
		echo '<br>';
					 
					// записва в базата ...					
					$success *= $this->Item->update_shop_item($item_data,$item_id);
//					$success *= $this->Item->save_item_number_R($item_data, $item_number);  
		}

echo '<br>';
echo '<br>';
		
   if($success) {echo '<b style="color:red;">SUCCESS</b>';}
   else {echo "<b>ERROR</b>";}
   
   die();
   return $success;
	}
	
	
	
	
	function items_to_sklad($db_type='items')
   {
		$success = 1;
		$all_items = $this->Item->get_all_items_from_old_items($db_type); // ->result_array()
		
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html lang="en-US" xmlns="http://www.w3.org/1999/xhtml" dir="ltr">
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
</head>
<body style="margin-left:20px;">';		
		$my_counter = 0;
		foreach($all_items as $row=>$item)
		{
	
			if($db_type=='items' or $db_type=='shops')
			{
				$inum = $item['item_number'];
				$skl  = $item['location'];			
				
				if($inum<4000 or $inum>98000)
				{ $q1=$q2=$q3=$q4=$q5=$q6=$q7=$q8=$q9=$q10='';}
				else
				{ $q1=$item['qty_1'];$q2=$item['qty_2'];$q3=$item['qty_3'];
				  $q4=$item['qty_4'];$q5=$item['qty_5'];$q6=$item['qty_6'];
				  $q7=$item['qty_7'];$q8=$item['qty_8'];$q9=$item['qty_9'];
				  $q10=$item['qty_max'];
				  
				  if($q1==0 or $q1==null) {$q1='';} if($q2==0 or $q2==null) {$q2='';}
				  if($q3==0 or $q3==null) {$q3='';} if($q4==0 or $q4==null) {$q4='';}
				  if($q5==0 or $q5==null) {$q5='';} if($q6==0 or $q6==null) {$q6='';}
				  if($q7==0 or $q7==null) {$q7='';} if($q8==0 or $q8==null) {$q8='';}
				  if($q9==0 or $q9==null) {$q9='';} if($q10==0 or $q10==null) {$q10='';}
				}
				
				if($db_type=='shops')
				{
					$inum_info = $this->Item->get_item_info($inum);
						$cat  = $this->Item->get_cat_id($inum_info->category);
						$coll = $inum_info->collection;
					if(!$coll>0) {$coll=0;}
				}
				else
				{
					if($item['collection']>0) {$coll=$item['collection'];}
					else {$coll=0;}
					$cat = $this->Item->get_cat_id($item['category']);
				}
				
				if($item['cost_price']>0) {$cost=$item['cost_price'];}
				else {$cost=$item['unit_price'];}
				
				$qty = $item['quantity'];
				$del=0; if($qty==0) {$del=1;}
				
				$item_data = array(
						'inum' => $inum,
						 'skl' => $skl,
						 'qty' => $qty,
						  'q1' => $q1,
						  'q2' => $q2,
						  'q3' => $q3,
						  'q4' => $q4,
						  'q5' => $q5,
						  'q6' => $q6,
						  'q7' => $q7,
						  'q8' => $q8,
						  'q9' => $q9,
						 'q10' => $q10,
					  'price' => $item['unit_price'],
					'price_2' => $item['unit_price_2'],
					'price_3' => $item['unit_price_3'],
					'price_4' => $item['unit_price_4'],
					'price_5' => $item['unit_price_5'],
						'cost' => $cost,
						'coll' => $coll,
						 'cat' => $cat,
						 'del' => $del );
				 
				// записва в новата база ...			
				if($this->Item->save_sklad($item_data))
				{
					$my_counter++;
					$success *= 1;
				}
			}

		}

echo '<br>';
echo '<br>';

   if($success) {echo '<b style="color:red;">SUCCESS: </b>'.$my_counter.' items';}
   else {echo "<b>ERROR</b>";}
   
	$this->refresh();
	}
	
	
	
	function prices_to_sklad($db_type='items')
   {
	//	echo 'STOPPED !!!';
	//	return false;
//		$db_type='items';
//		$db_type='shops';  
   
   
		$success = 1;
		
		$all_items = $this->Item->get_prices_from_old_items($db_type); // ->result_array()
		
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html lang="en-US" xmlns="http://www.w3.org/1999/xhtml" dir="ltr">
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
</head>
<body style="margin-left:20px;">';		
		$my_counter = 0;
		foreach($all_items as $row=>$item)
		{
	
			if($db_type=='items' or $db_type=='shops')
			{
				$inum = $item['item_number'];
				$skl  = $item['location'];	
				
				if($item['cost_price']>0) {$cost=$item['cost_price'];}
				else {$cost=$item['unit_price'];}
				
				$item_data = array(
						'inum' => $inum,
						 'skl' => $skl,
					  'price' => $item['unit_price'],
					'price_2' => $item['unit_price_2'],
					'price_3' => $item['unit_price_3'],
					'price_4' => $item['unit_price_4'],
					'price_5' => $item['unit_price_5'],
						'cost' => $cost
										);
										
				// записва в новата база ...			
				if($this->Item->update_sklad($item_data))
				{
					$my_counter++;
					$success *= 1;
				}
			}

		}

echo '<br>';
echo '<br>';

   if($success) {echo '<b style="color:red;">SUCCESS: </b>'.$my_counter.' items';}
   else {echo "<b>ERROR</b>";}
   
	$this->refresh();
	}


	

// -----------------------------------------------------------------------------
	function all_sizes_to_vedom($db_type='1412')
   {
		echo 'Vedom: '.$db_type.'<br>';
//		return false;
//		$db_type='items';
//		$db_type='shops';  
   
		$vedom = 'V'.$db_type;
		$success = 1;
		
		$all_items = $this->Item->get_sizes_from_old_vedom($vedom); // ->result_array()
		
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html lang="en-US" xmlns="http://www.w3.org/1999/xhtml" dir="ltr">
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
</head>
<body style="margin-left:20px;">';


		$my_counter = 0;
		foreach($all_items as $row=>$item)
		{
			$inum = $item['item_number'];
			$mode_id = $item['mode_id'];
			if($mode_id!='F' and $mode_id!='Ki' and $mode_id!='Di' and $mode_id!='Pr')
			{			
				$client='';
				if($mode_id=='OM' or $mode_id=='OMi') {$client=','.$item['client'];}
				
				$allow = $this->Item->get_blanka_info($inum)->allow_sizes;
				if($allow)
				{
					$name = $item['item_qty'].','.$item['qty_1'].','.$item['qty_2'].','.$item['qty_3'].','.$item['qty_4'].','.$item['qty_5'].
													  ','.$item['qty_6'].','.$item['qty_7'].','.$item['qty_8'].','.$item['qty_9'].','.$item['qty_max'].$client;
				}
				else { $name='';}

			
				$item_data = array(
						 'doc_id' => $item['doc_id'],
							'line' => $item['line'],
				  'item_number' => $item['item_number'],
						'item_id' => 0,
						 'client' => '',
						'supplier'=> '',
					 'item_name' => $name
										);

				// записва в новата база ...			
				if($this->Item->update_vedom_items($vedom,$item_data))
				{
					$my_counter++;
					$success *= 1;
				}
			}

		}

echo '<br>';
echo '<br>';

   if($success) {echo '<b style="color:red;">SUCCESS: </b>'.$my_counter.' items';}
   else {echo "<b>ERROR</b>";}
   
die();
	$this->refresh();
	}

	
/* ============================================== Специални Функции ======================================= */	
	// връща в Склад-ГП и прави документ за ВС
	function sklad_return($bisoft_id)
	{
	$db_vedom = 'V'.date('ym', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));

	$client_id 	 = $bisoft_id;
	$client_name = $this->Consignee->get_info_by_bisoft_id($client_id)->company_name;

	$person_info = $this->Employee->get_logged_in_employee_info();
	$employee_id = $this->BiSOFT_Model->get_person();
	$employee	 =	$this->Employee->get_names($employee_id);

	//Зареждаме данни за Базата с Връщането на Стока ...
	$mode = 'consi_return';
	$mode_id 	= $this->BiSOFT_Model->get_pay_group($mode);			 // index-a 'Е', 'SE' ..
	$doc_date 	= $this->BiSOFT_Model->get_user_mode_date();
	$doc_name	= $this->BiSOFT_Model->get_document_title($mode);	 // това си е вече заглавието...
	$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...

	$all_total	= 0; $total_qty = 0; $line = 1;
	
		// зареждам основните параметри на Главния документ ......
		$document_data = array(
				'mode'				=> $mode,
				'mode_id'			=> $mode_id,
				'mode_price'		=> 1,
				'doc_number'		=> $doc_number,
				'doc_date' 			=> $doc_date,
				'total_discount'	=> 0,
				'taxed'				=> 0,
				'total_taxes'		=> 0,
				'pay_type'			=> $this->lang->line('reports_returns'),
				'supplier_id'		=> $client_id,
				'supplier'			=> $client_name,
				'client_id'			=> $client_id,
				'client'				=> $client_name,
				'employee_id'		=> $employee_id,
				'location'			=> $bisoft_id 
									);

			//------------------------ записва в Базите Данни ---------------------- //
			$this->db->trans_start(); // --> отваря запис към БАЗАТА ...-->> 
			// вкарва данните от Документа в Месечната База Данни ... //
			$this->db->insert( $db_vedom, $document_data);
			$doc_id = $this->db->insert_id();  // от тук си взимам номерчето на документа

		foreach($this->Inventory->get_sklad_for_client( $bisoft_id, 0 )->result_array() as $row)
			{
				$inum = $row['inum'];
				if ($this->Item->exists_in_items($inum) and abs($row['qty']) > 0 )
					{
						$skl_info=$this->Item->get_sklad_info($inum,0);
						$item_info=$this->Item->get_blanka_info($inum);
							$allow_sizes=$item_info->allow_sizes;
							if($allow_sizes=='105') {$allow_sizes=0;}

						if($allow_sizes)
						{
							$qty_1 	= -abs($row['q1']); if($qty_1==0){$qty_1='';}
							$qty_2 	= -abs($row['q2']); if($qty_2==0){$qty_2='';}
							$qty_3 	= -abs($row['q3']); if($qty_3==0){$qty_3='';}
							$qty_4 	= -abs($row['q4']); if($qty_4==0){$qty_4='';}
							$qty_5 	= -abs($row['q5']); if($qty_5==0){$qty_5='';}
							$qty_6 	= -abs($row['q6']); if($qty_6==0){$qty_6='';}
							$qty_7 	= -abs($row['q7']); if($qty_7==0){$qty_7='';}
							$qty_8 	= -abs($row['q8']); if($qty_8==0){$qty_8='';}
							$qty_9 	= -abs($row['q9']); if($qty_9==0){$qty_9='';}
							$qty_max = -abs($row['q10']); if($qty_max==0){$qty_max='';}
							
							$sizeQty = -abs($row['qty']);
							
							$item_name_qty = $sizeQty.','.$qty_1.','.$qty_2.','.$qty_3.
															  ','.$qty_4.','.$qty_5.','.$qty_6.
															  ','.$qty_7.','.$qty_8.','.$qty_9.','.$qty_max;
						}
						else // безразмерен
						{	$qty_1=$qty_2=$qty_3=$qty_4=$qty_5=$qty_6=$qty_7=$qty_8=$qty_9=$qty_max='';
							$sizeQty = -abs($row['qty']);
							$item_name_qty = 0;
						}

							$item_data = array(
								'doc_id'  		=> $doc_id,
								'line'  			=> $line,
								'mode_id'		=> $mode_id,
								'doc_number'	=> $doc_number,
								'doc_date' 		=> $doc_date,
								'item_number' 	=> $inum,
								'item_name'		=> $item_name_qty,
								'item_qty' 			=> -abs($row['qty']),
								'item_unit_price' => abs($row['price']),
								'item_discount' 	=> 0,
								'item_taxes' 	 	=> 0,
								'supplier_id'		=> $client_id,
								'client_id'			=> $client_id,
								'location'			=> $bisoft_id 	);

						// вкарваме във Ведомостта ...
						$this->db->insert( $db_vedom.'_items', $item_data);

						// сега вкарваме в Склад-ГП
						if($allow_sizes)
						{
							$qty_1 = $row['q1'] + $skl_info->q1; if($qty_1==0){$qty_1='';}
							$qty_2 = $row['q2'] + $skl_info->q2; if($qty_2==0){$qty_2='';}
							$qty_3 = $row['q3'] + $skl_info->q3; if($qty_3==0){$qty_3='';}
							$qty_4 = $row['q4'] + $skl_info->q4; if($qty_4==0){$qty_4='';}
							$qty_5 = $row['q5'] + $skl_info->q5; if($qty_5==0){$qty_5='';}
							$qty_6 = $row['q6'] + $skl_info->q6; if($qty_6==0){$qty_6='';}
							$qty_7 = $row['q7'] + $skl_info->q7; if($qty_7==0){$qty_7='';}
							$qty_8 = $row['q8'] + $skl_info->q8; if($qty_8==0){$qty_8='';}
							$qty_9 = $row['q9'] + $skl_info->q9; if($qty_9==0){$qty_9='';}
							$qty_max = $row['q10'] + $skl_info->q10; if($qty_max==0){$qty_max='';}
						}
						else // безразмерен
						{	$qty_1=$qty_2=$qty_3=$qty_4=$qty_5=$qty_6=$qty_7=$qty_8=$qty_9=$qty_max=''; }

					$item_to_items = array(
						  'inum' => $inum,
						   'skl' => 0,
							'q1'  => $qty_1,
							'q2'  => $qty_2,
							'q3'  => $qty_3,
							'q4'  => $qty_4,
							'q5'  => $qty_5,
							'q6'  => $qty_6,
							'q7'  => $qty_7,
							'q8'  => $qty_8,
							'q9'  => $qty_9,
							'q10' => $qty_max,
							'qty' => $skl_info->qty + abs($row['qty']),
							'del' => 0 );

					$total_qty 	+= $row['qty'];
					$all_total 	+= round($row['qty']*$row['price'],2);

					// запис в Склад-ГП
					$this->Item->save_sklad($item_to_items);

				$line++;
				} // END of Item->exists_in_items($inum)

			// най сетне изтриваме артикула от sklad на магазина ...
			$this->Inventory->delete_item_from_sklad( $bisoft_id, $inum );
			}
			
			$document_data = array(
				'total_qty'			=> -abs($total_qty),
				'total_sum'			=> -abs($all_total),
				'pay_amount'		=> -abs($all_total),
				'total_discount'	=> '',
				'pay_group'			=> '',
				'taxed'				=> 0,
				'comment'			=> 'returned stock',
				'location'			=> $bisoft_id
											);

			// Актуализирам Базата с Общите Данни ....
			$this->db->where('doc_id', $doc_id);
			$this->db->update( $db_vedom, $document_data);
			
		$this->db->trans_complete();
		
	$this->refresh($data=array());
	}
	
	// връща Склад-ГП по документи
	function sklad_rescue()
	{
		$this->load->library('Rescue_lib');
		
		// Стартови параметри
		$vedom = 'V1601_items';
		$doc_start = '519'; 
		$doc_end = '572';
		$writeEnable = '0';
		
		$success = $this->rescue_lib->rescue_sklad($vedom,$doc_start,$doc_end,$writeEnable);
	
	echo '<br>';
	if($success) { echo 'FINE It is OK!';}
	else { echo 'ERROR !!!';}
	
	die();
	}
	
	// обръща 6->16 9->13 по документи и _items
	function vedom_rechange_bourgas()
	{
		$this->load->library('Rescue_lib');
		
		// Стартови параметри
		$vedom = 'V1510';		
		$success = $this->rescue_lib->vedom_rechange($vedom);
	
	echo '<br>';
	if($success) { echo 'FINE It is OK!';}
	else { echo 'ERROR !!!';}
	
	die();
	}
	
	
	
/* ============================================== Други Функции ==================================== */	
	public function print_vedom($skl,$export_excel=0)
	{
		$location = $this->BiSOFT_Model->get_location();
		$data['location']   = $location;
		$data['bisoft_id']  = $skl;
		$data['vedom_pack'] = $this->BiSOFT_Model->get_vedom();
		$data['vedom_year'] = $this->BiSOFT_Model->get_user_mode_year();
		$data['sklad']		  = $skl;
		$data['group']		  = 0;
		$data['size']		  = 0;
		
		$data['category']   = $cat  = $this->BiSOFT_Model->get_mode_assort();
		$data['collection'] = $coll = $this->BiSOFT_Model->get_mode_mat();
		if($cat==0) { $data['cat_name']='';}
		else { $data['cat_name'] = $this->Item->get_cat_name($cat);}
		
		$data['client_info']  = $this->Consignee->get_info_by_bisoft_id($skl);
	
		$data['export_excel'] = $export_excel;		
			
		// зарежда размерите ...
		$data['size_grid']  = $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table'] = $this->BiSOFT_Model->get_sizes('grid_2');

	$this->load->view("items/sklad_print",$data);
	}
	

	public function sklad_to_zebex($skl)
	{
		$zData = '';$separ=PHP_EOL;
		$skl_info = $this->Item->get_all_sklad($skl,10000)->result_array();
		if($skl_info)
		{
			foreach($skl_info as $item)
			{
				$inum = $item['inum'];
				if($inum>9999 and $inum<99000)
				{
					$qty=$item['qty'];
					$q1=$q2=$q3=$q4=$q5=$q6=$q7=$q8=$q9=$q10=0;
					$q_1=$item['q1'];$q_2=$item['q2'];$q_3=$item['q3'];$q_4=$item['q4'];$q_5=$item['q5'];
					$q_6=$item['q6'];$q_7=$item['q7'];$q_8=$item['q8'];$q_9=$item['q9'];$q_10=$item['q10'];
					$qsuma = (int)$q_1 + (int)$q_2 + (int)$q_3 + (int)$q_4 + (int)$q_5 + 
								(int)$q_6 + (int)$q_7 + (int)$q_8 + (int)$q_9 + (int)$q_10;
					if($qty>0 and $qsuma>0) // размерни
					{ 
						if($q_1>0)
							{ $zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00010'; 
							  for($x=0; $x<$q_1;$x++) {$zData .= $zcode.$separ;}
							}
						if($q_2>0)
							{ $zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00020';
							  for($x=0; $x<$q_2;$x++) {$zData .= $zcode.$separ;}
							}
						if($q_3>0)
							{ $zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00030';
							  for($x=0; $x<$q_3;$x++) {$zData .= $zcode.$separ;}
							}
						if($q_4>0)
							{ $zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00040';
							  for($x=0; $x<$q_4;$x++) {$zData .= $zcode.$separ;}
							}
						if($q_5>0)
							{ $zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00050';
							  for($x=0; $x<$q_5;$x++) {$zData .= $zcode.$separ;}
							}
						if($q_6>0)
							{ $zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00060';
							  for($x=0; $x<$q_6;$x++) {$zData .= $zcode.$separ;}
							}
						if($q_7>0)
							{ $zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00070';
							  for($x=0; $x<$q_7;$x++) {$zData .= $zcode.$separ;}
							}
						if($q_8>0)
							{ $zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00080';
							  for($x=0; $x<$q_8;$x++) {$zData .= $zcode.$separ;}
							}
						if($q_9>0)
							{ $zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00090';
							  for($x=0; $x<$q_9;$x++) {$zData .= $zcode.$separ;}
							}
						if($q_10>0)
							{ $zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00100'; 
							  for($x=0; $x<$q_10;$x++) {$zData .= $zcode.$separ;}
							}
					}
					elseif($qty>0 and !$qsuma) // безразмерни
					{
						$zcode = str_pad($inum, 8, "0", STR_PAD_LEFT).'00000';
						for($x=0; $x<$qty;$x++) {$zData .= $zcode.$separ;}
					}

				} // if($inum>9999 and $inum<99000)

			} // foreach($skl_info as $item)
			
		} // if($skl_info)
	
		chdir("../bisoft_data/zebex/");
		echo getcwd() . "<br>";

		$myfile = fopen("zebex-".$skl.".txt", "w") or die("Unable to open file!");
		fwrite($myfile, $zData);
		fclose($myfile);
		
		echo "file: zebex-$skl.txt";

		die();
	}
	
/* ============================== Сравнява Склада на Магазина с Централен Склад ====================== */	
	public function check_consi_sales($skl)
	{
		$location = $this->BiSOFT_Model->get_location();
		if($location > 0) // САМО за магазините
			{ header('Location: '.BISOFT.'index.php/Items/refresh');}
		
		$data['location']   = $location;
		$data['bisoft_id']  = $skl;
		$data['client_info']  = $this->Consignee->get_info_by_bisoft_id($skl);
		$data['vedom_pack'] = $this->BiSOFT_Model->get_vedom();
		$data['vedom_year'] = $this->BiSOFT_Model->get_user_mode_year();
		$data['sklad']		  = $skl;
		$data['group']		  = 0;
		$data['size']		  = 0;
		
		$data['category']   = $cat  = $this->BiSOFT_Model->get_mode_assort();
		$data['collection'] = $coll = $this->BiSOFT_Model->get_mode_mat();
		if($cat==0) { $data['cat_name']='';}
		else { $data['cat_name'] = $this->Item->get_cat_name($cat);}
		
		// зарежда размерите ...
		$data['size_grid']  = $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table'] = $this->BiSOFT_Model->get_sizes('grid_2');
		
		// зареждаме от Складовете
		$data['items_to_go'] = array();
		$all_sklad = $this->Item->get_real_sklad($skl,$cat,$coll,10000)->result_array();
		// $sgp_sklad = $this->Item->get_real_sklad(0,0,0,10000)->result_array();
		
		foreach($all_sklad as $item)
		{
			$inum = $item['inum'];
			$sgp_item = $this->Item->get_sklad_info($inum,0);
			if($sgp_item and $sgp_item->qty > 0)
			{
				$q1=$q2=$q3=$q4=$q5=$q6=$q7=$q8=$q9=$q10=0;
				if($sgp_item->q1>0 and $item['q1']==0) {$q1=$sgp_item->q1;}
				if($sgp_item->q2>0 and $item['q2']==0) {$q2=$sgp_item->q2;}
				if($sgp_item->q3>0 and $item['q3']==0) {$q3=$sgp_item->q3;}
				if($sgp_item->q4>0 and $item['q4']==0) {$q4=$sgp_item->q4;}
				if($sgp_item->q5>0 and $item['q5']==0) {$q5=$sgp_item->q5;}
				if($sgp_item->q6>0 and $item['q6']==0) {$q6=$sgp_item->q6;}
				if($sgp_item->q7>0 and $item['q7']==0) {$q7=$sgp_item->q7;}
				if($sgp_item->q8>0 and $item['q8']==0) {$q8=$sgp_item->q8;}
				if($sgp_item->q9>0 and $item['q9']==0) {$q9=$sgp_item->q9;}
				if($sgp_item->q10>0 and $item['q10']==0) {$q10=$sgp_item->q10;}
				$qty=$q1+$q2+$q3+$q4+$q5+$q6+$q7+$q8+$q9+$q10;
				
				if($qty>0)
				{
					$data['items_to_go'][]=array(
						'inum'=>$inum,
						'name'=>$this->Item->get_name($inum),
						 'qty'=>$qty,
						  'q1'=>($q1>0) ? $q1 : '',
						  'q2'=>($q2>0) ? $q2 : '',
						  'q3'=>($q3>0) ? $q3 : '',
						  'q4'=>($q4>0) ? $q4 : '',
						  'q5'=>($q5>0) ? $q5 : '',
						  'q6'=>($q6>0) ? $q6 : '',
						  'q7'=>($q7>0) ? $q7 : '',
						  'q8'=>($q8>0) ? $q8 : '',
						  'q9'=>($q9>0) ? $q9 : '',
						  'q10'=>($q10>0) ? $q10 : '' );
				}
			}

		}

		// зареждаме от последните 2 месеца
		$data['items_soldout'] = array();
		$last_item = 0;
		$vedom_soldout = $this->Item->get_magazin_from_vedoms($skl);
		foreach($vedom_soldout as $item)
		{
			$inum = $item['item_number'];
			$sklad_item = $this->Item->get_sklad_info($inum,$skl);
			if($sklad_item and $sklad_item->qty==0 and $inum!=$last_item)
			{
				$sgp_item = $this->Item->get_sklad_info($inum,0);
				if($sgp_item and $sgp_item->qty>0)
				{
					if($cat==0 or ($cat!=0 and $cat==$sgp_item->cat))
					{
						$data['items_soldout'][]=array(
							'inum'=>$inum,
							'name'=>$this->Item->get_name($inum),
							'qty'=>$sgp_item->qty,
							'q1'=>($sgp_item->q1>0) ? $sgp_item->q1 : '',
							'q2'=>($sgp_item->q2>0) ? $sgp_item->q2 : '',
							'q3'=>($sgp_item->q3>0) ? $sgp_item->q3 : '',
							'q4'=>($sgp_item->q4>0) ? $sgp_item->q4 : '',
							'q5'=>($sgp_item->q5>0) ? $sgp_item->q5 : '',
							'q6'=>($sgp_item->q6>0) ? $sgp_item->q6 : '',
							'q7'=>($sgp_item->q7>0) ? $sgp_item->q7 : '',
							'q8'=>($sgp_item->q8>0) ? $sgp_item->q8 : '',
							'q9'=>($sgp_item->q9>0) ? $sgp_item->q9 : '',
							'q10'=>($sgp_item->q10>0) ? $sgp_item->q10 : '' );
						$last_item = $inum;
					}
				}
			}
		}
		
	$this->load->view("items/check_consi_sales",$data);
	}
	
	
/* ============================== Прехвърля от Склад в Склад ====================== */	
	public function move_items_from_to_sklad($from_skl=0)
	{
      $success = 1;
      $to_skl = 810; // това беше правено за ТИМ ... и сие
      if($from_skl==$to_skl) {header('Location: '.BISOFT.'index.php/items');}
      $all_from_sklad = $this->Item->get_all_sklad($from_skl,10000)->result_array();

      echo 'ПРЕХВЪРЛЯНЕ на МАГАЗИН:'.$from_skl.' към МАГАЗИН:'.$to_skl.'<br>  '.date('d.m.Y').'<br><br>';
      
      foreach($all_from_sklad as $from_item)
      {
         $inum = $from_item['inum'];
         $blanka = $this->Item->get_blanka_info($inum);
         $coll = $blanka->collection;

         if($this->Item->exists_in_sklad($inum,$to_skl)) 
            { // ако го има в 810 ?
               $item_info = $this->Item->get_sklad_info($inum,$to_skl);
               $qty = $from_item['qty']+$item_info->qty;

               if($qty!=0)
               {
                  $add_text = '';
                  $q1=$from_item['q1']+$item_info->q1;if($q1==0){$q1='';}
                  $q2=$from_item['q2']+$item_info->q2;if($q2==0){$q2='';}
                  $q3=$from_item['q3']+$item_info->q3;if($q3==0){$q3='';}
                  $q4=$from_item['q4']+$item_info->q4;if($q4==0){$q4='';}
                  $q5=$from_item['q5']+$item_info->q5;if($q5==0){$q5='';}
                  $q6=$from_item['q6']+$item_info->q6;if($q6==0){$q6='';}
                  $q7=$from_item['q7']+$item_info->q7;if($q7==0){$q7='';}
                  $q8=$from_item['q8']+$item_info->q8;if($q8==0){$q8='';}
                  $q9=$from_item['q9']+$item_info->q9;if($q9==0){$q9='';}
                  $q10=$from_item['q10']+$item_info->q10;if($q10==0){$q10='';}

                  $item_data=array(
                  'item_id' => $item_info->item_id,
                     'inum' => $inum,
                      'skl' => $to_skl,
                     'coll' => $coll,
                      'qty' => $qty,
                       'q1' => $q1,
                       'q2' => $q2,
                       'q3' => $q3,
                       'q4' => $q4,
                       'q5' => $q5,
                       'q6' => $q6,
                       'q7' => $q7,
                       'q8' => $q8,
                       'q9' => $q9,
                       'q10' => $q10,
                       'del' => 0 );
                       
                  if($from_item['price']!=$item_info->price) 
                     {$add_text=' разлика: цена('.$from_skl.')-'.$from_item['price'].' <=> '.'цена('.$to_skl.')-'.$item_info->price;}     

                  $success *= $this->Item->update_sklad($item_data);
                  $success *= $this->Item->delete_inum($inum,$from_skl);
                  echo $inum."(".$from_skl.")-".$from_item['qty']."бр. -> (".$to_skl.")-".$qty.'бр.'.$add_text."<br>";
               }
               else
               { 
                  $success *= $this->Item->delete_inum($inum,$to_skl);
                  $success *= $this->Item->delete_inum($inum,$from_skl);
               }
            }
            else // ако го няма в 810 ?!
            {
               $qty = $from_item['qty'];

               if($qty!=0)
               {
                  $q1=$from_item['q1'];if($q1==0){$q1='';}
                  $q2=$from_item['q2'];if($q2==0){$q2='';}
                  $q3=$from_item['q3'];if($q3==0){$q3='';}
                  $q4=$from_item['q4'];if($q4==0){$q4='';}
                  $q5=$from_item['q5'];if($q5==0){$q5='';}
                  $q6=$from_item['q6'];if($q6==0){$q6='';}
                  $q7=$from_item['q7'];if($q7==0){$q7='';}
                  $q8=$from_item['q8'];if($q8==0){$q8='';}
                  $q9=$from_item['q9'];if($q9==0){$q9='';}
                  $q10=$from_item['q10'];if($q10==0){$q10='';}

                  $item_data=array(
                     'inum' => $inum,
                     'skl' => $to_skl,
                     'coll' => $coll,
                     'cat' => $from_item['cat'],
                     'price' => $from_item['price'],
                     'price_2' => $from_item['price_2'],
                     'price_3' => $from_item['price_3'],
                     'price_4' => $from_item['price_4'],
                     'price_5' => $from_item['price_5'],
                     'cost' => $from_item['cost'],
                     'dsc' => $from_item['dsc'],
                     'qty' => $qty,
                     'q1' => $q1,
                     'q2' => $q2,
                     'q3' => $q3,
                     'q4' => $q4,
                     'q5' => $q5,
                     'q6' => $q6,
                     'q7' => $q7,
                     'q8' => $q8,
                     'q9' => $q9,
                     'q10' => $q10,
                     'del' => 0 );
      
                  $success *= $this->Item->save_sklad($item_data);
                  $success *= $this->Item->delete_inum($inum,$from_skl);
                  echo $inum."(".$from_skl.")-".$from_item['qty']."бр. -> (".$to_skl.")-".$qty."бр.<br>";
               }
               else
               { 
                  $success *= $this->Item->delete_inum($inum,$to_skl);
                  $success *= $this->Item->delete_inum($inum,$from_skl);
               }
            
            }
      }

      
   echo '<br>Result: '.$success;   
      
	die();
	header('Location: '.BISOFT.'index.php/items');
	}
	

	
	function generate_barcodes($item_ids)
	{
		$result = array();

		$item_ids = explode(':', $item_ids);
		foreach ($item_ids as $item_id)
		{
			$item_info = $this->Item->get_info($item_id);

			$result[] = array('name' =>$item_info->name, 'id'=> $item_id);
		}

		$data['items'] = $result;
		$this->load->view("barcode_sheet", $data);
	}

	
	
	function update_all_shops()
	{
      $success = 1;
      $all_items = $this->Item->get_all_items_from_new_shops();
		$cnt = 1;
		
		
		foreach($all_items as $item)
		{
         if(!$item['cat'] or !$item['coll'] or empty($item['cat']) or empty($item['coll']) )
         {
            $inum = $item['inum'];
            if($this->Item->exists_in_items($inum))
            {
               $item_info = $this->Item->get_item_info($inum);
               $coll = $item_info->collection;
               $cat  = $this->Item->get_cat_id($item_info->category);
               if($cat>0 and $coll>0)
               {
                  $item['coll'] = $coll;
                  $item['cat']  = $cat;
                  $item_data = $item;
                  $success *= $this->Item->update_an_item_in_new_shops($item_data);
                  
                  /*echo $cnt.' --> '.$coll.' --> '.$cat.' --> ';
                     print_r($item_data);
                  
                     echo ' ==== success:'.$success.'<br>';
                     $cnt++;
                  */
               }
            }
         }
		
		}
   return $success;
	}
	
	
	// функция за обработка на РОСИ ...
	function update_rosi()
	{
      $success = 1;
      $vedomPack = "V1906";
      $all_docs = $this->Sale->get_all_docs($vedomPack);
		
		foreach($all_docs as $doc_data)
		{
			$doc_data['employee_id']=1523;
			$doc_id = $doc_data['doc_id'];
			$this->Sale->update($doc_data, $doc_id, $vedomPack);
			
			echo $doc_id.'<br>';
			print_r($doc_data);
		
			echo '<br><br>';
		}
		
		echo $vedomPack.'<br>';	
		echo 'КРАЙ';
		die();
	}
	
	
/* ============================== Чисти Склад ====================== */	
	public function clears_sklad($skl=1)
	{
		echo 'SKLAD:'.$skl.'<br><hr>';

		$all_items = $this->Item->get_sklad_now($skl);
		if($all_items and $skl==0)
		{
			foreach($all_items as $item)
			{
				if($item['del']==1)
				{
					$item_id = $item['item_id'];
					$rezult = $this->Item->delete_item_from_sklad_now($item_id,$skl);
					if($rezult) 
					{ echo 'deleted: #'.$item['inum'].'<br>'; }
				}
			}
		}
		elseif($all_items and $skl>0)
		{
			foreach($all_items as $item)
			{
				if($item['del']==1 or !$item['qty'])
				{
					$item_id = $item['item_id'];
					$rezult = $this->Item->delete_item_from_sklad_now($item_id,$skl);
					if($rezult) 
					{ echo 'deleted: #'.$item['inum'].'<br>'; }
				}
			}
		}
		else { echo 'НЯМА НИЩО ЗА ТРИЕНЕ !!!';}

	die('<br><br>READY !!!');
	//	$this->refresh();
	}

	
	/* ----	gets 98100 ---- */
	function get_9810x()
	{
		$inum = '98100';
		$vedom='V2004';
		$success = 1;
		$cnt = 0;
		
		$all_items = $this->Item->get_9810x($inum,$vedom);
		if($all_items)
		{
			foreach($all_items as $docum)
			{
				$doc_id = $docum['doc_id'];
				if(true) // $doc_id!=3575
				{
					$success *= $this->Item->delete_9810x($inum,$vedom,$doc_id);
					
					if($success)
					{
						$cnt++;
						print_r($doc_id);
						echo '<br>';
					}
				}
			}
		}
		
echo '<br>';
print_r($success.' cnt:'.$cnt);
die();
		
	return true;
	}
	
	
	
	/* ----	gets item_plan ---- */
	function get_items_plan()
	{
		$all_items = $this->Item->get_all_items_plan();

		if($all_items)
		{
			$cur_item = 0;
			foreach($all_items as $item)
			{
				$inum = $item['inum'];
				$coll = $item['coll'];
				$coll_name = $this->Item->get_collection_name($coll);
				
				$check = $this->Item->check_item_plan($inum,$coll);
				
				if($check)
				{
					if($cur_item != $inum) { echo '<br>'; }
					
					print_r($inum.' / '.$coll_name.' ( '.$coll.' )  plan id: '.$item['plan_id']);
					echo '<br>';
					
					$cur_item = $inum;

				}

			}
		}
		
die();
		
	return true;
	}
	
	
	function get_discount_items($skl=1)
	{
		$items = $this->Item->get_sklad_discounts($skl);
	
		if($items)
		{
			$sklad = "Склад-СГП на артикули с отстъпка по-малка от (-20%)";
			if($skl>0) { $sklad = "Склад-$skl сравнена с Склад-СГП"; }
		
			$in_style = "style='text-align:center;width:110px;border-bottom:1px solid #444;'";
			
			echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
					<b>ИЗВАДКА от $sklad</b><br>";
			
			echo "<table>";
		
				echo "<tr>";
					echo "<th $in_style>артикул</th>";
					
					if(!$skl) { echo "<th $in_style>цена-2</th>";echo "<th $in_style>цена-3</th>";} 
					else { echo "<th $in_style>продава</th>";echo "<th $in_style>цена2 СГП</th>"; }
					
					echo "<th $in_style>отст.</th>";
					echo "<th $in_style>реком.цена</th>";
					if(!$skl) { echo "<th $in_style>онлайн</th>"; }
					else { echo "<th $in_style>забележка</th>"; }
				echo "</tr>";
		
			foreach($items as $item)
			{
				$error = 0; $disc = 0;
				$inum = $item['inum'];
				
				$black = $this->OnLine->get_black_price($inum,0);
				if($skl==0)
				{
					$price_2 = $item['price_2'];
					$price_3 = $item['price_3'];

					if($price_2!=0) { $disc = 100 * round(($price_2 - $price_3) / $price_2,3); }

					if($price_2==0 or $price_3==0 or $price_2==$price_3 or $price_2<$price_3)
					{ $error = 1; } 
					
					$new_price = to_dot(round(0.80 * $price_2,1));
					if($black>0 and $black<$new_price) { $new_price = $black; }
				}
				else // магазини
				{
					$price_2 = $item['price'];
					$price_3 = '-';
					
					$item_info = $this->Item->get_sklad_info($inum,0); // цени централен склад 
					if($item_info)
					{
						$iprice_2 = $item_info->price_2;
						$iprice_3 = $item_info->price_3;
						$price_3  = $iprice_2;
					
						if($iprice_2!=0) { $disc = 100 * round(($iprice_2 - $price_2) / $iprice_2,3); }
						
						$new_price = to_dot(round(0.80 * $iprice_2,1));
						if($black>0 and $black<$new_price) { $new_price = $black; }
					}
				}
				
				$limit = 20;
				if($skl>0) {$limit = 100;}

				
				if($inum > 9999 and $inum<98000 and $disc<$limit)
				{
					echo "<tr style='text-align:center;'>";
					
					$yes_online = "-";
					if($this->OnLine->is_active_online_item($inum) and $skl==0) { $yes_online = "OM"; }
					
					if($skl>0 and $new_price>$price_2) { $yes_online = "( $price_2 )"; }
				
					if(!$error)
					{ 
						echo "<td $in_style><b>$inum</b></td>";
						echo "<td $in_style>$price_2</td>";
						echo "<td $in_style>$price_3</td>";
						echo "<td $in_style>$disc %</td>";
						echo "<td $in_style><b>$new_price</b></td>";
						echo "<td $in_style><i>$yes_online</i></td>";
					}
					else
					{
						echo "<td $in_style><b>$inum</b></td>";
						echo "<td $in_style>$price_2</td>";
						echo "<td $in_style>$price_3</td>";
						echo "<td colspan='3' $in_style><b>========= ERROR =========</b></td>";
					}

					echo "</tr>";
				}
			}
			echo "</table>";
		}

		die();
	
	
		return true;
	}
	
	
	function compare_sklads()
	{
		$sklad = $this->Item->compare_sklad_items('sklad');
		$sklad_old = $this->Item->compare_sklad_items('sklad_old');
	
		foreach($sklad as $item)
		{
			$inum = $item['inum'];
			$price_2 = $price = $item['price_2'];
			$price_3 = $item['price_3'];
			// $item_old = $sklad_old[$inum];
			
			if($price_3>0 and $price_3<$price_2)
			{
				$price = $price_3;
				foreach($sklad_old as $item_old)
				{
					$inum_old = $item_old['inum'];
					$price_2_old = $price_old = $item_old['price_2'];
					$price_3_old = $item_old['price_3'];

					if($price_3_old>0 and $price_3_old<$price_2_old)
					{ $price_old = $price_3_old; }
						
					if($inum<98000 and $inum===$inum_old and $price_3!=$price_3_old)
					{


						echo "<b>$inum</b> --- стара цена: $price_old ===>> нова цена:$price";
						echo '<br>';
					}
				}
			
			}

		
		}
	
	
	
	
	
	die();
	}
	
/* ================================== TRANSFORM ITEMS ==================================== */	
	function move_item()
	{
	//	$item_to_move=$this->input->post('id');
		$data = array( );
	
/*		
		if($this->Item->delete_list($item_to_move))
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('items_successful_deleted').' '.
			count($item_to_move).' '.$this->lang->line('items_one_or_multiple')));
		}
		else
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('items_cannot_be_deleted')));
		}
*/		
		$this->load->view('items/move_item',$data);
	}


	function move_OldToNew_item()
	{
		$old_inum = (int)$this->input->post('old_inum');
		$new_inum = (int)$this->input->post('new_inum');
		if($old_inum>9999 and $old_inum<98000 and $new_inum>9999 and $new_inum<98000)
		{
			$keyOLD = $this->Item->exists_by_number_gpr($old_inum);
			$keyNEW = !$this->Item->exists_by_number_gpr($new_inum);
			
			if($keyOLD) // and $keyNEW
			{
				echo "<div style='width:60%;margin-left:20%;background:yellow;line-height:40px;text-align:center;font-size:150%;'>
						<b>$old_inum >>> $new_inum</b></div><br>";

				$anySKLAD = $this->Item->exists_in_any_sklad($old_inum);
				if($anySKLAD)
				{

					// реално update-ва
					if( $this->Item->update_move_item($old_inum,$new_inum) )
					{ echo "<br><b>SKLAD + ITEMS + TECNOs</b> - successully updated!<br>"; }
					else { echo "<br><b style='color:red;'>ERROR</b> updating SKLAD + ITEMS + TECNOs.<br>";  }
				}
	
	
				if( $this->Item->update_move_item_orders($old_inum,$new_inum) )
				{ echo "<br><b>ORDERS</b> - successully updated!<br>"; }
				else { echo "<br><b style='color:red;'>ERROR</b> updating ORDERS.<br>";  }
	
	
				if( $this->Item->update_move_item_vedoms($old_inum,$new_inum) )
				{ echo "<br><b>VEDOMS 2014-2022</b> - successully updated!<br>"; }
				else { echo "<br><b style='color:red;'>ERROR</b> updating VEDOMS 2014-2022.<br>";  }
	
				// $data = $this->Item->move_item_info($old_inum);
				// print_r($data);	
	
		echo "<br><br>";
	
	
		echo "<span style='background:#ddd;color:black;padding:10px 12px;'><b>".
					anchor("items/refresh",'ГОТОВО', array('style'=>'color:black;','id'=>'end_move_item')).
				"</span>";

		die();
	
	
			} // if($this->Item->exists
			elseif(!$keyOLD) { echo "ERROR - wrong item:<br><b style='color:red;'>стар: $old_inum - НЕ СЪЩЕСТВУВА ???"; }
			elseif(!$keyNEW)  { echo "ERROR - wrong item:<br><b style='color:red;'>новия: $new_inum - СЪЩЕСТВУВА ???</b>"; }
			else { echo "ERROR - wrong item(s):<br><b>old = $old_inum ???  ---- new = $new_inum ???</b>"; }

		}
		else { echo "ERROR !!!"; die(); }
		
		
		return true;
	}
	
	
	

	/* ----	get the width for the add/edit form ---- */
	function get_form_width()
	{
		return 450;
	}

	/* ----	get the width for the add/edit form ---- */
	function get_form_full_width()
	{
		return 820;
	}
	
}
?>
