<?php require_once ("Secure_area.php");

class Materials extends Secure_area 
{
	function __construct()
	{
		parent::__construct('Materials');
		$this->load->library('Mat_lib');
	}
	
	function index($list='0')
	{
		$mode_menu = 'materials';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
      $this->mat_lib->clear_dateKey();
		$data=array('list'=>$list);
		$this->refresh($data);
	}

	function refresh($data=array())
	{
		$location = $this->BiSOFT_Model->get_location();
		$data['location']=$location;

			// вземам си всички АСОРТИМЕНТИ
			$data['assort'] = $this->BiSOFT_Model->get_mode_mat();
			$data['assorts'] = array('0' => '--- '.$this->lang->line('mats_select').' '.$this->lang->line('mats_assortment').' ---');
			foreach ($this->Material->get_all_assorts()->result() as $assort)
			{ $data['assorts'][$assort->key] = $assort->key.'. '.$assort->type; }

		$data['mode'] = $this->mat_lib->get_mode();
		$data['mat_period'] = $this->mat_lib->get_period();

		// дати ...
		$data['dateKey'] = $this->mat_lib->get_dateKey();
		$data['modes_years']=array();
		for($k=0;$k<5;$k++) { $data['modes_years'][date("Y")-$k] = date("Y")-$k; }

		$data['modes_months'] = array(
			'01' => $this->lang->line('cal_january'),
			'02' => $this->lang->line('cal_february'),
			'03' => $this->lang->line('cal_march'),
			'04' => $this->lang->line('cal_april'),
			'05' => $this->lang->line('cal_mayl'),
			'06' => $this->lang->line('cal_june'),
			'07' => $this->lang->line('cal_july'),
			'08' => $this->lang->line('cal_august'),
			'09' => $this->lang->line('cal_september'),
			'10' => $this->lang->line('cal_october'),
			'11' => $this->lang->line('cal_november'),
			'12' => $this->lang->line('cal_december')	);

		$data['modes_days'] = array();
		for($k=1;$k<=31;$k++) { $data['modes_days'][$k] = $k; }

		$data['mode_day']		= (int) date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['mode_month']	= (int) date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['mode_year']	= (int) date('Y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['now_year']	   = $this->BiSOFT_Model->get_user_mode_year();
		$data['cur_date']		= date('d.m.Y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		// край на дати ...

		// ОБЩИ
		$data['controller_name']=strtolower(get_class());
		$data['form_width']=$this->get_form_width();
		$config['base_url'] = site_url('/materials/index');
		
		// старо да се изтрие
		// $config['total_rows'] = $this->Material->count_all();	
		// $config['num_links'] = 2;
		// $config['uri_segment'] = 3;
		// $this->pagination->initialize($config);
		
		// New Pagination
		$all_records = $this->Material->count_all($data['assort']);
		$config['per_page'] = 25;
		$data['pages'] = ceil($all_records/$config['per_page']);
		$page_offset = 0;
		if(!isset($data['page'])) {$data['page']=1;}
		else{$page_offset = $config['per_page'] * ($data['page']-1);}

		$data['manage_table']=get_materials_manage_table( $this->Material->get_all_assort( $data['assort'], $config['per_page'], $page_offset ),
																		  $this );
		$this->load->view('materials/manage',$data);
	}

	function pages($page=1)
	{
		$data=array( 'page' => $page );
		$this->refresh($data);
	}

	function change_mat_assort()
	{
		$assort = $this->input->post("mat_assort");
		$this->BiSOFT_Model->set_mode_mat($assort);
		$this->refresh();
	}


/* -------------------------------- CHANGE DATE ------------------------------ */
	function show_hide_DATE()
	{
		if ( !$this->mat_lib->get_dateKey() ) 
				{ !$this->mat_lib->set_dateKey(); }
		else	{ !$this->mat_lib->clear_dateKey(); }

	$this->refresh();
	}

	function select_YEAR()
	{
		$c_day = date('d');
		$c_month = date('m');
		$c_year = $this->input->post("now_year");
		$mode_date = "$c_year-$c_month-$c_day";

		$this->BiSOFT_Model->set_user_date($mode_date);
		$this->BiSOFT_Model->set_user_year($c_year);
	$this->refresh();
	}	

	function change_YEAR()
	{
		$c_day = date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_month = date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_year = $this->input->post("mode_year");
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);
		$this->BiSOFT_Model->set_user_year($c_year);
	$this->refresh();
	}


	function change_MONTH()
	{
		$c_day = date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_month = $this->input->post("mode_month");
		$c_year = date('y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);
	$this->refresh();
	}

	function change_DAY()
	{
		$c_day = $this->input->post("mode_day");
		$c_month = date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_year = date('y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);
	$this->refresh();
	}


	function find_material_info()
	{
		$mat_number=$this->input->post('scan_mat_number');
		echo json_encode($this->Material->find_material_info($mat_number));
	}

	function search()
	{
		$search=$this->input->post('search');
		$data_rows=get_materials_manage_table_data_rows($this->Material->search($search),$this);
		echo $data_rows;
	}

	/* --- Gives search suggestions based on what is being searched for -----	*/
	function suggest()
	{
		$suggestions = $this->Material->get_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}
	
	function material_search()
	{
		$suggestions = $this->Material->get_material_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}
	

	function suggest_category()
	{
		$suggestions = $this->Material->get_category_suggestions($this->input->post('q'));
		echo implode("\n",$suggestions);
	}

	function get_row()
	{
		$mat_id = $this->input->post('row_id');
		$data_row=get_material_data_row($this->Material->get_info($mat_id),$this);
		echo $data_row;
	}

	
	//BiSOFT Inventory Details VEDOMOST //
	function count_details($mat_id=-1)
	{
		$data['location']		= $this->BiSOFT_Model->get_location();
		$data['vedom_year']	= $this->BiSOFT_Model->get_user_mode_year();
		$data['mat_info']		= $this->Material->get_info($mat_id);
	$this->load->view("materials/count_details",$data);
	}

	// ----------------- Външни Диалогови ---------------------- //
	function view_mat($mat_number=0)
	{
		$mat_id = $this->Material->get_all_info($mat_number);
		if($mat_id)
		{
			$location = $this->BiSOFT_Model->get_location();
			$user_id	 = $this->BiSOFT_Model->get_person();
		
			$data['location']	= $location;
			$data['user_id']	= $user_id;
			$data['status']	= $mat_id;
			$data['mat_info']	= $this->Material->get_info($mat_id);

			// вземам си всички ДОСТАВЧИЦИ
			$data['suppliers'] = array('0' => $this->lang->line('reports_edit_nosupplier'));
				foreach ($this->Supplier->get_all()->result() as $supplier)
					{ $data['suppliers'][$supplier->bisoft_id] = character_limiter($supplier->company_name,35);}

			// вземам си таблицата с асортимента
			$data['assortment'] = array();
				foreach ($this->BiSOFT_Model->get_mat_table()->result() as $assort)
					{ $data['assortment'][$assort->key] = character_limiter($assort->type,35);}

			$data['block'] = true;
			$this->load->view("materials/form",$data);
		}
		else { die('Липсва материал: '.$mat_number);}
	}

	// ------------------------ ДИАЛОГОВИ КУТИИ ---  ДЕЛА ----------------------------------- //
	function view($mat_id=-1)
	{
      $location = $this->BiSOFT_Model->get_location();
      $user_id	 = $this->BiSOFT_Model->get_person();
	
		$data['location']	= $location;
		$data['user_id']	= $user_id;
		$data['status']	= $mat_id;
		$data['mat_info']	= $this->Material->get_info($mat_id);

		// вземам си всички ДОСТАВЧИЦИ
		$data['suppliers'] = array('0' => $this->lang->line('reports_edit_nosupplier'));
			foreach ($this->Supplier->get_all()->result() as $supplier)
				{ $data['suppliers'][$supplier->bisoft_id] = character_limiter($supplier->company_name,35);}

		// вземам си таблицата с асортимента
		$data['assortment'] = array();
			foreach ($this->BiSOFT_Model->get_mat_table()->result() as $assort)
				{ $data['assortment'][$assort->key] = character_limiter($assort->type,35);}

		$data['block'] = false;
	$this->load->view("materials/form",$data);
	}

	
	function save($mat_id=-1)
	{
		$location = $this->BiSOFT_Model->get_location();

		if ($mat_id == -1)  //ако е НОВ МАТЕРИАЛ ...
			{	$material_number = $this->input->post('mat_assort').
										 str_pad($this->input->post('supplier_id'), 3, "0", STR_PAD_LEFT).
										 str_pad($this->input->post('mat_num'), 7, "0", STR_PAD_LEFT);
				$supplier_id = $this->input->post('supplier_id');
				$supplier	 = $this->Supplier->get_supplier_name($supplier_id);
			}
		else  // при update на МАТЕРИАЛ ...
			{  $material_number = $this->input->post('mat_number'); 
				$supplier_id 	  = (int)substr($material_number,1,3);
				$supplier	 	  = $this->Supplier->get_supplier_name($supplier_id);
			}	

		$assort		= (int)substr($material_number,0,1);
		$meters 		= (float)$this->input->post('meters');
		$kgs 			= (float)$this->input->post('kgs');
		$quantity 	= (float)$this->input->post('quantity');
		$kgs_lmeter = (float)$this->input->post('kgs_lmeter');
		$mat_width 	= (float)$this->input->post('mat_width');
		$unit_price = (float)$this->input->post('unit_price');

		$tops[1]		= (float)$this->input->post('top_1');
		$tops[2]		= (float)$this->input->post('top_2');
		$tops[3]		= (float)$this->input->post('top_3');
		$tops[4]		= (float)$this->input->post('top_4');
		$tops[5]		= (float)$this->input->post('top_5');
		$tops[6]		= (float)$this->input->post('top_6');
		$tops[7]		= (float)$this->input->post('top_7');
		$tops[8]		= (float)$this->input->post('top_8');
		$tops[9]		= (float)$this->input->post('top_9');
		$tops[10]	= (float)$this->input->post('top_10');
		$tops[11]	= (float)$this->input->post('top_11');
		$tops[12]	= (float)$this->input->post('top_12');
		$tops[13]	= (float)$this->input->post('top_13');
		$tops[14]	= (float)$this->input->post('top_14');
		$tops[15]	= (float)$this->input->post('top_15');
		$tops[16]	= (float)$this->input->post('top_16');
		$tops[17]	= (float)$this->input->post('top_17');
		$tops[18]	= (float)$this->input->post('top_18');
		$tops[19]	= (float)$this->input->post('top_19');
		$tops[20]	= (float)$this->input->post('top_20');

		$all_kgs = 0;
		$tops_quantity = 0;

		for($k=1;$k<21;$k++)
		{
			$all_kgs += (float)$tops[$k];
			if ($tops[$k] != 0 and !empty($tops[$k])) {$tops_quantity++;}
		}

	if ( $assort < 4 ) // значи е ПЛАТ или ХАСТАР ...
		{
		if ( $tops_quantity > 0 ) // имаме топове kg
			{ $quantity = $tops_quantity;
				if ( (empty($meters) or $meters==0) and $kgs > 0 and ($kgs_lmeter > 0 and $mat_width > 0) )
					{
						$meters = round( $kgs / $kgs_lmeter / $mat_width , 1);
					}
				elseif ( $all_kgs > 0 and $kgs_lmeter > 0 and $mat_width > 0 )
					{
						$kgs = $all_kgs;
						$meters = round( $kgs / $kgs_lmeter / $mat_width , 1);
					}
			}  // tops_qty > 0 ...
		}
		
			$del = $this->input->post('deleted');
			if($del) {$del=1;} else {$del=0;}
         if($mat_id==-1) {$del=0;}
	
			$mat_data = array(
				'mat_number'=>$material_number,
				'name'=>$this->input->post('name'),
				'mat_color'=>$this->input->post('mat_color'),
				'contents'=>$this->input->post('contents'),
				'mat_width'=>$mat_width,
				'contractility_L'=>$this->input->post('contractility_L'),
				'contractility_W'=>$this->input->post('contractility_W'),
				'mat_measure'=>$this->input->post('mat_measure'),
				'mat_assort'=>$assort,
				'meters'=>$meters,
				'kgs'=>$kgs,
				'quantity'=>$quantity,
				
				'top_1' => ((float)$tops[1]==0) ? '' : $tops[1],
				'top_2' => ((float)$tops[2]==0) ? '' : $tops[2],
				'top_3' => ((float)$tops[3]==0) ? '' : $tops[3],
				'top_4' => ((float)$tops[4]==0) ? '' : $tops[4],
				'top_5' => ((float)$tops[5]==0) ? '' : $tops[5],
				'top_6' => ((float)$tops[6]==0) ? '' : $tops[6],
				'top_7' => ((float)$tops[7]==0) ? '' : $tops[7],
				'top_8' => ((float)$tops[8]==0) ? '' : $tops[8],
				'top_9' => ((float)$tops[9]==0) ? '' : $tops[9],
			  'top_10' => ((float)$tops[10]==0) ? '' : $tops[10],
			  'top_11' => ((float)$tops[11]==0) ? '' : $tops[11],
			  'top_12' => ((float)$tops[12]==0) ? '' : $tops[12],
			  'top_13' => ((float)$tops[13]==0) ? '' : $tops[13],
			  'top_14' => ((float)$tops[14]==0) ? '' : $tops[14],
			  'top_15' => ((float)$tops[15]==0) ? '' : $tops[15],
			  'top_16' => ((float)$tops[16]==0) ? '' : $tops[16],
			  'top_17' => ((float)$tops[17]==0) ? '' : $tops[17],
			  'top_18' => ((float)$tops[18]==0) ? '' : $tops[18],
			  'top_19' => ((float)$tops[19]==0) ? '' : $tops[19],
			  'top_20' => ((float)$tops[20]==0) ? '' : $tops[20],
			  
				'kgs_lmeter'=>$kgs_lmeter,
				'unit_price'=>$unit_price,
				'currency'=>$this->input->post('currency'),
				'supplier_id'=>$supplier_id,
				'supplier'=>$supplier,
				'description'=>$this->input->post('description'),
				'deleted'=>$del );

		if ($mat_id == -1) // прави ДОСТАВКА ... 
		{ 		// $cur_mat_info = $this->Material->get_info($mat_id);
			$vedom = 'M'.date('Y');
			$doc_number = date('ym')*1000000;
			$employee_id = $this->BiSOFT_Model->get_person();
			$emp_info = $this->Employee->get_info($employee_id);
			// $employee = $emp_info->first_name.' '.$emp_info->last_name;

			$doc_data = array(
				'doc_number'=>$doc_number,
				'doc_date'=> date('Y-m-d'),
				'mode'=>'dostav',
				'mode_id'=>'dM',
				'mat_number'=>$material_number,
				'name'=>$this->input->post('name').','.$this->input->post('mat_color'),
				'meters'=>$meters,
				'kgs'=>$kgs,
				'quantity' => $quantity,
				
				'top_1' => ((float)$tops[1]==0) ? '' : $tops[1],
				'top_2' => ((float)$tops[2]==0) ? '' : $tops[2],
				'top_3' => ((float)$tops[3]==0) ? '' : $tops[3],
				'top_4' => ((float)$tops[4]==0) ? '' : $tops[4],
				'top_5' => ((float)$tops[5]==0) ? '' : $tops[5],
				'top_6' => ((float)$tops[6]==0) ? '' : $tops[6],
				'top_7' => ((float)$tops[7]==0) ? '' : $tops[7],
				'top_8' => ((float)$tops[8]==0) ? '' : $tops[8],
				'top_9' => ((float)$tops[9]==0) ? '' : $tops[9],
			  'top_10' => ((float)$tops[10]==0) ? '' : $tops[10],
			  'top_11' => ((float)$tops[11]==0) ? '' : $tops[11],
			  'top_12' => ((float)$tops[12]==0) ? '' : $tops[12],
			  'top_13' => ((float)$tops[13]==0) ? '' : $tops[13],
			  'top_14' => ((float)$tops[14]==0) ? '' : $tops[14],
			  'top_15' => ((float)$tops[15]==0) ? '' : $tops[15],
			  'top_16' => ((float)$tops[16]==0) ? '' : $tops[16],
			  'top_17' => ((float)$tops[17]==0) ? '' : $tops[17],
			  'top_18' => ((float)$tops[18]==0) ? '' : $tops[18],
			  'top_19' => ((float)$tops[19]==0) ? '' : $tops[19],
			  'top_20' => ((float)$tops[20]==0) ? '' : $tops[20],
			  
			  'employee_id' => $employee_id );

		// приготвя документа ------------------------ //
			$doc_id = $this->Material->save_vedom($doc_data,$vedom,false);
			$doc_number = $doc_number + $doc_id;
			$new_data=array('doc_id'=>$doc_id,'doc_number'=>$doc_number);
			$this->Material->save_vedom($new_data,$vedom,$doc_id);
		}

		if(!$this->Material->exists_by_number($material_number))
		{
         if($mat_id==-1)
			{
            if($this->Material->save($mat_data,false))
            {
               echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_successful_adding').' '.
               $mat_data['name'],'mat_id'=>-1));
               $mat_id = $mat_data['mat_id'];
            }
            else
            {
               echo json_encode(array('success'=>false,'message'=>$this->lang->line('mats_error_adding_updating').' '.
               $mat_data['name'],'mat_id'=>-1));
            }
			}
			else
			{	// Неудачно регистриране ...
				echo json_encode(array('success'=>false,'message'=>$this->lang->line('mats_error_adding_updating').' '.
				$mat_data['name'],'mat_id'=>$mat_id));
			}
		}
		else // има го материала ...
		{  //New MAT FAILs
			if($mat_id==-1)
			{
				echo json_encode(array('success'=>false,'message'=>$this->lang->line('mats_error_adding_updating').' '.
				$mat_data['name'],'mat_id'=>-1));
			}
			else //previous mat = OK
			{
				// Удачно регистриране ...
				if($this->Material->save($mat_data,$mat_id))
            {
               echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_successful_updating').' '.
               $mat_data['name'],'mat_id'=>$mat_id));
            }
            else //failure
            {
               echo json_encode(array('success'=>false,'message'=>$this->lang->line('mats_error_adding_updating').' '.
               $mat_data['name'],'mat_id'=>-1));
            }
			}
		}
	}
	

/* -------------------------------------------   ДОСТАВКА ------------------------------------ */
	function dostavka($mat_id=-1)
	{
		$location = $this->BiSOFT_Model->get_location();
		$user_id	 = $this->BiSOFT_Model->get_person();
		$data['location']	= $location;
		$data['user_id']	= $user_id;
		$data['status']	= $mat_id;
		$data['mat_info']	= $this->Material->get_info($mat_id);

		// вземам си всички ДОСТАВЧИЦИ
		$data['suppliers'] = array('0' => $this->lang->line('reports_edit_nosupplier'));
			foreach ($this->Supplier->get_all()->result() as $supplier)
				{ $data['suppliers'][$supplier->bisoft_id] = character_limiter($supplier->company_name,30);}

		$data['supplier'] = $suppler = substr($data['mat_info']->mat_number,1,3);
		if(!$this->Material->exists_supplier($suppler)) { $data['supplier'] = 0; }

		// вземам си таблицата с асортимента
		$data['assortment'] = array();
			foreach ($this->BiSOFT_Model->get_mat_table()->result() as $assort)
				{ $data['assortment'][$assort->key] = character_limiter($assort->type,35);}

	$this->load->view("materials/form_dostavka",$data);
	}

	
	function save_dostavka($mat_id)
	{
		$success = '-1';
		$location = $this->BiSOFT_Model->get_location();
		$material_number = $this->input->post('mat_number');
		$assort		= (int)substr($material_number,0,1);

		$employee_id = $this->BiSOFT_Model->get_person();
		$emp_info = $this->Employee->get_info($employee_id);
		$employee = $emp_info->first_name.' '.$emp_info->last_name;
		$mat_info = $this->Material->get_info($mat_id);
		
		$meters 		= (float)$this->input->post('meters');
		$kgs 			= (float)$this->input->post('kgs');
		$quantity 	= (float)$this->input->post('quantity');
		$kgs_lmeter = (float)$this->input->post('kgs_lmeter');
		$mat_width 	= (float)$this->input->post('mat_width');

			$itop[1]		= (float)$this->input->post('top_1');
			$itop[2]		= (float)$this->input->post('top_2');
			$itop[3]		= (float)$this->input->post('top_3');
			$itop[4]		= (float)$this->input->post('top_4');
			$itop[5]		= (float)$this->input->post('top_5');
			$itop[6]		= (float)$this->input->post('top_6');
			$itop[7]		= (float)$this->input->post('top_7');
			$itop[8]		= (float)$this->input->post('top_8');
			$itop[9]		= (float)$this->input->post('top_9');
			$itop[10]	= (float)$this->input->post('top_10');
			$itop[11]	= (float)$this->input->post('top_11');
			$itop[12]	= (float)$this->input->post('top_12');
			$itop[13]	= (float)$this->input->post('top_13');
			$itop[14]	= (float)$this->input->post('top_14');
			$itop[15]	= (float)$this->input->post('top_15');
			$itop[16]	= (float)$this->input->post('top_16');
			$itop[17]	= (float)$this->input->post('top_17');
			$itop[18]	= (float)$this->input->post('top_18');
			$itop[19]	= (float)$this->input->post('top_19');
			$itop[20]	= (float)$this->input->post('top_20');
	
		if($mat_info)
		{
			$top[1]	= (float)$mat_info->top_1 + $itop[1];
			$top[2]	= (float)$mat_info->top_2 + $itop[2];
			$top[3]	= (float)$mat_info->top_3 + $itop[3];
			$top[4]	= (float)$mat_info->top_4 + $itop[4];
			$top[5]	= (float)$mat_info->top_5 + $itop[5];
			$top[6]	= (float)$mat_info->top_6 + $itop[6];
			$top[7]	= (float)$mat_info->top_7 + $itop[7];
			$top[8]	= (float)$mat_info->top_8 + $itop[8];
			$top[9]	= (float)$mat_info->top_9 + $itop[9];
			$top[10]	= (float)$mat_info->top_10 + $itop[10];
			$top[11]	= (float)$mat_info->top_11 + $itop[11];
			$top[12]	= (float)$mat_info->top_12 + $itop[12];
			$top[13]	= (float)$mat_info->top_13 + $itop[13];
			$top[14] = (float)$mat_info->top_14 + $itop[14];
			$top[15] = (float)$mat_info->top_15 + $itop[15];
			$top[16] = (float)$mat_info->top_16 + $itop[16];
			$top[17] = (float)$mat_info->top_17 + $itop[17];
			$top[18] = (float)$mat_info->top_18 + $itop[18];
			$top[19] = (float)$mat_info->top_19 + $itop[19];
			$top[20] = (float)$mat_info->top_20 + $itop[20];
		}
		else
		{
			$top[1] = $itop[1]; $top[2] = $itop[2]; $top[3]	= $itop[3]; $top[4] = $itop[4]; $top[5] = $itop[5];
			$top[6] = $itop[6]; $top[7] = $itop[7]; $top[8]	= $itop[8]; $top[9] = $itop[9]; $top[10] = $itop[10];
			$top[11] = $itop[11]; $top[12] = $itop[12]; $top[13] = $itop[13]; $top[14] = $itop[14]; $top[15] = $itop[15];
			$top[16] = $itop[16]; $top[17] = $itop[17]; $top[18] = $itop[18]; $top[19] = $itop[19]; $top[20] = $itop[20];
		}	

		$all_kgs = $qty = 0;
		$top_quantity = 0;

		for($k=1;$k<21;$k++)
		{
			$all_kgs += $top[$k];
			if ($top[$k] != 0 and !empty($top[$k])) {$top_quantity++;}
		}

		if( $assort < 4 ) // значи е ПЛАТ или ХАСТАР ...
		{
			if ( $top_quantity > 0 ) // имаме топове kg
			{ $quantity = $top_quantity;
				if ( (empty($meters) or $meters==0) and $kgs > 0 and ($kgs_lmeter > 0 and $mat_width > 0) )
				{
					$meters = round( $kgs / $kgs_lmeter / $mat_width , 1);
				}
				elseif ( $all_kgs > 0 and $kgs_lmeter > 0 and $mat_width > 0 )
				{
					$kgs = $all_kgs;
					$meters = round( $kgs / $kgs_lmeter / $mat_width , 1);
				}
			}  // tops_qty > 0 ...
		}
		elseif( $assort == 8 )
		{ $qty = $this->input->post('qty'); }
	
		$mat_data = array(
				'mat_number'=>$material_number,
				'meters'=>$meters,
				'kgs'=>$kgs,
				'quantity'=>$quantity+$qty,
				'top_1' => ((float)$top[1]==0) ? '' : $top[1],
				'top_2' => ((float)$top[2]==0) ? '' : $top[2],
				'top_3' => ((float)$top[3]==0) ? '' : $top[3],
				'top_4' => ((float)$top[4]==0) ? '' : $top[4],
				'top_5' => ((float)$top[5]==0) ? '' : $top[5],
				'top_6' => ((float)$top[6]==0) ? '' : $top[6],
				'top_7' => ((float)$top[7]==0) ? '' : $top[7],
				'top_8' => ((float)$top[8]==0) ? '' : $top[8],
				'top_9' => ((float)$top[9]==0) ? '' : $top[9],
			  'top_10' => ((float)$top[10]==0) ? '' : $top[10],
			  'top_11' => ((float)$top[11]==0) ? '' : $top[11],
			  'top_12' => ((float)$top[12]==0) ? '' : $top[12],
			  'top_13' => ((float)$top[13]==0) ? '' : $top[13],
			  'top_14' => ((float)$top[14]==0) ? '' : $top[14],
			  'top_15' => ((float)$top[15]==0) ? '' : $top[15],
			  'top_16' => ((float)$top[16]==0) ? '' : $top[16],
			  'top_17' => ((float)$top[17]==0) ? '' : $top[17],
			  'top_18' => ((float)$top[18]==0) ? '' : $top[18],
			  'top_19' => ((float)$top[19]==0) ? '' : $top[19],
			  'top_20' => ((float)$top[20]==0) ? '' : $top[20] );
				
		$all_kgs = 0;
		$top_quantity = 0;

		for($k=1;$k<21;$k++)
		{
			$all_kgs += $itop[$k];
			if ($itop[$k] != 0 and !empty($itop[$k])) {$top_quantity++;}
		}
						
		if($all_kgs>0 or $qty!=0 )
		{
			if( $assort < 4 ) // значи е ПЛАТ или ХАСТАР ...
			{
				if( $top_quantity > 0 ) // имаме топове kg
				{ $quantity = $top_quantity;
					if( (empty($meters) or $meters==0) and $kgs > 0 and ($kgs_lmeter > 0 and $mat_width > 0) )
					{
						$meters = round( $kgs / $kgs_lmeter / $mat_width , 1);
					}
					elseif ( $all_kgs > 0 and $kgs_lmeter > 0 and $mat_width > 0 )
					{
						$kgs = $all_kgs;
						$meters = round( $kgs / $kgs_lmeter / $mat_width , 1);
					}
				}  // tops_qty > 0 ...
			}
			
			// период и дати ...
			$period = strtotime( $this->input->post('form_date') );
			$vedom = 'M'.date('Y', $period);
			$doc_number = date('ym', $period) * 1000000;
			$doc_date = date('Y-m-d', $period);
			
			$subcont_id = 0;
			if( $assort == 8 )
			{ $subcont_id = (int)$this->input->post('supplier'); }

			$doc_data = array(
				'doc_number'=>$doc_number,
				'doc_date'=> $doc_date,
				'mode'=>'dostav',
				'mode_id'=>'dM',

				'mat_number'=>$material_number,
				'name'=>$this->input->post('name').','.$this->input->post('mat_color'),
				'meters'=>$meters,
				'kgs'=>$kgs,
				'quantity'=>( ($assort==8) ? $qty : $quantity),

				'top_1' => ((float)$itop[1]==0) ? '' : $itop[1],
				'top_2' => ((float)$itop[2]==0) ? '' : $itop[2],
				'top_3' => ((float)$itop[3]==0) ? '' : $itop[3],
				'top_4' => ((float)$itop[4]==0) ? '' : $itop[4],
				'top_5' => ((float)$itop[5]==0) ? '' : $itop[5],
				'top_6' => ((float)$itop[6]==0) ? '' : $itop[6],
				'top_7' => ((float)$itop[7]==0) ? '' : $itop[7],
				'top_8' => ((float)$itop[8]==0) ? '' : $itop[8],
				'top_9' => ((float)$itop[9]==0) ? '' : $itop[9],
				'top_10' => ((float)$itop[10]==0) ? '' : $itop[10],
				'top_11' => ((float)$itop[11]==0) ? '' : $itop[11],
				'top_12' => ((float)$itop[12]==0) ? '' : $itop[12],
				'top_13' => ((float)$itop[13]==0) ? '' : $itop[13],
				'top_14' => ((float)$itop[14]==0) ? '' : $itop[14],
				'top_15' => ((float)$itop[15]==0) ? '' : $itop[15],
				'top_16' => ((float)$itop[16]==0) ? '' : $itop[16],
				'top_17' => ((float)$itop[17]==0) ? '' : $itop[17],
				'top_18' => ((float)$itop[18]==0) ? '' : $itop[18],
				'top_19' => ((float)$itop[19]==0) ? '' : $itop[19],
				'top_20' => ((float)$itop[20]==0) ? '' : $itop[20],
				
				'subcont_id' => $subcont_id,
				'employee_id' => $employee_id );
				
		// приготвя документа ------------------------ //
			$doc_id = $this->Material->save_vedom($doc_data,$vedom,false);
			$doc_number = $doc_number + $doc_id;
			$new_data=array('doc_id'=>$doc_id,'doc_number'=>$doc_number);
			
			$success *= $this->Material->save($mat_data,$mat_id);
			$success *= $this->Material->save_vedom($new_data,$vedom,$doc_id);

		} // if($all_kgs>0)
			
		if( $success )
		{
			// Удачно регистриране ...
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_successful_updating').' '.
			$material_number.' '.$mat_info->name,'mat_id'=>$mat_id));
		}
		elseif($success=='-1')
		{
			// Удачно регистриране ...
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_no_update').' '.
			$material_number.' '.$mat_info->name,'mat_id'=>$mat_id));
		}
		else //failure
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('mats_error_adding_updating').' '.
			$material_number.' '.$mat_info->name,'mat_id'=>-1));
		}
	}
	

/* -------------------------------------------   ИСКАНЕ ------------------------------------ */
	function iskane($mat_id=-1)
	{
	if($mat_id==-1) { return false;}

	$location = $this->BiSOFT_Model->get_location();
	$user_id	 = $this->BiSOFT_Model->get_person();
		$data['location']	= $location;
		$data['user_id']	= $user_id;
		$data['status']	= $mat_id;
		$data['mat_info']	= $this->Material->get_info($mat_id);

		// вземам си всички ДОСТАВЧИЦИ
		$data['suppliers'] = array('0' => $this->lang->line('reports_edit_nosupplier'));
			foreach ($this->Supplier->get_all()->result() as $supplier)
				{ $data['suppliers'][$supplier->bisoft_id] = character_limiter($supplier->company_name,35);}

		// вземам си таблицата с асортимента
		$data['assortment'] = array();
			foreach ($this->BiSOFT_Model->get_mat_table()->result() as $assort)
				{ $data['assortment'][$assort->key] = character_limiter($assort->type,35);}

	$this->load->view("materials/form_iskane",$data);
	}

	function save_iskane($mat_id)
	{
		$success = '-1'; 
		$location = $this->BiSOFT_Model->get_location();
		$material_number = $this->input->post('mat_number');
		$to_delete = $this->input->post('to_delete');

		$employee_id = $this->BiSOFT_Model->get_person();
		$emp_info = $this->Employee->get_info($employee_id);
		$employee = $emp_info->first_name.' '.$emp_info->last_name;

		$mat_info 	= $this->Material->get_info($mat_id);

		$assort		= (int)substr($material_number,0,1);
		$meters 		= (float)$this->input->post('meters');
		$kgs 			= (float)$this->input->post('kgs');
		$quantity 	= (float)$this->input->post('quantity');
		$kgs_lmeter = (float)$this->input->post('kgs_lmeter');
		$mat_width 	= (float)$this->input->post('mat_width');

		if($to_delete) // само при приключване
		{
			if($mat_info)
			{
				$itop[1]	 = (float)$mat_info->top_1;
				$itop[2]	 = (float)$mat_info->top_2;
				$itop[3]	 = (float)$mat_info->top_3;
				$itop[4]	 = (float)$mat_info->top_4;
				$itop[5]	 = (float)$mat_info->top_5;
				$itop[6]	 = (float)$mat_info->top_6;
				$itop[7]	 = (float)$mat_info->top_7;
				$itop[8]	 = (float)$mat_info->top_8;
				$itop[9]	 = (float)$mat_info->top_9;
				$itop[10] = (float)$mat_info->top_10;
				$itop[11] = (float)$mat_info->top_11;
				$itop[12] = (float)$mat_info->top_12;
				$itop[13] = (float)$mat_info->top_13;
				$itop[14] = (float)$mat_info->top_14;
				$itop[15] = (float)$mat_info->top_15;
				$itop[16] = (float)$mat_info->top_16;
				$itop[17] = (float)$mat_info->top_17;
				$itop[18] = (float)$mat_info->top_18;
				$itop[19] = (float)$mat_info->top_19;
				$itop[20] = (float)$mat_info->top_20;
			}
			else
			{
				$itop[1]=$itop[2]=$itop[3]=$itop[4]=$itop[5]=$itop[6]=$itop[7]=$itop[8]=$itop[9]=$itop[10]=0;
				$itop[11]=$itop[12]=$itop[13]=$itop[14]=$itop[15]=$itop[16]=$itop[17]=$itop[18]=$itop[19]=$itop[20]=0;
			}

			$quantity = $meters = $kgs = 0;
			$top[1] = $top[2] = $top[3] = $top[4] = $top[5] = $top[6] = $top[7] = $top[8] = $top[9] = $top[10] = 0;
			$top[11]	= $top[12] = $top[13] = $top[14]	= $top[15] = $top[16] = $top[17]	= $top[18] = $top[19] = $top[20] = 0;
      }
      else
      {
			$itop[1]	 = (float)$this->input->post('top_1');
			$itop[2]	 = (float)$this->input->post('top_2');
			$itop[3]	 = (float)$this->input->post('top_3');
			$itop[4]	 = (float)$this->input->post('top_4');
			$itop[5]	 = (float)$this->input->post('top_5');
			$itop[6]	 = (float)$this->input->post('top_6');
			$itop[7]	 = (float)$this->input->post('top_7');
			$itop[8]	 = (float)$this->input->post('top_8');
			$itop[9]	 = (float)$this->input->post('top_9');
			$itop[10] = (float)$this->input->post('top_10');
			$itop[11] = (float)$this->input->post('top_11');
			$itop[12] = (float)$this->input->post('top_12');
			$itop[13] = (float)$this->input->post('top_13');
			$itop[14] = (float)$this->input->post('top_14');
			$itop[15] = (float)$this->input->post('top_15');
			$itop[16] = (float)$this->input->post('top_16');
			$itop[17] = (float)$this->input->post('top_17');
			$itop[18] = (float)$this->input->post('top_18');
			$itop[19] = (float)$this->input->post('top_19');
			$itop[20] = (float)$this->input->post('top_20');
			
			if($mat_info)
			{
				$top[1]	= (float)$mat_info->top_1 - $itop[1];
				$top[2]	= (float)$mat_info->top_2 - $itop[2];
				$top[3]	= (float)$mat_info->top_3 - $itop[3];
				$top[4]	= (float)$mat_info->top_4 - $itop[4];
				$top[5]	= (float)$mat_info->top_5 - $itop[5];
				$top[6]	= (float)$mat_info->top_6 - $itop[6];
				$top[7]	= (float)$mat_info->top_7 - $itop[7];
				$top[8]	= (float)$mat_info->top_8 - $itop[8];
				$top[9]	= (float)$mat_info->top_9 - $itop[9];
				$top[10] = (float)$mat_info->top_10 - $itop[10];
				$top[11]	= (float)$mat_info->top_11 - $itop[11];
				$top[12]	= (float)$mat_info->top_12 - $itop[12];
				$top[13]	= (float)$mat_info->top_13 - $itop[13];
				$top[14]	= (float)$mat_info->top_14 - $itop[14];
				$top[15]	= (float)$mat_info->top_15 - $itop[15];
				$top[16]	= (float)$mat_info->top_16 - $itop[16];
				$top[17]	= (float)$mat_info->top_17 - $itop[17];
				$top[18]	= (float)$mat_info->top_18 - $itop[18];
				$top[19]	= (float)$mat_info->top_19 - $itop[19];
				$top[20] = (float)$mat_info->top_20 - $itop[20];
			}
			else
			{
				$top[1]  = $top[2] = $top[3] = $top[4] = $top[5] = $top[6] = $top[7] = $top[8] = $top[9] = $top[10] = 0;
				$top[11]	= $top[12] = $top[13] = $top[14]	= $top[15] = $top[16] = $top[17]	= $top[18] = $top[19] = $top[20] = 0;
			}
      }

		$all_kgs = 0;
		$top_quantity = $new_top_quantity = $new_meters = 0;
		$all_tops = $itop[1] + $itop[2] + $itop[3] + $itop[4] + $itop[5] + $itop[6] + $itop[7] + $itop[8] + $itop[9] + $itop[10] +
						$itop[11] + $itop[12] + $itop[13] + $itop[14] + $itop[15] + $itop[16] + $itop[17] + $itop[18] + $itop[19] + $itop[20];
						
		if($all_tops and $kgs_lmeter > 0 and $mat_width > 0 ) {$new_meters=round( $all_tops / $kgs_lmeter / $mat_width , 1);}
		
			for($k=1;$k<21;$k++)
			{
				$all_kgs += $top[$k];
				if ($top[$k] != 0 and !empty($top[$k])) {$top_quantity++;}
				if ($itop[$k] != 0 and !empty($itop[$k])) {$new_top_quantity++;}
			}

		if($all_kgs>0 or $to_delete)
		{
			if ( $assort < 4 ) // значи е ПЛАТ или ХАСТАР ...
				{
				if ( $top_quantity > 0 ) // имаме топове kg
					{ $quantity = $top_quantity;
						if ( (empty($meters) or $meters==0) and $kgs > 0 and ($kgs_lmeter > 0 and $mat_width > 0) )
							{
								$meters = round( $kgs / $kgs_lmeter / $mat_width , 1);
							}
						elseif ( $all_kgs > 0 and $kgs_lmeter > 0 and $mat_width > 0 )
							{
								$kgs = $all_kgs;
								$meters = round( $kgs / $kgs_lmeter / $mat_width , 1);
							}
					}  // tops_qty > 0 ...
				}
		}
			
		if($all_tops>0 or $to_delete)
		{
			$mat_data = array(
				'mat_number'=>$material_number,
				'meters'=>$meters,
				'kgs'=>$kgs,
				'quantity'=>$quantity,

				'top_1' => ((float)$top[1]==0) ? '' : $top[1],
				'top_2' => ((float)$top[2]==0) ? '' : $top[2],
				'top_3' => ((float)$top[3]==0) ? '' : $top[3],
				'top_4' => ((float)$top[4]==0) ? '' : $top[4],
				'top_5' => ((float)$top[5]==0) ? '' : $top[5],
				'top_6' => ((float)$top[6]==0) ? '' : $top[6],
				'top_7' => ((float)$top[7]==0) ? '' : $top[7],
				'top_8' => ((float)$top[8]==0) ? '' : $top[8],
				'top_9' => ((float)$top[9]==0) ? '' : $top[9],
			  'top_10' => ((float)$top[10]==0) ? '' : $top[10],
			  'top_11' => ((float)$top[11]==0) ? '' : $top[11],
			  'top_12' => ((float)$top[12]==0) ? '' : $top[12],
			  'top_13' => ((float)$top[13]==0) ? '' : $top[13],
			  'top_14' => ((float)$top[14]==0) ? '' : $top[14],
			  'top_15' => ((float)$top[15]==0) ? '' : $top[15],
			  'top_16' => ((float)$top[16]==0) ? '' : $top[16],
			  'top_17' => ((float)$top[17]==0) ? '' : $top[17],
			  'top_18' => ((float)$top[18]==0) ? '' : $top[18],
			  'top_19' => ((float)$top[19]==0) ? '' : $top[19],
			  'top_20' => ((float)$top[20]==0) ? '' : $top[20] );
	
			// период и дати ...
			$period = strtotime( $this->input->post('form_date') );
			$vedom = 'M'.date('Y', $period);
			$doc_number = date('ym', $period) * 1000000;
			$doc_date = date('Y-m-d', $period);

			$doc_data = array(
				'doc_number'=>$doc_number,
				'doc_date'=> $doc_date,
				'mode'=>'iskane',
				'mode_id'=>'iM',

				'mat_number'=>$material_number,
				'name'=>$this->input->post('name').','.$this->input->post('mat_color'),
				'meters'=>$new_meters,
				'kgs'=>$all_tops,
				'quantity'=>$new_top_quantity,

				'top_1' => ((float)$itop[1]==0) ? '' : $itop[1],
				'top_2' => ((float)$itop[2]==0) ? '' : $itop[2],
				'top_3' => ((float)$itop[3]==0) ? '' : $itop[3],
				'top_4' => ((float)$itop[4]==0) ? '' : $itop[4],
				'top_5' => ((float)$itop[5]==0) ? '' : $itop[5],
				'top_6' => ((float)$itop[6]==0) ? '' : $itop[6],
				'top_7' => ((float)$itop[7]==0) ? '' : $itop[7],
				'top_8' => ((float)$itop[8]==0) ? '' : $itop[8],
				'top_9' => ((float)$itop[9]==0) ? '' : $itop[9],
				'top_10' => ((float)$itop[10]==0) ? '' : $itop[10],
				'top_11' => ((float)$itop[11]==0) ? '' : $itop[11],
				'top_12' => ((float)$itop[12]==0) ? '' : $itop[12],
				'top_13' => ((float)$itop[13]==0) ? '' : $itop[13],
				'top_14' => ((float)$itop[14]==0) ? '' : $itop[14],
				'top_15' => ((float)$itop[15]==0) ? '' : $itop[15],
				'top_16' => ((float)$itop[16]==0) ? '' : $itop[16],
				'top_17' => ((float)$itop[17]==0) ? '' : $itop[17],
				'top_18' => ((float)$itop[18]==0) ? '' : $itop[18],
				'top_19' => ((float)$itop[19]==0) ? '' : $itop[19],
				'top_20' => ((float)$itop[20]==0) ? '' : $itop[20],

				'employee_id'=>$employee_id );
				
		// приготвя документа ------------------------ //
			$doc_id = $this->Material->save_vedom($doc_data,$vedom,false);
			$doc_number = $doc_number + $doc_id;
			$new_data=array('doc_id'=>$doc_id,'doc_number'=>$doc_number);

			$success *= $this->Material->save($mat_data,$mat_id);
			$success *= $this->Material->save_vedom($new_data,$vedom,$doc_id);
		} // if($all_tops > 0 or $to_delete)

		if( $success )
		{
			// Удачно регистриране ...
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_successful_updating').' '.
			$material_number.' '.$mat_info->name,'mat_id'=>$mat_id));
		}
		elseif($success=='-1')
		{
			// Без Промяна ...
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_no_update').' '.
			$material_number.' '.$mat_info->name,'mat_id'=>$mat_id));
		}
		else //failure
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('mats_error_adding_updating').' '.
			$material_number.' '.$mat_info->name,'mat_id'=>-1));
		}
	}


/* --------- Протокол за материали --------------------- */	
	function promat($mat_id=-1)
	{
	if($mat_id==-1) { return false;}

	$location = $this->BiSOFT_Model->get_location();
	$user_id	 = $this->BiSOFT_Model->get_person();
		$data['location']	= $location;
		$data['user_id']	= $user_id;
		$data['status']	= $mat_id;
		$data['mat_info']	= $this->Material->get_info($mat_id);

		// вземам си всички ДОСТАВЧИЦИ
		$data['suppliers'] = array('0' => $this->lang->line('reports_edit_nosupplier'));
			foreach ($this->Supplier->get_all()->result() as $supplier)
				{ $data['suppliers'][$supplier->bisoft_id] = character_limiter($supplier->company_name,35);}
			
		// вземам си всички ПОДИЗПЪЛНИТЕЛИ
		$data['subcont']  = 0;
		$data['subconts'] = array('0' => '-- ИЗБЕРЕТЕ --');
			foreach ($this->Subcont->get_all_subcaonts()->result() as $subcont)
				{ $data['subconts'][$subcont->bisoft_id] = character_limiter($subcont->company_name,35);}

		// вземам си таблицата с асортимента
		$data['assortment'] = array();
			foreach ($this->BiSOFT_Model->get_mat_table()->result() as $assort)
				{ $data['assortment'][$assort->key] = character_limiter($assort->type,35);}

		$this->load->view("materials/form_promat",$data);
	}

	function save_promat($mat_id)
	{
		$success = '-1'; 
		$location = $this->BiSOFT_Model->get_location();
		$material_number = $this->input->post('mat_number');

		$employee_id = $this->BiSOFT_Model->get_person();
		$emp_info = $this->Employee->get_info($employee_id);
		$employee = $emp_info->first_name.' '.$emp_info->last_name;

		$subcont_id = $this->input->post('subcont_id');
		$mat_info 	= $this->Material->get_info($mat_id);

		$assort		= (int) substr($material_number,0,1);
	//	$meters 		= $this->input->post('meters');
	//	$kgs 			= $this->input->post('kgs');
	//	$quantity 	= $this->input->post('quantity');
	//	$kgs_lmeter = $this->input->post('kgs_lmeter');
	//	$mat_width 	= $this->input->post('mat_width');

		$old_qty = $this->input->post('old_qty');
		$qty = $this->input->post('qty');
		
		$quantity = $old_qty - $qty;

		if($qty!=0 and $subcont_id>0)
		{
			$mat_data = array(
				'mat_number'=>$material_number,
				'quantity'=>$quantity );
	
			// период и дати ...
			$period = strtotime( $this->input->post('form_date') );
			$vedom  = 'M'.date('Y', $period);
			$doc_number = date('ym', $period) * 1000000;
			$doc_date   = date('Y-m-d', $period);

			$doc_data = array(
				'doc_number'=>$doc_number,
				'doc_date'=> $doc_date,
				'mode'=>'promat',
				'mode_id'=>'prM',

				'mat_number'=>$material_number,
				'name'=>$this->input->post('name').','.$this->input->post('mat_color'),
				'quantity'=>$qty,
				
				'subcont_id'=>$subcont_id,
				'employee_id'=>$employee_id );
				
		// приготвя документа ------------------------ //
			$doc_id = $this->Material->save_vedom($doc_data,$vedom,false);
			$doc_number = $doc_number + $doc_id;
			$new_data=array('doc_id'=>$doc_id,'doc_number'=>$doc_number);

			$success *= $this->Material->save($mat_data,$mat_id);
			$success *= $this->Material->save_vedom($new_data,$vedom,$doc_id);
		} // if($all_tops > 0 or $to_delete)

		if( $success )
		{
			// Удачно регистриране ...
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_successful_updating').' '.
			$material_number.' '.$mat_info->name,'mat_id'=>$mat_id));
		}
		elseif($success=='-1')
		{
			// Без Промяна ...
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_no_update').' '.
			$material_number.' '.$mat_info->name,'mat_id'=>$mat_id));
		}
		else //failure
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('mats_error_adding_updating').' '.
			$material_number.' '.$mat_info->name,'mat_id'=>-1));
		}
	}


/* ----------------------------------- END of documents  ------------------------------- */

	function bulk_edit()
	{
		$data = array();
		$suppliers = array('' => $this->lang->line('mats_none'));
		foreach($this->Supplier->get_all()->result_array() as $row)
		{
			$suppliers[$row['person_id']] = $row['first_name'] .' '. $row['last_name'];
		}
		$data['suppliers'] = $suppliers;
	$this->load->view("materials/form_bulk", $data);
	}

	function bulk_update()
	{
	$location = $this->BiSOFT_Model->get_location();
	$materials_to_update = $this->input->post('mat_ids');
	$mat_data = array();

		foreach($_POST as $key=>$value)
		{
			//This field is nullable, so treat it differently
		if($value!='' and !(in_array($key, array('mat_ids'))))
				{ $mat_data["$key"]=$value;}
		}

		//Material data could be empty if tax information is being updated
		if(empty($mat_data) || $this->Material->update_multiple($mat_data,$materials_to_update))
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_successful_bulk_edit')));
		}
		else
		{ echo json_encode(array('success'=>false,'message'=>$this->lang->line('materials_error_updating_multiple')));}
	}


	function delete()
	{
		$materials_to_delete=$this->input->post('ids');

		if($this->Material->delete_list($materials_to_delete))
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_successful_deleted').' '.
			count($materials_to_delete).' '.$this->lang->line('mats_one_or_multiple')));
		}
		else
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('mats_cannot_be_deleted')));
		}
	}
	

	function print_barcode($mat_id=0)
	{
	//	$materials_to_print=$this->input->post('ids');
		$mat_info = $this->Material->get_info($mat_id);
		$barcode  = $this->Label->barcode_bicode_12($mat_info->mat_number);
		$assort 	 = substr($mat_info->mat_number,0,1);

		$supplier = character_limiter($mat_info->supplier,16);
		$name = character_limiter($mat_info->name.','.$mat_info->mat_color,32);
		$width = '';
		$mat_width = $mat_info->mat_width;
		if ( empty($mat_width) or !$mat_width )
			{ $width = '';}
		elseif ( $assort < 4 and $mat_width!=0 )	
			{ $width	= $this->lang->line('mats_width').': '.$mat_width;}
		elseif ( $assort > 3 and $mat_width!=0 )	
			{ $width	= $this->lang->line('mats_size').': '.$mat_width;}

		if ( $assort < 4 ) // само 1,2 и 3 са със топове
				{ $top = $this->lang->line('mats_top').': '; $top_value = 1; $top_weight = $mat_info->top_1.' кг';}
		else 	{ $top = $top_value = $top_weight = '';}

		$data = array(
					'mat_number'=> $barcode, 
					'mat_name'	=> $name,
					'mat_width'	=> $width,
					'mat_top'	=> $top,
					'top_value'	=> $top_value,
					'top_weight'=> $top_weight,
					'supplier'  => $supplier );

	$this->load->view("materials/print_barcode", $data);
	}


/* -------------------------------------------   DO TUK ------------------------------------ */
	//BiSOFT Inventory Tracking
	function save_inventory($mat_id=-1)
	{	
		$location = $this->BiSOFT_Model->get_location();
		$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
		$emp_info=$this->Employee->get_info($employee_id);
		$employee_name=$emp_info->first_name.' '.$emp_info->last_name;
		$cur_mat_info = $this->Material->get_info($mat_id);

		$mode ='balance';
		$mode_id = 'BL';
			if ( $location != 0 )
			{
				$mode = $mode ='shop_balance';
				$mode_id = 'SBL';
			}

		$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
		$doc_date = date('Y-m-d');
		$client_name = $this->lang->line('mats_inventory_change');

		$quantity = $cur_mat_info ? $this->input->post('quantity') - $cur_mat_info->quantity : $this->input->post('quantity');

		$new_qty =  $this->input->post('quantity') - $cur_mat_info->quantity;

		$qty_to_change = $quantity;


		if ( $qty_to_change != 0 )  // записвам само при промяна на количества ...
			{
				// зареждам основните параметри на Главния документ ......
				$docs_data = array(
						'mode'				=> $mode,
						'mode_id'			=> $mode_id,
						'doc_number'		=> $doc_number,
						'doc_date' 			=> $doc_date,
						'total_qty'			=> $quantity,
						'total_sum'			=> 0,
						'total_discount'	=> 0,
						'pay_group'			=> '',
						'pay_type'			=> '',
						'pay_amount'		=> 0,
						'client_id'			=> 0,
						'client'				=> $client_name,
						'employee_id'		=> $employee_id,
						'employee'			=> $employee_name,
						'comment'			=> $this->lang->line('mats_manually_editing_of_quantity'),
						'location'			=> $location );

					// записва в БД Инвентар и си взима номерче ...
					$doc_id = $this->Inventory->insert_docs($docs_data);


				// зареждам параметрите на materials документа ......
					$inv_data = array(
						'doc_id'			=> $doc_id,
						'mat_id'			=> $mat_id,
						'line'			=> 1,
						'mode_id' 		=> $mode_id,
						'doc_number' 	=> $doc_number,
						'doc_date' 		=> $doc_date,
						'mat_number'	=> $this->input->post('mat_number')=='' ? null:$this->input->post('mat_number'),
						'mat_name'		=> $this->input->post('name'),

						'mat_qty'		=> $quantity,
					'mat_unit_price'	=> $this->input->post('unit_price'),

						'client_id'		=> 0,
						'client'			=> $client_name,
						'location'		=> $location );


				// записва в БД Инвентар Артикула ...
				$this->Inventory->insert_docs_materials($inv_data);

			}  // край на '$qty_to_change != 0'

	
		//Update stock quantity
		$mat_data = array(
		'quantity'=> $cur_mat_info->quantity + $this->input->post('newquantity'),
			);

		if($this->Material->save($mat_data,$mat_id))
		{			
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_successful_updating').' '.
			$cur_mat_info->name,'mat_id'=>$mat_id));
		}
		else//failure
		{	
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('mats_error_adding_updating').' '.
			$cur_mat_info->name,'mat_id'=>-1));
		}

	}  //------------------- BiSOFT ---------- //

/* ============================================== ВЕДОМОСТИ ==================================== */
	function edit_vedoms($mode_id=0)
	{
	   $location = $this->BiSOFT_Model->get_location();		
		$user_id  = $this->BiSOFT_Model->get_person();
		$vedom	 = date('Y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$report_data = $this->Material->getVedomData('M'.$vedom,$mode_id);

		$qty_total = 0;
		$tabular_data = array();
		foreach($report_data as $row)
		{	
			$tabular_data[] = array('doc_id'=>$row['doc_id'],'mode_id' => $row['mode_id'] );
			$qty_total += $row['quantity'];
		}
		
		if($mode_id) { $this->mat_lib->set_mode_id($mode_id); }
		
		$vedom_title = $this->lang->line('mats_title_vedom');
		if($mode_id=='dM') {$vedom_title = $this->lang->line('mats_tip_dostavka');}
		elseif($mode_id=='iM') {$vedom_title = $this->lang->line('mats_tip_iskane');}
		elseif($mode_id=='prM') {$vedom_title = $this->lang->line('mats_tip_promat');}
		
		$data = array(
				"controller_name" => strtolower(get_class()),
					"title" 			=> $vedom_title.' - '.$vedom,
					"vedom" 			=> 'M'.$vedom,
					"headers" 		=> $this->Material->getVedomColumns(),
					"data" 			=> $tabular_data,
					"summary_data" => '',
					"qty_total" 	=> $qty_total,
					"user_id" 		=> $user_id,
					"mode_id"		=> $mode_id,
					"location" 		=> $location );

	$this->load->view("materials/view_vedoms", $data);
	}

	// AJAX променя реда ?!
	function get_doc_row()
	{
		$vedom = 'M'.date('Y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$doc_id = $this->input->post('row_id');
		$data_row = get_matdoc_data_row($this->Material->get_document($doc_id,$vedom),$this);
		echo $data_row;
	}


	function edit_document($doc_id=0)
	{
		$location = $this->BiSOFT_Model->get_location();
		$vedom	 = date('Y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$doc_info = $this->Material->get_document($doc_id, 'M'.$vedom);

		$data['location']	= $location;
		$data['user_id']	= $this->BiSOFT_Model->get_person();
		$data['doc_id']	= $doc_id;
		$data['doc_info']	= $doc_info;
		$data['mat_info']	= $this->Material->get_blanka($doc_info->mat_number);

		// вземам си всички ДОСТАВЧИЦИ
		$data['suppliers'] = array('0' => $this->lang->line('reports_edit_nosupplier'));
			foreach ($this->Supplier->get_all()->result() as $supplier)
				{ $data['suppliers'][$supplier->bisoft_id] = character_limiter($supplier->company_name,35);}

		// вземам си всички ПОДИЗПЪЛНИТЕЛИ
		$data['subcont']  = 0;
		$data['subconts'] = array('0' => '-- ИЗБЕРЕТЕ --');
			foreach ($this->Subcont->get_all_subcaonts()->result() as $subcont)
				{ $data['subconts'][$subcont->bisoft_id] = character_limiter($subcont->company_name,35);}				
				
		// вземам си таблицата с асортимента
		$data['assortment'] = array();
			foreach ($this->BiSOFT_Model->get_mat_table()->result() as $assort)
				{ $data['assortment'][$assort->key] = character_limiter($assort->type,35);}

	$this->load->view("materials/form_edit",$data);
	}
	

	function save_edit_doc($doc_id)
	{
		$success  = '-1';
		$location = $this->BiSOFT_Model->get_location();
		$user_id	 = $this->BiSOFT_Model->get_person();
		$del = ($this->input->post('deleted')) ? 1 : 0;
		// период и дати ...
		$vedom	 = date('Y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$period = strtotime( $this->input->post('form_date') );
		$doc_date = date('Y-m-d', $period);
		
		$doc_info = $this->Material->get_document($doc_id, 'M'.$vedom);
		$imat 	 = $doc_info->mat_number;
			$assort = (int) substr($imat,0,1);
			$kgs_lmeter = $this->Material->get_kgs_lmeter($imat);
			$mat_width  = $this->Material->get_matwidth($imat);
		
		$meters 	 = $this->input->post('meters');
		$kgs 		 = $this->input->post('kgs');
		$quantity = $this->input->post('quantity');

		$tops=array();
		$any_change = 0;
		$tops[1]  = (float)$this->input->post('top_1');   $any_change += (float)$doc_info->top_1 - $tops[1];
		$tops[2]  = (float)$this->input->post('top_2');   $any_change += (float)$doc_info->top_2 - $tops[2];
		$tops[3]  = (float)$this->input->post('top_3');   $any_change += (float)$doc_info->top_3 - $tops[3];
		$tops[4]  = (float)$this->input->post('top_4');   $any_change += (float)$doc_info->top_4 - $tops[4];
		$tops[5]  = (float)$this->input->post('top_5');   $any_change += (float)$doc_info->top_5 - $tops[5];
		$tops[6]  = (float)$this->input->post('top_6');   $any_change += (float)$doc_info->top_6 - $tops[6];
		$tops[7]  = (float)$this->input->post('top_7');   $any_change += (float)$doc_info->top_7 - $tops[7];
		$tops[8]  = (float)$this->input->post('top_8');   $any_change += (float)$doc_info->top_8 - $tops[8];
		$tops[9]  = (float)$this->input->post('top_9');   $any_change += (float)$doc_info->top_9 - $tops[9];
		$tops[10] = (float)$this->input->post('top_10');  $any_change += (float)$doc_info->top_10 - $tops[10];
		$tops[11] = (float)$this->input->post('top_11');  $any_change += (float)$doc_info->top_11 - $tops[11];
		$tops[12] = (float)$this->input->post('top_12');  $any_change += (float)$doc_info->top_12 - $tops[12];
		$tops[13] = (float)$this->input->post('top_13');  $any_change += (float)$doc_info->top_13 - $tops[13];
		$tops[14] = (float)$this->input->post('top_14');  $any_change += (float)$doc_info->top_14 - $tops[14];
		$tops[15] = (float)$this->input->post('top_15');  $any_change += (float)$doc_info->top_15 - $tops[15];
		$tops[16] = (float)$this->input->post('top_16');  $any_change += (float)$doc_info->top_16 - $tops[16];
		$tops[17] = (float)$this->input->post('top_17');  $any_change += (float)$doc_info->top_17 - $tops[17];
		$tops[18] = (float)$this->input->post('top_18');  $any_change += (float)$doc_info->top_18 - $tops[18];
		$tops[19] = (float)$this->input->post('top_19');  $any_change += (float)$doc_info->top_19 - $tops[19];
		$tops[20] = (float)$this->input->post('top_20');  $any_change += (float)$doc_info->top_20 - $tops[20];

		$all_kgs = 0;
		$tops_quantity = 0;

		for($k=1;$k<21;$k++)
			{
				$all_kgs += $tops[$k];
				if ($tops[$k] != 0 and !empty($tops[$k])) {$tops_quantity++;}
			}
		
		if ( $assort < 4 ) // значи е ПЛАТ или ХАСТАР ...
			{
			if ( $tops_quantity > 0 ) // имаме топове kg
				{ $quantity = $tops_quantity;
					if ( (empty($meters) or $meters==0) and $kgs > 0 and ($kgs_lmeter > 0 and $mat_width > 0) )
						{
							$meters = round( $kgs / $kgs_lmeter / $mat_width , 1);
						}
					elseif ( $all_kgs > 0 and $kgs_lmeter > 0 and $mat_width > 0 )
						{
							$kgs = $all_kgs;
							$meters = round( $kgs / $kgs_lmeter / $mat_width , 1);
						}
				}  // tops_qty > 0 ...
			}

		if($doc_info->doc_date != $doc_date) {$any_change+=1;}
		$any_change += $del;
		
		if($any_change!=0)
		{
			$doc_data=array(
				  'doc_id' => $doc_id,
				 'doc_date'=> $doc_date,
					'top_1' => ((float)$tops[1]==0) ? '' : $tops[1],
					'top_2' => ((float)$tops[2]==0) ? '' : $tops[2],
					'top_3' => ((float)$tops[3]==0) ? '' : $tops[3],
					'top_4' => ((float)$tops[4]==0) ? '' : $tops[4],
					'top_5' => ((float)$tops[5]==0) ? '' : $tops[5],
					'top_6' => ((float)$tops[6]==0) ? '' : $tops[6],
					'top_7' => ((float)$tops[7]==0) ? '' : $tops[7],
					'top_8' => ((float)$tops[8]==0) ? '' : $tops[8],
					'top_9' => ((float)$tops[9]==0) ? '' : $tops[9],
				  'top_10' => ((float)$tops[10]==0) ? '' : $tops[10],
				  'top_11' => ((float)$tops[11]==0) ? '' : $tops[11],
				  'top_12' => ((float)$tops[12]==0) ? '' : $tops[12],
				  'top_13' => ((float)$tops[13]==0) ? '' : $tops[13],
				  'top_14' => ((float)$tops[14]==0) ? '' : $tops[14],
				  'top_15' => ((float)$tops[15]==0) ? '' : $tops[15],
				  'top_16' => ((float)$tops[16]==0) ? '' : $tops[16],
				  'top_17' => ((float)$tops[17]==0) ? '' : $tops[17],
				  'top_18' => ((float)$tops[18]==0) ? '' : $tops[18],
				  'top_19' => ((float)$tops[19]==0) ? '' : $tops[19],
				  'top_20' => ((float)$tops[20]==0) ? '' : $tops[20],
				'quantity' => $quantity,
				  'meters' => $meters,
					  'kgs' => $kgs,
				 'deleted' => $del );
		
			$success = $this->Material->update_document($doc_data, $doc_id, 'M'.$vedom);
		}

		if($success==1)
		{	// Удачно регистриране ...
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_successful_doc_update').' '.
			$doc_info->doc_number,'doc_id'=>$doc_id));
		}
		elseif($success=='-1') // no change
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('mats_nochange_doc_update').' '.
			$doc_info->doc_number,'doc_id'=>$doc_id));
		}
		else //failure
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('mats_error_doc_update').' '.
			$doc_info->doc_number,'doc_id'=>$doc_id));
		}
	}
	
	function delete_document($vedom=0,$doc_id=0)
	{
	   if($vedom and $doc_id)
      {
         $this->db->trans_start();
            $this->db->delete( $vedom, array('doc_id'=>$doc_id)); 
         $this->db->trans_complete();
      //   return $this->db->trans_status();
		}
		
		$mode_id = $this->mat_lib->get_mode_id();
		$this->edit_vedoms($mode_id);
	}

// -----------------------------------------------------------------------------

	/* ----	get the width for the add/edit form ---- */
	function get_form_width()
	{ return 360;}

	/* ----	get the width for the add/edit form ---- */
	function get_form_full_width()
	{ return 780;}
	
} ?>
