<?php require_once ("Secure_area.php");

class Recvs extends Secure_area
{
	function __construct()
	{
		parent::__construct('Recvs');
		$this->load->library('Recv_lib');
	}

	function index($list='0')
	{
		$this->BiSOFT_Model->clear_user_modes();
		$this->BiSOFT_Model->zebex_delete();
		$this->recv_lib->clear_all();

		$mode_menu = 'recvs';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
	
		$data=array('list'=>$list);
		$this->_reload($data);
	}
	
	function search()
	{
		$barcode_item = $this->input->post("search");
		$data=array();
		$result_success = 'OK';
		$mode = $this->recv_lib->get_mode();

		$exist_item = $this->Item->exists_in_items($barcode_item);
		$location = $this->BiSOFT_Model->get_location();
		$skl=$this->BiSOFT_Model->get_user_mode_client();

		if ($this->recv_lib->is_valid_barcode($barcode_item))
		{  // това ще да е грешка от липса на размер ?!?!?
			if(!$this->recv_lib->add_item_barcode($barcode_item,1))
			{ $data['error']=$this->lang->line('recvs_size_fail');}
		}
		elseif($this->recv_lib->is_valid_item_number($barcode_item) and $exist_item)
		{
			$result_success = $this->recv_lib->add_item($barcode_item,0);
			// проверявам за вид на грешката :
			if ( $result_success != 'OK' )
			{
		   	if ( $result_success == 'S' )
						{ $data['error']=$this->lang->line('sales_size_fail');}
				else	{ $data['error']=$this->lang->line('sales_unable_to_add_item');}
		   }
		}
		elseif(!$exist_item)
		{ $data['error']=$this->lang->line('sales_unable_to_add_item');}

		if( $mode!='recv' and $mode!='manu' )
		{
			$item_id = 0;
			$item_info = $this->Item->get_sklad_info($barcode_item,$skl);
			if($item_info) {$item_id = $item_info->item_id;}
			if($item_id and $this->recv_lib->out_of_stock($item_id))
			{
				if( $mode=='consi_return' or $mode=='recv_return' or $mode=='brak')
				{$data['error'] = $this->lang->line('recvs_quantity_less_than_zero').$skl;}
			}
		}
	
	$this->_reload($data);
	}

	function item_search()
	{
		$suggestions = $this->Item->get_item_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		$suggestions = array_merge($suggestions, $this->Item_kit->get_item_kit_search_suggestions($this->input->post('q'),$this->input->post('limit')));
		echo implode("\n",$suggestions);
	}

	function supplier_search()
	{
	$location = $this->BiSOFT_Model->get_location();
	$mode = $this->BiSOFT_Model->get_user_mode();

		if ($mode == 'consi' or $mode == 'shop_sale' or $mode == 'consi_return')
		{ $suggestions = $this->Consignee->get_consignee_search_suggestions($this->input->post('q'),$this->input->post('limit'));}
		else
		{ $suggestions = $this->Supplier->get_supplier_search_suggestions($this->input->post('q'),$this->input->post('limit'));}

	echo implode("\n",$suggestions);
	}

	function select_supplier()
	{
		$supplier_id = $this->input->post("supplier");
		$this->recv_lib->set_supplier($supplier_id);
	$this->_reload();
	}

	function remove_supplier()
	{
		$this->recv_lib->remove_supplier();
		$this->_reload();
	}


	function select_consignee()
	{
		$consignee_id = $this->input->post("mode_consi");
		$this->recv_lib->set_consignee($consignee_id);
	$this->_reload();
	}


	function remove_consignee()
	{
		$this->recv_lib->remove_consignee();
	$this->_reload();
	}
	
	function select_revision()
	{
		$skl = $this->input->post("mode_rev");
		$this->recv_lib->set_consignee($skl);
	$this->_reload();
	}

	function change_mode()
	{
		$mode = $this->input->post("mode");
		$this->recv_lib->set_mode($mode);
		$this->BiSOFT_Model->set_user_mode($mode);
	$this->_reload();
	}

	function change_category()
	{
		$category = $this->input->post("item_category");
		$this->BiSOFT_Model->set_mode_assort($category);
	$this->_reload();
	}

	function show_hide_DATE()
	{
		if ( !$this->recv_lib->get_dateKey() ) 
				{ $this->recv_lib->set_dateKey(); }
		else	{ $this->recv_lib->clear_dateKey(); }

	$this->_reload();
	}


	function change_YEAR()
	{
		$c_day = date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_month = date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_year = $this->input->post("mode_year");
		  $m_limit = $this->BiSOFT_Model->get_month_limit($c_month,$c_year);
		  if($c_day>$m_limit) {$c_day=$m_limit;}
		  
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);
		$this->BiSOFT_Model->set_user_year($c_year);

	$this->_reload();
	}


	function change_MONTH()
	{
		$c_day = date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_month = $this->input->post("mode_month");
		$c_year = date('y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		  $m_limit = $this->BiSOFT_Model->get_month_limit($c_month,$c_year);
		  if($c_day>$m_limit) {$c_day=$m_limit;}
		  
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);

	$this->_reload();
	}

	function change_DAY()
	{
		$c_day = $this->input->post("mode_day");
		$c_month = date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_year = date('y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		  $m_limit = $this->BiSOFT_Model->get_month_limit($c_month,$c_year);
		  if($c_day>$m_limit) {$c_day=$m_limit;}
		  
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);

	$this->_reload();
	}

	function change_PRICE()
	{
		$mode_price = $this->input->post("mode_price");
		$this->recv_lib->set_mode_price($mode_price);
		$this->BiSOFT_Model->set_user_price($mode_price);
	$this->_reload();
	}


	function change_PRINTON()
	{
		$mode_print = $this->input->post("mode_print");
		$this->recv_lib->set_mode_print($mode_print);
	$this->_reload();
	}


	function set_comment() 
	{
 	  $this->recv_lib->set_comment($this->input->post('comment'));
	}
	
	function set_email_receipt()
	{
 	  $this->recv_lib->set_email_receipt($this->input->post('email_receipt'));
	}

	
	
/* =============================== KITS =============================== */
	function change_kit_mode($kit_mode)
	{
		$this->recv_lib->empty_cart();
		$this->recv_lib->clear_line();
		$this->recv_lib->clear_kit();
		$this->recv_lib->clear_kit_mode();
		
		$this->recv_lib->set_kit_mode($kit_mode);
	$this->_reload();
	}	
	
	function clear_kit()
	{
		$this->recv_lib->clear_kit_mode();
		$this->recv_lib->clear_kit();
	$this->_reload();
	}
	
	function select_kit()
	{
		$this->recv_lib->empty_cart();
		$this->recv_lib->clear_line();
		
		$inum = (int)$this->input->post("kit");
		if(!$inum) { $this->recv_lib->clear_kit(); }
		
		elseif($inum>13000 and $inum<14000 and $this->Item->exists_in_items($inum))
		{
			if(!$this->Item->exists_item_kit($inum)) // NOT exists in item_kits DB ???  
			{
				// NEW EMPTY Record in DB
				$kit_info = $this->Item->get_info_from_sgp($inum);
				$skl_info = $this->Item->get_sklad_info($inum,0);
				if($kit_info)
				{
					$kit_1 = (int)$kit_info->kit_1; if($kit_1<10000 or $kit_1>98000) {$kit_1=0;}
					$kit_2 = (int)$kit_info->kit_2; if($kit_2<10000 or $kit_2>98000) {$kit_2=0;}
					$kit_3 = (int)$kit_info->kit_3; if($kit_3<10000 or $kit_3>98000) {$kit_3=0;}

					$kit_1_data = $kit_2_data = $kit_3_data = $asize_1 = $asize_2 = $asize_3 = 0;
					if($kit_1) { $kit_1_data = $this->Item->get_info_from_sgp($kit_1); $asize_1 = $kit_1_data->allow_sizes; }
					if($kit_2) { $kit_2_data = $this->Item->get_info_from_sgp($kit_2); $asize_2 = $kit_2_data->allow_sizes; }
					if($kit_3) { $kit_3_data = $this->Item->get_info_from_sgp($kit_3); $asize_3 = $kit_3_data->allow_sizes; }
			
					$kit_data = array(
							'inum' => $inum,
							'name' => $kit_info->name,
							 'qty' => 0,
						  'price' => $skl_info->price,
						'price_2' => $skl_info->price_2,
						'price_3' => $skl_info->price_3,
						  'kit_1' => $kit_1,
						 'size_1' => $asize_1,
						  'skl_1' => 0,
						  'kit_2' => $kit_2,
						 'size_2' => $asize_2,
						  'skl_2' => 0,
						  'kit_3' => $kit_3,
						 'size_3' => $asize_3,
						  'skl_3' => 0,
							 'del' => 0 );

					// записва в item_kits		 
					$this->Item->save_item_kit($kit_data, $inum);			
				} // if($kit_info)
			}

 
			// add Комплект: item (13xxx)
			$Qty = array('0'=>'0','1'=>'0','2'=>'0','3'=>'0','4'=>'0','5'=>'0','6'=>'0','7'=>'0','8'=>'0','9'=>'0','10'=>'0');
			$inum_info = $this->Item->get_sklad_info($inum,0);
			$price = $inum_info->price_2; if($inum_info->price_3>0 and $inum_info->price_3<$inum_info->price_2) { $price = $inum_info->price_3; }
			
			$this->recv_lib->add_item( $inum, 0, $price, 0, $Qty );
 
			$this->recv_lib->set_kit($inum);
		} // if($inum>13000 and $inum<14000
		
		
	$this->_reload();
	}

	
/* =============================== KITS End =============================== */		
	
	
	//Alain Multiple Payments
	function add_payment()
	{		
		$data = array();
		$this->form_validation->set_rules( 'amount_tendered', 'lang:recvs_amount_tendered', 'numeric' );
		
		if ( $this->form_validation->run() == FALSE )
		{
			if ( $this->input->post( 'payment_type' ) == $this->lang->line( 'sales_gift_card' ) )
				$data['error']=$this->lang->line('sales_must_enter_numeric_giftcard');
			else
				$data['error']=$this->lang->line('sales_must_enter_numeric');
				
 			$this->_reload( $data );
 			return;
		}
		
		$payment_type = $this->input->post( 'payment_type' );
		if ( $payment_type == $this->lang->line( 'sales_giftcard' ) )
		{
			$payments = $this->recv_lib->get_payments();
			$payment_type = $this->input->post( 'payment_type' ) . ':' . $payment_amount = $this->input->post( 'amount_tendered' );
			$current_payments_with_giftcard = isset( $payments[$payment_type] ) ? $payments[$payment_type]['payment_amount'] : 0;
			$cur_giftcard_value = $this->Giftcard->get_giftcard_value( $this->input->post( 'amount_tendered' ) ) - $current_payments_with_giftcard;
			
			if ( $cur_giftcard_value <= 0 )
			{
				$data['error'] = 'Giftcard balance is ' . to_currency( $this->Giftcard->get_giftcard_value( $this->input->post( 'amount_tendered' ) ) ) . ' !';
				$this->_reload( $data );
				return;
			}

			$new_giftcard_value = $this->Giftcard->get_giftcard_value( $this->input->post( 'amount_tendered' ) ) - $this->recv_lib->get_amount_due( );
			$new_giftcard_value = ( $new_giftcard_value >= 0 ) ? $new_giftcard_value : 0;
			$data['warning'] = 'Giftcard ' . $this->input->post( 'amount_tendered' ) . ' balance is ' . to_currency( $new_giftcard_value ) . ' !';
			$payment_amount = min( $this->recv_lib->get_amount_due( ), $this->Giftcard->get_giftcard_value( $this->input->post( 'amount_tendered' ) ) );
		}
		else
		{
			$payment_amount = $this->input->post( 'amount_tendered' );
		}
		
		if( !$this->recv_lib->add_payment( $payment_type, $payment_amount ) )
		{
			$data['error']='Unable to Add Payment! Please try again!';
		}
		
		$this->_reload($data);
	}

	//Alain Multiple Payments
	function delete_payment( $payment_id )
	{
		$this->recv_lib->delete_payment( $payment_id );
		$this->_reload();
	}

	
	function add($item=0)
	{
		if(!$item) {$barcode_item = $this->input->post("search");}
		else {$barcode_item = $item;}
		
		$data=array();
		$result_success = 'OK';
		$mode = $this->recv_lib->get_mode();

		$exist_item = $this->Item->exists_in_items($barcode_item);
		$location = $this->BiSOFT_Model->get_location();
		$skl=$this->BiSOFT_Model->get_user_mode_client();

		if ($this->recv_lib->is_valid_barcode($barcode_item))
		{  // това ще да е грешка от липса на размер ?!?!?
			if(!$this->recv_lib->add_item_barcode($barcode_item,1))
			{ $data['error']=$this->lang->line('recvs_size_fail');}
		}
		elseif($this->recv_lib->is_valid_item_number($barcode_item) and $exist_item)
		{
			$result_success = $this->recv_lib->add_item($barcode_item,0);
			// проверявам за вид на грешката :
			if ( $result_success != 'OK' )
			{
		   	if ( $result_success == 'S' )
						{ $data['error']=$this->lang->line('sales_size_fail');}
				else	{ $data['error']=$this->lang->line('sales_unable_to_add_item');}
		   }
		}
		elseif(!$exist_item)
		{ $data['error']=$this->lang->line('sales_unable_to_add_item');}

		if( $mode!='recv' and $mode!='manu' and $mode!='macka' )
		{
			$item_id = 0;
			$item_info = $this->Item->get_sklad_info($barcode_item,$skl);
			if($item_info) {$item_id = $item_info->item_id;}
			if($item_id and $this->recv_lib->out_of_stock($item_id))
			{
				if( $mode=='consi_return' or $mode=='recv_return' or $mode=='brak')
				{$data['error'] = $this->lang->line('recvs_quantity_less_than_zero').$skl;}
			}
		}
	
	$this->_reload($data);
	}

/* ----------------------------------------------------------------------- */
	function edit_sale($inum,$line)
	{
		$data['mode'] = $mode = $this->recv_lib->get_mode();
		$data['skl']  = $data['location'] = $this->BiSOFT_Model->get_location();
		$data['inum'] = $inum;
//		$data['line'] = $line;
//		$data['name'] = $this->Item->get_name($inum);
//		$data['cart_info'] = $this->recv_lib->get_cart_item($line);
		$data['skl_info']  = $this->Item->get_sklad_info($inum,$data['skl']);
		$data['item_info'] = $this->Item->get_item_info($inum);
		
		$data['cart_info'] = $cart_info = $this->BiSOFT_Model->zebex_get($inum, $mode);
		$data['line'] = $cart_info->line;
			$data['name'] = $cart_info->name;
			$data['qty'] = $cart_info->qty;
				$data['q1']=$cart_info->q1;$data['q2']=$cart_info->q2;$data['q3']=$cart_info->q3;
				$data['q4']=$cart_info->q4;$data['q5']=$cart_info->q5;$data['q6']=$cart_info->q6;
				$data['q7']=$cart_info->q7;$data['q8']=$cart_info->q8;$data['q9']=$cart_info->q9;
				$data['q10']=$cart_info->q10;
				
			$data['mprice'] = (float)$cart_info->mprice;
			$data['price']  = (float)$cart_info->price;
			$data['dsc'] 	 = (float)$cart_info->dsc;
			$data['inv'] 	 = '';
				
		// Commisions ...		
		$commision=0;
		$consi_info = $this->Consignee->get_info_by_bisoft_id($this->recv_lib->get_consignee());
		if($consi_info)
		{  
			$commision = $consi_info->commision;
			if(empty($commision)) {$commision=0;}
		}
			
		$data['commision'] = $commision;
		
		// събира всички останали dropdowns ...
		$data = $this->Item->get_all_dropdowns($data);
		
		// забрана след плащане ... BLOCK > 0
		$block=round($this->recv_lib->get_payments_total(),0);
		$data['block'] = $block;


	$this->load->view("recvs/form_editsale",$data);
	}
	
	
	function save_edit_item($inum,$line)
	{
		$success = 1; $item_name = '';$allow_sizes=0;
		$skl	= $this->BiSOFT_Model->get_location();
		$mode = $this->recv_lib->get_mode();
		$to_delete = $this->input->post('deleted');
		
		$inv_name = '';
		$data = array();
		if(null !== $this->input->post('inv_name'))
         { $inv_name = $this->input->post('inv_name');}
         
		if($to_delete and $inum) 
		{  // изтрива артикула
			$this->BiSOFT_Model->zebex_delete_item($inum,$mode);
		}
		elseif($inum>0)
		{
			$data = array();
			$mode_price = $this->BiSOFT_Model->get_user_mode_price();

			$skl_info  = $this->Item->get_sklad_info($inum,$skl);
			$cart_info = $this->BiSOFT_Model->zebex_get($inum, $mode);
			if($cart_info)
			{
				$item_name = $cart_info->name;
				$allow_sizes = $cart_info->sizes;
			}

			// ЦЕНИ ---------------------------- //
			$mprice = $this->input->post('mode_price');
			$price  = $this->input->post('price');
			if($mprice=='99') {$price = $this->input->post('price');}
			elseif($mprice=='1') {$price = $skl_info->price;}
			elseif($mprice=='2') {$price = $skl_info->price_2;}
			elseif($mprice=='3') {$price = $skl_info->price_3;}
			elseif($mprice=='4') {$price = $skl_info->price_4;}
			elseif($mprice=='5') {$price = $skl_info->price_5;}
			
			if($mode_price==99) 
				{$this->form_validation->set_rules('price', 'lang:items_price', 'required|numeric');}

			if (!is_numeric($price)) { str_replace(',', '.', $price); $price = round($price,2);}
			$price = abs($price);

			// ОТСТЪПКИ ----------------------- //
			$discount = $this->input->post("discount");
			if ( $discount == '') { $discount = 0;}
			if (!is_numeric($discount)) 
				{ str_replace(',', '.', $discount);
				str_replace('%', '', $discount);}

			// КОЛИЧЕСТВО -------------------------- //
			$this->form_validation->set_rules('quantity', 'lang:items_quantity', 'required|numeric');
			if($allow_sizes)
			{
				if($mode=='balance' or $mode=='revision' or $mode=='kit')
				{
					$q1 = (int)$this->input->post("q1");
					$q2 = (int)$this->input->post("q2");
					$q3 = (int)$this->input->post("q3");
					$q4 = (int)$this->input->post("q4");
					$q5 = (int)$this->input->post("q5");
					$q6 = (int)$this->input->post("q6");
					$q7 = (int)$this->input->post("q7");
					$q8 = (int)$this->input->post("q8");
					$q9 = (int)$this->input->post("q9");
					$q10 = (int)$this->input->post("q10");
				}
				else
				{
					$q1 = (int)abs($this->input->post("q1"));
					$q2 = (int)abs($this->input->post("q2"));
					$q3 = (int)abs($this->input->post("q3"));
					$q4 = (int)abs($this->input->post("q4"));
					$q5 = (int)abs($this->input->post("q5"));
					$q6 = (int)abs($this->input->post("q6"));
					$q7 = (int)abs($this->input->post("q7"));
					$q8 = (int)abs($this->input->post("q8"));
					$q9 = (int)abs($this->input->post("q9"));
					$q10 = (int)abs($this->input->post("q10"));
				}		
				$quantity = $q1+$q2+$q3+$q4+$q5+$q6+$q7+$q8+$q9+$q10;
			}
			else
			{ $quantity = $this->input->post("quantity");
			  $q1=$q2=$q3=$q4=$q5=$q6=$q7=$q8=$q9=$q10=0;
			}

			// при празна бланка изтрива ?!
			if($quantity==0) 
			{ $this->BiSOFT_Model->zebex_delete_item($inum,$mode);} // изтрива артикула
			else
			{
				if ($this->form_validation->run() != FALSE)
					{
						$this->BiSOFT_Model->zebex_edit($mode,$inum,$line,$quantity,$allow_sizes,$price,$mprice,$discount,
															$q1,$q2,$q3,$q4,$q5,$q6,$q7,$q8,$q9,$q10);										
					}
				else
					{ $data['error']=$this->lang->line('recvs_error_editing_item');}

				$item_id = $this->Item->get_sklad_info($inum,$skl)->item_id;
				if($this->BiSOFT_Model->zebex_no_stock($item_id,$mode))
					{
					if( $mode=='consi' or $mode=='recv_return' or $mode=='brak')
						{ $data['warning'] = '#'.$inum.': '.$this->lang->line('recvs_quantity_less_than_zero');}
					}
			} // if($quantity==0)
		} // if to_delete ?	

		$all_qty = $this->BiSOFT_Model->zebex_all_qty($mode);
		$total_suma = $this->recv_lib->get_total($mode,0);
		$amount_due = $this->recv_lib->get_amount_due($mode);

		// AJAX answer ...	
		if($success)
		{			
			echo json_encode(array('success'=>true,
										  'message'=>$this->lang->line('items_successful_updating').' '.$item_name,
										  'amount_due'=>$amount_due,
										  'all_qty'=>$all_qty,
										  'line_id'=>$line )
								  );
		}
		else // failure
		{	
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('items_error_adding_updating').' '.
			$item_name,'line_id'=>-1));
		}
	}
	
	// AJAX
	function get_item_line()
	{
		$line_id = $this->input->post('row_id');
		$mode = $this->recv_lib->get_mode();
		$litem = $this->BiSOFT_Model->zebex_get_line($line_id,$mode);

		if($litem)
			{  
				$item = array(
							'mode' => $litem->mode,
							'line' => $litem->line,
							'inum' => $litem->inum,
							  'id' => $litem->id,
							'name' => $litem->name,
							 'qty' => $litem->qty,
							 
							  'q1' => (!$litem->q1) ? '' : $litem->q1,
							  'q2' => (!$litem->q2) ? '' : $litem->q2,
							  'q3' => (!$litem->q3) ? '' : $litem->q3,
							  'q4' => (!$litem->q4) ? '' : $litem->q4,
							  'q5' => (!$litem->q5) ? '' : $litem->q5,
							  'q6' => (!$litem->q6) ? '' : $litem->q6,
							  'q7' => (!$litem->q7) ? '' : $litem->q7,
							  'q8' => (!$litem->q8) ? '' : $litem->q8,
							  'q9' => (!$litem->q9) ? '' : $litem->q9,
							 'q10' => (!$litem->q10) ? '' : $litem->q10,

							 'skl' => $litem->skl,
						  'price' => $litem->price,
						 'mprice' => $litem->mprice,
							 'dsc' => $litem->dsc,
						  'allow' => $litem->sizes,
									);
			
				$data_row = get_cart_row($item,$this);
				echo $data_row;
			}
		else 
			{	if($this->recv_lib->count_cart()) 
					{ echo '';}
				else 
					{ echo "<tr><td colspan='17'><div class='warning_noitems' style='background-color:rgba(230,230,100,0.35);padding:10px;'>".
							 $this->lang->line('sales_no_items_in_cart')."</div></td></tr>"; 
					}
			}
	}

	function delete_item($item_number)
	{
		$this->recv_lib->delete_item($item_number);
		$this->_reload();
	}

	// ------------------------------------------------- COMPLETE ------------------------------- //
	function complete()
	{
		sleep(0.25);
		$location = $this->BiSOFT_Model->get_location();
		$mode = $this->recv_lib->get_mode();

		// определяме Location ... и Location_id
		if($mode=='shop_sgp') 
		{  
			$location = $this->BiSOFT_Model->get_mode_location();
			$location_id = $location;
		}
		else
		{  
			$location = $this->BiSOFT_Model->get_location();
			$location_id = $this->BiSOFT_Model->get_mode_location();
		}
		$data['location'] = $location;
		
		// ako e КИТ ?
		$kit = 0;
		if($mode=='kit') 
		{
			$kit_mode = $this->recv_lib->get_kit_mode();
			$kit = $this->recv_lib->get_kit();
			if($kit_mode<0) { $kit = -abs($kit); }
			if($kit=='') { $kit = 0; }
			
			if($kit!=0) { $this->Recv->reg_kits($kit); }
		}

		$data['magazin_name'] = '';
		if	( $location != 0 ) 
			{ $data['magazin_name'] = $this->Consignee->get_info_by_bisoft_id($location)->company_name;}
		elseif ( $location == 0 and $mode=='consi')
			{ $data['magazin_name'] = $this->Consignee->get_info_by_bisoft_id($location_id)->company_name;}

		// взима се всичко от кошницата ...
		$data['cart'] = $this->BiSOFT_Model->zebex_get_all($mode);

		$data['subtotal']	= to_currency_no_money($this->recv_lib->get_subtotal($mode));
		$data['total']		= $data['subtotal']; // времено до изчисление на таксите и отстъпките.
		$data['taxed']		= 0;
		$data['tax_VAT']	= 0;
		$data['currency']	= ' лв.'; // $this->config->currency_symbol;
		$data['all_qty']	= $this->recv_lib->get_all_qty();
	 		
		//изтегля и разпределя атрибутите на документа  ..
			$doc_date 	= date('Y-m-d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
			$data['transaction_time']= date('Y-m-d');

			$vedom		= $this->BiSOFT_Model->get_vedom($mode);
			$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
			$doc_name	= $this->BiSOFT_Model->get_document_title($mode);

		$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
		$emp_info=$this->Employee->get_info($employee_id);
		$data['employee']=$emp_info->first_name.' '.$emp_info->last_name;
		$comment = $this->recv_lib->get_comment(); if ($comment==0) { $comment = '';}

		$data['payments']=$this->recv_lib->get_payments();

		// секция : Доставчици / Консигнатори или НИКОЙ според режима на Документа...
		$bisoft_id = 0;
		$supplier_discount = 0;

		if ( $mode=='manu' or $mode=='macka' or $mode=='balance' or $mode=='brak' or $mode=='stock' or $mode=='qtynote') 
				{  $supplier_id = 0; $data['supplier_discount'] = 0;}

		elseif (	$mode=='consi' or
					$mode=='consi_return' or
					$mode=='revision' or	
					$mode=='shop_recv' or
					$mode=='shop_sgp' or 
					$mode=='shop_return') // МАГАЗИН-КОНСИГНАТОР
				{
					$consignee_id 	= $this->recv_lib->get_consignee();
					$bisoft_id 		= $consignee_id;
					$consi_info		= $this->Consignee->get_info_by_bisoft_id($bisoft_id);
						$supplier_discount = $consi_info->discount;
						$supplier_price	 = $consi_info->price_group;
				}

			else  // за всички останали, които искат ДОСТАВЧИК
				{
					$supplier_id = $this->recv_lib->get_supplier();
					if ($supplier_id!=-1)
					{
						$supplier_id = $this->recv_lib->get_supplier();
						$suppl_info=$this->Supplier->get_info($supplier_id);
							$bisoft_id=$suppl_info->bisoft_id;
							$supplier_discount=$suppl_info->discount;
							$supplier_price=$suppl_info->price_group;
					} 
					else { $supplier_discount = 0;}

					$data['total']	= to_currency_no_money($this->recv_lib->get_total($mode,$supplier_discount));
				}

		//SAVE recv to database
		$data['doc_id'] = $this->Recv->save(
													$data['cart'], 
													$mode, 
													$data['all_qty'],
													$kit,
													$data['subtotal'],
													$doc_number, 
													$doc_name,	
													$bisoft_id, // за Доставчик - Консигнатор ...
													$supplier_discount, 
													$employee_id,
													0,
													$comment);
		$doc_id = $data['doc_id'];

		if ($data['doc_id'] == 'doc-1')  // това значи ГРЕШКА ...
			{ $data['error_message'] = $this->lang->line('recvs_transaction_failed');}

		// определяме вида на ВЕДОМОСТТА и ПЕЧАТА...
		$print_type	= $this->recv_lib->get_mode_print();
		$vedomPack	= 'V'.date('ym', strtotime($doc_date));
		$backNoKey	= false;

		$this->recv_lib->clear_all();
		$this->BiSOFT_Model->zebex_delete();
		$this->BiSOFT_Model->clear_user_modes();
			$mode_menu = 'recvs';
			$this->BiSOFT_Model->set_mode_menu($mode_menu);
			
		require_once(APPPATH."plugins/bisoft/blanka_recvs_print.php");
	}
	

	function receipt($doc_id,$vedomPack,$print_type,$mode)
	{
		$recv_info = $this->Recv->get_info($doc_id,$vedomPack,$mode)->row_array();
		$this->recv_lib->copy_entire_recv($doc_id,$vedomPack,$mode);
		$data['mode'] = $mode;

		// определяме Location ... и Location_id
		if ( $mode=='shop_sgp' ) 
			{  $location = $this->BiSOFT_Model->get_mode_location();
				$location_id = $location;
			}
		elseif ( $mode == 'consi' or $mode == 'consi_return') 
			{ 	$location = $this->BiSOFT_Model->get_location();
				$location_id = $recv_info['client_id'];
			} 
		else 
			{ 	$location = $recv_info['location'];
				$location_id = $this->BiSOFT_Model->get_location();
			}
		$data['location'] = $location;

		if	( $location != 0 ) 
			{ $data['magazin_name'] = $this->Consignee->get_info_by_bisoft_id($location)->company_name;}
		elseif ( $location == 0 and ($mode == 'consi' or $mode == 'consi_return') )
			{ $data['magazin_name'] = $this->Consignee->get_info_by_bisoft_id($location_id)->company_name;}

		$data['cart']		= $this->BiSOFT_Model->zebex_get_all($mode); // $this->recv_lib->get_cart();
		$data['subtotal']	= to_currency_no_money($this->recv_lib->get_subtotal());
		$data['total']		= $data['subtotal']; 
		$data['taxed']		= 0;
		$data['tax_VAT']	= 0;
		$data['currency']	= ' лв.'; // $this->config->currency_symbol;
		$data['all_qty']	= $this->recv_lib->get_all_qty();

		//изтегля и разпределя атрибутите на документа  ..
			$vedom		= $this->BiSOFT_Model->get_vedom($mode);
			$doc_name	= $this->BiSOFT_Model->get_document_title($mode);
			$doc_number	= $recv_info['doc_number'];
			$doc_date 	= $recv_info['doc_date'];

		$data['transaction_time']= $recv_info['doc_date'];
		$bisoft_id = $recv_info['client_id'];
		$location_id = $recv_info['location'];
		$comment = $recv_info['comment'];

		$emp_info=$this->Employee->get_info($recv_info['employee_id']);
		$data['employee']	= $recv_info['employee'];
		$data['customer_discount'] = 0;
		$data['total']	= $data['subtotal'];
		$data['payments']=$recv_info['pay_type'];

		// определям ДОСТАВЧИКА или КОНСИГНАТОРА ....
		if ( $mode=='recv' or $mode=='recv_return' or $mode=='stock' or $mode=='protocol')
			{
				if($bisoft_id!=-1 and $bisoft_id!=0)
				{
					$suppl_info=$this->Supplier->get_info_by_bisoft_id($bisoft_id); // тегли от ДОСТАВЧИЦИ
					$data['customer']=$suppl_info->company_person;
					$data['customer_company']=$suppl_info->company_name;
					$data['customer_account_number']=$suppl_info->account_number;
					$data['customer_price']=$suppl_info->price_group;
				}
				else
				{
					$data['customer']='';
					$data['customer_company']='';
					$data['customer_discount']=0;
					$data['customer_account_number']='';
					$data['customer_price']=1;
				}
			} // за D всички видове доставки ...

		elseif ( $mode=='consi' or 
					$mode=='consi_return' or
					$mode=='shop_sgp' or
					$mode=='shop_recv' or 
					$mode=='shop_return' or 
					$mode=='revision')
			{
				if($bisoft_id > 0)
				{  // тегли от КОНСИГНАТОРИ
					$consi_info=$this->Consignee->get_info_by_bisoft_id($bisoft_id);  
					$data['customer']=$consi_info->company_person;
					$data['customer_company']=$consi_info->company_name;
					$data['customer_account_number']=$consi_info->account_number;
					$data['customer_price']=$consi_info->price_group;
				}	// за C, BC, R - от консигнатори ...
				else
				{
					$data['customer']='';
					$data['customer_company']='';
					$data['customer_discount']=0;
					$data['customer_account_number']='';
					$data['customer_price']=1;
				}
			} 
		elseif ( $mode=='offer' or $mode=='proforma' )
			{
				if($bisoft_id!=-1 and $bisoft_id!=0)
				{
					$cust_info=$this->Customer->get_info_by_bisoft_id($bisoft_id); // тегли от КЛИЕНТИ
					$data['customer']=$cust_info->company_person;
					$data['customer_company']=$cust_info->company_name;
					$data['customer_account_number']=$cust_info->account_number;
					$data['customer_price']=$cust_info->price_group;
				}
				else
				{
					$data['customer']='';
					$data['customer_company']='';
					$data['customer_discount']=0;
					$data['customer_account_number']='';
					$data['customer_price']=1;
				}
			} // за Of & PF  всички оферти и даже проформи ...

		else
			{
					$data['customer']='';
					$data['customer_company']='';
					$data['customer_discount']=0;
					$data['customer_account_number']='';
					$data['customer_price']=1;
			} // за всичко останало ...


			$data['customer_discount'] = 0;

			$customer_discount = $recv_info['total_discount'];

			if ( $bisoft_id > 0 and $customer_discount != 0) 
				{ $data['customer_discount'] = $customer_discount;}

		$data['total']	= to_currency_no_money($this->recv_lib->get_total($mode,$customer_discount));
		// край на определянето на КЛИЕНТА / ДОСТАВЧИКА или КОНСИГНАТОРА ....

		$data['receipt_name'] 	= $doc_name;
		$data['receipt_number'] = $doc_number;
		$data['receipt_date'] 	= date('d.m.Y', strtotime($data['transaction_time']));
		$data['print_date'] 		= date('H:i / d.m.Y', strtotime($recv_info['date_start']));
		$data['bisoft_id'] 		= $bisoft_id;
		$data['vedomPack'] 		= 'V'.date('ym', strtotime($doc_date));
		$data['comment']	 		= $comment;

		if ($print_type == 'sizes_prices') { $data['allow_prices'] = 1;}
		
		$data['controller_name']=strtolower(get_class());
	
		if ($print_type=='prices') { $this->load->view("bisoft/blanka_prices",$data);}
		elseif ($print_type=='offers') { $this->load->view("bisoft/blanka_offer",$data);}
		else { $this->load->view("bisoft/blanka_sizes",$data);}		

	$this->recv_lib->clear_all();
	$this->BiSOFT_Model->clear_user_modes();
	}
	

	function print_to($mode)
	{ // тук трябва да е друго нещо ...
		$this->complete();

	}


	function edit($doc_id,$vedomPack,$print_type,$mode)
	{
		$data = array();
		$data['vedomPack'] = $vedomPack;
		$data['print_type'] = $print_type;

		$data['doc_info'] = $this->Recv->get_info($doc_id,$vedomPack)->row_array();
		$data['type_docs'] = array(
         'manu'	=> $this->lang->line('recvs_manufacturing'),
         'kit'		=> $this->lang->line('recvs_kits'),
         'stock'	=> $this->lang->line('recvs_stock') );
         
		$data['mode'] = $data['doc_info']['mode'];
		$client_id = $data['doc_info']['client_id'];
		$supplier_id = $data['doc_info']['supplier_id'];
		$data['location'] = $location = $data['doc_info']['location'];
		$data['supplier_id'] = 0;
		
		if ( $mode=='recv' or $mode=='recv_return')
			{	// вземам всички ДОСТАВЧИЦИ
				$data['supplier_id'] = $supplier_id;
				$data['suppliers'] = array('' => $this->lang->line('reports_edit_nosupplier'));
				foreach ($this->Supplier->get_all()->result() as $supplier)
					{ $data['suppliers'][$supplier->bisoft_id] = character_limiter($supplier->company_name,45);}
					
				$data['type_docs'] = array(
					'recv'		  	=> $this->lang->line('recvs_receiving'),
					'recv_return' 	=> $this->lang->line('recvs_return'),
					'protocol'		=> $this->lang->line('recvs_protocol'),
					
					'stock'	  		=> $this->lang->line('recvs_stock') );
			}
		elseif ( $mode=='manu' or $mode=='macka' )
			{
				$data['type_docs'] = array(
						'manu' => $this->lang->line('recvs_manufacturing'),
			         'macka'=> $this->lang->line('recvs_macka'),	);	
			}
		elseif ( $mode=='consi' or $mode=='consi_return' )
			{
				// вземам всички КОНСИГНАТОРИ
				$data['suppliers'] = array();
				foreach ($this->Consignee->get_all()->result() as $consignee)
					{ $data['suppliers'][$consignee->bisoft_id] = character_limiter($consignee->company_name,45);}
					
				$data['type_docs'] = array(
					'consi'		  	=> $this->lang->line('recvs_consignation'),
					'consi_return'	=> $this->lang->line('recvs_return_consi'),
					'revision'	  	=> $this->lang->line('recvs_revision')	);	
			}
		elseif ( $mode=='offer' or $mode=='proforma' )
			{
				// вземам всички КЛИЕНТИ
				$data['supplier_id'] = $client_id;
				$data['suppliers'] = array('' => $this->lang->line('reports_edit_noclient'));
				foreach ($this->Customer->get_all()->result() as $customer)
				 { $data['suppliers'][$customer->bisoft_id] = character_limiter($customer->company_name,45);}
				 
				$data['type_docs'] = array(
					'protocol'		=> $this->lang->line('recvs_protocol'),
					'stock'	  		=> $this->lang->line('recvs_stock'),
					'offer'	  		=> $this->lang->line('recvs_offer') );	
			}
		elseif ( $mode=='balance' or $mode=='kit')
			{
            $data['type_docs'] = array( 'balance' => $this->lang->line('recvs_balance'),'kit'=> $this->lang->line('recvs_kit') );
				// вземам всички КЛИЕНТИ, КОНСИГНАТОРИ или ДОСТАВЧИЦИ
				
            if($supplier_id)
               {  // вземам всички ДОСТАВЧИЦИ
						$data['supplier_id'] = $supplier_id;
                  $data['suppliers'] = array('' => $this->lang->line('reports_edit_nosupplier'));
                  foreach ($this->Supplier->get_all()->result() as $supplier)
                     { $data['suppliers'][$supplier->bisoft_id] = character_limiter($supplier->company_name,45);}
               }
            elseif($client_id)
               {  // вземам всички КЛИЕНТИ
						$data['supplier_id'] = $client_id;
                  $data['suppliers'] = array('' => $this->lang->line('reports_edit_noconsi'));
                  foreach ($this->Customer->get_all()->result() as $customer)
							{ $data['suppliers'][$customer->bisoft_id] = character_limiter($customer->company_name,45);}
               }
            else
               {  // вземам всички КОНСИГНАТОРИ
						$data['supplier_id'] = $location;
                  $data['suppliers'] = array('' => $this->lang->line('reports_edit_noconsi'));
						foreach ($this->Consignee->get_all()->result() as $consignee)
							{ $data['suppliers'][$consignee->bisoft_id] = character_limiter($consignee->company_name,45);}
					}
			}

		// вземам си всички ОПЕРАТОРИ
		$data['employees'] = array();
		foreach ($this->Employee->get_operators()->result() as $employee)
			{ $data['employees'][$employee->person_id] = $employee->first_name .' '. $employee->last_name;}
			
	$this->load->view('recvs/edit', $data);
	}


	function save($doc_id, $vedomPack, $mode)
	{
		$doc_date = $this->input->post('doc_date');
		$vedomPack_new	= 'V'. date('ym', strtotime($doc_date));

		$employee_id 	= $this->input->post('employee_id');
		$employee	 	= $this->Employee->get_info($employee_id)->first_name
							 .' '. $this->Employee->get_info($employee_id)->last_name;
							 
		$client = $supplier = '';
		$client_id = $supplier_id = $location = $this->input->post('supplier_id') ? $this->input->post('supplier_id') : 0;
		if($client_id)
		{ 
			if($mode == 'recv' or $mode == 'recv_return')
				{ $supplier = $this->Supplier->get_info_by_bisoft_id($this->input->post('supplier_id'))->company_name;
              $client_id = $location = 0;
            }
			elseif($mode == 'consi' or $mode == 'consi_return')
				{ $client = $this->Consignee->get_info_by_bisoft_id($this->input->post('supplier_id'))->company_name;
				  $supplier_id=0;
				}
			elseif ($mode == 'offer')
				{ $client = $this->Customer->get_info_by_bisoft_id($this->input->post('supplier_id'))->company_name;
				  $supplier_id=$location=0;
				}
			elseif ($mode == 'balance')
				{ $client = $this->Customer->get_info_by_bisoft_id($this->input->post('supplier_id'))->company_name;
				  $location = $supplier_id = 0;
            }
			else
				{ $supplier = $this->Supplier->get_info_by_bisoft_id($this->input->post('supplier_id'))->company_name;
              $client_id = $location = 0;
            }
		}
	
		$taxed = 0;

		$mode =  $this->input->post('type_doc');
		$mode_id = $this->BiSOFT_Model->get_pay_group( $mode );
		$line_id = date('ym', strtotime($doc_date)).str_pad($doc_id, 4, "0", STR_PAD_LEFT);
		
		$total_sum 	 = $this->input->post('total_sum');
		$total_taxes = 0;
		$pay_amount  = $this->input->post('pay_amount');

		$doc_data = array(
			'doc_date' 		=> date('Y-m-d', strtotime($doc_date)),
			'mode' 			=> $mode,
			'mode_id' 		=> $mode_id,
			'client_id' 	=> $client_id,
			'client' 		=> $client,
			'supplier_id' 	=> $supplier_id,
			'supplier' 		=> $supplier,
			'total_qty' 	=> $this->input->post('total_qty'),
			'total_sum' 	=> $total_sum,
		'total_discount'	=> $this->input->post('total_discount'),
			'pay_amount'	=> $pay_amount,
			'pay_date'		=> null,
			'employee_id' 	=> $employee_id,
			'employee' 		=> $employee,
			'location' 		=> $location,
			'comment' 		=> $this->input->post('comment') );

		$items_data = array(
			'doc_date' 		=> date('Y-m-d', strtotime($doc_date)),
			'mode_id' 		=> $mode_id,
			'item_taxes' 	=> $taxed,
			'client_id' 	=> $client_id,
			'supplier_id' 	=> $supplier_id,
			'location' 		=> $location );

		/* ============================    ========================= */
		if ($vedomPack==$vedomPack_new)
		{  // действа САМО при ДАТА в същия месец //
			// актуализира items ...
			$vedomItems = $vedomPack.'_items';
			$this->Recv->update_items($items_data, $doc_id, $vedomItems);

			if($this->Recv->update($doc_data, $doc_id, $vedomPack))
				{ echo json_encode(array(	'success'=>true,
													'line_id'=>$line_id,
													'mode_id'=>$mode_id,
													'total'=>to_dot($total_sum),
													'taxes'=>to_dot($total_taxes),
													'amount'=>to_dot($pay_amount),
													'message'=> 'За да актуализирате общите сборове, моля освежете страницата - REFRESH !!!' )
										);
				}
			else
				{ echo json_encode(array(	'success'=>false,
													'line_id'=>$line_id,
													'mode_id'=>$mode_id,
													'message'=>$this->lang->line('recvs_unsuccessfully_updated') )
										 );
				}
		}
	else // действа САМО при промяна на ДАТА //
		{
			// актуализира items ...
			$vedomItems = $vedomPack.'_items';
			$this->Recv->update_items($items_data, $doc_id, $vedomItems);

			// премества items ...
			$vedomItems_new = $vedomPack_new.'_items';
			$this->BiSOFT_Model->set_user_date(date('Y-m-d H:i:s',strtotime($doc_date)));
			$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
			$doc_data['doc_number'] = $doc_number;

			$this->db->trans_start();
				$this->db->insert( $vedomPack_new, $doc_data);
				$newdoc_id = $this->db->insert_id();

				$old_item_data = $this->Recv->get_recv_items($doc_id,$vedomPack,$mode);
				foreach($old_item_data->result_array() as $line=>$item)
					{
						$item['doc_id'] = $newdoc_id;
						$item['doc_number'] = $doc_number;
						$item['doc_date'] = date('Y-m-d', strtotime($doc_date));
						$this->db->insert($vedomItems_new,$item);
					}
			$this->db->trans_complete();

			if($this->delete($doc_id,$vedomPack)) // маха всичко старо //
				{ echo json_encode(array(	'success'=>true,
													'line_id'=>$line_id,
													'mode_id'=>$mode_id,
													'message'=>$this->lang->line('sales_successfully_moved') )
										);
				}
			else
				{ echo json_encode(array(  'success'=>false,
													'line_id'=>$line_id,
													'mode_id'=>$mode_id,
													'message'=>$this->lang->line('recvs_unsuccessfully_updated') )
										);
				}
		}

	} // край
	

	function delete($doc_id,$vedomPack)
	{
		$data = array();
		if ($this->Recv->delete($doc_id,$vedomPack))
			{ $data['success'] = $this->lang->line('sales_delete_successful');}
		else
			{ $data['error'] = $this->lang->line('sales_delete_unsuccessful');}

	$this->load->view('recvs/delete', $data);
	}
	
	
	// ================= AJAX edit vedom line ... ======================== //
	function edit_line_item($doc_idx)
	{
		$line   = (int)substr($doc_idx,-3);
		$doc_id = (int)substr($doc_idx,0,-7);
		$vedom  = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom;

		$data = array();
		$data['user_id']	 = $this->BiSOFT_Model->get_person();
		$data['vedomPack'] = $vedomPack;
		$data['line'] = $line;
		$data['doc_idx'] 	 = $doc_idx;
		$data['item_info'] = $item_info = $this->BiSOFT_Model->get_doc_item($doc_idx);
		$data['location']  = $location  = $item_info->location;

		// събира всички останали dropdowns ...
		$data = $this->Item->get_all_dropdowns($data);

	$this->load->view('recvs/edit_line_item', $data);
	}


	function save_line_item($doc_idx)
	{
		$line   = (int)substr($doc_idx,-3);
		$doc_id = (int)substr($doc_idx,0,-7);
		$vedom  = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom;
			
		$to_delete = $this->input->post('deleted');
		$inum = $this->input->post('item_number');
		$allow_sizes = $this->Item->get_allow_sizes($inum);

		$item_qty = $this->input->post('item_qty');
		$q1 = $q2 = $q3 = $q4 = $q5 = $q6 = $q7 = $q8 = $q9 = $q10 = '';
		$item_name = '';

		if($allow_sizes) 
			{	 
				$q1 = ($this->input->post('qty_1')!=0) ? $this->input->post('qty_1') : '';
				$q2 = ($this->input->post('qty_2')!=0) ? $this->input->post('qty_2') : '';
				$q3 = ($this->input->post('qty_3')!=0) ? $this->input->post('qty_3') : '';
				$q4 = ($this->input->post('qty_4')!=0) ? $this->input->post('qty_4') : '';
				$q5 = ($this->input->post('qty_5')!=0) ? $this->input->post('qty_5') : '';
				$q6 = ($this->input->post('qty_6')!=0) ? $this->input->post('qty_6') : '';
				$q7 = ($this->input->post('qty_7')!=0) ? $this->input->post('qty_7') : '';
				$q8 = ($this->input->post('qty_8')!=0) ? $this->input->post('qty_8') : '';
				$q9 = ($this->input->post('qty_9')!=0) ? $this->input->post('qty_9') : '';
				$q10 = ($this->input->post('qty_10')!=0) ? $this->input->post('qty_10') : '';
				
				$item_qty = (int)$q1 + (int)$q2 + (int)$q3 + (int)$q4 + (int)$q5 + 
								(int)$q6 + (int)$q7 + (int)$q8 + (int)$q9 + (int)$q10;
				
				$item_name = $item_qty.','.$q1.','.$q2.','.$q3.','.$q4.','.$q5.
											  ','.$q6.','.$q7.','.$q8.','.$q9.','.$q10;
			}
				
			$items_data = array(
						'doc_id' => $doc_id,
						  'line' => $line,
				 'item_number' => $inum,
			'item_unit_price' => (float)$this->input->post('item_unit_price'),
			  'item_discount' => (int)$this->input->post('item_discount'),
					 'costsale' => (float)$this->input->post('costsale'),
					 'item_qty' => $item_qty,
					'item_name' => $item_name,
					  'deleted' => $to_delete );

		if ($this->BiSOFT_Model->update_line_item($items_data,$doc_idx))
			{
				$calc_data = $this->BiSOFT_Model->recalc_document($doc_idx);
			
				echo json_encode(array(
					'success'	=> true,
					'doc_row'	=> $doc_id.$vedom,
					'line'		=> $line,
					'line_id'	=> $doc_id.$vedom.str_pad($line, 3, "0", STR_PAD_LEFT),
					
					'qty_doc'   => $calc_data['qty_doc'],
					'sum_doc'   => $calc_data['sum_doc'],
					'all_doc'   => $calc_data['all_doc'],
					'tax_doc'   => $calc_data['tax_doc'],
				  'amount_doc' => $calc_data['amount_doc'],
					'cost_doc'  => $calc_data['cost_doc'],
					
					'total_qty' => $calc_data['total_qty'],
					'total_vat' => $calc_data['total_vat'],				
					'total_sum' => $calc_data['total_sum'],				
				  'total_cost' => $calc_data['total_cost'],				
					
					'message'	=> 'арт.'.$inum.' ... '.$this->lang->line('reports_edit_line_success')));
			}
		else
			{ 	echo json_encode(array(
					'success'	=> false,
					'doc_row'	=> $doc_id.$vedom,
					'line'		=> $line,			
					'message'	=> $this->lang->line('reports_edit_line_unsuccess')));
			}
	}

	function get_document_row()
	{
		$doc_idx = $this->input->post('row_id');
		$line    = (int)substr($doc_idx,-3);
		$doc_id  = (int)substr($doc_idx,0,-7);
		$vedom   = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom;
			
		$item_info = $this->BiSOFT_Model->get_doc_item($doc_idx);
		$allow_sizes = $this->Item->get_allow_sizes($item_info->item_number);
		if($item_info->deleted == 0)
			{
				$Qty = array();
				if($allow_sizes)
					{ $Qty = explode(',',$item_info->item_name); }
				else 
					{ $Qty[1]=$Qty[2]=$Qty[3]=$Qty[4]=$Qty[5]=$Qty[6]=$Qty[7]=$Qty[8]=$Qty[9]=$Qty[10]=0;
					  $Qty[0]=$item_info->item_qty;}

				$rqty_1 = $Qty[1]; if(!$rqty_1) {$rqty_1 = '';}
				$rqty_2 = $Qty[2]; if(!$rqty_2) {$rqty_2 = '';}
				$rqty_3 = $Qty[3]; if(!$rqty_3) {$rqty_3 = '';}
				$rqty_4 = $Qty[4]; if(!$rqty_4) {$rqty_4 = '';}
				$rqty_5 = $Qty[5]; if(!$rqty_5) {$rqty_5 = '';}
				$rqty_6 = $Qty[6]; if(!$rqty_6) {$rqty_6 = '';}
				$rqty_7 = $Qty[7]; if(!$rqty_7) {$rqty_7 = '';}
				$rqty_8 = $Qty[8]; if(!$rqty_8) {$rqty_8 = '';}
				$rqty_9 = $Qty[9]; if(!$rqty_9) {$rqty_9 = '';}
				$rqty_10 = $Qty[10]; if(!$rqty_10) {$rqty_10 = '';}
			
				$item=array(
				 'controller' => 'Recvs',
					  'vedom'  => $vedom,
				    'mode_id' => $item_info->mode_id,
					  'doc_id' => $doc_id,
						 'line' => $line,
						 'inum' => $item_info->item_number,
					   'price' => $item_info->item_unit_price,
						  'qty' => $item_info->item_qty,
						  'dsc' => $item_info->item_discount,
						  'tax' => $item_info->item_taxes,
					'costsale' => $item_info->costsale,
							'q1' => $rqty_1,
							'q2' => $rqty_2,
							'q3' => $rqty_3,
							'q4' => $rqty_4,
							'q5' => $rqty_5,
							'q6' => $rqty_6,
							'q7' => $rqty_7,
							'q8' => $rqty_8,
							'q9' => $rqty_9,
						  'q10' => $rqty_10 );

				$data_row = get_vedom_row( $item , 'Recvs' );
				echo $data_row;
			}
			else {echo '';}
	}
	
	
	function _payments_cover_total()
	{
		$total_payments = 0;
		$mode = $this->recv_lib->get_mode();
		foreach($this->recv_lib->get_payments() as $payment)
		 { $total_payments += $payment['payment_amount'];}

		/* Changed the conditional to account for floating point rounding */
		if ( ( $this->recv_lib->get_mode() == 'recv' ) && ( ( to_currency_no_money( $this->recv_lib->get_total($mode,0) ) - $total_payments ) > 1e-6 ) )
		{ return false;}	
	return true;
	}

	
    function cancel_recv()
    {
		$this->load->model('Revision');
		$this->Revision->delete_all_revision();

		$mode = $this->recv_lib->get_mode();
		$this->BiSOFT_Model->zebex_clear_all($mode);
		$this->recv_lib->clear_all();
		$this->_reload();
    }


// ------------------------------ DELIVERED MODULE -------------------------------- //
	function deliver()  // suspend = analog
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $this->recv_lib->get_mode();

		$data['cart']		= $this->recv_lib->get_cart();
		$data['subtotal']	= to_currency_no_money($this->recv_lib->get_subtotal());
		$data['total']		= to_currency_no_money($this->recv_lib->get_total($mode,0));
		$data['currency']	= ' лв.'; // $this->config->currency_symbol;
		$data['all_qty']	= $this->recv_lib->get_all_qty();
		$data['mode']		= $mode;
		$data['location'] = $location;

		//изтегля и разпределя атрибутите на документа  ..
			$doc_date 	= date('Y-m-d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
			$vedom		= $this->BiSOFT_Model->get_vedom($mode);
			$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
			$doc_name	= $this->BiSOFT_Model->get_document_title($mode);


		$data['transaction_time']= date('Y-m-d');

		$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
		$emp_info=$this->Employee->get_info($employee_id);
		$data['employee']=$emp_info->first_name.' '.$emp_info->last_name;

		$comment = $this->input->post('comment');	
			if ($comment==0) { $comment = '';}

		$consignee_id = $this->recv_lib->get_consignee();
		$bisoft_id = 0;

		if($consignee_id!=-1)
		{
			$consi_info=$this->Consignee->get_info($consignee_id);
			$bisoft_id=$consi_info->bisoft_id;
			$data['consignee']=$consi_info->company_person;
			$data['consignee_company']=$consi_info->company_name;
			$data['consignee_discount']=$consi_info->discount;
			$data['consignee_account_number']=$consi_info->account_number;
		} 
		else { $data['consignee_discount'] = 0;}

		$consignee_discount = $data['consignee_discount'];

		//SAVE recv to database
		$data['doc_id'] = $this->Delivered->save(
													$data['cart'], 
													$mode, 
													$data['all_qty'], 
													$data['subtotal'],
													$doc_number, 
													$doc_name,	
													$bisoft_id, 
													$data['consignee_discount'], 
													$employee_id, 
													'', 
													$comment);

		if ($data['doc_id'] == 'doc-1')
		{ $data['error_message'] = $this->lang->line('recvs_transaction_failed');}

	$this->recv_lib->clear_all();
	$this->_reload(array('success' => $this->lang->line('recvs_successful_delivery')));
	}

	function delivered()  // само показва в таблицата ... from suspended
	{
		$data = array();
		$data['location'] = $this->BiSOFT_Model->get_location();
		$data['delivered'] = $this->Delivered->get_all()->result_array();
	$this->load->view('recvs/delivered', $data);
	}
	
	function view_delivered($doc_id) // НЕ-Освобождава, само ГЛЕДА
	{
		$this->recv_lib->clear_all();
		$this->recv_lib->copy_entire_delivered_table($doc_id);
		$data['view'] = 1;
  	$this->_reload($data);
	}

	function undeliver() // освобождава и изтрива ... unsuspend
	{
		$doc_id = $this->input->post('delivered_doc_id');
		$this->recv_lib->clear_all();
		$this->recv_lib->copy_entire_delivered_table($doc_id);
		$this->Delivered->delete($doc_id);
  	$this->_reload();
	}

// ------------------------------ OLD BiSOFT DELIVERY MODULE -------------------------------- //

	function bisoft_delivery()
	{
		$this->load->view("recvs/bisoft_delivery", null);
	}


	function do_bisoft_delivery()  // from delivered временно ...
	{
		$msg = 'do_bisoft_delivery';
		$failCodes = array();
		$location = $this->BiSOFT_Model->get_location();
		$view_path = 'recvs/_reload';
		$mode = $this->recv_lib->get_mode();

		// get BiSOFT path
		$this->CI =& get_instance();
		$bisoft_path = $this->CI->BiSOFT_Model->get_path();

		$this->load->library('spreadsheetexcelreader');
      $this->spreadsheetexcelreader->setOutputEncoding('CP1251'); // Set output Encoding

			$quantity = 1;

		$myDelivery = '_D' . $location . '.bls';
		$sRoot = $_SERVER['DOCUMENT_ROOT'];
		$bls_to_read = $sRoot.'/'.$bisoft_path.'/'.$myDelivery;


	// Load from BiSOFT ....
		if (!is_readable($bls_to_read))
			{ // ГРЕШКА - връщаме се в началото на controller-a ...
				$msg = $this->lang->line('common_error_import');
				$data['error'] = $msg;
				$this->refresh($data);
			}

		else 
		{ // тук вече зарежда нормално от BiSOFT доставката ... - >

			$data_file = new Spreadsheetexcelreader($bls_to_read, false);
			$rowCount = $data_file->rowcount(0);
			$qty=array();

			if($rowCount > 1)
			{  // #2 if row > 1

				for($i = 2; $i <= $rowCount; $i++) 
				{  // #3 for i=1 and on ...

				$doc_number 	= intval( $data_file->val($i, 'A') );
				$doc_date 		= $data_file->val($i, 'B');
				$item_number	= $data_file->val($i, 'C');
				$item_name		= $data_file->val($i, 'D');
				$item_size		= $data_file->val($i, 'E');
				$quantity		= $data_file->val($i, 'F');
				$item_price		= $data_file->val($i, 'G');
				$item_discount	= $data_file->val($i, 'H'); if (empty($item_discount)) {$item_discount = 0;}

					$qty[1]=$qty[2]=$qty[3]=$qty[4]=$qty[5]=$qty[6]=$qty[7]=$qty[8]=$qty[9]=$qty[0] = 0;

					if ($item_size > 9)	{ $item_size = 0;}

					if ($item_size != 0)	{ $qty[$item_size] = $quantity;}

				$mode_id			= $data_file->val($i, 'L');
				$mode				= $this->BiSOFT_Model->get_mode_symbol($mode_id);
				$client_id		= intval( $data_file->val($i, 'M')); // много ВАЖНО Определям Клиента кой е .

					// adds items to cart
					$result = $this->recv_lib->add_item( 
												$item_number, 
												$quantity, 
												$item_price, 
												$item_discount,
	
								$qty[1], $qty[2], $qty[3], $qty[4], $qty[5],
								$qty[6], $qty[7], $qty[8], $qty[9], $qty[0]);


					if(!$result) {	$failCodes[] = $item_number;}

				}  // #3 for i=1

			}  // #2 if row > 1


		} // тук вече ... else statement

		$success = true;
		if(count($failCodes) > 1)
		{ 	
				$msg = $this->lang->line('recvs_error_import') . count($failCodes) ."): ".implode(", ", $failCodes);
				$success = false;
				$data['error'] = $msg;
			}
		else 
			{
				$msg = $this->lang->line('recvs_successful_import').' BiSOFT Old Format';
				$data['success'] = $msg;
			}

	$this->_reload(null);
	}



// ------------------------------ RECV SETTINGS MODULE -------------------------------- //

	function recvs_settings_box_view()
	{
		$this->load->view("recvs/settings_box", null);
	}



	function recvs_settings()
	{


	}


// ==================== START TABLE (Zebex) Import ==================== //
	function zebex_select()
	{
		header("Location: http://127.0.0.1/.read_serial.php");die();
	}
	
	function zebex_import()
	{
		$this->load->view("recvs/zebex_import", null);
	}

	function do_zebex_import()
	{
		$msg = 'do_zebex_import';
		$data = array();
		$failCodes = array();
		$successCode = array ();
		$success = 1;
		$mode = $this->recv_lib->get_mode();
		$mprice = $this->recv_lib->get_mode_price();

		if ($_FILES['file_path']['error']!=UPLOAD_ERR_OK)
		{
			$msg = $this->lang->line('recvs_file_failed');
			$data['error'] = $msg;
			$this->_reload($data);
		}
		else
		{
			if (($handle = fopen($_FILES['file_path']['tmp_name'], "r")) !== FALSE)
			{
				if($mode!='revision') // при всички $modes
				{
					$i=1;$line=1;
					while (($data = fgetcsv($handle)) !== FALSE) 
					{
						$item_code = trim($data[0]);
						$success *= $this->BiSOFT_Model->zebex_add_barcode($item_code,$line,$mode,$mprice);
						$i++;
					}
					$this->recv_lib->set_line($line);
				}
// ================== Revision ZEBEX Import ====================== //
				else // само за РЕВИЗИИ
				{
				  $skl = $this->recv_lib->get_consignee();

				  require_once(APPPATH."plugins/recv/revision_sklad.php");
				  require_once(APPPATH."plugins/recv/revision_zebex.php");
				  require_once(APPPATH."plugins/recv/revision_result.php");

				} // end of Revisions
// ================== END Revision ZEBEX Import ====================== //

			}
			else 	
			{				
				$msg = $this->lang->line('recvs_file_failed');
				$data['error'] = $msg;
				$this->_reload($data);
			}
		}
		
	  if(count($failCodes) > 1)
	  { 	
			$msg = $this->lang->line('recvs_error_import') . count($failCodes) ."): ".implode(", ", $failCodes);
			$data['error'] = $msg;
	  }
	  elseif($success)
	  {
			$msg = $this->lang->line('recvs_successful_import').' Zebex';
			$data['success'] = $msg;
	  }

	$this->_reload($data);
	}
	
	
	function revision_to_excel($consi_id)
	{
      $data = array();
      if($consi_id)
      {
         $zebex_data = $this->BiSOFT_Model->zebex_get_revision();
         if($zebex_data)
         {
         // $excData = '';
            $data = array(
                  'mode' => 'revision',
            'controller' => 'Home',
                  'cart' => $zebex_data,
          'receipt_name' => 'РЕВИЗИЯ',
          'magazin_name' => $consi_id,
        'receipt_number' => '',
          'receipt_date' => date("d.m.Y"),
             'bisoft_id' => $consi_id,
            
            

                        );
/*
            foreach($zebex_data as $row)
            {
             //  print_r($row);
             //  echo '<br>';
            
               $name = str_replace(array('=', ';', ':', '-', '@', '\'', ',', '/', '|', '\\', '%', '^',
                                      '#', '"', '&', '!', '$', '*', '(', ')', '~'), '', $row['name'] );
                                      
               $excData .= $row['line'].','.$row['inum'].','.$name.','.$row['sizes'].','.$row['qty'].','.
                           $row['q1'].','.$row['q2'].','.$row['q3'].','.$row['q4'].','.$row['q5'].','.
                           $row['q6'].','.$row['q7'].','.$row['q8'].','.$row['q9'].','.$row['q10']."\r\n".'<br>';

            }
*/
         }
         $this->load->view("recvs/print_revision",$data);
      
      die();
      
      }

      return 0;
      // $this->_reload();
	}
	

	

// ----------------------------------------- END of TABLE Import -------------------------------- //
	function recvs_change_mode() 
	{
		$this->load->view("change_mode");
	}

	function do_change_mode() 
	{
		$mode = $this->input->post("mode");
		$this->recv_lib->set_mode($mode);
		$this->_reload();
	}
// end

	function delivery_internet() 
	{

	}

	function printer_settings() 
	{

	}
	
	

// =============================================================================================== //
// ----------------------------------------------- REALEN START ---------------------------------- //
	function _reload($data=array())
	{
		$user_id = $this->BiSOFT_Model->get_person();
		$person_info = $this->Employee->get_logged_in_employee_info();
		$location 	 = $this->BiSOFT_Model->get_location();
		if($location!=0) {$this->BiSOFT_Model->set_user_client($location);}
		$key_CKP  	 = $this->BiSOFT_Model->get_version_ckp();
		$person_mode = $this->BiSOFT_Model->get_user_mode();
		
		// $dateKey 	 = $this->recv_lib->get_dateKey();
		// $data['dateKey'] = $dateKey;
		
		$mode = $this->recv_lib->get_mode();
		$this->BiSOFT_Model->set_user_mode($mode);

		if(!isset($data['view'])) {$data['view']=0;}
		
		$config['base_url'] = site_url('/recvs/index');
		$data['form_width'] = $this->get_form_width();
		$data['controller_name']=strtolower(get_class());
		
		// New Pagination
		$config['per_page'] = 20;
		$all_records = $this->BiSOFT_Model->zebex_cart_pages($mode);
		$data['pages'] = ceil($all_records/$config['per_page']);
		$page_offset = 0;
		if(!isset($data['page'])) {$data['page']=1;}
		else{$page_offset = $config['per_page'] * ($data['page']-1);}		

		// зарежда количката ...
		$data['cart']=$this->recv_lib->get_cart_page($config['per_page'],$page_offset);

		// зарежда размерите ...
		$data['size_grid']= $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table']= $this->BiSOFT_Model->get_sizes('grid_3');
		$data['size_table_top']= $this->BiSOFT_Model->get_sizes('grid_4');

	if( $location == 0 ) //тук се вкарат документите, с които работи само БАЗАТА
	{
			// вземам си всички КАТЕГОРИИ
			$data['category'] = $this->BiSOFT_Model->get_mode_assort();
			$data['categories'] = array('0' => '-- '.$this->lang->line('items_all_categories').' --');
			foreach ($this->Item->get_item_categories()->result() as $category)
			{ $data['categories'][$category->cat_id] = $category->category_bg;}	

		if( !$key_CKP and $user_id!='1470' )
		{
			$data['modes']=array(
				'manu' 			=> $this->lang->line('recvs_manufacturing'),
				'macka' 			=> $this->lang->line('recvs_macka'),
				'recv'		  	=> $this->lang->line('recvs_receiving'),
				'recv_return' 	=> $this->lang->line('recvs_return'),
				'consi'		  	=> $this->lang->line('recvs_consignation'),
				'consi_return'	=> $this->lang->line('recvs_return_consi'),
				'protocol'		=> $this->lang->line('recvs_protocol'),
				'kit'	  			=> $this->lang->line('recvs_kit'),
				'stock'	  		=> $this->lang->line('recvs_stock'),
				'balance'	  	=> $this->lang->line('recvs_balance'),
				'brak'		  	=> $this->lang->line('recvs_brak'),
				'revision'	  	=> $this->lang->line('recvs_revision')
							);
		}
		else
		{
			$data['modes']=array(
				'stock'	  		=> $this->lang->line('recvs_stock'),
				'qtynote'		=> $this->lang->line('recvs_qtynote'),
				'revision'	  	=> $this->lang->line('recvs_revision')
							);
			if($mode=='manu') 
			{				
				$mode='qtynote';
				$this->BiSOFT_Model->set_user_mode($mode);
			}
		}
	}
	else //тук се вкарат документите, с които работят само МАГАЗИНИТЕ
	{
		$data['modes']=array(
			'qtynote'		=> $this->lang->line('recvs_qtynote'),
			'balance'		=> $this->lang->line('recvs_shop_balance'),
			'brak'		  	=> $this->lang->line('recvs_brak'),
			'revision'		=> $this->lang->line('recvs_shop_revision')
						);
		$mode='qtynote';
		$this->BiSOFT_Model->set_user_mode($mode);
	}

	if($mode=='consi' or $mode=='consi_return') // само за консигнация
	{
		$data['modes_prices']=array(
			99	=> $this->lang->line('sales_unit_price'),
			1	=> $this->lang->line('sales_price').'-I',
			2	=> $this->lang->line('sales_price').'-II / III',
			3	=> $this->lang->line('sales_price').'-III',
			4	=> $this->lang->line('sales_price').'-IV',
			5	=> $this->lang->line('sales_price').'-V');
   }
   else
   {
		$data['modes_prices']=array(
			99	=> $this->lang->line('sales_unit_price'),
			1	=> $this->lang->line('sales_price').'-I',
			2	=> $this->lang->line('sales_price').'-II',
			3	=> $this->lang->line('sales_price').'-III',
			4	=> $this->lang->line('sales_price').'-IV',
			5	=> $this->lang->line('sales_price').'-V');
   }

		$data['modes_prints']=array(
			'sizes_prices'	=> $this->lang->line('reports_print_sizes_prices'),
			'sizes'	=> $this->lang->line('reports_print_sizes'),
			'prices'	=> $this->lang->line('reports_print_prices') );

		$data['modes_years']=array();
		for($k=0;$k<2;$k++) // установява само тек. и предходна година.
			{ $data['modes_years'][date("Y")-$k] = date("Y")-$k;}

		$data['modes_months'] = array(
			'01' => $this->lang->line('cal_january'),
			'02' => $this->lang->line('cal_february'),
			'03' => $this->lang->line('cal_march'),
			'04' => $this->lang->line('cal_april'),
			'05' => $this->lang->line('cal_mayl'),
			'06' => $this->lang->line('cal_june'),
			'07' => $this->lang->line('cal_july'),
			'08' => $this->lang->line('cal_august'),
			'09' => $this->lang->line('cal_september'),
			'10' => $this->lang->line('cal_october'),
			'11' => $this->lang->line('cal_november'),
			'12' => $this->lang->line('cal_december')	);

		$data['mode']			= $mode;
		$data['mode_day']		= (int) date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['mode_month']	= (int) date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		$data['cur_date']		= date('d.m.Y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));

		$m_limit = $this->BiSOFT_Model->get_month_limit($data['mode_month'],$data['mode_year']);
		$data['modes_days'] = array();
		for($k=1;$k<=$m_limit;$k++) { $data['modes_days'][$k]=$k;}		
		
		$data['mode_print']	= $this->recv_lib->get_mode_print();  

		$data['location']		= $location;
		$data['subtotal']		= to_currency_no_money($this->recv_lib->get_subtotal());
		$data['currency']		= ' лв.'; // $this->config->currency_symbol;
		$data['all_qty']		= $this->recv_lib->get_all_qty();
		$data['items_module_allowed'] = $this->Employee->has_permission('items', $person_info->person_id);
		$data['comment'] 		= $this->recv_lib->get_comment();

		$data['total']	= $data['subtotal'];

		$bisoft_id = $data['consi_id'] = 0;
		$data['supplier_price'] = 99;

		$data['consignees'] = array('-1' => '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
																	$this->lang->line('reports_set_consignee') );
																	
		if ( $mode=='manu' or  $mode=='macka' or $mode=='balance' or $mode=='brak' or $mode=='qtynote' ) 
			{  $supplier_id = 0; $data['supplier_discount'] = 0;}
		elseif ( $mode=='consi' or $mode=='consi_return' or $mode=='revision' )
			{ 
					$consignee_id = $this->recv_lib->get_consignee();
					if($consignee_id<1 or !is_numeric($consignee_id)) {$consignee_id=0;}
					$data['consi_id'] = $consignee_id;

					// вземам си всички КОНСИГНАТОРИ
					foreach ($this->Consignee->get_all_dropdown()->result() as $consignee)
						{ $data['consignees'][$consignee->bisoft_id] = 
						  character_limiter('&nbsp;('.$consignee->bisoft_id.') '.$consignee->company_name,28);
						}
					$bisoft_id=$consignee_id;
					
					if($bisoft_id>0)
					{	$consi_info=$this->Consignee->get_info_by_bisoft_id($bisoft_id);

						$data['supplier']=$consi_info->company_person;
	 					$data['supplier_company']=$consi_info->company_name;
						$data['supplier_discount']=$consi_info->discount;
						$data['supplier_account_number']=$consi_info->account_number;
						$data['supplier_price']=$consi_info->price_group;
						$data['supplier_address']='';
					}
					else 
					{	$data['supplier']=$data['supplier_company']=$data['supplier_discount']=
						$data['supplier_account_number']=$data['supplier_price']=$data['supplier_address']='';}

					$supplier_discount = $data['supplier_discount'];
					$data['total']	= to_currency_no_money($this->recv_lib->get_total($mode,$supplier_discount));
			}
		else
			{	$supplier_id = $this->recv_lib->get_supplier();
			
				if ($supplier_id!=-1)
				{
					$suppl_info=$this->Supplier->get_info($supplier_id);

					$bisoft_id = $suppl_info->bisoft_id;
					$data['supplier']=$suppl_info->company_person;
					$data['supplier_company']=$suppl_info->company_name;
					$data['supplier_discount']=$suppl_info->discount;
					$data['supplier_account_number']=$suppl_info->account_number;
					$data['supplier_price']=$suppl_info->price_group;
					$data['supplier_address']='';
						
					$period = date('Y');
					$supplier_duties = $this->Recv->get_supplier_due($bisoft_id,$period);
					if($supplier_duties) { $data['supplier_due'] = $supplier_duties->due; }
					else { $data['supplier_due'] = 0;}

				} 
				else { $data['supplier_discount'] = 0;}

				$supplier_discount = $data['supplier_discount'];
				$data['total']	= to_currency_no_money($this->recv_lib->get_total($mode,$supplier_discount));
			} // end of... else if


		if( isset ($supplier_id) and $supplier_id > 0) 
			{ 
			  $this->BiSOFT_Model->set_user_client($supplier_id);
			  $this->recv_lib->set_mode_price($data['supplier_price']);
			  $this->BiSOFT_Model->set_mode_location($location);
			}
		elseif( isset ($consignee_id) and $consignee_id > 0) 
			{ 
			  $this->BiSOFT_Model->set_user_client($consignee_id);
			  $this->recv_lib->set_mode_price($data['supplier_price']);
			  $this->BiSOFT_Model->set_mode_location($consignee_id);
			}
		else 
			{ 
			  $this->BiSOFT_Model->set_mode_location($location);
			  $this->BiSOFT_Model->set_user_client(0);
			}

		$mode_price	= $this->recv_lib->get_mode_price();
		$data['mode_price'] = $mode_price;
		
		// ново Комплектация
		$data['kit_inum'] = $kit_inum = $this->recv_lib->get_kit();
		$data['kit_mode'] = $kit_mode = $this->recv_lib->get_kit_mode();
		if($mode=='kit')
		{
			$data['kit_id'] = $kit_inum;
			$data['all_kits'] = array('0' => ($kit_mode>0) ? '= Комплектоване =' : '= Разкомплектоване =');
         foreach ($this->Item->get_all_kits()->result() as $kit)
         { 
				$inum_kit = $kit->item_number;
				$kitName  = str_replace('Подаръчен комплект ', '', $kit->name );
				$kitData  = '';
				if($inum_kit>13000 and $inum_kit<14000)
				{ 
					if($kit->kit_1) { $kitData .= " (".$kit->kit_1.")"; }
					if($kit->kit_2) { $kitData .= " (".$kit->kit_2.")"; }
					if($kit->kit_3) { $kitData .= " (".$kit->kit_3.")"; }
					$data['all_kits'][$kit->item_number] = (int)($kit->item_number).' - '.$kitName.$kitData;
				}
			}
		}

		if (isset($info)) { $data['info'] = $info;}
		if (isset($success)) { $data['success'] = $success;}
		if (isset($error)) { $data['error'] = $error;}

	$this->load->view("recvs/register",$data);
	}
// -----------------------------------------------------------------------------
	function pages($page)
	{
		$data=array( 'page' => $page );
	
	$this->_reload($data);
	}

	/* ----	get the width for the add/edit form ---- */
	function get_form_width()
	{ return 360;}

	/* ----	get the width for the add/edit form ---- */
	function get_form_full_width()
	{ return 780;}
	
	
}
?>
