<?php require_once ("Secure_area.php");
		require_once (APPPATH."libraries/ofc-library/open-flash-chart.php");

class Reports extends Secure_area 
{
	function __construct()
	{
		parent::__construct('Reports');
		$this->load->helper('Report');		
	}
	
	//Initial report listing screen
	function index()
	{
		header('Location: '.BISOFT.'index.php');
	/*
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		$data['modes_years']=array();
		$limit_year = 4;
		for($k=0;$k<$limit_year;$k++)
			{ $data['modes_years'][date("Y")-$k] = date("Y")-$k;}
		$data['mode_year'] = $this->BiSOFT_Model->get_user_mode_year();
		$data['controller_name'] = strtolower(get_class());
		$this->load->view("reports/listing",$data);
	*/
	}
	
	// Refresh listing screen
	function refresh()
	{
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		$data = array();
		$data['controller_name'] = strtolower(get_class());
		$data['modes_years']=array();
		$limit_year = 4;
		for($k=0;$k<$limit_year;$k++)
			{ $data['modes_years'][date("Y")-$k] = date("Y")-$k;}
		$data['mode_year'] = $this->BiSOFT_Model->get_user_mode_year();
		$this->load->view("reports/listing",$data);	
	}

	function change_YEAR()
	{
		$mode_year = $this->input->post("mode_year");
		$this->BiSOFT_Model->set_user_year($mode_year);
		if ($mode_year > date ('Y'))	
				{ $this->BiSOFT_Model->set_user_year(date('Y')); }
		else  { $this->BiSOFT_Model->set_user_year($mode_year);  }
	$this->refresh();
	}

	function _get_common_report_data($all=0)
	{
		$data = array();
		$data['report_date_range_simple'] = get_simple_date_ranges();
		$data['years']  = get_years($all);
		$data['months'] = get_months(1);
		$data['days'] 	 = get_days();
		$data['selected_month']=date('n');
		$data['selected_day']=date('d',strtotime('-1 second',strtotime('+1 month',strtotime(date('m').'/01/'.date('Y').' 00:00:00'))));
		$data['selected_year']=$data['now_YEAR']=date('Y');
		$data['daily_day']=date('d');
	return $data;
	}
	
	function _get_summary_report_data($all=0)
	{
		$data = array();
		$data['report_date_range_simple'] = get_summary_date_ranges();
		$data['years']  = get_years($all);
		$data['months'] = get_months(1);
		$data['days'] 	 = get_days();
		$data['selected_month']=date('n');
		$data['selected_day']=date('d');
		$data['selected_year']=$data['now_YEAR']=date('Y');
		$data['daily_day']=date('d');	
	return $data;
	}
	
	// Input for reports that require only a date range and an export to excel. 
	// (see routes.php to see that all summary reports route here)
	function date_input_excel_export()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$this->load->view("reports/date_input_excel_export",$data);	
	}


	function date_input_summary()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$this->load->view("reports/date_input_summary",$data);	
	}

	
	// Input for reports that require only a date range. 
	// (see routes.php to see that all graphical summary reports route here)
	function date_input()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$this->load->view("reports/date_input",$data);	
	}


//--------------------- Summary ITEMS report --------------------------- //
	function date_input_summary_items()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_summary_report_data();
		$data['clients'] = $this->lang->line('reports_items');
		
		// вземам си всички КОЛЕКЦИИ  
		$collections = array('0' => '&nbsp;&nbsp;'.$this->lang->line('reports_select_collection'));
		if ( $this->Appconfig->get('language') == 'bulgarian' ) 
			{
				$lang = "bg";
				foreach ( $this->Order->get_collections()->result() as $collection)
						  { $collections[$collection->key] = '&nbsp;&nbsp;'.$collection->collection_bg; }
			}
		elseif ( $this->Appconfig->get('language') == 'english' )
			{
				$lang = "en";
				foreach ( $this->Order->get_collections()->result() as $collection)
						  { $collections[$collection->key] = '&nbsp;&nbsp;'.$collection->collection_en; }
			}
		$data['collections'] = $collections;
		$data['collection_id'] = 0;
		
		$this->load->view("reports/date_input_summary_items",$data);	
	}

	function summary_items($start_date, $end_date, $collection=0, $group=0, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_summary_items.php");}


//-------------------------- Summary SALES Report ------------------------ //
	function date_input_summary_sales()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_summary_report_data(1);
		$data['clients'] = $this->lang->line('reports_sales');
		$this->load->view("reports/date_input_summary_sales",$data);	
	}

	function summary_sales($start_date, $end_date, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_summary_sales.php");}
	

//------------------------- Summary RECVS Report -------------------------- //
	function date_input_summary_recvs()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_summary_report_data(1);
		$data['clients'] = $this->lang->line('reports_receivings');
		$this->load->view("reports/date_input_summary_recvs",$data);	
	}

	function summary_recvs($start_date, $end_date, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_summary_recvs.php");}


//-------------------------- Summary CUSTOMERS report ----------------------- //
	function date_input_summary_customers()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_summary_report_data(1);
		$data['specific_input_name'] = $this->lang->line('reports_customer');
		
		// вземам си всички КЛИЕНТИ
		$data['customer']  = 0;
		$data['customers'] = array('0' => $this->lang->line('reports_all_clients'));
		foreach ($this->Customer->get_dropdown_1()->result() as $customer)
			{ $data['customers'][$customer->bisoft_id] = '&nbsp;'.character_limiter($customer->company_name,42); }
		$data['customers']['100000'] = $data['customers']['100001'] = " ";
		$data['customers']['100002'] = "============= LOW RATINGS ==============";
		$data['customers']['100003'] = " ";
		foreach ($this->Customer->get_dropdown_2()->result() as $customer)
			{ $data['customers'][$customer->bisoft_id] = '>> '.character_limiter($customer->company_name,28).' <<'; }
			
		// FIRMI
		$data['firma'] = 0; 
		$data['specific_firmas'] = array(
				'0' => $this->config->item('company'),
				'2' => $this->config->item('2_company') );
				
		$data['clients'] = $this->lang->line('reports_customers');
		$this->load->view("reports/date_input_summary_customers",$data);	
	}

	function summary_customers($start_date, $end_date, $client_id, $all_unit, $firma, $sale_type, $export_excel=0)
	{ 
		if($sale_type=='duty')
			{ require_once(APPPATH."plugins/reports/reports_summary_customers_duty.php"); }
      elseif($sale_type=='duty_last')
			{ require_once(APPPATH."plugins/reports/reports_summary_customers_duty_last.php"); }
		else
			{ require_once(APPPATH."plugins/reports/reports_summary_customers.php"); }
	}
	
	
//----------------------- Summary CONSIGNEES report ----------------------- //
	function date_input_summary_consignees()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_summary_report_data(1);
		$data['specific_input_name'] = $this->lang->line('reports_consignee');
		$data['clients'] = $this->lang->line('reports_consignees');
		// вземам си всички МАГАЗИНИ
		$data['consignee']  = 0;
		$data['consignees'] = array('0' => $this->lang->line('reports_all_consis'));
		foreach ($this->Consignee->get_all_dropdown()->result() as $consignee)
				{ $data['consignees'][$consignee->bisoft_id] = '&nbsp;('.$consignee->bisoft_id.') - '.character_limiter($consignee->company_name,35); }
		$this->load->view("reports/date_input_summary_consignees",$data);	
	}

	function summary_consignees($start_date, $end_date, $client_id, $all_unit, $sale_type, $export_excel=0)
	{
		if($sale_type=='duty')
			{ require_once(APPPATH."plugins/reports/reports_summary_consignees_duty.php"); }
		elseif($sale_type=='duty_last')
			{ require_once(APPPATH."plugins/reports/reports_summary_consignees_duty_last.php"); }
		else
			{ require_once(APPPATH."plugins/reports/reports_summary_consignees.php"); }
	}
	

//-------------------------- Summary ONLINE CLIENTS ---------------------- //
	function date_input_summary_online_clients()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_summary_report_data(1);
		$data['specific_input_name'] = $this->lang->line('reports_online_client');
		$data['clients'] = $this->lang->line('reports_online_clients');
		// вземам си всички ONLINE Клиенти ...
		$data['online_client']  = 1;
		$data['online_clients'] = array('1' => '&nbsp;<< '.$this->lang->line('reports_online_shop').'&nbsp;>>');
		foreach ($this->Customer->get_all_online_clients()->result() as $online)
				{ $data['online_clients'][$online->bisoft_id] = '&nbsp;'.character_limiter($online->company_name,50);}
				
		$this->load->view("reports/date_input_summary_online_clients",$data);	
	}

	function summary_online_clients($start_date, $end_date, $client_id, $all_unit, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_summary_online_clients.php");}	


//------------------------ Summary SUPPLIERS report --------------------- //
	function date_input_summary_suppliers()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_summary_report_data(1);
		$data['specific_input_name'] = $this->lang->line('reports_supplier');
		$data['clients'] = $this->lang->line('reports_suppliers');
		// вземам си всички ДОСТАВЧИЦИ
		$data['supplier'] = 0;
		$data['suppliers'] = array('0' => $this->lang->line('reports_all_suppliers'));
		foreach ($this->Supplier->get_dropdown_1()->result() as $supplier)
			{ $data['suppliers'][$supplier->bisoft_id] = '&nbsp;'.character_limiter($supplier->company_name,42); }
		$data['suppliers']['100000'] = $data['suppliers']['100001'] = " ";
		$data['suppliers']['100002'] = "============= LOW RATINGS ==============";
		$data['suppliers']['100003'] = " ";
		foreach ($this->Supplier->get_dropdown_2()->result() as $supplier)
			{ $data['suppliers'][$supplier->bisoft_id] = '>> '.character_limiter($supplier->company_name,28).' <<'; }		
	
		$this->load->view("reports/date_input_summary_suppliers",$data);	
	}

	function summary_suppliers($start_date, $end_date, $supplier_id, $all_unit, $sale_type, $export_excel=0)
	{
		if($sale_type=='duty')
			{ require_once(APPPATH."plugins/reports/reports_summary_suppliers_duty.php"); }
		elseif($sale_type=='duty_last')
			{ require_once(APPPATH."plugins/reports/reports_summary_suppliers_duty_last.php"); }
		else
			{ require_once(APPPATH."plugins/reports/reports_summary_suppliers.php"); }
	
	}
	

//----------------------- Summary PROFIT report ----------------------- //
	function date_input_summary_profits()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_summary_report_data(1);
		$data['clients'] = $this->lang->line('reports_profit');
		
		// вземам си всички КОЛЕКЦИИ  
		$collections = array('0' => '&nbsp;&nbsp;'.$this->lang->line('reports_select_collection'));
		if ( $this->Appconfig->get('language') == 'bulgarian' ) 
			{
				$lang = "bg";
				foreach ( $this->Order->get_collections()->result() as $collection)
						  { $collections[$collection->key] = '&nbsp;&nbsp;'.$collection->collection_bg; }
			}
		elseif ( $this->Appconfig->get('language') == 'english' )
			{
				$lang = "en";
				foreach ( $this->Order->get_collections()->result() as $collection)
						  { $collections[$collection->key] = '&nbsp;&nbsp;'.$collection->collection_en; }
			}
		$data['collections'] = $collections;
		$data['collection_id'] = 0;
		
		$this->load->view("reports/date_input_summary_profits",$data);	
	}

	function summary_profits($start_date, $end_date, $collection, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_summary_profits.php");}


//---------------------- Summary EMPLOYEES report ---------------------- //
	function date_input_summary_employees()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_summary_report_data(1);
		$data['clients'] = $this->lang->line('reports_employees');
		$this->load->view("reports/date_input_summary_employees",$data);	
	}

	function summary_employees($start_date, $end_date, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_summary_employees.php");}
	

// --------------------- Summary CATEGORIES Report --------------------- //
	function summary_categories($start_date, $end_date, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_summary_categories.php");}



// ======================= GRAPHICAL Reports =========================== //
// --------------------  Graphical Summary SALES INPUT ----------------- //
	function graphical_sales_input()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['clients'] = $this->lang->line('reports_sales');
		$this->load->view("reports/graphical_sales",$data);	
	}

	function graphical_sales($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_sales');
		$model = $this->Summary_sales;

		$data = array(
			"title" => $this->lang->line('reports_sales_summary_report'),
			"data_file" => site_url("reports/graphical_summary_sales_graph/$start_date/$end_date/$sale_type"),
			"subtitle" => date('d.m.Y', strtotime($start_date)) .' - '.date('d.m.Y', strtotime($end_date)),
			"summary_data" => $model->getSummaryData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type))
						 );

		$this->load->view("reports/graphical",$data);
	}
	
	//The actual graph data
	function graphical_summary_sales_graph($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_sales');
		$model = $this->Summary_sales;
		$report_data = $model->getData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type));

		$graph_data = array();
		foreach($report_data as $row)	{$graph_data[date('d.m.Y',strtotime($row['doc_date']))]=$row['total'];}
		
		$data = array(
			"title" => $this->lang->line('reports_sales_summary_report'),
			"yaxis_label"=>$this->lang->line('reports_revenue'),
			"xaxis_label"=>$this->lang->line('reports_date_period'),
			"data" => $graph_data );

print_r($data);			
die();

	$this->load->view("reports/graphs/line",$data);
	}

	
//------------------------  Graphical Summary ITEMS Report --------------------- //

	function graphical_items_input()
	{
		$data = $this->_get_common_report_data();
		$data['clients'] = $this->lang->line('reports_items');
		$this->load->view("reports/graphical_items",$data);	
	}


	function graphical_items($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_items');
		$model = $this->Summary_items;

		$data = array(
			"title" => $this->lang->line('reports_items_summary_report'),
			"data_file" => site_url("reports/graphical_summary_items_graph/$start_date/$end_date/$sale_type"),
			"subtitle" => date('d.m.Y', strtotime($start_date)) .' - '.date('d.m.Y', strtotime($end_date)),
			"summary_data" => $model->getSummaryData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type))
					);

		$this->load->view("reports/graphical",$data);
	}
	
	//The actual graph data
	function graphical_summary_items_graph($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_items');
		$model = $this->Summary_items;
		$report_data = $model->getData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type));
		
		$graph_data = array();
		foreach($report_data as $row)
		{
			$graph_data[$row['item_name']] = $row['total'];
		}

		$data = array(
			"title" => $this->lang->line('reports_items_summary_report'),
			"xaxis_label"=>$this->lang->line('reports_revenue'),
			"yaxis_label"=>$this->lang->line('reports_items'),
			"data" => $graph_data  );

		$this->load->view("reports/graphs/pie",$data);
	}
	


//---------------------------------------  Graphical Summary SUPPLIERS Report ------------------------------ //
	function graphical_suppliers_input()
	{
		$data = $this->_get_common_report_data();
		$data['clients'] = $this->lang->line('reports_suppliers');
		$this->load->view("reports/graphical_suppliers",$data);	
	}


	function graphical_suppliers($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_suppliers');
		$model = $this->Summary_suppliers;

		$data = array(
			"title" => $this->lang->line('reports_suppliers_summary_report'),
			"data_file" => site_url("reports/graphical_summary_suppliers_graph/$start_date/$end_date/$sale_type"),
			"subtitle" => date('d.m.Y', strtotime($start_date)) .' - '.date('d.m.Y', strtotime($end_date)),
			"summary_data" => $model->getSummaryData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type))
		);

		$this->load->view("reports/graphical",$data);
	}
	
	//The actual graph data
	function graphical_summary_suppliers_graph($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_suppliers');
		$model = $this->Summary_suppliers;
		$report_data = $model->getGraphData(array(
						'start_date'=> $start_date,
						'end_date'	=> $end_date,
						'sale_type' => $sale_type) );
		
		$graph_data = array();
		foreach($report_data as $row)
		{
			$graph_data[$row['supplier']] = $row['total'];
		}
		
		$data = array(
			"title" => $this->lang->line('reports_suppliers_summary_report'),
			"xaxis_label"=>$this->lang->line('reports_kaca_razhod'),
			"yaxis_label"=>$this->lang->line('reports_suppliers'),
			"data" => $graph_data
		);

		$this->load->view("reports/graphs/hbar",$data);
	}
	

//---------------------------------------  Graphical Summary CUSTOMERS Report ------------------------------ //
	function graphical_customers_input()
	{
		$data = $this->_get_common_report_data();
		$data['clients'] = $this->lang->line('reports_customers');
	$this->load->view("reports/graphical_customers",$data);	
	}


	function graphical_customers($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_customers');
		$model = $this->Summary_customers;

		$data = array(
			"title" => $this->lang->line('reports_customers_summary_report'),
			"data_file" => site_url("reports/graphical_summary_customers_graph/$start_date/$end_date/$sale_type"),
			"subtitle" => date('d.m.Y', strtotime($start_date)) .' - '.date('d.m.Y', strtotime($end_date)),
			"summary_data" => $model->getSummaryData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type))
		);

	$this->load->view("reports/graphical",$data);
	}
	
	//The actual graph data
	function graphical_summary_customers_graph($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_customers');
		$model = $this->Summary_customers;
		$report_data = $model->getGraphData(array(
					'start_date'=> $start_date,
					'end_date'	=> $end_date,
					'sale_type' => $sale_type ) );
		
		$graph_data = array();
		foreach($report_data as $row)
			{ $graph_data[$row['client']] = $row['total'];}
		
		$data = array(
			"title" => $this->lang->line('reports_customers_summary_report'),
			"xaxis_label"=>$this->lang->line('reports_revenue'),
			"yaxis_label"=>$this->lang->line('reports_customers'),
			"data" => $graph_data );

	$this->load->view("reports/graphs/hbar",$data);
	}



//---------------------------  Graphical Summary CONSIGNEES Report --------------------- //
	function graphical_consignees_input()
	{
		$data = $this->_get_common_report_data();
		$data['clients'] = $this->lang->line('reports_consignees');
		$this->load->view("reports/graphical_consignees",$data);	
	}

	function graphical_consignees($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_consignees');
		$model = $this->Summary_consignees;

		$data = array(
			"title" => $this->lang->line('reports_consignees_summary_report'),
			"data_file" => site_url("reports/graphical_summary_consignees_graph/$start_date/$end_date/$sale_type"),
			"subtitle" => date('d.m.Y', strtotime($start_date)) .' - '.date('d.m.Y', strtotime($end_date)),
			"summary_data" => $model->getSummaryData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type))
		);

	$this->load->view("reports/graphical",$data);
	}
	
	//The actual graph data
	function graphical_summary_consignees_graph($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_consignees');
		$model = $this->Summary_consignees;
		$report_data = $model->getGraphData(array(
					'start_date'=> $start_date,
					'end_date'	=> $end_date,
					'sale_type' => $sale_type ) );
		
		$graph_data = array();
		foreach($report_data as $row)
			{ $graph_data[$row['client']] = $row['total'];}
		
		$data = array(
			"title" => $this->lang->line('reports_consignees_summary_report'),
			"xaxis_label"=>$this->lang->line('reports_revenue'),
			"yaxis_label"=>$this->lang->line('reports_consignees'),
			"data" => $graph_data  );

	$this->load->view("reports/graphs/hbar",$data);
	}



//----------------------- Graphical Summary EMPLOYEES Report ----------------- //
	function graphical_employees_input()
	{
		$data = $this->_get_common_report_data();
		$data['clients'] = $this->lang->line('reports_employees');
		$this->load->view("reports/graphical_employees",$data);	
	}


	function graphical_employees($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_employees');
		$model = $this->Summary_employees;

		$data = array(
			"title" => $this->lang->line('reports_employees_summary_report'),
			"data_file" => site_url("reports/graphical_summary_employees_graph/$start_date/$end_date/$sale_type"),
			"subtitle" => date('d.m.Y', strtotime($start_date)) .' - '.date('d.m.Y', strtotime($end_date)),
			"summary_data" => $model->getSummaryData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type))
                  );

	$this->load->view("reports/graphical",$data);
	}
	
	//The actual graph data
	function graphical_summary_employees_graph($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_employees');
		$model = $this->Summary_employees;
		$report_data = $model->getData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type));
	
		$graph_data = array();
		foreach($report_data as $row) { $graph_data[$row['employee']] = $row['pay_amount'];}
		
		$data = array(
			"title" => $this->lang->line('reports_employees_summary_report'),
			"data" => $graph_data );

	$this->load->view("reports/graphs/pie",$data);
	}
	

//-------------------------  Graphical Summary CATEGORIES Report ---------------------- //

	function graphical_categories($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_categories');
		$model = $this->Summary_categories;

		$data = array(
			"title" => $this->lang->line('reports_categories_summary_report'),
			"data_file" => site_url("reports/graphical_summary_categories_graph/$start_date/$end_date/$sale_type"),
			"subtitle" => date('d.m.Y', strtotime($start_date)) .' - '.date('d.m.Y', strtotime($end_date)),
			"summary_data" => $model->getSummaryData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type))
		);

	$this->load->view("reports/graphical",$data);
	}
	
	//The actual graph data
	function graphical_summary_categories_graph($start_date, $end_date, $sale_type)
	{
		$this->load->model('reports/Summary_categories');
		$model = $this->Summary_categories;
		$report_data = $model->getData(array('start_date'=>$start_date, 'end_date'=>$end_date, 'sale_type' => $sale_type));
		
		$graph_data = array();
		foreach($report_data as $row)
			{ $graph_data[$row['category']] = $row['total'];}
		
		$data = array(
			"title" => $this->lang->line('reports_categories_summary_report'),
			"data" => $graph_data  );

	$this->load->view("reports/graphs/pie",$data);
	}
	


// =========================== SPECIFIC REPORTS ============================= //
	// КЛИЕНТ
	function specific_customer_input()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['specific_input_name'] = $this->lang->line('reports_customer');
		
		$customers = array();
		foreach($this->Customer->get_all()->result() as $customer)
			{ $customers[$customer->person_id] = character_limiter($customer->company_name, 40);}
		$data['specific_input_data'] = $customers;
		$data['clients'] = $this->lang->line('reports_customers');
		$this->load->view("reports/specific_customer_input",$data);	
	}


	function specific_customer($start_date, $end_date, $customer_id, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_specific_customer.php");}



// ------------------------- КОНСИГНАТОРИ - МАГАЗИНИ ------------------------ //

	function specific_consignee_input()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['specific_input_name'] = $this->lang->line('reports_consignee');

		foreach($this->Consignee->get_all_dropdown()->result() as $consignee)
			{ $consignees[$consignee->person_id] = '&nbsp;&nbsp;( '.$consignee->bisoft_id.' ) - '.character_limiter($consignee->company_name, 45);}
		$data['specific_input_data'] = $consignees;
		$data['clients'] = $this->lang->line('reports_consignees');
		$this->load->view("reports/specific_consignee_input",$data);	
	}


	function specific_consignee($start_date, $end_date, $consignee_id, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_specific_consignee.php");}
	


// ------------------------------ ДОСТАВЧИК ------------------------------ //

	function specific_supplier_input()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['specific_input_name'] = $this->lang->line('reports_supplier');
		
		$suppliers = array();
		foreach($this->Supplier->get_all()->result() as $supplier)
		{
			$suppliers[$supplier->person_id] = character_limiter($supplier->company_name, 45);
		}
		$data['specific_input_data'] = $suppliers;
		$data['clients'] = $this->lang->line('reports_suppliers');
		$this->load->view("reports/specific_supplier_input",$data);	
	}


	function specific_supplier($start_date, $end_date, $supplier_id, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_specific_supplier.php");}
	

// ----------------------------------- ОПЕРАТОРИ ------------------------------- //
	function specific_employee_input()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['specific_input_name'] = $this->lang->line('reports_employee');
		
		$employees = array();
		foreach($this->Employee->get_all()->result() as $employee)
		{
			if($employee->unit_location==1)
			{ $employees[$employee->person_id] = '&nbsp;&nbsp;'.$employee->first_name .' '.$employee->last_name.'&nbsp;&nbsp;';}
		}
		$data['specific_input_data'] = $employees;
		$data['clients'] = $this->lang->line('reports_employees');
		$this->load->view("reports/specific_employee_input",$data);	
	}


	function specific_employee($start_date, $end_date, $employee_id, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_specific_employee.php");}
	

	//  -------------------------- СИЛВИЯ ЗА ФАКТУРИТЕ --------------------------------- //
	function silvia_invoices()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data(1);
		$data['location'] = $this->BiSOFT_Model->get_location();

		// FIRMI
		$data['specific_input_name'] = $this->lang->line('reports_companies');
		$data['firma'] = 0; 
		$data['specific_input_data'] = array(
				'0' => $this->config->item('company'),
				'2' => $this->config->item('2_company') );

	$this->load->view("reports/silvia_invoices",$data);	
	}


	function silvia_detailed_invoices($start_date, $end_date, $firma, $sale_type, $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_detailed_silvia_invoices.php");}



	//  ------------------------- ДНЕВНИК НА ФАКТУРИТЕ ------------------------------- //
	function date_invoices()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['location'] = $this->BiSOFT_Model->get_location();
		
		// FIRMI
		$data['firma'] = 0;
		$data['specific_input_name'] = $this->lang->line('reports_companies');
		$data['specific_input_data'] = array(
				'0' => $this->config->item('company'),
				'2' => $this->config->item('2_company') );
		
	$this->load->view("reports/date_invoices",$data);	
	}


	function detailed_invoices($start_date, $end_date, $firma=0, $sale_type='invoice', $print_type='prices', $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_detailed_invoices.php");}



	//  ----------------------------- Подробни ПРОДАЖБИ ---------------------------------- //
	function date_sales()
	{	
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['location'] = $this->BiSOFT_Model->get_location();
		$data['user_id']  = $this->BiSOFT_Model->get_person();
		$this->load->view("reports/date_sales",$data);	
	}

	function detailed_sales($start_date, $end_date, $sale_type, $print_type='prices', $export_excel=0, $recalc_vedom=0)
	{ require_once(APPPATH."plugins/reports/reports_detailed_sales.php");}
	


	// ------------------------------ Подробни ДОСТАВКИ -----------------------------------//
	function date_recvs()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['location'] = $this->BiSOFT_Model->get_location();
		$this->load->view("reports/date_recvs",$data);	
	}

	function detailed_recvs($start_date, $end_date, $sale_type, $print_type='sizes', $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_detailed_recvs.php");}
			


	// --------------------------  Подробни ДР.ДОКУМЕНТИ ---------------------------------//

	function date_documents()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
		$data['location'] = $this->BiSOFT_Model->get_location();
		$this->load->view("reports/date_documents",$data);	
	}

	function detailed_documents($start_date, $end_date, $sale_type, $print_type='sizes', $export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_detailed_documents.php");}
			

	function excel_export()
	{ 
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		$this->load->view("reports/excel_export",array());
	}
	
//  СКЛАД отрицателни количества ...........................
	function inventory_low($export_price=0,$export_online=0,$export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_inventory_low.php");}
	

//  -----------------------------------  СКЛАД Пълна Извадка ---------------------------------- //
	function inventory_summary($export_price=0,$export_online=0,$export_excel=0)
	{ require_once(APPPATH."plugins/reports/reports_inventory_summary.php");}

	
//Input for reports that require only one date for daily report (see routes.php)
	function daily_excel_export() // към Дневен Отчет
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
	   $data['location'] = $this->BiSOFT_Model->get_location();
		$this->load->view("reports/daily_excel_export",$data);	
	}

// ------------------------  ДНЕВЕН ОТЧЕТ към BiSOFT (Excel) -----------------------------------//
	function daily_sales($start_date, $sale_type, $export_excel=1)
	{ require_once(APPPATH."plugins/reports/reports_daily_sales.php");}

	
// ------------------------  ДНЕВЕН ОТЧЕТ НА КАСА -----------------------------------//
	function daily_kaca_export()
	{
		$this->BiSOFT_Model->clear_user_modes();
		$mode_menu = 'reports';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data = $this->_get_common_report_data();
	   $data['location'] = $this->BiSOFT_Model->get_location();
		$this->load->view("reports/daily_kaca_export",$data);
	}

	function daily_kaca($kaca_date)
	{ require_once(APPPATH."plugins/reports/reports_daily_kaca.php");}
	
	function add_daily_kaca($kaca_date)
	{ require_once(APPPATH."plugins/reports/reports_add_daily_kaca.php");}
	
	function edit_dKaca_row($kaca_date,$doc_id='-1')
	{
		$vedomPack = 'K'.date('Y',strtotime($kaca_date));
		// да се довърши някой ден ...

		require_once(APPPATH."plugins/reports/reports_daily_kaca.php");
	}
	
	function delete_dKaca_row($kaca_date,$doc_id='-1')
	{
		$vedomPack = 'K'.date('Y',strtotime($kaca_date));
		$this->load->model('reports/Daily_sales');
		$model = $this->Daily_sales;
		if($doc_id) {$model->delete_dKACA_row($vedomPack,$doc_id);}
			
		require_once(APPPATH."plugins/reports/reports_daily_kaca.php");
	}
	
	function daily_kaca_finish($total_cost=0,$kaca_date)
	{ require_once(APPPATH."plugins/reports/reports_finish_daily_kaca.php");}
	
	function print_kaca($kaca_date)
	{
		// да се довърши някой ден ...
		require_once(APPPATH."plugins/reports/reports_daily_kaca.php");
	}
	
	
/* ------------------------------------------- SPECIAL PRINT -------------------------------------- */
	public function print_array($data)
	{	
		echo '<!DOCTYPE HTML>
				<html lang="en-US">
				<head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head>
				<body style="margin-left:10px;">';
		
		foreach($data as $line=>$row)
		{
			echo $line.'<b style="color:blue;"> =>> </b>';
			print_r($row);
			echo '<br>';
		}
		
		echo '<br><b style="color:red;">END.</b>';
		echo '</body>';
		
	die();
	}
	
/* ----------------------------------------- КРАЙ ---------------------------------------- */
} ?>
