<?php require_once ("Secure_area.php");

class Sales extends Secure_area
{
	function __construct()
	{
		parent::__construct('Sales');
		$this->load->library('Sale_lib');
	}

	function index($list='0')
	{
		$this->BiSOFT_Model->clear_user_modes();
		$this->BiSOFT_Model->zebex_delete();
		$this->sale_lib->remove_customer();

		$mode_menu = 'sales';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);
		
		$data=array('list'=>$list);
		$this->_reload($data);
	}

	function change_mode()
	{
		$mode = $this->sale_lib->get_mode();
		$this->BiSOFT_Model->zebex_clear_all($mode);
		
		$mode = $this->input->post("mode");
		$this->sale_lib->set_mode($mode);
		$this->BiSOFT_Model->set_user_mode($mode);
	$this->_reload();
	}

	function show_hide_DATE()
	{
		if ( !$this->sale_lib->get_dateKey() ) 
				{ $this->sale_lib->set_dateKey(); }
		else	{ $this->sale_lib->clear_dateKey(); }
	$this->_reload();
	}

	function change_YEAR()
	{
		$c_day = date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_month = date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_year = $this->input->post("mode_year");
		  $m_limit = $this->BiSOFT_Model->get_month_limit($c_month,$c_year);
		  if($c_day>$m_limit) {$c_day=$m_limit;}
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);
		$this->BiSOFT_Model->set_user_year($c_year);
	$this->_reload();
	}

	function change_MONTH()
	{
		$c_day = date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_month = $this->input->post("mode_month");
		$c_year = date('y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		  $m_limit = $this->BiSOFT_Model->get_month_limit($c_month,$c_year);
		  if($c_day>$m_limit) {$c_day=$m_limit;}
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);
	$this->_reload();
	}

	function change_DAY()
	{
		$c_day = $this->input->post("mode_day");
		$c_month = date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$c_year = date('y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		  $m_limit = $this->BiSOFT_Model->get_month_limit($c_month,$c_year);
		  if($c_day>$m_limit) {$c_day=$m_limit;}
		$mode_date = "$c_year-$c_month-$c_day";
		$this->BiSOFT_Model->set_user_date($mode_date);
	$this->_reload();
	}


	function change_PRICE()
	{
		$mode_price = $this->input->post("mode_price");
		$this->sale_lib->set_mode_price($mode_price);
		$this->BiSOFT_Model->set_user_price($mode_price);
	$this->_reload();
	}


	function change_VALUTA()
	{
		$mode_valuta = $this->input->post("mode_valuta");
		$this->sale_lib->set_mode_valuta($mode_valuta);
	$this->_reload();
	}


	function change_PRINTON()
	{
		$mode_print = $this->input->post("mode_print");
		$this->sale_lib->set_mode_print($mode_print);
	$this->_reload();
	}


	function change_PAYMENT()
	{
		$payment_type = $this->input->post("payment_type");
		$this->sale_lib->set_mode_payment($payment_type);
	$this->_reload();
	}

	function search()
	{
		$barcode_item = $this->input->post("search");
		$data=array();
		$result_success = 'OK';
		$mode = $this->sale_lib->get_mode();

		$exist_item = $this->Item->exists_in_items($barcode_item);
		$location = $this->BiSOFT_Model->get_location();

		if($mode=='consi_sale')	{$skl=$this->BiSOFT_Model->get_user_mode_client();}
		else {$skl=$location;}
		
		if($this->sale_lib->is_valid_barcode($barcode_item)) // test for barCode
		  {	// това ще е грешка от липса на размер ?!?!?
			 if(!$this->sale_lib->add_item_barcode($barcode_item,1))
			 { $data['error']=$this->lang->line('sales_size_fail');}
		  }
		elseif($this->sale_lib->is_valid_item_number($barcode_item) and $exist_item)
		  {
          $result_success = $this->sale_lib->add_item($barcode_item,0);
			 if ( $result_success != 'OK' )	// проверявам за вид на грешката
			 {
				  if ( $result_success == 'S' )
						  { $data['error']=$this->lang->line('sales_size_fail');}
				  else	{ $data['error']=$this->lang->line('sales_unable_to_add_item');}
			 }
		  }
		elseif(!$exist_item)
		{ $data['error']=$this->lang->line('sales_unable_to_add_item');}
		
		if($this->Item->exists_in_sklad($barcode_item,$skl)) // $result_success != 'OK' && 
		{ 
         $item_id = $this->Item->get_sklad_info($barcode_item,$skl)->item_id;
         if($this->sale_lib->out_of_stock($item_id))
         {
         if( $mode != 'sale_return' and  $mode != 'shop_return') 
            { $data['error'] = $this->lang->line('sales_quantity_less_than_zero').$skl;}
         }
		}

	$this->_reload($data);
	}

	function item_search()
	{
		$suggestions = $this->Item->get_item_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		$suggestions = array_merge($suggestions, $this->Item_kit->get_item_kit_search_suggestions($this->input->post('q'),$this->input->post('limit')));
		echo implode("\n",$suggestions);
	}

	function customer_search()
	{
		$suggestions = $this->Customer->get_customer_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}

	function select_customer()
	{
		$customer_id = $this->input->post("customer");
		$this->sale_lib->set_customer($customer_id);
		$mode = $this->sale_lib->get_mode();
      if($mode!='prep_sale')
         {$this->_reload();}
		else
         {$this->sale_lib->get_prep_cart($customer_id);$this->_reload();}
	}

	function remove_customer()
	{
		$this->sale_lib->remove_customer();
		$mode = $this->sale_lib->get_mode();
		if($mode=='prep_sale') {$this->sale_lib->clear_all();}
	$this->_reload();
	}
	
	function remove_giftcard()
	{
		$this->sale_lib->clear_giftcard();
		$this->sale_lib->empty_payments();
	$this->_reload();
	}
	
	function remove_giftcard_owner()
	{
		$this->sale_lib->clear_giftcard();
		$this->sale_lib->empty_payments();
	$this->_reload();
	}
	
	function select_online_client()
	{
		$online_client = mb_convert_case($this->input->post("online_client"),MB_CASE_TITLE,"UTF-8");
		$this->sale_lib->set_online_client($online_client);
	$this->_reload();
	}
	
	function remove_online_client()
	{
		$this->sale_lib->remove_online_client();
		$this->sale_lib->empty_payments();
	$this->_reload();
	}

	
	function select_consignee()
	{
		$consignee_id = $this->input->post("mode_consi");
		$this->sale_lib->set_consignee($consignee_id);
	$this->_reload();
	}

	function remove_consignee()
	{
		$this->sale_lib->remove_consignee();
	$this->_reload();
	}

	function set_comment() 
	{ $this->sale_lib->set_comment($this->input->post('comment'));}
	
	function set_email_receipt()
	{ $this->sale_lib->set_email_receipt($this->input->post('email_receipt'));}

	//Alain Multiple Payments
	function add_payment()
	{		
		$data = $gift_info = array();
		$giftcard = $giftcard_value = 0;
		$mode = $this->sale_lib->get_mode();
		$location = $this->BiSOFT_Model->get_location();
		
		
			// $payment_amount = $this->input->post('amount_tendered');	
		
		// echo $this->input->post( 'payment_type' );
		// die();
		
		if(($mode=='shop_sale' or $mode=='shop_return') and $location > 0)
		{
			 // Giftcards
			 $giftcard = $this->input->post('giftcard');
			 if($giftcard)
				{
               $giftcard_value = 0;
					$gift_info = $this->Giftcard->get_giftcard_by_code($giftcard);
					if($gift_info)
					{
                  if(is_numeric($giftcard) and $giftcard>0)
                     { $giftcard_value = round($gift_info->procent/100,2);}
                  elseif(!is_numeric($giftcard)) // за СТОЙНОСТНИ
                     { $giftcard_value = round($gift_info->value,0);}
               }
				}
			 
			 if($gift_info)
			 {
            $this->sale_lib->set_giftcard($gift_info->giftcard_number);
            $this->sale_lib->set_giftvalue($giftcard_value);
			 }
		}

		$this->form_validation->set_rules( 'amount_tendered', 'lang:sales_amount_tendered', 'numeric' );
		
		if ( $this->form_validation->run() == FALSE )
		{
			if ( $this->input->post( 'payment_type' ) == $this->lang->line( 'sales_gift_card' ) )
				{ $data['error']=$this->lang->line('sales_must_enter_numeric_giftcard');}
			else
				{ $data['error']=$this->lang->line('sales_must_enter_numeric');}
				
 		$this->_reload( $data );
 		return ;
		}
		
		$payment_type = $this->input->post( 'payment_type' );
		if ( $payment_type == $this->lang->line('sales_giftcard') )
		{

		}
		else
		{ $payment_amount = $this->input->post('amount_tendered');}

		
		// Errors
		if( !$this->sale_lib->add_payment( $payment_type, $payment_amount ) )
		  { $data['error']='Unable to Add Payment! Please try again!';}

	$this->_reload($data);
	}

	//Alain Multiple Payments
	function delete_payment( $payment_id )
	{
		$this->sale_lib->delete_payment( $payment_id );
		$this->_reload();
	}


	function add_new_giftcard($giftcard_id='-1')
	{
      $data['giftcard_id'] = $giftcard_id;
		$data['giftcard_info']=$this->Giftcard->get_info($giftcard_id);
		$data['categories'] = $this->Giftcard->get_all_categories('mag');
		$data['category']   = 'vip10';
	$this->load->view("sales/form_giftcard",$data);
	}	
	
	function form_giftcard($giftcard='-1')
	{
		$giftcard_id = '-1';
		$data = $gift_info = array();
		if(is_numeric($giftcard) and strlen($giftcard)>7)
		  {
			 $gift_info = $this->Giftcard->get_giftcard_by_code($giftcard);
			 $giftcard_value = round($gift_info->procent/100,2);
			 $giftcard_id = $gift_info->giftcard_id;
		  }

		$data['giftcard_id'] = $giftcard_id;
		$data['giftcard_info'] = $this->Giftcard->get_info($giftcard_id);
		$data['categories'] = $this->Giftcard->get_all_categories('mag');
		$data['category']   = 'vip10';
		if($giftcard_id!='-1') {$data['category'] = $data['giftcard_info']->type;}
		
	$this->load->view("sales/form_giftcard",$data);
	}

	function save_form_giftcard($giftcard_id=-1)
	{
      $type = $this->input->post('gift_category');
		$giftcard = $this->input->post('giftcard_number');
		if(is_numeric($giftcard) and strlen($giftcard)>7 and $giftcard_id!='-1')
		  { 
			 $giftcard_id = $this->Giftcard->get_giftcard_by_code($giftcard)->giftcard_id;
			 if(!$this->Giftcard->exists($giftcard_id)) {$giftcard_id=0;}
		  }
      elseif($giftcard_id=='-1') { $type = 'vip10'; }

		$giftcard_data = array(
					'gift_num'=>$this->input->post('gift_num'),
					'giftcard_number'=>$giftcard,
					'type'=>$type,
					'procent'=>$this->input->post('procent'),
					'owner'=>$this->input->post('owner'),
					'uguomu'=>$this->input->post('email'),
					'mobile'=>$this->input->post('mobile'),
					'date_start'=>date('Y-m-d',strtotime($this->input->post('date_start'))),
					'deleted'=>0 );
			
		if( $this->Giftcard->save( $giftcard_data, $giftcard_id ) )
		{
		   $giftcard_number = $this->input->post('giftcard_number');
			$this->sale_lib->set_giftcard($giftcard_number);
			$this->sale_lib->set_giftvalue($this->input->post('procent'));
			
			$giftcard_id = $giftcard_data['giftcard_id'];
			$gift_info = $this->Giftcard->get_giftcard_by_code($giftcard_number);
				$owner = $gift_info->owner;
			
			//New giftcard
			if($giftcard_id==-1)
			{
				echo json_encode(array(
					 'success'=>true,
					 'message'=>$this->lang->line('giftcards_successful_adding').' #'.$giftcard_data['giftcard_number'].', '.$owner,
					 'giftcard_id' => $giftcard_id,
					 'giftcard' 	=> $giftcard_number,
					 'giftvalue' 	=> $gift_info->procent,
					 'owner' 		=> $owner ));
			}
			else //previous giftcard
			{
				echo json_encode(array(
					 'success'=>true,
					 'message'=>$this->lang->line('giftcards_successful_updating').' #'.$giftcard_data['giftcard_number'].', '.$owner,
					 'giftcard_id' => $giftcard_id,
					 'giftcard' 	=> $giftcard_number,
					 'giftvalue' 	=> $gift_info->procent,
					 'owner' 		=> $owner ));
			}
			
		  $this->sale_lib->clear_giftcard();
		  $this->sale_lib->empty_payments();
		}
		else//failure
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('giftcards_error_adding_updating').' '.
			$giftcard_data['giftcard_number'],'giftcard_id'=>-1));
		}
	}
	

	function add_item_from_google ($item_number, $size=0)
	{
			$q = array(); 
			$q[1]=$q[2]=$q[3]=$q[4]=$q[5]=$q[6]=$q[7]=$q[8]=$q[9]=$q[10]=0;
			$q[$size] = 1;
			
			$Qty=array(
            '1'=>$q[1],'2'=>$q[2],'3'=>$q[3],'4'=>$q[4],'5'=>$q[5],
            '6'=>$q[6],'7'=>$q[7],'8'=>$q[8],'9'=>$q[9],'10'=>$q[10]);
			
			// adds items to cart
			$this->sale_lib->add_item($item_number, 1, 0, 0, 0, $Qty);
	$this->_reload();
	}


	function add($item=0)
	{
		if(!$item) {$barcode_item = $this->input->post("item");}
		else {$barcode_item = $item;}
		
		$data=array();
		$result_success = 'OK';
		$mode = $this->sale_lib->get_mode();

		$exist_item = $this->Item->exists_in_items($barcode_item);
		$location = $this->BiSOFT_Model->get_location();

		if($mode=='consi_sale')	{$skl=$this->BiSOFT_Model->get_user_mode_client();}
		else {$skl=$location;}
		
		if($this->sale_lib->is_valid_barcode($barcode_item)) // test for barCode
		  {	// това ще е грешка от липса на размер ?!?!?
			 if(!$this->sale_lib->add_item_barcode($barcode_item,1))
			 { $data['error']=$this->lang->line('sales_size_fail');}
		  }
		elseif($this->sale_lib->is_valid_item_number($barcode_item) and $exist_item)
		  {
			 // РЕАЛНО ДОБАВЯ + item
          $result_success = $this->sale_lib->add_item($barcode_item,0);
			 if ( $result_success != 'OK' )	// проверявам за вид на грешката
			 {
				  if ( $result_success == 'S' )
						  { $data['error']=$this->lang->line('sales_size_fail');}
				  else	{ $data['error']=$this->lang->line('sales_unable_to_add_item');}
			 }
		  }
		elseif(!$exist_item)
		{ $data['error']=$this->lang->line('sales_unable_to_add_item');}
		
		if($this->Item->exists_in_sklad($barcode_item,$skl)) // $result_success != 'OK' and 
		{ 
         $item_id = $this->Item->get_sklad_info($barcode_item,$skl)->item_id;
         if($this->sale_lib->out_of_stock($item_id))
         {
				if( $mode != 'sale_return' and  $mode != 'shop_return') 
					{ $data['error'] = $this->lang->line('sales_quantity_less_than_zero').$skl;}
         }
		}

	$this->_reload($data);
	}

	
/* ----------------------------------------------------------------------- */
	function edit_sale($inum,$line)
	{
      $skl = $this->BiSOFT_Model->get_location();
      $data['inum'] = $inum;

		$giftvalue = $commision = $commision_L = 0;
		$data['mode'] = $mode = $this->sale_lib->get_mode();
		$consignee = $this->BiSOFT_Model->get_user_mode_client();
		$client_info=array();$discount=0;$taxable=0;
		
		$data['location'] = $this->BiSOFT_Model->get_location();
		$data['bFriday']  = $this->sale_lib->get_bFriday();
		if($data['location']==0) {$data['bFriday']=0;}

		if($mode=='consi_sale')
			{ $data['skl'] = $consignee;}
		else
			{ $data['skl'] = $data['location'];}

		$data['item_info'] = $this->Item->get_item_info($inum);
		$data['skl_info']  = $skl_info  = $this->Item->get_sklad_info($inum,$data['skl']);
		$data['cart_info'] = $cart_info = $this->BiSOFT_Model->zebex_get($inum, $mode);
			$data['line'] = $cart_info->line;
			$data['name'] = $cart_info->name;
			$data['qty'] = $cart_info->qty;
			
				$data['q1']=(int)$cart_info->q1;$data['q2']=(int)$cart_info->q2;$data['q3']=(int)$cart_info->q3;
				$data['q4']=(int)$cart_info->q4;$data['q5']=(int)$cart_info->q5;$data['q6']=(int)$cart_info->q6;
				$data['q7']=(int)$cart_info->q7;$data['q8']=(int)$cart_info->q8;$data['q9']=(int)$cart_info->q9;
				$data['q10']=(int)$cart_info->q10;

			$data['mprice'] = $cart_info->mprice;
			$data['price'] = $cart_info->price;
			$data['dsc'] 	= (float)$cart_info->dsc;
			$data['inv'] 	= '';

		if($mode=='prep_sale')
		{
         $client_person_id = $this->BiSOFT_Model->get_user_mode_client();
         if($client_person_id) {$client_info = $this->Customer->get_info($client_person_id);}
         if($client_info)
         {
            $discount = (float)$client_info->discount;
            $taxable  = $client_info->taxable;
         }
		}
		$data['client_discount'] = $discount;
      $data['client_taxable']  = $taxable;
      $dsc = 100 - (float)$data['dsc'];
		$data['costsale'] = round($data['price']*$dsc/100,6);
		$data['commision'] = 0;
		
		// събира всички останали dropdowns ...
		$data = $this->Item->get_all_dropdowns($data);
		
		// забрана след плащане ... BLOCK > 0
		$block=round($this->sale_lib->get_payments_total(),0);
		$data['block'] = $block;

	$this->load->view("sales/form_editsale",$data);
	}
	
	
	function save_edit_item($inum,$line)
	{
		$success = 1; $item_name = '';
		$skl	= $this->BiSOFT_Model->get_location();
		$mode = $this->sale_lib->get_mode();
		$to_delete = $this->input->post('deleted');

		$inv_name = '';
		$data = array();
		if(null !== $this->input->post('inv_name'))
         { $inv_name = $this->input->post('inv_name');}
	
		if($to_delete and $inum) 
		{  // изтрива артикула
			$this->BiSOFT_Model->zebex_delete_item($inum,$mode);
		}
		else
		{
			$mode_price = $this->BiSOFT_Model->get_user_mode_price();
			$skl_info  = $this->Item->get_sklad_info($inum,$skl);
			$cart_info = $this->BiSOFT_Model->zebex_get($inum, $mode);
				$item_name = $cart_info->name;
				$allow_sizes = $cart_info->sizes;

			// ЦЕНИ ---------------------------- //
			$mprice = $this->input->post('mode_price');
			$price  = $this->input->post('price');
			if($mprice=='99') {$price = $this->input->post('price');}
			elseif($mprice=='1') {$price = $skl_info->price;}
			elseif($mprice=='2') {$price = $skl_info->price_2;}
			elseif($mprice=='3') {$price = $skl_info->price_3;}
			elseif($mprice=='4') {$price = $skl_info->price_4;}
			elseif($mprice=='5') {$price = $skl_info->price_5;}
			
			if($mode_price=='99') 
				{$this->form_validation->set_rules('price', 'lang:items_price', 'required|numeric');}

			if (!is_numeric($price)) { str_replace(',', '.', $price); $price = round($price,2);}
			if ($mode == 'sale' or $mode == 'shop_sale' or $mode == 'sale_return' or $mode == 'shop_return' or $mode == 'offer') 
				{ $price = abs($price);}

			// ОТСТЪПКИ ----------------------- //
			$discount = $this->input->post("discount");
			if ( $discount == '') { $discount = 0;}
			if (!is_numeric($discount)) 
				{ str_replace(',', '.', $discount);
				str_replace('%', '', $discount);}

	//		$discount = (int) $discount; // закръгля отстъпката до цяло число
	//		$this->form_validation->set_rules('item_discount', 'lang:items_discount', 'required|integer');	

			$this->form_validation->set_rules('quantity', 'lang:items_quantity', 'required|numeric');

			if($allow_sizes)
			{
				$q1 = (int)abs($this->input->post("q1"));
				$q2 = (int)abs($this->input->post("q2"));
				$q3 = (int)abs($this->input->post("q3"));
				$q4 = (int)abs($this->input->post("q4"));
				$q5 = (int)abs($this->input->post("q5"));
				$q6 = (int)abs($this->input->post("q6"));
				$q7 = (int)abs($this->input->post("q7"));
				$q8 = (int)abs($this->input->post("q8"));
				$q9 = (int)abs($this->input->post("q9"));
				$q10 = (int)abs($this->input->post("q10"));
				
				$quantity = $q1+$q2+$q3+$q4+$q5+$q6+$q7+$q8+$q9+$q10;
			}
			else
			{	$quantity = abs($this->input->post("quantity"));
				$q1=$q2=$q3=$q4=$q5=$q6=$q7=$q8=$q9=$q10=0;
			}
	
			// при празна бланка изтрива ?!
			if($quantity==0) 
			{
				$this->BiSOFT_Model->zebex_delete_item($inum,$mode);
			} // изтрива артикула
			else
			{
				if ($this->form_validation->run() != FALSE)
					{ 
						$this->BiSOFT_Model->zebex_edit($mode,$inum,$line,$quantity,$allow_sizes,$price,$mprice,$discount,
															$q1,$q2,$q3,$q4,$q5,$q6,$q7,$q8,$q9,$q10);
					}
				else
					{ $data['error']=$this->lang->line('sales_error_editing_item');}
				
				$item_id = $this->Item->get_sklad_info($inum,$skl)->item_id;
				if($this->BiSOFT_Model->zebex_no_stock($item_id,$mode))
					{
						if ( $mode != 'sale_return' and  $mode != 'shop_return' and  $mode != 'consi_return' ) 
							{ $data['info'] = '#'.$inum.': '.$this->lang->line('sales_quantity_less_than_zero');}
					}
			} // if($quantity==0)
		} // if to_delete ?
			
		$all_qty = $this->BiSOFT_Model->zebex_all_qty($mode);
		$total_suma = $this->sale_lib->get_total($mode); // $this->BiSOFT_Model->zebex_subtotal($mode);
		$amount_due = $this->sale_lib->get_amount_due($mode); // $this->BiSOFT_Model->zebex_amount_due($mode);
		
		// AJAX answer ...	
		if($success)
		{			
			echo json_encode(array('success'=>true,
										  'message'=>$this->lang->line('items_successful_updating').' '.$item_name,
										  'total_suma'=>$total_suma,
										  'amount_due'=>$amount_due,
										  'all_qty'=>$all_qty,
										  'line_id'=>$line ) );
		}
		else // failure
		{	
			echo json_encode(array('success'=>false,
										  'message'=>$this->lang->line('items_error_adding_updating').' '.$item_name,
										  'line_id'=>-1));
		}

	}
	
	// AJAX
	function get_item_line()
	{
		$line_id = $this->input->post('row_id');
		$mode = $this->sale_lib->get_mode();
		$litem = $this->BiSOFT_Model->zebex_get_line($line_id,$mode);

		if($litem)
			{  
				$item = array(
							'mode' => $litem->mode,
							'line' => $litem->line,
							'inum' => $litem->inum,
							  'id' => $litem->id,
							'name' => $litem->name,
							 'qty' => $litem->qty,
							 
							  'q1' => (!$litem->q1) ? '' : $litem->q1,
							  'q2' => (!$litem->q2) ? '' : $litem->q2,
							  'q3' => (!$litem->q3) ? '' : $litem->q3,
							  'q4' => (!$litem->q4) ? '' : $litem->q4,
							  'q5' => (!$litem->q5) ? '' : $litem->q5,
							  'q6' => (!$litem->q6) ? '' : $litem->q6,
							  'q7' => (!$litem->q7) ? '' : $litem->q7,
							  'q8' => (!$litem->q8) ? '' : $litem->q8,
							  'q9' => (!$litem->q9) ? '' : $litem->q9,
							 'q10' => (!$litem->q10) ? '' : $litem->q10,

							 'skl' => $litem->skl,
						  'price' => $litem->price,
						 'mprice' => $litem->mprice,
							 'dsc' => $litem->dsc,
						  'allow' => $litem->sizes,
									);
			
				$data_row = get_cart_row($item,$this);
				echo $data_row;
			}
		else 
			{	if($this->sale_lib->count_cart()) 
					{ echo '';}
				else 
					{ echo "<tr><td colspan='17'><div class='warning_noitems' style='background-color:rgba(230,230,100,0.35);padding:10px;'>".
							 $this->lang->line('sales_no_items_in_cart')."</div></td></tr>"; 
					}
			}
	}
	
	
	function delete_item($line)
	{
		$this->BiSOFT_Model->zebex_delete_line($line);
		$this->_reload();
	}

	function clientData()
	{
		$bisoft_id = 0;
		$customer_id = $this->sale_lib->get_customer();
		$cust_info=$this->Customer->get_info($customer_id);
		if($cust_info) {$bisoft_id = $cust_info->bisoft_id;}
		$comment = $this->sale_lib->get_comment();

		if($bisoft_id==1000)
		{
			$name 	= $this->sale_lib->get_client_name();
			$surname = $this->sale_lib->get_client_surname();
			$address = $this->sale_lib->get_client_data();
		}
		else
		{
			$name 	= $cust_info->first_name;
			$surname = $cust_info->last_name;
			$address = $cust_info->address;
		}
			$data = array(
			'customer_id' => $customer_id,
			  'bisoft_id' => $bisoft_id,
		  'company_name' => $cust_info->company_name,
		 		 'address' => $address,
					 'name' => $name,
				 'surname' => $surname,
				 'comment' => $comment );

		$this->load->view("sales/client_data",$data);
	}
	

	function save_clientData()
	{
		$comment = $this->input->post('comment');
		$this->sale_lib->set_comment($comment);
	
		$bisoft_id = $success = 0;
		$customer_id = $this->sale_lib->get_customer();
		$cust_info = $this->Customer->get_info($customer_id);
		if($cust_info) {$bisoft_id = $cust_info->bisoft_id;$person_id = $cust_info->person_id;}

		if($bisoft_id and $person_id)
		{
			$name = $this->input->post('name');
			$surname = $this->input->post('surname');
			$address = $this->input->post('address');
		
			if($bisoft_id!=1000)
			{
				$person_data = array(
					'bisoft_id'	=> $bisoft_id,
					'person_id'	=> $person_id,
					'first_name'=> $name,
					'last_name'	=> $surname,
					'address'	=> $address );
							
				$customer_data=array(
					'bisoft_id'	=> $bisoft_id,
					'person_id'	=> $person_id,
			  'company_person'=> $name.' '.$surname );
				
				$success = $this->Customer->save($person_data,$customer_data,$person_id);
			}
			
			$this->sale_lib->set_client_name($name);
			$this->sale_lib->set_client_surname($surname);
			$this->sale_lib->set_client_data($address);
		}

		echo json_encode(array('success'=>true,
										'message'=>$this->lang->line('items_successful_updating') ));
	}

// ============================================= COMPLETE ============================================= //
	function complete()
	{
		sleep(0.25);	
		$location = $this->BiSOFT_Model->get_location();
		$person_report = 1;
		if(!$this->Employee->has_permission('reports',$this->Employee->get_logged_in_employee_info()->person_id))
			{ $person_report = 0; }

		$mode = $this->sale_lib->get_mode();
		$data['mode'] = $mode;
		$data['cart'] = $this->BiSOFT_Model->zebex_get_all($mode);
		
		// Определям КЛИЕНТА / КОНСИГНАТОРА ...
		$data['customer_company'] = $data['customer_data'] = '';
		$client_status = $client_taxable = 0;
		$bisoft_id = $data['customer'] = $data['customer_discount'] = $data['customer_due'] = 0;

		if( ($mode=='sale' or $mode=='sale_return') and !$location )  // само за продажби ...
		{
			$customer_id=$this->sale_lib->get_customer();
			if($customer_id!=-1)
			{
					if(is_numeric($customer_id))
						{
							$cust_info=$this->Customer->get_info($customer_id);
							if($cust_info)
							{
								$bisoft_id=$cust_info->bisoft_id;
								$client_status=$cust_info->status;
								$client_taxable=$cust_info->taxable;
							
								$data['customer']=$cust_info->company_person;
								$data['customer_company']=$cust_info->company_name;
								$data['customer_discount']=$cust_info->discount;
								
								// НАСЕЛЕНИЕ
								if($bisoft_id==1000)
								{
									$clientName = $this->sale_lib->get_client_name();
									$clientSurname = $this->sale_lib->get_client_surname();
									$data['customer'] = $clientName.' '.$clientSurname;
									$data['customer_company']=$cust_info->company_name;
									$data['customer_discount']=0;
								} // END НАСЕЛЕНИЕ
							}
						}
					else // клиент ONLINE
						{
							$bisoft_id=1000000;
								$data['customer']=$customer_id;
								$data['customer_company']=$customer_id;
								$data['customer_discount']=0;
						}
			}

		}
		elseif ( ($mode=='shop_sale' or $mode=='shop_return') and $location > 0 )  // само за магазинни продажби ...
			{ 
				$bisoft_id=$location;
				if($bisoft_id>0)
				{
					$cust_info=$this->Consignee->get_info_by_bisoft_id($bisoft_id);
						$data['customer']=$cust_info->company_person;
						$data['customer_company']=$cust_info->company_name;
						$data['customer_discount']=$cust_info->discount;
				}
			}
		elseif ( $mode=='consi_sale' and $location == 0 )  // само за отчет на консигнации ...
			{ 
				$bisoft_id=$this->sale_lib->get_consignee();
				if($bisoft_id>0)
				{
					$cust_info=$this->Consignee->get_info_by_bisoft_id($bisoft_id);
						$data['customer']=$cust_info->company_person;
						$data['customer_company']=$cust_info->company_name;
						$data['customer_discount']=$cust_info->discount;
				}
			}
		elseif ( ($mode=='online_sale' or $mode=='online_return') and $location == 0 )  // само за onlines ...
			{ 
				$bisoft_id=1000000;
					$data['customer']=$customer_id=$this->sale_lib->get_online_client();
					$data['customer_company']=$customer_id;
                  if($customer_id=='-1') {$data['customer_company']='<< АНОНИМЕН >>';}
					$data['customer_discount']=0;
			}

		$customer_discount = $data['customer_discount'];
		$data['mode_price'] = $this->sale_lib->get_mode_price();

		// определям ДДС-то ...
		$taxed = 0;
		$mode_price = $data['mode_price'];
		if($mode_price == 'vat' or $mode=='online_sale' or $mode=='online_return') 
         { 
            $taxed=1;$customer_discount=$data['customer_discount']=0;
            $this->sale_lib->set_mode_price(100);
            $data['mode_price'] = $this->sale_lib->get_mode_price();
         }
		if($location==0 and $client_status=='onlineto' and $client_taxable) // специалните клиенти
         { $taxed=1;$customer_discount=$data['customer_discount']=0;}
		$data['taxed'] = $taxed;

		$data['tax_VAT']	= to_currency_no_money($this->sale_lib->get_tax_VAT($mode,$taxed));
		$data['currency']	= $this->config->item('currency_symbol');
		$data['all_qty']	= $this->sale_lib->get_all_qty();

		// $data['subtotal']	= to_currency_no_money($this->sale_lib->get_subtotal($mode));
		$data['subtotal']	= to_currency_no_money($this->sale_lib->get_real_subtotal($mode));
		$data['total'] = to_currency_no_money($this->sale_lib->get_total($mode,$customer_discount,$taxed));
		
		$data['payments']=$this->sale_lib->get_payments($mode);
		$data['amount_change']=to_currency($this->sale_lib->get_amount_due($mode,$taxed) * -1);		
		
		// само за играта 3 за 2
		$location_lock = 0;
		if($location>0 and $location<11 and $location!=7) {$location_lock = 1;} // само без Красьо=7 ?!
		$data['three4two']=$data['three4two_suma']=0;
		if($location_lock and $this->OnLine->get_three4two() and count($data['cart'])>2)
         {
            $data['three4two']=1;
            $data['three4two_suma']=$this->sale_lib->get_three4two_discount();
         }

		//изтегля и разпределя атрибутите на документа  ..
		$doc_date = date('Y-m-d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['transaction_time']= date('Y-m-d');
			$vedom		= $this->BiSOFT_Model->get_vedom($mode);
			$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
			$doc_name	= $this->BiSOFT_Model->get_document_title($mode);

		$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
		$emp_info=$this->Employee->get_info($employee_id);
		$data['employee']=$emp_info->first_name.' '.$emp_info->last_name;         

		$comment = $this->sale_lib->get_comment();

		//SAVE sale to database
		$data['doc_id'] = $this->Sale->save(
												$data['cart'], 
												$mode, 
												$data['all_qty'], 
												$data['subtotal'],
												$doc_number, 
												$doc_name,	
												$bisoft_id,
												$data['customer_company'], 
												$customer_discount, 
												$employee_id, 
												$data['payments'], 
												$comment);

		$doc_id = $data['doc_id'];

		if ($doc_id == 'doc-1')
		{ $data['error_message'] = $this->lang->line('sales_transaction_failed');}
		else
		{
			if ($this->sale_lib->get_email_receipt() && !empty($cust_info->email))
			{
				$this->load->library('email');
				$config['mailtype'] = 'html';				
				$this->email->initialize($config);
				$this->email->from($this->config->item('email'), $this->config->item('company'));
				$this->email->to($cust_info->email); 
				$this->email->subject($this->lang->line('sales_receipt'));
				$this->email->message($this->load->view("sales/receipt_email",$data, true));	
				$this->email->send();
			}
		}

		// определяме Ведомостта и вид на ПЕЧАТ...
		$vedomPack	= 'V'.date('ym', strtotime($doc_date));
		$print_type = $this->sale_lib->get_mode_print();
		$backNoKey	= false;

		$this->sale_lib->clear_all();
		$this->BiSOFT_Model->zebex_delete();
		$this->BiSOFT_Model->clear_user_modes();
			$mode_menu = 'sales';
			$this->BiSOFT_Model->set_mode_menu($mode_menu);

		// викам документа
		if ( $location ==0 ) 
			{	require_once(APPPATH."plugins/bisoft/blanka_sales_print.php");}
		else
			{ 	$this->_reload(); } 
	}
	

// ========================== COMPLETE PREPARATION EXPEDITION ======================= //
	function complete_prep()
	{
		sleep(1);
		$location = $this->BiSOFT_Model->get_location();
		$mode = $this->sale_lib->get_mode();
      if($location>0 or $mode!='prep_sale') 
         { 
				header("Location: ".BISOFT."index.php/sales");
         } // ГРЕШКА не е обект 0.
				
		$data['mode'] = $mode;
		$data['cart'] = $this->sale_lib->get_cart();
		$order_No = $this->input->post('order_No');
		$order_date = date('Y-m-d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));

		$customer_id=$this->sale_lib->get_customer();
		$cust_info=$this->Customer->get_info($customer_id);
		$data['bisoft_id']=$bisoft_id=$cust_info->bisoft_id;
		$client_status=$cust_info->status;
		$client_taxable=$cust_info->taxable;
							
			$data['customer']=$cust_info->company_person;
			$data['customer_company']=$cust_info->company_name;
			$data['customer_discount']=$cust_info->discount;
			$data['taxed']=$taxed=$cust_info->taxable;

		// определям ДДС-то ...
		$mode_price='vat';$data['taxed']=$taxed=1;$customer_discount=$data['customer_discount']=0;

		$data['tax_VAT']	= to_currency_no_money($this->sale_lib->get_tax_VAT($mode,$taxed));
		$data['currency']	= $this->config->item('currency_symbol');
		$data['all_qty']	= $this->sale_lib->get_all_qty();

		$data['subtotal']	= to_currency_no_money($this->sale_lib->get_real_subtotal($mode));
		$data['total'] = to_currency_no_money($this->sale_lib->get_total($mode,$customer_discount,$taxed));
		
		$data['payments']=$this->sale_lib->get_payments('sale'); // изкуствено.
		$data['amount_change']=to_currency($this->sale_lib->get_amount_due($mode,$taxed) * -1);		

		$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
		$emp_info=$this->Employee->get_info($employee_id);
		$data['employee']=$emp_info->first_name.' '.$emp_info->last_name; 
		
		//изтегля и разпределя атрибутите на документа  ..
		$doc_date = $order_date;
		$data['transaction_time']= date('Y-m-d');
		// $vedom		= $this->BiSOFT_Model->get_vedom($mode);
		$doc_name	= $this->BiSOFT_Model->get_document_title($mode);

		// определяме Ведомостта и вид на ПЕЧАТ...
		$vedomPack = 'V'.date('ym', strtotime($doc_date));
		$print_type = $this->sale_lib->get_mode_print();
		
		// стария документ
		$doc_info=array();
		if($this->Sale->exists_prep_client($bisoft_id)) 
         {
            $doc_info = $this->Sale->get_prep_info($bisoft_id);
            $doc_number	= $doc_info['doc_number'];
            $doc_id = $doc_info['doc_id'];
            $this->Suspended->delete($doc_id);
         }
		else {$doc_number	= $this->BiSOFT_Model->get_document_number($mode);} // взима НОВ номер ...

		if($order_No) { $comment = 'Поръчка No: '.$order_No.' от '.$this->input->post('order_date');}
      else { $comment = '';}
					 
		// SAVE sale to Suspended  $data['doc_id'] = //
		$data['doc_id'] = $this->Suspended->save(
													$data['cart'], 
													$mode, 
													$data['all_qty'], 
													$data['subtotal'],
													$doc_number, 
													$doc_name,	
													$bisoft_id, 
													$data['customer_discount'], 
													$employee_id,
													$taxed,
													$order_No,
													$order_date,
													$comment );
													

		if ($data['doc_id'] == 'doc-1')
         { $data['error_message'] = $this->lang->line('sales_transaction_failed');}

      // определяме вида на ВЕДОМОСТТА и ПЕЧАТА...
		$print_type	= $this->sale_lib->get_mode_print();
		$vedomPack	= 'V'.date('ym', strtotime($doc_date));
		$backNoKey	= false;
		
      $this->sale_lib->clear_all();
      $this->BiSOFT_Model->zebex_delete();
      $this->BiSOFT_Model->clear_user_modes();
			$mode_menu = 'sales';
			$this->BiSOFT_Model->set_mode_menu($mode_menu);

      $this->_reload(array('success' => $this->lang->line('sales_successfully_suspended_sale')));
   }
	

	// СПИРАМ ТОВА ... за всички документи ------- RECEIPT --------- //
	function receipt($doc_id,$vedomPack,$print_type='prices',$mode='sale')
	{
		$user_id   = $this->BiSOFT_Model->get_person();
		$sale_info = $this->Sale->get_info($doc_id,$vedomPack)->row_array();
		$location = $sale_info['location'];
		$mode = $sale_info['mode'];


		$taxed = $sale_info['taxed'];		
		if($taxed==1 and $mode=='sale')
		{
			$mode='online_sale';
			$this->sale_lib->set_mode($mode);
			$data['mode'] = $mode;
		}
		else // всички нормални документи ...
		{
			$this->sale_lib->set_mode($mode);
			$data['mode'] = $mode;
		}

		if ($mode=='online_sale')
			{ $this->sale_lib->copy_online_sale($doc_id,$vedomPack);}
		else
			{ $this->sale_lib->copy_entire_sale($doc_id,$vedomPack);}
		
		// $data['cart']		= $this->sale_lib->get_cart();
		$data['cart']			= $this->BiSOFT_Model->zebex_get_all($mode);
		$data['mode_price'] = $this->sale_lib->get_mode_price();
		$data['subtotal']	= to_currency_no_money($this->sale_lib->get_subtotal($mode));
		$data['taxes']		= $this->sale_lib->get_taxes();
		$data['tax_VAT']	= $taxed;
		$data['currency']	= ' лв.'; // $this->config->currency_symbol;
		$data['all_qty']	= $this->sale_lib->get_all_qty();

		// определям ДДС-то ....
		$data['taxed']	= $taxed;

		//изтегля и разпределя атрибутите на документа  ..
			$vedom		= $this->BiSOFT_Model->get_vedom($mode);
			$doc_name	= $this->BiSOFT_Model->get_document_title($mode);
			$doc_number	= $sale_info['doc_number'];
			$doc_date 	= $sale_info['doc_date'];

		$data['transaction_time']= $sale_info['doc_date'];
		$bisoft_id = $sale_info['client_id'];
		$location_id = $location;
		if(isset($sale_info['location']) and $sale_info['location']!=0) { $location_id = $sale_info['location'];}

		if	( $location != 0)
			{ $data['magazin_name'] = $this->Consignee->get_info_by_bisoft_id($location)->company_name;}
		elseif ($mode=='shop_sale' or $mode=='consi_sale')
			{ $data['magazin_name'] = $this->Consignee->get_info_by_bisoft_id($location_id)->company_name;}
		
		$emp_info=$this->Employee->get_info($sale_info['employee_id']);
		$data['payment_type']	= $sale_info['pay_type'];
		$data['payments']			= $sale_info['pay_type'];
		if(($mode=='shop_sale' or $mode=='shop_return') and $user_id < 11) // само за НАС
			{$data['payments']=  $sale_info['pay_type'].'<br><u>отчет:<b>'.to_dot($sale_info['pay_sale']).
                              $this->Appconfig->get('currency_symbol').'</b></u>';}
		
		$data['amount_change']	= to_currency($this->sale_lib->get_amount_due($mode,$taxed) * -1);
		$data['employee']			= $sale_info['employee'];
		$data['employee_id']		= $sale_info['employee_id'];
		$data['location']			= $sale_info['location'];
		$data['comment']			= $sale_info['comment'];
			
		if($mode=='online_sale' or $mode=='online_return')
			{
				$data['online'] 			 = $sale_info['client'];
				$data['online_address']  = $sale_info['comment'];
				$data['online_delivery'] = $sale_info['delivery'];
				$data['online_email'] 	 = $sale_info['employee']; if($mode=='online_return') {$data['online_email']='';}
				$data['online_tax'] 		 = $sale_info['total_taxes'];
				$data['online_track'] 	 = $sale_info['order_id'];
			}
		elseif($bisoft_id > 0)
			{
				if ( $mode=='consi_sale' or $mode=='shop_sale' )
						{ $cust_info=$this->Consignee->get_info_by_bisoft_id($bisoft_id);}
				else	{ $cust_info=$this->Customer->get_info_by_bisoft_id($bisoft_id);}
			
				$data['customer']=$cust_info->company_person;
				$data['customer_company']=$cust_info->company_name;
				$data['customer_account_number']=$cust_info->account_number;
				$data['customer_taxable']=$cust_info->taxable;
					if($taxed) {$data['online_tax']=$sale_info['total_taxes'];}  // за Online eMAG	
				$data['customer_address']='';
			} 

		$customer_discount = $sale_info['total_discount'];
		$data['customer_discount'] = $customer_discount;

		$data['total'] = to_currency_no_money($this->sale_lib->get_total($mode,$customer_discount,$taxed));

		if(isset($sale_info['giftcard']) and $sale_info['giftcard'])
		  { 
			 $data['giftcard'] = $sale_info['giftcard'];
			 $data['giftprocent'] = $sale_info['giftprocent'];
			 $data['giftvalue'] = $sale_info['giftvalue'];
		  }
		 else
		  { $data['giftcard'] = $data['giftprocent'] = $data['giftvalue'] = 0; }
		
		$data['voucher']=0;
		if($data['giftprocent'] and $data['giftvalue']==0)
		   { 
            if(strtolower(substr($data['giftcard'],0,5))!='promo')
            {  // нормален vip без започващи с 'promo' ...
               if($mode!='online_sale' and $mode!='online_return')
               {
                  $data['subtotal'] -= round($data['giftprocent'] * $data['subtotal'] / 100, 2);
                  $data['total'] -= round($data['giftprocent'] * $data['total'] / 100, 2);
               }
               else {$data['voucher']=$data['total']-$data['subtotal'];}
				}
		   }
		   
      if($data['giftvalue'] and $data['giftprocent']==0)
		   { 
            if(strtolower(substr($data['giftcard'],0,5))!='promo')
            {  // нормален vip без започващи с 'promo' ...
               $data['subtotal'] -= $data['giftvalue'];
               $data['total'] -= $data['giftvalue'];
				}
		   }

		$data['receipt_name'] 	= $doc_name;
		$data['receipt_number'] = $doc_number;
		$data['receipt_date'] 	= date('d.m.Y', strtotime($data['transaction_time']));
		$data['receipt_time'] 	= date('d.m.Y H:i');
		$data['print_date'] 		= date('H:i / d.m.Y', strtotime($sale_info['date_start']));
		$data['bisoft_id'] 		= $bisoft_id;
		$data['vedomPack'] 		= 'V'.date('ym', strtotime($doc_date));
		
		$data['allow_prices'] = 0;
		if ($print_type == 'sizes_prices') { $data['allow_prices']=1;}
		
		$data['controller_name']=strtolower(get_class());

		if ($print_type=='prices') 
			{ $this->load->view("bisoft/blanka_prices",$data);}
		elseif ($print_type=='sizes' or $print_type=='sizes_prices')
			{ $this->load->view("bisoft/blanka_sizes",$data);}
			
	$this->sale_lib->clear_all();
	$this->BiSOFT_Model->clear_user_modes();
	}

	function cancel_sale()
	{
		$mode = $this->sale_lib->get_mode();
		$this->BiSOFT_Model->zebex_clear_all($mode);
		$this->sale_lib->clear_all();
		$this->_reload();
	}
    
    
	function print_online($doc_id,$vedomPack)
	{
		$data = array();
		$items = $this->BiSOFT_Model->get_document_items($doc_id,$vedomPack)->result_array();
		$doc_data = $this->BiSOFT_Model->get_document_info($doc_id,$vedomPack);
		if($items)
		{
			foreach($items as $item)
			{
				$inum = $item['item_number'];
				$name = $this->Item->get_name($inum);
				$all_Sizes = $this->Item->get_sizes($inum);
				
				$size='';
				$Qty = explode(',',$item['item_name']);
				for ($x=1; $x<11;$x++)
				{
					if($Qty[$x]>0)
					{ $size = $all_Sizes[$x];}
				}
		
				$data[$inum] = array(
						'inum' => $inum,
						'name' => $name,
						 'qty' => $item['item_qty'],
						'size' => $size );
			}
		}

		$items = array('items'=> $data,
							'order'=> $doc_data->doc_number,
							'date'=> date('d.m.Y',strtotime($doc_data->doc_date)),
							'client'=> $doc_data->client);
							
		$this->load->view("sales/print_online",$items);
	}    
    
	function print_to($mode='sale')
	{  // тук трябва да е друго нещо ...
		$this->complete();
	}


	function edit($doc_id,$vedomPack,$print_type,$mode)
	{
		$data = array();
		$data['vedomPack'] = $vedomPack;
		$data['print_type'] = $print_type;

		$data['doc_info'] = $this->Sale->get_info($doc_id,$vedomPack)->row_array();

		if($mode=='shop_sale' or $mode=='shop_return')
		{	// вземам си всички КОНСИГНАТОРИ
			$data['customers'] = array();
			foreach ($this->Consignee->get_all()->result() as $consignee)
				{ $data['customers'][$consignee->bisoft_id] = character_limiter($consignee->company_name,45);}
		}
		else
		{	// вземам си всички КЛИЕНТИ
			$data['customers'] = array('' => $this->lang->line('reports_edit_noclient'));
			foreach ($this->Customer->get_all()->result() as $customer)
				{ $data['customers'][$customer->bisoft_id] = character_limiter($customer->company_name,45);}
				
			// вземам си БРАНДОВЕ
				$data['brand'] = $data['doc_info']['brand'];
				$data['brands'] = array('0' => $this->lang->line('reports_all_brands'));
				foreach ($this->BiSOFT_Model->get_brands()->result() as $brand)
					{ $data['brands'][$brand->client_id] = character_limiter($brand->name,40); }
		}

		// вземам си всички ОПЕРАТОРИ
		$data['employees'] = array();
		foreach ($this->Employee->get_operators()->result() as $employee)
			{ $data['employees'][$employee->person_id] = $employee->first_name . ' '. $employee->last_name;}

		$data['mode'] = $data['doc_info']['mode'];
		$data['location'] = $data['doc_info']['location'];
		$data['type_docs'] = array(
			'sale' 			 => $this->lang->line('sales_sale'),
			'sale_return' 	 => $this->lang->line('sales_return_sale'),
			'shop_sale' 	 => $this->lang->line('sales_shop_sale'),
			'shop_return' 	 => $this->lang->line('sales_shop_return'),
			'online_sale'   => $this->lang->line('sales_online_sale'),
			'online_return' => $this->lang->line('sales_online_return'),
			'prep_sale'     => $this->lang->line('sales_prepare_sale') );

	$this->load->view('sales/edit', $data);
	}
	

	function save($doc_id, $vedomPack, $mode='sale')
	{
      $success  = 1;
      $brand = $this->input->post('brand_id');
		$doc_date = $this->input->post('doc_date');
		$vedomPack_new	= 'V'. date('ym', strtotime($doc_date));
		
		// Дата на плащане
		$pay_date = $this->input->post('pay_date');
		if($pay_date=="1970-01-01" or $pay_date=="0000-00-00" or $pay_date=="01.01.1970" or $pay_date==null) {$pay_date=null;}
		else { $pay_date=date('Y-m-d', strtotime($pay_date)); }
		// Плащане
		$pay_sale = $this->input->post('pay_sale');
		if($pay_sale==0) {$pay_date=null;}

		if ($mode!='online_sale' and $mode!='online_return')
			{ 
				$mode = $this->input->post('type_doc'); 
				$employee_id 	= $this->input->post('employee_id');
				$employee	 	= $this->Employee->get_info($employee_id)->first_name
							 .' '. $this->Employee->get_info($employee_id)->last_name;
			}

		$mode_id = $this->BiSOFT_Model->get_pay_group( $mode );
		$line_id = date('ym', strtotime($doc_date)).str_pad($doc_id, 4, "0", STR_PAD_LEFT);

		$taxed  = $this->input->post('taxed') ? 1 : 0;
		$valuta = '1';
		$valuta_rate = '1.0000';
		
		$total_sum 	 = $this->input->post('total_sum');
		$total_taxes = $this->input->post('total_taxes');
		$pay_amount  = $this->input->post('pay_amount');

		if($mode=='shop_sale' or $mode=='shop_return') // САМО ЗА МАГАЗИНИТЕ ...
			{
				$client_id = $this->input->post('client_id') ? $this->input->post('client_id') : 0;
				if ( $client_id == 0 ) { $client = '';}
				else { $client = $this->Consignee->get_info_by_bisoft_id($this->input->post('client_id'))->company_name;}
				$location = $this->input->post('client_id') ? $this->input->post('client_id') : 0;

				$doc_data = array(
					'doc_date' 		=> date('Y-m-d', strtotime($doc_date)),
					'mode' 			=> $mode,
					'mode_id' 		=> $mode_id,
					'client_id' 	=> $client_id,
					'client' 		=> $client,
					'total_qty' 	=> $this->input->post('total_qty'),
					'total_sum' 	=> $total_sum,
				'total_discount'	=> $this->input->post('total_discount'),
					'pay_group'		=> $this->input->post('pay_group'),
					'pay_type' 		=> $this->input->post('pay_type'),
					'pay_amount'	=> $pay_amount,
					'pay_sale'		=> $pay_sale,
					'pay_date'		=> $pay_date,
					'due_sum'		=> $this->input->post('due_sum'),
					'taxed' 			=> $taxed,
					'total_taxes' 	=> $total_taxes,
					'employee_id' 	=> $employee_id,
					'employee' 		=> $employee,
					'comment' 		=> $this->input->post('comment'),
					'location' 		=> $location );

				$items_data = array(
					'doc_date' 		=> date('Y-m-d', strtotime($doc_date)),
					'mode_id' 		=> $mode_id,
					'item_taxes' 	=> $taxed,
					'client_id' 	=> $client_id,
					'location' 		=> $location );
			}
		elseif($mode=='online_sale' or $mode=='online_return') // за online Shop ------------------- //
			{
				$doc_data = array(
					'doc_date' 		=> date('Y-m-d', strtotime($doc_date)),
					'mode' 			=> $mode,
					'mode_id' 		=> $mode_id,
					'delivery' 		=> $this->input->post('delivery'),
					'total_qty' 	=> $this->input->post('total_qty'),
					'total_sum' 	=> $total_sum,
				'total_discount'	=> $this->input->post('total_discount'),
					'pay_group'		=> $this->input->post('pay_group'),
					'pay_type' 		=> $this->input->post('pay_type'),
					'pay_amount'	=> $pay_amount,
					'pay_sale'		=> $pay_sale,
					'pay_date'		=> $pay_date,
					'due_sum'		=> $this->input->post('due_sum'),
					'taxed' 			=> $taxed,
					'total_taxes' 	=> $total_taxes,
					'order_id' 		=> $this->input->post('order_id'),
					'ref_id' 		=> $this->input->post('ref_id'),
					'brand'			=> 1,
					'comment' 		=> $this->input->post('comment')	);

				$items_data = array(
               'mode_id' 		=> $mode_id,
					'doc_date' 		=> date('Y-m-d', strtotime($doc_date)) );
			}
		elseif($mode=='discount') // за ОСТЪПКА ЗА КЛИЕНТИ //
			{
				$doc_data = array(
					'doc_date' 		=> date('Y-m-d', strtotime($doc_date)),
					'mode' 			=> $mode,
					'mode_id' 		=> 'ED',
					'total_qty' 	=> 1,
					'total_sum' 	=> $total_sum,
				'total_discount'	=> $this->input->post('total_discount'),
					'pay_group'		=> $this->input->post('pay_group'),
					'pay_type' 		=> $this->input->post('pay_type'),
					'pay_amount'	=> $pay_amount,
					'pay_sale'		=> $pay_sale,
					'pay_date'		=> $pay_date,
					'due_sum'		=> $this->input->post('due_sum'),
					'taxed' 			=> $taxed,
					'total_taxes' 	=> 0,
					'comment' 		=> $this->input->post('comment')	);

				$items_data = 0;
			}
		else  // за ВСИЧКИ ДОКУМЕНТИ, освен Магазините и online Shop-a ...
			{
				$location	= $this->input->post('location');
				$bank_mode	= 1;
				$order_id	= '';

				$client_id = $this->input->post('client_id') ? $this->input->post('client_id') : 0;
				if ( $client_id == 0 ) { $client = '';}
				else { $client = $this->Customer->get_info_by_bisoft_id($this->input->post('client_id'))->company_name;}

				$doc_data = array(
					'doc_date' 		=> date('Y-m-d', strtotime($doc_date)),
					'mode' 			=> $mode,
					'mode_id' 		=> $mode_id,
					'mode_price'	=> $bank_mode,
					'client_id' 	=> $client_id,
					'client' 		=> $client,
					'total_qty' 	=> $this->input->post('total_qty'),
					'total_sum' 	=> $total_sum,
				'total_discount'	=> $this->input->post('total_discount'),
					'pay_group'		=> $this->input->post('pay_group'),
					'pay_type' 		=> $this->input->post('pay_type'),
					'pay_amount'	=> $pay_amount,
					'pay_sale'		=> $pay_sale,
					'pay_date'		=> $pay_date,
					'due_sum'		=> $this->input->post('due_sum'),

					'currency'		=> $valuta,
					'currency_rate'=> $valuta_rate,

					'taxed' 			=> $taxed,
					'total_taxes' 	=> $total_taxes,
					'employee_id' 	=> $employee_id,
						'order_id' 	=> $order_id,
					'employee' 		=> $employee,
					'brand'			=> $brand,
					'location' 		=> $location,
					'comment' 		=> $this->input->post('comment') );

				$items_data = array(
					'doc_date' 		=> date('Y-m-d', strtotime($doc_date)),
					'mode_id' 		=> $mode_id,
					'item_taxes' 	=> $taxed,
					'client_id' 	=> $client_id,
					'brand'			=> $brand,
					'location' 		=> $location );
			}
			
		/* ================================================ */
		if ($vedomPack==$vedomPack_new)
		{ // действа САМО при ДАТА в същия месец //

			$success *= $this->Sale->update($doc_data, $doc_id, $vedomPack);
			// актуализира items ...
			$vedomItems = $vedomPack.'_items';
			if($items_data) {$success *= $this->Sale->update_items($items_data, $doc_id, $vedomItems);}

			if ($success)
				{ echo json_encode(array(	'success'=>true,
													'line_id'=>$line_id,
													'mode_id'=>$mode_id,
													'total'=>to_dot($total_sum),
													'taxes'=>to_dot($total_taxes),
													'amount'=>to_dot($pay_amount),
													'message'=> 'За да актуализирате общите сборове, моля освежете страницата - REFRESH !!!'
													// $this->lang->line('sales_successfully_updated')
												 )
										);
				}
			else
				{ echo json_encode(array(	'success'=>false,
													'line_id'=>$line_id,
													'mode_id'=>$mode_id,
													'message'=>$this->lang->line('sales_unsuccessfully_updated')
												 )
										);
				}
		}
	else // действа САМО при промяна на ДАТА //
		{
			// актуализира items ...
			$vedomItems = $vedomPack.'_items';
			$this->Sale->update_items($items_data, $doc_id, $vedomItems);

			// премества items ...
			$vedomItems_new = $vedomPack_new.'_items';
			$this->BiSOFT_Model->set_user_date(date('Y-m-d H:i:s',strtotime($doc_date)));
			$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
			$doc_data['doc_number'] = $doc_number;

		$this->db->trans_start(); // --> отваря запис към БАЗАТА ... -->> 
			// вкарва данните от Документа в Месечната База Данни ... //
			$this->db->insert( $vedomPack_new, $doc_data);
			$newdoc_id = $this->db->insert_id();

			$old_item_data = $this->Sale->get_sale_items($doc_id,$vedomPack);
			foreach($old_item_data->result_array() as $line=>$item)
			{
				$item['doc_id'] = $newdoc_id;
				$item['doc_number'] = $doc_number;
				$item['doc_date'] = date('Y-m-d', strtotime($doc_date));
				$this->db->insert($vedomItems_new,$item);
			}
		$this->db->trans_complete();
		
			if($this->delete($doc_id,$vedomPack)) // маха всичко старо //
				{ echo json_encode(array(	'success'=>true,
													'line_id'=>$line_id,
													'mode_id'=>$mode_id,
													'message'=>$this->lang->line('sales_successfully_moved'))
										);
				}
			else
				{ echo json_encode(array(	'success'=>false,
													'line_id'=>$line_id,
													'mode_id'=>$mode_id,
													'message'=>$this->lang->line('sales_unsuccessfully_updated'))
										);
				}
		}

	} // край


	function delete($doc_id,$vedomPack)
	{
		$data = array();
		if ($this->Sale->delete($doc_id,$vedomPack))
			{ $data['success'] = $this->lang->line('sales_delete_successful');}
		else
			{ $data['error'] = $this->lang->line('sales_delete_unsuccessful');}
	$this->load->view('sales/delete', $data);
	}
	
	
	// ================= AJAX edit vedom line ... ======================== //
	function edit_line_item($doc_idx)
	{
		$line   = (int)substr($doc_idx,-3);
		$doc_id = (int)substr($doc_idx,0,-7);
		$vedom  = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom;

		$data = array();
		$data['user_id']	 = $this->BiSOFT_Model->get_person();
		$data['vedomPack'] = $vedomPack;
		$data['line']      = $line;
		$data['doc_idx'] 	 = $doc_idx;
		$data['item_info'] = $item_info = $this->BiSOFT_Model->get_doc_item($doc_idx);
		$data['doc_info']  = $doc_info  = $this->BiSOFT_Model->get_info_by_doc_id($doc_id,$vedomPack)->row();
		$data['location']  = $location  = $item_info->location;
		
		$mode = $item_info->mode_id;
		$data['giftcard']  = 0;
		$data['giftprocent'] = $data['giftvalue'] = 0;

      // игра 3 за 2
		$data['three4two'] = $data['item_vat'] = $three4two = $item_vat = 0;
		$order_id = $doc_info->order_id;
		if($order_id=='three4two') {$data['three4two']=$three4two=1;}		
		
		if($mode=='SE' or $mode=='BP')
		{
			$data['commision'] = 0;
         $consi_info = $this->Consignee->get_info_by_bisoft_id($location);
         if($consi_info->discount)
         { $data['commision'] = (float)$consi_info->discount; }

			$data['giftcard'] = $giftcard = $doc_info->giftcard;
			$data['giftprocent'] = $giftprocent = $doc_info->giftprocent;
			$data['giftvalue'] = $giftvalue = $doc_info->giftvalue;
		}

		// събира всички останали dropdowns ...
		$data = $this->Item->get_all_dropdowns($data);		
	$this->load->view('sales/edit_line_item', $data);
	}
	
	
	function save_line_item($doc_idx)
	{
		$line   = (int)substr($doc_idx,-3);
		$doc_id = (int)substr($doc_idx,0,-7);
		$vedom  = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom;
		
		$doc_info = $this->BiSOFT_Model->get_info_by_doc_id($doc_id,$vedomPack)->row();
			$mode_id  = $doc_info->mode_id;
			$client   = $doc_info->client;
			$item_taxes = 0;
			$cust_info = array();
			if($mode_id=='E' or $mode_id=='BE')
            {  $cust_info = $this->Customer->get_info_by_bisoft_id($doc_info->client_id);
               if($cust_info)
               {
                  if($cust_info->status=='onlineto' and $cust_info->taxable and $doc_info->taxed)
                     {$item_taxes=round(0.2*$this->input->post('item_unit_price'),7);}
               }
            }
         elseif($mode_id=='SE' or $mode_id=='BP')
            { $consi_info = $this->Consignee->get_info_by_bisoft_id($doc_info->client_id);}
         elseif($mode_id=='OM' or $mode_id=='OMi' or $mode_id=='OMB')
            { $item_taxes=round(0.2*$this->input->post('item_unit_price'),7);}

		$to_delete = 0; if($this->input->post('deleted')) {$to_delete=1;} else {$to_delete=0;}
		$inum = $this->input->post('item_number');
		$allow_sizes = $this->Item->get_allow_sizes($inum);

		$item_qty = (int)$this->input->post('item_qty');
		$q1 = $q2 = $q3 = $q4 = $q5 = $q6 = $q7 = $q8 = $q9 = $q10 = '';
		$item_name = '';
				
		if($allow_sizes) 
			{	 
				$q1 = ($this->input->post('qty_1')!=0) ? $this->input->post('qty_1') : '';
				$q2 = ($this->input->post('qty_2')!=0) ? $this->input->post('qty_2') : '';
				$q3 = ($this->input->post('qty_3')!=0) ? $this->input->post('qty_3') : '';
				$q4 = ($this->input->post('qty_4')!=0) ? $this->input->post('qty_4') : '';
				$q5 = ($this->input->post('qty_5')!=0) ? $this->input->post('qty_5') : '';
				$q6 = ($this->input->post('qty_6')!=0) ? $this->input->post('qty_6') : '';
				$q7 = ($this->input->post('qty_7')!=0) ? $this->input->post('qty_7') : '';
				$q8 = ($this->input->post('qty_8')!=0) ? $this->input->post('qty_8') : '';
				$q9 = ($this->input->post('qty_9')!=0) ? $this->input->post('qty_9') : '';
				$q10 = ($this->input->post('qty_10')!=0) ? $this->input->post('qty_10') : '';
				
				$item_qty = (int)$q1 + (int)$q2 + (int)$q3 + (int)$q4 + (int)$q5 + 
								(int)$q6 + (int)$q7 + (int)$q8 + (int)$q9 + (int)$q10;
				
				$item_name = $item_qty.','.$q1.','.$q2.','.$q3.','.$q4.','.$q5.
											  ','.$q6.','.$q7.','.$q8.','.$q9.','.$q10.','.$client;
			}
			
			$items_data = array(
						'doc_id' => $doc_id,
						  'line' => $line,
				 'item_number' => $inum,
			'item_unit_price' => $this->input->post('item_unit_price'),
			  'item_discount' => $this->input->post('item_discount'),
              'item_taxes' => $item_taxes,
					 'costsale' => $this->input->post('costsale'),
					 'item_qty' => $item_qty,
					'item_name' => $item_name,
					  'deleted' => $to_delete );

		if ($this->BiSOFT_Model->update_line_item($items_data,$doc_idx))
			{
				$calc_data = $this->BiSOFT_Model->recalc_document($doc_idx);
	
				echo json_encode(array(
					'success'	=> true,
					'doc_row'	=> $doc_id.$vedom,
					'line'		=> $line,
					'line_id'	=> $doc_id.$vedom.str_pad($line, 3, "0", STR_PAD_LEFT),
					
					'qty_doc'   => $calc_data['qty_doc'],
					'sum_doc'   => $calc_data['sum_doc'],
					'dsc_doc'   => $calc_data['dsc_doc'],
					'all_doc'   => $calc_data['all_doc'],
					'tax_doc'   => $calc_data['tax_doc'],
				  'amount_doc' => $calc_data['amount_doc'],
				  'client_doc' => $calc_data['client_doc'],
					'cost_doc'  => $calc_data['cost_doc'],
					
					'total_sum' => $calc_data['total_sum'],
					'total_dsc' => $calc_data['total_cost']-$calc_data['total_pay'],
					'total_vat' => $calc_data['total_vat'],				
					'total_pay' => $calc_data['total_pay'],
					'total_qty' => $calc_data['total_qty'],
				  'total_cost' => $calc_data['total_cost'],				
					
					'message'	=> 'арт.'.$inum.' ... '.$this->lang->line('reports_edit_line_success')));
			}
		else
			{ 	echo json_encode(array(
					'success'	=> false,
					'doc_idx'	=> $doc_idx,
					'line'		=> $line,			
					'message'	=> $this->lang->line('reports_edit_line_unsuccess')));
			}
	}
	
	
	function get_document_row()
	{
		$doc_idx = $this->input->post('row_id');
		$line    = (int)substr($doc_idx,-3);
		$doc_id  = (int)substr($doc_idx,0,-7);
		$vedom   = (int)substr($doc_idx,-7,-3);
		$vedomPack = 'V'.$vedom;
			
		$doc_info = $this->BiSOFT_Model->get_info_by_doc_id($doc_id,$vedomPack)->row();
			$giftprocent = $doc_info->giftprocent;
			$giftvalue   = $doc_info->giftvalue;
			
		$item_info = $this->BiSOFT_Model->get_doc_item($doc_idx);
		$allow_sizes = $this->Item->get_allow_sizes($item_info->item_number);
		if($item_info and $item_info->deleted==0)
			{
				$Qty = array();
				if($allow_sizes)
					{ $Qty = explode(',',$item_info->item_name); }
				else 
					{ $Qty[1]=$Qty[2]=$Qty[3]=$Qty[4]=$Qty[5]=$Qty[6]=$Qty[7]=$Qty[8]=$Qty[9]=$Qty[10]=0;
					  $Qty[0]=$item_info->item_qty;}
			
				$item=array(
				 'controller' => 'Sales',
					  'vedom'  => $vedom,
				    'mode_id' => $item_info->mode_id,
					  'doc_id' => $doc_id,
						 'line' => $line,
						 'inum' => $item_info->item_number,
					   'price' => $item_info->item_unit_price,
						  'qty' => $item_info->item_qty,
						  'dsc' => $item_info->item_discount,
						  'tax' => $item_info->item_taxes,
				'giftprocent' => $giftprocent,
				  'giftvalue' => $giftvalue,
					'costsale' => $item_info->costsale,
							'q1' => (!$Qty[1]) ? '' : $Qty[1],
							'q2' => (!$Qty[2]) ? '' : $Qty[2],
							'q3' => (!$Qty[3]) ? '' : $Qty[3],
							'q4' => (!$Qty[4]) ? '' : $Qty[4],
							'q5' => (!$Qty[5]) ? '' : $Qty[5],
							'q6' => (!$Qty[6]) ? '' : $Qty[6],
							'q7' => (!$Qty[7]) ? '' : $Qty[7],
							'q8' => (!$Qty[8]) ? '' : $Qty[8],
							'q9' => (!$Qty[9]) ? '' : $Qty[9],
						  'q10' => (!$Qty[10]) ? '' : $Qty[10] );

				$data_row = get_vedom_row($item,"Sales");
				echo $data_row;
			}
			else { echo '';}
	}


	// не се използва ...
	function delete_line_item($doc_id, $line, $vedomPack)
	{ 
		// $this->Sale->delete_line_item($doc_id, $line, $vedomPack);
	}
	

	function _payments_cover_total()
	{
		$total_payments = 0;
		foreach($this->sale_lib->get_payments() as $payment)
			{ $total_payments += $payment['payment_amount'];}
	return true;
	}


// -------------------------- Функции за Магазини > 100 --------------------------------- //
	function view_sale($item_number)
	{
		$data['skl']  = $this->BiSOFT_Model->get_location();
		$data['inum'] = $item_number;		
		$data['name'] = $this->Item->get_name($item_number);
		$data['skl_info'] = $this->Item->get_sklad_info($item_number,$data['skl']);
		$data['item_info'] = $this->Item->get_item_info($item_number);
		// събира всички останали dropdowns ...
		$data = $this->Item->get_all_dropdowns($data);	
	$this->load->view("items/form_sale",$data);
	}
	
	
	/* =================== SKLAD ===================== */
	function sklad_mag_100()
	{	
		$this->load->model('reports/Shop_sklad');
		$model = $this->Shop_sklad;
		$tabular_data = array();
		$report_data = $model->getData(array());
	   $location = $this->BiSOFT_Model->get_location();
		if($location!=0) {$this->BiSOFT_Model->set_user_client($location);}

		$total_qty = $total_sum = 0;
		foreach($report_data as $row)
		{
			$inum = $row['inum'];
			$item_info = $this->Item->get_item_info($inum);
				$item_name 	 = $item_info->name;			
				$allow_sizes = $item_info->allow_sizes;
				if($inum<4000 or $inum>98000) {$allow_sizes=0;}
		
			if ($allow_sizes) {$width='width:820';}
			else {$width = 'width:450';}
			
			$vedom_link = anchor( 'sales/items_shop_details/'.$inum.'/'.$width,  // link
							$this->lang->line('items_shop_vedom'),
							array('class'=>'thickbox','title'=>$this->lang->line('items_shop_item_vedom')) );

			$price = round($row['price']*(100-$row['dsc'])/100,2);
			
		   $tabular_data[] = array(
					$inum,
					$item_name,
					$row['q1'],
					$row['q2'],
					$row['q3'],
					$row['q4'],
					$row['q5'],
					$row['q6'],
					$row['q7'],
					$row['q8'],
					$row['q9'],
					$row['q10'],
					$row['qty'], 
					to_dot($price),
					$vedom_link );

			$total_qty += $row['qty'];
			$total_sum += $row['qty'] * $price;
		}

		$data = array(
		"controller_name"=>strtolower(get_class()),
					"mode"  => 'sklad',
					"modes" => array(
								'shop_sale'	 	=> $this->lang->line('sales_shop_sale'),
								'shop_return'	=> $this->lang->line('sales_shop_return'),
								'sklad'			=> $this->lang->line('sales_shop_items'),
								'dneven'			=> $this->lang->line('sales_shop_daily') 
											),

					"title" 			=> $this->lang->line('reports_inventory_summary_report'),
					"subtitle" 		=> $this->lang->line('reports_consignee').': '.$this->Consignee->get_consi_name($location),
					"headers" 		=> $model->getDataColumns(),
					"data" 			=> $tabular_data,
					"summary_data" => $model->getSummaryData(array()),
					"export_excel" => 0,
					"total_qty" 	=> $total_qty,
					"total_sum" 	=> to_dot($total_sum),
					"location" 		=> $location );

	$this->load->view("sales/sklad_view",$data);
	}

	
	
	//BiSOFT Inventory Details
	public function items_shop_details($item_number)
	{
		$data['inum'] = $item_number;	
		$data['skl']  = $this->BiSOFT_Model->get_location();
		$data['name'] = $this->Item->get_name($item_number);
		$data['skl_info']  = $this->Item->get_sklad_info($item_number,$data['skl']);
		$data['item_info'] = $this->Item->get_item_info($item_number);		
		$data['location']  = $data['skl'];
		$data['vedom_pack'] = $this->BiSOFT_Model->get_vedom();
		$data['vedom_year'] = $this->BiSOFT_Model->get_user_mode_year();
	$this->load->view("items/items_shop_details",$data);
	}

	
	/* ============================== DNEVEN OTCHET =========================== */
	function dneven_mag_100()
	{	
		$location = $this->BiSOFT_Model->get_location();
		if($location!=0) {$this->BiSOFT_Model->set_user_client($location);}
		$person_report = 1;
		if(!$this->Employee->has_permission('reports',$this->Employee->get_logged_in_employee_info()->person_id))
			{ $person_report = 0; }
		$data['person_report'] = $person_report;

		$dateKey = $this->sale_lib->get_dateKey();

		$this->load->model('reports/Daily_sales');
		$model = $this->Daily_sales;

		$daily_date = $this->BiSOFT_Model->get_user_mode_date();

		$daily_tab_data = array();
		$report_data = $model->getData(array('start_date' => $daily_date, 'sale_type' => 'all'));

		$all_qty = $all_total = $all_cost = $all_cash = $all_bank = 0;
	    foreach($report_data as $row)
	    {
			$skl_info  = $this->Item->get_sklad_info($row['item_number']);
			$item_name = $this->Item->get_inum_name($row['item_number']);
			$allow_sizes = $this->Item->get_allow_sizes($row['item_number']);
			if ($person_report) { $price_I = $row['item_unit_price'];}
			else { $price_I = $skl_info->price; } // тук ЛЪЖЕМ Магазина с цена-Iгр.?!?

			$payment = $model->getPayment(array('start_date'=>$daily_date, 'doc_id' => $row['doc_id']));

			$giftprocent = $model->getGiftprocent($row['doc_id'],$daily_date);
			$giftvalue = $model->getGiftvalue($row['doc_id'],$daily_date);
			
			$mSuma = round($row['item_unit_price'] * (100 - $row['item_discount']) / 100, 4);
			if($giftprocent) {$mSuma=round($mSuma*(100-$giftprocent)/100,4);}
			
			$item_discount = '';
			if(intval($row['item_discount']) != 0) { $item_discount = $row['item_discount'].'%';}
			elseif($giftprocent>0) { $item_discount = 'vip'.$giftprocent.'%';}
			elseif($giftvalue>0) { $item_discount = 'v-'.round($giftvalue,0).'лв';}
			
			$vedom = 'V'.date('ym',strtotime($daily_date));
			$pay_vid = $this->BiSOFT_Model->get_document_pay_group($vedom,$row['doc_id']);
			
			$all_qty += $row['item_qty'];		
			$all_total += $row['item_qty'] * $mSuma;
			$all_cost  += $row['item_qty'] * $row['costsale'];
			
			if($pay_vid=='P') {$all_cash += $row['item_qty'] * $row['costsale'];}
			elseif($pay_vid=='kC' or $pay_vid=='dC') {$all_bank += $row['item_qty'] * $row['costsale'];}
			elseif($pay_vid=='BP') {$all_cash -= abs($row['item_qty'] * $row['costsale']);}

		$Qty = array();
		if($allow_sizes)
		{
         $Qty = explode(',',$row['item_name']);
      }
      else
      {
         $Qty = array('0'=>$row['item_qty'],'1'=>'','2'=>'','3'=>'','4'=>'','5'=>'','6'=>'','7'=>'','8'=>'','9'=>'','10'=>'');		
		}
			
		$daily_tab_data[] = array(
				$row['item_number'], 
				$item_name,
				$Qty[1],$Qty[2],$Qty[3],$Qty[4],$Qty[5],$Qty[6],$Qty[7],$Qty[8],$Qty[9],$Qty[10],
				$row['item_qty'],
				to_currency_no_money($price_I),
				$item_discount,
				to_currency_no_money($mSuma),
				to_currency_no_money($mSuma * $row['item_qty']),
				to_currency_no_money($row['costsale'] * $row['item_qty']),
				$pay_vid,
				$row['mode_id'],
				$row['location'] );
	    }

		$data = array(
			"mode" 			=> 'dneven',
			"modes"			=> array(
											'shop_sale'	 	=> $this->lang->line('sales_shop_sale'),
											'shop_return'	=> $this->lang->line('sales_shop_return'),
											'sklad'			=> $this->lang->line('sales_shop_items'),
											'dneven'			=> $this->lang->line('sales_shop_daily')
											),
			"title" 			=> $this->lang->line('reports_daily_sales_report'),
			"subtitle" 		=> $this->lang->line('reports_consignee').': '.$this->Consignee->get_consi_name($location).'<br>'.date('d.m.Y', strtotime($daily_date)),
			"headers" 		=> $model->getDataColumns(),
			"data" 			=> $daily_tab_data,
			"dateKey"		=> $dateKey,
			"summary_data" => array(), // $model->getSummaryData(array()),
			"export_excel" => 0,
			"person_report"=> $person_report,
			"total_qty" 	=> $all_qty,
			"total_sum" 	=> to_dot(round($all_total,1)),
			"total_cost" 	=> to_dot(round($all_cost,1)),
			"total_cash"	=> to_dot(round($all_cash,1)),
			"total_bank"	=> to_dot(round($all_bank,1))
									);

		$data['modes_years']=array();
		for($k=0;$k<3;$k++) { $data['modes_years'][date("Y")-$k] = date("Y")-$k;}
		
		$data['modes_months'] = array(
			'01' => $this->lang->line('cal_january'),
			'02' => $this->lang->line('cal_february'),
			'03' => $this->lang->line('cal_march'),
			'04' => $this->lang->line('cal_april'),
			'05' => $this->lang->line('cal_mayl'),
			'06' => $this->lang->line('cal_june'),
			'07' => $this->lang->line('cal_july'),
			'08' => $this->lang->line('cal_august'),
			'09' => $this->lang->line('cal_september'),
			'10' => $this->lang->line('cal_october'),
			'11' => $this->lang->line('cal_november'),
			'12' => $this->lang->line('cal_december')	);

		$data['modes_days'] = array();
		for($k=1;$k<=31;$k++) { $data['modes_days'][$k] = $k;}

		$data['mode_day']		= (int) date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['mode_month']	= (int) date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		
		$data['controller_name']=strtolower(get_class());

	$this->load->view("sales/daily_table",$data);
	}


	function sklad_dneven_home()
	{	
    	$this->sale_lib->clear_all();
		$this->BiSOFT_Model->clear_user_modes();
	$this->_reload();
	}


	function about_DATE()
	{
		$mode = $this->BiSOFT_Model->get_user_mode();
		if ($mode != 'sklad')
			{
				if ( !$this->sale_lib->get_dateKey() ) 
					{ !$this->sale_lib->set_dateKey(); }
				else	
					{ !$this->sale_lib->clear_dateKey(); }
			}
	$this->_reload();
	}
// ------------------- Край на Магазини > Report Permission ----------------- //




// ---------------------------------  SUSPEND ---------------------------------- //

	function suspend()
	{
		$data=array();		
		$data['location'] = $location = $this->BiSOFT_Model->get_location();
		$data['mode']		= $mode = $this->sale_lib->get_mode();
		
		$customer_discount = 0;
		$taxed = 0;
		$customer_id=$this->sale_lib->get_customer();
		$bisoft_id = 0;

		if($customer_id!=-1)
		{
			$cust_info=$this->Customer->get_info($customer_id);
			$bisoft_id=$cust_info->bisoft_id;
			$data['customer']=$cust_info->company_person;
			$data['customer_email']=$cust_info->email;
			$data['customer_company']=$cust_info->company_name;
			$data['customer_discount']=$customer_discount=$cust_info->discount;
			$data['customer_account_number']=$cust_info->account_number;
			$data['customer_address']=''; // $cust_info->city.', '.$cust_info->address;
			$taxed = $cust_info->taxable;
		} else {	$data['customer_discount'] = 0;}

		$data['cart']		= $this->sale_lib->get_cart();
		$data['subtotal']	= to_currency_no_money($this->sale_lib->get_subtotal($mode));
		$data['taxes']		= $this->sale_lib->get_taxes();
		$data['tax_VAT']	= to_currency_no_money($this->sale_lib->get_tax_VAT($mode,$taxed));
		$data['total']		= to_currency_no_money($this->sale_lib->get_total($mode,$customer_discount,$taxed));
		$data['currency']	= ' лв.'; // $this->config->currency_symbol;
		$data['all_qty']	= $this->sale_lib->get_all_qty();
		
		//изтегля и разпределя атрибутите на документа  ..
			$vedom		= $this->BiSOFT_Model->get_vedom($mode);
			$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
			$doc_name	= $this->BiSOFT_Model->get_document_title($mode);
			$doc_date 	= date('Y-m-d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));

		$data['transaction_time']= date('Y-m-d');

		$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
		$emp_info=$this->Employee->get_info($employee_id);
		$data['employee']=$emp_info->first_name.' '.$emp_info->last_name;

		$comment = $this->input->post('comment');	
			if ($comment==0) { $comment = '';}

		$order_No = null;$order_date=$doc_date;
		//SAVE sale to database
		$data['doc_id'] = $this->Suspended->save(
													$data['cart'], 
													$mode, 
													$data['all_qty'], 
													$data['subtotal'],
													$doc_number, 
													$doc_name,	
													$bisoft_id, 
													$data['customer_discount'], 
													$employee_id,
													$taxed,
													$order_No,
													$order_date,
													$comment );
													
		if ($data['doc_id'] == 'doc-1')
         { $data['error_message'] = $this->lang->line('sales_transaction_failed');}

		$this->sale_lib->clear_all();
			$mode_menu = 'sales';
			$this->BiSOFT_Model->set_mode_menu($mode_menu);
	
	$this->_reload(array('success' => $this->lang->line('sales_successfully_suspended_sale')));
	}
	

	function suspended()
	{
		$data = array();
		$data['suspended'] = $this->Suspended->get_all()->result_array();
	$this->load->view('sales/suspended', $data);
	}
	
	function unsuspend()
	{
		$doc_id = $this->input->post('suspended_doc_id');
		$this->sale_lib->clear_all();
			$mode_menu = 'sales';
			$this->BiSOFT_Model->set_mode_menu($mode_menu);

		$this->sale_lib->copy_entire_suspended_sale($doc_id);
		$this->Suspended->delete($doc_id);
		
  	$this->_reload();
	}


	
// ------------------------------ DELIVERED MODULE -------------------------------- //

	function deliver()  // suspend = analog
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $this->sale_lib->get_mode();

		$data['cart']		= $this->sale_lib->get_cart();
		$data['subtotal']	= to_currency_no_money($this->sale_lib->get_subtotal($mode));
		$data['total']		= to_currency_no_money($this->sale_lib->get_total($mode));
		$data['currency']	= ' лв.'; // $this->config->currency_symbol;
		$data['all_qty']	= $this->sale_lib->get_all_qty();
		$data['mode']		= $mode;
		$data['location'] = $location;

		//изтегля и разпределя атрибутите на документа  ..
			$doc_date 	= date('Y-m-d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
			$vedom		= $this->BiSOFT_Model->get_vedom($mode);
			$doc_number	= $this->BiSOFT_Model->get_document_number($mode); // взима НОВ номер ...
			$doc_name	= $this->BiSOFT_Model->get_document_title($mode);

		$data['transaction_time']= date('Y-m-d');

		$employee_id=$this->Employee->get_logged_in_employee_info()->person_id;
		$emp_info=$this->Employee->get_info($employee_id);
		$data['employee']=$emp_info->first_name.' '.$emp_info->last_name;

		$comment = $this->input->post('comment');	
			if ($comment==0) { $comment = '';}

		$consignee_id = $this->sale_lib->get_consignee();
		$bisoft_id = 0;

		if($consignee_id!=-1)
		{
			$consi_info=$this->Consignee->get_info($consignee_id);
			$bisoft_id=$consi_info->bisoft_id;
			$data['consignee']=$consi_info->company_person;
			$data['consignee_company']=$consi_info->company_name;
			$data['consignee_discount']=$consi_info->discount;
			$data['consignee_account_number']=$consi_info->account_number;
		} 
		else { $data['consignee_discount'] = 0;}

		$consignee_discount = $data['consignee_discount'];

		//SAVE recv to database
		$data['doc_id'] = $this->Delivered->save(
													$data['cart'], 
													$mode, 
													$data['all_qty'], 
													$data['subtotal'],
													$doc_number, 
													$doc_name,	
													$bisoft_id, 
													$data['consignee_discount'], 
													$employee_id, 
													'', 
													$comment);

		if ($data['doc_id'] == 'doc-1')
		{ $data['error_message'] = $this->lang->line('recvs_transaction_failed');}
		
		$this->sale_lib->clear_all();
			$mode_menu = 'sales';
			$this->BiSOFT_Model->set_mode_menu($mode_menu);
	$this->_reload(array('success' => $this->lang->line('recvs_successful_delivery')));
	}
	

	function delivered()  // само показва в таблицата ... from suspended
	{
		$data = array();
		$data['location'] = $this->BiSOFT_Model->get_location();
		$data['delivered'] = $this->Delivered->get_all()->result_array();
	$this->load->view('sales/delivered', $data);
	}
	
	function view_delivered($doc_id) // НЕ-Освобождава, само ГЛЕДА
	{
		$this->sale_lib->clear_all();
			$mode_menu = 'sales';
			$this->BiSOFT_Model->set_mode_menu($mode_menu);
		$this->sale_lib->copy_entire_delivered_table($doc_id);
		$data['view'] = 1;
  	$this->_reload($data);
	}

	function undeliver() // освобождава и изтрива ... unsuspend
	{
		$doc_id = $this->input->post('delivered_doc_id');
		$this->sale_lib->clear_all();
			$mode_menu = 'sales';
			$this->BiSOFT_Model->set_mode_menu($mode_menu);
		$this->sale_lib->copy_entire_delivered_table($doc_id);
		$this->Delivered->delete($doc_id);
  	$this->_reload();
	}

// ------------------------------ OLD BiSOFT DELIVERY MODULE -------------------------------- //

	
	
// ------------------------------ SALE SETTINGS MODULE -------------------------------- //
	function sales_settings_box_view()
	{
		$this->load->view("sales/settings_box", null);
	}

	function sales_settings()
	{

	}
	
	

// ------------------------------ START TABLE (Zebex) Import -------------------------------- //
	function zebex_select()
	{
		header("Location: http://127.0.0.1/.read_serial.php");die();
	}

	function zebex_import()
	{
		$this->load->view("sales/zebex_import", null);
	}

	function do_zebex_import()
	{
		$msg = 'do_zebex_import';
		$data = array();
		$failCodes = array();
		$successCode = array ();
		$success = 1;
		$mode = $this->sale_lib->get_mode();
		$mprice = $this->sale_lib->get_mode_price();

		if ($_FILES['file_path']['error']!=UPLOAD_ERR_OK)
		{
			$msg = $this->lang->line('sales_file_failed');
			$data['error'] = $msg;
			$this->_reload($data);
		}
		else
		{
			if (($handle = fopen($_FILES['file_path']['tmp_name'], "r")) !== FALSE)
			{
				$i=1;$line=1;
				while (($data = fgetcsv($handle)) !== FALSE) 
				{
					$item_code = trim($data[0]);
					$success  *= $this->BiSOFT_Model->zebex_add_barcode($item_code,$line,$mode,$mprice);
					$i++;
				}
				$this->sale_lib->set_line($line);
			}
			else 	
			{			
				$msg = $this->lang->line('sales_file_failed');
				$data['error'] = $msg;
				$this->_reload($data);
			}
		}

	  if(count($failCodes) > 1)
	  { 	
			$msg = $this->lang->line('sales_error_import') . count($failCodes) ."): ".implode(", ", $failCodes);
			$data['error'] = $msg;
	  }
	  elseif($success)
	  {
			$msg = $this->lang->line('sales_successful_import').' Zebex';
			$data['success'] = $msg;
	  }

	$this->_reload($data);
	}

// ----------------------------------------- END of TABLE Import -------------------------------- //



// ======================================================================== //
// -------------------------------- REALEN START -------------------------- //

	function _reload($data=array())
	{
		$user_id = $this->BiSOFT_Model->get_person();
		$mode = $this->sale_lib->get_mode();
		$this->BiSOFT_Model->set_user_mode($mode);
		$firma = $this->BiSOFT_Model->get_firma_key();
		
		$person_info = $this->Employee->get_logged_in_employee_info();
		$data['location'] = $location = $this->BiSOFT_Model->get_location();
			if($location!=0) {$this->BiSOFT_Model->set_user_client($location);}
			
		$key_CKP  	 = $this->BiSOFT_Model->get_version_ckp();
		$person_mode = $this->BiSOFT_Model->get_user_mode();

		$person_report = 1;
		if(!$this->Employee->has_permission('reports',$this->Employee->get_logged_in_employee_info()->person_id))
			{ $person_report = 0; }
		$data['person_report'] = $person_report;

		// $dateKey = $this->sale_lib->get_dateKey();
		// $data['dateKey'] = $dateKey;
         
		$data['controller_name']=strtolower(get_class());

		// New Pagination
		$config['per_page'] = 20;
		$all_records = $this->BiSOFT_Model->zebex_cart_pages($mode);
		$data['pages'] = ceil($all_records/$config['per_page']);
		$page_offset = 0;
		if(!isset($data['page'])) {$data['page']=1;}
		else{$page_offset = $config['per_page'] * ($data['page']-1);}
		
		// зарежда количката
		$data['cart'] = $this->sale_lib->get_cart_page($config['per_page'],$page_offset);

		// зарежда размерите ...
		$data['size_grid']= $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table']= $this->BiSOFT_Model->get_sizes('grid_3');
		$data['size_table_top']= $this->BiSOFT_Model->get_sizes('grid_4');

	if( $location==0 ) //тук се вкарат документите, с които работи само БАЗАТА
	{
		if ( !$key_CKP )
		{
			$data['modes']=array(
				'sale'		 	 => $this->lang->line('sales_sale'),
				'sale_return'	 => $this->lang->line('sales_return_sale'),
				'consi_sale'	 => $this->lang->line('sales_consi_sale'),
				'online_sale'   => $this->lang->line('sales_online_sale'),
				'online_return' => $this->lang->line('sales_online_return'),
				'prep_sale'     => $this->lang->line('sales_prepare_sale') );
		}
		else
		{
			$data['modes']=array(
				'offer'			=> $this->lang->line('sales_offer'),
				'proforma'		=> $this->lang->line('sales_proforma') );
		}

         $data['modes_prices']=array(
            99	=> $this->lang->line('sales_unit_price'),
            1	=> $this->lang->line('sales_price').'-I',
            2	=> $this->lang->line('sales_price').'-II',
            3	=> $this->lang->line('sales_price').'-III',
            4	=> $this->lang->line('sales_price').'-IV',
            5	=> $this->lang->line('sales_price').'-V' );
	}
	else 	//тук се вкарат документите, с които работят само МАГАЗИНИТЕ
	{
		if ( $person_report == 0 ) // документи, за чужди МАГАЗИНИ забранен ОТЧЕТИ ...
			{
				$data['modes']=array(
					'shop_sale'	 	=> $this->lang->line('sales_shop_sale'),
					'shop_return'	=> $this->lang->line('sales_shop_return'),
					'sklad'			=> $this->lang->line('sales_shop_items'),
					'dneven'			=> $this->lang->line('sales_shop_daily') );
			}
		else
			{
				$data['modes']=array(
					'shop_sale'	 	=> $this->lang->line('sales_shop_sale'),
					'shop_return'	=> $this->lang->line('sales_shop_return'),
					'sklad'			=> $this->lang->line('sales_shop_items'),
					'dneven'			=> $this->lang->line('sales_shop_daily') );
			}
			
			$data['modes_prices']=array(
				1	=> $this->lang->line('sales_price').'-I',
				2	=> $this->lang->line('sales_price').'-II',
				3	=> $this->lang->line('sales_price').'-III',
				4	=> $this->lang->line('sales_price').'-IV',
				5	=> $this->lang->line('sales_price').'-V' );
	}

			if ( $location == 0 ) //тук се вкарат документите, с които работи само БАЗАТА
				{
					$data['payment_key']=$this->lang->line('sales_not_paid');
					$data['payment_options']=array(
                  $this->lang->line('sales_not_paid') => $this->lang->line('sales_not_paid'),
						$this->lang->line('sales_cash') => $this->lang->line('sales_cash'),
						$this->lang->line('sales_debit') => $this->lang->line('sales_debit'),
						$this->lang->line('sales_credit') => $this->lang->line('sales_credit'),
						$this->lang->line('sales_paypal') => $this->lang->line('sales_paypal'),
						$this->lang->line('sales_giftcard') => $this->lang->line('sales_giftcard'),
						$this->lang->line('sales_gift') => $this->lang->line('sales_gift')
                                             );
				}
			elseif( ($location < 10 and $location!=7) or ($location > 20 and $location < 60) )  // работят МАГАЗИНИ ...
				{
					$data['payment_key']=$this->lang->line('sales_cash');
					$data['payment_options']=array(
						$this->lang->line('sales_cash') => $this->lang->line('sales_cash'),
						$this->lang->line('sales_debit') => $this->lang->line('sales_debit'),
						$this->lang->line('sales_credit') => $this->lang->line('sales_credit'),
						$this->lang->line('sales_giftcard') => $this->lang->line('sales_giftcard'),
						$this->lang->line('sales_not_paid') => $this->lang->line('sales_not_paid'),
                                             );
				}
			else //тук се вкарат документите, с които работят другите МАГАЗИНИ ...
				{
					$data['payment_key']=$this->lang->line('sales_not_paid');
					$data['payment_options']=array(
						$this->lang->line('sales_not_paid') => $this->lang->line('sales_not_paid'),
						$this->lang->line('sales_cash') => $this->lang->line('sales_cash'),
						$this->lang->line('sales_debit') => $this->lang->line('sales_debit'),
						$this->lang->line('sales_credit') => $this->lang->line('sales_credit'),
						$this->lang->line('sales_giftcard') => $this->lang->line('sales_giftcard'),
											);
				}

			if ( $mode == 'sale_return' or $mode == 'shop_return' or $mode == 'online_return' ) //само върната стока
				{
					$data['payment_key']=$this->lang->line('sales_returned_goods');
					$data['payment_options']=array(
						$this->lang->line('sales_returned_goods') => $this->lang->line('sales_returned_goods'),
						$this->lang->line('sales_not_paid') => $this->lang->line('sales_not_paid') );
				}
			elseif ( $mode == 'offer' or $mode == 'proforma' ) // оферти и проформи
				{
					$data['payment_key']=$this->lang->line('sales_offer_price');
					$data['payment_options']=array(
						$this->lang->line('sales_offer_price') => $this->lang->line('sales_offer_price') );
				}
				
		$data['modes_years']=array();
		for($k=0;$k<2;$k++) // установява само тек. и предходна година.
			{ $data['modes_years'][date("Y")-$k] = date("Y")-$k;}
			
		$data['modes_months'] = array(
			'01' => $this->lang->line('cal_january'),
			'02' => $this->lang->line('cal_february'),
			'03' => $this->lang->line('cal_march'),
			'04' => $this->lang->line('cal_april'),
			'05' => $this->lang->line('cal_mayl'),
			'06' => $this->lang->line('cal_june'),
			'07' => $this->lang->line('cal_july'),
			'08' => $this->lang->line('cal_august'),
			'09' => $this->lang->line('cal_september'),
			'10' => $this->lang->line('cal_october'),
			'11' => $this->lang->line('cal_november'),
			'12' => $this->lang->line('cal_december')	);

		$data['mode']			= $mode;
		$data['mode_day']		= (int) date('d', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['mode_month']	= (int) date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		$data['cur_date']		= date('d.m.Y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));

		$m_limit = $this->BiSOFT_Model->get_month_limit($data['mode_month'],$data['mode_year']);
		$data['modes_days'] = array();
		for($k=1;$k<=$m_limit;$k++) { $data['modes_days'][$k]=$k;}

		

		$data['online_client']='';
		$bisoft_id = $data['consi_id'] = $data['customer_due'] = $data['customer_due_vat'] = 0;
		$client_status = $client_taxable = 0;
		
		if ( $mode=='consi_sale' )
			{ $consignee_id = $this->sale_lib->get_consignee();
				if($consignee_id<1 or !is_numeric($consignee_id)) {$consignee_id=0;}
			  $data['consi_id'] = $consignee_id;

				// вземам всички КОНСИГНАТОРИ
				$data['consignees'] = array('-1' => '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$this->lang->line('reports_set_consignee') );
					foreach ($this->Consignee->get_all_dropdown()->result() as $consignee)
						{ 
                     if($firma['styler']===1 and (int)$consignee->bisoft_id<7)
                     { } // изважда Магазин-1 на STYLER + всичко до Краси - (M-7)
                     else
                     { $data['consignees'][$consignee->bisoft_id] = '&nbsp;&nbsp;( '.$consignee->bisoft_id.' ) - '.$consignee->company_name; }
                  }
					$bisoft_id=$consignee_id;
					
					if($bisoft_id>0)
					{	$consi_info=$this->Consignee->get_info_by_bisoft_id($bisoft_id);
					
						$data['customer']=$consi_info->company_person;
				//		$data['customer_email']=$consi_info->email;
						$data['customer_company']=$consi_info->company_name;
						$data['customer_discount']=(float)$consi_info->discount;
						$data['customer_account_number']=$consi_info->account_number;
						$data['customer_price']=$consi_info->price_group;
						$data['customer_address']='';
					}
					else 
					{	$data['customer']=$data['customer_company']=$data['customer_discount']=
						$data['customer_account_number']=$data['customer_price']=$data['customer_address']='';
					}
			}
		elseif( $mode=='online_sale' or $mode=='online_return' )
		   {
				$data['online_client'] = $this->sale_lib->get_online_client();
				$customer_id   = -1;
				$data['customer_price'] = 2;
				$data['customer_discount'] = 0;
		   }
		else
			{ 
				$customer_id = $this->sale_lib->get_customer();
				if( $customer_id != -1)
				{	$bisoft_id=1000000;$data['customer_address']='';
					if(is_numeric($customer_id))
						{
							$bisoft_id=$customer_id;
							$cust_info=$this->Customer->get_info($customer_id);
								$data['customer']=$cust_info->company_person;
								$data['customer_email']=$cust_info->email;
								$data['customer_company']=$cust_info->company_name;
								$data['customer_discount']=(float)$cust_info->discount;
								$data['customer_account_number']=$cust_info->account_number;
								$data['customer_price']=$cust_info->price_group;
									$client_status=$cust_info->status;
									$client_taxable=$cust_info->taxable;
									
								$period = date('Y');
								$cust_due = $this->Sale->get_customer_due($cust_info->bisoft_id,$period);
								if($cust_due) 
								{ 
									$data['customer_due'] = $cust_due->sales;
									$data['customer_due_vat'] = $cust_due->sales_vat;
								}
								else {$data['customer_due']=$data['customer_due_vat']=0;}
						}
					else // случаен клиент
						{
							$data['customer']='';
							$data['customer_company']=$customer_id;
							$data['customer_discount']=0;
							$data['customer_email']='';
							$data['customer_account_number']='';
							$data['customer_price']=2;
						}
				} else {	$data['customer_discount'] = 0;}
			}

		$customer_discount = (float)$data['customer_discount'];

		if( isset ($customer_id) and $customer_id > 0) 
			{ 
			  $this->BiSOFT_Model->set_user_client($customer_id);
			  $this->BiSOFT_Model->set_mode_location($location);

			  if($mode != 'proforma' and $mode != 'offer' )	
				  { $this->sale_lib->set_mode_price($data['customer_price']);}
			}
		elseif( isset ($consignee_id) ) 
			{ 
			  $this->BiSOFT_Model->set_user_client($consignee_id);
			  $this->BiSOFT_Model->set_mode_location($consignee_id);
			}
		else 
			{ 
			  $this->BiSOFT_Model->set_mode_location($location);
			  $this->BiSOFT_Model->set_user_client(0);
			}
			
      $data['bisoft_id'] = $bisoft_id;

      // modes_prints HIDDEN ...
		$data['mode_print']	= $this->sale_lib->get_mode_print();
		$data['modes_prints']=array(
			'prices'	=> $this->lang->line('reports_print_prices'),
			'sizes'	=> $this->lang->line('reports_print_sizes'),
			'sizes_prices' => $this->lang->line('reports_print_sizes_prices') );      
      
		// mode_prices 
		if ( $person_report == 0 and $location != 0 ) { $this->sale_lib->set_mode_price(1);}  // само за Магазини > 100 ...
		$mode_price	= $this->sale_lib->get_mode_price();
		if($mode=='online_sale' or $mode=='online_return')
		{
         $data['mode_price'] = $mode_price = 100;
         $this->sale_lib->set_mode_price($mode_price);
		}
		else
		{  $data['mode_price'] = $mode_price;}
		
		// Giftcards
		$data['giftcard']	= $this->sale_lib->get_giftcard();
		$data['giftcard_value']	= $this->sale_lib->get_giftvalue();
		if($data['giftcard']) 
		  {
			 $gift_info = $this->Giftcard->get_giftcard_by_code($data['giftcard']);
			 $data['gift_info'] = $gift_info;
			 $data['owner'] = $gift_info->owner;
		  }

		// Всичко за СУМИТЕ
		$data['subtotal']		= to_currency_no_money($this->sale_lib->get_subtotal($mode));  

		// определям ДДС-то ....
		$taxed = 0;
		$data['currency'] = $this->config->item('currency_symbol');
		if ( $mode_price == 100 or $mode_price == 102 or $mode=='online_sale' or $mode=='online_return' ) { $taxed = 1;}
		if($location==0 and $client_status=='onlineto' and $client_taxable) // специалните клиенти
         {  
            $data['taxed']    = $taxed=0;
            $data['tax_VAT']  = round($data['subtotal']/6,2);
         }
      else
         {
            $data['taxed']    = $taxed;
            $data['tax_VAT']	= to_currency_no_money($this->sale_lib->get_tax_VAT($mode,$taxed));
         }
         
		$data['total']	      = to_currency_no_money($this->sale_lib->get_total($mode,$customer_discount,$taxed));
      $data['amount_due']	= $this->sale_lib->get_amount_due($mode,$taxed);
      $data['all_qty'] 		= $this->sale_lib->get_all_qty();

		$data['items_module_allowed'] = $this->Employee->has_permission('items', $person_info->person_id);
		$data['comment'] 		= $this->sale_lib->get_comment();
		$data['email_receipt'] = $this->sale_lib->get_email_receipt();
		
		$data['payments']		= $this->sale_lib->get_payments();
		$data['payments_cover_total'] = $this->_payments_cover_total();
		$data['payments_total']= $this->sale_lib->get_payments_total();
		$data['order'] = $this->sale_lib->get_order();

		if (isset($info)) { $data['info'] = $info;}
		if (isset($success)) { $data['success'] = $success;}
		if (isset($error)) { $data['error'] = $error;}
		
		$config['base_url'] = site_url('/sales/index');
		$data['form_width']=$this->get_form_width();

		// само за играта 3 за 2
		$data['location_lock']=0;
		// разрешава на ВСИЧКИ Магазини без Красьо да играят 3 за 2.
		// има такова и в Sale_Lib ... get_three4two_discount() и в Sale (model)
		$allow_three4two = $this->OnLine->allow_three4two();
		
		if($location>0 and $location<11 and $location!=7) {$data['location_lock']=1;} // само без Красьо=7 ?!
		
		// Three 4 Two
		$data['three4two']=$data['three4two_suma']=0;
		if($allow_three4two and $data['location_lock'] and $this->OnLine->get_three4two() and count($data['cart'])>2)
         {
            $data['three4two']=1;
            $data['three4two_suma']=$this->sale_lib->get_three4two_discount();
         }
         
      // Black Friday
      $data['bFriday']=$this->OnLine->get_black_friday();
      $data['bFriday_pro']=0;
      if($data['bFriday'] and $data['location_lock'])
         {  
            $data['bFriday_pro']=$this->sale_lib->get_bFriday_discount();
            $data['modes_prices']=array(0=>'black '.$this->lang->line('sales_price'));
         }
      
	if ($mode=='sklad') 
		{ $this->sklad_mag_100();}
	elseif ($mode=='dneven') 
		{ $this->dneven_mag_100();}
	else  // за всички останали режими ...
		{ $this->load->view("sales/register",$data);}
	}
	
// -----------------------------------------------------------------------------
	function pages($page=1)
	{
		$data=array( 'page' => $page );
	$this->_reload($data);
	}
	
   function print_order($order_No=0,$order_date=0)
   {
      if($order_No and $order_date)
      {
         $data=array('koketna'=>$order_No,'koketna_date'=>$order_date);
         $this->load->view("labels/fourlines_label", $data);
      }
      else {$this->_reload();}
   }

	/* ----	get the width for the add/edit form ---- */
	function get_form_width()
	{ return 360;}

	/* ----	get the width for the add/edit form ---- */
	function get_form_full_width()
	{ return 780;}
	
}
?>
