<?php require_once ("Person_controller.php");

class Subconts extends Person_controller
{
	function __construct()
	{
		parent::__construct('Subconts');
	}
	
	function index()
	{
		$this->BiSOFT_Model->clear_production();
		$mode_menu = 'subconts';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);

		$config['base_url'] = site_url('/subconts/index');
		$config['total_rows'] = $this->Subcont->count_all();
		$config['per_page'] = 100;
		$config['num_links'] = 10;
		$config['uri_segment'] = 3;
		$this->pagination->initialize($config);

		$data['modes_years']=array();
		$limit_year=date('y')-13; // установява тек.година-13 или от 2014г.
		for($k=0;$k<$limit_year;$k++)
		{
			$data['modes_years'][date("Y")-$k] = date("Y")-$k;
		}
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		
		$data['controller_name']=strtolower(get_class());
		$data['form_width']=$this->get_form_width();
		$data['manage_table']=get_subcont_manage_table( $this->Subcont->get_all_top( $config['per_page'], $this->uri->segment( $config['uri_segment'] ) ), $this );
		
		
// print_r( $this->Subcont->get_all_top() );		
// die();		
		
		$this->load->view('subconts/manage',$data);
	}

	function refresh($data=array())
	{
		$config['base_url'] = site_url('/subconts/index');
		$config['total_rows'] = $this->Subcont->count_all();
		$config['per_page'] = 100;
		$config['num_links'] = 10;
		$config['uri_segment'] = 3;
		$this->pagination->initialize($config);

		$data['modes_years']=array();
		$limit_year=date('y')-13; // установява тек.година-13 или от 2014г.
		for($k=0;$k<$limit_year;$k++)
		{
			$data['modes_years'][date("Y")-$k] = date("Y")-$k;
		}
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		
		$data['controller_name']=strtolower(get_class());
		$data['form_width']=$this->get_form_width();
		$data['manage_table']=get_Subcont_manage_table( $this->Subcont->get_all_top( $config['per_page'], $this->uri->segment( $config['uri_segment'] ) ), $this );

		$this->load->view('subconts/manage',$data);
	}

	function change_YEAR()
	{
		$mode_year = $this->input->post("mode_year");
		if ($mode_year > date ('Y'))	
				{ $this->BiSOFT_Model->set_user_year(date('Y')); }
		else  { $this->BiSOFT_Model->set_user_year($mode_year); }

		$this->BiSOFT_Model->set_user_mode('supply_report');
		$this->BiSOFT_Model->set_user_date();

	$this->refresh();
	}

	/*	Returns Subcont table data rows. This will be called with AJAX. */
	function search()
	{
		$search=$this->input->post('search');
		$data_rows=get_Subcont_manage_table_data_rows($this->Subcont->search($search),$this);
		echo $data_rows;
	}
	
	/*	Gives search suggestions based on what is being searched for */
	function suggest()
	{
		$suggestions = $this->Subcont->get_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}
	
	/*	Loads the Subcont edit form */
	function view($subcont_id=-1)
	{
		$data['user_id']=$this->BiSOFT_Model->get_person();
		$data['person_info']=$this->Subcont->get_info($subcont_id);
		$last_number = $this->Subcont->get_max_bisoft_id();

		if ( $subcont_id != -1 )
			{ $data['bisoft_id']	= $data['person_info']->bisoft_id;}
		else
			{ $data['bisoft_id']	= 1 + $last_number;}
			
		$data['subcont_id'] = $subcont_id;
		
		$data['modes_prices']=array(
				0  => $this->lang->line('sales_unit_price'),
				1	=> $this->lang->line('sales_price').'-I',
				2	=> $this->lang->line('sales_price').'-II',
				3	=> $this->lang->line('sales_price').'-III',
				4	=> $this->lang->line('sales_price').'-IV',
				5	=> $this->lang->line('sales_price').'-V' );
				
		$data['modes_clients']=array(
			'subcont_GP' => 'доставчик-ГП',
				'subcont' => 'подизпълнител',
			 'principle' => 'възложител');
				
	$this->load->view("subconts/form",$data);
	}
	
	/*
	Inserts/updates a Subcont
	*/
	function save($subcont_id=-1)
	{
		$first_name = mb_convert_case($this->input->post('first_name'),MB_CASE_TITLE,"UTF-8");
		$last_name  = mb_convert_case($this->input->post('last_name'),MB_CASE_TITLE,"UTF-8");
      $city       = mb_convert_case($this->input->post('city'),MB_CASE_TITLE,"UTF-8");
      $city = trim(str_replace('Гр.', '', $city ));
      $city = trim(str_replace('С.', 'с. ', $city ));
		
		$person_data = array(
			'bisoft_id'=>$this->input->post('bisoft_id'),
			'first_name' => $first_name,
			'last_name'  => $last_name,
			'company'=>$this->input->post('company_name'),
			'email'=>$this->input->post('email'),
			'phone_number'=>$this->input->post('phone_number'),
			'address'=>$this->input->post('address'),
			'country'=>mb_convert_case($this->input->post('country'),MB_CASE_TITLE,"UTF-8"),
			'city'=>$city,
			'location'=>$this->input->post('bisoft_id'),
			'comments'=>$this->input->post('comments')
						);

		$discount = $this->input->post('discount');
		$price_group = $this->input->post('price_group');
		$status	 = $this->input->post('modes_clients');
		if($status=='Subcont') {$discount=0;}
		if($discount>0) {$price_group=0;}	
						
		$Subcont_data=array(
			'bisoft_id'=>$this->input->post('bisoft_id'),
			'company_name'=>$this->input->post('company_name'),
			'company_person' => "$first_name $last_name",
			'account_number'=>$this->input->post('account_number'),
			'price_group'=>$price_group,
			'status'=>$status,
			'discount'=>$discount,
			'commision'=>0,
			'taxable'=>$this->input->post('taxable')=='' ? 0:1,
			'deleted'=>$this->input->post('deleted')=='' ? 0:1
						);

		if($this->Subcont->save($person_data,$Subcont_data,$subcont_id))
		{
			//New Subcont
			if($subcont_id==-1)
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('subconts_successful_adding').' '.
				$Subcont_data['company_name'],'person_id'=>$Subcont_data['person_id']));
			}
			else //previous Subcont
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('subconts_successful_updating').' '.
				$Subcont_data['company_name'],'person_id'=>$subcont_id));
			}
		}
		else//failure
		{	
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('subconts_error_adding_updating').' '.
			"$first_name $last_name",'person_id'=>$subcont_id));
		}
	}
	
	
	/* This deletes subconts from the subconts table */
  function delete()
	{
		$subconts_to_delete=$this->input->post('ids');
		
		if($this->Subcont->delete_list($subconts_to_delete))
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('subconts_successful_deleted').' '.
			count($subconts_to_delete).' '.$this->lang->line('subconts_one_or_multiple')));
		}
		else
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('subconts_cannot_be_deleted')));
		}
	}
	
	/*	Gets one row for a Subcont manage table. This is called using AJAX to update one row. */
	function get_row()
	{
		$person_id = $this->input->post('row_id');
		$data_row=get_Subcont_data_row($this->Subcont->get_info($person_id),$this);
		echo $data_row;
	}
	
	function inventory($bisoft_id=-1) {


	}


	function search_item($bisoft_id)
	{
		$item_number = $this->input->post('item_number');
		$this->vedom($bisoft_id,$item_number);
	}
	
// ------------------------------------------- ВЕДОМОСТИ ----------------------------------- //

	function vedom($bisoft_id=-1,$item_number=0) 
	{
		$location = $this->BiSOFT_Model->get_location();
		$data['location'] = $location;
		$data['controller_name']=strtolower(get_class());
		$data['vedom_pack'] = $this->BiSOFT_Model->get_vedom();
		$data['vedom_year'] = $this->BiSOFT_Model->get_user_mode_year();
		$data['client_id'] = $bisoft_id;
		$data['client_info']=$this->Subcont->get_info_by_bisoft_id($bisoft_id);
		$data['item_number'] = ($item_number) ? $item_number : '';
		// зарежда размерите ...
		$data['size_grid']= $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table']= $this->BiSOFT_Model->get_sizes('grid_2');

		$this->load->view("subconts/vedom_details",$data);
	} //------------------------------------------- BiSOFT



//	get the width for the add/edit form
	function get_form_width()
	{			
		return 360;
	}
}
?>
