<?php require_once ("Person_controller.php");

class Suppliers extends Person_controller
{
	function __construct()
	{
		parent::__construct('Suppliers');
	}
	
	function index()
	{
		$this->BiSOFT_Model->clear_production();
		$mode_menu = 'suppliers';
		$this->BiSOFT_Model->set_mode_menu($mode_menu);

		$config['base_url'] = site_url('/suppliers/index');
		$config['total_rows'] = $this->Supplier->count_all();
		$config['per_page'] = 100;
		$config['num_links'] = 10;
		$config['uri_segment'] = 3;
		$this->pagination->initialize($config);

		$data['modes_years']=array();
		$limit_year=date('y')-13; // установява тек.година-13 или от 2014г.
		for($k=0;$k<$limit_year;$k++)
		{
			$data['modes_years'][date("Y")-$k] = date("Y")-$k;
		}
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		
		$data['controller_name']=strtolower(get_class());
		$data['form_width']=$this->get_form_width();
		$data['manage_table']=get_supplier_manage_table( $this->Supplier->get_all_top( $config['per_page'], $this->uri->segment( $config['uri_segment'] ) ), $this );
		$this->load->view('suppliers/manage',$data);
	}

	function refresh($data=array())
	{
		$config['base_url'] = site_url('/suppliers/index');
		$config['total_rows'] = $this->Supplier->count_all();
		$config['per_page'] = 100;
		$config['num_links'] = 10;
		$config['uri_segment'] = 3;
		$this->pagination->initialize($config);

		$data['modes_years']=array();
		$limit_year=date('y')-13; // установява тек.година-13 или от 2014г.
		for($k=0;$k<$limit_year;$k++)
		{
			$data['modes_years'][date("Y")-$k] = date("Y")-$k;
		}
		$data['mode_year']	= $this->BiSOFT_Model->get_user_mode_year();
		
		$data['controller_name']=strtolower(get_class());
		$data['form_width']=$this->get_form_width();
		$data['manage_table']=get_supplier_manage_table( $this->Supplier->get_all_top( $config['per_page'], $this->uri->segment( $config['uri_segment'] ) ), $this );
		$this->load->view('suppliers/manage',$data);
	}

	function change_YEAR()
	{
		$mode_year = $this->input->post("mode_year");
		if ($mode_year > date ('Y'))	
				{ $this->BiSOFT_Model->set_user_year(date('Y')); }
		else  { $this->BiSOFT_Model->set_user_year($mode_year); }

		$this->BiSOFT_Model->set_user_mode('supply_report');
		$this->BiSOFT_Model->set_user_date();

	$this->refresh();
	}

	/*	Returns supplier table data rows. This will be called with AJAX. */
	function search()
	{
		$search=$this->input->post('search');
		$data_rows=get_supplier_manage_table_data_rows($this->Supplier->search($search),$this);
		echo $data_rows;
	}
	
	/*	Gives search suggestions based on what is being searched for */
	function suggest()
	{
		$suggestions = $this->Supplier->get_search_suggestions($this->input->post('q'),$this->input->post('limit'));
		echo implode("\n",$suggestions);
	}
	
	/*	Loads the supplier edit form */
	function view($supplier_id=-1)
	{
		$data['user_id']=$this->BiSOFT_Model->get_person();
		$data['person_info']=$this->Supplier->get_info($supplier_id);
		$last_number = $this->Supplier->get_max_bisoft_id();

		if ( $supplier_id != -1 )
			{ $data['bisoft_id']	= $data['person_info']->bisoft_id;}
		else
			{ $data['bisoft_id']	= 1 + $last_number;}
			
		$data['supplier_id'] = $supplier_id;
		
		$data['modes_prices']=array(
				0  => $this->lang->line('sales_unit_price'),
				1	=> $this->lang->line('sales_price').'-I',
				2	=> $this->lang->line('sales_price').'-II',
				3	=> $this->lang->line('sales_price').'-III',
				4	=> $this->lang->line('sales_price').'-IV',
				5	=> $this->lang->line('sales_price').'-V' );
				
		$data['modes_clients']=array(
				'supplier'   => 'доставчик',
				'supplierto' => 'доставчик т.о.%');
				
	$this->load->view("suppliers/form",$data);
	}
	
	/*
	Inserts/updates a supplier
	*/
	function save($supplier_id=-1)
	{
		$first_name = mb_convert_case($this->input->post('first_name'),MB_CASE_TITLE,"UTF-8");
		$last_name  = mb_convert_case($this->input->post('last_name'),MB_CASE_TITLE,"UTF-8");
		$city       = mb_convert_case($this->input->post('city'),MB_CASE_TITLE,"UTF-8");
      $city = trim(str_replace('Гр.', '', $city ));
      $city = trim(str_replace('С.', 'с. ', $city ));
		
		$person_data = array(
			'bisoft_id'=>$this->input->post('bisoft_id'),
			'first_name'=>$first_name,
			'last_name'=>$last_name,
			'company'=>$this->input->post('company_name'),
			'email'=>$this->input->post('email'),
			'phone_number'=>$this->input->post('phone_number'),
			'address'=>$this->input->post('address'),
			'country'=>mb_convert_case($this->input->post('country'),MB_CASE_TITLE,"UTF-8"),
			'city'=>$city,
			'location'=>$this->input->post('bisoft_id'),
			'comments'=>$this->input->post('comments')
						);

		$discount = $this->input->post('discount');
		$price_group = $this->input->post('price_group');
		$status	 = $this->input->post('modes_clients');
		if($status=='supplier') {$discount=0;}
		if($discount>0) {$price_group=0;}	
						
		$supplier_data=array(
			'bisoft_id'=>$this->input->post('bisoft_id'),
			'company_name'=>$this->input->post('company_name'),
			'company_person'=>"$first_name $last_name",
			'account_number'=>$this->input->post('account_number'),
			'price_group'=>$price_group,
			'status'=>$status,
			'discount'=>$discount,
			'commision'=>0,
			'taxable'=>$this->input->post('taxable')=='' ? 0:1,
			'deleted'=>$this->input->post('deleted')=='' ? 0:1
						);

		if($this->Supplier->save($person_data,$supplier_data,$supplier_id))
		{
			//New supplier
			if($supplier_id==-1)
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('suppliers_successful_adding').' '.
				$supplier_data['company_name'],'person_id'=>$supplier_data['person_id']));
			}
			else //previous supplier
			{
				echo json_encode(array('success'=>true,'message'=>$this->lang->line('suppliers_successful_updating').' '.
				$supplier_data['company_name'],'person_id'=>$supplier_id));
			}
		}
		else//failure
		{	
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('suppliers_error_adding_updating').' '.
			"$first_name $last_name",'person_id'=>$supplier_id));
		}
	}
	
	
	/*	This deletes suppliers from the suppliers table */
  function delete()
	{
		$suppliers_to_delete=$this->input->post('ids');
		
		if($this->Supplier->delete_list($suppliers_to_delete))
		{
			echo json_encode(array('success'=>true,'message'=>$this->lang->line('suppliers_successful_deleted').' '.
			count($suppliers_to_delete).' '.$this->lang->line('suppliers_one_or_multiple')));
		}
		else
		{
			echo json_encode(array('success'=>false,'message'=>$this->lang->line('suppliers_cannot_be_deleted')));
		}
	}
	
	/*
	Gets one row for a supplier manage table. This is called using AJAX to update one row.
	*/
	function get_row()
	{
		$person_id = $this->input->post('row_id');
		$data_row=get_supplier_data_row($this->Supplier->get_info($person_id),$this);
		echo $data_row;
	}
	
	function inventory($bisoft_id=-1) {


	}

	function search_item($bisoft_id)
	{
		$item_number = $this->input->post('item_number');
		$this->vedom($bisoft_id,$item_number);
	}
// ------------------------------------------- ВЕДОМОСТИ ----------------------------------- //

	function vedom($bisoft_id=-1,$item_number=0) 
	{
		$location = $this->BiSOFT_Model->get_location();
		$data['location'] = $location;
		$data['controller_name']=strtolower(get_class());
		$data['vedom_pack'] = $this->BiSOFT_Model->get_vedom();
		$data['vedom_year'] = $this->BiSOFT_Model->get_user_mode_year();
		$data['client_id'] = $bisoft_id;
		$data['client_info']=$this->Supplier->get_info_by_bisoft_id($bisoft_id);
		$data['item_number'] = ($item_number) ? $item_number : '';
		// зарежда размерите ...
		$data['size_grid']= $this->BiSOFT_Model->get_sizes('grid_1');
		$data['size_table']= $this->BiSOFT_Model->get_sizes('grid_2');

		$this->load->view("suppliers/vedom_details",$data);
	} //------------------------------------------- BiSOFT



/* =========================== BISOFT (EXCEL 2003) DIRECT IMPORT MODULE =========================*/

	/**
	 * Display form: Import data from an excel file
	 * author: Bisser Alexiev Feb.2014
	 */
  function bisoft_import($myFile='_DOSTAV.bls')
	{
	$msg = "do_bisoft_import_from_suppliers.bls";
	$failCodes = null;
	$successCode = null;
   $location = $this->Employee->get_logged_in_employee_info()->location;
	$view_path = 'suppliers/refresh';

	// get BiSOFT path
	$this->CI =& get_instance();
	$bisoft_path = $this->CI->BiSOFT_Model->get_path();

// error_reporting(E_ALL ^ E_NOTICE);

// require_once 'bisoft_reader.php';
//$data_file = new Spreadsheetexcelreader("suppliers.xls", false);
// base_url().'BiSOFT/DB'
//	chdir (base_url().'BiSOFT');
//	$now_dir = getcwd();

		$this->load->library('spreadsheetexcelreader');
      $this->spreadsheetexcelreader->setOutputEncoding('CP1251'); // Set output Encoding

	$sRoot = $_SERVER['DOCUMENT_ROOT'];
	$file_to_read = $sRoot.'/'.$bisoft_path.'/DB/'.$myFile;

	if (!is_readable($file_to_read))
     	{ // ГРЕШКА - връщаме се в началото на controller-a ...
			$msg = $this->lang->line('common_error_import');
			$data['error'] = $msg;
		 	$this->refresh($data);
		return false;
     	}

		else 
		{ // тук вече зарежда нормално от BiSOFT ... - >

		$data_file = new Spreadsheetexcelreader($file_to_read, false);

			$rowCount = $data_file->rowcount(0);
//			$colCount = $data_file->colcount(0);
//        $rows = $data_file->sheets[0]['cells'];
//        $rowCount = count($data_file->sheets[0]['cells']);

      if($rowCount > 1)
		{  // #2 if row > 1

			for($i = 5; $i<=$rowCount; $i++) 
			{  // #3 for i=1 and on ...
			$supplier_code 	= $data_file->val( $i, 'A');
			$supplier_id 		= $this->Supplier->get_info($supplier_code);

			$first_last_name = $data_file->val($i, 'K');

// обработвам за глупави знаци ...
	$first_last_name = character_limiter(str_replace(array('=', '-', '_', '/', '|', '\\', '#', '№', '.', ',', '@', '&', '!', '$', '*', '(', ')', '~'), ' ', $first_last_name),30);

		list ($firstname, $lastname) = explode(' ', $first_last_name.' _');
				$firstname = trim($firstname);
				$lastname  = trim(str_replace(array('_'), '', $lastname));


	$supplier_number = intval( $supplier_code );

	$key_yes = 1;
	$bisoft_id  =  intval( $supplier_code );

	if ($this->Supplier->bisoft_id_exists($bisoft_id)) { $key_yes = 0;}

	// проверявам за Данъчна регистрация ...
	$taxable = '1';


	  $person_data = array(
		'bisoft_id'			=> $bisoft_id,
		'company'	  		=> $data_file->val( $i, 'B'),
		'city'	  	  		=> $data_file->val( $i, 'C'),
		'address'	  		=> $data_file->val( $i, 'D'),
		'phone_number'		=> $data_file->val( $i, 'E'),
		'location'			=> $data_file->val( $i, 'P'),
		'country'	  		=> 'България',
		'first_name'		=> $firstname,
		'last_name'			=> $lastname,
		);


	  $supplier_data = array(
		'bisoft_id'			=> $bisoft_id,
		'company_name'		=> $data_file->val( $i, 'B'),
		'company_person'	=> $first_last_name,
		'account_number'	=> $data_file->val( $i, 'I'),
		'bank'				=> $data_file->val( $i, 'F'),
		'bank_account'    => $data_file->val( $i, 'G'),
		'discount'			=> 100 * $data_file->val( $i, 'Q'),
		'price_group'		=> $data_file->val( $i, 'P'),
		'taxable'			=> $taxable,
		'location'			=> null,
		);

					// updates of DataBase Suppliers & People
					if ($key_yes == 1 and $bisoft_id > 0) 
					{
					  if(!$this->Supplier->save( $person_data, $supplier_data))
						{ $failCodes[] = 'BiSOFT:'.$supplier_code; }
					}
				}  // 3

			}  //  #2 if row >1
			else { 
						$msg = 'Your upload file has no data or not in supported format.';
						$data['error'] = $msg;
		 				$this->refresh($data);
					return false;
					}  // end #2 may STOP if file error ?!?!?

		}  // end #1

		// defines error or success message.
		$view_path = 'suppliers/index';

		if(count($failCodes) > 1)
		{  $msg = $this->lang->line('recvs_error_import') . count($failCodes) ."): ".implode(", ",$failCodes); 
			$data['error'] = $msg;} // ГРЕШКА (човешка :(
		else {
				$msg = $this->lang->line('recvs_successful_import');
				$data['success'] = $msg;}  // УСПЕХ !!!

	$this->refresh($data);
	} // end #0 of BiSOFT Import
// ==================================== End of Import BiSOFT ================================ //



// ====================================== CSV Importer =================================/
//	 * Display form: Import data from an CSV file
//	 * author: Bisser Alexiev Dec-2013     времено СПРЯН - но РАБОТИ за  Еталон CSV

	function csv_import()
	{
		$this->load->view("suppliers/csv_import", null);
	}

	function do_csv_import()
	{
		$msg = 'do_csv_import';
		$failCodes = array();
		if ($_FILES['file_path']['error']!=UPLOAD_ERR_OK)
		{
			$msg = $this->lang->line('items_excel_import_failed');
			echo json_encode( array('success'=>false,'message'=>$msg) );
			return;
		}
		else
		{
			if (($handle = fopen($_FILES['file_path']['tmp_name'], "r")) !== FALSE)
			{
				//Skip first row
				fgetcsv($handle);
				
				$i=1;
				while (($data = fgetcsv($handle)) !== FALSE) 
				{
// My stuff
				$first_last_name = $data[10];
				list($firstname, $lastname) = explode(' ', $first_last_name);
				$supplier_number = intval( $data[0] );

					$person_data = array(
					'first_name'=> trim($firstname),
					'last_name'=> trim($lastname),
					'phone_number'=>$data[4],
					'address'=>$data[3],
					'city'=>$data[2],
					'country'=> 'България',
					'comments'=>$data[11]
					);
					
					$supplier_data=array(
					'account_number'=>$data[8]=='' ? null:$data[8],
					'company_name'=>$data[1],
					'bank'=>$data[5],
					'bank_account'=>$data[6],
					'discount'=>$data[16],
					'taxable'=>$data[14]=='' ? 0:1,
					);
					
					if(!$this->Supplier->save($person_data,$supplier_data))
					{	
						$failCodes[] = $i;
					}
					
					$i++;
				}
			}
			else 
			{
				echo json_encode( array('success'=>false,'message'=>'Your upload file has no data or not in supported format.') );
				return;
			}
		}

		$success = true;
		if(count($failCodes) > 1)
		{
			$msg = "Most suppliers imported. But some were not, here is list of their CODE (" .count($failCodes) ."): ".implode(", ", $failCodes);
			$success = false;
		}
		else
		{
			$msg = "Import Suppliers successful";
		}

		echo json_encode( array('success'=>$success,'message'=>$msg) );
	}
	
// ====================================== END CSV Importer =================================/

//	get the width for the add/edit form
	function get_form_width()
	{			
		return 360;
	}
}
?>
