<?php

function to_currency($number)
{
	$CURR =& get_instance();
	$CURR->load->language('common');

	if(is_numeric($number))
	{ 	
		if($number >= 0)
         {
            return $CURR->lang->line('currency_left').number_format($number, 2, '.', '').$CURR->lang->line('currency_right');
         } 
		else
			{
            return '-'.$CURR->lang->line('currency_left').number_format(abs($number), 2, '.', '').$CURR->lang->line('currency_right');
			}
	}
	else { return $number;}
}


function to_currency_no_money($number)
{
	if(is_numeric($number))
	{ return number_format($number, 2, '.', '');}
	else { return $number;}
}

function to_any_money($number)
{
	$fraction = 0;
	$new_number = $number;
	if (strpos($new_number, '.') !== false) { list($new_number, $fraction) = explode('.', $new_number);}

	if ( $fraction > 1000 and (int)substr($fraction,-3)!=0 ) 
		{ $number = number_format($number, 5, '.', '');}
	elseif( $fraction > 100 and $fraction <= 1000 )
		{ $number = number_format($number, 4, '.', '');}
	elseif( $fraction > 10 and $fraction <= 100 )
		{ $number = number_format($number, 3, '.', '');}
	else
		{ $number = number_format($number, 2, '.', '');}

return $number;
}

function to_any_money_styler($number)
{
	$fraction = 0;
	$new_number = $number;
	if (strpos($new_number, '.') !== false) { list($new_number, $fraction) = explode('.', $new_number);}

	if ( $fraction > 100000 and (int)substr($fraction,-4)!=0 ) 
		{ $number = number_format($number, 7, '.', '');}
	elseif( $fraction > 10000 and $fraction <= 100000 and (int)substr($fraction,-3)!=0 )
		{ $number = number_format($number, 6, '.', '');}
	elseif( $fraction > 1000 and $fraction <= 10000 and (int)substr($fraction,-2)!=0 )
		{ $number = number_format($number, 5, '.', '');}
	elseif( $fraction > 100 and $fraction <= 1000 )
		{ $number = number_format($number, 4, '.', '');}
	elseif( $fraction > 10 and $fraction <= 100 )
		{ $number = number_format($number, 3, '.', '');}
	else
		{ $number = number_format($number, 2, '.', '');}

return $number;
}

function to_any_money_invoice($number)
{
	$fraction = 0;
	$new_number = $number;
	if (strpos($new_number, '.') !== false) { list($new_number, $fraction) = explode('.', $new_number);}

	if ( $fraction > 100 and (int)substr($fraction,-2)!=0 ) 
		{ $number = number_format($number, 3, '.', '');}
	elseif( $fraction > 10 and $fraction <= 100 )
		{ $number = number_format($number, 2, '.', '');}
	else
		{ $number = number_format($number, 2, '.', '');}

return $number;
}

// -------------------------------------------//


function to_comma($number)
{
	$CURR =& get_instance();
	$CURR->load->language('common');

	if(is_numeric($number))
	{ 
		if($number >= 0)
			{ return number_format($number, 2, ',', '');} 
		else
			{ return '-'.number_format(abs($number), 2, ',', '');}
   }
   else { return $number;}
}

function to_dot($number)
{
	if(is_numeric($number))
	{
		if ($number >= 0)
			{ return number_format($number, 2, '.', '');} 
		else
			{ return '-'.number_format(abs($number), 2, '.', '');}
   }
   else { return $number;}
}


function to_dot_3($number)
{
	if(is_numeric($number))
	{
		if ($number >= 0)
			{ return number_format($number, 3, '.', '');} 
		else
			{ return '-'.number_format(abs($number), 3, '.', '');}
   }
   else { return $number;}
}

function to_dot_4($number)
{
	if(is_numeric($number))
	{
		if ($number >= 0)
			{ return number_format($number, 4, '.', '');} 
		else
			{ return '-'.number_format(abs($number), 4, '.', '');}
   }
   else { return $number;}
}

function to_dot_5($number)
{
	if(is_numeric($number))
	{
		if ($number >= 0)
			{ return number_format($number, 5, '.', '');} 
		else
			{ return '-'.number_format(abs($number), 5, '.', '');}
   }
   else { return $number;}
}

function to_dot_6($number)
{
	if(is_numeric($number))
	{
		if ($number >= 0)
			{ return number_format($number, 6, '.', '');} 
		else
			{ return '-'.number_format(abs($number), 6, '.', '');}
   }
   else { return $number;}
}

function to_dot_7($number)
{
	if(is_numeric($number))
	{
		if ($number >= 0)
			{ return number_format($number, 7, '.', '');} 
		else
			{ return '-'.number_format(abs($number), 7, '.', '');}
   }
   else { return $number;}
}

// -------------------------------------//
// Convertor NUMERIC => Words (English) //

function convert_number_to_words_en($number,$valuta='pounds') 
{
   $CURR =& get_instance();
	$CURR->load->language('common');

    $hyphen      = ' ';
    $conjunction = ' and ';
    $separator   = ', ';
    $negative    = ' - (negative) ';
    $decimal     = ' '.$valuta .', (and) ';
    $dictionary  = array(
        0                   => 'zero',
        1                   => 'one',
        2                   => 'two',
        3                   => 'three',
        4                   => 'four',
        5                   => 'five',
        6                   => 'six',
        7                   => 'seven',
        8                   => 'eight',
        9                   => 'nine',
        10                  => 'ten',
        11                  => 'eleven',
        12                  => 'twelve',
        13                  => 'thirteen',
        14                  => 'fourteen',
        15                  => 'fifteen',
        16                  => 'sixteen',
        17                  => 'seventeen',
        18                  => 'eighteen',
        19                  => 'nineteen',
        20                  => 'twenty',
        30                  => 'thirty',
        40                  => 'fourty',
        50                  => 'fifty',
        60                  => 'sixty',
        70                  => 'seventy',
        80                  => 'eighty',
        90                  => 'ninety',
        100                 => 'hundred',
        1000                => 'thousand',
        1000000             => 'million',
        1000000000          => 'billion',
        1000000000000       => 'trillion',
        1000000000000000    => 'quadrillion',
        1000000000000000000 => 'quintillion'
    );
    
    if (!is_numeric($number)) { return false;}
    
    if (($number >= 0 && (int) $number < 0) || (int) $number < 0 - PHP_INT_MAX) 
		{
        // overflow
        trigger_error(
            'convert_number_to_words_en only accepts numbers between -' . PHP_INT_MAX . ' and ' . PHP_INT_MAX,
            E_USER_WARNING
        );
    	return false;
    	}

    if ($number < 0) { return $negative . convert_number_to_words_en(number_format(abs($number), 2, '.', ''));}
    
    $string = $fraction = null;
    if (strpos($number, '.') !== false) { list($number, $fraction) = explode('.', $number);}
    
    switch (true) {
        case $number < 21:
            $string = $dictionary[(int) $number];
            break;
        case $number < 100:
            $tens   = ((int) ($number / 10)) * 10;
            $units  = $number % 10;
            $string = $dictionary[$tens];
            if ($units) {
                $string .= $hyphen . $dictionary[$units];
            }
            break;
        case $number < 1000:
            $hundreds  = $number / 100;
            $remainder = $number % 100;
            $string = $dictionary[$hundreds] . ' ' . $dictionary[100];
            if ($remainder) {
                $string .= $conjunction . convert_number_to_words_en($remainder);
            }
            break;
        default:
            $baseUnit = pow(1000, floor(log($number, 1000)));
            $numBaseUnits = (int) ($number / $baseUnit);
            $remainder = $number % $baseUnit;
            $string = convert_number_to_words_en($numBaseUnits) . ' ' . $dictionary[$baseUnit];
            if ($remainder) {
                $string .= $remainder < 100 ? $conjunction : $separator;
                $string .= convert_number_to_words_en($remainder);
            }
            break;
    }
    
// now pennies ...

    if (null !== $fraction && is_numeric($fraction)) 
{
    $string .= $decimal;
    if ($fraction < 1) { $fraction = 0; }

    switch (true) 
			{
			case $fraction < 21:	
		         $string .= $dictionary[round(10*$fraction/10,0)];
		         break;
			case $fraction < 100:
		         $tens    = ((int) ($fraction / 10)) * 10;
		         $units   = $fraction % 10;
		         $string .= $dictionary[$tens];
		         if ($units) 
					{
		             $string .= $hyphen . $dictionary[$units];
		         }
		         break;
			}

	 if($valuta=='pounds') {$string .= $CURR->lang->line('common_penny_inwords');}
	 elseif($valuta=='EUR') {$string .= $CURR->lang->line('common_cents_inwords');}
    }
    
return $string;
}


// Convertor NUMERIC => Words (Bulgarian) //
function convert_number_to_words_bg($number,$valuta='лева') 
{
   $CURR =& get_instance();
	$CURR->load->language('common');

//	 $number = number_format($number, 2, '.', '');
    $hyphen      = ' и ';
    $conjunction = ' и ';
    $separator   = ', ';
    $negative    = ' - (минус) ';
    $decimal     = $CURR->lang->line('common_value_inwords') . ' и ';
    $dictionary  = array(
        0                   => 'нула',
        1                   => 'един',
        2                   => 'два',
        3                   => 'три',
        4                   => 'четири',
        5                   => 'пет',
        6                   => 'шест',
        7                   => 'седем',
        8                   => 'осем',
        9                   => 'девет',
        10                  => 'десет',
        11                  => 'единадесет',
        12                  => 'дванадесет',
        13                  => 'тринадесет',
        14                  => 'четиринадесет',
        15                  => 'петнадесет',
        16                  => 'шестнадесет',
        17                  => 'седемнадесет',
        18                  => 'осемнадесет',
        19                  => 'деветнадесет',
        20                  => 'двадесет',
        30                  => 'тридесет',
        40                  => 'четиридесет',
        50                  => 'петдесет',
        60                  => 'шестдесет',
        70                  => 'седемдесет',
        80                  => 'осемдесет',
        90                  => 'деведесет',
        100                 => 'сто',
        200                 => 'двеста',
        300                 => 'триста',
        400                 => 'четиристотин',
        500                 => 'петстотин',
        600                 => 'шестстотин',
        700                 => 'седемстотин',
        800                 => 'осемстотин',
        900                 => 'деветстотин',
        1000                => 'хиляди',
        1000000             => 'милион',
        2000000             => 'милиона',
        1000000000          => 'милярд',
        1000000000000       => 'трилион',
        1000000000000000    => 'квадрилион',
        1000000000000000000 => 'квинтилион'
    );

    $fra_dictionary  = array(
        0                   => 'нула',
        1                   => 'една',
        2                   => 'две',
        3                   => 'три',
        4                   => 'четири',
        5                   => 'пет',
        6                   => 'шест',
        7                   => 'седем',
        8                   => 'осем',
        9                   => 'девет',
        10                  => 'десет',
        11                  => 'единадесет',
        12                  => 'дванадесет',
        13                  => 'тринадесет',
        14                  => 'четиринадесет',
        15                  => 'петнадесет',
        16                  => 'шестнадесет',
        17                  => 'седемнадесет',
        18                  => 'осемнадесет',
        19                  => 'деветнадесет',
        20                  => 'двадесет',
        30                  => 'тридесет',
        40                  => 'четиридесет',
        50                  => 'петдесет',
        60                  => 'шестдесет',
        70                  => 'седемдесет',
        80                  => 'осемдесет',
        90                  => 'деведесет'
    );
    
    if (!is_numeric($number)) { return false; }
    
    if (($number >= 0 && (int) $number < 0) || (int) $number < 0 - PHP_INT_MAX) 
	 {
        // overflow
        trigger_error(
            'convert_number_to_words_bg приема значения само между -' . PHP_INT_MAX . ' и ' . PHP_INT_MAX,
            E_USER_WARNING
        );
    return false;
    }

    if ($number < 0) { return $negative . convert_number_to_words_bg(number_format(abs($number), 2, '.', ''));}
    
    $string = $fraction = null;
    if (strpos($number, '.') !== false) 
	 {
		list($number, $fraction) = explode('.', $number);
    }

    switch (true) {
        case $number < 21:
            $string = $dictionary[$number];
            break;

        case $number < 100:
            $tens   = ((int) ($number / 10)) * 10;
            $units  = $number % 10;
            $string = $dictionary[$tens];
            if ($units) 
					{ $string .= $hyphen . $dictionary[$units];}
            break;

        case $number < 1000:
            $hundreds  = 100 * (int)($number / 100);
            $remainder = $number % 100;

				if($hundreds==$number) { $string = $dictionary[$hundreds];}
				else { $string = $dictionary[$hundreds] . $hyphen;}

            if ($remainder) { $string .= convert_number_to_words_bg($remainder); }
            break;

        case $number < 2000:
				$string = 'хиляда, ';
            $hundreds  = 100 * (int)(($number-1000) / 100);
            $remainder = ($number - 1000) % 100;

				if($hundreds==($number-1000)) { $string .= $hyphen . $dictionary[$hundreds];}
				else { $string .= $dictionary[$hundreds] . $hyphen;}

            if ($remainder) { $string .= convert_number_to_words_bg($remainder);}
            break;

        case $number < 3000:
				$string = 'две хиляди, ';
            $hundreds  = 100 * (int)(($number-2000) / 100);
            $remainder = ($number - 2000) % 100;

				if($hundreds==($number-2000)) { $string .= $dictionary[$hundreds];}
				else { $string .= $dictionary[$hundreds] . $hyphen;}

            if ($remainder) { $string .= convert_number_to_words_bg($remainder);}
            break;

        default:
            $baseUnit = pow(1000, floor(log($number, 1000)));
            $numBaseUnits = (int) ($number / $baseUnit);
            $remainder = $number % $baseUnit;
            $string = convert_number_to_words_bg($numBaseUnits) . ' ' . $dictionary[$baseUnit];
            if ($remainder) 
					{
                 $string .= $remainder < 100 ? $conjunction : $separator;
                 $string .= convert_number_to_words_bg($remainder);
            	}
            break;
    }
    


	// а сега и десетиците, стотинките ...
    if (null !== $fraction && is_numeric($fraction)) 
    {
    	 $string .= $decimal; 
    	 if ($fraction < 1) { $fraction = 0; }

		 switch (true) 
		 	{
		   case $fraction < 21:	
		         $string .= $fra_dictionary[round(10*$fraction/10,0)];
		         break;

		   case $fraction < 100:
		         $tens   = ((int) ($fraction / 10)) * 10;
		         $units  = $fraction % 10;
		         $string .= $fra_dictionary[$tens];
		         if ($units) 
						{ $string .= $hyphen . $fra_dictionary[$units];}
		         break;
		 	}
	 $string .= $CURR->lang->line('common_penny_inwords').'.';
    }
    
return $string;
}

?>
