<?php /* ============== FENOTAGS =================== */

function get_fenotags_table($boxes_info)
{
	$CI =& get_instance();
	$mode = $CI->fenotag_lib->get_mode();
	$machine = $CI->fenotag_lib->get_machine();
	$table_data_rows='';
	
	$shaft = 0;
	if($mode=='report') { $shaft = $CI->fenotag_lib->get_shift(); }	
	
	$td_no_css    = 'border:none;background:transparent;';
	$td_reel_css  = 'text-align:center;color:#606;background:#ddd;font-size:105%;height:30px;';
	$td_sumas_css = 'text-align:center;color:#007;background:#ddd;font-size:115%;height:30px;';
	$td_avrR_css  = 'text-align:center;color:#009;background:#bfb;font-size:115%;height:30px;';
	$td_avrC_css  = 'text-align:center;color:#707;background:#bfb;font-size:115%;height:30px;';
	$td_final_css = 'text-align:center;color:#000;background:#ddd;font-size:125%;height:30px;text-shadow: 1px 1px #888;';
	$td_final_avg = 'text-align:center;color:#000;background:#ecc;font-size:125%;height:30px;text-shadow: 1px 1px #888;'; 
	
	if($boxes_info)
	{
      // show headers
      echo $CI->fenotag_lib->getReelHeaders();


      // start values
      $cnt = $all_result = $all_losts = $all_facs = $all_ours = $all_reals = $all_calds = $final_lost = $active = $reels_done = 0;
      
      foreach($boxes_info as $row)
      { 
         $item_id = $row['item_id'];
         $hexInc  = $row['hexInc'];
         $table_data_rows .= get_fenotag_row( $item_id);
         
         $realTime = $caldTime = 0;
         $calc_Reel = $CI->Fenotag->calc_reel($item_id);
            $realTime = ($calc_Reel['realResult']) ? $calc_Reel['realResult'] : 0;
            $caldTime = ($calc_Reel['caldResult']) ? $calc_Reel['caldResult'] : 0;

         $all_ours   += $row['ourFails'];
         $all_facs   += $row['facFails'];
         $all_losts   = $all_ours + $all_facs;
         $all_reals  += $realTime;
         $all_calds  += $caldTime;
         $all_result += $row['finalGood'];
         $active     += (int)$row['active']; 
         if($machine and $realTime>0 and $caldTime>0) { $active = 0; }
         
         $cnt++;
      }
         
      $final_losts = '';
      if($all_result>0) { $final_losts = 100*round($all_ours/$all_result,3).'%'; }
       
      $reels_done = $cnt - $active;
       
       
      // ved-1
      $vedbar1_txt = "";
      if($machine) { $vedbar1_txt .= "( $machine ) - "; }
      $vedbar1_txt .= "$reels_done от $cnt";
      
      // ved-2
      $vedbar2_txt='';

      
      if($mode=='orders' and $all_result>0 and count($boxes_info)>1)
      {
         $allCalendar = $allReal = '';
         if($all_reals>0 and $reels_done>0) { $allReal = $all_reals/$reels_done; }
         if($all_calds>0 and $reels_done>0) { $allCalendar = $all_calds/$reels_done; }

         // защита за 1-2 box
         if($allReal<1000000) { $allReal = $CI->Fenotag->time_convert($allReal); } else { $allReal = "-"; }
         $allCalendar = $CI->Fenotag->time_convert($allCalendar);
         
         if($allReal > 0 and $allCalendar > 0) { $vedbar2_txt = "$allReal ($allCalendar)"; } 
         
         $table_data_rows .= 
         "<tr>
            <th style='$td_no_css'></th>
            <th style='$td_reel_css'><i>$reels_done / $cnt бр.</i></th>
            <th colspan='6' style='$td_no_css'></th>
               <th style='$td_avrR_css'><b>$allReal</b></th>
               <th style='$td_avrC_css'><b>$allCalendar</b></th>
            <th style='$td_sumas_css'><b>$all_ours</b></th>
            <th style='$td_sumas_css'><b>$all_facs</b></th>
            <th style='$td_sumas_css'><b>$all_losts</b></th>
            <th style='$td_final_css'><b>$all_result</b></th>
            <th style='$td_final_avg'><b style='color:#c00;'>$final_losts</b></th>
         </tr>";
       ?>
         
         <div id="bottom_bar_empty">
            <div id="bottom_vedbar_1">
               <span class="bottom_bar_title">БР. РОЛКИ</span>
               <span id="total_qty" class="bottom_bar_text"><b><?=$vedbar1_txt;?></b></span>
            </div>

            <div id="bottom_vedbar_2">
               <span class="bottom_bar_title">ВРЕМЕНА</span>
               <span id="total_sum" class="bottom_bar_text"><b><?=$vedbar2_txt;?></b></span>
            </div>

            <div id="bottom_vedbar_3">
               <span class="bottom_bar_title">НЕУШИТИ</span>
               <span id="total_sum" class="bottom_bar_text"><b><?=$all_ours;?></b></span>
            </div>

            <div id="bottom_vedbar_4">
               <span class="bottom_bar_title">ВСИЧКО ТАГОВЕ</span>
               <span id="total_sum" class="bottom_bar_text"><b><?=$all_result;?></b></span>
            </div>            
            
            <div id="bottom_vedbar_5">
               <span class="bottom_bar_title">ЗАГУБИ</span>
               <span id="total_cost" class="bottom_bar_text" style='color:white;background:#a00;'><b><?=$final_losts;?></b></span>
            </div>
         </div>
<?php }
   }
   else // no data ...
   {
      $table_data_rows = "<tr>
                            <th colspan='13'>
                              <div class='warning_noitems' style='background-color:rgba(130,250,100,0.25);border:1px solid #555;padding:5px;'>".
                                 $CI->lang->line('feno_no_items').
                              "</div>
                            </th>
                         </tr>"; 
   }
	
	return $table_data_rows;
}

function get_fenotag_row($item_id)
{
	$CI =& get_instance();
	$mode = $CI->fenotag_lib->get_mode();
	$controller = strtolower('Fenotags');
	$table_data_row = '';
	
	$shaft = 0;
	if($mode=='report') { $shaft = $CI->fenotag_lib->get_shift(); }
	
	// взимаме целия ред ...
	$row = $CI->Fenotag->get_reel_id($item_id);

   $reel_gcolor = 'color:#050;text-shadow: 1px 1px #888;'; // green
   $reel_rcolor = 'color:#900;text-shadow: 1px 1px #aaa;'; // red
   $td_no_css   = 'border:none;background:transparent;';
   $td_css      = 'text-align:center;color:#222;';
		$td_css_hex = $td_css;
   $td_gr_css   = 'text-align:center;color:#030;text-shadow: 1px 1px #ccc;';
   $td_red_css  = 'text-align:center;color:#a00;';
   $td_blue_css = 'text-align:center;color:#006;';
   $td_real_css = 'text-align:center;color:#008;';
   $td_cald_css = 'text-align:center;color:#505;';

	$box  = $row->box_id;
	$feno = $row->feno_id;
	$reel = $row->reel_id;
	$hexInc = $row->hexInc; 
   $active = $row->active;
   $reel_color = $reel_rcolor;
   if($active) { $reel_color = $reel_gcolor; }
	
	$reel_txt  = "<b>$feno-$reel</b>";
	$reel_link = '<b>'.anchor("$controller/view_fenoreel/$box/$feno/$reel/width:720/height:500",
									  $reel_txt,array('class'=>'thickbox','style'=>$reel_color,'title'=>"Кутия:$box / Ролка: $feno-$reel")).'</b>';
									  
   $machine = $row->machine; if(!$machine) { $machine='-';}
	
	// пълна извадка shaft = 0 / all
	if($mode=='orders' and !$shaft)
	{
      $fmName = $CI->Fenotag->get_BG_month_name($row->firstTime);
      $lmName = $CI->Fenotag->get_BG_month_name($row->lastTime);
      
	   $firstNo   = (int)$row->firstNo;
      $firstTime = (null!=$row->firstTime) ? date('H:i / d.'.$fmName,strtotime($row->firstTime)) : '-';
      $lastNo    = (int)$row->lastNo;
      $lastTime  = (null!=$row->lastTime) ? date('H:i / d.'.$lmName,strtotime($row->lastTime)) : '-';
      
      // неушити:
      $ourFails = (int)$row->ourFails;
      $facFails = (int)$row->facFails;
      $allFails = $ourFails + $facFails;
   }
   elseif($mode=='report' and $shaft)
   {
      switch($shaft)
      {
        case 'day' :
               $firstNo   = (int)$row->dayFirst;
               $firstTime = (null!=$row->dayFirstTime) ? date('H:i / d.M',strtotime($row->dayFirstTime)) : '-';
               $lastNo    = (int)$row->dayLast;
               $lastTime  = (null!=$row->dayLastTime) ? date('H:i / d.M',strtotime($row->dayLastTime)) : '-';
               $ourFails  = (int)$row->dayFails;
               $facFails  = (int)$row->dayFacs;
               break;
               
        case 'mid' :
               $firstNo   = (int)$row->midFirst;
               $firstTime = (null!=$row->midFirstTime) ? date('H:i / d.M',strtotime($row->midFirstTime)) : '-';
               $lastNo    = (int)$row->midLast;
               $lastTime  = (null!=$row->midLastTime) ? date('H:i / d.M',strtotime($row->midLastTime)) : '-';
               $ourFails  = (int)$row->midFails;
               $facFails  = (int)$row->midFacs;
               break;
               
        case 'night' :
               $firstNo   = (int)$row->nightFirst;
               $firstTime = (null!=$row->nightFirstTime) ? date('H:i / d.M',strtotime($row->nightFirstTime)) : '-';
               $lastNo    = (int)$row->nightLast;
               $lastTime  = (null!=$row->nightLastTime) ? date('H:i / d.M',strtotime($row->nightLastTime)) : '-';
               $ourFails  = (int)$row->nightFails;
               $facFails  = (int)$row->nightFacs;
               break;
   
        case 'other':
               $firstNo   = (int)$row->otherFirst;
               $firstTime = (null!=$row->otherFirstTime) ? date('H:i / d.M',strtotime($row->otherFirstTime)) : '-';
               $lastNo    = (int)$row->otherLast;
               $lastTime  = (null!=$row->otherLastTime) ? date('H:i / d.M',strtotime($row->otherLastTime)) : '-';
               $ourFails  = (int)$row->otherFails;
               $facFails  = (int)$row->otherFacs;
               break;
               
        case 'all':
               $firstNo   = (int)$row->firstNo;
               $firstTime = (null!=$row->firstTime) ? date('H:i / d.M',strtotime($row->firstTime)) : '-';
               $lastNo    = (int)$row->lastNo;
               $lastTime  = (null!=$row->lastTime) ? date('H:i / d.M',strtotime($row->lastTime)) : '-';
               $ourFails = (int)$row->ourFails;
               $facFails = (int)$row->facFails;
               break;
   
      } // switch
      
      $allFails = $ourFails + $facFails;
   }
      
   // изчислява календарното и реалното време на изпълнение на ролката
   $realTime = $caldTime = '';
   $calc_Reel = $CI->Fenotag->Fenotag->calc_reel($item_id);
      $realTime = ($calc_Reel['realTime']) ? $calc_Reel['realTime'] : '';
      $caldTime = ($calc_Reel['caldTime']) ? $calc_Reel['caldTime'] : '';
   
   
	if($hexInc==='0')
	{
		$result = $firstNo - $lastNo - $allFails;
		(null===$row->lastTime) ? $result=0 : '';
   
		if($firstNo<=0) { $firstNo = '-'; }
		if($lastNo<=0)  { $lastNo = '-'; }
   }
   else // само Hexa + Increment $lastNo > $firstNo ?!
   {
		// Hex INCREMENT (+)
	//	$result = $lastNo - $firstNo - $allFails;
	//	if($firstNo=='0') { $firstNo = '-'; }
	//	if($lastNo =='0') { $lastNo = '-'; }
		
		// Hex DECREMENT   (-)
		$result = $firstNo - $lastNo - $allFails;
		if($firstNo<=0) { $firstNo = '-'; }
		if($lastNo<=0)  { $lastNo = '-'; }
		
		$firstNo = strtoupper(dechex($row->firstNo));
		$lastNo  = strtoupper(dechex($row->lastNo));

		(null===$row->lastTime) ? $result=0 : '';
		$td_css_hex = 'text-align:center;color:#a00;font-weight:600;';
   }
   
   $lost = 0;
   if($result>0) { $lost = 100*round($ourFails/$result,3); }

   // Errors
   if(!$ourFails) { $ourFails = ''; }
   if(!$facFails) { $facFails = ''; }
   if(!$allFails) { $allFails = ''; }
      
   // Results
   if($result<=0) { $result = '-'; }
   if(!$lost) { $lost = '-'; } else { $lost .= '%'; }

	
	// сега целия ред:
	$table_data_row.=
	"<tr>
      <th width='0.1%' style='$td_no_css'>
         <input type='checkbox' class='hidden hidePRN' id='item_$item_id' value='$item_id'/>
      </th>
      <td style='$td_css'>$reel_link</td>
      <td style='$td_css'><b>$box</b></td>
      <td style='$td_css'><b>$machine</b></td>
      <td style='$td_css_hex'>$firstNo</td>
      <td style='$td_blue_css'>$firstTime</td>
      <td style='$td_css_hex'>$lastNo</td>
      <td style='$td_blue_css'>$lastTime</td>
         <td style='$td_real_css'><b>$realTime</b></td>
         <td style='$td_cald_css'><b>$caldTime</b></td>
      <td style='$td_css'>$ourFails</td>
      <td style='$td_css'>$facFails</td>
      <td style='$td_css'><b>$allFails</b></td>
      <td style='$td_gr_css'><b>$result<b></td>
      <td style='$td_red_css'><i>$lost</i></td>
   </tr>";

	return $table_data_row;
}

/*================================ REPAIRS ============================ */
function get_repairs_table($repairs_data)
{
	$CI =& get_instance();
	$mode = $CI->fenotag_lib->get_mode();
	$table_data_rows='';
	
	$td_no_css    = 'border:none;background:transparent;';
	$td_sum_css   = 'text-align:center;color:#222;background:#ddd;font-size:120%;height:25px;border:1px solid #222;';
	$td_total_css = 'text-align:center;color:#b00;background:#fff;font-size:120%;height:25px;border:1px solid #222;';

	$td_sumas_css = 'text-align:center;color:#007;background:#ddd;font-size:115%;height:30px;';
	$td_avrR_css  = 'text-align:center;color:#009;background:#bfb;font-size:115%;height:30px;';
	$td_avrC_css  = 'text-align:center;color:#707;background:#bfb;font-size:115%;height:30px;';
	$td_final_css = 'text-align:center;color:#000;background:#ddd;font-size:125%;height:30px;text-shadow: 1px 1px #888;';
	$td_final_avg = 'text-align:center;color:#000;background:#ecc;font-size:125%;height:30px;text-shadow: 1px 1px #888;'; 

	$all_summas = $CI->Fenotag->get_sumRepairs('2210');

	if($repairs_data)
	{
      // show headers
      echo $CI->fenotag_lib->getRepairHeaders();

      // start values
      $total_B1 = $total_B2 = $total_B3 = $total_B4 = $total_B5 = $total_B6 = 0;
      
      foreach($repairs_data as $row)
      { 
         $rep_id = $row['rep_id'];
         $table_data_rows .= get_repair_row( $rep_id );
         
         $sum_row_b1 = (int)$row['b1_day'] + (int)$row['b1_mid'] + (int)$row['b1_night']; $total_B1 += $sum_row_b1;
         $sum_row_b2 = (int)$row['b2_day'] + (int)$row['b2_mid'] + (int)$row['b2_night']; $total_B2 += $sum_row_b2;
         $sum_row_b3 = (int)$row['b3_day'] + (int)$row['b3_mid'] + (int)$row['b3_night']; $total_B3 += $sum_row_b3;
         $sum_row_b4 = (int)$row['b4_day'] + (int)$row['b4_mid'] + (int)$row['b4_night']; $total_B4 += $sum_row_b4;
         
         $sum_row_b5 = (int)$row['b5_day'] + (int)$row['b5_mid'] + (int)$row['b5_night']; $total_B5 += $sum_row_b5;
         $sum_row_b6 = (int)$row['b6_day'] + (int)$row['b6_mid'] + (int)$row['b6_night']; $total_B6 += $sum_row_b6;
         
      }
      
      $all_repairs = $total_B1 + $total_B2 + $total_B3 + $total_B4 + $total_B5 + $total_B6;
      
      $total_B1 = ($total_B1) ? "$total_B1 ч." : '-';
      $total_B2 = ($total_B2) ? "$total_B2 ч." : '-';
      $total_B3 = ($total_B3) ? "$total_B3 ч." : '-';
      $total_B4 = ($total_B4) ? "$total_B4 ч." : '-';
      $total_B5 = ($total_B5) ? "$total_B5 ч." : '-';
      $total_B6 = ($total_B6) ? "$total_B6 ч." : '-';
      
      if($all_repairs>0)
      {
         $table_data_rows .=
         "<tr>
            <th colspan='3' style='$td_no_css'></th>
            <th colspan='3' id='b1_sum' style='$td_sum_css'>$total_B1</th>
            <th style='$td_no_css'></th>
            <th colspan='3' id='b2_sum' style='$td_sum_css'>$total_B2</th>
            <th style='$td_no_css'></th>
            <th colspan='3' id='b3_sum' style='$td_sum_css'>$total_B3</th>
            <th style='$td_no_css'></th>
            <th colspan='3' id='b4_sum' style='$td_sum_css'>$total_B4</th>
            <th style='$td_no_css'></th>
            <th colspan='3' id='b5_sum' style='$td_sum_css'>$total_B5</th>
            <th style='$td_no_css'></th>
            <th colspan='3' id='b6_sum' style='$td_sum_css'>$total_B6</th>
      
            <th id='b_allsum' style='$td_total_css'>$all_repairs ч.</th>
         </tr>";
      }
   }
   else
   {
      $table_data_rows = "<tr>
                            <th colspan='13'>
                              <div class='warning_noitems' style='background-color:rgba(130,250,100,0.25);border:1px solid #555;padding:5px;'>".
                                 $CI->lang->line('feno_no_items').
                              "</div>
                            </th>
                         </tr>"; 
   } ?>
         <div id="bottom_bar_empty">
         
            <div id="bottom_rbar_1">
               <span class="bottom_bar_title">B1</span>
               <span id="place_B1" class="bottom_bar_text"><?=$total_B1;?></span>
            </div>

            <div id="bottom_rbar_2">
               <span class="bottom_bar_title">B2</span>
               <span id="place_B2" class="bottom_bar_text"><?=$total_B2;?></span>
            </div>

            <div id="bottom_rbar_3">
               <span class="bottom_bar_title">B3</span>
               <span id="place_B3" class="bottom_bar_text"><?=$total_B3;?></span>
            </div>

            <div id="bottom_rbar_4">
               <span class="bottom_bar_title">B4</span>
               <span id="place_B4" class="bottom_bar_text"><?=$total_B4;?></span>
            </div>            
            
            <div id="bottom_rbar_5">
               <span class="bottom_bar_title">B5</span>
               <span id="place_B5" class="bottom_bar_text"><?=$total_B5;?></span>
            </div>
            
            <div id="bottom_rbar_6">
               <span class="bottom_bar_title">B6</span>
               <span id="place_B6" class="bottom_bar_text"><?=$total_B6;?></span>
            </div>

         </div>
<?php   
   
   return $table_data_rows;
}

function get_repair_row($rep_id)
{
	$CI =& get_instance();
	$mode = $CI->fenotag_lib->get_mode();
	$controller = strtolower('Fenotags');
	$table_data_row = '';

	$td_bcolor = 'color:#004;'; // blue
	$td_gcolor = 'color:#404;'; // violet
   $td_rcolor = 'color:#900;text-shadow: 1px 1px #aaa;'; // red
   $td_no_css = 'border:none;background:transparent;';
   $td_css    = 'text-align:center;color:#222;';
   
   $th_css    = 'text-align:center;color:#222;background:#ccc;border:1px solid #222;font-size:120%;';
	
	// взимаме целия ред ...
	$row = $CI->Fenotag->get_rep_id($rep_id);
	
	$months_12 = array('1'=>'яну','2'=>'фев','3'=>'мар','4'=>'апр','5'=>'май','6'=>'юни',
                      '7'=>'юли','8'=>'авг','9'=>'сеп','10'=>'окт','11'=>'ное','12'=>'дек');
	
	$mon = (int)date("m",strtotime($row->date));
	$mMonth = $months_12[$mon];
	$date = date("d",strtotime($row->date)).".".$mMonth;
	
	$b1_day    = $row->b1_day;
	$b1_mid    = $row->b1_mid;
	$b1_night  = $row->b1_night;
	$b1_reel   = $row->b1_reel;
	
	$b2_day    = $row->b2_day;
	$b2_mid    = $row->b2_mid;
	$b2_night  = $row->b2_night;
	$b2_reel   = $row->b2_reel;
	
	$b3_day    = $row->b3_day;
	$b3_mid    = $row->b3_mid;
	$b3_night  = $row->b3_night;
	$b3_reel   = $row->b3_reel;
	
	$b4_day    = $row->b4_day;
	$b4_mid    = $row->b4_mid;
	$b4_night  = $row->b4_night;
	$b4_reel   = $row->b4_reel;

	// допълнителни за сега не се използват ?!
	$b5_day    = $row->b5_day;
	$b5_mid    = $row->b5_mid;
	$b5_night  = $row->b5_night;
	$b5_reel   = $row->b5_reel;
	
	$b6_day    = $row->b6_day;
	$b6_mid    = $row->b6_mid;
	$b6_night  = $row->b6_night;
	$b6_reel   = $row->b6_reel;
	
   // изчислявам
	$row_time  = $b1_day + $b1_mid + $b1_night + $b2_day + $b2_mid + $b2_night +
                $b3_day + $b3_mid + $b3_night + $b4_day + $b4_mid + $b4_night +
                $b5_day + $b5_mid + $b5_night + $b6_day + $b6_mid + $b6_night;
	
	$row_time  = ($row_time) ? $row_time.' ч.' : '';
	
	// чистим 0-те
	$b1_day    = (!$b1_day) ? '' : (int)$b1_day;
   $b1_mid    = (!$b1_mid) ? '' : (int)$b1_mid;
	$b1_night  = (!$b1_night) ? '' : (int)$b1_night;
	
	$b2_day    = (!$b2_day) ? '' : (int)$b2_day;
   $b2_mid    = (!$b2_mid) ? '' : (int)$b2_mid;
	$b2_night  = (!$b2_night) ? '' : (int)$b2_night;
	
	$b3_day    = (!$b3_day) ? '' : (int)$b3_day;
   $b3_mid    = (!$b3_mid) ? '' : (int)$b3_mid;
	$b3_night  = (!$b3_night) ? '' : (int)$b3_night;
	
	$b4_day    = (!$b4_day) ? '' : (int)$b4_day;
   $b4_mid    = (!$b4_mid) ? '' : (int)$b4_mid;
	$b4_night  = (!$b4_night) ? '' : (int)$b4_night;
	
	// допълнителните
	$b5_day    = (!$b5_day) ? '' : (int)$b5_day;
   $b5_mid    = (!$b5_mid) ? '' : (int)$b5_mid;
	$b5_night  = (!$b5_night) ? '' : (int)$b5_night;
	
	$b6_day    = (!$b6_day) ? '' : (int)$b6_day;
   $b6_mid    = (!$b6_mid) ? '' : (int)$b6_mid;
	$b6_night  = (!$b6_night) ? '' : (int)$b6_night;
	
	$rep_txt  = "$date";
	$rep_link = anchor("$controller/view_repair/$rep_id/width:620/height:430",
									  $rep_txt,
									  array('class'=>'thickbox','title'=>"ден: $date"));	
	
	// сега целия ред:
	$table_data_row.=
	"<tr>
      <th width='0.1%' style='$td_no_css'>
         <input type='checkbox' class='hidden hidePRN' id='rep_$rep_id' value='$rep_id'/>
      </th>

      <td style='$td_bcolor'>$rep_link</td>
      
      <td style='$td_gcolor'><b>$b1_reel</b></td>
      <td>$b1_day</td><td>$b1_mid</td><td>$b1_night</td>
      
      <td style='$td_gcolor'><b>$b2_reel</b></td>
      <td>$b2_day</td><td>$b2_mid</td><td>$b2_night</td>

      <td style='$td_gcolor'><b>$b3_reel</b></td>
      <td>$b3_day</td><td>$b3_mid</td><td>$b3_night</td>
      
      <td style='$td_gcolor'><b>$b4_reel</b></td>
      <td>$b4_day</td><td>$b4_mid</td><td>$b4_night</td>

      <td style='$td_gcolor'><b>$b5_reel</b></td>
      <td>$b5_day</td><td>$b5_mid</td><td>$b5_night</td>
      
      <td style='$td_gcolor'><b>$b6_reel</b></td>
      <td>$b6_day</td><td>$b6_mid</td><td>$b6_night</td>
      
      <th style='$th_css'><b>$row_time</b></th>
      <th></th>
   </tr>";

	return $table_data_row;
} ?>
