<?php
class Bisoft_lib
{
	var $CI;

  	function __construct()
	{
		$this->CI =& get_instance();
	}

	// certification
	function get_certkey() 
	{ 
      if(!$this->CI->session->userdata('cert')) { return 0; }
      else { return $this->CI->session->userdata('cert'); }
	}

	function check_certkey($certKey,$certName='') 
	{ 
		if( $certKey and strlen($certKey)==32 and !is_numeric($certKey) )
		{
			switch($certKey)
			{
		//		case 'H1ad34506fb9b428de7940a049db8a0P': $keyAccess=1; $certName='NAP';break; // NAP => eShop
				case 'M536e10c984de1dfc09dc532cd04d6fH': $keyAccess=2; // Shops => BiSOFT
																	  if($certName=='') {$certName='shop';}
																	  break; 
				case 'S76b46a80286c0c7e57Y78cefbd6197P': $keyAccess=3; // Production => BiSOFT
																	  if($certName=='') {$certName='manu';}
																	  break; 
				case 'Se72f454eb68c96c754Z91Lc015G317H': $keyAccess=4; // Office => BiSOFT + eShop
																	  if($certName=='') {$certName='office';}
																	  break; 
				// Main Head = BiSOFT
				case 'Ae93a66ceb4bf201deaF1b0f6473z4cA': $keyAccess=8; $certName='AHHA';break; // AHHA
				case 'D7dba2aee0f01deaF1b0f6a3WJ51a4cL': $keyAccess=8; $certName='DESSY';break; // Dessy
				case 'C4bba630148cfbad2c662f8eb58acfeK': $keyAccess=8; $certName='SILVIA';break; // Силвия
				case 'M75034b7dba2aee0639fLde45b615f3K': $keyAccess=8; $certName='MOMOTO';break; // Момчил
				case 'P43bfd6e61e3r705C5f9f45ce20d452K': $keyAccess=8; $certName='RENETA';break; // Ренета
				// Admins
				case 'B1b8a4dN75d8b3f7a9c7z32f64U51d8K': $keyAccess=9; $certName='VIKI';break; // Виктор
				case 'B613c1z9fe6d78c2e8c4a3WJ5271ac6A': $keyAccess=9; $certName='BISKA';break; // Бисер
				default: $keyAccess=0;$certName='';
			}
		} // if(isset($_GET['cert']))
		else { $certKey=0;$keyAccess=0;$certName=''; }
		
		if($certKey and $keyAccess)
		{
         $this->CI->session->set_userdata('cName', $certName);
         $this->CI->session->set_userdata('cert', $certKey);
         $this->CI->session->set_userdata('keyAccess', $keyAccess);
      }
      return $keyAccess;
   }
   
	function get_keyAccess() 
	{ 
      if(!$this->CI->session->userdata('keyAccess')) { return 0; }
      else { return $this->CI->session->userdata('keyAccess'); }
	}
	
	function clear_certkey() 	
	{ 
      $this->CI->session->unset_userdata('cName');
      $this->CI->session->unset_userdata('cert');
      $this->CI->session->unset_userdata('keyAccess');
      $this->CI->session->sess_destroy();
   }	
	
	//Mobile
	function check_mobile() 
	{ 
      if(!$this->CI->session->userdata('check_mobile')) { return 0; }
      else { return $this->CI->session->userdata('check_mobile'); }
	}
	
	function block_mobile() 
   { $this->CI->session->set_userdata('check_mobile', 1);}
	
	function get_mobile() 
	{       
      if(!$this->CI->session->userdata('mobile')) { return 0; }
      else { return $this->CI->session->userdata('mobile'); }
	}
	
	function set_mobile($isMobile) 
	{ $this->CI->session->set_userdata('mobile', $isMobile); }
	
	function get_cart()
	{
		if(!$this->CI->session->userdata('cart'))
			$this->set_cart(array());

	return $this->CI->session->userdata('cart');
	}


	function set_cart($cart_data)
	{
		$this->CI->session->set_userdata('cart',$cart_data);
	}


	// Multiple Payments
	function get_payments()
	{
		if( !$this->CI->session->userdata( 'payments' ) )
			$this->set_payments( array( ) );

		return $this->CI->session->userdata('payments');
	}


	function set_payments($payments_data)
	{
		$this->CI->session->set_userdata('payments',$payments_data);
	}

	
	// Comments
	function get_comment() 
	{
		return $this->CI->session->userdata('comment');
	}


	function set_comment($comment) 
	{
		$this->CI->session->set_userdata('comment', $comment);
	}

	function clear_comment() 	
	{
		$this->CI->session->unset_userdata('comment');
	}
	

	function get_email_receipt() 
	{
		return $this->CI->session->userdata('email_receipt');
	}


	function set_email_receipt($email_receipt) 
	{
		$this->CI->session->set_userdata('email_receipt', $email_receipt);
	}


	function clear_email_receipt() 	
	{
		$this->CI->session->unset_userdata('email_receipt');
	}

// -------- Multiple Payments ----------------------------------------

	function add_payment( $payment_id, $payment_amount )
	{
		$payments = $this->get_payments();
		$payment = array( $payment_id=>
		array(
			'payment_type' => $payment_id,
			'payment_amount' => $payment_amount
			)
		);

		//payment_method already exists, add to payment_amount
		if( isset( $payments[$payment_id] ) )
		{
			$payments[$payment_id]['payment_amount'] += $payment_amount;
		}
		else
		{
			//add to existing array
			$payments += $payment;
		}

		$this->set_payments( $payments );
	return true;
	}


	function edit_payment($payment_id,$payment_amount)
	{
		$payments = $this->get_payments();
		if(isset($payments[$payment_id]))
		{
			$payments[$payment_id]['payment_type'] = $payment_id;
			$payments[$payment_id]['payment_amount'] = $payment_amount;
			$this->set_payments($payment_id);
		}
	return false;
	}


	function delete_payment( $payment_id )
	{
		$payments = $this->get_payments();
		unset( $payments[urldecode( $payment_id )] );
		$this->set_payments( $payments );
	}


	function empty_payments()
	{
		$this->CI->session->unset_userdata('payments');
	}


	function get_payments_total()
	{
		$subtotal = 0;
		foreach($this->get_payments() as $payments)
		{
		    $subtotal += $payments['payment_amount'];
		}
		return to_currency_no_money($subtotal);
	}


	function get_amount_due($mode='sale')
	{
		$customer_discount = $this->get_customer_discount();
		$amount_due		= 0;
		$payment_total = $this->get_payments_total();
		$sales_total	= $this->get_total($mode,$customer_discount);

		$amount_due = to_currency_no_money ( $sales_total - $payment_total );

		return $amount_due;
	}
// -------- end of Payments ----------------



	// -------------------------- CUSTOMER ---------------------- //
	function get_customer()
	{
		if(!$this->CI->session->userdata('customer'))
			$this->set_customer(-1);

		return $this->CI->session->userdata('customer');
	}

	function set_customer($customer_id)
	{
		$this->CI->session->set_userdata('customer',$customer_id);
	}

	function remove_customer()
	{
		$this->CI->session->unset_userdata('customer');
		$this->CI->BiSOFT_Model->set_user_client(0);
	}

	// -------------------------- SUPPLIER ---------------------- //
	function get_supplier()
	{
		if(!$this->CI->session->userdata('supplier'))
			$this->set_supplier(-1);

	return $this->CI->session->userdata('supplier');
	}

	function set_supplier($supplier_id)
	{
		if ($supplier_id > 0) { $this->CI->BiSOFT_Model->set_user_client($supplier_id);}
		$this->CI->session->set_userdata('supplier',$supplier_id);
	}

	function remove_supplier()
	{
		$this->CI->session->unset_userdata('supplier');
		$this->CI->BiSOFT_Model->set_user_client(0);
	}


	// -------------------------- CONSIGNEE ---------------------- //
	function get_consignee()
	{
		if(!$this->CI->session->userdata('consignee'))
			$this->set_consignee(6);

	return $this->CI->session->userdata('consignee');
	}

	function set_consignee($consignee_id)
	{
		if ($consignee_id > 0) { $this->CI->BiSOFT_Model->set_user_client($consignee_id);}
		$this->CI->session->set_userdata('consignee',$consignee_id);
	}

	function remove_consignee()
	{
		$this->CI->session->unset_userdata('consignee');
		$this->CI->BiSOFT_Model->set_user_client(0);
	}



// ------------------------------ Prices ----------------------------- //

	function get_mode_price()
	{
		if(!$this->CI->session->userdata('mode_price'))
			$this->set_mode_price(6);

		return $this->CI->session->userdata('mode_price');
	}

	function set_mode_price($mode_price)
	{
		$this->CI->session->set_userdata('mode_price',$mode_price);
	}

// ------------------------------ Printons ----------------------------- //

	function get_mode_print()
	{
		if(!$this->CI->session->userdata('mode_print'))
			$this->set_mode_print('prices');

		return $this->CI->session->userdata('mode_print');
	}

	function set_mode_print($mode_print)
	{
		$this->CI->session->set_userdata('mode_print',$mode_print);
	}


// -------------------------- modes ----------------------------------

	function get_mode()
	{
	$location = $this->CI->Employee->get_logged_in_employee_info()->location;
	$default_mode = 'sale';
	if( !$location == 0) { $default_mode = 'shop_sale';}

		if(!$this->CI->session->userdata('sale_mode'))
			$this->set_mode($default_mode);

	return $this->CI->session->userdata('sale_mode');
	}


	function set_mode($mode)
	{
		$this->CI->session->set_userdata('sale_mode', $mode);
	}



	function add_item( $item_number, $quantity=1, $price=0, $item_discount=0, 
			$qty_1=0, $qty_2=0, $qty_3=0, $qty_4=0, $qty_5=0,
			$qty_6=0, $qty_7=0, $qty_8=0, $qty_9=0, $qty_max=0)
	{
		$location = $this->CI->BiSOFT_Model->get_location();
		$mode = $this->get_mode();
		$error_key = 0;
		
		if($mode=='shop_sale' or $mode=='shop_return' or  $mode=='consi_sale')
			{
				$item_info = $this->CI->Item->get_snum_info($item_number,$location);
					$item_id = $item_info->item_id; if(!$item_id) {return false;}
					$real_info = $this->CI->Item->get_inum_info($item_number); // от 'items'
					$name = $real_info->name;
					if($item_number<6000) {$allow_sizes=0;}
					else {$allow_sizes=$real_info->allow_sizes;}
			}
		else // за всички останали от централен Склад-ГП
			{
				$item_info = $this->CI->Item->get_inum_info($item_number);
					$item_id = $item_info->item_id; if(!$item_id) {return false;}
					$name = $item_info->name;
					if($item_number<6000) {$allow_sizes=0;}
					else {$allow_sizes=$item_info->allow_sizes;}
			}

		$items = $this->get_cart();
			$maxkey=$insertkey=$updatekey=0;
			$itemalreadyinsale=FALSE;

		foreach ($items as $item)
		{
			if($maxkey <= $item['line']) { $maxkey = $item['line'];}

			if($item['id']==$item_id)
			{
				$itemalreadyinsale=TRUE;
				$updatekey=$item['line'];
			}
		}

		$insertkey=$maxkey+1;
		$mode_price = $this->get_mode_price();
		switch ($mode_price) 
			{
				case '1': $item_price = $item_info->unit_price;   break;
				case '2': $item_price = $item_info->unit_price_2; break;
				case '3': $item_price = $item_info->unit_price_3; break;
				case '4': $item_price = $item_info->unit_price_4; break;
				case '5': $item_price = $item_info->unit_price_5; break;
				default:  $item_price = $item_info->unit_price;
			}
		$item_price = to_dot($item_price);

		if ( $allow_sizes ) 
			{
				$item = array(($insertkey)=>
								array(
									'line'	=> $insertkey,
									'id'		=> $item_id,
									'inum'	=> $item_number,
									'qty' 	=> $quantity,			
									'Sizes' 	=> $quantity.','.$qty_1.','.$qty_2.','.$qty_3.','.$qty_4.','.$qty_5.
																','.$qty_6.','.$qty_7.','.$qty_8.','.$qty_9.','.$qty_max,
									'disc'	=> $item_discount,
									'price'	=> $price!=null ? $price: $item_price )
								);
								
				//Item already exists
				if($itemalreadyinsale)
					{
						$items[$updatekey]['qty']+=$quantity;
						$old_Qty = explode(',',$items[$updatekey]['Sizes']);
						$items[$updatekey]['Sizes']=($old_Qty[0]+$quantity).','.
									($old_Qty[1]+$qty_1).','.
									($old_Qty[2]+$qty_2).','.
									($old_Qty[3]+$qty_3).','.
									($old_Qty[4]+$qty_4).','.
									($old_Qty[5]+$qty_5).','.
									($old_Qty[6]+$qty_6).','.
									($old_Qty[7]+$qty_7).','.
									($old_Qty[8]+$qty_8).','.
									($old_Qty[9]+$qty_9).','.
									($old_Qty[10]+$qty_max);
					}
				else //add to existing array
					{ $items += $item; }
			}
		else // безразмерни
			{
				if (!$quantity) { $quantity=1;} // за безразмерни qty=1
				$item = array(($insertkey)=>
								array(
									'line'	 => $insertkey,
									'id' 		 => $item_id,
									'inum'	 => $item_number,
									'qty' 	 => $quantity,
									'Sizes' 	 => $quantity,
									'disc'	 => $item_discount,
									'price'	 => $price!=null ? $price: $item_price )
								);
				//Item already exists
				if($itemalreadyinsale)
					{ $items[$updatekey]['qty']++;}  // добавя безразмерни кол-ва.
				else //add to existing array
					{ $items += $item; }
			} // $allow_sizes

		$this->set_cart($items);
		if ($error_key == 'S') { return $error_key; }
	return 'OK';
	}


	function is_valid_invoice_item_number($barcode_item,$mode='sale') 
	{

	   if (!is_numeric($barcode_item)) { return false; }
	   if ($mode!='invoice' and $mode!='invoice_ki' and $mode!='invoice_di' and $mode!='invoice_pr') { return false;}

	   $lenBarcode = strlen($barcode_item);
	   if ($lenBarcode > 0 and $lenBarcode < 4 ) { return true; }
	
	return false;
	}


	
	function out_of_stock($item_id)
	{
		if(!$item_id) { return false;}

		$item = $this->CI->Item->get_sklad_idx($item_id);
		$quanity_added = $this->get_quantity_already_added($item_id);
		
		if ($item->quantity - $quanity_added < 0)
		{
			return true;
		}
		return false;
	}
	
	function get_quantity_already_added($item_id)
	{
		$items = $this->get_cart();
		$quanity_already_added = 0;
		foreach ($items as $item)
			{
				if($item['id']==$item_id)
					{ $quanity_already_added+=$item['qty'];}
			}
	return $quanity_already_added;
	}

	
	function get_item_id($line_to_get)
	{
		$items = $this->get_cart();

		foreach ($items as $line=>$item)
		{
			if($line==$line_to_get)
			{
				return $item['item_id'];
			}
		}
		return -1;
	}



	function edit_item( $line, $quantity, $item_discount, $price,
			$qty_1,$qty_2,$qty_3,$qty_4,$qty_5,$qty_6,$qty_7,$qty_8,$qty_9,$qty_max)
	{
		$items = $this->get_cart();
		if(isset($items[$line]))
		{
			$items[$line]['qty'] 		= $quantity;
			$items[$line]['disc']= $item_discount;
			$items[$line]['price'] 			= $price;

			$items[$line]['q1'] 		= $qty_1;
			$items[$line]['q2'] 		= $qty_2;
			$items[$line]['q3'] 		= $qty_3;
			$items[$line]['q4'] 		= $qty_4;
			$items[$line]['q5'] 		= $qty_5;
			$items[$line]['q6'] 		= $qty_6;
			$items[$line]['q7'] 		= $qty_7;
			$items[$line]['q8'] 		= $qty_8;
			$items[$line]['q9'] 		= $qty_9;
			$items[$line]['q10'] 	= $qty_max;

			$this->set_cart($items);
		}
		return false;
	}



// my stuff  ------------------------------- BarCode  ------------------------------------- //
	
	function is_valid_item_number($barcode_item) 
	{

	   if (!is_numeric($barcode_item)) { return false; }

	   $lenBarcode = strlen($barcode_item);
	   if ($lenBarcode <  4 or $lenBarcode > 7 ) { return false; }
	
	return true;
	}


	function is_valid_barcode($barcode_item)
	{ //barCode validation
	$lenBarcode = strlen($barcode_item);
		if ($lenBarcode <  8) { return false; }
		if ($lenBarcode >  8 and $lenBarcode < 12) { return false; }
		if ($lenBarcode > 13) { return false; }
		if (is_numeric(!$barcode_item)) { return false; }
	return true;
	}



	function add_item_barcode($barcode_item,$quantity=1)
	{  //barCode #
		$lenBarcode = strlen($barcode_item);
		$item_number = 0;
		$barcode = substr($barcode_item,0,-1);

		$qty = array();
			 $qty[1] = 0; $qty[2] = 0; $qty[3] = 0; $qty[4] = 0; $qty[5] = 0;
			 $qty[6] = 0; $qty[7] = 0; $qty[8] = 0; $qty[9] = 0; $qty[0] = 0;

		// EAN-8 Code table - checks 5-7 digit item numbers
		if ($lenBarcode == 8 ) { $item_number = (int) $barcode;}

		// EAN-13 Code table
		if ($lenBarcode == 13 ) 
		{
		// checks 380 = Bulgaria Code table
		   $barcode_380 = substr($barcode_item,0,3);
		   if ($barcode_380 == '380') { $item_number = (int) substr($barcode_item,-6,-1); }
		   else { // else 380
			// Normal 13 bit code
			$barcode = substr($barcode_item,1,-1);
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 10) { $qty[$size_qty] = $quantity;}
			elseif ($size_qty == 10) { $qty[0] = $quantity; }
			else 
				{ 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[0] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
				}
			} // end of else 380
		}

		// BiSOFT internal Code table 12 (-leading 0)
		if ($lenBarcode == 12 ) 
		{
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 10) { $qty[$size_qty] = $quantity;}
			elseif ($size_qty == 10) { $qty[0] = $quantity; }
			else { 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[0] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
			     }
		}

	
	$this->add_item($item_number, $quantity, 0, 0,
		$qty[1], $qty[2], $qty[3], $qty[4], $qty[5],
		$qty[6], $qty[7], $qty[8], $qty[9], $qty[0]);

	return true;
	}


	function check_item_sizes($item_number,$item_data,$mode='sale') 
	{
	// за някои режими няма смисъл да се проверяват количествата ...
	    if (	$mode == 'sale_return' or $mode == 'shop_return' or $mode == 'consi_return' or 
		$mode == 'invoice' or $mode == 'invoice_ki' or $mode == 'invoice_di' or $mode == 'invoice_pr' or
		$mode == 'brak' or $mode == 'balance') { return true;}	

	    $item_info = $this->CI->Item->get_item_info($item_number);
	    $skl_info = $this->CI->Item->get_sklad_info($item_number,0);
	    $key_for_error = 0;
	    $allow_sizes = $item_info->allow_sizes;

     if ( $allow_sizes ) {   // поверка на РАЗМЕРНИ АРТИКУЛИ ...

	$item_store = array(
		'quantity'  => $skl_info->qty,
		'qty_1'	   => $skl_info->q1,
		'qty_2'	   => $skl_info->q2,
		'qty_3'	   => $skl_info->q3,
		'qty_4'	   => $skl_info->q4,
		'qty_5'	   => $skl_info->q5,
		'qty_6'	   => $skl_info->q6,
		'qty_7'	   => $skl_info->q7,
		'qty_8'	   => $skl_info->q8,
		'qty_9'	   => $skl_info->q9,
		'qty_max'   => $skl_info->q10,
		);

	if ($item_store['quantity'] < $item_data['quantity']) 	{ $key_for_error = 1;}
	if ($item_store['qty_1'] < $item_data['qty_1'])     	{ $key_for_error = 1;}
	if ($item_store['qty_2'] < $item_data['qty_2'])     	{ $key_for_error = 1;}
	if ($item_store['qty_3'] < $item_data['qty_3'])     	{ $key_for_error = 1;}
	if ($item_store['qty_4'] < $item_data['qty_4'])     	{ $key_for_error = 1;}
	if ($item_store['qty_5'] < $item_data['qty_5'])     	{ $key_for_error = 1;}
	if ($item_store['qty_6'] < $item_data['qty_6'])     	{ $key_for_error = 1;}
	if ($item_store['qty_7'] < $item_data['qty_7'])     	{ $key_for_error = 1;}
	if ($item_store['qty_8'] < $item_data['qty_8'])     	{ $key_for_error = 1;}
	if ($item_store['qty_9'] < $item_data['qty_9'])     	{ $key_for_error = 1;}
	if ($item_store['qty_max'] < $item_data['qty_max']) 	{ $key_for_error = 1;}

	} else  {  // поверка само на БЕЗРАЗМЕРНИ ...
		  $qtty = $skl_info->qty;
		  if( $qtty < $item_data['quantity']) { $key_for_error = 1;} 
		}

	if ($key_for_error == 1) {return false;}
	return true;
	}

// end of my stuff --------------------------------------------------------------------------




	function is_valid_receipt($receipt_doc_id)
	{
		//POS #
		$pieces = explode(' ',$receipt_doc_id);

		if(count($pieces)==2)
		{
			return $this->CI->Sale->exists($pieces[1]);
		}

		return false;
	}
	
	function is_valid_item_kit($item_kit_id)
	{
		//KIT #
		$pieces = explode(' ',$item_kit_id);

		if(count($pieces)==2)
		{
			return $this->CI->Item_kit->exists($pieces[1]);
		}

		return false;
	}

	function return_entire_sale($receipt_doc_id,$vedomPack)
	{
		//POS #
		$pieces = explode(' ',$receipt_doc_id);
		$doc_id = $pieces[1];

		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Sale->get_sale_items($doc_id,$vedomPack)->result() as $row)
		{
			$this->add_item($row->item_id,-$row->item_qty,$row->item_unit_price,$row->item_discount);
		}
		$this->set_customer($this->CI->Sale->get_customer($doc_id,$vedomPack)->person_id);
	}
	
	function add_item_kit($external_item_kit_id)
	{
		//KIT #
		$pieces = explode(' ',$external_item_kit_id);
		$item_kit_id = $pieces[1];
		
		foreach ($this->CI->Item_kit_items->get_info($item_kit_id) as $item_kit_item)
		{
			$this->add_item($item_kit_item['item_id'], $item_kit_item['quantity']);
		}
	}



// ---- other 

	function copy_entire_sale($doc_id,$vedomPack)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Sale->get_sale_items($doc_id,$vedomPack)->result() as $row)
		{
			$this->add_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount,
					$row->qty_1, $row->qty_2, $row->qty_3, $row->qty_4, $row->qty_5,
					$row->qty_6, $row->qty_7, $row->qty_8, $row->qty_9, $row->qty_max
							);
		}

		foreach($this->CI->Sale->get_sale_payments($doc_id,$vedomPack)->result() as $row)
		{
			$this->add_payment($row->pay_type,$row->pay_amount);
		}

	$this->set_customer($this->CI->Sale->get_customer($doc_id,$vedomPack)->person_id);
	}
	




	function copy_entire_suspended_sale($doc_id,$vedomPack)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Suspended->get_sale_items($doc_id,$vedomPack)->result() as $row)
		{
			$this->add_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount,
					$row->qty_1, $row->qty_2, $row->qty_3, $row->qty_4, $row->qty_5,
					$row->qty_6, $row->qty_7, $row->qty_8, $row->qty_9, $row->qty_max
							);
		}

			$customer_id = 0;
			$bisoft_id = $this->CI->Suspended->get_customer($doc_id,$vedomPack);

				if ($bisoft_id != 0)  // когато не е бил избран КЛИЕНТ 
				{
					$customer_id = $this->CI->Customer->get_info_by_bisoft_id($bisoft_id)->person_id;
					$this->set_customer($customer_id);
				}

			$mode = $this->CI->Suspended->get_mode($doc_id);
		$this->set_mode($mode);
		$this->set_comment($this->CI->Suspended->get_comment($doc_id));
	}



	function delete_item($line)
	{
		$items=$this->get_cart();
		unset($items[$line]);
		$this->set_cart($items);
	}

	function empty_cart()
	{
		$this->CI->session->unset_userdata('cart');
	}


	function clear_mode_price()
	{
		$this->CI->session->unset_userdata('mode_sale_price');
		$this->CI->session->unset_userdata('mode_recv_price');
	}

	function clear_mode_print()
	{
		$this->CI->session->unset_userdata('mode_sale_print');
		$this->CI->session->unset_userdata('mode_recv_print');
		$this->CI->session->unset_userdata('mode_print');
	}

	function clear_mode()
	{
		$this->CI->session->unset_userdata('sale_mode');
		$this->CI->session->unset_userdata('recv_mode');
	}

	function clear_all()
	{
		$this->clear_mode();
		$this->empty_cart();
		$this->clear_comment();
		$this->clear_email_receipt();
		$this->empty_payments();
		$this->clear_mode_price();
		$this->clear_mode_print();
		$this->remove_customer();
		$this->remove_consignee();
		$this->remove_supplier();
	}

/* ===========================================================================================  */
	function copy_entire_document($doc_id, $vedomPack, $mode, $location)
	{
		if(null===$mode) { $mode='sale'; }
		$this->clear_all();

		foreach($this->CI->BiSOFT_Model->get_document_items($doc_id,$vedomPack)->result() as $row)
		{
			$Qty = explode(',',$row->item_name);
			$this->CI->BiSOFT_Model->zebex_add_doc_item( // add_document_item(
					$mode,
					$row->item_number,
					$row->line,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount,
					$Qty, 
					$location );
		}


	if ( $mode == 'sale' or $mode == 'sale_return' or $mode == 'shop_sale' or $mode == 'shop_return')
		{ 
			foreach($this->CI->Sale->get_sale_payments($doc_id,$vedomPack)->result() as $row)
			{ $this->add_payment($row->pay_type,$row->pay_amount);}

			$this->set_customer($this->CI->Sale->get_customer($doc_id,$vedomPack)->person_id);
		}
	elseif ( $mode != 'shop_recv' and $mode != 'shop_sgp')
		{ $this->set_supplier($this->CI->Recv->get_supplier($doc_id,$vedomPack)->person_id);}
	}
	
/* ===========================================================================================  */
	function copy_entire_online_document($doc_id, $vedomPack, $mode)
	{
		if(null===$mode) { $mode='online_sale'; }
		$this->clear_all();

		foreach($this->CI->BiSOFT_Model->get_document_items($doc_id,$vedomPack)->result() as $row)
		{
			$Qty = explode(',',$row->item_name);
			$this->CI->BiSOFT_Model->zebex_add_online_item( // add_document_item(
					$mode,
					$row->item_number,
					$row->line,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount,
					$Qty, 0 );
		}
	}


	// само за PRINT-ове ... СТАРО ...
	function add_document_item( $mode, $inum, $quantity, $price, $discount, $Qty, $location)
	{
		$error_key = 0;
		$skl = $this->CI->BiSOFT_Model->get_user_mode_client();
		
		$name='';$allow_sizes=0;
		$item_info = $this->CI->Item->get_blanka_info($inum);
		$sizes = $this->CI->Item->get_sizes($inum);
		if($item_info)
		{
			$allow_sizes = $item_info->allow_sizes;
			$name = $item_info->name;
		}
		
		if($location==0)
		{
			if($mode == 'consi_sale')
				{$skl_info=$this->CI->Item->get_sklad_info($inum,$skl);}
			else
				{
					if(!$this->CI->Item->exists_in_sklad($inum,0)){return 0;}
					$skl_info=$this->CI->Item->get_sklad_info($inum,0);
				}
		}
		else // магазини
		{
			if($mode == 'shop_sale' and !$this->CI->Item->exists_in_sklad($inum,$location)){return 0;}
			$skl_info=$this->CI->Item->get_sklad_info($inum,$location);
		}
		
		$item_id = $skl_info->item_id;

		$items = $this->get_cart();
			$maxkey=$insertkey=$updatekey=0;
			$itemalreadyinsale=FALSE;

		foreach ($items as $item)
		{
			if($maxkey <= $item['line']) { $maxkey = $item['line'];}

			if($item['inum']==$inum)
			{
				$itemalreadyinsale=TRUE;
				$updatekey=$item['line'];
			}
		}

		$insertkey=$maxkey+1;

		$mode_price = $this->get_mode_price();
		switch ($mode_price) 
			{
				case '1': $item_price = $skl_info->price;   break;
				case '2': $item_price = $skl_info->price_2; break;
				case '3': $item_price = $skl_info->price_3; break;
				case '4': $item_price = $skl_info->price_4; break;
				case '5': $item_price = $skl_info->price_5; break;
				default:  $item_price = $skl_info->price;
			}
		$item_price = to_dot($item_price);

		if ( $allow_sizes ) 
			{
				// $quantity  = $q1+$q2+$q3+$q4+$q5+$q6+$q7+$q8+$q9+$q10; ГРЕШИ ПРИ БАРКОД ЧЕТЕЦА ?!
				$item = array(($insertkey)=>
								array(
									'line' => $insertkey,
									'id'	 => $item_id,
									'inum' => $inum,
									'skl'	 => $skl,
									'qty'	 => $quantity.','.$Qty[1].','.$Qty[2].','.$Qty[3].','.$Qty[4].','.$Qty[5].
															  ','.$Qty[6].','.$Qty[7].','.$Qty[8].','.$Qty[9].','.$Qty[10],
									'dsc'	 => $discount,
									'price'=> $price!=null ? $price: $item_price )
										);
								
				//Item already exists
				if($itemalreadyinsale)
					{
						$old_Qty = explode(',',$items[$updatekey]['qty']);
						$items[$updatekey]['qty']=($old_Qty[0]+$quantity).','.
									($old_Qty[1]+$Qty[1]).','.
									($old_Qty[2]+$Qty[2]).','.
									($old_Qty[3]+$Qty[3]).','.
									($old_Qty[4]+$Qty[4]).','.
									($old_Qty[5]+$Qty[5]).','.
									($old_Qty[6]+$Qty[6]).','.
									($old_Qty[7]+$Qty[7]).','.
									($old_Qty[8]+$Qty[8]).','.
									($old_Qty[9]+$Qty[9]).','.
									($old_Qty[10]+$Qty[10]);
					}
				else //add to existing array
					{ $items += $item; }
			}
		else // безразмерни
			{
				if (!$quantity) { $quantity=1;} // за безразмерни qty=1
				$item = array(($insertkey)=>
								array(
									'line' => $insertkey,
									'id'	 => $item_id,
									'inum' => $inum,
									'skl'	 => $skl,
									'qty'	 => $quantity,
									'dsc'  => $discount,
									'price'=> $price!=null ? $price: $item_price )
										);
				//Item already exists
				if($itemalreadyinsale)
					{ $items[$updatekey]['qty']++;}  // добавя безразмерни кол-ва.
				else //add to existing array
					{ $items += $item; }
			} // $allow_sizes
		
		$this->set_cart($items);
		
	return true;
	}


// ------------------------------------------- INVOICES -------------------------------- //

	function copy_entire_invoice($doc_number,$vedomPack,$firma)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->BiSOFT_Model->get_invoice_items($doc_number,$vedomPack,$firma)->result() as $row)
		{
			$this->add_invoice_item(
					$row->item_name,
					$row->invoice_name,
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount );
		}

		foreach($this->CI->BiSOFT_Model->get_invoice_payments($doc_number,$vedomPack)->result() as $row)
			{ $this->add_payment($row->pay_type,$row->pay_amount);}
	}



	// само за Invoices
	function add_invoice_item( $item_name, $invoice_name, $item_id, $quantity, $price, $discount)
	{
		if(!$item_id) { return false; }
	
		$items = $this->get_cart();
     	$maxkey=$insertkey=$updatekey=0;
		$itemalreadyinsale=FALSE;

		foreach ($items as $item)
		{
			if($maxkey <= $item['line']) { $maxkey = $item['line'];}

			if($item['id']==$item_id)
			{
				$itemalreadyinsale=TRUE;
				$updatekey=$item['line'];
			}
		}

		$insertkey=$maxkey+1;

		$item = array(($insertkey)=>
		array(
			'line' => $insertkey,
			'id'	 => $item_id,
			'name_bg' => $item_name,
			'name_en' => $invoice_name,
			'inum' => $item_id,
			'qty'	 => $quantity,
         'dsc'  => $discount,
			'price'=> $price!=null ? $price: 0 )
				);
		
		//Item already exists
		if($itemalreadyinsale)
			{ $items[$updatekey]['qty']+=$quantity;}
		else //add to existing array
			{ $items+=$item;}

		$this->set_cart($items);

	return true;
	}




// =================================================

	function get_customer_discount()
	{
		$customer_id = $this->get_customer();
		$customer_discount = $this->CI->Customer->get_info($customer_id)->discount;
		if ($customer_discount == '') { return 0;}

	return $customer_discount;
	}



	function get_taxes()
	{
		$customer_id = $this->get_customer();
		$customer = $this->CI->Customer->get_info($customer_id);

		//Do not charge sales tax if we have a customer that is not taxable
		if (!$customer->taxable and $customer_id!=-1)
		{
		   return array();
		}

		$taxes = array();
	return $taxes;
	}

/*	=========================== THREE 4 TWO =========================== */	
	function get_three4two_discount()
	{  
      $location_lock = 0;
      $location = $this->CI->BiSOFT_Model->get_location();
      if($location>0 and $location<11 and $location!=7) {$location_lock = 1;} // само без Красьо=7 ?!
      
      $min_suma = 0;
		$cart = $this->get_cart();
		if ($location_lock and count($cart)>2)
			{
            $new_min_suma = 0;
            foreach($cart as $item)
				{  // find MINIMUM
               $price = round((100-$item['dsc'])*$item['price']/100,2);
               if(($new_min_suma==0) or ($new_min_suma >= $price)) 
                  {$new_min_suma = $price;}
            }
            $min_suma = -abs($new_min_suma);
         }
         
	return $min_suma;
	}
	

	function get_subtotal()
	{
		$subtotal = 0;
		foreach($this->get_cart() as $item)
			{
				if(isset($item['dsc']) and $item['dsc']>0) {$disc = $item['dsc'];}
				else {$disc = 0;}
				$subtotal += $item['qty'] * round( $item['price']*(100-$disc)/100, 7);
			}
			
      $subtotal += $this->get_three4two_discount();
      
	return $subtotal;
	}

	function get_online_total()
	{
		$subtotal = $this->get_subtotal('online_sale');
		$total = 1.2 * $subtotal;
	return $total;
	}

	function get_invoice_subtotal()
	{
		$subtotal = 0;
		foreach($this->get_cart() as $item)
		{
			$subtotal += $item['qty']*round( $item['price']*(100-$item['dsc'])/100, 7);
		}
	return $subtotal;
	}


	function get_tax_VAT($mode='invoice', $taxed=1)
	{
		$tax_VAT	= 0;
		$subtotal = $this->get_subtotal();
		if ( 	$mode == 'invoice' or 
				$mode == 'invoice_ki' or 
				$mode == 'invoice_di' or 
				$mode == 'invoice_pr' or
				$mode == 'proforma' or $mode == 'offer')
			{  $subtotal = $this->get_invoice_subtotal();
				$tax_VAT = round( 20 * $subtotal / 100, 7);}

		if ( $taxed == 0 ) { $tax_VAT	= 0;}

	return $tax_VAT;
	}



	function get_total($mode='sale',$customer_discount=0)
	{
		$subtotal = $this->get_subtotal();
		if ( 	$mode == 'invoice' or 
				$mode == 'invoice_ki' or 
				$mode == 'invoice_di' or 
				$mode == 'invoice_pr' or
				$mode == 'proforma' or $mode == 'offer')
			{  $subtotal = $this->get_invoice_subtotal();}
		$total = round( $subtotal * ( 100 - $customer_discount ) / 100, 7); 
		foreach($this->get_taxes() as $tax)
			{ $total += $tax;}

		// добавяме ДДС-то +
		$total += $this->get_tax_VAT($mode);

	return $total;
	}


	function get_invoice_total($mode='invoice', $taxed=1)
	{
		$total = $this->get_invoice_subtotal();
		foreach($this->get_taxes() as $tax) {$total+=$tax;}
		$total += $this->get_tax_VAT($mode,$taxed);
	return $total;
	}


	function get_all_qty()
	{
		$all_qty = 0;
		foreach($this->get_cart() as $item)
			{ $all_qty += $item['qty'];}
	return $all_qty;
	}

	function get_rs232c()
	{
		$TIMEOUT = 10; 
		$fd = dio_open( '/dev/ttyS1', O_RDWR | O_NONBLOCK );
		dio_tcsetattr( $fd, array( 
				'baud' => 9600,
				'bits' => 8,
				'stop' => 1,
				'parity' => 0,
				'flow_control' => 0,
				'is_canonical' => 0 ) 
						); 
		dio_write( $fd, 'tempertur?' ); 
		$input = ''; 
		$time_start = time(); 
		while($time_start + $TIMEOUT > time()) 
			{ 
				$input .= dio_read( $fd ); 
				usleep( 100000 ); 
			} 
		echo $input; 
		dio_close( $fd );
	}

}
?>
