<?php
class Consi_lib
{
	var $CI;

  	function __construct()
	{
		$this->CI =& get_instance();
	}

	function get_cart()
	{
		if(!$this->CI->session->userdata('cart'))
			$this->set_cart(array());

		return $this->CI->session->userdata('cart');
	}

	function set_cart($cart_data)
	{
		$this->CI->session->set_userdata('cart',$cart_data);
	}

	//Alain Multiple Payments
	function get_payments()
	{
		if( !$this->CI->session->userdata( 'payments' ) )
			$this->set_payments( array( ) );

		return $this->CI->session->userdata('payments');
	}

	//Alain Multiple Payments
	function set_payments($payments_data)
	{
		$this->CI->session->set_userdata('payments',$payments_data);
	}
	
	function get_comment() 
	{
		return $this->CI->session->userdata('comment');
	}

	function set_comment($comment) 
	{
		$this->CI->session->set_userdata('comment', $comment);
	}

	function clear_comment() 	
	{
		$this->CI->session->unset_userdata('comment');
	}
	
	function get_email_receipt() 
	{
		return $this->CI->session->userdata('email_receipt');
	}

	function set_email_receipt($email_receipt) 
	{
		$this->CI->session->set_userdata('email_receipt', $email_receipt);
	}

	function clear_email_receipt() 	
	{
		$this->CI->session->unset_userdata('email_receipt');
	}

	function add_payment( $payment_id, $payment_amount )
	{
		$payments = $this->get_payments();
		$payment = array( $payment_id=>
		array(
			'payment_type' => $payment_id,
			'payment_amount' => $payment_amount
			)
		);

		//payment_method already exists, add to payment_amount
		if( isset( $payments[$payment_id] ) )
		{
			$payments[$payment_id]['payment_amount'] += $payment_amount;
		}
		else
		{
			//add to existing array
			$payments += $payment;
		}

		$this->set_payments( $payments );
		return true;

	}

	//Alain Multiple Payments
	function edit_payment($payment_id,$payment_amount)
	{
		$payments = $this->get_payments();
		if(isset($payments[$payment_id]))
		{
			$payments[$payment_id]['payment_type'] = $payment_id;
			$payments[$payment_id]['payment_amount'] = $payment_amount;
			$this->set_payments($payment_id);
		}

		return false;
	}

	//Alain Multiple Payments
	function delete_payment( $payment_id )
	{
		$payments = $this->get_payments();
		unset( $payments[urldecode( $payment_id )] );
		$this->set_payments( $payments );
	}

	//Alain Multiple Payments
	function empty_payments()
	{
		$this->CI->session->unset_userdata('payments');
	}

	//Alain Multiple Payments
	function get_payments_total()
	{
		$subtotal = 0;
		foreach($this->get_payments() as $payments)
		{
		    $subtotal += $payments['payment_amount'];
		}
		return to_currency_no_money($subtotal);
	}

	//Alain Multiple Payments
	function get_amount_due()
	{
		$amount_due		= 0;
		$payment_total = $this->get_payments_total();
		$consis_total	= $this->get_total();

		$amount_due = to_currency_no_money ( $consis_total - $payment_total );

		return $amount_due;
	}

	function get_consignee()
	{
		if(!$this->CI->session->userdata('consignee'))
			$this->set_consignee(-1);

		return $this->CI->session->userdata('consignee');
	}

	function set_consignee($consignee_id)
	{
		$this->CI->session->set_userdata('consignee',$consignee_id);
	}

	function get_mode()
	{
	$location = $this->CI->Employee->get_logged_in_employee_info()->location;
	$default_mode = 'consi';
	if( !$location == 0) { $default_mode = '0';}

		if(!$this->CI->session->userdata('consi_mode'))
			$this->set_mode($default_mode);

	return $this->CI->session->userdata('consi_mode');
	}


	function set_mode($mode)
	{
		$this->CI->session->set_userdata('consi_mode', $mode);
	}







	function add_item( $item_id, $quantity=1, $price=0, $item_discount=0, 
							$doc_number=0, $doc_date=0, $doc_name='Document', $mode='consi',
			$qty_1=0, $qty_2=0, $qty_3=0, $qty_4=0, $qty_5=0,
			$qty_6=0, $qty_7=0, $qty_8=0, $qty_9=0, $qty_max=0)
	{
		//make sure item exists
	/*	if(!$this->CI->Item->exists($item_id))
		{
			//try to get item id given an item_number
			$item_id = $this->CI->Item->get_item_id($item_id);

			if(!$item_id)
				return false;
		} */

			//try to get item id given an item_number
			$item_id = $this->CI->Item->get_item_id($item_id);

			if(!$item_id) { return false; }

		//Alain Serialization and Description

		//Get all items in the cart so far...
		$items = $this->get_cart();

        //We need to loop through all items in the cart.
        //If the item is already there, get it's key($updatekey).
        //We also need to get the next key that we are going to use in case we need to add the
        //item to the cart. Since items can be deleted, we can't use a count. we use the highest key + 1.

        	$maxkey=0;                       //Highest key so far
        	$itemalreadyinconsi=FALSE;        //We did not find the item yet.
		$insertkey=0;                    //Key to use for new entry.
		$updatekey=0;                    //Key to use to update(quantity)

		foreach ($items as $item)
		{
            //We primed the loop so maxkey is 0 the first time.
            //Also, we have stored the key in the element itself so we can compare.

			if($maxkey <= $item['line'])
			{
				$maxkey = $item['line'];
			}

			if($item['item_id']==$item_id)
			{
				$itemalreadyinconsi=TRUE;
				$updatekey=$item['line'];
			}
		}

		$insertkey=$maxkey+1;

		//array/cart records are identified by $insertkey and item_id is just another field.
		$item = array(($insertkey)=>
		array(
			'item_id'=>$item_id,
			'line'=>$insertkey,
			'name'=>$this->CI->Item->get_info($item_id)->name,
			'item_number'=>$this->CI->Item->get_info($item_id)->item_number,
			'item_size_group'=>$this->CI->Item->get_info($item_id)->item_size_group,
			'allow_sizes'=>$this->CI->Item->get_info($item_id)->allow_sizes,

			'qty_1'=>$qty_1,
			'qty_2'=>$qty_2,
			'qty_3'=>$qty_3,
			'qty_4'=>$qty_4,
			'qty_5'=>$qty_5,
			'qty_6'=>$qty_6,
			'qty_7'=>$qty_7,
			'qty_8'=>$qty_8,
			'qty_9'=>$qty_9,
			'qty_max'=>$qty_max,

			'quantity'=>$quantity,
         'item_discount'=>$item_discount,
			'price'=>$price!=null ? $price: $this->CI->Item->get_info($item_id)->unit_price
			)
		);


		// тук една проверчица за размери пак да видим какво аджиба става в количката

		$allow_sizes = $this->CI->Item->get_info($item_id)->allow_sizes;
		$sum_qtys = $qty_1 + $qty_2 + $qty_3 + $qty_4 + $qty_5 + 
			    $qty_6 + $qty_7 + $qty_8 + $qty_9 + $qty_max;
 
		if ( $allow_sizes == 1 ) 
		{
			if   ( $sum_qtys == 0 ) { // това е грешно има размери а не ги иска ?!?
			       return false;} 
			else { 
				$mode = $this->get_mode();
				$item_test_data = array('quantity' => $quantity,
							'qty_1'	   => $qty_1,
							'qty_2'	   => $qty_2,
							'qty_3'	   => $qty_3,
							'qty_4'	   => $qty_4,
							'qty_5'	   => $qty_5,
							'qty_6'	   => $qty_6,
							'qty_7'	   => $qty_7,
							'qty_8'	   => $qty_8,
							'qty_9'	   => $qty_9,
							'qty_max'  => $qty_max);

		// if (!$this->check_item_sizes($item_number,$item_test_data,$mode)) {return false;}

				}

		} 

		//Item already exists
		if($itemalreadyinconsi)
		{
			if ( $allow_sizes == 0 )
			{ $items[$updatekey]['quantity']+=$quantity; } // добавя безразмерни кол-ва.
			else 
			{
			  $items[$updatekey]['qty_1']+=$qty_1;
			  $items[$updatekey]['qty_2']+=$qty_2;
			  $items[$updatekey]['qty_3']+=$qty_3;
			  $items[$updatekey]['qty_4']+=$qty_4;
			  $items[$updatekey]['qty_5']+=$qty_5;
			  $items[$updatekey]['qty_6']+=$qty_6;
			  $items[$updatekey]['qty_7']+=$qty_7;
			  $items[$updatekey]['qty_8']+=$qty_8;
			  $items[$updatekey]['qty_9']+=$qty_9;
			  $items[$updatekey]['qty_max']+=$qty_max;
			  $items[$updatekey]['quantity']+=$quantity;

			}  // добавя размерни кол-ва.
		}
		else
		{
			//add to existing array
			$items+=$item;
		}

		$this->set_cart($items);
		return true;
	}

	
	function out_of_stock($item_id)
	{
		//make sure item exists
/*		if(!$this->CI->Item->exists($item_id))
		{
			//try to get item id given an item_number
			$item_id = $this->CI->Item->get_item_id($item_id);

			if(!$item_id)
				return false;
		}
*/		
		//try to get item id given an item_number
		$item_id = $this->CI->Item->get_item_id($item_id);

			if(!$item_id) { return false;}


		$item = $this->CI->Item->get_info($item_id);
		$quanity_added = $this->get_quantity_already_added($item_id);
		
		if ($item->quantity - $quanity_added < 0)
		{
			return true;
		}
		return false;
	}
	
	function get_quantity_already_added($item_id)
	{
		$items = $this->get_cart();
		$quanity_already_added = 0;
		foreach ($items as $item)
		{
			if($item['item_id']==$item_id)
			{
				$quanity_already_added+=$item['quantity'];
			}
		}
		return $quanity_already_added;
	}

	
	function get_item_id($line_to_get)
	{
		$items = $this->get_cart();

		foreach ($items as $line=>$item)
		{
			if($line==$line_to_get)
			{
				return $item['item_id'];
			}
		}
		return -1;
	}



	function edit_item( $line, $quantity, $item_discount, $price,
			$qty_1,$qty_2,$qty_3,$qty_4,$qty_5,$qty_6,$qty_7,$qty_8,$qty_9,$qty_max)
	{
		$items = $this->get_cart();
		if(isset($items[$line]))
		{
			$items[$line]['quantity'] 		= $quantity;
			$items[$line]['item_discount']= $item_discount;
			$items[$line]['price'] 			= $price;

			$items[$line]['qty_1'] 		= $qty_1;
			$items[$line]['qty_2'] 		= $qty_2;
			$items[$line]['qty_3'] 		= $qty_3;
			$items[$line]['qty_4'] 		= $qty_4;
			$items[$line]['qty_5'] 		= $qty_5;
			$items[$line]['qty_6'] 		= $qty_6;
			$items[$line]['qty_7'] 		= $qty_7;
			$items[$line]['qty_8'] 		= $qty_8;
			$items[$line]['qty_9'] 		= $qty_9;
			$items[$line]['qty_max'] 	= $qty_max;

			$this->set_cart($items);
		}
		return false;
	}



// my stuff  ------------------------------- BarCode  ------------------------------------- //
	
	function is_valid_item_number($barcode_item) 
	{

	   if (!is_numeric($barcode_item)) { return false; }

	   $lenBarcode = strlen($barcode_item);
	   if ($lenBarcode <  4 or $lenBarcode > 7 ) { return false; }
	
	return true;
	}


	function is_valid_barcode($barcode_item)
	{ //barCode validation
	$lenBarcode = strlen($barcode_item);
	$lenBarcode = strlen($barcode_item);
		if ($lenBarcode <  8) { return false; }
		if ($lenBarcode >  8 and $lenBarcode < 12) { return false; }
		if ($lenBarcode > 13) { return false; }
		if (is_numeric(!$barcode_item)) { return false; }
		return true;
	}



	function add_item_barcode($barcode_item,$quantity=1)
	{ //barCode #
	$lenBarcode = strlen($barcode_item);
	$item_number = 0;
	$barcode = substr($barcode_item,0,-1);

	$qty = array();
	    $qty[1] = 0; $qty[2] = 0; $qty[3] = 0; $qty[4] = 0; $qty[5] = 0;
	    $qty[6] = 0; $qty[7] = 0; $qty[8] = 0; $qty[9] = 0; $qty[0] = 0;

		// EAN-8 Code table - checks 5-7 digit item numbers
		if ($lenBarcode == 8 ) { $item_number = (int) $barcode;}

		// EAN-13 Code table
		if ($lenBarcode == 13 ) {
		// checks 380 = Bulgaria Code table
		   $barcode_380 = substr($barcode_item,0,3);
		   if ($barcode_380 == '380') { $item_number = (int) substr($barcode_item,-6,-1); }
		   else { // else 380
			// Normal 13 bit code
			$barcode = substr($barcode_item,1,-1);
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 10) { $qty[$size_qty] = $quantity;}
			elseif ($size_qty == 10) { $qty[0] = $quantity; }
			else { 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[0] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
			     }
			} // end of else 380
		}

		// BiSOFT internal Code table 12 (-leading 0)
		if ($lenBarcode == 12 ) {
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 10) { $qty[$size_qty] = $quantity;}
			elseif ($size_qty == 10) { $qty[0] = $quantity; }
			else { 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[0] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
			     }
		}

		$mode = $this->get_mode();
		$item_test_data = array('quantity' => $quantity,
					'qty_1'	   => $qty[1],
					'qty_2'	   => $qty[2],
					'qty_3'	   => $qty[3],
					'qty_4'	   => $qty[4],
					'qty_5'	   => $qty[5],
					'qty_6'	   => $qty[6],
					'qty_7'	   => $qty[7],
					'qty_8'	   => $qty[8],
					'qty_9'	   => $qty[9],
					'qty_max'  => $qty[0]);

//	if (!$this->check_item_sizes($item_number,$item_test_data,$mode)) {return false;}
	
//	else { // когато всичко е ОК !!!
	$this->add_item($item_number, $quantity, 0, 0, '', '', '', '',
		$qty[1], $qty[2], $qty[3], $qty[4], $qty[5],
		$qty[6], $qty[7], $qty[8], $qty[9], $qty[0]);

	return true;
// }
	}


	function check_item_sizes($item_number,$item_data,$mode='consi') {
	// за някои режими просто няма смисъл да се проверяват количествата ...
	    if (	$mode == 'return' or $mode == 'return_consi' or $mode == 'return_consi' or 
		$mode == 'invoice' or $mode == 'invoice_ki' or $mode == 'invoice_di' or $mode == 'invoice_pr' or
		$mode == 'scrap') { return true;}	

	    $item_id = $this->CI->Item->get_item_id($item_number);
	    $key_for_error = 0;
	    $allow_sizes = $this->CI->Item->get_info($item_id)->allow_sizes;

     if ( $allow_sizes == 1 ) {   // поверка на РАЗМЕРНИ АРТИКУЛИ ...

	$item_store = array(
		'quantity' => $this->CI->Item->get_info($item_id)->quantity,
		'qty_1'	   => $this->CI->Item->get_info($item_id)->qty_1,
		'qty_2'	   => $this->CI->Item->get_info($item_id)->qty_2,
		'qty_3'	   => $this->CI->Item->get_info($item_id)->qty_3,
		'qty_4'	   => $this->CI->Item->get_info($item_id)->qty_4,
		'qty_5'	   => $this->CI->Item->get_info($item_id)->qty_5,
		'qty_6'	   => $this->CI->Item->get_info($item_id)->qty_6,
		'qty_7'	   => $this->CI->Item->get_info($item_id)->qty_7,
		'qty_8'	   => $this->CI->Item->get_info($item_id)->qty_8,
		'qty_9'	   => $this->CI->Item->get_info($item_id)->qty_9,
		'qty_max'  => $this->CI->Item->get_info($item_id)->qty_max,
		);

	if ($item_store['quantity'] < $item_data['quantity']) 	{ $key_for_error = 1;}
	if ($item_store['qty_1'] < $item_data['qty_1'])     	{ $key_for_error = 1;}
	if ($item_store['qty_2'] < $item_data['qty_2'])     	{ $key_for_error = 1;}
	if ($item_store['qty_3'] < $item_data['qty_3'])     	{ $key_for_error = 1;}
	if ($item_store['qty_4'] < $item_data['qty_4'])     	{ $key_for_error = 1;}
	if ($item_store['qty_5'] < $item_data['qty_5'])     	{ $key_for_error = 1;}
	if ($item_store['qty_6'] < $item_data['qty_6'])     	{ $key_for_error = 1;}
	if ($item_store['qty_7'] < $item_data['qty_7'])     	{ $key_for_error = 1;}
	if ($item_store['qty_8'] < $item_data['qty_8'])     	{ $key_for_error = 1;}
	if ($item_store['qty_9'] < $item_data['qty_9'])     	{ $key_for_error = 1;}
	if ($item_store['qty_max'] < $item_data['qty_max']) 	{ $key_for_error = 1;}

	} else  {  // поверка само на БЕЗРАЗМЕРНИ ...
		  $qtty = $this->CI->Item->get_info($item_id)->quantity;
		  if( $qtty < $item_data['quantity']) { $key_for_error = 1;} 
		}

	if ($key_for_error == 1) {return false;}
	return true;
	}

// end of my stuff --------------------------------------------------------------------------




	function is_valid_receipt($receipt_sale_id)
	{
		//POS #
		$pieces = explode(' ',$receipt_sale_id);

		if(count($pieces)==2)
		{
			return $this->CI->Consi->exists($pieces[1]);
		}

		return false;
	}
	
	function is_valid_item_kit($item_kit_id)
	{
		//KIT #
		$pieces = explode(' ',$item_kit_id);

		if(count($pieces)==2)
		{
			return $this->CI->Item_kit->exists($pieces[1]);
		}

		return false;
	}

	function return_entire_consi($receipt_sale_id)
	{
		//POS #
		$pieces = explode(' ',$receipt_sale_id);
		$sale_id = $pieces[1];

		$this->empty_cart();
		$this->remove_consignee();

		foreach($this->CI->Consi->get_consi_items($sale_id)->result() as $row)
		{
			$this->add_item($row->item_id,-$row->quantity_purchased,$row->item_unit_price,$row->item_discount);
		}
		$this->set_consignee($this->CI->Consi->get_consignee($sale_id)->person_id);
	}
	
	function add_item_kit($external_item_kit_id)
	{
		//KIT #
		$pieces = explode(' ',$external_item_kit_id);
		$item_kit_id = $pieces[1];
		
		foreach ($this->CI->Item_kit_items->get_info($item_kit_id) as $item_kit_item)
		{
			$this->add_item($item_kit_item['item_id'], $item_kit_item['quantity']);
		}
	}

	function copy_entire_consi($sale_id)
	{
		$this->empty_cart();
		$this->remove_consignee();

		foreach($this->CI->Consi->get_consi_items($sale_id)->result() as $row)
		{
			$this->add_item(
					$row->item_number,
					$row->quantity_purchased,
					$row->item_unit_price,
					$row->item_discount,
					$row->doc_number,
					$row->doc_date,
					'',
					$row->mode,
					$row->qty_1, $row->qty_2, $row->qty_3, $row->qty_4, $row->qty_5,
					$row->qty_6, $row->qty_7, $row->qty_8, $row->qty_9, $row->qty_max
							);
		}
		foreach($this->CI->Consi->get_consi_payments($sale_id)->result() as $row)
		{
			$this->add_payment($row->payment_type,$row->payment_amount);
		}
		$this->set_consignee($this->CI->Consi->get_consignee($sale_id)->person_id);

	}
	
	function copy_entire_suspended_consi($sale_id)
	{
		$this->empty_cart();
		$this->remove_consignee();

		foreach($this->CI->Suspended->get_consi_items($sale_id)->result() as $row)
		{
			$this->add_item(
					$row->item_number,
					$row->quantity_purchased,
					$row->item_unit_price,
					$row->item_discount,
					$row->doc_number,
					$row->doc_date,
					'',
					$row->mode,
					$row->qty_1, $row->qty_2, $row->qty_3, $row->qty_4, $row->qty_5,
					$row->qty_6, $row->qty_7, $row->qty_8, $row->qty_9, $row->qty_max
							);
		}

		$this->set_consignee($this->CI->Suspended->get_consignee($sale_id)->person_id);
		$this->set_comment($this->CI->Suspended->get_comment($sale_id));
	}



//add_item( $item_id, $quantity=1, $price=0, $item_discount=0, 
//							$doc_number=0, $doc_date=0, $doc_name='Document', $doc_type='consi',
//			$qty_1=0, $qty_2=0, $qty_3=0, $qty_4=0, $qty_5=0,
	//		$qty_6=0, $qty_7=0, $qty_8=0, $qty_9=0, $qty_max=0)




	function delete_item($line)
	{
		$items=$this->get_cart();
		unset($items[$line]);
		$this->set_cart($items);
	}

	function empty_cart()
	{
		$this->CI->session->unset_userdata('cart');
	}

	function remove_consignee()
	{
		$this->CI->session->unset_userdata('consignee');
	}

	function clear_mode()
	{
		$this->CI->session->unset_userdata('consi_mode');
	}

	function clear_all()
	{
		$this->clear_mode();
		$this->empty_cart();
		$this->clear_comment();
		$this->clear_email_receipt();
		$this->empty_payments();
		$this->remove_consignee();
	}

	function get_consignee_discount()
	{
		$consignee_id = $this->get_consignee();
		$consignee = $this->CI->Consignee->get_info($consignee_id);

		$consignee_discount = $consignee->discount;

		if ($consignee_discount == 0 or $consignee_discount == '') 
				{ return 0;}

		return $consignee_discount;
	}



	function get_taxes()
	{
		$consignee_id = $this->get_consignee();
		$consignee = $this->CI->Consignee->get_info($consignee_id);

		//Do not charge consis tax if we have a consignee that is not taxable
		if (!$consignee->taxable and $consignee_id!=-1)
		{
		   return array();
		}

		$taxes = array();
		foreach($this->get_cart() as $line=>$item)
		{
			$tax_info = $this->CI->Item_taxes->get_info($item['item_id']);

			foreach($tax_info as $tax)
			{
				$name = $tax['percent'].'% ' . $tax['name'];
				$tax_amount=($item['price']*$item['quantity']-$item['price']*$item['quantity']*$item['item_discount']/100)*(($tax['percent'])/100);


				if (!isset($taxes[$name]))
				{
					$taxes[$name] = 0;
				}
				$taxes[$name] += $tax_amount;
			}
		}

		return $taxes;
	}

	function get_subtotal()
	{
		// вадим отстъпките -
		$consignee_discount = $this->get_consignee_discount();
		$subtotal = 0;

		foreach($this->get_cart() as $item)
		{
		    $subtotal += $item['price']*$item['quantity']*(100-$item['item_discount']-$consignee_discount)/100;
		}
		return to_currency_no_money($subtotal);
	}



	function get_total()
	{
		$total = 0;

		// вадим отстъпките -
		$consignee_discount = $this->get_consignee_discount();

		foreach($this->get_cart() as $item)
		{
            $total += $item['price']*$item['quantity']*(100-$item['item_discount']-$consignee_discount)/100;
		}

		// добавяме таксите +
		foreach($this->get_taxes() as $tax)
		{
			$total += $tax;
		}

		return to_currency_no_money($total);
	}


	function get_all_qty()
	{
		$all_qty = 0;
		foreach($this->get_cart() as $item)
			{ $all_qty += $item['quantity'];}

		return $all_qty;
	}


}
?>
