<?php
class Doc_lib
{
	var $CI;

  	function __construct()
	{
		$this->CI =& get_instance();
	}


	function get_cart()
	{
		if(!$this->CI->session->userdata('cart'))
			$this->set_cart(array());

	return $this->CI->session->userdata('cart');
	}


	function set_cart($cart_data)
	{
		$this->CI->session->set_userdata('cart',$cart_data);
	}


	// Multiple Payments
	function get_payments()
	{
		if( !$this->CI->session->userdata( 'payments' ) )
			$this->set_payments( array( ) );

		return $this->CI->session->userdata('payments');
	}


	function set_payments($payments_data)
	{
		$this->CI->session->set_userdata('payments',$payments_data);
	}

	
	// Comments
	function get_comment() 
	{
		return $this->CI->session->userdata('comment');
	}


	function set_comment($comment) 
	{
		$this->CI->session->set_userdata('comment', $comment);
	}

	function clear_comment() 	
	{
		$this->CI->session->unset_userdata('comment');
	}
	

	function get_email_receipt() 
	{
		return $this->CI->session->userdata('email_receipt');
	}


	function set_email_receipt($email_receipt) 
	{
		$this->CI->session->set_userdata('email_receipt', $email_receipt);
	}


	function clear_email_receipt() 	
	{
		$this->CI->session->unset_userdata('email_receipt');
	}

// -------- Multiple Payments ----------------------------------------

	function add_payment( $payment_id, $payment_amount )
	{
		$payments = $this->get_payments();
		$payment = array( $payment_id=>
		array(
			'payment_type' => $payment_id,
			'payment_amount' => $payment_amount
			)
		);

		//payment_method already exists, add to payment_amount
		if( isset( $payments[$payment_id] ) )
		{
			$payments[$payment_id]['payment_amount'] += $payment_amount;
		}
		else
		{
			//add to existing array
			$payments += $payment;
		}

		$this->set_payments( $payments );
	return true;
	}


	function edit_payment($payment_id,$payment_amount)
	{
		$payments = $this->get_payments();
		if(isset($payments[$payment_id]))
		{
			$payments[$payment_id]['payment_type'] = $payment_id;
			$payments[$payment_id]['payment_amount'] = $payment_amount;
			$this->set_payments($payment_id);
		}
	return false;
	}


	function delete_payment( $payment_id )
	{
		$payments = $this->get_payments();
		unset( $payments[urldecode( $payment_id )] );
		$this->set_payments( $payments );
	}


	function empty_payments()
	{
		$this->CI->session->unset_userdata('payments');
	}


	function get_payments_total()
	{
		$subtotal = 0;
		foreach($this->get_payments() as $payments)
		{
		    $subtotal += $payments['payment_amount'];
		}
	return to_currency_no_money($subtotal);
	}


	function get_amount_due($mode='sale',$taxed=0)
	{
		$customer_discount = $this->get_customer_discount();
		$amount_due		= 0;

		$payment_total = round($this->get_payments_total(),2);
		$sales_total	= round($this->get_total($mode,$customer_discount,$taxed),2);

		$amount_due = to_currency_no_money ( $sales_total - $payment_total );

		return $amount_due;
	}
// -------- end of Payments ----------------



	// ------------------------------------- DATE KEY---------------------------------- //
	function get_dateKey() 
	{
		if	(!$this->CI->session->userdata('date_key'))
			{ return false;}
	return true;
	}

	function set_dateKey() 
	{
		$this->CI->session->set_userdata('date_key', 1);
	}

	function clear_dateKey() 	
	{
		$this->CI->session->unset_userdata('date_key');
	}




	function get_customer()
	{
		if(!$this->CI->session->userdata('customer'))
			$this->set_customer(-1);

		return $this->CI->session->userdata('customer');
	}

	function set_customer($customer_id)
	{
		$this->CI->session->set_userdata('customer',$customer_id);
	}


// ------------------------------ Prices ----------------------------- //


	function get_mode_price()
	{
		if	(!$this->CI->session->userdata('mode_sale_price'))
			{ 
			$new_mode = 99; if($this->CI->config->item('vat')==1) { $new_mode = 100;}
			$this->set_mode_price($new_mode);
			}

	return $this->CI->session->userdata('mode_sale_price');
	}

	function set_mode_price($mode_price)
	{
		$this->CI->session->set_userdata('mode_sale_price',$mode_price);
	}


// ------------------------------ Type Payment ----------------------------- //


	function get_mode_payment()
	{
		if	(!$this->CI->session->userdata('mode_sale_payment'))
			{ $this->set_mode_payment($this->CI->lang->line('sales_cash'));}

	return $this->CI->session->userdata('mode_sale_payment');
	}

	function set_mode_payment($type_payment)
	{
		$this->CI->session->set_userdata('mode_sale_payment',$type_payment);
	}


// ------------------------------ Printons ----------------------------- //

	function get_mode_print()
	{
		if(!$this->CI->session->userdata('mode_sale_print'))
			$this->set_mode_print('prices');

		return $this->CI->session->userdata('mode_sale_print');
	}

	function set_mode_print($mode_print)
	{
		$this->CI->session->set_userdata('mode_sale_print',$mode_print);
	}


// -------------------------- modes ----------------------------------

	function get_mode()
	{
	$location = $this->CI->Employee->get_logged_in_employee_info()->location;
	$default_mode = 'sale';
	if( !$location == 0) { $default_mode = 'shop_sale';}

		if(!$this->CI->session->userdata('sale_mode'))
			$this->set_mode($default_mode);

	return $this->CI->session->userdata('sale_mode');
	}


	function set_mode($mode)
	{
		$this->CI->session->set_userdata('sale_mode', $mode);
	}







	function add_item( $item_id, $quantity=1, $price=0, $item_discount=0, 
			$qty_1=0, $qty_2=0, $qty_3=0, $qty_4=0, $qty_5=0,
			$qty_6=0, $qty_7=0, $qty_8=0, $qty_9=0, $qty_max=0)
	{
		//make sure item exists
	/*	if(!$this->CI->Item->exists($item_id))
		{
			//try to get item id given an item_number
			$item_id = $this->CI->Item->get_item_id($item_id);

			if(!$item_id)
				return false;
		} */



			//try to get item id given an item_number
			$item_id = $this->CI->Item->get_item_id($item_id);
			if(!$item_id) { return false; }

		//Alain Serialization and Description

		//Get all items in the cart so far...
		$items = $this->get_cart();

        //We need to loop through all items in the cart.
        //If the item is already there, get it's key($updatekey).
        //We also need to get the next key that we are going to use in case we need to add the
        //item to the cart. Since items can be deleted, we can't use a count. we use the highest key + 1.

        	$maxkey=0;                       //Highest key so far
        	$itemalreadyinsale=FALSE;        //We did not find the item yet.
		$insertkey=0;                    //Key to use for new entry.
		$updatekey=0;                    //Key to use to update(quantity)


		foreach ($items as $item)
		{
            //We primed the loop so maxkey is 0 the first time.
            //Also, we have stored the key in the element itself so we can compare.

			if($maxkey <= $item['line'])
			{
				$maxkey = $item['line'];
			}

			if($item['item_id']==$item_id)
			{
				$itemalreadyinsale=TRUE;
				$updatekey=$item['line'];
			}
		}

		$insertkey=$maxkey+1;

		// обслужвам си цената ...
		$mode_price = $this->get_mode_price();

		$item_unit_price = $this->CI->Item->get_info($item_id)->unit_price;
		if ($mode_price==1) {$this->CI->Item->get_info($item_id)->unit_price;}
		if ($mode_price==2) {$this->CI->Item->get_info($item_id)->unit_price_2;}
		if ($mode_price==3) {$this->CI->Item->get_info($item_id)->unit_price_3;}
		if ($mode_price==4) {$this->CI->Item->get_info($item_id)->unit_price_4;}
		if ($mode_price==5) {$this->CI->Item->get_info($item_id)->unit_price_5;}

		//array/cart records are identified by $insertkey and item_id is just another field.
		$item = array(($insertkey)=>
		array(
			'item_id'=>$item_id,
			'line'=>$insertkey,
			'name'=>$this->CI->Item->get_info($item_id)->name,
			'item_number'=>$this->CI->Item->get_info($item_id)->item_number,
			'item_size_group'=>$this->CI->Item->get_info($item_id)->item_size_group,
			'allow_sizes'=>$this->CI->Item->get_info($item_id)->allow_sizes,

			'qty_1'=>$qty_1,
			'qty_2'=>$qty_2,
			'qty_3'=>$qty_3,
			'qty_4'=>$qty_4,
			'qty_5'=>$qty_5,
			'qty_6'=>$qty_6,
			'qty_7'=>$qty_7,
			'qty_8'=>$qty_8,
			'qty_9'=>$qty_9,
			'qty_max'=>$qty_max,

			'quantity'=>$quantity,
         'item_discount'=>$item_discount,
			'price'=>$price!=null ? $price: $item_unit_price )
		);


		// тук една проверчица за размери пак да видим какво аджиба става в количката
		$error_key = 0;

		$allow_sizes = $this->CI->Item->get_info($item_id)->allow_sizes;
		$sum_qtys = $qty_1 + $qty_2 + $qty_3 + $qty_4 + $qty_5 + 
			    $qty_6 + $qty_7 + $qty_8 + $qty_9 + $qty_max;
 

		if ( $allow_sizes == 1 ) 
		{ 
				$item_test_data = array(
						'quantity' 		=> $quantity,
							'qty_1'	   => $qty_1,
							'qty_2'	   => $qty_2,
							'qty_3'	   => $qty_3,
							'qty_4'	   => $qty_4,
							'qty_5'	   => $qty_5,
							'qty_6'	   => $qty_6,
							'qty_7'	   => $qty_7,
							'qty_8'	   => $qty_8,
							'qty_9'	   => $qty_9,
							'qty_max'  => $qty_max);

		// $mode = $this->get_mode();
		// if (!$this->check_item_sizes($item_number,$item_test_data,$mode)) {return false;}

			if ( $sum_qtys == 0 ) // това е грешно има размери а не ги иска ?!?
				{ $error_key = 'S'; }  
		} 

		//Item already exists
		if($itemalreadyinsale)
		{
			if ( $allow_sizes == 0 )
			{ $items[$updatekey]['quantity']+=$quantity; } // добавя безразмерни кол-ва.
			else 
			{  // добавя размерни кол-ва.
			  $items[$updatekey]['qty_1']+=$qty_1;
			  $items[$updatekey]['qty_2']+=$qty_2;
			  $items[$updatekey]['qty_3']+=$qty_3;
			  $items[$updatekey]['qty_4']+=$qty_4;
			  $items[$updatekey]['qty_5']+=$qty_5;
			  $items[$updatekey]['qty_6']+=$qty_6;
			  $items[$updatekey]['qty_7']+=$qty_7;
			  $items[$updatekey]['qty_8']+=$qty_8;
			  $items[$updatekey]['qty_9']+=$qty_9;
			  $items[$updatekey]['qty_max']+=$qty_max;
			  $items[$updatekey]['quantity']+=$quantity;
			}  // добавя размерни кол-ва.
		}
		else //add to existing array
		{ $items+=$item; }

		$this->set_cart($items);

		if ($error_key == 'S') { return $error_key; }

	return 'OK';
	}


	function is_valid_invoice_item_number($barcode_item,$mode='invoice') 
	{

	   if (!is_numeric($barcode_item)) { return false; }
	   if ($mode!='invoice' and $mode!='invoice_ki' and $mode!='invoice_di' and $mode!='invoice_pr') { return false;}

	   $lenBarcode = strlen($barcode_item);
	   if ($lenBarcode > 0 and $lenBarcode < 3 ) { return true; }
	
	return false;
	}



	// само за Invoices
	function add_invoice_item( $item_number, $quantity, $price, $item_discount)
	{

			$item_id = $this->CI->Item->get_item_id_invoice($item_number);

			if(!$item_id) { return false; }


		//Get all items in the cart so far...
		$items = $this->get_cart();

        	$maxkey=0;                       //Highest key so far
        	$itemalreadyinsale=FALSE;        //We did not find the item yet.
		$insertkey=0;                    //Key to use for new entry.
		$updatekey=0;                    //Key to use to update(quantity)

		foreach ($items as $item)
		{
            //We primed the loop so maxkey is 0 the first time.
            //Also, we have stored the key in the element itself so we can compare.

			if($maxkey <= $item['line'])
			{
				$maxkey = $item['line'];
			}

			if($item['item_id']==$item_id)
			{
				$itemalreadyinsale=TRUE;
				$updatekey=$item['line'];
			}
		}

		$insertkey=$maxkey+1;

		//array/cart records are identified by $insertkey and item_id is just another field.
		$item = array(($insertkey)=>
		array(
			'item_id'=>$item_id,
			'line'=>$insertkey,
			'name'=>$this->CI->Item->get_info_invoice($item_id)->name,
			'item_number'=>$this->CI->Item->get_info_invoice($item_id)->item_number,

			'quantity'=>$quantity,
         'item_discount'=>$item_discount,
			'allow_sizes'=>0,
			'price'=>$price!=null ? $price: $this->CI->Item->get_info_invoice($item_id)->unit_price
			)
		);

		//Item already exists
		if($itemalreadyinsale)
		{
			$items[$updatekey]['quantity']+=$quantity; // добавя безразмерни кол-ва.
		}
		else //add to existing array
		{ $items+=$item; }

		$this->set_cart($items);

	return true;
	}



	
	function out_of_stock($item_id)
	{
		//make sure item exists
/*		if(!$this->CI->Item->exists($item_id))
		{
			//try to get item id given an item_number
			$item_id = $this->CI->Item->get_item_id($item_id);

			if(!$item_id)
				return false;
		}
*/		
		//try to get item id given an item_number
		$item_id = $this->CI->Item->get_item_id($item_id);

			if(!$item_id) { return false;}


		$item = $this->CI->Item->get_info($item_id);
		$quanity_added = $this->get_quantity_already_added($item_id);
		
		if ($item->quantity - $quanity_added < 0)
		{
			return true;
		}
		return false;
	}
	
	function get_quantity_already_added($item_id)
	{
		$items = $this->get_cart();
		$quanity_already_added = 0;
		foreach ($items as $item)
		{
			if($item['item_id']==$item_id)
			{
				$quanity_already_added+=$item['quantity'];
			}
		}
		return $quanity_already_added;
	}

	
	function get_item_id($line_to_get)
	{
		$items = $this->get_cart();

		foreach ($items as $line=>$item)
		{
			if($line==$line_to_get)
			{
				return $item['item_id'];
			}
		}
		return -1;
	}



	function edit_item( $line, $item_name, $quantity, $item_discount, $price,
			$qty_1,$qty_2,$qty_3,$qty_4,$qty_5,$qty_6,$qty_7,$qty_8,$qty_9,$qty_max)
	{
		$items = $this->get_cart();
		if(isset($items[$line]))
		{
			if(!$item_name=='') { $items[$line]['name'] = $item_name;}
			
			$items[$line]['quantity'] 		= $quantity;
			$items[$line]['item_discount']= $item_discount;
			$items[$line]['price'] 			= $price;

			$items[$line]['qty_1'] 		= $qty_1;
			$items[$line]['qty_2'] 		= $qty_2;
			$items[$line]['qty_3'] 		= $qty_3;
			$items[$line]['qty_4'] 		= $qty_4;
			$items[$line]['qty_5'] 		= $qty_5;
			$items[$line]['qty_6'] 		= $qty_6;
			$items[$line]['qty_7'] 		= $qty_7;
			$items[$line]['qty_8'] 		= $qty_8;
			$items[$line]['qty_9'] 		= $qty_9;
			$items[$line]['qty_max'] 	= $qty_max;

			$this->set_cart($items);
		}
	return false;
	}



// my stuff  ------------------------------- BarCode  ------------------------------------- //
	
	function is_valid_item_number($barcode_item,$mode='sale') 
	{
	if ($mode=='invoice' or $mode=='invoice_ki' or $mode=='invoice_di' or $mode=='invoice_pr') { return false;}
	   if (!is_numeric($barcode_item)) { return false; }

	   $lenBarcode = strlen($barcode_item);
	   if ($lenBarcode <  4 or $lenBarcode > 7 ) { return false; }
	
	return true;
	}


	function is_valid_barcode($barcode_item,$mode='sale')
	{ //barCode validation
	if ($mode=='invoice' or $mode=='invoice_ki' or $mode=='invoice_di' or $mode=='invoice_pr') { return false;}
	$lenBarcode = strlen($barcode_item);
		if ($lenBarcode <  8) { return false; }
		if ($lenBarcode >  8 and $lenBarcode < 12) { return false; }
		if ($lenBarcode > 13) { return false; }
		if (is_numeric(!$barcode_item)) { return false; }
	return true;
	}



	function add_item_barcode($barcode_item,$quantity=1)
	{  //barCode #
		$lenBarcode = strlen($barcode_item);
		$item_number = 0;
		$barcode = substr($barcode_item,0,-1);

		$qty = array();
			 $qty[1] = 0; $qty[2] = 0; $qty[3] = 0; $qty[4] = 0; $qty[5] = 0;
			 $qty[6] = 0; $qty[7] = 0; $qty[8] = 0; $qty[9] = 0; $qty[0] = 0;

		// EAN-8 Code table - checks 5-7 digit item numbers
		if ($lenBarcode == 8 ) { $item_number = (int) $barcode;}

		// EAN-13 Code table
		if ($lenBarcode == 13 ) 
		{
		// checks 380 = Bulgaria Code table
		   $barcode_380 = substr($barcode_item,0,3);
		   if ($barcode_380 == '380') { $item_number = (int) substr($barcode_item,-6,-1); }
		   else { // else 380
			// Normal 13 bit code
			$barcode = substr($barcode_item,1,-1);
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 10) { $qty[$size_qty] = $quantity;}
			elseif ($size_qty == 10) { $qty[0] = $quantity; }
			else 
				{ 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[0] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
				}
			} // end of else 380
		}

		// BiSOFT internal Code table 12 (-leading 0)
		if ($lenBarcode == 12 ) 
		{
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 10) { $qty[$size_qty] = $quantity;}
			elseif ($size_qty == 10) { $qty[0] = $quantity; }
			else { 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[0] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
			     }
		}

		$mode = $this->get_mode();
		$item_test_data = array('quantity' => $quantity,
					'qty_1'	   => $qty[1],
					'qty_2'	   => $qty[2],
					'qty_3'	   => $qty[3],
					'qty_4'	   => $qty[4],
					'qty_5'	   => $qty[5],
					'qty_6'	   => $qty[6],
					'qty_7'	   => $qty[7],
					'qty_8'	   => $qty[8],
					'qty_9'	   => $qty[9],
					'qty_max'  => $qty[0]);

//	if (!$this->check_item_sizes($item_number,$item_test_data,$mode)) {return false;}
	
//	else { // когато всичко е ОК !!!
	$this->add_item($item_number, $quantity, 0, 0,
		$qty[1], $qty[2], $qty[3], $qty[4], $qty[5],
		$qty[6], $qty[7], $qty[8], $qty[9], $qty[0]);

	return true;
	}


	function check_item_sizes($item_number,$item_data,$mode='sale') 
	{
	// за някои режими няма смисъл да се проверяват количествата ...
	    if (	$mode == 'sale_return' or $mode == 'shop_return' or $mode == 'consi_return' or 
		$mode == 'invoice' or $mode == 'invoice_ki' or $mode == 'invoice_di' or $mode == 'invoice_pr' or
		$mode == 'brak' or $mode == 'balance') { return true;}	

	    $item_id = $this->CI->Item->get_item_id($item_number);
	    $key_for_error = 0;
	    $allow_sizes = $this->CI->Item->get_info($item_id)->allow_sizes;

     if ( $allow_sizes == 1 ) {   // поверка на РАЗМЕРНИ АРТИКУЛИ ...

	$item_store = array(
		'quantity' => $this->CI->Item->get_info($item_id)->quantity,
		'qty_1'	   => $this->CI->Item->get_info($item_id)->qty_1,
		'qty_2'	   => $this->CI->Item->get_info($item_id)->qty_2,
		'qty_3'	   => $this->CI->Item->get_info($item_id)->qty_3,
		'qty_4'	   => $this->CI->Item->get_info($item_id)->qty_4,
		'qty_5'	   => $this->CI->Item->get_info($item_id)->qty_5,
		'qty_6'	   => $this->CI->Item->get_info($item_id)->qty_6,
		'qty_7'	   => $this->CI->Item->get_info($item_id)->qty_7,
		'qty_8'	   => $this->CI->Item->get_info($item_id)->qty_8,
		'qty_9'	   => $this->CI->Item->get_info($item_id)->qty_9,
		'qty_max'  => $this->CI->Item->get_info($item_id)->qty_max,
		);

	if ($item_store['quantity'] < $item_data['quantity']) 	{ $key_for_error = 1;}
	if ($item_store['qty_1'] < $item_data['qty_1'])     	{ $key_for_error = 1;}
	if ($item_store['qty_2'] < $item_data['qty_2'])     	{ $key_for_error = 1;}
	if ($item_store['qty_3'] < $item_data['qty_3'])     	{ $key_for_error = 1;}
	if ($item_store['qty_4'] < $item_data['qty_4'])     	{ $key_for_error = 1;}
	if ($item_store['qty_5'] < $item_data['qty_5'])     	{ $key_for_error = 1;}
	if ($item_store['qty_6'] < $item_data['qty_6'])     	{ $key_for_error = 1;}
	if ($item_store['qty_7'] < $item_data['qty_7'])     	{ $key_for_error = 1;}
	if ($item_store['qty_8'] < $item_data['qty_8'])     	{ $key_for_error = 1;}
	if ($item_store['qty_9'] < $item_data['qty_9'])     	{ $key_for_error = 1;}
	if ($item_store['qty_max'] < $item_data['qty_max']) 	{ $key_for_error = 1;}

	} else  {  // поверка само на БЕЗРАЗМЕРНИ ...
		  $qtty = $this->CI->Item->get_info($item_id)->quantity;
		  if( $qtty < $item_data['quantity']) { $key_for_error = 1;} 
		}

	if ($key_for_error == 1) {return false;}
	return true;
	}

// end of my stuff --------------------------------------------------------------------------




	function is_valid_receipt($receipt_doc_id)
	{
		//POS #
		$pieces = explode(' ',$receipt_doc_id);

		if(count($pieces)==2)
		{
			return $this->CI->Docedit->exists($pieces[1]);
		}

		return false;
	}
	
	function is_valid_item_kit($item_kit_id)
	{
		//KIT #
		$pieces = explode(' ',$item_kit_id);

		if(count($pieces)==2)
		{
			return $this->CI->Item_kit->exists($pieces[1]);
		}

		return false;
	}

	function return_entire_sale($receipt_doc_id,$vedomPack)
	{
		//POS #
		$pieces = explode(' ',$receipt_doc_id);
		$doc_id = $pieces[1];

		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Docedit->get_sale_items($doc_id,$vedomPack)->result() as $row)
		{
			$this->add_item($row->item_id,-$row->item_qty,$row->item_unit_price,$row->item_discount);
		}
		$this->set_customer($this->CI->Docedit->get_customer($doc_id,$vedomPack)->person_id);
	}
	
	function add_item_kit($external_item_kit_id)
	{
		//KIT #
		$pieces = explode(' ',$external_item_kit_id);
		$item_kit_id = $pieces[1];
		
		foreach ($this->CI->Item_kit_items->get_info($item_kit_id) as $item_kit_item)
		{
			$this->add_item($item_kit_item['item_id'], $item_kit_item['quantity']);
		}
	}




	function copy_entire_document($doc_number,$vedomPack)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Docedit->get_doc_items($doc_number,$vedomPack)->result() as $row)
		{
			$this->add_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount,
					$row->qty_1, $row->qty_2, $row->qty_3, $row->qty_4, $row->qty_5,
					$row->qty_6, $row->qty_7, $row->qty_8, $row->qty_9, $row->qty_max );
		}

		foreach($this->CI->Docedit->get_doc_payments($doc_number,$vedomPack)->result() as $row)
		{
			$this->add_payment($row->pay_type,$row->pay_amount);
		}

	$this->set_customer($this->CI->Docedit->get_customer($doc_number,$vedomPack)->person_id);
	}



















// ---- other 

	function copy_entire_sale($doc_id,$vedomPack)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Docedit->get_sale_items($doc_id,$vedomPack)->result() as $row)
		{
			$this->add_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount,
					$row->qty_1, $row->qty_2, $row->qty_3, $row->qty_4, $row->qty_5,
					$row->qty_6, $row->qty_7, $row->qty_8, $row->qty_9, $row->qty_max
							);
		}

		foreach($this->CI->Docedit->get_sale_payments($doc_id,$vedomPack)->result() as $row)
		{
			$this->add_payment($row->pay_type,$row->pay_amount);
		}

	$this->set_customer($this->CI->Docedit->get_customer($doc_id,$vedomPack)->person_id);
	}
	

	function copy_entire_invoice($doc_number,$vedomPack)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Docedit->get_invoice_items($doc_number,$vedomPack)->result() as $row)
		{
			$this->add_invoice_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount
							);
		}

		foreach($this->CI->Docedit->get_invoice_payments($doc_number,$vedomPack)->result() as $row)
		{
			$this->add_payment($row->pay_type,$row->pay_amount);
		}

//	$this->set_customer($this->CI->Docedit->get_customer($doc_id,$vedomPack)->person_id);
	}



	function copy_entire_suspended_sale($doc_id,$vedomPack)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Suspended->get_sale_items($doc_id,$vedomPack)->result() as $row)
		{
			$this->add_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount,
					$row->qty_1, $row->qty_2, $row->qty_3, $row->qty_4, $row->qty_5,
					$row->qty_6, $row->qty_7, $row->qty_8, $row->qty_9, $row->qty_max	);
		}

			$customer_id = 0;
			$bisoft_id = $this->CI->Suspended->get_customer($doc_id,$vedomPack);

				if ($bisoft_id != 0)  // когато не е бил избран КЛИЕНТ 
				{
					$customer_id = $this->CI->Customer->get_info_by_bisoft_id($bisoft_id)->person_id;
					$this->set_customer($customer_id);
				}

			$mode = $this->CI->Suspended->get_mode($doc_id);
		$this->set_mode($mode);
		$this->set_comment($this->CI->Suspended->get_comment($doc_id));
	}





	function delete_item($line)
	{
		$items=$this->get_cart();
		unset($items[$line]);
		$this->set_cart($items);
	}

	function empty_cart()
	{
		$this->CI->session->unset_userdata('cart');
	}

	function remove_customer()
	{
		$this->CI->session->unset_userdata('customer');
	}

	function clear_mode_price()
	{
		$this->CI->session->unset_userdata('mode_sale_price');
	}

	function clear_mode_print()
	{
		$this->CI->session->unset_userdata('mode_sale_print');
	}

	function clear_mode()
	{
		$this->CI->session->unset_userdata('sale_mode');
	}

	function clear_all()
	{
		$this->clear_mode();
		$this->clear_dateKey();
		$this->empty_cart();
		$this->clear_comment();
		$this->clear_email_receipt();
		$this->empty_payments();
		$this->clear_mode_price();
		$this->clear_mode_print();
		$this->remove_customer();
	}

	function get_customer_discount()
	{
		$customer_id = $this->get_customer();
		$customer_discount = $this->CI->Customer->get_info($customer_id)->discount;
		if ($customer_discount == '') { return 0;}

	return $customer_discount;
	}



	function get_taxes()
	{
		$customer_id = $this->get_customer();
		$customer = $this->CI->Customer->get_info($customer_id);

		//Do not charge sales tax if we have a customer that is not taxable
		if (!$customer->taxable and $customer_id!=-1)
		{
		   return array();
		}

		$taxes = array();
		foreach($this->get_cart() as $line=>$item)
		{
			$tax_info = $this->CI->Item_taxes->get_info($item['item_id']);

			foreach($tax_info as $tax)
			{
				$name = $tax['percent'].'% ' . $tax['name'];
				$tax_amount=round(($item['price']*$item['quantity']-$item['price']*$item['quantity']*$item['item_discount']/100)*(($tax['percent'])/100),4);


				if (!isset($taxes[$name]))
				{
					$taxes[$name] = 0;
				}
				$taxes[$name] += $tax_amount;
			}
		}

	return $taxes;
	}


	function get_subtotal()
	{
		$mode_price = $this->get_mode_price();
		$subtotal = 0;
		foreach($this->get_cart() as $item)
		{
		$cur_item_info = $this->CI->Item->get_info($item['item_id']);
			$item_price = $item['price'];
			if ($mode_price==1) { $item_price = $cur_item_info->unit_price;}
			if ($mode_price==2) { $item_price = $cur_item_info->unit_price_2;}
			if ($mode_price==3) { $item_price = $cur_item_info->unit_price_3;}
			if ($mode_price==4) { $item_price = $cur_item_info->unit_price_4;}
			if ($mode_price==5) { $item_price = $cur_item_info->unit_price_5;}

			$subtotal += $item['quantity'] * round( $item_price*(100-$item['item_discount'])/100, 4);
		}
	return $subtotal;
	}


	function get_tax_VAT($mode='invoice', $taxed=1)
	{
		$subtotal = $this->get_subtotal();

		// добавяме ДДС-то ....
		$tax_VAT	= 0;

		if ( $mode == 'invoice' or $mode == 'invoice_ki' or $mode == 'invoice_di' or $mode == 'invoice_pr')
			{ $tax_VAT = round( 20 * $subtotal / 100, 4);}

		if ( $taxed == 0 ) { $tax_VAT	= 0;}

	return $tax_VAT;
	}



	function get_total($mode='sale',$customer_discount=0,$taxed)
	{
		$subtotal = $this->get_subtotal();

		// вадим отстъпките -
		// $customer_discount = $this->get_customer_discount();
	if ($mode=='invoice' or $mode=='invoice_ki' or $mode=='invoice_di' or $mode=='invoice_pr') 
		  { $total = $subtotal;}	
	else { $total = round( $subtotal * ( 100 - $customer_discount ) / 100, 4);}

		// добавяме таксите +
		foreach($this->get_taxes() as $tax)
			{ $total += $tax;}

		// добавяме ДДС-то +
		$total += $this->get_tax_VAT($mode,$taxed);

	return $total;
	}


	function get_all_qty()
	{
		$all_qty = 0;
		foreach($this->get_cart() as $item)
			{ $all_qty += $item['quantity'];}
	return $all_qty;
	}


}
?>
