<?php

class Recv_lib
{
	var $CI;
  	function __construct()
	{ $this->CI =& get_instance();}


// -------------------------- MODES ---------------------------------- //
	function get_mode()
	{
	$location = $this->CI->Employee->get_logged_in_employee_info()->location;
	$default_mode = 'manu';
	if( !$location == 0) { $default_mode = 'shop_sgp';}

		if(!$this->CI->session->userdata('recv_mode'))
			{	
				$this->set_mode($default_mode);
				$this->remove_supplier();
				$this->remove_consignee();
			}
	return $this->CI->session->userdata('recv_mode');
	}

	function set_mode($mode)
	{ $this->CI->session->set_userdata('recv_mode',$mode);}

	function clear_mode()
	{ $this->CI->session->unset_userdata('recv_mode');}
	
	
	// Cart
	function get_cart()
	{
		$mode = $this->get_mode();
		return $this->CI->BiSOFT_Model->zebex_get_all($mode,0,0);
	}
	
	function get_cart_page($limit=20,$offset=0)
	{
		$mode = $this->get_mode();
		return $this->CI->BiSOFT_Model->zebex_get_all($mode,$limit,$offset);
	}

	function set_cart($cart_data)
	{
		$mode = $this->get_mode();
		if($cart_data)
			{ return $this->CI->BiSOFT_Model->zebex_save($cart_data,$mode);}
		else
			{ return false;}
	}

	function empty_cart()
	{
		$mode = $this->get_mode();
		return $this->CI->BiSOFT_Model->zebex_clear_all($mode);		
	}
	
	
// -------------------------- LINES ---------------------------------- //
	function get_line()
	{
		if(!$this->CI->session->userdata('recv_line'))
			$this->set_line(1);
	return $this->CI->session->userdata('recv_line');
	}

	function set_line($line)
	{ $this->CI->session->set_userdata('recv_line', $line);}

	function clear_line()
	{ $this->CI->session->unset_userdata('recv_line');}	
	
	
// -------------------------- KITS ---------------------------------- //
	function get_kit()
	{
		if(!$this->CI->session->userdata('recv_kit'))
			{ $this->set_kit("0"); }
	return $this->CI->session->userdata('recv_kit');
	}

	function set_kit($kit)
	{ $this->CI->session->set_userdata('recv_kit', $kit); }
	

	function clear_kit()
	{ $this->CI->session->unset_userdata('recv_kit'); }		
	
	function get_kit_mode()
	{
		if(!$this->CI->session->userdata('recv_kit_mode'))
			{ $this->set_kit_mode(1); }
	return $this->CI->session->userdata('recv_kit_mode');
	}

	function set_kit_mode($kit_mode)
	{ $this->CI->session->set_userdata('recv_kit_mode', (int)$kit_mode); }

	function clear_kit_mode()
	{ $this->CI->session->unset_userdata('recv_kit_mode'); }	
	
	
	// -------  Payments ---------- //
	function get_payments()
	{
		if( !$this->CI->session->userdata( 'recv_pays' ) )
			$this->set_payments( array( ) );

		return $this->CI->session->userdata('recv_pays');
	}


	function set_payments($payments_data)
	{
		$this->CI->session->set_userdata('recv_pays',$payments_data);
	}
	

	function empty_payments()
	{
		$this->CI->session->unset_userdata('recv_pays');
	}
	
	
	function get_comment() 
	{
		return $this->CI->session->userdata('recv_comment');
	}

	function set_comment($comment) 
	{
		$this->CI->session->set_userdata('recv_comment', $comment);
	}

	function clear_comment() 	
	{
		$this->CI->session->unset_userdata('recv_comment');
	}
	
	function get_email_receipt() 
	{
		return $this->CI->session->userdata('recv_email_receipt');
	}

	function set_email_receipt($email_receipt) 
	{
		$this->CI->session->set_userdata('recv_email_receipt', $email_receipt);
	}

	function clear_email_receipt() 	
	{
		$this->CI->session->unset_userdata('recv_email_receipt');
	}

	function add_payment( $payment_id, $payment_amount )
	{
		$payments = $this->get_payments();
		$payment = array( $payment_id=>
		array(
			'payment_type' => $payment_id,
			'payment_amount' => $payment_amount
			)
		);

		//payment_method already exists, add to payment_amount
		if( isset( $payments[$payment_id] ) )
		{
			$payments[$payment_id]['payment_amount'] += $payment_amount;
		}
		else
		{  //add to existing array
			$payments += $payment;
		}

		$this->set_payments( $payments );
		return true;

	}

	//Alain Multiple Payments
	function edit_payment($payment_id,$payment_amount)
	{
		$payments = $this->get_payments();
		if(isset($payments[$payment_id]))
		{
			$payments[$payment_id]['payment_type'] = $payment_id;
			$payments[$payment_id]['payment_amount'] = $payment_amount;
			$this->set_payments($payment_id);
		}

		return false;
	}

	//Alain Multiple Payments
	function delete_payment( $payment_id )
	{
		$payments = $this->get_payments();
		unset( $payments[urldecode( $payment_id )] );
		$this->set_payments( $payments );
	}



	//Alain Multiple Payments
	function get_payments_total()
	{
		$subtotal = 0;
		foreach($this->get_payments() as $payments)
			{ $subtotal += $payments['payment_amount'];}
	return to_currency_no_money($subtotal);
	}

	//Alain Multiple Payments
	function get_amount_due($mode='recv_mode')
	{
		$supplier_discount = $this->get_supplier_discount();
		$amount_due		= 0;
		$payment_total = $this->get_payments_total();
		$recvs_total	= $this->get_total($mode,$supplier_discount);
		$amount_due = to_currency_no_money ( $recvs_total - $payment_total );

	return $amount_due;
	}



	// ------------------------------------- DATE KEY---------------------------------- //
	function get_dateKey() 
	{
		if	(!$this->CI->session->userdata('recv_date_key'))
			{ return 0;}
	return 1;
	}

	function set_dateKey() 
	{ $this->CI->session->set_userdata('recv_date_key', 1); }

	function clear_dateKey() 	
	{ $this->CI->session->unset_userdata('recv_date_key'); }



	// -------------------------- SUPPLIER ---------------------- //
	function get_supplier()
	{
		if(!$this->CI->session->userdata('recv_supplier'))
			$this->set_supplier(-1);

	return $this->CI->session->userdata('recv_supplier');
	}

	function set_supplier($supplier_id)
	{
		if ($supplier_id > 0) { $this->CI->BiSOFT_Model->set_user_client($supplier_id);}
		$this->CI->session->set_userdata('recv_supplier',$supplier_id);
	}

	function remove_supplier()
	{
		$this->CI->session->unset_userdata('recv_supplier');
		$this->CI->BiSOFT_Model->set_user_client(0);
	}


	// -------------------------- CONSIGNEE ---------------------- //
	function get_consignee()
	{
		if(!$this->CI->session->userdata('recv_consignee'))
			$this->set_consignee(-1);
	return $this->CI->session->userdata('recv_consignee');
	}

	function set_consignee($consignee_id)
	{
		if ($consignee_id > 0) { $this->CI->BiSOFT_Model->set_user_client($consignee_id);}
		$this->CI->session->set_userdata('recv_consignee',$consignee_id);
	}

	function remove_consignee()
	{
		$this->CI->session->unset_userdata('recv_consignee');
		$this->CI->BiSOFT_Model->set_user_client(0);
	}



// ------------------------------ Prices ----------------------------- //

	function get_mode_price()
	{
		if(!$this->CI->session->userdata('recv_price'))
			{$this->set_mode_price(99);}

		return $this->CI->session->userdata('recv_price');
	}

	function set_mode_price($mode_price)
	{ $this->CI->session->set_userdata('recv_price',$mode_price);}
	
	function clear_mode_price()
	{ $this->CI->session->unset_userdata('recv_price');}
	


// ------------------------------ Printons ----------------------------- //

	function get_mode_print()
	{
		if(!$this->CI->session->userdata('recv_prn'))
			$this->set_mode_print('sizes_prices');

		return $this->CI->session->userdata('recv_prn');
	}

	function set_mode_print($mode_print)
	{
		$this->CI->session->set_userdata('recv_prn',$mode_print);
	}
	
	function clear_mode_print()
	{ $this->CI->session->unset_userdata('recv_prn');}


	function clear_all()
	{
		$this->empty_cart();
		$this->remove_supplier();
		$this->remove_consignee();
		$this->clear_mode_price();
		$this->clear_mode_print();
		$this->clear_line();
		$this->clear_kit();
		$this->clear_kit_mode();
		$this->clear_dateKey();
		$this->clear_comment();
		$this->clear_email_receipt();
		$this->empty_payments();
		$this->clear_mode();
	}
	
	


	function add_item( $inum, $quantity=1, $price=0, $discount=0, $Qty=array() )
	{
		$success = 1;
		$user_id   = $this->CI->BiSOFT_Model->get_person();
      $error_key = $allow_sizes = $item_price = 0; 
      $name=''; $sizes = array();
		$location = $this->CI->BiSOFT_Model->get_location();
		$kit_mode = $this->get_kit_mode();
		$mode = $this->get_mode();
		$qty_col = 1;
		$skl = 0;
		
		$item_info = $this->CI->Item->get_blanka_info($inum);
		if($item_info)
		{
         $sizes = $this->CI->Item->get_sizes($inum);
			$allow_sizes = $item_info->allow_sizes;
			$name = $item_info->name;
      }
      
      if( $mode=='macka' and $inum < 98100 ) { return false;}
			
		if(!count($Qty)) {$Qty[1]=$Qty[2]=$Qty[3]=$Qty[4]=$Qty[5]=$Qty[6]=$Qty[7]=$Qty[8]=$Qty[9]=$Qty[10]=0;}
		  
//		$commision_key = $comis_price = 0;
		$mode_price = $this->get_mode_price();
		
		if($mode=='revision')
		{
         $skl = $this->CI->BiSOFT_Model->get_user_mode_client();
         $skl_info = $this->CI->Item->get_sklad_info($inum,$skl);
         $item_price = '99999';
         if($skl_info) { $item_price = (float)$skl_info->price; }
         $qty_col = $quantity;
		}
		elseif($mode=='kit')
		{
			$skl = 0;
			$qty_col = $quantity;
		}
		elseif($mode=='consi')
		{
			
			$skl = 0;
			$skl_info = $this->CI->Item->get_sklad_info($inum,$skl);
			if($skl_info)
			{
            if($mode_price!=2)
            {
               switch ($mode_price) 
               {
						case '1': $item_price = (float)$skl_info->price;   break;
                  case '2': $item_price = (float)$skl_info->price_2; break;
                  case '3': $item_price = (float)$skl_info->price_3; break;
                  case '4': $item_price = (float)$skl_info->price_4; break;
                  case '5': $item_price = (float)$skl_info->price_5; break;
                  default:  $item_price = isset($skl_info->price) ? (float)$skl_info->price : 0;
               }
            }
            else // Нова корекция 3 вместо 2-ра цена
            {  $item_price=(float)$skl_info->price_2;
               if($skl_info->price_3>0 and $skl_info->price_3 < $skl_info->price_2) 
					{$mode_price=3;$item_price=(float)$skl_info->price_3;}
				}
         }
				
		}
		elseif($mode=='recv_return' or $mode=='brak')
		{
			$skl = 0;
			$skl_info = $this->CI->Item->get_sklad_info($inum,$skl);
		}
		elseif($mode=='consi_return')
		{
			$skl = $this->CI->BiSOFT_Model->get_user_mode_client();
			$skl_info = $this->CI->Item->get_sklad_info($inum,$skl);
			$item_price = 0;
		}
		elseif($mode=='manu' or $mode=='macka')
		{
			$skl = 0;
			$skl_info = $this->CI->Item->get_sklad_info($inum,$skl);
				$mode_price = 0;
				$price = (float)$skl_info->cost;
		}
		else
		{
			$skl = 0;
			$skl_info = $this->CI->Item->get_sklad_info($inum,$skl);
		}

		if($allow_sizes) {$qty_col=$quantity;}
		
		$item_id = isset($skl_info->item_id) ? $skl_info->item_id : 0;

		if($this->CI->BiSOFT_Model->zebex_exists($inum, $mode))
		{ 
			// ако го има в Базата - събирам кол-вата  ...
			$item_now = $this->CI->BiSOFT_Model->zebex_get($inum,$mode);
			if($item_now)
			{
				$Qty[1] += (int)$item_now->q1;$Qty[2]  += (int)$item_now->q2;
				$Qty[3] += (int)$item_now->q3;$Qty[4]  += (int)$item_now->q4;
				$Qty[5] += (int)$item_now->q5;$Qty[6]  += (int)$item_now->q6;
				$Qty[7] += (int)$item_now->q7;$Qty[8]  += (int)$item_now->q8;
				$Qty[9] += (int)$item_now->q9;$Qty[10] += (int)$item_now->q10;
				
				$qty_col=$quantity=$Qty[1]+$Qty[2]+$Qty[3]+$Qty[4]+$Qty[5]+$Qty[6]+$Qty[7]+$Qty[8]+$Qty[9]+$Qty[10];
			}

			$item_data = array(
								'user_id' => $user_id,
									'mode' => $mode,
									  'id' => $item_id,
									'inum' => $inum,
									 'qty' => $qty_col,
									  'q1' => $Qty[1], 'q2' => $Qty[2], 'q3' => $Qty[3],
									  'q4' => $Qty[4], 'q5' => $Qty[5], 'q6' => $Qty[6], 
									  'q7' => $Qty[7], 'q8' => $Qty[8], 'q9' => $Qty[9], 'q10' => $Qty[10],
									 'dsc' => $discount,
								 'mprice' => $mode_price,
								  'price' => ($price!=null) ? $price : $item_price,
									 'skl' => $skl
								);
			// актуализира в ZEBEX + $success.
			$success *= $this->CI->BiSOFT_Model->zebex_save($item_data,$mode);
		}
		else // няма го ?!
		{
			$line = $this->get_line();
			$item_data = array(
								'user_id' => $user_id,
									'mode' => $mode,
									'line' => $line,
									  'id' => $item_id,
									'inum' => $inum,
									'name' => $name,
									 'qty' => $qty_col,
									  'q1' => $Qty[1], 'q2' => $Qty[2], 'q3' => $Qty[3], 
									  'q4' => $Qty[4], 'q5' => $Qty[5], 'q6' => $Qty[6], 
									  'q7' => $Qty[7], 'q8' => $Qty[8], 'q9' => $Qty[9], 'q10' => $Qty[10],
									'dsc'	 => $discount,
								 'mprice' => $mode_price,
								  'price' => ($price!=null) ? $price : $item_price,
								  'sizes' => $allow_sizes,
									 'skl' => $skl
										);
			
			// актуализира в ZEBEX + $success + нов ред.
			$success *= $this->CI->BiSOFT_Model->zebex_save($item_data,$mode);
			$this->set_line($line+1);
		}

		if($success) { return 'OK';}
		else { return 0;}
	}

		
	function out_of_stock($item_id)
	{	if(!$item_id) { return false;}
		$skl_info = $this->CI->Item->get_sklad_idx($item_id);
		$qty = $skl_info->qty;
		$qty_added = $this->get_qty_already_added($item_id);
		if ($qty<=0 or $qty-$qty_added<0) {return true;}
		else {return false;}
	}

	function get_qty_already_added($item_id)
	{	$items = $this->get_cart();
		$qty_already_added = 0;
		foreach ($items as $item)
			{ if($item['id']==$item_id) { $qty_already_added+=$item['qty'];} }
	return $qty_already_added;
	}

	function get_item_id($line_to_get)
	{	$items = $this->get_cart();
		foreach ($items as $line=>$item)
			{ if($line==$line_to_get) {return $item['id'];} }
	return -1;
	}

	function get_item_inum($line_to_get)
	{	$items = $this->get_cart();
		foreach ($items as $line=>$item)
			{ if($line==$line_to_get) {return $item['inum'];} }
	return -1;
	}
	
	function get_cart_item($line_to_get)
	{	$items = $this->get_cart();
		foreach ($items as $line=>$item)
			{ if($line==$line_to_get) {return $item;} }
	return -1;
	}

	
	function edit_item( $line, $quantity, $allow_sizes, $price, $mprice, $discount,
							  $q1,$q2,$q3,$q4,$q5,$q6,$q7,$q8,$q9,$q10)
	{
		$items = $this->get_cart();
		if(isset($items[$line]))
		{
			$items[$line]['dsc']    = $discount;
			$items[$line]['price']  = $price;
			$items[$line]['mprice'] = $mprice;
			
			if($allow_sizes)
			{ $items[$line]['qty'] = $quantity.','.$q1.','.$q2.','.$q3.','.$q4.','.$q5.
														  ','.$q6.','.$q7.','.$q8.','.$q9.','.$q10;}
			else
			{ $items[$line]['qty'] = $quantity;}
			
		$this->set_cart($items);
		}
	return false;
	}

	
	function get_cart_item_info( $line )
	{
		$items = $this->get_cart();$item=array();
		if(isset($items[$line]))
			{ $item = $items[$line];}
		else {return -1;}
	return $item;
	}
	
	
// my stuff  ------------------------------- BarCode  ------------------------------------- //
	
	function is_valid_item_number($barcode_item) 
	{
	   if (!is_numeric($barcode_item)) { return false; }
	   $lenBarcode = strlen($barcode_item);
	   if ($lenBarcode <  4 or $lenBarcode > 7 ) { return false; }
	return true;
	}

	function is_valid_barcode($barcode_item)
	{ //barCode validation
	$lenBarcode = strlen($barcode_item);
		if ($lenBarcode <  8) { return false; }
		if ($lenBarcode >  8 and $lenBarcode < 12) { return false; }
		if ($lenBarcode > 13) { return false; }
		if (is_numeric(!$barcode_item)) { return false; }
		return true;
	}


/* ----------------------------- REVISIONS --------------------------- */
	function get_barcode_qty($barcode_item)
	{ //barCode #
		$lenBarcode = strlen($barcode_item);
		$quantity 	= 1;
		$barcode 	= substr($barcode_item,0,-1);

		$qty = array(); $qty['error']=$qty[9]=$qty[8]=$qty[7]=$qty[6]=$qty[5]=$qty[4]=$qty[3]=$qty[2]=$qty[1]=$qty[10]=$qty['item']=0;

	   if (!is_numeric($barcode_item)) { $qty['error']=2; return $qty; } // край ГРЕШКА ...

		// EAN-8 Code table - checks 5-7 digit item numbers
		if ($lenBarcode == 8 ) { $qty['item'] = (int) $barcode; }
		// EAN-13 Code table
		elseif ($lenBarcode==13 or $lenBarcode==12) 
		{
		// checks 380 = Bulgaria Code table
		   $barcode_380 = substr($barcode_item,0,3);
		   if ($lenBarcode==13 and $barcode_380=='380') 
				{	$qty['item'] = (int) substr($barcode_item,-6,-1); }
			else
				{
					// Normal 12/13 bit code else 380
					$barcode = substr($barcode_item,0,-1);
					$qty['item'] = (int) substr($barcode,0,-4);
					$size_qty = (int) substr($barcode,9,10);
					$sizeQty = 0;

					if ($size_qty > 0 and $size_qty < 10) { $qty[$size_qty] = $quantity;}
					elseif ($size_qty == 10) 
						{ $qty[10] = $quantity; }
					else 
						{ 
							// различните размерни групи .....
							if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
							if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
							if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
							if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

							if ($size_qty > 10 and $size_qty < 100) 
								{$size_qty = floor($size_qty/2) - $sizeQty;}

							if ($size_qty > 9) { $qty[10] = $quantity; }
							elseif ($size_qty == 0) { }
							else { $qty[$size_qty] = $quantity; }
						}
				} // end of else 380
		}
		else { $qty['error']=1;}

	return $qty;
	}

	function revision_drop_sklad(&$sklad,$items)
	{
		$success = 0;
		$item_number = $items['item'];

		foreach($sklad as $line=>$item)
			{
				if($item_number==$item['inum'])
				{
					$sklad[$line]['qty']--;
					$sklad[$line]['q1']  -= (int)$items['1'];
					$sklad[$line]['q2']  -= (int)$items['2'];
					$sklad[$line]['q3']  -= (int)$items['3'];
					$sklad[$line]['q4']  -= (int)$items['4'];
					$sklad[$line]['q5']  -= (int)$items['5'];
					$sklad[$line]['q6']  -= (int)$items['6'];
					$sklad[$line]['q7']  -= (int)$items['7'];
					$sklad[$line]['q8']  -= (int)$items['8'];
					$sklad[$line]['q9']  -= (int)$items['9'];
					$sklad[$line]['q10'] -= (int)$items['10'];
					$success = 1;
				}
			}

	return $success;
	}
	
	function revision_check_sklad($shop_id,$inum,$size,$qty)
	{
		$success = 0;
      if($item_info = $this->CI->Item->get_sklad_info($inum,$shop_id))
      {
         if($this->CI->Item->get_allow_sizes($inum)) // размерни
         {
				$qty = (int)$qty;
				$q1  = (int)$item_info->q1; $q2 = (int)$item_info->q2; $q3  = (int)$item_info->q3;
				$q4  = (int)$item_info->q4; $q5 = (int)$item_info->q5; $q6  = (int)$item_info->q6;
				$q7  = (int)$item_info->q7; $q8 = (int)$item_info->q8; $q9  = (int)$item_info->q9;
				$q10 = (int)$item_info->q10;
				
          switch($size)
               {
                  case '1': if(($q1-$qty)!=0) {$success = $q1;}; break;
                  case '2': if(($q2-$qty)!=0) {$success = $q2;}; break;
                  case '3': if(($q3-$qty)!=0) {$success = $q3;}; break;
                  case '4': if(($q4-$qty)!=0) {$success = $q4;}; break;
                  case '5': if(($q5-$qty)!=0) {$success = $q5;}; break;
                  case '6': if(($q6-$qty)!=0) {$success = $q6;}; break;
                  case '7': if(($q7-$qty)!=0) {$success = $q7;}; break;
                  case '8': if(($q8-$qty)!=0) {$success = $q8;}; break;
                  case '9': if(($q9-$qty)!=0) {$success = $q9;}; break;
                  case '10': if(($q10-$qty)!=0) {$success = $q10;}; break;
                  
                  case '60': if(($q1-$qty)!=0) {$success = $q1;}; break;
                  case '62': if(($q2-$qty)!=0) {$success = $q2;}; break;
                  case '64': if(($q3-$qty)!=0) {$success = $q3;}; break;
                  case '66': if(($q4-$qty)!=0) {$success = $q4;}; break;
                  case '68': if(($q5-$qty)!=0) {$success = $q5;}; break;
                  case '70': if(($q6-$qty)!=0) {$success = $q6;}; break;
                  case '72': if(($q7-$qty)!=0) {$success = $q7;}; break;
                  case '74': if(($q8-$qty)!=0) {$success = $q8;}; break;
                  case '76': if(($q9-$qty)!=0) {$success = $q9;}; break;
                  
                  case '80': if(($q1-$qty)!=0) {$success = $q1;}; break;
                  case '82': if(($q2-$qty)!=0) {$success = $q2;}; break;
                  case '84': if(($q3-$qty)!=0) {$success = $q3;}; break;
                  case '86': if(($q4-$qty)!=0) {$success = $q4;}; break;
                  case '88': if(($q5-$qty)!=0) {$success = $q5;}; break;
                  case '90': if(($q6-$qty)!=0) {$success = $q6;}; break;
                  case '92': if(($q7-$qty)!=0) {$success = $q7;}; break;
                  case '94': if(($q8-$qty)!=0) {$success = $q8;}; break;
                  case '96': if(($q9-$qty)!=0) {$success = $q9;}; break;
               }
         }
         else // безразмерни ...
         {
            $razlika = $qty-$item_info->qty;
            if($razlika!=0) { $success = $item_info->qty;}
         }
		}
		
	return $success;
	}	
/* ------------------------------------ END REVISIONS ------------------------------- */



	function add_item_barcode($barcode_item,$quantity)
	{ //barCode #
		$lenBarcode = strlen($barcode_item);
		$item_number = 0;
		$barcode = substr($barcode_item,0,-1);

		$qty=array();$qty[0]=1;
		$qty[9]=$qty[8]=$qty[7]=$qty[6]=$qty[5]=$qty[4]=$qty[3]=$qty[2]=$qty[1]=$qty[10]=0;

		// EAN-8 Code table - checks 5-7 digit item numbers
		if ($lenBarcode == 8 ) { $item_number = (int) $barcode; }

		// EAN-13 Code table
		if ($lenBarcode == 13 ) {
		// checks 380 = Bulgaria Code table
		   $barcode_380 = substr($barcode_item,0,3);
		   if ($barcode_380 == '380') { $item_number = (int) substr($barcode_item,-6,-1); }
		   else { // else 380
			// Normal 13 bit code
			$barcode = substr($barcode_item,1,-1);
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 11) { $qty[$size_qty] = $quantity;}
			else { 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[10] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
			     }
			} // end of else 380
		}

		// BiSOFT internal Code table 12 (-leading 0)
		if ($lenBarcode == 12 ) {
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 11) { $qty[$size_qty] = $quantity;}
			else 
			{ 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[10] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
			}
		}

		$this->add_item($item_number, $quantity, 0, 0, $qty );
		
	return true;
	}


	function check_item_sizes($item_number,$item_data,$mode) 
		{
	    $item_info = $this->CI->Item->get_item_info($item_number);
	    $skl_info  = $this->CI->Item->get_sklad_info($item_number,0);
	    $key_for_error = 0;
	    $allow_sizes = $item_info->allow_sizes;

     if ( $allow_sizes ) 
     {
			$item_store = array(
				'quantity'  => (int)$skl_info->qty,
				'qty_1'	   => (int)$skl_info->q1,
				'qty_2'	   => (int)$skl_info->q2,
				'qty_3'	   => (int)$skl_info->q3,
				'qty_4'	   => (int)$skl_info->q4,
				'qty_5'	   => (int)$skl_info->q5,
				'qty_6'	   => (int)$skl_info->q6,
				'qty_7'	   => (int)$skl_info->q7,
				'qty_8'	   => (int)$skl_info->q8,
				'qty_9'	   => (int)$skl_info->q9,
				'qty_max'   => (int)$skl_info->q10,
								);

			if ($item_store['quantity'] < $item_data['quantity']) 		{ $key_for_error = 1;}
			if ($item_store['qty_1'] < (int)$item_data['qty_1'])     	{ $key_for_error = 1;}
			if ($item_store['qty_2'] < (int)$item_data['qty_2'])     	{ $key_for_error = 1;}
			if ($item_store['qty_3'] < (int)$item_data['qty_3'])     	{ $key_for_error = 1;}
			if ($item_store['qty_4'] < (int)$item_data['qty_4'])     	{ $key_for_error = 1;}
			if ($item_store['qty_5'] < (int)$item_data['qty_5'])     	{ $key_for_error = 1;}
			if ($item_store['qty_6'] < (int)$item_data['qty_6'])     	{ $key_for_error = 1;}
			if ($item_store['qty_7'] < (int)$item_data['qty_7'])     	{ $key_for_error = 1;}
			if ($item_store['qty_8'] < (int)$item_data['qty_8'])     	{ $key_for_error = 1;}
			if ($item_store['qty_9'] < (int)$item_data['qty_9'])     	{ $key_for_error = 1;}
			if ($item_store['qty_max'] < (int)$item_data['qty_max']) 	{ $key_for_error = 1;}
		} 
		else  
		{  // поверка само на БЕЗРАЗМЕРНИ ...
			$qtty = $skl_info->qty;
			if( $qtty < $item_data['quantity']) { $key_for_error = 1;} 
		}

		if ($key_for_error == 1) {return false;}
	return true;
	}

	
	function add_revision_zebex($shop_id,$all_items)
	{
      $success = 1;
      foreach($all_items as $inum=>$item_inf)
      {
         $last_item = 0;
         foreach($item_inf as $size=>$qty)
         {
            $Qty = array(
            '1' => 0, '2' => 0, '3' => 0, '4' => 0, '5' => 0, 
            '6' => 0, '7' => 0, '8' => 0, '9' => 0, '10' => 0 );
            $rezult = $this->revision_check_sklad($shop_id,$inum,$size,$qty);
            if($rezult and $shop_id)
            {
               $razlika = $qty-$rezult;
               if($size)         
               { 
                  if($size>=80 and $size<=98)
                     { $size = (int)(1+($size-80)/2);}
                  elseif($size>=60 and $size<=78)
                     { $size = (int)(1+($size-60)/2);}
                  elseif($size>=40 and $size<=58)
                     { $size = (int)(1+($size-40)/2);}
               } // if $size
                  
               if($size>0 and $size<11) { $Qty[$size] = $razlika;}      

               $last_item = $inum;
               $success *= $this->add_item($inum,$razlika,0,0,$Qty);
            } // if($rezult)
         } // foreach($item_inf
      } // foreach($all_items
               
   return $success;            
	}
	
	
// end of my stuff --------------------------------------------------------------------------

	// не се използва
	function return_entire_recv($receipt_doc_id)
	{
		//POS #
		$pieces = explode(' ',$receipt_doc_id);
		$doc_id = $pieces[1];

		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_supplier();

		foreach($this->CI->Recv->get_recv_items($doc_id)->result() as $row)
		{
			$Qty = explode(',',$row->item_name);
			$this->add_item($row->item_id,-$row->item_qty,$row->item_unit_price,$row->item_discount,$Qty);
		}
		
	$this->set_supplier($this->CI->Recv->get_supplier($doc_id)->person_id);
	}


	function copy_entire_recv($doc_id, $vedomPack, $mode)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_supplier();
		$this->remove_consignee();

		foreach($this->CI->Recv->get_recv_items($doc_id, $vedomPack, $mode)->result() as $row)
		{
			$Qty = explode(',',$row->item_name);
			$this->add_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount,
					$Qty );
		}

	if ( $mode != 'shop_recv' and $mode != 'shop_sgp')
		{ $this->set_supplier($this->CI->Recv->get_supplier($doc_id,$vedomPack)->person_id);}
	}
	

	function copy_entire_suspended_recv($doc_id)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_supplier();
		$this->remove_consignee();

		foreach($this->CI->Recv_suspended->get_recv_items($doc_id)->result() as $row)
		{
			$this->add_item($row->item_id,$row->item_qty,$row->item_unit_price,$row->item_discount);
		}
		foreach($this->CI->Recv_suspended->get_recv_payments($doc_id)->result() as $row)
		{
			$Qty = explode(',',$row->item_name);
			$this->add_payment($row->payment_type,$row->payment_amount,0,0,$Qty);
		}
		$this->set_supplier($this->CI->Recv_suspended->get_supplier($doc_id)->person_id);
		$this->set_comment($this->CI->Recv_suspended->get_comment($doc_id));
	}

	function delete_item($line)
	{
		$items=$this->get_cart();
		unset($items[$line]);
		$this->set_cart($items);
	}


	function get_supplier_discount()
	{
		$supplier_id = $this->get_supplier();
		$supplier = $this->CI->Supplier->get_info($supplier_id);

		$supplier_discount = $supplier->discount;

		if ($supplier_discount == 0 or $supplier_discount == '') 
				{ return 0;}

	return $supplier_discount;
	}


	function get_taxes()
	{
		$supplier_id = $this->get_supplier();
		$supplier = $this->CI->Supplier->get_info($supplier_id);

		//Do not charge recvs tax if we have a supplier that is not taxable
		if (!$supplier->taxable and $supplier_id!=-1)
		{ return array();}

		$taxes = array();
		foreach($this->get_cart() as $line=>$item)
		{
			$tax_info = $this->CI->Item_taxes->get_info($item['item_id']);

			foreach($tax_info as $tax)
			{
				$name = $tax['percent'].'% ' . $tax['name'];
				$tax_amount=($item['price']*$item['qty']-$item['price']*$item['qty']*(int)$item['dsc']/100)*(($tax['percent'])/100);

				if (!isset($taxes[$name])) {$taxes[$name]=0;}
				$taxes[$name] += $tax_amount;
			}
		}
	return $taxes;
	}

// ---------------------------------------------  DELIVERY -------------------------------- //

	function copy_entire_delivered_table($doc_id)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_supplier();
		$this->remove_consignee();
				
		$mode = $this->CI->Delivered->get_mode($doc_id);
		$this->set_mode($mode);
		$this->set_comment($this->CI->Delivered->get_comment($doc_id));
		$this->CI->BiSOFT_Model->zebex_clear_all($mode);
		
		$delivery = $this->CI->Delivered->get_delivered_items($doc_id)->result();
		
		if($delivery)
		{
			foreach($delivery as $row)
			{
				$Qty = explode(',',$row->item_name);
				$this->add_item(
						$row->item_number,
						$row->item_qty,
						$row->item_unit_price,
						$row->item_discount,
						$Qty );
			}
			
			$consignee_id = 0;
			$bisoft_id = $this->CI->Delivered->get_consignee($doc_id);

			if ($bisoft_id > 0)  // когато не е бил избран КОНСИГНАТОР Е ГРЕШКА ?!!?!?! 
			{
				$consignee_id = $this->CI->Consignee->get_info_by_bisoft_id($bisoft_id)->bisoft_id;
				$this->set_consignee($consignee_id);
			}
		}
	}


	function get_subtotal($mode='recv')
	{
		$subtotal = 0;
		$cart = $this->CI->BiSOFT_Model->zebex_get_all($mode,0,0);
		
		if($cart)
		{
			foreach($cart as $item)
			{
				// $item_info = $this->CI->Item->get_sklad_idx($item['id']); - не се използва вече
				$item_price  = (float)$item['price'];
				$subtotal 	+= (int)$item['qty'] * round( $item_price * (100 - (float)$item['dsc']) / 100, 8);
			}
		}
	return round($subtotal,8);
	}


	function get_total($mode,$supplier_discount)
	{
		$subtotal = $this->get_subtotal($mode);
		$total = round( (float)$subtotal * ( 100 - (int)$supplier_discount ) / 100, 8);
	return $total;
	}

	function get_all_qty()
	{
		$mode = $this->get_mode();
		return $this->CI->BiSOFT_Model->zebex_all_qty($mode);
	}
	
	function count_cart()
	{ 	
		$mode = $this->get_mode();
		$all_items = $this->CI->BiSOFT_Model->zebex_all_qty($mode);
		if($all_items) { return (int)$all_items;}
		else { return 0;}
	}

} ?>
