<?php class Sale_lib
{
	var $CI;
  	function __construct()
	{ $this->CI =& get_instance();}

// -------------------------- MODES ---------------------------------- //
	function get_mode()
	{
		$location = $this->CI->Employee->get_logged_in_employee_info()->location;
		if($location!=0) {$this->CI->BiSOFT_Model->set_user_client($location);}
		$key_CKP  = $this->CI->BiSOFT_Model->get_version_ckp();
		if ( $location==0 )
			{
				if ( !$key_CKP ) { $default_mode = 'sale'; }
				else { $default_mode = 'sale'; }
			}
		else
			{ $default_mode = 'shop_sale';}

			if(!$this->CI->session->userdata('sale_mode'))
			  { $this->set_mode($default_mode);}

	return $this->CI->session->userdata('sale_mode');
	}

	function set_mode($mode)
	{ $this->CI->session->set_userdata('sale_mode', $mode);}

	function clear_mode()
	{ $this->CI->session->unset_userdata('sale_mode');}
	

	// Cart
	function get_cart()
	{
		$mode = $this->get_mode();
		return $this->CI->BiSOFT_Model->zebex_get_all($mode,0,0);
	}
	
	function get_cart_page($limit=20,$offset=0)
	{
		$mode = $this->get_mode();
		return $this->CI->BiSOFT_Model->zebex_get_all($mode,$limit,$offset);
	}

	function set_cart($cart_data)
	{
		$mode = $this->get_mode();
		if($cart_data)
			{ return $this->CI->BiSOFT_Model->zebex_save($cart_data,$mode);}
		else
			{ return false;}
	}

	function empty_cart()
	{ 
		$mode = $this->get_mode();
		return $this->CI->BiSOFT_Model->zebex_clear_all($mode);
	}	
	
	
// -------------------------- LINES ---------------------------------- //
	function get_line()
	{
		if(!$this->CI->session->userdata('sale_line'))
			$this->set_line(1);
	return $this->CI->session->userdata('sale_line');
	}

	function set_line($line)
	{ $this->CI->session->set_userdata('sale_line', $line);}

	function clear_line()
	{ $this->CI->session->unset_userdata('sale_line');}	
	
	
	// Orders
	function get_order()
	{
      if(!$this->CI->session->userdata('sale_order'))
			{ $this->set_order(0);}

	return $this->CI->session->userdata('sale_order');
	}

	function set_order($order)
	{ $this->CI->session->set_userdata('sale_order', $order);}

	function clear_order()
	{ $this->CI->session->unset_userdata('sale_order');}	
	
	
	// Giftcards
	function get_giftcard() 
	{ if(!$this->CI->session->userdata('sale_giftcard'))
				$this->set_giftcard(0);
	return $this->CI->session->userdata('sale_giftcard');
	}

	function set_giftcard($giftcard) 
	{ $this->CI->session->set_userdata('sale_giftcard', $giftcard);}
	
	function get_giftvalue() 
	{ if(!$this->CI->session->userdata('sale_giftvalue'))
				$this->set_giftvalue(0);
	return $this->CI->session->userdata('sale_giftvalue');
	}

	function set_giftvalue($giftvalue) 
	{ $this->CI->session->set_userdata('sale_giftvalue', $giftvalue);}

	function clear_giftcard() 	
	{ $this->CI->session->unset_userdata('sale_giftcard');
	  $this->CI->session->unset_userdata('sale_giftvalue'); }
	
	
	// Comments
	function get_comment() 
	{ if(!$this->CI->session->userdata('sale_comment'))
				$this->set_comment('');
	return $this->CI->session->userdata('sale_comment');
	}

	function set_comment($comment) 
	{ $this->CI->session->set_userdata('sale_comment', $comment);}

	function clear_comment() 	
	{ $this->CI->session->unset_userdata('sale_comment');}
	

	// E-mail
	function get_email_receipt() 
	{ return $this->CI->session->userdata('sale_email_receipt');}


	function set_email_receipt($email_receipt) 
	{ $this->CI->session->set_userdata('sale_email_receipt', $email_receipt);}


	function clear_email_receipt() 	
	{ $this->CI->session->unset_userdata('sale_email_receipt');}

	
	// User Data
	function get_user_data() 
	{ return $this->CI->session->userdata('user_data');}

	function set_user_data($userData) 
	{ $this->CI->session->set_userdata('user_data', $userData);}

	function clear_user_data() 	
	{ $this->CI->session->unset_userdata('user_data');}
	
	
// -------- Multiple Payments ----------------------------------------

	// Multiple Payments
	function get_payments()
	{
		if( !$this->CI->session->userdata( 'sale_pays' ) )
			$this->set_payments( array() );
	return $this->CI->session->userdata('sale_pays');
	}

	function set_payments($payments_data)
	{ $this->CI->session->set_userdata('sale_pays',$payments_data); }

	function empty_payments()
	{ $this->CI->session->unset_userdata('sale_pays');}
	
	
	
	function add_payment( $payment_id, $payment_amount )
	{
		$payments = $this->get_payments();
		$payment = array( $payment_id=>
		array(
			'payment_type' => $payment_id,
			'payment_amount' => $payment_amount )
		);

		//payment_method already exists, add to payment_amount
		if( isset( $payments[$payment_id] ) )
		{
			$payments[$payment_id]['payment_amount'] += $payment_amount;
		}
		else
		{  //add to existing array
			$payments += $payment;
		}

		$this->set_payments( $payments );
	return true;
	}


	function edit_payment($payment_id,$payment_amount)
	{
		$payments = $this->get_payments();
		if(isset($payments[$payment_id]))
		{
			$payments[$payment_id]['payment_type'] = $payment_id;
			$payments[$payment_id]['payment_amount'] = $payment_amount;
			$this->set_payments($payment_id);
		}
	return false;
	}

	function delete_payment( $payment_id )
	{
		$payments = $this->get_payments();
		unset( $payments[urldecode( $payment_id )] );
		$this->set_payments( $payments );
	}


	function get_payments_total()
	{
		$subtotal=0;
		foreach($this->get_payments() as $payments)
			{ $subtotal += $payments['payment_amount'];}

	return to_currency_no_money($subtotal);
	}


	function get_amount_due($mode,$taxed)
	{
		$customer_discount = $this->get_customer_discount();
		$amount_due=0;
		if(!isset($taxed)) { $taxed = 0; }
		$payment_total = round($this->get_payments_total(),2);
		$sales_total   = round($this->get_total($mode,$customer_discount,$taxed),2);

		$amount_due = to_currency_no_money ( $sales_total - $payment_total ); 

	return $amount_due;
	}
// -------- end of Payments ----------------



	// ------------------------------------- DATE KEY---------------------------------- //
	function get_dateKey() 
	{
		if	(!$this->CI->session->userdata('sale_date_key'))
			{ return 0;}
	return 1;
	}

	function set_dateKey() 
	{ $this->CI->session->set_userdata('sale_date_key', 1);}

	function clear_dateKey() 	
	{ $this->CI->session->unset_userdata('sale_date_key');}



	// -------------------------- CUSTOMER ---------------------- //
	function get_customer()
	{
		if(!$this->CI->session->userdata('sale_customer'))
			$this->set_customer(-1);

	return $this->CI->session->userdata('sale_customer');
	}

	function set_customer($customer_id)
	{ $this->CI->session->set_userdata('sale_customer',$customer_id);}

	function remove_customer()
	{
		$this->CI->session->unset_userdata('sale_customer');
		$this->CI->session->unset_userdata('sale_oder');
		$this->CI->session->unset_userdata('sale_client_name');
		$this->CI->session->unset_userdata('sale_client_surname');
		$this->CI->session->unset_userdata('sale_client_data');
		$this->CI->session->unset_userdata('sale_comment');
		$this->CI->BiSOFT_Model->set_user_client(0);
	}

	
	// -------------------------- CLIENT NAME---------------------- //
	function get_client_name()
	{ if(!$this->CI->session->userdata('sale_client_name'))
			$this->set_client_name('');
	return $this->CI->session->userdata('sale_client_name');
	}

	function set_client_name($name)
	{ $this->CI->session->set_userdata('sale_client_name',$name); }
	

	// -------------------------- CLIENT SURNAME---------------------- //
	function get_client_surname()
	{ if(!$this->CI->session->userdata('sale_client_surname'))
			$this->set_client_surname('');
	return $this->CI->session->userdata('sale_client_surname');
	}

	function set_client_surname($surname)
	{ $this->CI->session->set_userdata('sale_client_surname',$surname); }
	

	// -------------------------- CLIENT DATA---------------------- //
	function get_client_data()
	{ if(!$this->CI->session->userdata('sale_client_data'))
			$this->set_client_data('');
	return $this->CI->session->userdata('sale_client_data');
	}

	function set_client_data($data)
	{ $this->CI->session->set_userdata('sale_client_data',$data); }



	// -------------------------- CONSIGNEE ---------------------- //
	function get_consignee()
	{
		if(!$this->CI->session->userdata('sale_consignee'))
		  { $this->set_consignee(-1);}
	return $this->CI->session->userdata('sale_consignee');
	}

	function set_consignee($consignee_id)
	{ $this->CI->session->set_userdata('sale_consignee',$consignee_id);}

	function remove_consignee()
	{
		$this->CI->session->unset_userdata('sale_consignee');
		$this->CI->BiSOFT_Model->set_user_client(0);
	}
	
	
	// ----------------------- ONLINE CLIENT  ------------------- //
	function get_online_client()
	{
		if(!$this->CI->session->userdata('sale_online_client'))
			$this->set_online_client(-1);

	return $this->CI->session->userdata('sale_online_client');
	}

	function set_online_client($online_client)
	{ $this->CI->session->set_userdata('sale_online_client',$online_client);}

	function remove_online_client()
	{
		$this->CI->session->unset_userdata('sale_online_client');
		$this->CI->BiSOFT_Model->set_user_client(0);
	}


// ------------------------------ Prices ----------------------------- //
	function get_mode_price()
	{	
		$location = $this->CI->BiSOFT_Model->get_location();
		if	(!$this->CI->session->userdata('sale_price'))
			{ 
				if($location==0) {$this->set_mode_price(99);}
				else {$this->set_mode_price(1);}
			}
	return $this->CI->session->userdata('sale_price');
	}

	function set_mode_price($mode_price)
	{ $this->CI->session->set_userdata('sale_price',$mode_price);}

	function clear_mode_price()
	{  $this->CI->session->unset_userdata('sale_price');}
	
	
	
// ------------------------------ Valuta ----------------------------- //
	function get_mode_valuta($curr)
	{
		if	(!$this->CI->session->userdata('sale_valuta'))
			{ $this->set_mode_valuta($curr);}

	return $this->CI->session->userdata('sale_valuta');
	}

	function set_mode_valuta($mode_valuta)
	{ $this->CI->session->set_userdata('sale_valuta',$mode_valuta);}

	
// ------------------------------ Type Payment ----------------------------- //
	function get_mode_payment()
	{
		if	(!$this->CI->session->userdata('sale_payment'))
			{ $this->set_mode_payment($this->CI->lang->line('sales_cash'));}
	return $this->CI->session->userdata('sale_payment');
	}

	function set_mode_payment($type_payment)
	{ $this->CI->session->set_userdata('sale_payment',$type_payment);}


// ------------------------------ Printons ----------------------------- //
	function get_mode_print()
	{
		if(!$this->CI->session->userdata('sale_prn'))
			$this->set_mode_print('prices');
	return $this->CI->session->userdata('sale_prn');
	}

	function set_mode_print($mode_print)
	{ $this->CI->session->set_userdata('sale_prn',$mode_print);}
	

	function clear_mode_print()
	{ 	$this->CI->session->unset_userdata('sale_prn');}

	
	function clear_all()
	{
		$this->empty_cart();
		$this->remove_customer();
		$this->empty_payments();
		$this->clear_mode_price();
		$this->clear_mode_print();
		$this->clear_line();
		$this->clear_dateKey();
		$this->clear_order();
		$this->clear_giftcard();
		$this->clear_comment();
		$this->clear_email_receipt();
		$this->clear_mode();
	}
	
	

	function add_item( $inum, $quantity, $price, $mprice, $discount, $Qty )
	{
		$success = 1;
		$user_id = $this->CI->BiSOFT_Model->get_person();
      $error_key = $allow_sizes = $item_price = $bFriday_pro = 0; 
      $name=''; $sizes = array();
		$location = $this->CI->BiSOFT_Model->get_location();
		$mode = $this->get_mode();

		$item_info = $this->CI->Item->get_blanka_info($inum);
		if($item_info)
		{
         $sizes = $this->CI->Item->get_sizes($inum);
			$allow_sizes = $item_info->allow_sizes;
			$name = $item_info->name;
      }
      
      // Black Fridays
      $bFriday=$this->get_bFriday();
      if($bFriday) {$bFriday_pro=(int)$this->get_bFriday_discount($inum);}
      if($location==0 or $location==7) {$bFriday=$bFriday_pro=0;}
			
      $model = 0; if($allow_sizes==0 and isset($Qty[12])) {$model = $Qty[12];}
		$commision_key = $comis_price = 0;	
		if(!count($Qty)) {$Qty[1]=$Qty[2]=$Qty[3]=$Qty[4]=$Qty[5]=$Qty[6]=$Qty[7]=$Qty[8]=$Qty[9]=$Qty[10]=$model=0;}		

		if($location==0)
		{
			if($mode == 'consi_sale')
				{
					$skl=$this->CI->BiSOFT_Model->get_user_mode_client();
					$skl_info=$this->CI->Item->get_sklad_info($inum,$skl);

					$commision_key = $this->CI->Consignee->get_info_by_bisoft_id($skl)->status;
					if($commision_key=='comis' and $skl_info)
						{
							$comis_price = (float)$skl_info->price;
							if($discount==0) {$discount=(float)$skl_info->dsc;}
						}
						else
						{	$comis_price = $price;}
				}
			else
				{
					$skl=0;
					$skl_info=$this->CI->Item->get_sklad_info($inum,0);
				}
			if(!$skl_info)   // НЕ СЪЩЕСТВУВА АРТИКУЛА В СКЛАД-ГП ?!
            { return false;}
		}
		else // магазини
		{
			$skl = $location;
			$skl_info=$this->CI->Item->get_sklad_info($inum,$skl);
			if(!$skl_info)   // НЕ СЪЩЕСТВУВА АРТИКУЛА В СКЛАД $skl ?!
            { return false;}
		}

		// Prices ...
		$mode_price = $mprice;
		if($mode=='shop_sgp' and $location!=0) // само за ВЪРНАТА от Магазин
         {$item_price = (float)$skl_info->price; $mode_price=1;}
      elseif(($mode=='online_sale' or $mode=='online_return') and $location==0)
      {
         $mode_price=100;
         $this->set_mode_price($mode_price);
         $item_price=round((float)$skl_info->price_2/1.2,8);
         if((int)$skl_info->price_3>0 and (int)$skl_info->price_3 < (int)$skl_info->price_2) 
            {$item_price=round((float)$skl_info->price_3/1.2,8);}
      }
      elseif($mode=='prep_sale' and $location==0)
      {
         $mode_price=2;$item_price=$skl_info->price_2;
         if((int)$skl_info->price_3>0 and (int)$skl_info->price_3<(int)$skl_info->price_2) 
            {$mode_price=3;$item_price=(float)$skl_info->price_3;}
      }
      elseif($bFriday) // Black Friday
      {
         $discount = $bFriday_pro;
         $price = $this->CI->OnLine->get_price_2($inum);
         $mode_price=0;
         $this->set_mode_price($mode_price);
      }
      else // всички други ...
         {
            $mode_price = $this->get_mode_price();
            switch ($mode_price) 
               {
                  case '1': $item_price = (float)$skl_info->price;   break;
                  case '2': $item_price = (float)$skl_info->price_2; break;
                  case '3': $item_price = (float)$skl_info->price_3; break;
                  case '4': $item_price = (float)$skl_info->price_4; break;
                  case '5': $item_price = (float)$skl_info->price_5; break;
                  default:  $item_price = (float)$skl_info->price;
               }
         }
		$item_price = to_dot($item_price);		
		
		// променя отстъпката на заложената ?!
		if($discount==0 and !$bFriday) {$discount = (float)$skl_info->dsc;}

			if ($allow_sizes) {$qty_col=$quantity;}
			else {$qty_col=1;}	
		
		// id - не знам дали ми трябва ?!
		$item_id = ($skl_info and isset($skl_info->item_id)) ? $skl_info->item_id : 0;

		if($this->CI->BiSOFT_Model->zebex_exists($inum, $mode) and $item_id>0)
		{ 
			// ако го има в Базата - събирам кол-вата  ...
			$item_now = $this->CI->BiSOFT_Model->zebex_get($inum,$mode);
			if($item_now)
			{
				$Qty[1] += (int)$item_now->q1;$Qty[2]  += (int)$item_now->q2;
				$Qty[3] += (int)$item_now->q3;$Qty[4]  += (int)$item_now->q4;
				$Qty[5] += (int)$item_now->q5;$Qty[6]  += (int)$item_now->q6;
				$Qty[7] += (int)$item_now->q7;$Qty[8]  += (int)$item_now->q8;
				$Qty[9] += (int)$item_now->q9;$Qty[10] += (int)$item_now->q10;
				
				$qty_col=$quantity=$Qty[1]+$Qty[2]+$Qty[3]+$Qty[4]+$Qty[5]+$Qty[6]+$Qty[7]+$Qty[8]+$Qty[9]+$Qty[10];
			}

			$item_data = array(
								'user_id' => $user_id,
									'mode' => $mode,
									  'id' => $item_id,
									'inum' => $inum,
									 'qty' => $qty_col,
									  'q1' => $Qty[1], 'q2' => $Qty[2], 'q3' => $Qty[3], 
									  'q4' => $Qty[4], 'q5' => $Qty[5], 'q6' => $Qty[6],
									  'q7' => $Qty[7], 'q8' => $Qty[8], 'q9' => $Qty[9], 
									 'q10' => $Qty[10],
									 'dsc' => $discount,
								 'mprice' => $mode_price,
								  'price' => ($price!=null) ? $price : $item_price,
									 'skl' => $skl
								);
			// актуализира в ZEBEX + $success.
			$success *= $this->CI->BiSOFT_Model->zebex_save($item_data,$mode);
		}
		elseif($item_id>0) // няма го ?!
		{
			$line = $this->get_line();
			$item_data = array(
								'user_id' => $user_id,
									'mode' => $mode,
									'line' => $line,
									  'id' => $item_id,
									'inum' => $inum,
									'name' => $name,
									 'qty' => $qty_col,
									  'q1' => $Qty[1], 'q2' => $Qty[2], 'q3' => $Qty[3],
									  'q4' => $Qty[4], 'q5' => $Qty[5], 'q6' => $Qty[6],
									  'q7' => $Qty[7], 'q8' => $Qty[8], 'q9' => $Qty[9],
									 'q10' => $Qty[10],
									'dsc'	 => $discount,
								 'mprice' => $mode_price,
								  'price' => ($price!=null) ? $price : $item_price,
								  'sizes' => $allow_sizes,
									 'skl' => $skl
									);
			
			// актуализира в ZEBEX + $success + нов ред.
			$success *= $this->CI->BiSOFT_Model->zebex_save($item_data,$mode);
			$this->set_line($line+1);
		}

		if($success) { return 'OK';}
		else { return 0;}
	}


	function out_of_stock($item_id)
	{	if(!$item_id) { return false;}
		$skl_info = $this->CI->Item->get_sklad_idx($item_id);
		$qty = $skl_info->qty;
		$qty_added = $this->get_qty_already_added($item_id);
		if ($qty<=0 or $qty-$qty_added<0) {return true;}
		else {return false;}
	}

	function get_qty_already_added($item_id)
	{	$items = $this->get_cart();
		$qty_already_added = 0;
		foreach ($items as $item)
			{ if($item['id']==$item_id) { $qty_already_added+=$item['qty'];} }
	return $qty_already_added;
	}

	function get_item_id($line_to_get)
	{	$items = $this->get_cart();
		foreach ($items as $line=>$item)
			{ if($line==$line_to_get) {return $item['id'];} }
	return -1;
	}

	function get_item_inum($line_to_get)
	{	$items = $this->get_cart();
		foreach ($items as $line=>$item)
			{ if($line==$line_to_get) {return $item['inum'];} }
	return -1;
	}
	
	function get_cart_item($line_to_get)
	{	$items = $this->get_cart();
		foreach ($items as $line=>$item)
			{ if($line==$line_to_get) {return $item;} }
	return -1;
	}

	
	function edit_item( $line, $quantity, $allow_sizes, $price, $mprice, $discount, $inv_name,
							  $q1,$q2,$q3,$q4,$q5,$q6,$q7,$q8,$q9,$q10)
	{
		$items = $this->get_cart();
		if(isset($items[$line]))
		{
			$items[$line]['dsc']    = $discount;
			$items[$line]['price']  = $price;
			$items[$line]['mprice'] = $mprice;
			$items[$line]['inv']    = $inv_name;
			if($allow_sizes)
			{ $items[$line]['qty'] = $quantity.','.$q1.','.$q2.','.$q3.','.$q4.','.$q5.
														  ','.$q6.','.$q7.','.$q8.','.$q9.','.$q10;}
			else
			{ $items[$line]['qty'] = $quantity;}
		$this->set_cart($items);
		}
	return false;
	}
	
	function get_cart_item_info( $line )
	{
		$item=array();
		$items = $this->get_cart();
		
		echo 'спряна...';
		// print_r($items);
		die();
		
		if(isset($items[$line]))
			{ $item = $items[$line];}
		else {return -1;}
	return $item;
	}
	

	
	
/* ========================== ПОДГОТОВКА ЗА ЕКСПЕДИЦИЯ =========================== */	
	function get_prep_cart( $customer_id )
	{
      $doc_id = 0;
      $cust_info = $this->CI->Customer->get_info($customer_id);
      $items = $this->CI->Sale->get_prep_items($cust_info->bisoft_id);
      if($items)
      {
         foreach($items as $item)
         {  
            $doc_id=$item['doc_id'];
            $inum=$item['item_number'];
            $qty=$item['item_qty'];
            $price=$item['item_unit_price'];
            $mprice=$item['mode_price'];
            $dsc=$item['item_discount'];
               $inv_name=$item['invoice_name'];
            $Qty=explode(',',$item['item_name']);
            if($inum) {$this->add_item( $inum, $qty, $price, $mprice, $dsc, $Qty, $inv_name );}
         }
      }

      if($doc_id) 
         {
            $order=$this->CI->Suspended->get_order($doc_id);
            if($order) {$this->set_order($order);}
            $order_date=$this->CI->Suspended->get_order_date($doc_id);
            if($order_date) {$this->CI->BiSOFT_Model->set_user_date($order_date);}
         }
	}
	


// my stuff  ------------------------------- BarCode  ------------------------------------- //
	function is_valid_item_number($barcode_item) 
	{
	   $lenBarcode=strlen($barcode_item);
	   if ($lenBarcode<4 or $lenBarcode>7) {return false;}
	   else {return true;}
	}

// ------------------------------------------ BARCODES -------------------------------- //
	function is_valid_barcode($barcode_item)
	{
		$lenBarcode = strlen($barcode_item);
		if ($lenBarcode<8) {return false;}
		if ($lenBarcode>8 and $lenBarcode < 12) {return false;}
		if ($lenBarcode>13) {return false;}
		if (is_numeric(!$barcode_item)) {return false;}
		else {return true;}
	}

	function add_item_barcode($barcode_item,$quantity)
	{  //barCode
		$lenBarcode=strlen($barcode_item);
		$item_number=0;
		$barcode=substr($barcode_item,0,-1);

		$qty=array();$qty[0]=1;
		$qty[1]=$qty[2]=$qty[3]=$qty[4]=$qty[5]=$qty[6]=$qty[7]=$qty[8]=$qty[9]=$qty[10]=0;

		// EAN-8 Code table - checks 5-7 digit item numbers
		if ($lenBarcode == 8 ) { $item_number = (int) $barcode; }

		// EAN-13 Code table
		if ($lenBarcode == 13 ) 
			{
			// checks 380 = Bulgaria Code table
			   $barcode_380 = substr($barcode_item,0,3);
				if ($barcode_380 == '380') { $item_number = (int) substr($barcode_item,-6,-1); }
		   	else { // else 380
			// Normal 13 bit code
			$barcode = substr($barcode_item,1,-1);
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 11) { $qty[$size_qty] = $quantity;}
			else 
				{ 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[10] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
				}
			} // end of else 380
		}

		// BiSOFT internal Code table 12 (-leading 0)
		if ($lenBarcode == 12 ) 
		{
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 11) { $qty[$size_qty] = $quantity;}
			else { 
						// различните размерни групи .....
						if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
						if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
						if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
						if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

						if ($size_qty > 10 and $size_qty < 100) 
							{$size_qty = floor($size_qty/2) - $sizeQty;}

						if ($size_qty > 9) { $qty[10] = $quantity; }
						elseif ($size_qty == 0) { }
						else { $qty[$size_qty] = $quantity; }
			     }
		}
		
		$this->add_item($item_number, $quantity, 0, 0, 0, $qty );

	return true;
	}


	function copy_entire_sale( $doc_id, $vedomPack )
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Sale->get_sale_items($doc_id,$vedomPack)->result() as $row)
		{
         $mprice = 0;
         if(isset($row->mode_price) and $row->mode_price) {$mprice=$row->mode_price;}
			$Qty = explode(',',$row->item_name);
			$this->add_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$mprice,
					$row->item_discount,
					$Qty );
		}

		foreach($this->CI->Sale->get_sale_payments($doc_id,$vedomPack)->result() as $row)
			{ $this->add_payment($row->pay_type,$row->pay_amount); }

      $customer = $this->CI->Sale->get_customer($doc_id,$vedomPack);
      if($customer) { $this->set_customer($this->CI->Sale->get_customer($doc_id,$vedomPack)->person_id);}
      else {$this->set_customer(0);}
	}


	function copy_online_sale( $doc_id, $vedomPack )
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Sale->get_sale_items($doc_id,$vedomPack)->result() as $row)
		{
         $mprice = 0;
			$Qty = explode(',',$row->item_name);
			$this->add_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$mprice,
					$row->item_discount,
					$Qty );
		}

		foreach($this->CI->Sale->get_sale_payments($doc_id,$vedomPack)->result() as $row)
			{ $this->add_payment($row->pay_type,$row->pay_amount); }

	$this->set_customer($this->CI->Sale->get_customer($doc_id,$vedomPack)->person_id);
	}


	function copy_entire_suspended_sale($doc_id)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();
		$mode = $this->CI->Suspended->get_mode($doc_id);

		foreach($this->CI->Suspended->get_sale_items($doc_id)->result() as $row)
		{
         $mprice = 0;
         $inum = $row->item_number;
         $allow_sizes = 1; //  да се отнемат размери ...
         $skl_info = $this->CI->Item->get_sklad_info($inum,0);
         if(isset($row->mode_price) and $row->mode_price) {$mprice=$row->mode_price;}
			$Qty = explode(',',$row->item_name);
			$this->add_item(
                     $inum,
                     $row->item_qty,
                     $row->item_unit_price,
                     $mprice,
                     $row->item_discount,
                     $Qty );
                     
         if($mode=='prep_sale')
         {  //Update stock quantity
				$q1 = (int)$skl_info->q1 + (int)$Qty[1];
				$q2 = (int)$skl_info->q1 + (int)$Qty[1];
				$q3 = (int)$skl_info->q1 + (int)$Qty[1];
				$q4 = (int)$skl_info->q1 + (int)$Qty[1];
				$q5 = (int)$skl_info->q1 + (int)$Qty[1];
				$q6 = (int)$skl_info->q1 + (int)$Qty[1];
				$q7 = (int)$skl_info->q1 + (int)$Qty[1];
				$q8 = (int)$skl_info->q1 + (int)$Qty[1];
				$q9 = (int)$skl_info->q9 + (int)$Qty[9];
				$q10 = (int)$skl_info->q10 + (int)$Qty[10];
         
				$item_data = array(
				  'inum' => $inum,
					'skl'	=> 0,
					'qty'	=> $skl_info->qty + $row->item_qty,
					'q1'	=> (!$q1)  ? '' : $q1,
					'q2'	=> (!$q2)  ? '' : $q2,
					'q3'	=> (!$q3)  ? '' : $q3,
					'q4'	=> (!$q4)  ? '' : $q4,
					'q5'	=> (!$q5)  ? '' : $q5,
					'q6'	=> (!$q6)  ? '' : $q6,
					'q7'	=> (!$q7)  ? '' : $q7,
					'q8'	=> (!$q8)  ? '' : $q8,
					'q9'	=> (!$q9)  ? '' : $q9,
					'q10'	=> (!$q10) ? '' : $q10,
					'del'	=> 0 );
					
			$this->CI->Item->save_sklad($item_data);
         }
		}
			
      $customer_id = 0;
		$bisoft_id = $this->CI->Suspended->get_customer($doc_id);

		if ($bisoft_id != 0)  // когато е бил избран КЛИЕНТ 
         {
				$customer_id = $this->CI->Customer->get_info_by_bisoft_id($bisoft_id)->person_id;
				$this->set_customer($customer_id);
			}

      if($mode=='prep_sale') { $mode='sale';}

      $this->set_mode($mode);
      $order=$this->CI->Suspended->get_order($doc_id);
		if($order) {$this->set_order($order);}
		$this->set_comment($this->CI->Suspended->get_comment($doc_id));
	}

// ---------------------------------------------  DELIVERY -------------------------------- //

	function copy_entire_delivered_table($doc_id)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_consignee();

		foreach($this->CI->Delivered->get_delivered_items($doc_id)->result() as $row)
		{
         $mprice = 0;
         if(isset($row->mode_price) and $row->mode_price) {$mprice=$row->mode_price;}
			$Qty = explode(',',$row->item_name);
			$this->add_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$mprice,
					$row->item_discount,
					$Qty );
		}
			$consignee_id = 0;
			$bisoft_id = $this->CI->Delivered->get_consignee($doc_id);

				if ($bisoft_id > 0)  // когато не е бил избран КОНСИГНАТОР Е ГРЕШКА ?!!?!?! 
				{
					$consignee_id = $this->CI->Consignee->get_info_by_bisoft_id($bisoft_id)->bisoft_id;
					$this->set_consignee($consignee_id);
				}

		$mode = $this->CI->Delivered->get_mode($doc_id);
		$this->set_mode($mode);
	}	


	function delete_item($line)
	{

	}

	
	function get_customer_discount()
	{
		$customer_id = $this->get_customer();
		$customer_discount = $this->CI->Customer->get_info($customer_id)->discount;
		if ($customer_discount == '') { return 0;}
	return $customer_discount;
	}


	function get_taxes()
	{
		$taxes = array();
		$cart  = $this->get_cart();

		if($cart)
		{
			$customer_id = $this->get_customer();
			$customer = $this->CI->Customer->get_info($customer_id);

			if (!$customer->taxable and $customer_id!=-1) { return $taxes;}
		}
	return $taxes;
	}

	
/*	=========================== THREE 4 TWO =========================== */	
	function get_three4two_discount($mode)
	{  
      // разрешава на ВСИЧКИ Магазини без Красьо да играят 3 за 2.
      $allow_three4two = $this->CI->OnLine->allow_three4two();
      if(!$this->CI->OnLine->get_three4two() or !$allow_three4two) {return 0;}
      
      $location_lock = 0;
      $location = $this->CI->BiSOFT_Model->get_location();

      if($location>0 and $location<11 and $location!=7) {$location_lock = 1;} // само без Красьо=7 ?!
      
      $min_suma = 0;
      $cart = $this->get_cart();
		if ($location_lock and count($cart)>2)
			{
            $new_min_suma = 0;
            foreach($cart as $item)
				{  // find MINIMUM
               $price = round((100-$item['dsc'])*$item['price']/100,7);
               if(($new_min_suma==0) or ($new_min_suma >= $price)) 
                  {$new_min_suma = $price;}
            }
            $min_suma = -abs($new_min_suma);
         }
         
	return $min_suma;
	}
	
	
/*	=========================== BLACK FRIDAY =========================== */
	function get_bFriday()
	{
      return $this->CI->OnLine->get_black_friday();
	}
	
	function get_bFriday_price($inum)
	{
      return $this->CI->OnLine->get_black_price($inum);
	}
	
	function get_bFriday_discount($inum)
	{  
      $location = $this->CI->BiSOFT_Model->get_location();
      $bFriday_pro = $this->CI->OnLine->get_text('black_friday_procent');
      if($inum and $this->CI->OnLine->get_black_friday()) 
         {
            $price_2 = $this->CI->OnLine->get_price_2($inum);
            $price_3 = $this->CI->OnLine->get_price_3($inum);
            $item_online = $this->CI->OnLine->get_online_item($inum);
            if($item_online)
            {
               $black_price = $item_online->black_price;
               if($black_price > 0) 
                  { $bFriday_pro = 100*round(($price_2-$black_price)/$price_2,8);}
            }
         }

   return $bFriday_pro;
	}

	
/*	=========================== TOTALS =========================== */
	function get_subtotal($mode)
	{
		$subtotal = 0;
		$cart = $this->get_cart();

		if($cart)
		{
			foreach($cart as $item)
				{ 
					$dsc = (100-(int)$item['dsc']);
					$subtotal += $item['qty'] * round( $item['price'] * $dsc / 100, 8); 
				}

			if ( $mode=='sale_return' or $mode=='shop_return' or $mode=='online_return') //тук се вкарат само върната стока
				{ $subtotal = -abs($subtotal);}

			$giftcard  = $this->get_giftcard();
			$giftvalue = $this->get_giftvalue();
			if( is_numeric($giftvalue) and $giftvalue>0 and $giftvalue<1) 
				{ $subtotal -= $giftvalue * $subtotal;}
			elseif( is_numeric($giftvalue) and $giftvalue>=1 and $giftvalue<200)
				{	
					if( $subtotal > $giftvalue )
					{ $subtotal -= $giftvalue; }
					else
					{ $subtotal = 0; }
				}
			$subtotal += $this->get_three4two_discount();
		}

	return $subtotal;
	}

	// само за магазини
	function get_real_subtotal($mode)
	{
		$subtotal = 0;
		$cart = $this->get_cart();

		if($cart)
		{
			foreach($cart as $item)
			{
				$subtotal += $item['qty'] * $item['price'];
			}
			if ( $mode=='sale_return' or $mode=='shop_return' or $mode=='online_return') //тук се вкарат само върната стока
				{ $subtotal = -abs($subtotal);}
				
			$subtotal += $this->get_three4two_discount();
		}

	return round($subtotal,8);
	}
	
	
	function get_tax_VAT($mode, $taxed)
	{
		$subtotal = $this->get_subtotal($mode);
		// добавяме ДДС-то ....
		$tax_VAT	= 0;

		if($mode == 'online_sale' or $taxed)
			{ $tax_VAT = round( 20 * $subtotal / 100, 8);}
			
		if($mode == 'online_return') {$tax_VAT = -abs($tax_VAT);}

		if ( $taxed == 0 ) { $tax_VAT	= 0;}

	return round($tax_VAT,8);
	}

	
	function get_total($mode,$customer_discount,$taxed)
	{
		$subtotal = $this->get_subtotal($mode);

		if ($mode == 'online_sale' or $mode == 'online_return') { $total = $subtotal;$taxed=1;}	
		else { $total = round( $subtotal * ( 100 - $customer_discount ) / 100, 8);}

		// добавяме таксите +
		foreach($this->get_taxes() as $tax) {$total+=$tax;}

		// добавяме ДДС-то +
		$total += round($this->get_tax_VAT($mode,$taxed),8);
	return $total;
	}

	function get_all_qty()
	{ 
		$mode = $this->get_mode();
		return $this->CI->BiSOFT_Model->zebex_all_qty($mode);
	}
	
	function count_cart()
	{ 	
		$mode = $this->get_mode();
		$all_items = $this->CI->BiSOFT_Model->zebex_all_qty($mode);
		if($all_items) { return (int)$all_items;}
		else { return 0;}
	}

	
} ?>
