<?php
class Shop_lib
{
	var $CI;

  	function __construct()
	{ $this->CI =& get_instance();}

	
	// Cart
	function get_cart()
	{
		if(!$this->CI->session->userdata('shop_cart'))
			$this->set_cart(array());

	return $this->CI->session->userdata('shop_cart');
	}

	function set_cart($cart_data)
	{
		$this->CI->session->set_userdata('shop_cart',$cart_data);
	}

	function empty_cart()
	{  $this->CI->session->unset_userdata('shop_cart');}
	
	
// -------------------------- MODES ---------------------------------- //
	function get_mode()
	{
      if(!$this->CI->session->userdata('shop_mode'))
			 $this->set_mode('shop_sale');

	return $this->CI->session->userdata('shop_mode');
	}

	function set_mode($mode)
	{ $this->CI->session->set_userdata('shop_mode', $mode);}

	function clear_mode()
	{ $this->CI->session->unset_userdata('shop_mode');}
	
	
// -------------------------- CATEGORIES ---------------------------------- //
	function get_category()
	{
      if(!$this->CI->session->userdata('shop_category'))
			 { $this->set_category(0);}

	return $this->CI->session->userdata('shop_category');
	}

	function set_category($category)
	{ $this->CI->session->set_userdata('shop_category', $category);}

	function clear_category()
	{ $this->CI->session->unset_userdata('shop_category');}
	
// -------- Multiple Payments ----------------------------------------

	// Multiple Payments
	function get_payments()
	{
		if( !$this->CI->session->userdata( 'shop_pays' ) )
			$this->set_payments( array( ) );

	return $this->CI->session->userdata('shop_pays');
	}


	function set_payments($payments_data)
	{
		$this->CI->session->set_userdata('shop_pays',$payments_data);
	}
	
	function add_payment( $payment_id, $payment_amount )
	{
		$payments = $this->get_payments();
		$payment = array( $payment_id=>
		array(
			'payment_type' => $payment_id,
			'payment_amount' => $payment_amount
			)
		);

		//payment_method already exists, add to payment_amount
		if( isset( $payments[$payment_id] ) )
		{
			$payments[$payment_id]['payment_amount'] += $payment_amount;
		}
		else
		{
			//add to existing array
			$payments += $payment;
		}

		$this->set_payments( $payments );
	return true;
	}


	function edit_payment($payment_id,$payment_amount)
	{
		$payments = $this->get_payments();
		if(isset($payments[$payment_id]))
		{
			$payments[$payment_id]['payment_type'] = $payment_id;
			$payments[$payment_id]['payment_amount'] = $payment_amount;
			$this->set_payments($payment_id);
		}
	return false;
	}

	function delete_payment( $payment_id )
	{
		$payments = $this->get_payments();
		unset( $payments[urldecode( $payment_id )] );
		$this->set_payments( $payments );
	}


	function empty_payments()
	{ $this->CI->session->unset_userdata('shop_pays');}


	function get_payments_total()
	{
		$subtotal=0;
		foreach($this->get_payments() as $payments)
			{ $subtotal += $payments['payment_amount'];}

	return to_currency_no_money($subtotal);
	}


	function get_amount_due($mode,$taxed)
	{
		$customer_discount = $this->get_customer_discount();
		$amount_due=0;
		if(!isset($taxed)) { $taxed = 0; }
		$payment_total = round($this->get_payments_total(),2);
		$sales_total   = round($this->get_total($mode,$customer_discount,$taxed),2);
	
		$amount_due = to_currency_no_money ( $sales_total - $payment_total );

	return $amount_due;
	}
// -------- end of Payments ---------------- //



	// ------------------------------------- DATE KEY---------------------------------- //
	function get_dateKey() 
	{
		if	(!$this->CI->session->userdata('shop_dateKey'))
			{ $this->set_dateKey(false);}
	return $this->CI->session->userdata('shop_dateKey');
	}

	function set_dateKey($key) 
	{ $this->CI->session->set_userdata('shop_dateKey',$key);}

	function clear_dateKey() 	
	{ $this->CI->session->unset_userdata('shop_dateKey');}

	// ------------------------------------- DATE ---------------------------------- //
	function get_date() 
	{
		if	(!$this->CI->session->userdata('shop_date'))
			{ $this->set_date(date('Y-m-d'));}
	return $this->CI->session->userdata('shop_date');
	}

	function set_date($date) 
	{ $this->CI->session->set_userdata('shop_date',$date);}
	

	function clear_date() 	
	{ $this->CI->session->unset_userdata('shop_dateKey');
     $this->CI->session->unset_userdata('shop_date'); }


// ------------------------------ Prices ----------------------------- //
	function get_mode_price()
	{	
		$location = $this->CI->Employee->get_client_location();
		if	(!$this->CI->session->userdata('shop_price'))
			{ $this->set_mode_price(99);}
	return $this->CI->session->userdata('shop_price');
	}

	function set_mode_price($mode_price)
	{ $this->CI->session->set_userdata('shop_price',$mode_price);}

	function clear_mode_price()
	{  $this->CI->session->unset_userdata('shop_price');}
	
	
	
// ------------------------------ Valuta ----------------------------- //
	function get_mode_valuta($curr)
	{
		if	(!$this->CI->session->userdata('shop_valuta'))
			{ $this->set_mode_valuta($curr);}

	return $this->CI->session->userdata('shop_valuta');
	}

	function set_mode_valuta($mode_valuta)
	{ $this->CI->session->set_userdata('shop_valuta',$mode_valuta);}

	
// ------------------------------ Type Payment ----------------------------- //
	function get_mode_payment()
	{
		if	(!$this->CI->session->userdata('shop_payment'))
			{ $this->set_mode_payment($this->CI->lang->line('sales_cash'));}
	return $this->CI->session->userdata('shop_payment');
	}

	function set_mode_payment($type_payment)
	{ $this->CI->session->set_userdata('shop_payment',$type_payment);}


// ------------------------------ Printons ----------------------------- //
	function get_mode_print()
	{
		if(!$this->CI->session->userdata('shop_prn'))
			$this->set_mode_print('prices');
	return $this->CI->session->userdata('shop_prn');
	}

	function set_mode_print($mode_print)
	{ $this->CI->session->set_userdata('shop_prn',$mode_print);}
	

	function clear_mode_print()
	{ 	$this->CI->session->unset_userdata('shop_prn');}

	
	function clear_all()
	{
		$this->clear_mode();
		$this->clear_category();
		$this->clear_date();$this->clear_dateKey();
		$this->empty_cart();
		$this->empty_payments();
		$this->clear_mode_price();
		$this->clear_mode_print();
	}
	
	

	function add_item( $inum, $quantity, $price, $discount, $Qty )
	{
		$location = $skl = $this->CI->Employee->get_client_location();
		$mode = $this->get_mode();
		$error_key = 0; $sizes = $this->CI->Shop->get_sizes($inum);
		$item_info = $this->CI->Shop->get_blanka_info($inum);
		$skl_info=$this->CI->Shop->get_shop_info($inum,$skl);
		$skl_gp_info=$this->CI->Shop->get_sklad_info($inum,0);
				
		if(!$item_info or !$skl_info or !$skl_gp_info) {return false;}
		
			$allow_sizes = $item_info->allow_sizes;
			if($allow_sizes=='105') {$allow_sizes=0;}
			$name = $item_info->name;
			
		$commision_key = $comis_price = 0;	
		if(!count($Qty)) {$Qty[1]=$Qty[2]=$Qty[3]=$Qty[4]=$Qty[5]=$Qty[6]=$Qty[7]=$Qty[8]=$Qty[9]=$Qty[10]=0;}		

		
		if(!$skl_info) {return false;} // НЯМА АРТИКУЛА В СКЛАД $skl ?!
	
		// променя отстъпката на заложената ?!
		if($discount==0) {$discount = $skl_info->dsc;}

		$item_id = $skl_info->item_id;

		$items = $this->get_cart();
			$maxkey=$insertkey=$updatekey=0;
			$itemalreadyinsale=FALSE;

		foreach ($items as $item)
		{
			if($maxkey <= $item['line']) { $maxkey = $item['line'];}

			if($item['inum']==$inum)
			{
				$itemalreadyinsale=TRUE;
				$updatekey=$item['line'];
			}
		}

		$insertkey=$maxkey+1;

		$mode_price = 2; // $this->get_mode_price();
		$item_price = to_dot($skl_gp_info->price_2);
	
		if ( $allow_sizes ) 
			{
				if($Qty[1]==0) {$Qty[1]='';} if($Qty[2]==0) {$Qty[2]='';} 
				if($Qty[3]==0) {$Qty[3]='';} if($Qty[4]==0) {$Qty[4]='';} 
				if($Qty[5]==0) {$Qty[5]='';} if($Qty[6]==0) {$Qty[6]='';} 
				if($Qty[7]==0) {$Qty[7]='';} if($Qty[8]==0) {$Qty[8]='';}
				if($Qty[9]==0) {$Qty[9]='';} if($Qty[10]==0) {$Qty[10]='';} 
				
				$item = array(($insertkey)=>
								array(
									'line' => $insertkey,
									'id'	 => $item_id,
									'inum' => $inum,
									'skl'	 => $skl,
									'qty'	 => $quantity,
                           'q1'=>$Qty[1],'q2'=>$Qty[2],'q3'=>$Qty[3],'q4'=>$Qty[4],'q5'=>$Qty[6],
                           'q6'=>$Qty[6],'q7'=>$Qty[7],'q8'=>$Qty[8],'q9'=>$Qty[9],'q10'=>$Qty[10],
									'dsc'	 => $discount,
								 'mprice' => $mode_price,
								  'price' => ($price!=null) ? $price : $item_price )
										);
								
				//Item already exists
				if($itemalreadyinsale)
					{
						$items[$updatekey]['qty'] += $quantity;
                     $items[$updatekey]['q1'] += $Qty[1];
                     $items[$updatekey]['q2'] += $Qty[2];
                     $items[$updatekey]['q3'] += $Qty[3];
                     $items[$updatekey]['q4'] += $Qty[4];
                     $items[$updatekey]['q5'] += $Qty[5];
                     $items[$updatekey]['q6'] += $Qty[6];
                     $items[$updatekey]['q7'] += $Qty[7];
                     $items[$updatekey]['q8'] += $Qty[8];
                     $items[$updatekey]['q9'] += $Qty[9];
                     $items[$updatekey]['q10'] += $Qty[10];
					}
				else //add to existing array
					{ $items += $item; }
			}
		else // безразмерни
			{
				if (!$quantity) { $quantity=1;} // за безразмерни qty=1
				$item = array(($insertkey)=>
								array(
									'line' => $insertkey,
									'id'	 => $item_id,
									'inum' => $inum,
									'skl'	 => $skl,
									'qty'	 => $quantity,
                           'q1'=>'','q2'=>'','q3'=>'','q4'=>'','q5'=>'',
                           'q6'=>'','q7'=>'','q8'=>'','q9'=>'','q10'=>'',
									'dsc'  => $discount,
								 'mprice' => $mode_price,
								  'price' => ($price!=null) ? $price : $item_price )
										);
				//Item already exists
				if($itemalreadyinsale)
					{ $items[$updatekey]['qty']++;}  // добавя безразмерни кол-ва.
				else //add to existing array
					{ $items += $item; }
			} // $allow_sizes
		
		$this->set_cart($items);
		
	return 'OK';
	}
	
	function out_of_stock($item_id)
	{	if(!$item_id) { return false;}
		$skl_info = $this->CI->Item->get_shop_idx($item_id);
		$qty = $skl_info->qty;
		$qty_added = $this->get_qty_already_added($item_id);
		if ($qty-$qty_added<0) {return true;}
		else {return false;}
	}

	function get_qty_already_added($item_id)
	{	$items = $this->get_cart();
		$qty_already_added = 0;
		foreach ($items as $item)
			{ if($item['id']==$item_id) { $qty_already_added+=$item['qty'];} }
	return $qty_already_added;
	}

	function get_item_id($line_to_get)
	{	$items = $this->get_cart();
		foreach ($items as $line=>$item)
			{ if($line==$line_to_get) {return $item['id'];} }
	return -1;
	}

	function get_item_inum($line_to_get)
	{	$items = $this->get_cart();
		foreach ($items as $line=>$item)
			{ if($line==$line_to_get) {return $item['inum'];} }
	return -1;
	}
	
	function get_cart_item($line_to_get)
	{	$items = $this->get_cart();
		foreach ($items as $line=>$item)
			{ if($line==$line_to_get) {return $item;} }
	return -1;
	}

	
	function edit_item( $line, $quantity, $allow_sizes, $price, $mprice, $discount,
							  $q1,$q2,$q3,$q4,$q5,$q6,$q7,$q8,$q9,$q10)
	{
		$items = $this->get_cart();
		if(isset($items[$line]))
		{
			if(!$q1){$q1='';} if(!$q2){$q2='';} if(!$q3){$q3='';} if(!$q4){$q4='';} if(!$q5){$q5='';}
			if(!$q6){$q6='';} if(!$q7){$q7='';} if(!$q8){$q8='';} if(!$q9){$q9='';} if(!$q10){$q10='';}
			$items[$line]['dsc']    = $discount;
			$items[$line]['price']  = $price;
			$items[$line]['mprice'] = $mprice;
			if($allow_sizes)
			{  $items[$line]['qty'] = $quantity;
            $items[$line]['q1'] = $q1;$items[$line]['q2'] = $q2;
            $items[$line]['q3'] = $q3;$items[$line]['q4'] = $q4;
            $items[$line]['q5'] = $q5;$items[$line]['q6'] = $q6;
            $items[$line]['q7'] = $q7;$items[$line]['q8'] = $q8;
            $items[$line]['q9'] = $q9;$items[$line]['q10'] = $q10;										  
         }
			else
			{ $items[$line]['qty'] = $quantity;}
		$this->set_cart($items);
		}
	return false;
	}
	
	function get_cart_item_info( $line )
	{
		$items = $this->get_cart();$item=array();
		if(isset($items[$line]))
			{ $item = $items[$line];}
		else {return -1;}
	return $item;
	}


// my stuff  ------------------------------- BarCode  ------------------------------------- //
	function is_valid_item_number($barcode_item) 
	{
	   $lenBarcode=strlen($barcode_item);
	   if ($lenBarcode<4 or $lenBarcode>7) {return false;}
	   else {return true;}
	}

// ------------------------------------------ BARCODES -------------------------------- //
	function is_valid_barcode($barcode_item)
	{
		$lenBarcode = strlen($barcode_item);
		if ($lenBarcode<8) {return false;}
		if ($lenBarcode>8 and $lenBarcode < 12) {return false;}
		if ($lenBarcode>13) {return false;}
		if (is_numeric(!$barcode_item)) {return false;}
		else {return true;}
	}

	function add_item_barcode($barcode_item,$quantity)
	{  //barCode
		$lenBarcode=strlen($barcode_item);
		$item_number=0;
		$barcode=substr($barcode_item,0,-1);

		$qty=array();$qty[0]=1;
		$qty[1]=$qty[2]=$qty[3]=$qty[4]=$qty[5]=$qty[6]=$qty[7]=$qty[8]=$qty[9]=$qty[10]=0;

		// EAN-8 Code table - checks 5-7 digit item numbers
		if ($lenBarcode == 8 ) { $item_number = (int) $barcode; }

		// EAN-13 Code table
		if ($lenBarcode == 13 ) 
			{
			// checks 380 = Bulgaria Code table
			   $barcode_380 = substr($barcode_item,0,3);
				if ($barcode_380 == '380') { $item_number = (int) substr($barcode_item,-6,-1); }
		   	else { // else 380
			// Normal 13 bit code
			$barcode = substr($barcode_item,1,-1);
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 11) { $qty[$size_qty] = $quantity;}
			else 
				{ 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[10] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
				}
			} // end of else 380
		}

		// BiSOFT internal Code table 12 (-leading 0)
		if ($lenBarcode == 12 ) 
		{
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 11) { $qty[$size_qty] = $quantity;}
			else { 
				// различните размерни групи .....
				if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
				if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
				if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
				if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

				if ($size_qty > 10 and $size_qty < 100) 
				   {$size_qty = floor($size_qty/2) - $sizeQty;}

				if ($size_qty > 9) { $qty[10] = $quantity; }
				elseif ($size_qty == 0) { }
				else { $qty[$size_qty] = $quantity; }
			     }
		}

		$this->add_item($item_number, $quantity, 0, 0, $qty );

	return true;
	}


	function copy_entire_sale($doc_id,$vedomPack)
	{
		$this->empty_cart();
		$this->clear_mode_price();
		$this->remove_customer();

		foreach($this->CI->Shop->get_sale_items($doc_id,$vedomPack)->result() as $row)
		{
			$Qty = explode(',',$row->item_name);
			$this->add_item(
					$row->item_number,
					$row->item_qty,
					$row->item_unit_price,
					$row->item_discount,
					$Qty );
		}

		foreach($this->CI->Shop->get_sale_payments($doc_id,$vedomPack)->result() as $row)
			{ $this->add_payment($row->pay_type,$row->pay_amount); }

      $this->set_customer(0);
	}



	function delete_item($line)
	{
		$items=$this->get_cart();
		unset($items[$line]);
		$this->set_cart($items);
	}

	
	function get_customer_discount()
	{
		$customer_discount = 0;
	return $customer_discount;
	}


	function get_taxes()
	{
		$taxes = array();
		return $taxes;
		die();
		
		
		foreach($this->get_cart() as $line=>$item)
		{
			$tax_info = $this->CI->Item_taxes->get_info($item['id']);
			foreach($tax_info as $tax)
			{
				$name = $tax['percent'].'% ' . $tax['name'];
				$tax_amount=round(($item['price']*$item['qty']-$item['price']*$item['qty']*$item['dsc']/100)*(($tax['percent'])/100),4);
				if (!isset($taxes[$name])) { $taxes[$name] = 0;}
				$taxes[$name] += $tax_amount;
			}
		}
	return $taxes;
	}


	function get_subtotal($mode)
	{
		$mode_price = 99; // $item['mprice'];
		$subtotal = 0;
		foreach($this->get_cart() as $item)
		{
			$item_info = $this->CI->Item->get_sklad_idx($item['id']);
			switch ($mode_price) 
				{
					case '99': $item_price = $item['price'];		break;
					case '1': $item_price = $item_info->price;   break;
					case '2': $item_price = $item_info->price_2; break;
					case '3': $item_price = $item_info->price_3; break;
					case '4': $item_price = $item_info->price_4; break;
					case '5': $item_price = $item_info->price_5; break;
					default:  $item_price = $item['price'];
				}

			$subtotal += $item['qty'] * round( $item_price * (100 - $item['dsc']) / 100, 4);
		}
		if ( $mode == 'shop_return' ) //тук се вкарат само върната стока
			{ $subtotal = -abs($subtotal);}
			
	return $subtotal;
	}

	// само за магазини
	function get_real_subtotal($mode)
	{
		$mode_price = 99; // $item['mprice'];
		$subtotal = 0;
		foreach($this->get_cart() as $item)
		{
			$item_info = $this->CI->Item->get_sklad_idx($item['id']);
			switch ($mode_price) 
				{
					case '99': $item_price = $item['price'];		break;
					case '1': $item_price = $item_info->price;   break;
					case '2': $item_price = $item_info->price_2; break;
					case '3': $item_price = $item_info->price_3; break;
					case '4': $item_price = $item_info->price_4; break;
					case '5': $item_price = $item_info->price_5; break;
					default:  $item_price = $item['price'];
				}

			$subtotal += $item['qty'] * $item_price;
		}
		if ( $mode == 'shop_return' ) //тук се вкарат само върната стока
			{ $subtotal = -abs($subtotal);}
			
	return $subtotal;
	}
	

	function get_tax_VAT($mode, $taxed)
	{
		$subtotal = $this->get_subtotal();
		// добавяме ДДС-то ....
		$tax_VAT	= 0;

		if ( $mode == 'online_sale' )
			{ $tax_VAT = round( 20 * $subtotal / 100, 4);}

		if ( !isset($taxed) or $taxed == 0 ) { $tax_VAT	= 0;}

	return round($tax_VAT,2);
	}

	
	function get_total($mode,$customer_discount,$taxed)
	{
		$subtotal = $this->get_subtotal();

		if ($mode == 'online_sale') { $total = $subtotal;}	
		else { $total = round( $subtotal * ( 100 - $customer_discount ) / 100, 4);}

		// добавяме таксите +
		foreach($this->get_taxes() as $tax) {$total+=$tax;}

		// добавяме ДДС-то +
		$total += round($this->get_tax_VAT($mode,$taxed),2);
	return $total;
	}

	function get_all_qty()
	{	$all_qty=0;
		foreach($this->get_cart() as $item) { $all_qty += $item['qty']; }
	return $all_qty;
	}
	
	function count_cart()
	{ return count($this->get_cart());}

	
} ?>
