<?php

class Trz_lib
{
	var $CI;
  	function __construct()
	{
		$this->CI =& get_instance();
	}

// ------------------------------------- MODE ---------------------------------- //
	function get_mode() 
	{
		if	(!$this->CI->session->userdata('trz_mode'))
			{ $this->set_mode('main');}
	return $this->CI->session->userdata('trz_mode');
	}

	function set_mode($mode) 
	{ $this->CI->session->set_userdata('trz_mode', $mode);}
	
	function clear_mode()
	{ $this->CI->session->unset_userdata('trz_mode');}
	
	
/* ======================== Multiple FIRMAS ============================ */
	function get_firma()
	{
		if( !$this->CI->session->userdata( 'trz_firma' ) )
		{ $this->set_firma(1);}
	return $this->CI->session->userdata('trz_firma');
	}

	function set_firma($firma_id)
	{ $this->CI->session->set_userdata('trz_firma',$firma_id);}
	
	function clear_firma()
	{ $this->CI->session->unset_userdata('trz_firma');}
	
		
// ------------------------------------- NORMA ---------------------------------- //
	function get_norma() 
	{
		if	(!$this->CI->session->userdata('trz_norma'))
			{ $this->set_norma('all');}
	return $this->CI->session->userdata('trz_norma');
	}

	function set_norma($norma) 
	{ $this->CI->session->set_userdata('trz_norma', $norma);}	
	
	function clear_norma()
	{ $this->CI->session->unset_userdata('trz_norma');}
	
	
	
	function clear_all()
	{
		$this->clear_mode();
		$this->clear_firma();
		$this->clear_norma();
		$this->clear_dateKey();
	}
	
	// ------------------------------------- DATE KEY---------------------------------- //
	function get_dateKey() 
	{
		if	(!$this->CI->session->userdata('date_key')) { return false;}
	return true;
	}

	function set_dateKey() 
	{ $this->CI->session->set_userdata('date_key', 1);}

	function clear_dateKey() 	
	{ $this->CI->session->unset_userdata('date_key'); }
	
	// таблицата, която изчислява всичко в TRZ dock-a
	function calculate_totals($selected_workers,$period) 
	{
		$vedom = 'T'.$period;
		$total_hours=$total_worked=$total_avance=$total_taxes=$total_sum=0;
		$error = 0;
		
		foreach($selected_workers as $worker)
		{
			$all_Month = $this->CI->TRZ->get_info_trz($worker['bisoft_id'],$vedom,$period);
			if($all_Month and isset($all_Month->TM) and $all_Month->TM)
			{
				$trz_data = json_decode($all_Month->TM);
				if($trz_data)
				{	// сметалка:
				  if(!isset($trz_data->job_time) or !is_numeric($trz_data->job_time)) {$trz_data->job_time = 8;}
				  if(!isset($trz_data->addHours) or !is_numeric($trz_data->addHours)) {$trz_data->addHours = 0;}			  
				  if(!isset($trz_data->trz_days) or !is_numeric($trz_data->trz_days)) {$trz_data->trz_days = 0;}
				  if(!isset($trz_data->trz_worked) or !is_numeric($trz_data->trz_worked)) {$trz_data->trz_worked = 0;}
				  if(!isset($trz_data->onHourSum) or !is_numeric($trz_data->onHourSum)) {$trz_data->onHourSum = 0;}
				  if(!isset($trz_data->addHourSum) or !is_numeric($trz_data->addHourSum)) {$trz_data->addHourSum = 0;}
				  if(!isset($trz_data->salary) or !is_numeric($trz_data->salary)) {$trz_data->salary = 0;}
				  if(!isset($trz_data->avance) or !is_numeric($trz_data->avance)) {$trz_data->avance = 0;}
				  if(!isset($trz_data->trz_taxes) or !is_numeric($trz_data->trz_taxes)) {$trz_data->trz_taxes = 0;}
				  
				// заради Вили Стил ?!  
				//	$total_hours += (isset($trz_data->trz_days)) ? ($trz_data->job_time * $trz_data->trz_days) + $trz_data->addHours : 0;
				
					$total_hours += ($trz_data->trz_days>0) ? ($trz_data->job_time * $trz_data->trz_days) + $trz_data->addHours : 0;
					$total_worked += (isset($trz_data->trz_worked) && isset($trz_data->addHourSum) && isset($trz_data->onHourSum)) ? 
											$trz_data->trz_worked + $trz_data->addHourSum + $trz_data->onHourSum : 0;
					$total_avance += (isset($trz_data->avance)) ? $trz_data->avance : 0;
					$total_taxes += (isset($trz_data->trz_taxes)) ? $trz_data->trz_taxes : 0;
					$total_sum += (isset($trz_data->salary)) ? $trz_data->salary : 0;
				}
			}
			else // if error ?
			{
			/*
				echo 'ERROR: id='.$worker['bisoft_id'];
				echo '<br>';
				print_r($all_Month);
				$error = 1;
				die();
			*/
			}
		}
		
		// if($error) {die();}
	
		$totals=array(
			'total_hours'	=> $total_hours,
			'total_worked'	=> $total_worked,
			'total_avance'	=> $total_avance,
			'total_taxes'	=> $total_taxes,
			'total_sum'		=> $total_sum	);
	
	return $totals;
	}
	
	
	function get_presence($period_data)
	{
		$day_1=json_decode($period_data->day_1);$day_2=json_decode($period_data->day_2);$day_3=json_decode($period_data->day_3);
		$day_4=json_decode($period_data->day_4);$day_5=json_decode($period_data->day_5);$day_6=json_decode($period_data->day_6);
		$day_7=json_decode($period_data->day_7);$day_8=json_decode($period_data->day_8);$day_9=json_decode($period_data->day_9);
		$day_10=json_decode($period_data->day_10);$day_11=json_decode($period_data->day_11);$day_12=json_decode($period_data->day_12);
		$day_13=json_decode($period_data->day_13);$day_14=json_decode($period_data->day_14);$day_15=json_decode($period_data->day_15);
		$day_16=json_decode($period_data->day_16);$day_17=json_decode($period_data->day_17);$day_18=json_decode($period_data->day_18);
		$day_19=json_decode($period_data->day_19);$day_20=json_decode($period_data->day_20);$day_21=json_decode($period_data->day_21);
		$day_22=json_decode($period_data->day_22);$day_23=json_decode($period_data->day_23);$day_24=json_decode($period_data->day_24);
		$day_25=json_decode($period_data->day_25);$day_26=json_decode($period_data->day_26);$day_27=json_decode($period_data->day_27);
		$day_28=json_decode($period_data->day_28);$day_29=json_decode($period_data->day_29);$day_30=json_decode($period_data->day_30);
		$day_31=json_decode($period_data->day_31);

		$presence=array(
					'1' => $day_1->P,   '2' => $day_2->P,   '3' => $day_3->P,
					'4' => $day_4->P,   '5' => $day_5->P,   '6' => $day_6->P,
					'7' => $day_7->P,	  '8' => $day_8->P,   '9' => $day_9->P,
				  '10' => $day_10->P, '11' => $day_11->P, '12' => $day_12->P,
				  '13' => $day_13->P, '14' => $day_14->P, '15' => $day_15->P,
				  '16' => $day_16->P, '17' => $day_17->P, '18' => $day_18->P,
				  '19' => $day_19->P, '20' => $day_20->P, '21' => $day_21->P,
				  '22' => $day_22->P, '23' => $day_23->P, '24' => $day_24->P,
				  '25' => $day_25->P, '26' => $day_26->P, '27' => $day_27->P,
				  '28' => $day_28->P, '29' => $day_29->P, '30' => $day_30->P,
				  '31' => $day_31->P  );

	return $presence;
	}


	function set_presence($period_data,$p_mins)
	{
		$days=array();
		$day_1=json_decode($period_data->day_1);$t_day_1=$day_1->T;$hb_day_1=$day_1->HB;$mk_day_1=$day_1->MK;$tm_day_1=$day_1->TM;
				$day_1=array('P'=>$p_mins['1'],'HB'=>$hb_day_1,'T'=>$t_day_1,'MK'=>$mk_day_1,'TM'=>$tm_day_1);
		$day_2=json_decode($period_data->day_2);$t_day_2=$day_2->T;$hb_day_2=$day_2->HB;$mk_day_2=$day_2->MK;$tm_day_2=$day_2->TM;
				$day_2=array('P'=>$p_mins['2'],'HB'=>$hb_day_2,'T'=>$t_day_2,'MK'=>$mk_day_2,'TM'=>$tm_day_2);
		$day_3=json_decode($period_data->day_3);$t_day_3=$day_3->T;$hb_day_3=$day_3->HB;$mk_day_3=$day_3->MK;$tm_day_3=$day_3->TM;
				$day_3=array('P'=>$p_mins['3'],'HB'=>$hb_day_3,'T'=>$t_day_3,'MK'=>$mk_day_3,'TM'=>$tm_day_3);
		$day_4=json_decode($period_data->day_4);$t_day_4=$day_4->T;$hb_day_4=$day_4->HB;$mk_day_4=$day_4->MK;$tm_day_4=$day_4->TM;
				$day_4=array('P'=>$p_mins['4'],'HB'=>$hb_day_4,'T'=>$t_day_4,'MK'=>$mk_day_4,'TM'=>$tm_day_4);
		$day_5=json_decode($period_data->day_5);$t_day_5=$day_5->T;$hb_day_5=$day_5->HB;$mk_day_5=$day_5->MK;$tm_day_5=$day_5->TM;
				$day_5=array('P'=>$p_mins['5'],'HB'=>$hb_day_5,'T'=>$t_day_5,'MK'=>$mk_day_5,'TM'=>$tm_day_5);
		$day_6=json_decode($period_data->day_6);$t_day_6=$day_6->T;$hb_day_6=$day_6->HB;$mk_day_6=$day_6->MK;$tm_day_6=$day_6->TM;
				$day_6=array('P'=>$p_mins['6'],'HB'=>$hb_day_6,'T'=>$t_day_6,'MK'=>$mk_day_6,'TM'=>$tm_day_6);
		$day_7=json_decode($period_data->day_7);$t_day_7=$day_7->T;$hb_day_7=$day_7->HB;$mk_day_7=$day_7->MK;$tm_day_7=$day_7->TM;
				$day_7=array('P'=>$p_mins['7'],'HB'=>$hb_day_7,'T'=>$t_day_7,'MK'=>$mk_day_7,'TM'=>$tm_day_7);
		$day_8=json_decode($period_data->day_8);$t_day_8=$day_8->T;$hb_day_8=$day_8->HB;$mk_day_8=$day_8->MK;$tm_day_8=$day_8->TM;
				$day_8=array('P'=>$p_mins['8'],'HB'=>$hb_day_8,'T'=>$t_day_8,'MK'=>$mk_day_8,'TM'=>$tm_day_8);
		$day_9=json_decode($period_data->day_9);$t_day_9=$day_9->T;$hb_day_9=$day_9->HB;$mk_day_9=$day_9->MK;$tm_day_9=$day_9->TM;
				$day_9=array('P'=>$p_mins['9'],'HB'=>$hb_day_9,'T'=>$t_day_9,'MK'=>$mk_day_9,'TM'=>$tm_day_9);
		$day_10=json_decode($period_data->day_10);$t_day_10=$day_10->T;$hb_day_10=$day_10->HB;$mk_day_10=$day_10->MK;$tm_day_10=$day_10->TM;
				$day_10=array('P'=>$p_mins['10'],'HB'=>$hb_day_10,'T'=>$t_day_10,'MK'=>$mk_day_10,'TM'=>$tm_day_10);
		$day_11=json_decode($period_data->day_11);$t_day_11=$day_11->T;$hb_day_11=$day_11->HB;$mk_day_11=$day_11->MK;$tm_day_11=$day_11->TM;
				$day_11=array('P'=>$p_mins['11'],'HB'=>$hb_day_11,'T'=>$t_day_11,'MK'=>$mk_day_11,'TM'=>$tm_day_11);
		$day_12=json_decode($period_data->day_12);$t_day_12=$day_12->T;$hb_day_12=$day_12->HB;$mk_day_12=$day_12->MK;$tm_day_12=$day_12->TM;
				$day_12=array('P'=>$p_mins['12'],'HB'=>$hb_day_12,'T'=>$t_day_12,'MK'=>$mk_day_12,'TM'=>$tm_day_12);
		$day_13=json_decode($period_data->day_13);$t_day_13=$day_13->T;$hb_day_13=$day_13->HB;$mk_day_13=$day_13->MK;$tm_day_13=$day_13->TM;
				$day_13=array('P'=>$p_mins['13'],'HB'=>$hb_day_13,'T'=>$t_day_13,'MK'=>$mk_day_13,'TM'=>$tm_day_13);
		$day_14=json_decode($period_data->day_14);$t_day_14=$day_14->T;$hb_day_14=$day_14->HB;$mk_day_14=$day_14->MK;$tm_day_14=$day_14->TM;
				$day_14=array('P'=>$p_mins['14'],'HB'=>$hb_day_14,'T'=>$t_day_14,'MK'=>$mk_day_14,'TM'=>$tm_day_14);
		$day_15=json_decode($period_data->day_15);$t_day_15=$day_15->T;$hb_day_15=$day_15->HB;$mk_day_15=$day_15->MK;$tm_day_15=$day_15->TM;
				$day_15=array('P'=>$p_mins['15'],'HB'=>$hb_day_15,'T'=>$t_day_15,'MK'=>$mk_day_15,'TM'=>$tm_day_15);
		$day_16=json_decode($period_data->day_16);$t_day_16=$day_16->T;$hb_day_16=$day_16->HB;$mk_day_16=$day_16->MK;$tm_day_16=$day_16->TM;
				$day_16=array('P'=>$p_mins['16'],'HB'=>$hb_day_16,'T'=>$t_day_16,'MK'=>$mk_day_16,'TM'=>$tm_day_16);
		$day_17=json_decode($period_data->day_17);$t_day_17=$day_17->T;$hb_day_17=$day_17->HB;$mk_day_17=$day_17->MK;$tm_day_17=$day_17->TM;
				$day_17=array('P'=>$p_mins['17'],'HB'=>$hb_day_17,'T'=>$t_day_17,'MK'=>$mk_day_17,'TM'=>$tm_day_17);
		$day_18=json_decode($period_data->day_18);$t_day_18=$day_18->T;$hb_day_18=$day_18->HB;$mk_day_18=$day_18->MK;$tm_day_18=$day_18->TM;
				$day_18=array('P'=>$p_mins['18'],'HB'=>$hb_day_18,'T'=>$t_day_18,'MK'=>$mk_day_18,'TM'=>$tm_day_18);
		$day_19=json_decode($period_data->day_19);$t_day_10=$day_19->T;$hb_day_19=$day_19->HB;$mk_day_19=$day_19->MK;$tm_day_19=$day_19->TM;
				$day_19=array('P'=>$p_mins['19'],'HB'=>$hb_day_19,'T'=>$t_day_19,'MK'=>$mk_day_19,'TM'=>$tm_day_19);
		$day_20=json_decode($period_data->day_20);$t_day_20=$day_20->T;$hb_day_20=$day_20->HB;$mk_day_20=$day_20->MK;$tm_day_20=$day_20->TM;
				$day_20=array('P'=>$p_mins['20'],'HB'=>$hb_day_20,'T'=>$t_day_20,'MK'=>$mk_day_20,'TM'=>$tm_day_20);
		$day_21=json_decode($period_data->day_21);$t_day_21=$day_21->T;$hb_day_21=$day_21->HB;$mk_day_21=$day_21->MK;$tm_day_21=$day_21->TM;
				$day_21=array('P'=>$p_mins['21'],'HB'=>$hb_day_21,'T'=>$t_day_21,'MK'=>$mk_day_21,'TM'=>$tm_day_21);
		$day_22=json_decode($period_data->day_22);$t_day_22=$day_22->T;$hb_day_22=$day_22->HB;$mk_day_22=$day_22->MK;$tm_day_22=$day_22->TM;
				$day_22=array('P'=>$p_mins['22'],'HB'=>$hb_day_22,'T'=>$t_day_22,'MK'=>$mk_day_22,'TM'=>$tm_day_22);
		$day_23=json_decode($period_data->day_23);$t_day_23=$day_23->T;$hb_day_23=$day_23->HB;$mk_day_23=$day_23->MK;$tm_day_23=$day_23->TM;
				$day_23=array('P'=>$p_mins['23'],'HB'=>$hb_day_23,'T'=>$t_day_23,'MK'=>$mk_day_23,'TM'=>$tm_day_23);
		$day_24=json_decode($period_data->day_24);$t_day_24=$day_24->T;$hb_day_24=$day_24->HB;$mk_day_24=$day_24->MK;$tm_day_24=$day_24->TM;
				$day_24=array('P'=>$p_mins['24'],'HB'=>$hb_day_24,'T'=>$t_day_24,'MK'=>$mk_day_24,'TM'=>$tm_day_24);
		$day_25=json_decode($period_data->day_25);$t_day_25=$day_25->T;$hb_day_25=$day_25->HB;$mk_day_25=$day_25->MK;$tm_day_25=$day_25->TM;
				$day_25=array('P'=>$p_mins['25'],'HB'=>$hb_day_25,'T'=>$t_day_25,'MK'=>$mk_day_25,'TM'=>$tm_day_25);
		$day_26=json_decode($period_data->day_26);$t_day_26=$day_26->T;$hb_day_26=$day_26->HB;$mk_day_26=$day_26->MK;$tm_day_26=$day_26->TM;
				$day_26=array('P'=>$p_mins['26'],'HB'=>$hb_day_26,'T'=>$t_day_26,'MK'=>$mk_day_26,'TM'=>$tm_day_26);
		$day_27=json_decode($period_data->day_27);$t_day_27=$day_27->T;$hb_day_27=$day_27->HB;$mk_day_27=$day_27->MK;$tm_day_27=$day_27->TM;
				$day_27=array('P'=>$p_mins['27'],'HB'=>$hb_day_27,'T'=>$t_day_27,'MK'=>$mk_day_27,'TM'=>$tm_day_27);
		$day_28=json_decode($period_data->day_28);$t_day_28=$day_28->T;$hb_day_28=$day_28->HB;$mk_day_28=$day_28->MK;$tm_day_28=$day_28->TM;
				$day_28=array('P'=>$p_mins['28'],'HB'=>$hb_day_28,'T'=>$t_day_28,'MK'=>$mk_day_28,'TM'=>$tm_day_28);
		$day_29=json_decode($period_data->day_29);$t_day_29=$day_29->T;$hb_day_29=$day_29->HB;$mk_day_29=$day_29->MK;$tm_day_29=$day_29->TM;
				$day_29=array('P'=>$p_mins['29'],'HB'=>$hb_day_29,'T'=>$t_day_29,'MK'=>$mk_day_29,'TM'=>$tm_day_29);
		$day_30=json_decode($period_data->day_30);$t_day_30=$day_30->T;$hb_day_30=$day_30->HB;$mk_day_30=$day_30->MK;$tm_day_30=$day_30->TM;
				$day_30=array('P'=>$p_mins['30'],'HB'=>$hb_day_30,'T'=>$t_day_30,'MK'=>$mk_day_30,'TM'=>$tm_day_30);
		$day_31=json_decode($period_data->day_31);$t_day_31=$day_31->T;$hb_day_31=$day_31->HB;$mk_day_31=$day_31->MK;$tm_day_31=$day_31->TM;
				$day_31=array('P'=>$p_mins['31'],'HB'=>$hb_day_31,'T'=>$t_day_31,'MK'=>$mk_day_31,'TM'=>$tm_day_31);

		$days=array(
				'1' => json_encode($day_1),
				'2' => json_encode($day_2),
				'3' => json_encode($day_3),
				'4' => json_encode($day_4),
				'5' => json_encode($day_5),
				'6' => json_encode($day_6),
				'7' => json_encode($day_7),
				'8' => json_encode($day_8),
				'9' => json_encode($day_9),
			  '10' => json_encode($day_10),
			  '11' => json_encode($day_11),
			  '12' => json_encode($day_12),
			  '13' => json_encode($day_13),
			  '14' => json_encode($day_14),
			  '15' => json_encode($day_15),
			  '16' => json_encode($day_16),
			  '17' => json_encode($day_17),
			  '18' => json_encode($day_18),
			  '19' => json_encode($day_19),
			  '20' => json_encode($day_20),
			  '21' => json_encode($day_21),
			  '22' => json_encode($day_22),
			  '23' => json_encode($day_23),
			  '24' => json_encode($day_24),
			  '25' => json_encode($day_25),
			  '26' => json_encode($day_26),
			  '27' => json_encode($day_27),
			  '28' => json_encode($day_28),
			  '29' => json_encode($day_29),
			  '30' => json_encode($day_30),
			  '31' => json_encode($day_31)
						);
	return $days;
	}

/* ================================= CALENDAR =================================== */	
	function get_months()
	{
		$months = array(
					'01' => $this->CI->lang->line('common_Jan'),
					'02' => $this->CI->lang->line('common_Feb'),
					'03' => $this->CI->lang->line('common_Mar'),
					'04' => $this->CI->lang->line('common_Apr'),
					'05' => $this->CI->lang->line('common_May'),
					'06' => $this->CI->lang->line('common_Jun'),
					'07' => $this->CI->lang->line('common_Jul'),
					'08' => $this->CI->lang->line('common_Aug'),
					'09' => $this->CI->lang->line('common_Sep'),
					'10' => $this->CI->lang->line('common_Oct'),
					'11' => $this->CI->lang->line('common_Nov'),
					'12' => $this->CI->lang->line('common_Dec') );
	return $months;
	}

}
?>
