<?php class BiSOFT_Model extends CI_Model
{
	function exists($key)
	{
		$this->db->from('bisoft');	
		$this->db->where('bisoft.key',$key);
		$query = $this->db->get();
		return ($query->num_rows()==1);
	}

/*	
	public function isMobile()
	{
		$isMobile = (bool)preg_match('#\b(ip(hone|od|ad)|android|opera m(ob|in)i|windows (phone|ce)|blackberry|tablet'.
                    '|s(ymbian|eries60|amsung)|p(laybook|alm|rofile/midp|laystation portable)|nokia|fennec|htc[\-_]'.
                    '|mobile|up\.browser|[1-4][0-9]{2}x[1-4][0-9]{2})\b#i', $_SERVER['HTTP_USER_AGENT'] );
	return $isMobile;
	}
*/	

	public function isMobile()
	{
      $this->load->library('Bisoft_lib');
      if($this->bisoft_lib->check_mobile())
         {
            $isMobile = $this->bisoft_lib->get_mobile();
            @define('isMobile',$isMobile);
         return $isMobile;
         }
	
      $isMobile = 0; // DESKTOP
      $tablet_browser = 0;
      $mobile_browser = 0;

      if (preg_match('/(tablet|ipad|playbook)|(android(?!.*(mobi|opera mini)))/i', strtolower($_SERVER['HTTP_USER_AGENT'])))
         { $tablet_browser++;}

      if (preg_match('/(up.browser|up.link|mmp|symbian|smartphone|midp|wap|phone|android|iemobile)/i', strtolower($_SERVER['HTTP_USER_AGENT'])))
         { $mobile_browser++;}

      if ((strpos(strtolower($_SERVER['HTTP_ACCEPT']),'application/vnd.wap.xhtml+xml') > 0) or ((isset($_SERVER['HTTP_X_WAP_PROFILE']) or isset($_SERVER['HTTP_PROFILE']))))
         { $mobile_browser++;}

      $mobile_ua = strtolower(substr($_SERVER['HTTP_USER_AGENT'], 0, 4));
      $mobile_agents = array(
         'w3c ','acs-','alav','alca','amoi','audi','avan','benq','bird','blac',
         'blaz','brew','cell','cldc','cmd-','dang','doco','eric','hipt','inno',
         'ipaq','java','jigs','kddi','keji','leno','lg-c','lg-d','lg-g','lge-',
         'maui','maxo','midp','mits','mmef','mobi','mot-','moto','mwbp','nec-',
         'newt','noki','palm','pana','pant','phil','play','port','prox',
         'qwap','sage','sams','sany','sch-','sec-','send','seri','sgh-','shar',
         'sie-','siem','smal','smar','sony','sph-','symb','t-mo','teli','tim-',
         'tosh','tsm-','upg1','upsi','vk-v','voda','wap-','wapa','wapi','wapp',
         'wapr','webc','winw','winw','xda ','xda-');

      if (in_array($mobile_ua,$mobile_agents)) 
         { $mobile_browser++;}

      if (strpos(strtolower($_SERVER['HTTP_USER_AGENT']),'opera mini') > 0)
         { $mobile_browser++;
            //Check for tablets on opera mini alternative headers
            $stock_ua = strtolower(isset($_SERVER['HTTP_X_OPERAMINI_PHONE_UA'])?$_SERVER['HTTP_X_OPERAMINI_PHONE_UA']:(isset($_SERVER['HTTP_DEVICE_STOCK_UA'])?$_SERVER['HTTP_DEVICE_STOCK_UA']:''));
            if (preg_match('/(tablet|ipad|playbook)|(android(?!.*mobile))/i', $stock_ua)) 
               { $tablet_browser++;}
         }

      if ($tablet_browser > 0) // tablet devices
         { $isMobile = 2;}
      else if ($mobile_browser > 0) // mobile devices
         { $isMobile = 1;}
      else // everything else
         { $isMobile = 0;}
         
      if($isMobile==2) {$isMobile = 0;}
      @define('isMobile',$isMobile);
      
      $this->bisoft_lib->set_mobile($isMobile);
      $this->bisoft_lib->block_mobile();
      
	return $isMobile;
	}
	

	// Country Code - Geo Locator
      /* must enable in php.ini for function file_get_contents:
            allow_url_fopen   = On
            allow_url_include = On
      */
   function geolocate($ip=NULL, $deep_detect=TRUE) 
   {
      $geo = $inEU = $rate = 0;
      if(filter_var($ip, FILTER_VALIDATE_IP) === FALSE) 
      {
         $ip = $_SERVER["REMOTE_ADDR"];
         if($deep_detect) 
         {
               if(filter_var(@$_SERVER['HTTP_X_FORWARDED_FOR'], FILTER_VALIDATE_IP))
               { $ip = $_SERVER['HTTP_X_FORWARDED_FOR']; }
               
               if(filter_var(@$_SERVER['HTTP_CLIENT_IP'], FILTER_VALIDATE_IP))
               { $ip = $_SERVER['HTTP_CLIENT_IP']; }
         }
      }

      if($ip=="::1" and ($_SERVER['HTTP_HOST']=='localhost' or $_SERVER['HTTP_HOST']=='127.0.0.1'))
      { $geo = 'BG'; $inEU = 1; }
      else
      {
         if( filter_var($ip, FILTER_VALIDATE_IP) ) 
         {
            // взима от външен сайт
            $ipdata = @json_decode(file_get_contents("http://www.geoplugin.net/json.gp?ip=".$ip));
            
            /* print_r($ipdata); - array();
               $ipdat = @$ipdata->geoplugin_city,
                        @$ipdata->geoplugin_regionName,
                        @$ipdata->geoplugin_countryName,
                        @$ipdata->geoplugin_countryCode,
                        @$ipdata->geoplugin_continentCode
                        @$ipdata->geoplugin_inEU  ( 0 / 1 )
                        @$ipdata->geoplugin_currencyConverter
            */
            
            if(@strlen(trim($ipdata->geoplugin_countryCode)) == 2) 
            {  
               $geo  = @$ipdata->geoplugin_countryCode; 
               $inEU = @$ipdata->geoplugin_inEU;
               $rate = @$ipdata->geoplugin_currencyConverter;
               if($geo=='TR') { $inEU=1; } // включвам Турция при посещения
            }
         }
      }

      return array('lang'=>$geo,'inEU'=>$inEU, 'rate'=>$rate);
   }	
	
	
	function get_all()
	{
		$this->db->from('bisoft');
		$this->db->order_by("key", "asc");
		return $this->db->get();		
	}


	function get($key)
	{
		$query = $this->db->get_where('bisoft', array('key' => $key), 1);
		if($query->num_rows()==1)
		{ return $query->row()->value;}
	return "";
	}

	function is_brand($brand)
	{
		$this->db->from('brands');
		$this->db->where('brand',$brand);
		$this->db->where('deleted',0);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $brand;}
		else	
			{ return 1;}	
	}
	
	function get_brands()
	{
		$this->db->from('brands');		
		$this->db->where('deleted',0);
		$this->db->order_by("brand", "asc");
		return $this->db->get();		
	}
	
	function get_brand_name($brand)
	{
		$this->db->from('brands');
		$this->db->where('brand',$brand);
		$this->db->where('deleted',0);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row()->name;}
		else	
			{ return "";}	
	}
	
	public function get_company()
	{
		$query = $this->db->get_where('app_config', array('key' => 'company_eng'), 1);
		if( $query->num_rows() == 1 )	{ return $query->row()->value; }
	return "";
	}

	public function get_version()
	{
		$query = $this->db->get_where('bisoft', array('key' => 'version'), 1);
		if( $query->num_rows() == 1 )	{ return $query->row()->value; }
	return "";
	}


	public function set_version()
	{
		$handle = fopen('license/version.txt', "r");
		while (($data = fgetcsv($handle)) !== FALSE) { $ver_code = trim($data[0]);}
			$ver_data = array( 'value' => $ver_code );
			$this->db->where('key', 'version');
			$success = $this->db->update( 'bisoft', $ver_data );
      fclose($handle);
	return $success;
	}


// --------------------------------- version ckp -------------------------- //
	public function get_version_ckp()
	{
		$query = $this->db->get_where('bisoft', array('key' => 'version_ckp'), 1);
		if( $query->num_rows() == 1 ) { return $query->row()->value; }
	return "0";
	}

	public function set_version_ckp($ver_code='1')
	{
		$ver_data = array('value' => $ver_code);
		$this->db->where('key', 'version_ckp');
		$success = $this->db->update( 'bisoft', $ver_data );
	return $success;
	}

// -------------------------------- END version ckp ------------------------ //

	function get_path()
	{
		$query = $this->db->get_where('bisoft', array('key' => 'bisoft_path'), 1);
		if( $query->num_rows() == 1 ) { return $query->row()->value; }
		return "";
	}


	function get_user()
	{
		$user = $this->Employee->get_logged_in_employee_info()->person_id;
		return $user;
	}


	function save($key,$value)
	{
		$config_data=array(
					'key'=>$key,
					'value'=>$value );

		if (!$this->exists($key))	{ return $this->db->insert('bisoft',$config_data);	}
		$this->db->where('key', $key);
	return $this->db->update('bisoft',$config_data);		
	}
	
	function batch_save($data)
	{
		$success=true;
		
		//Run these queries as a transaction, we want to make sure we do all or nothing
		$this->db->trans_start();
		foreach($data as $key=>$value)
		{
			if(!$this->save($key,$value))
			{
				$success=false;
				break;
			}
		}
		
		$this->db->trans_complete();		
	return $success;
	}
		
	function delete($key)
	{
		return $this->db->delete('bisoft', array('key' => $key)); 
	}
	
	function delete_all()
	{
		return $this->db->empty_table('bisoft'); 
	}


	function get_sizes($grid='grid_1')
	{
		$this->db->from('sizes');
		$this->db->where('key', $grid);
		$query = $this->db->get();

	if( $query->num_rows() == 1 )	{ return $query->row(); }
	return "";		
	}


// --------------------------------- SESSIONS ------------------------- //
	function get_all_sessions()
	{
		$this->db->from('sessions');
		$this->db->order_by("ip_address", "asc");
	return $this->db->get();		
	}

	function delete_session($session_id)
	{
		$this->db->trans_start();
		$this->db->delete( 'sessions', array('session_id' => $session_id)); 
		$this->db->trans_complete();
	return $this->db->trans_status();
	}


	function delete_all_sessions($session_id=null)
	{
	return $this->db->empty_table('sessions');
	}




/* =============================  ДОКУМЕНТИ  =============================== */

	public function get_info_by_document_number($doc_number, $vedom)
	{  
		$this->db->from($vedom);
		$this->db->where('doc_number',$doc_number);
	return $this->db->get();
	}



/* ----------------------------  MAT TABLE --------------------------------- */

	function get_mat_table()
	{
		$this->db->from('mat_table');
		$this->db->order_by("key", "asc");
	return $this->db->get();		
	}
	

	function get_mat_table_type($key)
	{
		$query = $this->db->get_where('mat_table', array('key' => $key), 1);
		
		if($query->num_rows()==1)
		{
			return $query->row()->type;
		}
		return "";
	}

	
/* ================================= Suggestions =========================*/
	
	/* Get search suggestions to find customers */
	function get_customer_suggestions($search,$limit)
	{
		$suggestions = array();
		$this->db->from('customers');
		$this->db->join('people','customers.bisoft_id=people.bisoft_id');	
		$this->db->where('deleted', 0);

		$this->db->like("account_number",$search);
		$this->db->order_by("company_name", "asc");		
		$by_company_name = $this->db->get();
		
		foreach($by_company_name->result() as $row)
			{ $suggestions[]=$row->bisoft_id.'|'.$row->account_number.' '.$row->company_name; }

		if(count($suggestions)==0)
		{
			$this->db->from('customers');
			$this->db->join('people','customers.bisoft_id=people.bisoft_id');	
			$this->db->where('deleted', 0);
			$this->db->like("company_name",$search);
			$this->db->order_by("company_name", "asc");		
			$by_company_name = $this->db->get();
			
			foreach($by_company_name->result() as $row)
				{ $suggestions[]=$row->bisoft_id.'|'.$row->account_number.' '.$row->company_name; }
			
			if(count($suggestions)==0)
			{
				$this->db->from('customers');
				$this->db->join('people','customers.bisoft_id=people.bisoft_id');	
				$this->db->where("(first_name LIKE '%".$this->db->escape_like_str($search)."%' or 
										last_name LIKE '%".$this->db->escape_like_str($search)."%' or 
										account_number LIKE '%".$this->db->escape_like_str($search)."%' or 
				CONCAT(`first_name`,' ',`last_name`) LIKE '%".$this->db->escape_like_str($search)."%') and deleted=0");
				$this->db->order_by("last_name", "asc");		
				$by_name = $this->db->get();
				
				foreach($by_name->result() as $row)
					{ $suggestions[]=$row->bisoft_id.'|'.$row->first_name.' '.$row->last_name." <i>/ ".$row->company_name."</i>"; }
			}
		}
			
		// only return $limit suggestions
		if(count($suggestions) > $limit)
			{ $suggestions = array_slice($suggestions, 0, $limit); }
		
		return $suggestions;
	}
	
	


/* ================================= BLANKA PRINTS =========================*/

	function exists_doc_number($doc_number,$vedom)
	{  
		$this->db->from($vedom);
		$this->db->where('doc_number',$doc_number);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}


	public function get_info_by_docNumber($doc_number,$vedomPack)
	{ 
		$this->db->from($vedomPack);
		$this->db->where('doc_number',$doc_number);
		$this->db->where('deleted = 0');
	return $this->db->get();
	}
	

	public function get_info_for_invoice($doc_id,$vedomPack)
	{ 
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
		$this->db->where('deleted',0);
	return $this->db->get();
	}

	// All Documents ...
	function get_document_info($doc_id,$vedomPack)
	{
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
		$this->db->where('deleted',0);
	return $this->db->get()->row();
	}
	
	// All Documents ...
	function get_document_items($doc_id,$vedomPack)
	{
		$db_items = $vedomPack . '_items';
		$this->db->from($db_items);
		$this->db->where('doc_id',$doc_id);
		$this->db->where('deleted',0);
	return $this->db->get();
	}
	

	// doc item for AJAX ...
	function get_doc_item($doc_idx)
	{
		$line   = (int)substr($doc_idx,-3);
		$doc_id = (int)substr($doc_idx,0,-7);
		$vedom  = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom.'_items';
		$this->db->from($vedomPack);
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{ return $query->row();}
		else	
			{ return 0;}
	}
	
	function get_factura_item($vedom,$doc_id,$line)
	{
		$this->db->from('V'.$vedom.'_items');
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{ return $query->row();}
		else	
			{ return 0;}
	}

	function update_line_item($items_data, $doc_idx)
	{  
		$line    = (int)substr($doc_idx,-3);
		$doc_id  = (int)substr($doc_idx,0,-7);
		$vedom   = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom.'_items';

		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
		$success = $this->db->update( $vedomPack, $items_data );
	return $success;
	}

	
// ================================ AJAX Recalculate Document via doc_idx=doc_id.vedom.line ======================== //
	function recalc_document($doc_idx)
	{
		$tax = $three4two = 0;
		$line    = (int)substr($doc_idx,-3);
		$doc_id  = (int)substr($doc_idx,0,-7);
		$vedom   = (int)substr($doc_idx,-7,-3);
			$vedomPack = 'V'.$vedom;
			$recalc_otchet=0; if($line='999') {$recalc_otchet=1;};

		$qty_doc=$total_sum_doc=$sum_doc=$pay_amount=$tax_doc=$cost_doc=$total_OM=$commision=0;
		$total_qty=$total_vat=$total_sum=$total_all=$total_cost=0;
		
		$doc_info = $this->get_info_by_doc_id($doc_id,$vedomPack)->row();
			$client_name = $doc_info->client;
			$client_id = $doc_info->client_id;
			$giftowner = $doc_info->giftowner;
			$location  = $doc_info->location;
			$mode_id   = $doc_info->mode_id;
			$total_dsc = (float)$doc_info->total_discount;
			$pay_group = $doc_info->pay_group;
			$order_id  = $doc_info->order_id;
			if($order_id=='three4two') {$three4two=1;$three4two_suma=to_dot($doc_info->due_sum);}
			
		$dsc_doc = '';	
		if($total_dsc) {$dsc_doc = $doc_info->total_discount.'%';}
		
		// Giftcards
		$giftcard = $doc_info->giftcard;
		
		$giftvalue = $giftprocent = 0; 
		if($doc_info->giftowner) 
         { 
            $giftowner = $doc_info->giftowner; 
            $giftprocent = $doc_info->giftprocent;
            $giftvalue = $doc_info->giftvalue;
         } 
		
		if($giftcard)
			{
            $gift_info = $this->Giftcard->get_giftcard_by_code($giftcard);
            if($gift_info)
            {
				//	$giftowner = $gift_info->owner;
					$giftvalue = $gift_info->cost;
					$giftprocent = $gift_info->procent;

					if($giftprocent>0) 
                    {$client_name = $giftowner.' (vip'.$giftprocent.'%)';}
					elseif($giftvalue>0) 
                    {$client_name = $giftowner.' ('.$giftvalue.'лв)';}
					else 
                    {$client_name = $giftowner;}
				}
			}

		$items_info = $this->get_document_items($doc_id,$vedomPack)->result_array();
		$cust_info  = $this->Customer->get_info_by_bisoft_id($client_id);
		$cust_status = $cust_dsc = $cust_taxable = 0;
		if($cust_info)
         {
            $cust_status = $cust_info->status;
            $cust_dsc = (float)$cust_info->discount;
            $cust_taxable = $cust_info->taxable;
         }

		foreach($items_info as $row=>$item)
		{
			$inum  = $item['item_number'];
			$line_now = $item['line'];
		   $iprice = (float)$item['item_unit_price'];
			$qty 	 = (int)$item['item_qty'];
			$dsc 	 = (float)$item['item_discount'];
			$tax 	 = (float)$item['item_taxes'];
			$cost	 = (float)$item['costsale'];

			$qty_doc  += $qty;
			$price	  = round($iprice*(100-$dsc)/100,7);
			$giftPrice = round($price*(100-$giftprocent)/100,7);
			$sum_doc  += $qty*$giftPrice;
			if($tax>0) {$tax_doc += round(0.2*$qty*$giftPrice,7);}
		
			if($recalc_otchet==1) // САМО КОГАТО пресмята и записва всичко.
			{
				if(($mode_id=='SE' or $mode_id=='BP') and $location>0) // само магазини ?!
					{
                  $total_sum_doc += $qty*$iprice;
						$discount = (float)$this->Consignee->get_info_by_bisoft_id($location)->discount;
						if($discount>0)
						{ $cost = round($price*(100-$discount)/100,7); }
						elseif($total_dsc>0) // за Красьо
						{ $cost = round($price*(100-$total_dsc)/100,7); }
				//		elseif($giftprocent>0)
				//		{ $cost = $giftPrice; }
						else
						{ $cost = $price; }
					}
				elseif($mode_id=='E' or $mode_id=='BE')
					{ 
                  if($cust_status=='onlineto' and $cust_taxable and $cust_dsc > 0)
                  {
							$total_sum_doc += round(1.2*($qty*$iprice),7);
							$item_disc = (float)$cust_info->discount;
							$cost = round($price*(100-$item_disc)/100, 2);  // round($price*(100-1.2*$item_disc)/100,7);
                  }
                  else
                  { 
                     $cost = round($giftPrice*(100-$total_dsc)/100,7);
                     $total_sum_doc += $qty*$iprice;
                  }
                 
               }
				elseif($mode_id=='OM' or $mode_id=='OMi' or $mode_id=='OMB')
					{ 
						$total_OM += round(1.2*($qty*$giftPrice),7);
						$cost = $giftPrice;
					}
				else
					{ 
                  if($cost==0) {$cost=$giftPrice;} 
                  $total_sum_doc += round($qty*$giftPrice,7);
					}

				$items_data = array(
						 'doc_id' => $doc_id,
							'line' => $line_now,
					  'costsale' => $cost );
										
				$doc_idx = $doc_id.$vedom.str_pad($line_now, 3, "0", STR_PAD_LEFT);
				$cost_doc += round($qty*$cost,7);

			// реално записва в item
			$this->update_line_item($items_data, $doc_idx);
			}
		}

		
		
		//Разпределяме index-ите на плащане ..
		$pay_type = '';
		switch ($pay_group) 
			{
				case 'H': $pay_type = $this->lang->line('sales_not_paid');break;
				case 'P': $pay_type = $this->lang->line('sales_cash');break;
				case 'T': $pay_type = $this->lang->line('sales_by_bank');break;
				case 'NP': $pay_type = $this->lang->line('kaca_post_transfer'); break;
				case 'HT': $pay_type = $this->lang->line('sales_not_paid_bank');break;
				case 'Ch': $pay_type = $this->lang->line('sales_check');break;
				case 'dC': $pay_type = $this->lang->line('sales_debit');break;
				case 'kC': $pay_type = $this->lang->line('sales_credit');break;
				case 'eP': $pay_type = $this->lang->line('sales_epay');break;
				case 'PP': $pay_type = $this->lang->line('sales_paypal');break;	
				case 'OMB': $pay_type = $this->lang->line('sales_online_return');break;
				case 'BP': $pay_type = $this->lang->line('sales_returned_goods');break;
				case 'BE': $pay_type = $this->lang->line('sales_returned_goods');break;
				case 'DSC': $pay_type = $this->lang->line('kaca_on_discount');break;
				default: '';
			}
			
		if($mode_id=='OM' or $mode_id=='OMi' or $mode_id=='OMB')
		{	// проверка на документа			
			$total_sum_doc = $total_OM;
			$tax_doc = round($total_sum_doc/6,7);
			$pay_amount = $total_sum_doc - $tax_doc;
            $delivery_cost = ' дост:'.$this->OnLine->get_text('delivery_cost');
            if($mode_id=='OMB') {$delivery_cost = '';}
			
			$total_sum  = round($total_OM - $doc_info->total_sum,7);
			$total_all  = round($pay_amount - $doc_info->pay_amount,7);
			
			if($doc_info->pay_sale == 0)
            { $cost_doc = $total_cost = 0;} // $giftvalue = 
         else
				{ $total_cost = round($cost_doc - $doc_info->pay_sale,7);}
		}
		elseif(($mode_id=='E' or $mode_id=='EE' or $mode_id=='BE') and $cust_info and $cust_info->status=='onlineto' and $cust_info->taxable)
		{	// изчисляване на "специалните online клиенти //
                  $tax_doc = round($total_sum_doc/6,7);
                  $pay_amount = $total_sum_doc - $tax_doc;
                  $total_sum  = round($total_sum_doc - (float)$doc_info->total_sum,7);
                  $total_all  = round($pay_amount - (float)$doc_info->pay_amount,7);
                  $total_cost = round($cost_doc - (float)$doc_info->pay_sale,7);
                  $pay_type   = $this->lang->line('reports_costsale');
		}
		elseif(($mode_id=='SE' or $mode_id=='BP') and $location>0) // само магазини ?!
		{
         $pay_amount = $total_sum_doc;
         if($giftprocent>0) {$pay_amount = round((100-$giftprocent)*$total_sum_doc/100,7);}
			$total_sum  = round($total_sum_doc - (float)$doc_info->total_sum,7);
			$total_all  = round($pay_amount - (float)$doc_info->pay_amount,7);
			$total_cost = round($cost_doc - (float)$doc_info->pay_sale,7);
		}
		else  // всички др. документи
		{
         $pay_amount = round($sum_doc * (100-$total_dsc)/100,7);
			if($tax>0) {$pay_amount += $tax_doc;}
			$total_sum  = round($total_sum_doc - (float)$doc_info->total_sum,7);
			$total_all  = round($pay_amount - (float)$doc_info->pay_amount,7);
			$total_cost = round($cost_doc - (float)$doc_info->pay_sale,7);
		}
		
		if($giftprocent) 
			{
				$pay_type .= ' (vip'.$giftprocent.'%)';
				$dsc_doc='vip'.$giftprocent.'%';
			}
		elseif($giftvalue and $giftprocent) 
			{
				$dsc_doc=round($giftvalue,0).'лв';
				$total_sum_doc += $giftvalue;
			}
		elseif($giftvalue and $giftprocent==0) 
			{
				$dsc_doc=round($giftvalue,0).'лв';
			}
			
		if($three4two)
			{	$pay_type .= ' (3=2)';
				$dsc_doc	  = 'three4two';
			}
		
		// допълнителни настройки
		$total_qty = $qty_doc - $doc_info->total_qty;		
		$total_vat = round($tax_doc - $doc_info->total_taxes,7);

		$total_discount = $total_dsc;
		
		$doc_data=array(
					'doc_id' => $doc_id,
				'total_qty'	=> $qty_doc,
		 'total_discount' => $total_discount,
				'giftowner'	=> $giftowner,
			 'giftprocent'	=> $giftprocent,
				'giftvalue'	=> $giftvalue,
					'client' => $client_name,
				 'pay_type'	=> $pay_type,
				'total_sum' => round($total_sum_doc,7),
			 'total_taxes' => round($tax_doc,7),
			  'pay_amount' => round($pay_amount,7),
				 'pay_sale'	=> round($cost_doc-$giftvalue,7)	);


		// актуализира Документа.
		$this->update_document($doc_data, $doc_id, $vedomPack);
		
		$total_dsc =  $total_cost - $giftvalue - $total_sum;
		
		$data=array(
			'qty_doc' => $qty_doc,
			'sum_doc' => to_dot($total_sum_doc),
			'dsc_doc' => $dsc_doc,
			'all_doc' => to_dot($pay_amount),
			'tax_doc' => to_dot($tax_doc),
		'amount_doc' => $pay_type,
		'client_doc' => $client_name,
		  'cost_doc' => to_dot($cost_doc-$giftvalue),
		  
		 'total_qty' => $total_qty,
		 'total_sum' => to_dot($total_sum),
		 'total_dsc' => to_dot($total_dsc),
		 'total_vat' => to_dot($total_vat),
		 'total_pay' => to_dot($total_all),
		'total_cost' => to_dot($total_cost-$giftvalue)  );
		
	return $data;
	}
	
	
	public function get_info_by_doc_id($doc_id,$vedomPack)
	{ 
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
		$this->db->where('deleted = 0');
	return $this->db->get();
	}
	
	function save_document($vedomPack,$doc_data)
	{  
		$doc_id = $this->db->insert( $vedomPack, $doc_data );
	return $doc_id;
	}	
	
	function update_document($doc_data, $doc_id, $vedomPack)
	{  
		$this->db->where('doc_id', $doc_id);
	return $this->db->update( $vedomPack, $doc_data );
	}	
	

	// Invoices ....
	function exists_invoice($invoice_number,$vedomPack,$firma='-1')
	{  
		$this->db->from($vedomPack);
		$this->db->where('doc_number',$invoice_number);
		$this->db->where("mode_id in ('F', 'Ki', 'Di', 'Pr')");
		if($firma!='-1'){$this->db->where('location',$firma);}
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function get_invoice_by_docNumber($doc_number,$vedomPack,$firma='-1')
	{ 
		$this->db->from($vedomPack);
		$this->db->where('doc_number',$doc_number);
		$this->db->where("mode_id in ('F', 'Ki', 'Di', 'Pr')");
		if($firma!='-1'){$this->db->where('location',$firma);}
		$this->db->where('deleted = 0');
	return $this->db->get();
	}
	
	function get_proforma_by_docNumber($doc_number,$vedomPack,$firma='-1')
	{ 
		$this->db->from($vedomPack);
		$this->db->where('doc_number',$doc_number);
		$this->db->where("mode_id",'PF');
		if($firma!='-1'){$this->db->where('location',$firma);}
		$this->db->where('deleted = 0');
	return $this->db->get();
	}
	
	function get_invoice_items($doc_number,$vedomPack,$firma='-1')
	{
		$db_sales_items = $vedomPack . '_items';
		$this->db->from($db_sales_items);
		$this->db->where('doc_number',$doc_number);
		if($firma!='-1'){$this->db->where('location',$firma);}
		$this->db->where('deleted = 0');
	return $this->db->get();
	}

	function get_invoice_payments($doc_number,$vedomPack,$firma='-1')
	{
		$this->db->from($vedomPack);
		$this->db->where('doc_number',$doc_number);
		$this->db->where("mode_id in ('F', 'Ki', 'Di', 'Pr')");
		if($firma!='-1'){$this->db->where('location',$firma);}
		$this->db->where('deleted = 0');
	return $this->db->get();
	}

	
	/*	Determines if a given item_NUMBER is an item	*/
	function exists_by_number($item_number)
	{
		$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	public function add_sub_arrays($arr1, $arr2, $mode_id, $znak='add') 
	{
		$result = array();
		if($arr1 and $arr2)
		{
			if($znak=='add')
			{
				foreach ($arr1 as $k=>$val) 
					{	
						if($mode_id=='BL' or $mode_id=='KIT') {$now = $val + $arr2[$k];}
						else { $now = (int)($val + abs($arr2[$k]));} 
						$result[] = $now;
					}
			}
			elseif($znak=='sub')
			{
				foreach ($arr1 as $k=>$val)
					{
						if($mode_id=='BL' or $mode_id=='KIT') {$now = $val - $arr2[$k];}
						else { $now = (int)($val - abs($arr2[$k]));}
						$result[] = $now;
					}
			}
		}
	return $result;
	}



/* ====================================  COMMON PUBLIC FUNCTIONS ============================== */

	public function get_person()   // функция, която връща КОЙ РАБОТИ ........OK
	{ 
		$user=0;
		$empl_info = $this->Employee->get_logged_in_employee_info();
		if($empl_info) {$user=$this->Employee->get_logged_in_employee_info()->person_id;}
		return $user;
	}

	public function get_location()// КЪДЕ РАБОТИ ОПЕРАТОРА
	{ 
		$location=0;
		$empl_info = $this->Employee->get_logged_in_employee_info();
		if($empl_info) {$location=$this->Employee->get_logged_in_employee_info()->location;}
		return $location;
	 }

	public function get_mode_location()   // функция, която връща КЪДЕ РАБОТИ ОПЕРАТОРА ........OK
	{ $location = $this->Employee->get_logged_in_employee_info()->mode_location; return $location; }

	public function get_mode_assort()   // функция, която връща АСОРТИМЕНТА ........OK
	{ $assort = $this->Employee->get_logged_in_employee_info()->mode_assort; return $assort; }

	public function get_mode_mat()   // функция, която връща АСОРТИМЕНТА НА МАТЕРИАЛА ......OK
	{ $mat = $this->Employee->get_logged_in_employee_info()->mode_mat; return $mat; }

	public function get_unit_location()   // функция, която връща КЪДЕ РАБОТИ ОПЕРАТОРА ........OK
	{ $location = $this->Employee->get_logged_in_employee_info()->unit_location; return $location; }

	public function get_user_mode()   // функция, която връща РЕЖИМА на Работа ........OK
	{
		$mode=0;
		$empl_info = $this->Employee->get_logged_in_employee_info();
		if($empl_info) {$mode = $this->Employee->get_logged_in_employee_info()->mode;}
		return $mode;
	}
	
	public function get_mode_menu($person_id=0)   // функция, която връща ОСНОВОТО МЕНЮ ......OK
	{  $mode_menu = 0;
		if(!$person_id)
		{
			$empl_info = $this->Employee->get_logged_in_employee_info();
			if($empl_info) { $mode_menu=$empl_info->mode_menu;}
		}
	return $mode_menu;
	}

	public function get_user_mode_year() 	// функция, която връща ГОДИНАТА за Обработка ........OK
	{ $mode_year = $this->Employee->get_logged_in_employee_info()->mode_year; return $mode_year;	}

	public function get_user_mode_price() 	// функция, която връща ГРУПАТА на ЦЕНА за Обработка ...
	{ $mode_price = $this->Employee->get_logged_in_employee_info()->mode_price; return $mode_price;	}

	public function get_user_half_year() 	// функция, която връща ГОДИНАТА за Обработка ........OK
	{ $mode_year = $this->Employee->get_logged_in_employee_info()->mode_year; 
	  return (int) substr($mode_year,2,3);	}

	public function get_user_mode_date() 	// функция, която връща ДАТА на Обработка ........OK
	{ $mode_date = $this->Employee->get_logged_in_employee_info()->mode_date; 
     if(!$mode_date or null==$mode_date or $mode_date==date('1970-01-01')) 
       { $mode_date=date('Y-m-d');$this->set_user_date($mode_date);}
	return $mode_date;	
	}

	public function get_user_mode_client()   // функция, която връща id на Клиента за Обработка ........OK
	{ $mode_client = $this->Employee->get_logged_in_employee_info()->mode_client; return $mode_client; }
	
	public function set_user_mode( $mode=0, $person_id=0) // функция, която установява РЕЖИМА на Работа ..
	{
      if($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}
		$modes_data = array(	'mode' => $mode );
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}


	public function set_user_year( $mode_year=0, $person_id=0) // функция, която установява ГОДИНАТА за Обработка ..
	{
	if($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}

	if ($mode_year == 0 or $mode_year > date('Y')) { $mode_year = date('Y');}
	if ($mode_year < '2014') { $mode_year = '2014';}

		$modes_data = array('person_id' => $person_id, 'mode_year' => $mode_year );
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}


	public function set_user_price( $mode_price=99, $person_id=0) // функция, която установява ЦЕНАТА ..
	{
	if($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}

		$modes_data = array(	'mode_price' => $mode_price );
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}


	public function set_user_date( $mode_date=0, $person_id=0) // функция, която установява ГОДИНАТА за Обработка ..
	{
	if($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}

	if ($mode_date == 0) { $mode_date = date('Y-m-d');}	

		$modes_data = array(	'mode_date' => $mode_date );
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}

	public function set_user_client( $mode_client=0, $person_id=0) // функция, която установява КЛИЕНТА ..
	{
		// if($mode_client==0) { $mode_client = $this->Employee->get_logged_in_employee_info()->location;}
		if($person_id==0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}
		$modes_data = array(	'mode_client' => $mode_client );
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}


	public function set_unit_location( $location=0, $person_id=0) // функция, която установява КЛИЕНТА ..
	{
	if($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}

		$modes_data = array(	'unit_location' => $location );
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}


	public function set_mode_location( $location=0, $person_id=0) // функция, която установява МЕСТОТО ..
	{
	if($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}

		$modes_data = array(	'mode_location' => $location );
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}

	public function set_mode_mat( $mat=0, $person_id=0) // функция, която установява МЕСТОТО ..
	{
	if($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}

		$modes_data = array(	'mode_mat' => $mat );
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}
	
	public function set_mode_menu( $mode_menu=0, $person_id=0) // функция, която установява МЕСТОТО ..
	{
		$success = 0;
		if(!$person_id and  null!==$this->Employee->get_logged_in_employee_info() ) 
			{ $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}
		if($person_id)
		{
			$modes_data = array(	'mode_menu' => $mode_menu, 'person_id' => $person_id );
			$success = $this->Employee->save_modes( $modes_data, $person_id );
		}
	return $success;
	}

	public function set_mode_assort( $assort=0, $person_id=0) // функция, която установява АСОРТИМЕНТА/раб.време ..
	{
	if($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}

		$modes_data = array(	'mode_assort' => $assort );
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}


	public function set_user_all_modes( $modes_data, $person_id=0) // функция, която установява 'modes'..
	{
	if($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}

		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}


	public function clear_user_modes($person_id=0) // функция, която изтрива РЕЖИМА на Работа ..
	{
	if ($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}
		$modes_data = array(
					'person_id' 	=> $person_id,
					'mode' 			=> 0,
					'mode_menu'		=> 0,
					'mode_client'	=> 0,
					'mode_price'	=> 1,
					'mode_assort'	=> 0,
					'mode_mat' 		=> 0,
					'mode_date' 	=> date('Y-m-d'),
					'mode_year' 	=> date('Y'),
					'mode_location'=> 0 );
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}

	public function clear_user_home($person_id=0) // функция, която изтрива РЕЖИМА на Работа ..
	{
		if ($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}
		$ip_address = $_SERVER['REMOTE_ADDR']; // $this->input->ip_address();
		$admin_issues = 'Logged';
		if ($person_id == 1) { $admin_issues = NULL; }
		$modes_data = array(
					'person_id' 	=> $person_id,
					'mode' 			=> 0,
					'mode_menu'		=> 0,
					'mode_client'  => 0,
					'mode_price'   => 1,
					'mode_assort'	=> 0,
					'mode_mat' 		=> 0,
					'mode_date'    => date('Y-m-d'),
					'mode_year'    => date('Y'),
					'admin_issues' => $admin_issues,
					'mode_location'=> 0 
									);
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}

	public function clear_user_logout($person_id=0) // функция, която изтрива РЕЖИМА на Работа ..
	{
		if ($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}
		$modes_data = array(
					'person_id' 	=> $person_id,
					'mode' 			=> 0,
					'mode_menu'		=> 0,
					'mode_client'  => 0,
					'mode_price'   => 1,
					'mode_assort'	=> 0,
					'mode_mat' 		=> 0,
					'mode_date'    => date('Y-m-d'),
					'mode_year'    => date('Y'),
					'admin_issues' => NULL,
					'mode_location'=> 0 
									);
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}
	
	public function clear_production($person_id=0) // функция, която изтрива РЕЖИМА на Работа ..
	{
	if ($person_id == 0) { $person_id = $this->Employee->get_logged_in_employee_info()->person_id;}

		$modes_data = array(
					'person_id' 	=> $person_id,
					'mode' 			=> 0,
					'mode_menu'		=> 0,
					'mode_client'  => 0,
					'mode_price'   => 1,
					'mode_assort'	=> 0,
					'mode_mat' 		=> 0,
			//		'mode_date'    => date('Y-m-d'),
			//		'mode_year'    => date('Y'),
					'admin_issues' => NULL,
					'mode_location'=> 0 
					);
		$success = $this->Employee->save_modes( $modes_data, $person_id );
	return $success;
	}
	
	public function clear_session_module()
	{
		$mySession = $this->session->all_userdata();
		foreach($mySession as $itm=>$anySes)
		{
			if($itm!='session_id' and $itm!='ip_address' and $itm!='user_agent' and $itm!='last_activity'
										 and $itm!='user_data' and $itm!='person_id' and $itm!='mobile')
			{$this->session->unset_userdata($itm);}
		}
	}
	

	public function get_user_settings()   // функция, която връща ВСИЧКИ РЕЖИМИ на Работа ........OK
	{ 
		$mode = $this->Employee->get_logged_in_employee_info()->mode;
		$mode_menu = $this->Employee->get_logged_in_employee_info()->mode_menu;
		$person_id = $this->Employee->get_logged_in_employee_info()->person_id;
		$bisoft_id = $this->Employee->get_logged_in_employee_info()->bisoft_id; 
		$location = $this->Employee->get_logged_in_employee_info()->location;
		$mode_location = $this->Employee->get_logged_in_employee_info()->mode_location;
		$unit_location = $this->Employee->get_logged_in_employee_info()->unit_location;
		$mode_date = $this->Employee->get_logged_in_employee_info()->mode_date;
		$mode_year = $this->Employee->get_logged_in_employee_info()->mode_year;
		$mode_client = $this->Employee->get_logged_in_employee_info()->mode_client;
		$mode_price = $this->Employee->get_logged_in_employee_info()->mode_price;
		$mode_assort = $this->Employee->get_logged_in_employee_info()->mode_assort;
		$mode_mat = $this->Employee->get_logged_in_employee_info()->mode_mat;
		$admin_issues = $this->Employee->get_logged_in_employee_info()->admin_issues;
			
			$all_modes = array(
						'person_id' 	=> $person_id,
						'bisoft_id' 	=> $bisoft_id,
						'location' 		=> $location,
						'mode' 			=> $mode,
						'mode_menu' 	=> $mode_menu,
						'mode_location'=> $mode_location,
						'unit_location'=> $unit_location,
						'mode_date' 	=> $mode_date,
						'mode_year' 	=> $mode_year,
						'mode_client' 	=> $mode_client,
						'mode_price' 	=> $mode_price,
						'mode_assort'	=> $mode_assort,
						'mode_mat' 		=> $mode_mat,
						'admin_issues' => $admin_issues );
	return $all_modes; 
	}

	public function get_search_placeholder($mode_menu=0)
	{
		$placeholder = '';
		if($mode_menu)
		{
			$placeholder = $this->lang->line('common_search');
		}
	return $placeholder;
	}

	public function get_homebar_mode_KEY($mode_menu=0)
	{
		$mode_KEY=0;
		if($mode_menu)
		{
			switch($mode_menu)
			{
				case 'invoices': 	$mode_KEY = 1; break;
				case 'sales': 		$mode_KEY = 1; break;
				case 'recvs': 		$mode_KEY = 1; break;
				case 'kacas': 		$mode_KEY = 1; break; 
				case 'orders': 	$mode_KEY = 1; break;
				case 'shops': 		$mode_KEY = 1; break;
          case 'productions': $mode_KEY = 1; break;
				case 'mackas': 	$mode_KEY = 1; break;
				case 'fenotags': 	$mode_KEY = 1; break; 
			}
		}
	return $mode_KEY;
	}
	
	public function get_homebar_refresh_KEY($mode_menu=0)
	{
		$refresh_KEY=0;
		if($mode_menu)
		{
			switch($mode_menu)
			{
				// case 'sales': $refresh_KEY = 1; break;
				case 'kacas': $refresh_KEY = 1; break;
				case 'productions': $refresh_KEY = 1; break;
				case 'mackas': $refresh_KEY = 1; break;
				case 'fenotags': $refresh_KEY = 1; break;
			}
		}
	return $refresh_KEY;
	}


/* ============================== VEDOMS =========================== */	

	function exists_vedom($key)
	{
		$this->db->from('vedoms');	
		$this->db->where('vedoms.key',$key);
		$query = $this->db->get();
		
	return ($query->num_rows()==1);
	}


	function get_vedom_number($vedom='vhro',$vedom_id='2201')
	{
		$query = $this->db->get_where('vedoms', array('key' => $vedom_id), 1);
		if( $query->num_rows() == 1 )	
		{ return (int)$query->row()->$vedom; }
		else { return 0; }
	}
	
	
	/*	Взима си поредният номер на фактурата	*/
	function get_fac_number($firma=0)
	{
		$fac_number = 1;
		$this->db->select('key,vfac,vfac_2');
		$this->db->from('vedoms');
		$query = $this->db->get()->result_array();
		
		if($firma<2) // за основната Фирма 0 или 1
		{
			foreach(array_reverse($query,true) as $vm)
			{
				if($vm['vfac']>0)	{$fac_number += $vm['vfac'];break;}
			}
		}
		elseif($firma==2) // ВТОРАТА ФИРМА
		{
			foreach(array_reverse($query,true) as $vm)
			{
				if($vm['vfac_2']>0)	{$fac_number += $vm['vfac_2'];break;}
			}
		}
		
	return $fac_number;
	}


	/*	Актуализира 'VEDOM Number' по документа	*/
	function set_vedom_number($vedom_number_data,$vedom_id=0)
	{
	  $success=false;
	  $this->db->trans_start();

			if (!$this->exists_vedom($vedom_id)) { $success=false; }
			else
			{
				$this->db->from('vedoms');	
				$this->db->where('key', $vedom_id);
				$success = $this->db->update('vedoms', $vedom_number_data);		
			}

	$this->db->trans_complete();		
	return $success;
	}

// ---------------------------------------- КРАЙ на Setting Functions ----------------------------- //

	public function get_firma_key()
	{	$styler_key = $hanna_key = $hannauk_key = $villy_key = 0;
		$acc_number = $this->Appconfig->get('my_account_number');
		if($acc_number=='115752718') {$styler_key=1;$hanna_key=0;$hannauk_key=0;$villy_key=1;}
		elseif($acc_number=='115867485') {$styler_key=0;$hanna_key=0;$hannauk_key=0;}
		elseif($acc_number=='202885516') {$styler_key=0;$hanna_key=1;$hannauk_key=0;}
		elseif($acc_number=='8409164') {$styler_key=0;$hanna_key=0;$hannauk_key=1;}
		$data=array('hanna'=>$hanna_key,'hannauk'=>$hannauk_key,'styler'=>$styler_key,'villy'=>$villy_key);
	return $data;
	}


	public function get_vedom() // функция, която връща променлива с index-a на РАБОТНАТА ДИРЕКТОРИЯ ЗА ГОДИНАТА
	{	$vedom_YEAR = 'V'. date('ym') . '_'; return $vedom_YEAR;	}

	public function get_vedom_from_docnumber($docnumber) // функция -> по дата
	{	$vedom_YEAR = 'V'. date('ym',strtotime($docnumber)) . '_'; 
	return $vedom_YEAR;
	}

	public function get_vedom_from_date($doc_date) // функция -> index-a на РАБОТНА ДИРЕКТОРИЯ ЗА ГОДИНА по дата
	{	$vedom_YEAR = 'V'. date('ym',strtotime($doc_date)) . '_'; return $vedom_YEAR;}

	// ------------------ основна функция, която връща променлива с ИМЕТО на Базата ----------------
	public function get_db_main( $mode )
	{
			$db_any = 'V'.date('ym', strtotime( $this->get_user_mode_date() ));
	return $db_any;
	}

	// ------------------ основна функция, която връща къде да пишем Инвентара в Базата ----------------
	public function get_inventory( $mode )
	{
	  $db_inventory = $this->get_db_main() . '_items';
	return $db_inventory;
	}

	public function get_shops_vedom() // функция, която връща променлива с index-a на РАБОТНАТА ДИРЕКТОРИЯ ЗА ГОДИНАТА
	{	$vedom_YEAR = 'S'. date('ym') . '_'; return $vedom_YEAR;	}


	// определя базовия номер на документа + който се добавя серийния за да се получи 'new_number'
	public function get_document_number( $mode, $firma=1, $check=0 )
	{
		$cur_date = date('ym', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
			$cur_m = date('m', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
			$cur_y = date('y', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		
		$doc_number = $cur_date.'000000';
		$nowVedom = 'vhro';
			switch ($mode) 
				{
					case 'sale':	 		$doc_number = $cur_date.'690000'; $nowVedom = 'vexp'; break; 
					case 'sale_return':	$doc_number = $cur_date.'690000'; $nowVedom = 'vexp'; break;
					case 'discount':	   $doc_number = $cur_date.'690000'; $nowVedom = 'vexp'; break;
					case 'online_sale':	$doc_number = $cur_date.'490000'; $nowVedom = 'vlin'; break;
					case 'online_return':$doc_number = $cur_date.'490000'; $nowVedom = 'vlin'; break;
					case 'prep_sale':    $doc_number = $cur_date.'000000'; $nowVedom = 'sexp'; break;
					case 'invoice':		$doc_number = '0'; $nowVedom = 'vfac'; if($firma==2) {$nowVedom = 'vfac_2';} break;
					case 'invoice_ki':	$doc_number = '0'; $nowVedom = 'vfac'; if($firma==2) {$nowVedom = 'vfac_2';} break;
					case 'invoice_di':	$doc_number = '0'; $nowVedom = 'vfac'; if($firma==2) {$nowVedom = 'vfac_2';} break;
					case 'invoice_pr':	$doc_number = '0'; $nowVedom = 'vfac'; if($firma==2) {$nowVedom = 'vfac_2';} break;

				//  за ПРОДАЖБИ и всички 'shop_sales' документи на МАГАЗИНА ...
					case 'shop_sale':		$doc_number = $cur_date.'890000';  $nowVedom = 'vmag'; break;
					case 'shop_return':	$doc_number = $cur_date.'890000';  $nowVedom = 'vmag'; break;

				//  за ДОСТАВКИ и всички 'recvs' документи  на Склад-ГП ...
					case 'recv': 			$doc_number = $cur_date.'290000';  $nowVedom = 'vdos'; break;
					case 'recv_return':	$doc_number = $cur_date.'290000';  $nowVedom = 'vdos'; break;
					case 'usluga':			$doc_number = $cur_date.'290000';  $nowVedom = 'vdos'; break;
					case 'manu': 			$doc_number = $cur_date.'190000';  $nowVedom = 'vman'; break;
					case 'macka': 			$doc_number = $cur_date.'190000';  $nowVedom = 'vman'; break;
					case 'protocol':		$doc_number = $cur_date.'900000';  break;
					case 'stock':			$doc_number = $cur_date.'900000';  break;
					case 'qtynote':		$doc_number = $cur_date.'000000';  break; // Справка Кол-ва
					case 'kit':				$doc_number = $cur_date.'300000';  $nowVedom = 'sppr'; break;
					case 'balance':		$doc_number = $cur_date.'000000';  $nowVedom = 'sexp'; break; 
					case 'brak':			$doc_number = $cur_date.'000000';  $nowVedom = 'sexp'; break;
					case 'revision':		$doc_number = $cur_date.'000000';  $nowVedom = 'sexp'; break;
	
				//  за ДОСТАВКИ и всички 'recvs' документи на МАГАЗИНА ...
					case 'shop_recv':		$doc_number = $cur_date.'200000';  $nowVedom = 'sdos'; break;
					case 'shop_sgp':		$doc_number = $cur_date.'900000';  $nowVedom = 'sppr'; break;

				//  за КОНСИГНАЦИЯ само 'consis' документи на МАГАЗИНА ...
					case 'consi': 			$doc_number = $cur_date.'790000';  $nowVedom = 'vkon'; break;
					case 'consi_sale':	$doc_number = $cur_date.'890000';  $nowVedom = 'vmag'; break;
					case 'consi_return':	$doc_number = $cur_date.'990000';  $nowVedom = 'vppr'; break;

				//  за ПРОФОРМИ и ОФЕРТИ ...
					case 'proforma':		$doc_number = $cur_date.'500000';  $nowVedom = 'vhro'; break;
					case 'offer':			$doc_number = $cur_date.'500000';  $nowVedom = 'vhro'; break;

					default: 				$doc_number = -1; $nowVedom = 'vhro';
				}

		// зареждаме НОМЕРА на Документа от База 'vedoms' на нашата Ведомост ...
		$vedom_period = 'V'.$cur_date;
		$currNumber   = $this->get_vedom_number( $nowVedom, $vedom_period );
		$new_number	  = -1;

			 if(!$currNumber)
				{ 
					if ( $mode=='invoice' or $mode=='invoice_ki' or $mode=='invoice_di' or $mode=='invoice_pr' )
						{ $new_number = $this->get_fac_number($firma); }
					else  // за всички други документи освен ФАКТУРИ ....
						{ $new_number = $doc_number + 1; }
				}
			else  // нормално увеличава с + 1 ...
				{ $new_number = $currNumber + 1;}

		// записваме в Базата новият номер ...
		$vedom_number_data = array( $nowVedom => $new_number );
		if($check==0)
			{ $success = $this->set_vedom_number($vedom_number_data,$vedom_period);} // записва.

	return $new_number;
	}


	// определя базовия номер на документа за Online Shop = 'new_number'
	public function get_online_document_number($success=1)
	{
		$cur_date = date('ym');
		$doc_number = $cur_date.'490000';
		$nowVedom = 'vlin';

		// зареждаме НОМЕРА на Документа от База 'vedoms' на нашата Ведомост ...
		$vedom_period 	= 'V'.$cur_date;
		$currNumber 	= $this->get_vedom_number(  $nowVedom, $vedom_period );
		$new_number		= -1;

				if ( $currNumber == 0 )
					{ $new_number = $doc_number + 1;}
				else  // нормално увеличава с + 1 ...
					{ $new_number = $currNumber + 1;}

		// записваме в Базата новият номер ...
		$vedom_number_data = array( $nowVedom => $new_number );
		if($success) { $this->set_vedom_number($vedom_number_data,$vedom_period); } // записва +1

	return $new_number;
	}


	// определя базовия номер на документа за Shops = 'new_number'
	public function get_shop_document_number()
	{
		$cur_date = date('ym');
		$doc_number = $cur_date.'890000';
		$nowVedom = 'vshop';

		// зареждаме НОМЕРА на Документа от База 'vedoms' на нашата Ведомост ...
		$vedom_period 	= $cur_date;
		$currNumber 	= $this->get_vedom_number(  $nowVedom, $vedom_period );
		$new_number		= -1;

				if ( $currNumber == 0 )
					{ $new_number = $doc_number + 1;}
				else  // нормално увеличава с + 1 ...
					{ $new_number = $currNumber + 1;}

		// записваме в Базата новият номер ...
		$vedom_number_data = array( $nowVedom => $new_number );
		$success = $this->set_vedom_number($vedom_number_data,$vedom_period);

	return $new_number;
	}

	//  -------------------------- функция която дава ЗАГЛАВИЕТО НА ДОКУМЕНТА ----------------------------
	public function get_mode_title( $mode )
	{
			switch ($mode) 
				{
					case 'aboutus':$menu_title=$this->lang->line('common_ABOUT_US');break;
					case 'contacts':$menu_title=$this->lang->line('common_CONTACTS');break;
					case 'chat':$menu_title=$this->lang->line('common_CHAT');break;
					case 'sales':$menu_title=$this->lang->line('module_sales');break;
					case 'recvs':$menu_title=$this->lang->line('module_recvs');break;
					case 'materials':$menu_title=$this->lang->line('module_materials');break;
					case 'employees':$menu_title=$this->lang->line('module_employees');break;
					default:	$menu_title = 0;
				}
				
	return $menu_title;
	}
	
	//  -------------------------- функция която дава ЗАГЛАВИЕТО НА ДОКУМЕНТА ----------------------------
	public function get_document_title( $mode )
	{
			switch ($mode) 
				{
			//  за ПРОДАЖБИ и всички 'sales' документи на Склад-ГП ...
				case 'sale':	 		$blanka_title = $this->lang->line('sales_receipt_sale');			break;
				case 'sale_return':	$blanka_title = $this->lang->line('sales_receipt_return_sale');break;
				case 'discount':	   $blanka_title = $this->lang->line('sales_receipt_discount');   break;
				case 'online_sale':	$blanka_title = $this->lang->line('sales_online_sale');			break;
				case 'online_return':$blanka_title = $this->lang->line('sales_online_return');		break;
				case 'prep_sale':    $blanka_title = $this->lang->line('sales_prepare_sale');		   break;
				case 'offer':	 		$blanka_title = $this->lang->line('sales_receipt_offer');		break;
				case 'proforma': 		$blanka_title = $this->lang->line('sales_receipt_proforma');	break;
				case 'invoice': 		$blanka_title = $this->lang->line('sales_receipt_invoice');		break;
				case 'invoice_ki':	$blanka_title = $this->lang->line('sales_receipt_invoice_ki');	break;
				case 'invoice_di':	$blanka_title = $this->lang->line('sales_receipt_invoice_di');	break;
				case 'invoice_pr':	$blanka_title = $this->lang->line('sales_receipt_invoice_pr');	break;

			//  за ПРОДАЖБИ и всички 'sales' документи на МАГАЗИН ...
				case 'shop_sale':	 	$blanka_title = $this->lang->line('sales_receipt_shop_sale');	break;
				case 'shop_return':	$blanka_title = $this->lang->line('sales_receipt_return_sale');break;
				case 'online_sale':	$blanka_title = $this->lang->line('sales_online_sale');			break;


			//  за ДОСТАВКИ и всички 'recvs' документи  на Склад-ГП ...
				case 'recv': 			$blanka_title = $this->lang->line('sales_receipt_recv');			break;
				case 'recv_return':	$blanka_title = $this->lang->line('sales_receipt_recv_return');break;
				case 'macka': 			$blanka_title = $this->lang->line('recvs_macka');					break;
				case 'usluga':			$blanka_title = $this->lang->line('sales_receipt_usluga');		break;
				case 'manu': 			$blanka_title = $this->lang->line('sales_receipt_manu');			break;
				case 'protocol':		$blanka_title = $this->lang->line('sales_receipt_ppr');			break;
				case 'stock':			$blanka_title = $this->lang->line('sales_receipt_stock');		break;
				case 'qtynote':		$blanka_title = $this->lang->line('recvs_qtynote');				break;
				case 'kit':				$blanka_title = $this->lang->line('sales_kit');						break;
				case 'balance':		$blanka_title = $this->lang->line('sales_receipt_balance');		break;
				case 'brak':			$blanka_title = $this->lang->line('sales_brak');					break;
				case 'revision':		$blanka_title = $this->lang->line('sales_receipt_revision');	break;
 
			//  за ДОСТАВКИ и всички 'recvs' документи на МАГАЗИНА ...
				case 'shop_recv':		$blanka_title = $this->lang->line('sales_receipt_shop_recv');	break;
				case 'shop_sgp':		$blanka_title = $this->lang->line('sales_receipt_shop_sgp');	break;
				case 'shop_balance':	$blanka_title = $this->lang->line('sales_receipt_balance');		break;
				case 'shop_revision':$blanka_title = $this->lang->line('sales_receipt_revision');	break;

			//  за КОНСИГНАЦИЯ само 'consis' документи на МАГАЗИНА ...
				case 'consi':	 		$blanka_title = $this->lang->line('sales_receipt_consi');		break;
				case 'consi_sale':	$blanka_title = $this->lang->line('sales_receipt_consi_report');break;
				case 'consi_return':	$blanka_title = $this->lang->line('sales_receipt_return_consi');break;

				default: 				$blanka_title = $this->lang->line('sales_receipt');
				}
	return $blanka_title;
	}

	//  -------------------------- функция която дава ЗАГЛАВИЕТО НА ДОКУМЕНТА ----------------------------
	public function get_document_title_id( $mode_id )
	{
			switch ($mode_id) 
			{
			//  за ПРОДАЖБИ и всички 'sales' документи на Склад-ГП ...
				case 'E':	$blanka_title = $this->lang->line('sales_receipt_sale');			break;
				case 'BE':	$blanka_title = $this->lang->line('sales_receipt_return_sale');break;
				case 'ED':	$blanka_title = $this->lang->line('sales_receipt_discount');   break;
				case 'OM':	$blanka_title = $this->lang->line('sales_online_sale');			break;
				case 'OMi':	$blanka_title = $this->lang->line('sales_online_sale');			break;
				case 'OMB':	$blanka_title = $this->lang->line('sales_online_return');		break;
				case 'EE':	$blanka_title = $this->lang->line('sales_prepare_sale');			break;
				case 'Of':	$blanka_title = $this->lang->line('sales_receipt_offer');		break;
				case 'PF':	$blanka_title = $this->lang->line('sales_receipt_proforma');	break;
				case 'F': 	$blanka_title = $this->lang->line('sales_receipt_invoice');		break;
				case 'Ki':	$blanka_title = $this->lang->line('sales_receipt_invoice_ki');	break;
				case 'Di':	$blanka_title = $this->lang->line('sales_receipt_invoice_di');	break;
				case 'Pr':	$blanka_title = $this->lang->line('sales_receipt_invoice_pr');	break;

			//  за ПРОДАЖБИ и всички 'sales' документи на МАГАЗИН ...
				case 'SE':	$blanka_title = $this->lang->line('sales_receipt_shop_sale');	break;
				case 'BP':	$blanka_title = $this->lang->line('sales_receipt_return_sale');break;
				case 'BC':	$blanka_title = $this->lang->line('sales_receipt_shop_sgp');	break; 

			//  за ДОСТАВКИ и всички 'recvs' документи  на Склад-ГП ...
				case 'D': 	$blanka_title = $this->lang->line('sales_receipt_recv');			break;
				case 'BD':	$blanka_title = $this->lang->line('sales_receipt_recv_return');break;
				case 'DY':	$blanka_title = $this->lang->line('sales_receipt_usluga');		break;
				case 'MK':	$blanka_title = $this->lang->line('sales_receipt_manu');			break;
				case 'MSK':	$blanka_title = $this->lang->line('sales_receipt_macka');		break;
				case 'KIT':	$blanka_title = $this->lang->line('sales_kit');						break;
				case 'BL':	$blanka_title = $this->lang->line('sales_receipt_balance');		break;
				case 'AB':	$blanka_title = $this->lang->line('sales_receipt_brak');			break;
				case 'QN':	$blanka_title = $this->lang->line('sales_qtynote');				break;
				case 'R':	$blanka_title = $this->lang->line('sales_receipt_revision');	break;
 
			//  за ДОСТАВКИ и всички 'recvs' документи на МАГАЗИНА ...
				case 'SD':	$blanka_title = $this->lang->line('sales_receipt_shop_recv');	break;
				case 'SR':	$blanka_title = $this->lang->line('sales_receipt_revision');	break;

			//  за КОНСИГНАЦИЯ само 'consis' документи на МАГАЗИНА ...
				case 'C':	$blanka_title = $this->lang->line('sales_receipt_consi');		break;
				case 'CE':	$blanka_title = $this->lang->line('sales_receipt_consi_report'); break;
				case 'CP':	$blanka_title = $this->lang->line('sales_receipt_consi_report'); break;
				case 'CB':	$blanka_title = $this->lang->line('sales_receipt_return_consi'); break;

				default: 	$blanka_title = $this->lang->line('sales_receipt');
			}
	return $blanka_title;
	}


	public function get_document_pay_group($vedom,$doc_id)
	{
		$this->db->select('doc_id,pay_group',false);
		$this->db->from($vedom);
		$this->db->where('doc_id', $doc_id);
		$this->db->where('deleted = 0');
		$query = $this->db->get();
		if($query->num_rows()==1)
		  { return $query->row()->pay_group;}
		else
		  { return '';}
	}


	// ----------------------------------- функция за разпределяне коеф.-те на операцията -------------
	public function get_pay_group( $mode )
	{
	//Разпределяме коеф-те за index-ите на плащане на Продажбата / Доставката ..
			$pay_group = '';
			switch ($mode) 
				{
			//  за ПРОДАЖБИ и всички 'sales' документи на Склад-ГП ...
				case 'sale': 				$pay_group = 'E';		break;
				case 'sale_return':		$pay_group = 'BE';	break;
				case 'discount':		   $pay_group = 'ED';	break;
				case 'online_sale':		$pay_group = 'OM';	break;
				case 'online_return':	$pay_group = 'OMB';	break;
				case 'prep_sale':			$pay_group = 'EE';	break;
				case 'offer':				$pay_group = 'Of';	break;
				case 'proforma':			$pay_group = 'PF';	break;
				case 'invoice':			$pay_group = 'F';		break;
				case 'invoice_ki':		$pay_group = 'Ki';	break;
				case 'invoice_di':		$pay_group = 'Di';	break;
				case 'invoice_pr':		$pay_group = 'Pr';	break;

			//  за ПРОДАЖБИ и всички 'shop_sales' документи на МАГАЗИНА ...
				case 'shop_sale':			$pay_group = 'SE';	break;
				case 'shop_return':		$pay_group = 'BP';	break;

			//  за ДОСТАВКИ и всички 'recvs' документи  на Склад-ГП ...
				case 'recv': 				$pay_group = 'D';		break;
				case 'recv_return':		$pay_group = 'BD';	break;
				case 'usluga':				$pay_group = 'DY';	break;
				case 'manu': 				$pay_group = 'MK';	break;
				case 'macka': 				$pay_group = 'MSK';	break;
				case 'protocol':			$pay_group = 'PPr';	break;
				case 'stock':				$pay_group = 'ST';	break;
				case 'courier':			$pay_group = 'SK';	break;
				case 'balance':			$pay_group = 'BL';	break;
				case 'qtynote':			$pay_group = 'QN';	break;
				case 'kit':					$pay_group = 'KIT';	break;
				case 'brak':				$pay_group = 'AB';	break;
				case 'revision':			$pay_group = 'R';		break;
 
			//  за ДОСТАВКИ и всички 'recvs' документи на МАГАЗИНА ...
				case 'shop_recv':			$pay_group = 'SD';	break;
				case 'shop_sgp':			$pay_group = 'BC';  break;

			//  за КОНСИГНАЦИЯ само 'consis' документи за МАГАЗИНИТЕ ...
				case 'consi': 				$pay_group = 'C';		break;
				case 'consi_sale':		$pay_group = 'CE';	break;
				case 'consi_return':		$pay_group = 'CB';	break;

				default: 					$pay_group = '';
				}
	return $pay_group;
	}

	// ------------------------- функция за връщане на mode от коеф.-те на ведомостите -------
	public function get_mode_symbol( $mode_id )
	{
	//Разпределяме коеф-те за index-ите на плащане на Продажбата / Доставката ..
			$mode = '';
			switch ($mode_id) 
				{
			//  за ПРОДАЖБИ и всички 'sales' документи на Склад-ГП ...
				case 'E':					$mode = 'sale';			break;
				case 'BE':					$mode = 'sale_return';	break;
				case 'ED':					$mode = 'discount';	   break;
				case 'OM':					$mode = 'online_sale';	break;
				case 'OMi':					$mode = 'online_sale';	break;
				case 'OMB':					$mode = 'online_return';break;
				case 'EE':					$mode = 'prep_sale';		break;
				case 'Of':					$mode = 'offer';			break;
				case 'PF':					$mode = 'proforma';		break;
				case 'F':					$mode = 'invoice';		break;
				case 'Ki':					$mode = 'invoice_ki';	break;
				case 'Di':					$mode = 'invoice_di';	break;
				case 'Pr':					$mode = 'invoice_pr';	break;

			//  за ПРОДАЖБИ и всички 'shop_sales' документи на МАГАЗИНА ...
				case 'P':					$mode = 'shop_sale';		break;
				case 'SE':					$mode = 'shop_sale';		break;
				case 'BP':					$mode = 'shop_return';	break;

			//  за ДОСТАВКИ и всички 'recvs' документи  на Склад-ГП ...
				case 'D': 					$mode = 'recv';			break;
				case 'BD':					$mode = 'recv_return';	break;
				case 'DY':					$mode = 'usluga';			break;
				case 'MK': 					$mode = 'manu';			break;
				case 'MSK': 				$mode = 'macka';			break;
				case 'PPr':					$mode = 'protocol';		break;
				case 'ST':					$mode = 'stock';			break;
				case 'SK':					$mode = 'courier';		break;
				case 'CT':					$mode = 'stock';			break;
				case 'KIT':					$mode = 'kit';				break;
				case 'BL':					$mode = 'balance';		break;
				case 'AB':					$mode = 'brak';			break;
				case 'QN':					$mode = 'qtynote';		break;
				case 'R':					$mode = 'revision';		break;
 
			//  за ДОСТАВКИ и всички 'recvs' документи на МАГАЗИНА ...
				case 'SD':					$mode = 'shop_recv';		break;
				case 'BC':					$mode = 'shop_sgp';  	break;

			//  за КОНСИГНАЦИЯ само 'consis' документи на МАГАЗИНА ...
				case 'C': 					$mode = 'consi';			break;
				case 'CE':					$mode = 'consi_sale';	break;
				case 'CP':					$mode = 'consi_sale';	break;
				case 'CB':					$mode = 'consi_return';	break;

				default: 					$mode = '';
				}
	return $mode;
	}
	

	//Разпределяме коеф-те за index-ите за плащане на Продажбата / Доставката ..
	public function get_mode_quantity( $mode )
	{
	$quantity = 1;
	return $quantity;
	}

	//Разпределяме коеф-те за index-ите на плащане на Продажбата / Доставката ..
	public function get_vedom_place_index( $vedom_mode='E' )
	{
		switch ($vedom_mode) 
		{
		case 'D': 	$nowVedom = 'vdos';  break;
		case 'DY': 	$nowVedom = 'vdos';  break;
		case 'BD': 	$nowVedom = 'vdos';  break;
		case 'MK': 	$nowVedom = 'vman';  break;
		case 'MSK': $nowVedom = 'vman';  break;
		case 'E': 	$nowVedom = 'vexp';  break;
		case 'BE': 	$nowVedom = 'vexp';  break;
		case 'ED': 	$nowVedom = 'vexp';  break;
		case 'OM': 	$nowVedom = 'vlin';  break;
		case 'OMi': $nowVedom = 'vlin';  break;
		case 'OMB': $nowVedom = 'vlin';  break;
		case 'EE': 	$nowVedom = 'sexp';  break;
		case 'C': 	$nowVedom = 'vkon';  break;
		case 'CP': 	$nowVedom = 'vmag';  break;
		case 'CE': 	$nowVedom = 'vmag';  break;
		case 'CB': 	$nowVedom = 'vppr';  break;
		case 'SE': 	$nowVedom = 'vmag';  break;
		case 'BC':	$nowVedom = 'vppr';  break;
		case 'KIT':	$nowVedom = 'sppr';  break;
		case 'AB':	$nowVedom = 'vppr';  break;
		case 'ST':	$nowVedom = 'vppr';  break;
		case 'SK':	$nowVedom = 'vppr';  break;
		case 'QN':	$nowVedom = 'vppr';  break;
		case 'BP':	$nowVedom = 'vppr';  break;
		case 'BL':	$nowVedom = 'vppr';  break;
		case 'R':	$nowVedom = 'vppr';  break;
		case 'PPR':	$nowVedom = 'vppr';  break;
		case 'Of': 	$nowVedom = 'vhro';  break;
		case 'PF': 	$nowVedom = 'vhro';  break;
		case 'F': 	$nowVedom = 'vfac';  break;
		case 'Ki': 	$nowVedom = 'vfac';  break;
		case 'Di': 	$nowVedom = 'vfac';  break;
		case 'Pr': 	$nowVedom = 'vfac';  break;
		case 'K': 	$nowVedom = 'vkac';  break;
		case 'POR':	$nowVedom = 'vpor';  break;
		case 'TRZ':	$nowVedom = 'vtrz';  break;
		case 'VDA':	$nowVedom = 'vdva';  break;
		case 'VDV':	$nowVedom = 'vdvm';  break;

		default: 	$nowVedom = 'vhro';
		}

	return $nowVedom;
	}

/* ========================================================= SIZES =========================================== */
	public function get_size_info($item_number)
	{
		$sizes = array ( // празна база ?! //
						'1'	=> '',
						'2'	=> '',
						'3'	=> '',
						'4'	=> '',
						'5'	=> '',
						'6'	=> '',
						'7'	=> '',
						'8'	=> '',
						'9'	=> '',
						'10'	=> '' );

	if ( $this->Item->exists_by_number( $item_number, $key=1) )
		{
			$item_id  = $this->Item->get_all_info($item_number);
			$all_item = $this->Item->get_info($item_id, $key=1);
				$allow_sizes 		= $all_item->allow_sizes;
				$item_size_group 	= $all_item->item_size_group;

		if ( $allow_sizes )
			{
				if ( !is_numeric($item_size_group) 
					and $item_size_group != 'S'  and $item_size_group != 's' 
					and $item_size_group != 'XS' and $item_size_group != 'xs' 
					and $item_size_group != 'J'  and $item_size_group != 'j'  // for JEANS ?!
					and $item_size_group != 'c46'  // for SUITS and trousers
					and $item_size_group != 'UK'
					and $item_size_group != 'EN') { $item_size_group = 40;} // слагам си стандартни размери ...

				$sizes = array();
				  if ($item_size_group == 'S' or $item_size_group == 's') 
				  {
                  $sizes = array (
                        '1'	=> 'S',
                        '2'	=> 'M',
                        '3'	=> 'L',
                        '4'	=> 'XL',
                        '5'	=> '2XL',
                        '6'	=> '3XL',
                        '7'	=> '4XL',
                        '8'	=> '5XL',
                        '9'	=> '6XL',
                        '10'	=> '7XL' ); 
					}
				  elseif ($item_size_group == 'XS' or $item_size_group == 'xs') 
				  {
                  $sizes = array (
                        '1'	=> 'S',
                        '2'	=> 'M',
                        '3'	=> 'L',
                        '4'	=> 'XL',
                        '5'	=> '2XL',
                        '6'	=> '3XL',
                        '7'	=> '4XL',
                        '8'	=> '5XL',
                        '9'	=> '6XL',
                        '10'	=> 'XS' ); 
					}
				  elseif ($item_size_group == 'J' or $item_size_group == 'j') 
				  {
                  $sizes = array (
                        '1'	=> '30',
                        '2'	=> '31',
                        '3'	=> '32',
                        '4'	=> '33',
                        '5'	=> '34',
                        '6'	=> '36',
                        '7'	=> '38',
                        '8'	=> '40',
                        '9'	=> '42',
                        '10'	=> '44' ); 
					}
				  elseif ($item_size_group == 'c46') 
				  {
                  $sizes = array (
								'1'	=> '46',
								'2'	=> '48',
								'3'	=> '50',
								'4'	=> '52',
								'5'	=> '54',
								'6'	=> '56',
								'7'	=> '58',
								'8'	=> '60',
								'9'	=> '62',
								'10'	=> 'max' );
					}
				   elseif ($item_size_group == 'UK' or $item_size_group == 'EN') 
				   {
                  $item_size_group = 6;
                  $sizes = array (
                     '1'	=> $item_size_group,
                     '2'	=> $item_size_group + 2,
                     '3'	=> $item_size_group + 4,
                     '4'	=> $item_size_group + 6,
                     '5'	=> $item_size_group + 8,
                     '6'	=> $item_size_group + 10,
                     '7'	=> $item_size_group + 12,
                     '8'	=> $item_size_group + 14,
                     '9'	=> $item_size_group + 16,
                     '10'	=> 'max' ); 
					}
				  elseif ($item_size_group > 90 and $item_size_group < 100) 
				  { // само ДЕТСКИ //
                  $sizes = array (
                        '1'	=> $item_size_group,
                        '2'	=> $item_size_group + 12,
                        '3'	=> $item_size_group + 24,
                        '4'	=> $item_size_group + 36,
                        '5'	=> $item_size_group + 48,
                        '6'	=> $item_size_group + 60,
                        '7'	=> $item_size_group + 72,
                        '8'	=> $item_size_group + 84,
                        '9'	=> $item_size_group + 96,
                        '10'	=> 'max' ); 
               }
               elseif ($item_size_group == 105) 
               { // само КОЛАНИ //
                  $sizes = array (
                     '1'	=> $item_size_group,
                     '2'	=> $item_size_group + 5,
                     '3'	=> $item_size_group + 10,
                     '4'	=> $item_size_group + 15,
                     '5'	=> $item_size_group + 20,
                     '6'	=> $item_size_group + 25,
                     '7'	=> $item_size_group + 30,
                     '8'	=> $item_size_group + 35,
                     '9'	=> $item_size_group + 45,
                     '10'	=> $item_size_group + 55 ); 
					}
				  else 
				  {
                  $sizes = array (
                        '1'	=> $item_size_group,
                        '2'	=> $item_size_group + 2,
                        '3'	=> $item_size_group + 4,
                        '4'	=> $item_size_group + 6,
                        '5'	=> $item_size_group + 8,
                        '6'	=> $item_size_group + 10,
                        '7'	=> $item_size_group + 12,
                        '8'	=> $item_size_group + 14,
                        '9'	=> $item_size_group + 16,
                        '10'	=> 'max' ); 
               }
			}
			else { return ' ';}

		}
		else { return ' ';} 

	return $sizes;
	}

	public function get_named_sizes( $inum, $sizes)
	{
      if($sizes)
      {
         $qty = $qty_1 = $qty_2 = $qty_3 = $qty_4 = $qty_5 = $qty_6 = $qty_7 = $qty_8 = $qty_9 = $qty_10 = 0;
         $Qty = explode(',',$sizes);
         if($Qty)
         {
            $qty = $Qty[0];
            $qty_1 = $Qty[1]; $qty_2 = $Qty[2]; $qty_3 = $Qty[3]; $qty_4 = $Qty[4]; $qty_5  = $Qty[5];
            $qty_6 = $Qty[6]; $qty_7 = $Qty[7]; $qty_8 = $Qty[8]; $qty_9 = $Qty[9]; $qty_10 = $Qty[10];
         }
         $rezult = $this->give_me_sizes( $inum, $qty,
											 $qty_1, $qty_2, $qty_3, $qty_4, $qty_5,
											 $qty_6, $qty_7, $qty_8, $qty_9, $qty_10);
         return $rezult;
      }
      return '';
	}
	
	

	public function give_me_sizes( $item_number, $quantity,
											 $qty_1, $qty_2, $qty_3, $qty_4, $qty_5,
											 $qty_6, $qty_7, $qty_8, $qty_9, $qty_10)
	{
	if ( $quantity == 0 ) { return ' ';}

	$sizes_to_show = ' ';

	if ( $this->Item->exists_in_items($item_number) )
		{
			$sizes = $this->Item->get_sizes($item_number);
            $ssL = '('; $ssR = ')';

			$q_1='';if($qty_1!=0){if($qty_1==1 or $qty_1==-1){$q_1=$sizes[1].',';}else{$q_1=$sizes[1].$ssL.$qty_1.$ssR.',';}}
			$q_2='';if($qty_2!=0){if($qty_2==1 or $qty_2==-1){$q_2=$sizes[2].',';}else{$q_2=$sizes[2].$ssL.$qty_2.$ssR.',';}}
			$q_3='';if($qty_3!=0){if($qty_3==1 or $qty_3==-1){$q_3=$sizes[3].',';}else{$q_3=$sizes[3].$ssL.$qty_3.$ssR.',';}}
			$q_4='';if($qty_4!=0){if($qty_4==1 or $qty_4==-1){$q_4=$sizes[4].',';}else{$q_4=$sizes[4].$ssL.$qty_4.$ssR.',';}}
			$q_5='';if($qty_5!=0){if($qty_5==1 or $qty_5==-1){$q_5=$sizes[5].',';}else{$q_5=$sizes[5].$ssL.$qty_5.$ssR.',';}}
			$q_6='';if($qty_6!=0){if($qty_6==1 or $qty_6==-1){$q_6=$sizes[6].',';}else{$q_6=$sizes[6].$ssL.$qty_6.$ssR.',';}}
			$q_7='';if($qty_7!=0){if($qty_7==1 or $qty_7==-1){$q_7=$sizes[7].',';}else{$q_7=$sizes[7].$ssL.$qty_7.$ssR.',';}}
			$q_8='';if($qty_8!=0){if($qty_8==1 or $qty_8==-1){$q_8=$sizes[8].',';}else{$q_8=$sizes[8].$ssL.$qty_8.$ssR.',';}}
			$q_9='';if($qty_9!=0){if($qty_9==1 or $qty_9==-1){$q_9=$sizes[9].',';}else{$q_9=$sizes[9].$ssL.$qty_9.$ssR.',';}}
			$q_10='';if($qty_10!=0){if($qty_10==1 or $qty_10==-1){$q_10=$sizes[10].',';}else{$q_10=$sizes[10].$ssL.$qty_10.$ssR.',';}}

		// получаваме окончателният резултат ... без последната запетая ...
		$sizes_to_show = substr(' '.$q_1.$q_2.$q_3.$q_4.$q_5.$q_6.$q_7.$q_8.$q_9.$q_10,0,-1);
		}
		else { return ' ';} 

	return $sizes_to_show;
	}

	function aasort(&$array, $key) 
	{
		$sorter=array();
		$ret=array();
		reset($array);
		foreach ($array as $ii => $va) 
		{
			$sorter[$ii]=$va[$key];
		}
		asort($sorter);
		foreach ($sorter as $ii => $va) 
		{
			$ret[$ii]=$array[$ii];
		}
		$array=$ret;
	}

/* ========================= СПОМАГАТЕЛНИ ========================== */
	function get_vedom_data($ved)
	{
		$vedom = 'V'.$ved;
		$this->db->select(	
				  'doc_id,
					mode,
					mode_id,
					total_sum,
					total_taxes,
					pay_amount,
					pay_type',false);
		$this->db->from($vedom);
		$this->db->where('mode', 'razhod_due');
		$this->db->where('deleted',0);
		$this->db->where('location',0);
		$query = $this->db->get();
		if($query->num_rows()>0)
			{ return $query->result_array();}
		else
			{ return 0;}
	}

	function save_vedom_data($ved,$data)
	{
		$vedom  = 'V'.$ved;
		$doc_id = $data['doc_id'];
		$this->db->where('doc_id',$doc_id);
	return $this->db->update($vedom,$data);
	}
	
	
	
	
// ----------------------------------------- ДРУГИ ----------------------------------------- //
	public function get_document($mode)
	{
			$doc_document = $this->get_document_number($mode);
	return $doc_document;
	}


	public function get_document_keys( $mode='sale', $location=0 )
	{
		$doc_number = 0;
		$pay_group	= '';
		$doc_name	= 'doc-1';
		$doc_type 	= $mode;

			// първо да настроим НОМЕРА на Документа //
			switch ($mode) 
				{
				// sale modes ....
				case 'sale':	 		
							$doc_number = date('ym').'600000'; $pay_group = 'E';
							$doc_name	= $this->lang->line('sales_receipt_sale');
							break; 
				case 'sale_return':
							$doc_number = date('ym').'600000'; $pay_group = 'BE';
							$doc_name	= $this->lang->line('sales_receipt_return');
							break;
				case 'discount':
							$doc_number = date('ym').'600000'; $pay_group = 'ED';
							$doc_name	= $this->lang->line('sales_discount');
							break;
				case 'online_sale':
							$doc_number = date('ym').'400000'; $pay_group = 'OM';
							$doc_name	= $this->lang->line('sales_online_sale');
							break;
				case 'online_return':
							$doc_number = date('ym').'400000'; $pay_group = 'OMB';
							$doc_name	= $this->lang->line('sales_online_return');
							break;
				case 'prep_sale':
							$doc_number = date('ym').'000000'; $pay_group = 'EE';
							$doc_name	= $this->lang->line('sales_prepare_sale');
							break;
				case 'consi':	 		
							$doc_number = date('ym').'700000'; $pay_group = 'C';
							$doc_name	= $this->lang->line('sales_receipt_consi');
							break; 
				case 'invoice':
							$doc_number = '0'; $pay_group = 'F';
							$doc_name	= $this->lang->line('sales_receipt_invoice');
							break;
				case 'invoice_ki':
							$doc_number = '0'; $pay_group = 'Ki';
							$doc_name	= $this->lang->line('sales_receipt_invoice_ki');
							break;
				case 'invoice_di':
							$doc_number = '0'; $pay_group = 'Di';
							$doc_name	= $this->lang->line('sales_receipt_invoice_di');
							break; 
				case 'invoice_pr':
							$doc_number = '0'; $pay_group = 'Pr';
							$doc_name	= $this->lang->line('sales_receipt_invoice_pr');
							break; 
				case 'offer':
							$doc_number = date('ym').'500000';  $pay_group = 'Of';
							$doc_name	= $this->lang->line('sales_receipt_offer');
							break;
				case 'proforma':
							$doc_number = date('ym').'500000';  $pay_group = 'PF';
							$doc_name	= $this->lang->line('sales_receipt_proforma');
							break;
				case 'kit':
							$doc_number = date('ym').'300000';  $pay_group = 'KIT';
							$doc_name	= $this->lang->line('sales_kit');
							break;
				case 'brak':
							$doc_number = date('ym').'000000';  $pay_group = 'AB';
							$doc_name	= $this->lang->line('sales_receipt_scrap');
							break;
				case 'balance':
							$doc_number = date('ym').'000000';  $pay_group = 'BL';
							$doc_name	= $this->lang->line('sales_receipt_scrap');
							break;
				case 'shop_balance':
							$doc_number = date('ym').'000000';  $pay_group = 'BL';
							$doc_name	= $this->lang->line('sales_receipt_scrap');
							break; 
				case 'docs':
							$doc_number = date('ym').'000000';  $pay_group	= '';
							$doc_name	= $this->lang->line('sales_receipt_docs');
							break;
				// recv modes ...
				case 'manu':
							$doc_number = date('ym').'100000'; $pay_group = 'MK';
							$doc_name	= $this->lang->line('recvs_receipt_manu');
							break;
				case 'macka':
							$doc_number = date('ym').'100000'; $pay_group = 'MSK';
							$doc_name	= $this->lang->line('recvs_macka');
							break;
				case 'recv':
							$doc_number = date('ym').'200000'; $pay_group = 'D';
							$doc_name	= $this->lang->line('recvs_receipt_recv');
							break;
				case 'recv_return':
							$doc_number = date('ym').'200000'; $pay_groups = 'BD';
							$doc_name	= $this->lang->line('recvs_receipt_return');
							break;
				case 'usluga':
							$doc_number = date('ym').'200000'; $pay_groups = 'DY';
							$doc_name	= $this->lang->line('recvs_receipt_usluga');
							break;
				case 'qtynote':
							$doc_number = date('ym').'000000';  $pay_group = 'QN';
							$doc_name	= $this->lang->line('recvs_qtynote');
							break; 
				// error or Nothing ?!?!
				default:	$doc_number = 'doc-1'; $pay_groups = '';
							$doc_name	= $this->lang->line('sales_receipt');
				}

			// ако се издава документ от някой обект ...
		//	if ( !$location == 0 ) { $doc_number = $location . '-' . $doc_number; }

		// дата е ясна, ако не се иска нещо друго :) ?!?!
		$doc_date = date('Y-m-d');

		// също и режима на работа си остава за сега този от $mode ...
		$doc_type = $mode;

		// и така крайният резултат :
		$doc_keys = array (
			'doc_number'=> $doc_number,
			'doc_date'	=> $doc_date,
			'doc_name'	=> $doc_name,
			'mode'		=> $doc_type,
			'pay_group' => $pay_group );
	return $doc_keys;
	}


	function get_location_name($key)  // съмнително е дали работи ?!?!
	{
		$this->db->from('locations');	
		$this->db->where('locations.location_id', $key);
		$query = $this->db->get();
   return $query;
	}

function get_db_items_inv_location()
	{
      $location = $this->Employee->get_logged_in_employee_info()->location;
		$db_items_inv = 'items';
		if ( $location == 0) { $db_items_inv = 'items';}
		else { $db_items_inv = 'shops';}

		$vedom = $this->config->item('vedom_pack');
		$db_items_inv = $vedom . '_items';

   return $db_items_inv;
	}

	
	/*	Get location from user  моя функция */
	function get_db_items_location()
	{
	$location = $this->Employee->get_logged_in_employee_info()->location;

		$db_items = 'items';
		if ( $location == 0) { $db_items = 'items';}
		else { $db_items = 'shops';}

	return $db_items;
	}


/* =============== Gets information about magazin ================== */
	function get_magazin($location)
	{
		$this->db->from('shops');	
		$this->db->where('location = '.$location);
		$query = $this->db->get();
		
	return $query->row();
	}


/* =============== KACA ================== */
	function get_kaca_operation($mode='razhod')
	{  
		$kaca_oper='';
		switch ($mode) 
			{
				case 'prihod': 			$kaca_oper = $this->lang->line('kaca_prihod_all');  	  break;
				case 'prihod_invoice': 	$kaca_oper = $this->lang->line('kaca_prihod_invoice'); break;
				case 'prihod_cash': 		$kaca_oper = $this->lang->line('kaca_prihod_cash');	  break;
				case 'prihod_vat': 		$kaca_oper = $this->lang->line('kaca_prihod_cash_vat');	break;
				case 'prihod_sale': 		$kaca_oper = $this->lang->line('kaca_prihod_sale');	  break;
				case 'prihod_shop': 		$kaca_oper = $this->lang->line('kaca_prihod_shop');	  break;
				case 'prihod_courier': 	$kaca_oper = $this->lang->line('kaca_prihod_courier'); break;
				case 'prihod_duePyco': 	$kaca_oper = $this->lang->line('kaca_prihod_duePyco'); break;
				case 'prihod_pyco': 		$kaca_oper = $this->lang->line('kaca_prihod_pyco'); break;
				case 'prihod_notpaid':	$kaca_oper = $this->lang->line('kaca_prihod_notpaid'); break;
				case 'prihod_macka_zags': $kaca_oper = $this->lang->line('kaca_prihod_macka_zags'); break;
				case 'prihod_memo': 		$kaca_oper = $this->lang->line('kaca_by_memo');		  break;

				case 'razhod_due': 		$kaca_oper = $this->lang->line('kaca_razhod_due');	  break;
				case 'razhod_mat': 		$kaca_oper = $this->lang->line('kaca_razhod_mat');	  break;
				case 'razhod_matadd': 	$kaca_oper = $this->lang->line('kaca_razhod_matadd');  break;
				case 'razhod_matwork': 	$kaca_oper = $this->lang->line('kaca_razhod_matwork'); break;
				case 'razhod_matpack': 	$kaca_oper = $this->lang->line('kaca_razhod_mat_pack');break;
				case 'razhod_matship': 	$kaca_oper = $this->lang->line('kaca_razhod_mat_ship');break;
				case 'razhod_matax': 	$kaca_oper = $this->lang->line('kaca_razhod_mat_tax'); break;
				case 'razhod_goods': 	$kaca_oper = $this->lang->line('kaca_razhod_goods');   break;
				case 'razhod_goodship': $kaca_oper = $this->lang->line('kaca_razhod_goods_ship'); break;
				case 'razhod_goodstax': $kaca_oper = $this->lang->line('kaca_razhod_goods_tax');  break;
				case 'razhod_machine': 	$kaca_oper = $this->lang->line('kaca_razhod_machine'); break;
				case 'razhod_service': 	$kaca_oper = $this->lang->line('kaca_razhod_service'); break;
				case 'razhod_favour': 	$kaca_oper = $this->lang->line('kaca_razhod_favour');  break;
				case 'razhod_packs': 	$kaca_oper = $this->lang->line('kaca_razhod_packs');	  break;
				case 'razhod_office': 	$kaca_oper = $this->lang->line('kaca_razhod_office');  break;
				case 'razhod_ship': 		$kaca_oper = $this->lang->line('kaca_razhod_ship');    break;
				case 'razhod_customs': 	$kaca_oper = $this->lang->line('kaca_razhod_customs'); break;
				case 'razhod_taxes': 	$kaca_oper = $this->lang->line('kaca_razhod_taxes');	  break;
				case 'razhod_account': 	$kaca_oper = $this->lang->line('kaca_razhod_account'); break;
				case 'razhod_insurance': $kaca_oper = $this->lang->line('kaca_razhod_insurance'); break;
				case 'razhod_credit': 	$kaca_oper = $this->lang->line('kaca_razhod_credit');  break;
				case 'razhod_banktax': 	$kaca_oper = $this->lang->line('kaca_razhod_banktax'); break;
				case 'razhod_court': 	$kaca_oper = $this->lang->line('kaca_razhod_court');   break;
				case 'razhod_tok': 		$kaca_oper = $this->lang->line('kaca_razhod_tok');	  break;
				case 'razhod_build': 	$kaca_oper = $this->lang->line('kaca_razhod_build');	  break;
				case 'razhod_naem': 		$kaca_oper = $this->lang->line('kaca_razhod_naem');    break;
				case 'razhod_fuel': 		$kaca_oper = $this->lang->line('kaca_razhod_fuel');	  break;
				case 'razhod_gsm': 		$kaca_oper = $this->lang->line('kaca_razhod_gsm');	  break;
				case 'razhod_salary': 	$kaca_oper = $this->lang->line('kaca_razhod_salary');  break;
				case 'razhod_pyco': 		$kaca_oper = $this->lang->line('kaca_razhod_pyco');    break;
				case 'razhod_work': 		$kaca_oper = $this->lang->line('kaca_razhod_work');	  break;
				case 'razhod_market': 	$kaca_oper = $this->lang->line('kaca_razhod_market');  break;
				case 'razhod_promo': 	$kaca_oper = $this->lang->line('kaca_razhod_promo');	  break;
				case 'razhod_trips': 	$kaca_oper = $this->lang->line('kaca_razhod_trips');   break;
				case 'razhod_present': 	$kaca_oper = $this->lang->line('kaca_razhod_present'); break;
				case 'razhod': 			$kaca_oper = $this->lang->line('kaca_razhod_all');	  break;
				case 'razhod_notpaid': 	$kaca_oper = $this->lang->line('kaca_razhod_notpaid'); break;
				case 'razhod_memo': 		$kaca_oper = $this->lang->line('kaca_by_memo');		  break;
				
				case 'razhod_macka_zags': 		 $kaca_oper = $this->lang->line('kaca_razhod_macka_zags'); 			break;
				case 'razhod_macka_materials': $kaca_oper = $this->lang->line('kaca_razhod_macka_materials'); 	break;
				case 'razhod_macka_labour': 	 $kaca_oper = $this->lang->line('kaca_razhod_macka_labour');		break;
				case 'razhod_macka_work': 		 $kaca_oper = $this->lang->line('kaca_razhod_macka_work');			break;
				case 'razhod_macka_favours': 	 $kaca_oper = $this->lang->line('kaca_razhod_macka_favours');		break;
				case 'razhod_macka_tok_buk': 	 $kaca_oper = $this->lang->line('kaca_razhod_macka_tok_buk');		break;
				case 'razhod_macka_transport': $kaca_oper = $this->lang->line('kaca_razhod_macka_transport');	break;
				case 'razhod_macka_machines':  $kaca_oper = $this->lang->line('kaca_razhod_macka_machines');		break;
				case 'razhod_macka_stores': 	 $kaca_oper = $this->lang->line('kaca_razhod_macka_stores');		break;

				case 'sale':		 		$kaca_oper = $this->lang->line('kaca_prihod_sale');	  break;
				case 'sale_return':		$kaca_oper = $this->lang->line('kaca_razhod_sale');    break;
				case 'shop_sale':	 		$kaca_oper = $this->lang->line('kaca_prihod_shop');    break;
				case 'shop_return':		$kaca_oper = $this->lang->line('kaca_razhod_shop');    break;
				case 'recv':		 		$kaca_oper = $this->lang->line('kaca_razhod_items');   break;
				case 'recv_return': 		$kaca_oper = $this->lang->line('kaca_razhod_items_return');break;
				case 'recv_mat':			$kaca_oper = $this->lang->line('kaca_razhod_mat');	  break;
				case 'discount': 			$kaca_oper = $this->lang->line('kaca_razhod_discount'); break;

				case 'invoice': 			$kaca_oper = $this->lang->line('sales_receipt_invoice');    break;
				case 'invoice_ki': 		$kaca_oper = $this->lang->line('sales_receipt_invoice_ki'); break;
				case 'invoice_di': 		$kaca_oper = $this->lang->line('sales_receipt_invoice_di'); break;
				case 'invoice_pr': 		$kaca_oper = $this->lang->line('sales_receipt_invoice_pr'); break;

			default: $kaca_oper = '';
			}

	return $kaca_oper;
	}
	
	
	
	
// ------------------------------------------ ZIP ---------------------------------- //
	function unzip($file)
	{
    $zip=zip_open(realpath(".")."/".$file);
    if(!$zip) {return("Unable to proccess file '{$file}'");}

    $e='';
    while($zip_entry=zip_read($zip)) 
			{
				$zdir=dirname(zip_entry_name($zip_entry));
				$zname=zip_entry_name($zip_entry);

				if(!zip_entry_open($zip,$zip_entry,"r")) 
					{$e.="Unable to proccess file '{$zname}'";continue;}

				if(!is_dir($zdir)) 
					{ $this->mkdirr($zdir,0777);}

				$zip_fs=zip_entry_filesize($zip_entry);
				if(empty($zip_fs)) continue;

				$zz=zip_entry_read($zip_entry,$zip_fs);

				$z=fopen($zname,"w");
					fwrite($z,$zz);
					fclose($z);
				zip_entry_close($zip_entry);
			}
	zip_close($zip);
	return($e);
	}


	function mkdirr($pn,$mode=null) 
	{
	 if (is_dir($pn)||empty($pn)) return true;
		 $pn=str_replace(array('/', ''),DIRECTORY_SEPARATOR,$pn);

	 if (is_file($pn)) 
		 {trigger_error('mkdirr() File exists', E_USER_WARNING);return false;}

	  $next_pathname=substr($pn,0,strrpos($pn,DIRECTORY_SEPARATOR));
	  if ($this->mkdirr($next_pathname,$mode)) 
		  { 
		   if(!file_exists($pn)) { return mkdir($pn,$mode);} 
		  }
	return false;
	}

// ----------------------- END of ZIP -------------------- //

	/* Determine if a particular database exists */
	public function is_database_exists($database_name)
	{
		$query = $this->db->query("SHOW TABLES LIKE '$database_name'");
		// return in_array($database_name, $this->all_db_list());
	return TRUE;	
	}


// ================== ZEBEX DataBase =================== //
	function zebex_exists($inum, $mode=0)
	{
		$user_id = $this->get_person();
		if($mode and $user_id)
		{
			$this->db->from('zebex');
			$this->db->where('user_id',$user_id);
			$this->db->where('mode',$mode);
			$this->db->where('inum',$inum);
			$this->db->where('del',0);
			$query=$this->db->get();
			return ($query->num_rows()>=1);
		}
		else { return 0;}
	}
	
	function zebex_get($inum, $mode=0)
	{
		$user_id = $this->get_person();
		if($mode and $user_id)
		{
			$data = array();
			$this->db->from('zebex');
			$this->db->where('user_id',$user_id);
			$this->db->where('mode',$mode);
			$this->db->where('inum',$inum);
			$this->db->where('del',0);
			$query=$this->db->get();
			if($query->num_rows()==1) 
				{ return $query->row();}
		}
		else { return 0;}
	}
	
	function zebex_save(&$data,$mode=0)
	{
		$user_id = $this->get_person();
		$inum = $data['inum'];
		if($mode and $user_id and $inum>0)
		{
			if(!$this->zebex_exists($inum,$mode))
			{ return $this->db->insert('zebex',$data); }
			else
			{
				$this->db->where('user_id',$user_id);
				$this->db->where('mode',$mode);
				$this->db->where('inum',$inum);
				$this->db->where('del',0);
				return $this->db->update('zebex',$data);
			}
		}
		else { return 0; } 
	}
	
	function zebex_delete_item($inum,$mode=0)
	{
		$user_id = $this->get_person();
		if($mode and $user_id and $inum>0)
			{ return $this->db->delete('zebex',array('user_id'=>$user_id,'mode'=>$mode,'inum'=>$inum));}
		else 
			{ return 0;}
	}

	function zebex_get_all($mode=0,$limit=0,$offset=0)
	{
		$user_id = $this->get_person();
		if($mode and $user_id)
		{
			$this->db->from('zebex');
			$this->db->where('user_id',$user_id);
			$this->db->where('mode',$mode);
				if($offset>0) {$this->db->offset($offset);}
				if($limit>0)  {$this->db->limit($limit);}
			$this->db->where('del',0);
			$this->db->order_by('line', 'desc');
			$query=$this->db->get();
			if($query->num_rows()>0) 
				{ return $query->result_array();}
			else 
				{ return 0; }
		}
		else  { return 0; } 
	}

	
	function zebex_all_qty($mode=0)
	{
		$user_id = $this->get_person();
		if($mode and $user_id)
		{
			$this->db->select('
				user_id,
				mode,
				sum(qty) as all_qty,
				del',	false);

			$this->db->from('zebex');
			$this->db->where('user_id',$user_id);
			$this->db->where('mode',$mode);
			$this->db->where('del',0);
			$query=$this->db->get();
			if($query->num_rows()>0) 
				{ return $query->row()->all_qty; }
			else 
				{ return 0;}
		}
		else  { return 0;} 
	}	

	
	function zebex_get_blanka($mode=0)
	{
		$user_id = $this->get_person();
		if($mode and $user_id)
		{
			$this->db->select('line,inum,name,qty,q1,q2,q3,q4,q5,q6,q7,q8,q9,q10,sizes,price,dsc,skl',false);
			$this->db->from('zebex');
			$this->db->where('user_id',$user_id);
			$this->db->where('mode',$mode);
			$this->db->where('del',0);
			$this->db->order_by('line', 'desc');
			$query=$this->db->get();
			if($query->num_rows()>0) 
				{ return $query->result_array();}
			else 
				{ return 0; }
		}
		else  { return 0; } 
	}
	
	function zebex_get_revision()
	{
		$user_id = $this->get_person();
		if($user_id)
		{
			$this->db->select('line,inum,name,qty,q1,q2,q3,q4,q5,q6,q7,q8,q9,q10,sizes,price,dsc,skl',false);
			$this->db->from('zebex');
			$this->db->where('user_id',$user_id);
			$this->db->where('del',0);
			$this->db->order_by('line', 'acs');
			$query=$this->db->get();
			if($query->num_rows()>0) 
				{ return $query->result_array();}
			else 
				{ return 0; }
		}
		else  { return 0; } 
	}
	
	
	function zebex_edit( $mode, $inum, $line, $quantity, $allow_sizes, $price, $mprice, $discount,
							  $q1,$q2,$q3,$q4,$q5,$q6,$q7,$q8,$q9,$q10)
	{
		$user_id = $this->get_person();
		
	//	if($q1==0) {$q1='';} if($q2==0) {$q2='';} if($q3==0) {$q3='';} if($q4==0) {$q4='';} if($q5==0) {$q5='';}
	//	if($q6==0) {$q6='';} if($q7==0) {$q7='';} if($q8==0) {$q8='';} if($q9==0) {$q9='';} if($q10==0) {$q10='';}

		$data = array(
				'user_id' => $user_id,
					'inum' => $inum,
					'line' => $line,
					 'qty' => $quantity,
					  'q1' => (int)$q1, 'q2' => (int)$q2, 'q3' => (int)$q3, 'q4' => (int)$q4,  'q5' => (int)$q5,
					  'q6' => (int)$q6, 'q7' => (int)$q7, 'q8' => (int)$q8, 'q9' => (int)$q9, 'q10' => (int)$q10,
				  'price' => $price,
				 'mprice' => $mprice,
					 'dsc' => $discount,
				  'sizes' => $allow_sizes,
					 'del' => 0 );

			$this->zebex_save($data,$mode);
	return true;
	}
	
	function zebex_no_stock($item_id=0,$mode=0)
	{	
		if(!$item_id) { return false;}
		$skl_info = $this->Item->get_sklad_idx($item_id);
		$inum = $skl_info->inum;
		$qty = $skl_info->qty;
		$qty_added = 0;
		
		if($mode)
		{ 	
			$info = $this->zebex_get($inum,$mode);
			if($info)
			{ $qty_added = $info->qty;}
		}
		
		if ($qty-$qty_added<0) {return true;}
		else {return false;}
	}
	
/*	=========================== return zero =========================== */
	function turn_zeros($indata)
	{
		$outdata = array();
		if($indata!=0 and !empty($indata) and count($indata)>0)
		{
			foreach($indata as $line=>$item)
			{
				if(empty($item) or $item='') {$item=0;}
				$outdata[$line]=$item;
			}
		return $outdata;
		}
		else { return 0;}

	}
	
	
	
	
/*	=========================== ZEBEX TOTALS =========================== */
	function zebex_subtotal($mode='sale')
	{
		$subtotal = 0;
		$cart = $this->zebex_get_all($mode);

		if($cart)
		{
			if($mode=='online_sale')
			{
				foreach($cart as $item)
					{ $subtotal += $item['qty'] * round( $item['price'] * (100 - $item['dsc']) / 100, 7);}
			}
			else
			{
				foreach($cart as $item)
					{ $subtotal += $item['qty'] * round( $item['price'] * (100 - $item['dsc']) / 100, 7);}
			}
			
			if ( $mode == 'sale_return' or $mode == 'shop_return' or $mode == 'online_return') //тук се вкарат само върната стока
				{ $subtotal = -abs($subtotal);}
		}

		/* $giftcard  = $this->get_giftcard();
		$giftvalue = $this->get_giftvalue();
		if( is_numeric($giftvalue) and $giftvalue>0 and $giftvalue<1) 
		   { $subtotal -= $giftvalue * $subtotal;}
		elseif( is_numeric($giftvalue) and $giftvalue>=1 and $giftvalue<200)
			{	
				if( $subtotal > $giftvalue )
				  { $subtotal -= $giftvalue; }
				else
              { $subtotal = 0; }
			}
			
		$subtotal += $this->get_three4two_discount();
		*/
	
	return $subtotal;
	}

	function zebex_tax_VAT($mode='online_sale', $taxed=1)
	{
		$subtotal = $this->zebex_subtotal($mode);
		// добавяме ДДС-то ....
		$tax_VAT	= 0;

		if ( $mode == 'online_sale' or $mode == 'online_return' or $taxed)
			{ $tax_VAT = round( 20 * $subtotal / 100, 7);}

		if ( $taxed == 0 ) { $tax_VAT	= 0;}

	return round($tax_VAT,7);
	}

	
	function zebex_total($mode='sale',$customer_discount=0,$taxed=0)
	{
		$total = 0;
		$subtotal = $this->zebex_subtotal($mode);

		if ($mode == 'online_sale' or $mode == 'online_return') { $total = $subtotal;$taxed=1;}	
		else { $total = round( $subtotal * ( 100 - $customer_discount ) / 100, 7);}

		// добавяме ДДС-то +
		$total += round($this->zebex_tax_VAT($mode,$taxed),7);

	return $total;
	}
	
	// само ONLINES
	function zebex_online_total($mode='online_sale')
	{
		$subtotal = $this->zebex_subtotal($mode);
		$total = 1.2 * $subtotal;
	return $total;
	}
/*	=========================== END ZEBEX TOTALS =========================== */	
	
	
	function zebex_amount_due($mode=0)
	{
		$amount_due=0;
		if($mode)
		{
	
	
		}
	return $amount_due;
	}

	// Изчиства тек.$mode
	function zebex_clear_all($mode=0)
	{
		if($mode)
		{
			$user_id = $this->get_person();
			$this->db->delete('zebex',array('user_id'=>$user_id,'mode'=>$mode));
			return true;
		}
		else {return false;}
	}
	
	// Изчиства всичко на user_id при Login
	function zebex_delete()
	{
		$user_id = $this->get_person();
		if($user_id>0)
		{
			$this->db->delete('zebex',array('user_id'=>$user_id));
			return true;
		}
		else {return false;}
	}	
	
	
	
	// други
	function zebex_get_line($line=0,$mode=0)
	{
		if($mode)
		{
			$user_id = $this->get_person();
			$data = array();
			$this->db->from('zebex');
			$this->db->where('user_id',$user_id);
			$this->db->where('line',$line);
			$this->db->where('del',0);
			$query=$this->db->get();
			if($query->num_rows()==1) 
				{ return $query->row();}
			else { return false;}
		}
		else {return false;}
	}
	
	function zebex_save_line(&$data,$mode=0)
	{
		if($mode)
		{
			$user_id = $this->get_person();
			$line = $data['line'];

			$this->db->from('zebex');
			$this->db->where('user_id',$user_id);
			$this->db->where('mode',$mode);
			$this->db->where('line',$line);
			return $this->db->update('zebex',$data);
		}
		else {return false;}
	}
	
	function zebex_edit_line( $line, $quantity, $allow_sizes, $price, $mprice, $discount,
							  $q1,$q2,$q3,$q4,$q5,$q6,$q7,$q8,$q9,$q10)
	{
		$user_id = $this->get_person();
		$items = $this->zebex_get_line($line);
		if(isset($items->line))
		{
	//		if(!$q1){$q1='';} if(!$q2){$q2='';} if(!$q3){$q3='';} if(!$q4){$q4='';} if(!$q5){$q5='';}
	//		if(!$q6){$q6='';} if(!$q7){$q7='';} if(!$q8){$q8='';} if(!$q9){$q9='';} if(!$q10){$q10='';}
			
	
		if($q1=='') {$q1=0;} if($q2=='') {$q2=0;} if($q3=='') {$q3=0;} if($q4=='') {$q4=0;} if($q5=='') {$q5=0;}
		if($q6=='') {$q6=0;} if($q7=='') {$q7=0;} if($q8=='') {$q8=0;} if($q9=='') {$q9=0;} if($q10=='') {$q10=0;}
			
			$items->dsc = $discount;
			$items->price = $price;
			$items->mprice = $mprice;
			
		/*
			if($allow_sizes)
			{ $items->qty = $quantity.','.$q1.','.$q2.','.$q3.','.$q4.','.$q5.
											  ','.$q6.','.$q7.','.$q8.','.$q9.','.$q10;}
			else
			{ $items->qty = $quantity;}
		*/
			
			$items->qty = $quantity;
			
			$data = array(
				'user_id' => $user_id,
					'line' => $line,
					 'qty' => $items->qty,
					  'q1' => (int)$q1, 'q2' => (int)$q2, 'q3' => (int)$q3, 'q4' => (int)$q4,  'q5' => (int)$q5,
					  'q6' => (int)$q6, 'q7' => (int)$q7, 'q8' => (int)$q8, 'q9' => (int)$q9, 'q10' => (int)$q10,
				  'price' => $price,
				 'mprice' => $mprice,
					 'dsc' => $discount,
					 'del' => 0 );

			$this->zebex_save_line($data);
		}
	return false;
	}	
	
	function zebex_delete_line($mode=0,$line=0)
	{
		if($mode and $line)
		{
			$user_id = $this->get_person();
			return $this->db->delete('zebex',array('user_id'=>$user_id,'mode'=>$mode,'line'=>$line));
		}
		else {return false;}
	}
	
	
	/* ====================  ADD DOCUMENT ITEM  ==================== */
	function zebex_add_doc_item( $mode, $inum, $line, $quantity, $price, $discount, $Qty, $location)
	{ // пхп 7.4 - ( $mode, $inum, $line, $quantity=1, $price=0, $discount=0, $Qty=array(), $location)
		if($mode and $inum)
		{
			$error_key = 0;
			$user_id = $this->get_person();
			$skl = $this->get_user_mode_client();

			$sizes=0;
			$name='';$item_id=0;
			$item_info = $this->Item->get_blanka_info($inum);
			$skl_info  = $this->Item->get_sklad_info($inum,$skl);
				
			if($item_info) { $name=$item_info->name; $sizes=$item_info->allow_sizes; }
			if($skl_info)  { $item_id=$skl_info->item_id; }
			
			if($sizes) 
				{ 
					// обръщам ги в '0' ...
					$Qty[1] = (int)$Qty[1]; $Qty[2] = (int)$Qty[2]; $Qty[3] = (int)$Qty[3];
					$Qty[4] = (int)$Qty[4]; $Qty[5] = (int)$Qty[5]; $Qty[6] = (int)$Qty[6];
					$Qty[7] = (int)$Qty[7]; $Qty[8] = (int)$Qty[8]; $Qty[9] = (int)$Qty[9];
					$Qty[10] = (int)$Qty[10];
					
					$qty = $Qty[1]+$Qty[2]+$Qty[3]+$Qty[4]+$Qty[5]+$Qty[6]+$Qty[7]+$Qty[8]+$Qty[9]+$Qty[10];
				}
			else 
				{ $qty=$quantity;$Qty[1]=$Qty[2]=$Qty[3]=$Qty[4]=$Qty[5]=$Qty[6]=$Qty[7]=$Qty[8]=$Qty[9]=$Qty[10]=0;}
				
			$data = array(
					'user_id' => $user_id,
						'mode' => $mode,
						'inum' => $inum,
						  'id' => $item_id,
						'name' => $name,
					  'sizes' => $sizes,
						'line' => $line,
						 'qty' => $qty,
						  'q1' => $Qty[1], 'q2' => $Qty[2], 'q3' => $Qty[3], 'q4' => $Qty[4],  'q5' => $Qty[5],
						  'q6' => $Qty[6], 'q7' => $Qty[7], 'q8' => $Qty[8], 'q9' => $Qty[9], 'q10' => $Qty[10],
					  'price' => $price,
					 'mprice' => 0,
						 'dsc' => $discount,
						 'del' => 0 );
						 
			return $this->zebex_save($data,$mode);
		}
		else {return 0;}
	}
	
	
	/* ====================  ADD ONLINE ITEM  ==================== */
	function zebex_add_online_item( $mode, $inum, $line, $quantity, $price, $discount, $Qty, $location)
	{ // php 7 -> ( $mode, $inum, $line, $quantity=1, $price=0, $discount=0, $Qty=array(), $location)
		if($mode and $inum)
		{
			$error_key = 0;
			$user_id = $this->get_person();
			$skl = $this->get_user_mode_client();

			$sizes=0;
			$name='';$item_id=0;
			$item_online = $this->OnLine->get_online_item($inum);

			if($item_online) 
			{ 
				$name = $item_online->name_bg; 
				$allow_sizes = $this->OnLine->get_allow_sizes($inum);
			}
			
			if($allow_sizes) 
				{ 
					// обръщам ги в '0' ...
					$Qty[1] = (int)$Qty[1]; $Qty[2] = (int)$Qty[2]; $Qty[3] = (int)$Qty[3];
					$Qty[4] = (int)$Qty[4]; $Qty[5] = (int)$Qty[5]; $Qty[6] = (int)$Qty[6];
					$Qty[7] = (int)$Qty[7]; $Qty[8] = (int)$Qty[8]; $Qty[9] = (int)$Qty[9];
					$Qty[10] = (int)$Qty[10];
					
					$qty=$Qty[1]+$Qty[2]+$Qty[3]+$Qty[4]+$Qty[5]+$Qty[6]+$Qty[7]+$Qty[8]+$Qty[9]+$Qty[10];
				}
			else { $qty=$quantity;$Qty[1]=$Qty[2]=$Qty[3]=$Qty[4]=$Qty[5]=$Qty[6]=$Qty[7]=$Qty[8]=$Qty[9]=$Qty[10]=0;}
				
			$data = array(
					'user_id' => $user_id,
						'mode' => $mode,
						'inum' => $inum,
						  'id' => $item_id,
						'name' => $name,
					  'sizes' => $allow_sizes,
						'line' => $line,
						 'qty' => $qty,
						  'q1' => $Qty[1], 'q2' => $Qty[2], 'q3' => $Qty[3], 'q4' => $Qty[4],  'q5' => $Qty[5],
						  'q6' => $Qty[6], 'q7' => $Qty[7], 'q8' => $Qty[8], 'q9' => $Qty[9], 'q10' => $Qty[10],
					  'price' => $price,
					 'mprice' => 0,
						 'dsc' => $discount,
						 'del' => 0 );
						 
			return $this->zebex_save($data,$mode);
		}
		else {return 0;}
	}

	/* ====================  BARCODES ==================== */
	function zebex_add_barcode($item_code,&$line,$mode=0,$mprice=0)
	{
		if($mode and $item_code)
		{
         $skl = $this->get_user_mode_client();
			$user_id = $this->get_person();
			$lenBarcode=strlen($item_code);
			$inum=0;$error=0;

			// Normal 13 bit code
			$barcode = (int)substr($item_code,1,-1);
			$inum = (int) substr($barcode,0,5);
			$size_qty = (int) substr($barcode,7,2);
			$sizeQty = 0; $allow_sizes=0;
			
			if($inum>9999) 
				{ 
					$item_info = $this->Item->get_blanka_info($inum);
					if($item_info) { $allow_sizes = $item_info->allow_sizes; }
					else { $error=1; }
				}
			else 
				{	$item_info = 0; }

			if(true) // !$error
			{
				$Qty=array();
				$Qty[1]=$Qty[2]=$Qty[3]=$Qty[4]=$Qty[5]=$Qty[6]=$Qty[7]=$Qty[8]=$Qty[9]=$Qty[10]=0;
		
				
				// определя по размери... да се добавят колани и обувки...
				if ($size_qty > 0 and $size_qty < 11) { $Qty[$size_qty] = 1;}
				else 
					{  // различните размерни групи .....
						if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
						if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
						if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
						if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

						if ($size_qty > 10 and $size_qty < 100) 
							{$size_qty = floor($size_qty/2) - $sizeQty;}

						if ($size_qty > 9) { $Qty[10] = 1; }
						elseif ($size_qty == 0) { }
						else { $Qty[$size_qty] = 1; }
					}

				// добавя артикул към Zebex.	
				if(!$this->zebex_exists($inum,$mode)) // нов артикул Zebex
				{
				//	$skl = 0;
				//	if($mode=='consi' or $mode=='consi_sale') { $skl = $this->get_user_mode_client();}
					
					$price=$discount=$sizes=0;
					$name='';$item_id=0;
					$item_info = $this->Item->get_blanka_info($inum);
					if($item_info) { $name=$item_info->name; $sizes=$item_info->allow_sizes;}
					
					$skl_info  = $this->Item->get_sklad_info($inum,$skl); // 
					if($skl_info)  
					{ 
							$item_id=$skl_info->item_id;
							$discount=$skl_info->dsc;
							$price=$skl_info->price;
							switch ($mprice) 
							{
								case '1': $price = (float)$skl_info->price;   break;
								case '2': $price = (float)$skl_info->price_2; break;
								case '3': $price = (float)$skl_info->price_3; break;
								case '4': $price = (float)$skl_info->price_4; break;
								case '5': $price = (float)$skl_info->price_5; break;
								default:  $price = (float)$skl_info->price;
							}
							//ценова политика ?!
							if(!$price and $skl_info->price_2) 
								{$price = $skl_info->price_2;}
							if($mode=='manu') {$price = $skl_info->cost;}
							elseif($mode!='sale' and $mode!='sale_return' and $skl_info->price_3>0) 
								{$price = $skl_info->price_3;}
					}
					else
					{
						$skl_info  = $this->Item->get_sklad_info($inum,0); // взимам от СГП
						if($skl_info)  // има го при нас ...
						{
							$discount=(float)$skl_info->dsc;
							$price=(float)$skl_info->price;
							switch ($mprice) 
							{
								case '1': $price = (float)$skl_info->price;   break;
								case '2': $price = (float)$skl_info->price_2; break;
								case '3': $price = (float)$skl_info->price_3; break;
								case '4': $price = (float)$skl_info->price_4; break;
								case '5': $price = (float)$skl_info->price_5; break;
								default:  $price = (float)$skl_info->price;
							}
							//ценова политика ?!
							if(!$price and $skl_info->price_2) 
								{ $price = (float)$skl_info->price_2; }
							if((int)$skl_info->price_3>0 and (int)$skl_info->price_2) 
								{
									$price = (float)$skl_info->price_3;
									if($mode=='consi')
									{
										$price = (float)$skl_info->price_2;
										$discount = 100*( (float)$skl_info->price_2 - (float)$skl_info->price_3) / (float)$skl_info->price_2;
									}
								}
						}
						else { $price=0;} // нямам друг избор ?!
					}
				
					if($allow_sizes)
					{ $qty=$Qty[1]+$Qty[2]+$Qty[3]+$Qty[4]+$Qty[5]+$Qty[6]+$Qty[7]+$Qty[8]+$Qty[9]+$Qty[10];}
					else {$qty=1;}
					
					$data = array(
                 'user_id' => $user_id,
                    'mode' => $mode,
                    'inum' => $inum,
							 'id' => $item_id,
						  'name' => $name,
						 'sizes' => $sizes,
                    'line' => $line,
							'qty' => $qty,
							 'q1' => $Qty[1], 'q2' => $Qty[2], 'q3' => $Qty[3], 'q4' => $Qty[4],  'q5' => $Qty[5],
							 'q6' => $Qty[6], 'q7' => $Qty[7], 'q8' => $Qty[8], 'q9' => $Qty[9], 'q10' => $Qty[10],
						 'price' => $price,
						'mprice' => $mprice,
							'dsc' => $discount,
							'skl' => $skl,
							'del' => 0 );

					$line++;
				}
				else // съществува вече в Zebex
				{
					$item_zbx = $this->zebex_get($inum,$mode);
					if($allow_sizes)
					{
						if($item_zbx->q1>0) {$Qty[1]+=$item_zbx->q1;}
						if($item_zbx->q2>0) {$Qty[2]+=$item_zbx->q2;}
						if($item_zbx->q3>0) {$Qty[3]+=$item_zbx->q3;}
						if($item_zbx->q4>0) {$Qty[4]+=$item_zbx->q4;}
						if($item_zbx->q5>0) {$Qty[5]+=$item_zbx->q5;}
						if($item_zbx->q6>0) {$Qty[6]+=$item_zbx->q6;}
						if($item_zbx->q7>0) {$Qty[7]+=$item_zbx->q7;}
						if($item_zbx->q8>0) {$Qty[8]+=$item_zbx->q8;}
						if($item_zbx->q9>0) {$Qty[9]+=$item_zbx->q9;}
						if($item_zbx->q10>0) {$Qty[10]+=$item_zbx->q10;}
						$qty=$Qty[1]+$Qty[2]+$Qty[3]+$Qty[4]+$Qty[5]+$Qty[6]+$Qty[7]+$Qty[8]+$Qty[9]+$Qty[10];
					}
					else
					{ $qty = 1+$item_zbx->qty;}

					$data = array(
                 'user_id' => $user_id,
                    'mode' => $mode,
                    'inum' => $inum,
							'qty' => $qty,
							 'q1' => $Qty[1], 'q2' => $Qty[2], 'q3' => $Qty[3], 'q4' => $Qty[4],  'q5' => $Qty[5],
							 'q6' => $Qty[6], 'q7' => $Qty[7], 'q8' => $Qty[8], 'q9' => $Qty[9], 'q10' => $Qty[10],
							'skl' => $skl,
							'del' => 0 );
				}
				return $this->zebex_save($data,$mode);
			}
			else { return 0; }
		}
		else { return 0; }
	}
	
	
	public function zebex_cart_pages($mode=0)
	{
		$user_id = $this->get_person();
		if($mode)
		{
			$this->db->from('zebex');
			$this->db->where('user_id',$user_id);
			$this->db->where('mode',$mode);
			$this->db->where('del',0);
		}
		$this->db->order_by('inum', 'asc');
		return $this->db->count_all_results();
	}
	

   public function ean13_check_digit($digits)
   {
      //first change digits to a string so that we can access individual numbers
      $digits =(string)$digits;
      // 1. Add the values of the digits in the even-numbered positions: 2, 4, 6, etc.
      // $even_sum1 = $digits{1} + $digits{3} + $digits{5} + $digits{7} + $digits{9} + $digits{11};
      $even_sum  = (int)substr($digits,1,1) + (int)substr($digits,3,1) + (int)substr($digits,5,1) + 
                   (int)substr($digits,7,1) + (int)substr($digits,9,1) + (int)substr($digits,11,1);
      // 2. Multiply this result by 3.
      $even_sum_three = $even_sum * 3;
      // 3. Add the values of the digits in the odd-numbered positions: 1, 3, 5, etc.
      $odd_sum = (int)substr($digits,0,1) + (int)substr($digits,2,1) + (int)substr($digits,4,1) + 
                 (int)substr($digits,6,1) + (int)substr($digits,8,1) + (int)substr($digits,10,1);
      // 4. Sum the results of steps 2 and 3.
      $total_sum = $even_sum_three + $odd_sum;
      // 5. The check character is the smallest number which, when added to the result in step 4,  produces a multiple of 10.
      $next_ten = (ceil($total_sum/10))*10;
      $check_digit = $next_ten - $total_sum;
       
      return $digits . $check_digit;
   }	
	
	
	
// ----------------------- RATING -------------------- //
// CUSTOMERS
	function customer_rating($bisoft_id,$suma) 
	{
		$rating = $this->Customer->get_info_by_bisoft_id($bisoft_id)->rating;
		$new_rating = $rating + round($suma/100, 0);
		$data = array('rating'=>$new_rating);
			$this->db->trans_start();
			$this->db->where('bisoft_id', $bisoft_id);
			$this->db->update('customers',$data);
			$this->db->trans_complete();		
	return true;
	}

// SUPPLIERS
	function supplier_rating($bisoft_id,$suma)
	{
		$rating = $this->Supplier->get_info_by_bisoft_id($bisoft_id)->rating;
		$new_rating = $rating + round($suma/100, 0);
		$data = array('rating'=>$new_rating);
			$this->db->trans_start();
			$this->db->where('bisoft_id', $bisoft_id);
			$this->db->update('suppliers',$data);
			$this->db->trans_complete();
	return true;
	}
	
	
// ----------------------- END OF RATING -------------------- //
	function get_egn_id()
	{
		$this->db->from('people');
		$this->db->where('egn_id > 0');
		$this->db->where('norma > 0');
		$this->db->order_by("egn_id", "asc");
		$query = $this->db->get();
	return $query->result_array();
	}
	
	
/* ================================= MAILING =================================== */
	function send_an_email($email,$title,$msg)
	{
		$this->load->library('email');
		$config['mailtype'] = 'html';				
		$this->email->initialize($config);
		$this->email->from($this->config->item('email'), $this->config->item('company_eng'));
		$this->email->to($email); 
		$this->email->subject($title);
		$this->email->message($msg);	
		$success=$this->email->send();
	return $success;
	}
	
	
	
/* ================================= CALENDAR =================================== */
	function get_vedom_in_words($vedom)
	{
		$months = array(
			'1' => $this->lang->line('cal_january'),
			'2' => $this->lang->line('cal_february'),
			'3' => $this->lang->line('cal_march'),
			'4' => $this->lang->line('cal_april'),
			'5' => $this->lang->line('cal_mayl'),
			'6' => $this->lang->line('cal_june'),
			'7' => $this->lang->line('cal_july'),
			'8' => $this->lang->line('cal_august'),
			'9' => $this->lang->line('cal_september'),
		  '10' => $this->lang->line('cal_october'),
		  '11' => $this->lang->line('cal_november'),
		  '12' => $this->lang->line('cal_december') );
		
		$inwords = $months[(int)substr($vedom,2,2)];
		$inwords .= '.20'.substr($vedom,0,2);
		
	return $inwords;
	}

	function get_common_months_years()
	{
		$data = array();
		$data['months'] = get_months();
		$data['days'] = get_days();
		$data['years'] = get_years();
		$data['selected_month']=date('n');
		$data['selected_day']=date('d');
		$data['selected_year']=date('Y');	
	
	return $data;
	}

	function get_months()
	{
		$CI =& get_instance();
		$CI->load->language('calendar');
	
		$months = array();
		for($k=1;$k<=12;$k++)
		{
			$cur_month = mktime(0, 0, 0, $k, 1, 2000);
			$months[date("m", $cur_month)] = date("M",$cur_month);
		}

		$months['01'] = $CI->lang->line('cal_january');
		$months['02'] = $CI->lang->line('cal_february');
		$months['03'] = $CI->lang->line('cal_march');
		$months['04'] = $CI->lang->line('cal_april');
		$months['05'] = $CI->lang->line('cal_mayl');
		$months['06'] = $CI->lang->line('cal_june');
		$months['07'] = $CI->lang->line('cal_july');
		$months['08'] = $CI->lang->line('cal_august');
		$months['09'] = $CI->lang->line('cal_september');
		$months['10'] = $CI->lang->line('cal_october');
		$months['11'] = $CI->lang->line('cal_november');
		$months['12'] = $CI->lang->line('cal_december');

	return $months;
	}

	function get_short_months()
	{
		$CI =& get_instance();
		$CI->load->language('calendar');
		
		$months['01'] = $CI->lang->line('cal_jan');
		$months['02'] = $CI->lang->line('cal_feb');
		$months['03'] = $CI->lang->line('cal_mar');
		$months['04'] = $CI->lang->line('cal_apr');
		$months['05'] = $CI->lang->line('cal_may');
		$months['06'] = $CI->lang->line('cal_jun');
		$months['07'] = $CI->lang->line('cal_jul');
		$months['08'] = $CI->lang->line('cal_aug');
		$months['09'] = $CI->lang->line('cal_sep');
		$months['10'] = $CI->lang->line('cal_oct');
		$months['11'] = $CI->lang->line('cal_nov');
		$months['12'] = $CI->lang->line('cal_dec');
		
	return $months;
	}

	function get_days()
	{	$days = array();
		for($k=1;$k<=31;$k++)
		{
			$cur_day = mktime(0, 0, 0, 1, $k, 2000);
			$days[date('d',$cur_day)] = date('j',$cur_day);
		}
	return $days;
	}


	function get_years()
	{	$years = array();
		for($k=0;$k<4;$k++)
         { $years[date("Y")-$k] = date("Y")-$k;}
	return $years;
	}

	
	function get_month_limit($month,$year)
	{
		$m_limit=31;$r_year = $year/4 - round($year/4,0); 
		switch ($month) 
			{
				case '02': $m_limit=28; break;
				case '04': $m_limit=30; break;
				case '06': $m_limit=30; break;
				case '09': $m_limit=30; break;
				case '11': $m_limit=30; break;
			}

		if($month=='02' and !$r_year) {$m_limit=29;}

	return $m_limit;
	}

	
	function get_month_holidays($month,$year)
	{
		$holidays = array();
		$m_limit  = $this->get_month_limit($month,$year);
		for($k=1;$k<=$m_limit;$k++)
		{
			$holidays[$k]=0;
			$dayW = date('N', strtotime($year.'-'.$month.'-'.$k) );
			if($dayW==6) {$holidays[$k]=1;} // събота
			if($dayW==7) {$holidays[$k]=2;} // неделя
			if($this->get_special_day($k,$month)) {$holidays[$k]=9;} // празник
			if($this->get_other_workday($k,$month)) {$holidays[$k]=0;} // работни дни през събота/неделя
		}

	return $holidays;
	}

	// празници //
	function get_special_day($day,$month)
	{
		$s_day = 0; 
		$day 	 = str_pad($day,2,"0",STR_PAD_LEFT);
		$month = str_pad($month,2,"0",STR_PAD_LEFT);
		$h_day = $day.'-'.$month;

		switch ($h_day) 
		{
		  case '01-01': $s_day=1; break;
		  case '02-01': $s_day=1; break;
		  case '03-03': $s_day=1; break;

				case '22-04': $s_day=1; break;
				case '25-04': $s_day=1; break; // ПРОМЕНЛИВ после Великден - за 2022 ?!
			
        case '01-05': $s_day=1; break;
        case '02-05': $s_day=1; break;  // заради 1-ви май неделя
		  case '06-05': $s_day=1; break;  // след Гергьовден
		  case '24-05': $s_day=1; break;

		  case '06-09': $s_day=1; break;
		  case '22-09': $s_day=1; break;

				case '24-12': $s_day=1; break;
				case '25-12': $s_day=1; break;
				case '26-12': $s_day=1; break;
				case '27-12': $s_day=1; break;
				case '28-12': $s_day=1; break;

		// case '31-12': $s_day=1; break;
		}					
	return $s_day;	
	}

	// работни дни през събота и неделя //
	function get_other_workday($day,$month)
	{
		$s_day = 0; 
		$day 	 = str_pad($day,2,"0",STR_PAD_LEFT);
		$month = str_pad($month,2,"0",STR_PAD_LEFT);
		$h_day = $day.'-'.$month;
		
		/* Спряна от 13-04-2018 - дел.дни като празници :) */
		switch ($h_day) 
		{
			// case '03-01': $s_day=1; break;
		}

	return $s_day;	
	}

	// връща ВСИЧКИ Раб.Дни за месеца на фирмата //
	function get_month_all_workdays($month,$year)
	{
		$workdays = 0;
		$days = array();
		$m_limit  = $this->get_month_limit($month,$year);
		for($k=1;$k<=$m_limit;$k++)
		{
			$days[$k]=0;
			$dayW = date('N', strtotime($year.'-'.$month.'-'.$k) );
			if($dayW!=6 and $dayW!=7) {$days[$k]=1;}
			if($this->get_special_day($k,$month)) {$days[$k]=0;} // национален празник
			if( ($dayW==6 or $dayW==7) and $this->get_other_workday($k,$month)) {$days[$k]=1;} // работни дни през събота/неделя
			
			// финал:
			if($days[$k]==1) {$workdays++;}
		}
	return $workdays;
	}
	
	// връща кодове на дните за месеца //
	function get_month_code_days($month,$year)
	{
		$days = array();
		$m_limit = $this->get_month_limit($month,$year);
		for($k=1;$k<=$m_limit;$k++)
		{
			$days[$k]=1;
			$dayW = date('N', strtotime($year.'-'.$month.'-'.$k) );
			if($dayW!=6 and $dayW!=7) {$days[$k]=0;}
			if($this->get_special_day($k,$month)) {$days[$k]=2;} // национален празник
			if( ($dayW==6 or $dayW==7) and $this->get_other_workday($k,$month)) {$days[$k]=0;} // работни дни през събота/неделя
		}
	return $days;
	}
	
	
	public function check_calendar($date)
	{
		$event = false; $styler = false; if($this->config->item('my_account_number')=='115752718'){$styler = true;}
		$egns = $this->get_egn_id();
		// проверява ДНЕС //
		$num_birthdays=0;
		$imen_today=$event_today=$event_end=$birthday=$add_birthday='';
		$exact_day = date('md',strtotime($date));
		
		switch ($exact_day) 
         {  // ПРАЗНИЧНИ И ИМЕННИ ДНИ
				case '0101': $imen_today='Днес е ВАСИЛЬОВДЕН, Поздравяваме Васил,Василка,Веска и Веско.'; break;
				case '0106': $imen_today='Днес е БОГОЯВЛЕНИЕ-ЙОРДАНОВДЕН, Поздравяваме Йордан,Йорданка,Данче,Данчо,Даниели.'; break;
				case '0107': $imen_today='Днес е Св.ЙОАН КРЪСТИТЕЛ, Поздравяваме Иванка,Иван,Ваня,Ваньо.'; break;
				case '0112': $imen_today='Днес е ТАТЯНИНДЕН, Поздравяваме Таня,Татяна,Траяна.'; break;
				case '0117': $imen_today='Днес е АНТОНОВДЕН, Поздравяваме Антоанета,Антони,Тони,Тотка.'; break;
				case '0118': $imen_today='Днес е АТАНАСОВДЕН, Поздравяваме Атанаска,Атанас,Наска,Наско.'; break;
				
				// Свилка, Свилка къде си сега приятелю ?!
				case '0211': $imen_today='Почитаме паметта на СВИЛЕН КАНЕВСКИ, скърбим с всички роднини и приятели.'; break;
					
				case '0214': $imen_today='Днес е Св.ВАЛЕНТИН,ТРИФОН ЗАРЕЗАН Поздравяваме Валентина,Вальо,Трифон и всички любители на виното.'; break;
				case '0301': $imen_today='Днес Поздравяваме всички с ЧЕСТИТА БАБА МАРТА !!!'; break;
				case '0308': $imen_today='Днес Поздравяваме всички момиченца и девойки,любими жени,майки и баби с ЧЕСТИТ 8-ми МАРТ !!!'; break;
				case '0321': if($styler) { $birthday='Днес Фирмен Магазин STYLER-1'; $event_end=" има ДЕН НА ОТКРИВАНЕ!"; } break;
				
				// променлив = 2023
				case '0304': $imen_today='Днес е ТОДОРОВДЕН Поздравяваме Тодор, Тошко, Юлиян, Тея ...'; break;
			//	case '0308': $imen_today='Днес е ТОДОРОВДЕН Поздравяваме Тодор, Тошко, Юлиян, Тея ...'; break; // 2025
			//	case '0323': $imen_today='Днес е ТОДОРОВДЕН Поздравяваме Тодор, Тошко, Юлиян, Тея ...'; break; // 2024
			
				case '0325': $imen_today='Днес е БЛАГОВЕЩЕНИЕ, Поздравяваме Благовеста,Блага и Благой.'; break;
				
				// променливи = 2023
				case '0408': $imen_today='Днес е ЛАЗАРОВДЕН, Поздравяваме Лазарка,Лазар,Лазарин.'; break;
				case '0409': $imen_today='Днес е ЦВЕТНИЦА, Поздравяваме Цветанка,Теменужка,Алена и всички др.цветя'; break;
				case '0410': $imen_today='Вчера беше ЦВЕТНИЦА, Поздравяваме Цветанка,Теменужка,Алена и всички др.цветя'; break;
				case '0416': $imen_today='ХРИСТОС ВОЗКРЕСЕ - ВО ИСТИНА ВОСКРЕСЕ!'; break;
				case '0417': $imen_today='ХРИСТОС ВОЗКРЕСЕ - ВО ИСТИНА ВОСКРЕСЕ!'; break;

				case '0501': $imen_today='Днес е ДЕН НА ТРУДА, Поздравяваме всички трудещи се !!!'; break;
				case '0506': $imen_today='Днес е ГЕРГЬОВДЕН, Поздравяваме Георги,Гергана,Галя,Ганка.'; break;
				case '0521': $imen_today='Днес е Св.КОНСТАНТИН И ЕЛЕНА, Поздравяваме Елена,Коце и Костадинка.'; break;
				case '0524': $imen_today='Днес е Св.КИРИЛ И МЕТОДИЙ, Поздравяваме Кирил,Методий и споменаваме Свилен Каневски.'; break;
         
				// променлив = 2023
				case '0525': $imen_today='Днес е СПАСОВДЕН, Поздравяваме Спаска,Спас,Сотир.'; break; // 2023 променлив ?!
         // case '0529': $imen_today='Днес е СПАСОВДЕН, Поздравяваме Спаска,Спас,Сотир.'; break; // 2025 променлив ?!
         // case '0603': $imen_today='Днес е СПАСОВДЕН, Поздравяваме Спаска,Спас,Сотир.'; break; // 2024 променлив ?!
            
            case '0624': $imen_today='Днес е ЕНЬОВДЕН, Поздравяваме Еньо,Янка,Янчо,Биляна,Деница,Деян.'; break;
            case '0629': $imen_today='Днес е ПЕТРОВДЕН, Поздравяваме Петранка,Петьо,Кремена,Павел,Павлина.'; break;
            case '0717': $imen_today='Днес е Св.МАРИНА, Поздравяваме Марина,Марин,Маринела,Марчо.'; break;
            case '0720': $imen_today='Днес е Св.ИЛИЯ-ИЛИНДЕН, Поздравяваме Илияна и Илия.'; break;
            case '0722': $imen_today='Днес е Св.МАРИЯ-МАГДАЛИНА, Поздравяваме Магда,Магдалена,Мидлена.'; break;
            case '0812': $imen_today='Днес е Св.БИСТРА МЪЧЕНИЦА (католич.), Поздравяваме Бистра и Бисер.'; break;
            case '0815': $imen_today='Днес е УСПЕНИЕ БОГОРОДИЧНО, Поздравяваме Мария,Марияна,Мариела,Преслава.'; break;
            case '0917': $imen_today='Днес е ВЯРА-НАДЕЖДА-ЛЮБОВ, Поздравяваме Вера,Надежда,Любка,Любомир,София'; break;
            case '1026': $imen_today='Днес е ДИМИТРОВДЕН, Поздравяваме Димитрина,Димитър,Митко,Димо.'; break;
            case '1108': $imen_today='Днес е АРХАНГЕЛ МИХАИЛ, Поздравяваме Ангелина,Ангел,Радка,Рангел,Милан.'; break;
            case '1111': $imen_today='Днес е Св.МИНА, Поздравяваме Минка,Минчо,Виктория,Виктор.'; break;
            case '1130': $imen_today='Днес е АДРЕЕВДЕН, Поздравяваме Андрей,Адрианa,Първан.'; break;
				case '1201': if($styler) {$birthday='Днес STYLER';$event_end=" има ДЕН НА ОТКРИВАНЕ!";} break;
				case '1205': $imen_today='Днес е САВА ОСВЕЩЕНИЙ, Поздравяваме Десислава,Сава,Светослав,Станислав,Владислав.'; break;
				case '1206': $imen_today='Днес е НИКУЛДЕН, Поздравяваме Николина,Николай,Нина,Николина,Кольо и Нено.'; break;
				case '1209': $imen_today='Днес е Св.АННА, Поздравяваме Анна,Аня,Анета,Анелия и внучката ми Анжелинка с Рожден Ден!'; break;
				case '1223': $imen_today='Днес е Св.НАУМ ОХРИДСКИ, Поздравяваме Наум'; break;
				case '1224': $imen_today='Днес е Рождество Христово! Поздравяваме всички с този Голям Празник!'; break;
				case '1227': $imen_today='Днес е СТЕФАНОВДЕН, Поздравяваме Стефани,Стефан,Стоян,Стоянка,Цанка,Цонко.'; break;
         }

		foreach ($egns as $person) 
			{ 
				$person_day = substr($person['egn_id'],2,4);
				// нов календар след 2000г.
				if((int)$person_day>4000) { $person_day -= 4000; }
				
            if($exact_day==$person_day)
               { 
                  $event_today='Днес';$event_end=" има РОЖДЕН ДЕН!";
                  $birthday.=$add_birthday.$person['first_name'].' '.$person['last_name'];$add_birthday=' и ';$num_birthdays++;
               }
            if($num_birthdays>1) 
               { $event_today='Днес';$event_end=" имат РОЖДЕН ДЕН!";}
			} 

		if(!empty($imen_today) or !empty($birthday)) 
         { $event = $imen_today.'&nbsp;'.$event_today.'&nbsp;'.$birthday.$event_end;}

	return $event;	
	}

	// CALENDAR new ...
	public function calendar_exists($period)
	{
		$this->db->from('calendar');	
		$this->db->where('period',$period);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	public function calendar_get($period)
	{
		if($this->calendar_exists($period))
		{
			$this->db->from('calendar');	
			$this->db->where('period',$period);	
		return $this->db->get()->result_array();
		}
		else {return false;}
	}
	
	public function calendar_save($period,$data)
	{
		$success=false;
		if(!$this->calendar_exists($period)) // new record
		{
			$this->db->trans_start();
				$success = $this->db->insert('calendar',$data);
			$this->db->trans_complete();		
		}
		else // only update
		{
			$this->db->trans_start();
				$this->db->where('period', $period);
				$success = $this->db->update('calendar',$data);
			$this->db->trans_complete();
		}
	return $success;
	}
	
	public function calendar_update($period,$data)
	{
		$success=false;
		if($this->calendar_exists($period))
		{
			$this->db->trans_start();
				$this->db->where('period', $period);
				$success = $this->db->update('calendar',$data);
			$this->db->trans_complete();		
		}
	return $success;
	}
	
	// BGN to LEU rate convertor
	public function set_leu_rate()
	{
      $rate_leu = 2.5; // start value
/*      
      $rate_usd = $rate_euro = 1;
      
      // Romania ip
      $ip = "103.249.70.255";
      $geo_usd  = @unserialize(file_get_contents('http://www.geoplugin.net/php.gp?ip='.$ip));
      if($geo_usd) { $rate_usd = (float)$geo_usd['geoplugin_currencyConverter']; }

      // Europe Germany ip
      $ip = "5.5.5.5";
      $geo_euro  = @unserialize(file_get_contents('http://www.geoplugin.net/php.gp?ip='.$ip));
      if($geo_euro) { $rate_euro = (float)$geo_euro['geoplugin_currencyConverter']; }

      if(is_numeric($rate_usd) and is_numeric($rate_euro))
      { $rate_leu = round( $rate_usd / ( $rate_euro * 1.95583 ), 4); }
*/

      $curl = curl_init();

      curl_setopt_array($curl, array(
      CURLOPT_URL => "https://api.apilayer.com/fixer/convert?to=RON&from=BGN&amount=1",
      CURLOPT_HTTPHEADER => array(
         "Content-Type: text/plain",
         "apikey: RgqdStWDcgOypmeo2zvStZGzzIgWQXUr"
                                    ),
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 0,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "GET"
      ));

      $response = curl_exec($curl);

      curl_close($curl);
      if($response) { $rate_leu = (float) json_decode($response)->result; }

      if($rate_leu)
      { $this->OnLine->save_settings( 'rate_RON', round($rate_leu,5) ); }
 
      return $rate_leu;
	}
	
	public function get_leu_rate()
	{
      $rate_leu = $this->OnLine->get_text('rate_RON');
      return $rate_leu;
	}
	
}
?>
