<?php class Delivered extends CI_Model
{
	function get_all()
	{
	$location = $this->BiSOFT_Model->get_location();
		$this->db->from('delivers');

		if ( $location != 0 ) { $this->db->where('client_id',$location);}  // само за МАГАЗИНИ филтър ...

		$this->db->order_by('doc_id');
		return $this->db->get();
	}
	
	public function get_info($doc_id)
	{
		$this->db->from('delivers');
		$this->db->where('doc_id',$doc_id);
		return $this->db->get();
	}

	function exists($doc_id)
	{
		$this->db->from('delivers');
		$this->db->where('doc_id',$doc_id);
		$query = $this->db->get();

		return ($query->num_rows()==1);
	}
	
	function update($delivered_data, $doc_id)
	{
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update('delivers',$delivered_data);
		
		return $success;
	}
	


	function save( $items, $mode, $all_qty, $subtotal, $doc_number, $doc_name,
					   $bisoft_id, $consignee_discount, $employee_id, $payments, $comment)
	{
		if(count($items)==0) { return -1; }
		if(null===$mode) { $mode='shop_sgp'; }
		$doc_id = false;

		// Определяме къде се намират DB за пълнене ...
		$location = $this->BiSOFT_Model->get_location();
		$vedom	 = $this->BiSOFT_Model->get_vedom();

	    	$db_delivers = 'delivers';
			$db_delivers_items = $db_delivers . '_items';

		//Зареждаме данни за Базата с Доставката ...
		$doc_date 	= date('Y-m-d');
		$doc_name	= $this->BiSOFT_Model->get_document_title($mode);	 // това си е вече заглавието...
		$mode_id 	= $this->BiSOFT_Model->get_pay_group($mode);			 // index-a 'Е', 'P' ..

				//Изчисляване плащането и групата за плащане .. index-a
				$pay_groups = '';
				$payment_types ='';
				$total_sum = 0;
				$pay_type = 'H';

		// зареждаме имената на Клиента и Оператора ......
		// $bisoft_id = $this->Customer->exists($customer_id) ? $customer_id : '';
		$client_name 	= '';
		if ( $bisoft_id != 0 )
			{ $client_name = $this->Consignee->get_info_by_bisoft_id($bisoft_id)->company_name;}

		$employee_name	=	$this->Employee->get_info($employee_id)->first_name .' '. 
								$this->Employee->get_info($employee_id)->last_name;

		// изчисляваме ДДС-то ......
		$total_discount = $consignee_discount;
		$tax_VAT 	= 0;
		$taxed	 	= 0;

		$total_amount = round($subtotal * (100 - $consignee_discount)/100, 2);

		// зареждам основните параметри на Главния документ ......
		$sales_data = array(
				'mode'				=> $mode,
				'mode_id'			=> $mode_id,
				'doc_number'		=> $doc_number,
				'doc_date' 			=> $doc_date,
				'total_qty'			=> $all_qty,
				'total_sum'			=> $subtotal,
				'total_discount'	=> $total_discount,
				'taxed'				=> $taxed,
				'total_taxes'		=> $tax_VAT,
				'pay_group'			=> $pay_type,
				'pay_type'			=> $payment_types,
				'pay_amount'		=> $total_amount,
				'client_id'			=> $bisoft_id,
				'client'				=> $client_name,
				'employee_id'		=> $employee_id,
				'employee'			=> $employee_name,
				'comment'			=> $comment,
				'location'			=> $location );

		$this->db->trans_start();
			$this->db->insert( $db_delivers, $sales_data );
			$delivery_id = $this->db->insert_id();

		// сканира количката за всеки артикул
		foreach($items as $line=>$item)
		{
			$inum=$item['inum'];$skl=$item['skl'];$allow_sizes=$item['size'];
			$skl_info = $this->Item->get_sklad_info($inum,$skl);
			$name = $this->Item->get_name($inum);

				// обслужвам си '0'-те ...
				$qty_1 = (!$item['q1']) ? '' : abs($item['q1']);
				$qty_2 = (!$item['q2']) ? '' : abs($item['q2']);
				$qty_3 = (!$item['q3']) ? '' : abs($item['q3']);
				$qty_4 = (!$item['q4']) ? '' : abs($item['q4']);
				$qty_5 = (!$item['q5']) ? '' : abs($item['q5']);
				$qty_6 = (!$item['q6']) ? '' : abs($item['q6']);
				$qty_7 = (!$item['q7']) ? '' : abs($item['q7']);
				$qty_8 = (!$item['q8']) ? '' : abs($item['q8']);
				$qty_9 = (!$item['q9']) ? '' : abs($item['q9']);
				$qty_10 = (!$item['q10']) ? '' : abs($item['q10']);
				
			$delivery_items_data = array(
				'doc_id'			=> $delivery_id,
				'item_id'		=> $item['id'],
				'line'			=> $item['line'],
				'mode_id' 		=> $mode_id,
				'doc_number' 	=> $doc_number,
				'doc_date' 		=> $doc_date,
				'item_number'	=> $inum,
				'item_name'		=> abs($sizeQty).','.$qty_1.','.$qty_2.','.$qty_3.','.$qty_4.','.qty_5
														 .','.$qty_6.','.$qty_7.','.$qty_8.','.$qty_9.','.$qty_10,
				'item_qty'		=> $item['qty'],
			'item_unit_price'	=> $item['price'],
			'item_discount'	=> $item['dsc'],
				'item_taxes'	=> $taxed,
				'client_id'		=> $bisoft_id,
				'location'		=> $location );

			if($delivery_items_data)
				{ $this->db->insert( $db_delivers_items, $delivery_items_data );} // проверка за ГРЕШКА
		}  // край на цикъла за артикулите ...

		$this->db->trans_complete();
		
		if ($this->db->trans_status() === FALSE) 
			{ return -1;}
		
	return $doc_id;
	}
	


	function delete($doc_id)
	{
		$this->db->trans_start();
			$this->db->delete( 'delivers_items', array('doc_id' => $doc_id)); 
			$this->db->delete( 'delivers', array('doc_id' => $doc_id)); 
		$this->db->trans_complete();
				
	return $this->db->trans_status();
	}


	function get_delivered_items($doc_id)
	{
		$this->db->from('delivers_items');
		$this->db->where('doc_id',$doc_id);
		$this->db->where('deleted',0);
	return $this->db->get();
	}


	function get_delivered_payments($doc_id)
	{
		$this->db->from('delivers');
		$this->db->where('doc_id',$doc_id);
	return $this->db->get()->row()->pay_type;
	}

	function get_supplier($doc_id)
	{
		$this->db->from('delivers');
		$this->db->where('doc_id',$doc_id);
	return $this->db->get()->row()->client_id;
	}

	function get_consignee($doc_id)
	{
		$this->db->from('delivers');
		$this->db->where('doc_id',$doc_id);
	return $this->db->get()->row()->client_id;
	}
	
	function get_mode($doc_id)
	{
		$this->db->from('delivers');
		$this->db->where('doc_id',$doc_id);
	return $this->db->get()->row()->mode;
	}

	
	function get_mode_id($doc_id)
	{
		$this->db->from('delivers');
		$this->db->where('doc_id',$doc_id);
	return $this->db->get()->row()->mode_id;
	}

	function get_comment($doc_id)
	{
		$this->db->from('delivers');
		$this->db->where('doc_id',$doc_id);
	return $this->db->get()->row()->comment;
	}

} ?>
