<?php 

class Invoice extends CI_Model
{
	public function get_info($doc_id,$vedomPack)
	{  
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
	return $this->db->get();
	}
	
	public function get_doc_info($vedomPack,$doc_id)
	{  
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
		$query = $this->db->get();
		if($query->num_rows()==1)
		{ return $query->row();}
		else
		{ return 0;}
	}

	public function get_info_by_vedom($doc_id,$vedom)
	{  
	$db_main = $this->BiSOFT_Model->get_db_main($mode);
		$db_sales = $vedom . $db_main; 
		$this->db->from($db_sales);
		$this->db->where('doc_id',$doc_id);
	return $this->db->get();
	}

	public function get_info_line($doc_id, $line, $vedomPack)
	{  
		$this->db->from($vedomPack.'_items');
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
	return $this->db->get();
	}

	public function get_info_invoice($doc_number,$vedomPack)
	{ 
		$this->db->from($vedomPack);
		$this->db->where('doc_number',$doc_number);
		$this->db->where("mode_id in ('F', 'Ki', 'Di', 'Pr')");
		$this->db->where('deleted = 0');
	return $this->db->get();
	}

	function exists($doc_id,$vedomPack)
	{  
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function update($doc_data, $doc_id, $vedomPack)
	{  
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update( $vedomPack, $doc_data );
	return $success;
	}

	function update_items($items_data, $doc_id, $vedomItems)
	{  
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update( $vedomItems, $items_data );
	return $success;
	}

	function update_line_item($items_data, $doc_id, $line, $vedomPack)
	{  
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
		$success = $this->db->update( $vedomPack.'_items', $items_data );
	return $success;
	}

	function exists_line_item( $vedomPack, $doc_id, $line )
	{
		$this->db->from($vedomPack.'_items');
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function add_line_item($items_data, $vedomPack, $doc_id, $line )
	{  
		if(!$this->exists_line_item( $vedomPack, $doc_id, $line ))
			{ return $this->db->insert($vedomPack.'_items', $items_data); }
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
	return $this->db->update( $vedomPack.'_items', $items_data );
	}

	// -------------------------------------- РЕГИСТРАЦИЯ ------------------------------------//
	function save( $items, $mode, $total_qty, $subtotal, $doc_number, $doc_name,
			$bisoft_id, $client_name, $customer_discount, $employee_id, $payments, $comment)
	{
		if(count($items)==0) { return -1; }
		
		if(null===$mode) { $mode='invoice'; }
		$doc_id = false;
	
		// Определяме къде се намират DB за пълнене ...
		$location = $this->BiSOFT_Model->get_mode_location();
		$firma	 = $this->invoice_lib->get_firma();if($firma==1){$firma=0;}
		$vedom	 = $this->BiSOFT_Model->get_vedom();
		$bank_mode = 1;
		$brand = $this->BiSOFT_Model->is_brand($bisoft_id); // 1 == основна фирма

	    	$db_sales = 'V'.date('ym', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
			$db_sales_items 			= $db_sales . '_items';
			$db_sales_payments 		= $db_sales;
				$db_suspended 			= 'suspended';
				$db_suspended_items 	= $db_suspended . '_items';

		//Зареждаме данни за Базата с Покупката ...
		$doc_date = $this->BiSOFT_Model->get_user_mode_date();
		$doc_name = $this->BiSOFT_Model->get_document_title($mode);	 // това си е вече заглавието...
		$mode_id  = $this->BiSOFT_Model->get_pay_group($mode);			 // index-a 'Е', 'SE' ..

				//Изчисляване плащането и групата за плащане .. index-a
				$pay_groups = '';
				$payment_types='';
				$total_sum = 0;
				$payK = 1;

		$is_paid = 0;
		foreach($payments as $payment_id=>$payment)
			{
				$pay_groups = $payment['payment_type'];
				$is_paid 	= $payment['is_paid'];
		//		$payment_types	= $payment_types.$payment['payment_type'].': '.to_currency($payK * $payment['payment_amount']).' ';
				$payment_types	= $payment['payment_type'];
				$total_sum	+=	$payment['payment_amount'];
			}

		$total_sum_text = to_currency($total_sum);

		//Разпределяме коеф.-те на index-ите на плащане за покупката ..
		$pay_type = 'H';
		if($is_paid)
		{
			switch ($pay_groups) 
			{
				case $this->lang->line('sales_not_paid'):	$pay_type = 'H';  break;
				case $this->lang->line('sales_cash'): 		$pay_type = 'P'; break;
				case $this->lang->line('sales_returned_goods'): $pay_type = 'BP';  break;
				case $this->lang->line('sales_by_bank'):	$pay_type = 'T'; $bank_mode = 1; break;
				case $this->lang->line('sales_by_bank').'2':	$pay_type = 'T'; $bank_mode = 2; break; 
				case $this->lang->line('sales_check'):		$pay_type = 'Ch'; break; 
				case $this->lang->line('sales_debit'):		$pay_type = 'dC'; break;
				case $this->lang->line('sales_credit'):	$pay_type = 'kC'; break;
				case $this->lang->line('sales_epay'):		$pay_type = 'eP'; break; 
				case $this->lang->line('sales_paypal'):	$pay_type = 'PP'; break;
				case $this->lang->line('sales_offer_price'):	$pay_type = 'Of'; break;
				default: $pay_type = 'H';
			}
		}

		// изчисляваме ДДС-то ......
		$this->load->library('sale_lib');
		$this->load->library('invoice_lib');
		$mode_price = $this->invoice_lib->get_mode_price();
		
		$invoice_export = $order_id = 0;
		$currency = 1;$currency_rate='1.0000';
		$client_data = '';
		$client_vat = 0;
		if ( $bisoft_id != 0 )
			{
				if($bisoft_id==1000) // НАСЕЛЕНИЕ
					{
						$cName 	 = $this->invoice_lib->get_client_name();
						$cSurname = $this->invoice_lib->get_client_surname();
						$client_name = $cName.' '.$cSurname;
						$client_data = $this->invoice_lib->get_client_data();
						$order_id = $this->invoice_lib->get_order();
					}
				elseif( $bisoft_id != 1000000 )
					{ 
						$client_name = $this->Customer->get_info_by_bisoft_id($bisoft_id)->company_name;
						$client_vat	 = $this->Customer->get_info_by_bisoft_id($bisoft_id)->add_vat;
						if($client_vat) {$pay_type='H';}
					}
			}
		$employee_name	=	$this->Employee->get_info($employee_id)->first_name .' '. 
								$this->Employee->get_info($employee_id)->last_name;

		if ($mode_price == 101)
			{ 	$invoice_export = 1; 
				$pay_type = 'Ex'; 
				$currency_rate = $this->invoice_lib->get_rate(); 
				$currency = $this->invoice_lib->get_mode_valuta();
			} // само UK ... GBPs
		if ($mode_price == 102) 
			{ 	$invoice_export = 2; 
				$pay_type = 'ExV'; 
				$currency_rate = $this->invoice_lib->get_rate(); 
				$currency = $this->invoice_lib->get_mode_valuta();
			} // само UK ... GBPs

		// ДДС
		$tax_VAT = 0;
		$taxed	= 0;
		if ($mode_price == 100 or $mode_price == 102) { $taxed = 1;}  // vat=100, export_vat 102

		$total_discount=$customer_discount;
		$total_amount=$subtotal;
		$total_discount=0 ;
		
		if ( $taxed == 1 )
			{ $tax_VAT=round( 20 * $subtotal / 100 , 6);}
		else
			{ $tax_VAT=0;}
		$total_amount += $tax_VAT;

		$pay_sale = $pay_vat = 0;
		if(($pay_type=='H' or $pay_type=='ExV') and $client_vat) {$pay_vat=-$tax_VAT;}
		if($pay_type == 'Of') { $comment .= $this->lang->line('sales_offer_price').': '.$mode_price.'гр.';}
		
		// знаците на totals ...
		$total_sum = $subtotal;

		// зареждам основните параметри на Главния документ ......
		$sales_data = array(
				'mode'				=> $mode,
				'mode_id'			=> $mode_id,
				'mode_price'		=> $bank_mode,
				'doc_number'		=> $doc_number,
				'doc_date' 			=> $doc_date,
				'total_qty'			=> $total_qty,
				'total_sum'			=> $total_sum,
				'total_discount'	=> $total_discount,
				'taxed'				=> $taxed,
				'total_taxes'		=> $tax_VAT,
				'brand'				=> $brand,
				'pay_group'			=> $pay_type,
				'pay_type'			=> $payment_types,
				'pay_amount'		=> $total_amount,
				'pay_sale'			=> $pay_sale,
				'pay_vat' 			=> $pay_vat,
				'currency'			=> $currency,
				'currency_rate'	=> $currency_rate,
				'order_id' 			=> $order_id,
				'client_id'			=> $bisoft_id,
				'client'				=> $client_name,
				'client_data' 		=> $client_data,
				'employee_id'		=> $employee_id,
				'employee'			=> $employee_name,
				'comment'			=> $comment,
				'location'			=> $firma );
		
		//------------------------ записва в Базите Данни ---------------------- //
		$this->db->trans_start(); // --> отваря запис към БАЗАТА ...-->> 

			// вкарва данните от Документа в Месечната База Данни ... //
			$this->db->insert( $db_sales, $sales_data);
			$doc_id = $this->db->insert_id();  // от тук си взимам номерчето на документа

		foreach($items as $line=>$item)  // сканира количката за всеки един артикул ...
			{
				$sales_items_data = array(
							'doc_id'			=> $doc_id,
							'line'			=> $item['line'],
							'mode_id' 		=> $mode_id,
							'doc_number' 	=> $doc_number,
							'doc_date' 		=> $doc_date,
							'item_number'	=> $item['id'],
							'item_name'		=> $item['name_bg'],
						'invoice_name'		=> $item['name_en'],
							'item_qty'		=> $item['qty'],
						'item_unit_price'	=> $item['price'],
						'item_discount'	=> $item['dsc'],
							'item_taxes'	=> $taxed,
							'client_id'		=> $bisoft_id,
							'brand'			=> $brand,
							'location'		=> $firma );
	
					if($mode=='invoice' or $mode=='invoice_ki' or $mode=='invoice_di' or $mode=='invoice_pr' or $mode=='proforma')
						{ $this->db->insert( $db_sales_items, $sales_items_data);}
						
			}  // край на цикъла за артикулите ...

		$this->db->trans_complete();
		if ($this->db->trans_status() === FALSE)	{ return -1;}

	return $doc_id;
	}
	


	function delete($doc_id,$vedomPack)
	{
		$this->db->trans_start();
			$this->db->delete( $vedomPack.'_items', array('doc_id' => $doc_id));
			$this->db->delete( $vedomPack, array('doc_id' => $doc_id)); 
		$this->db->trans_complete();
	return $this->db->trans_status();
	}


	function delete_line_item($doc_id, $line, $vedomPack)
	{
		$this->db->trans_start();
			$this->db->delete( $vedomPack.'_items', array('doc_id' => $doc_id, 'line' => $line));
		$this->db->trans_complete();
	return $this->db->trans_status();
	}


	function get_sale_items($doc_id,$vedomPack)
	{
		$db_sales_items = $vedomPack . '_items';
		$this->db->from($db_sales_items);
		$this->db->where('doc_id',$doc_id);
	return $this->db->get();
	}

	function get_sale_payments($doc_id,$vedomPack)
	{
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
	return $this->db->get();
	}


	// Invoices ....
	function get_invoice_items($doc_number,$vedomPack)
	{
		$db_sales_items = $vedomPack . '_items';
		$this->db->from($db_sales_items);
		$this->db->where('doc_number',$doc_number);
	return $this->db->get();
	}

	function get_invoice_payments($doc_number,$vedomPack)
	{
		$this->db->from($vedomPack);
		$this->db->where('doc_number',$doc_number);
	return $this->db->get();
	}


	function get_customer($doc_id,$vedomPack)
	{
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
	return $this->Customer->get_info($this->db->get()->row()->client_id);
	}

/* ------------------------------------------ other ----------------------------- */
	
	// AJAX Recalculate Document and VedomPack
	function recalc_invoice($vedomPack,$doc_id)
	{
		$qty_doc=$sum_doc=$pay_amount=$cost_doc=0;
		$total_qty=$total_vat=$total_sum=$total_cost=0;
		$doc_info = $this->BiSOFT_Model->get_info_for_invoice($doc_id,$vedomPack)->row();
			$total_dsc = $doc_info->total_discount;
			$pay_group = $doc_info->pay_group;
			
		$items_info = $this->BiSOFT_Model->get_document_items($doc_id,$vedomPack)->result_array();

		foreach($items_info as $line=>$item)
		{
			$inum  = $item['item_number'];
		  $iprice = $item['item_unit_price'];
			$qty 	 = $item['item_qty'];
			$dsc 	 = $item['item_discount'];
			$cost	 = $item['costsale'];
			
			$qty_doc  += $qty;
			$price  = round($iprice*(100-$dsc)/100,7);
			$sum_doc  += $qty*$price;
			$cost_doc += $qty*$cost;
		}
		$pay_amount = round($sum_doc * (100-$total_dsc)/100,6);
		
		$total_vat  = 0;
		$total_qty  = $qty_doc - $doc_info->total_qty;
		$total_sum  = round($pay_amount - $doc_info->pay_amount,6);
		$total_cost = round($cost_doc - $doc_info->pay_sale,6);
		
		//Разпределяме index-ите на плащане ..
		$pay_type = '';
		switch ($pay_group) 
		{
			case 'H': $pay_type = $this->lang->line('sales_not_paid').': ';break;
			case 'P': $pay_type = $this->lang->line('sales_cash').': ';break;
			case 'T': $pay_type = $this->lang->line('sales_by_bank').': ';break;
			case 'Ch': $pay_type = $this->lang->line('sales_check').': ';break;
			case 'dC': $pay_type = $this->lang->line('sales_debit').': ';break;
			case 'kC': $pay_type = $this->lang->line('sales_credit').': ';break;
			case 'eP': $pay_type = $this->lang->line('sales_epay').': ';break;
			case 'PP': $pay_type = $this->lang->line('sales_paypal').': ';break;			
			case 'BP': $pay_type = $this->lang->line('sales_returned_goods').': ';break;
			case 'BE': $pay_type = $this->lang->line('sales_returned_goods').': ';break;			
			default: '';
		}
		$pay_type .= to_dot($pay_amount).' лв';
		
		$doc_data=array(
					'doc_id' => $doc_id,
				'total_qty'	=> $qty_doc,
				'pay_type'	=> $pay_type,
				'total_sum' => to_dot($sum_doc),
			  'pay_amount' => to_dot($pay_amount),
				 'pay_sale'	=> to_dot($cost_doc)
							);
		
		// актуализира Документа.
		$this->update($doc_data, $doc_id, $vedomPack);
		
		$data=array(
			'qty_doc' => $qty_doc,
			'sum_doc' => to_dot($sum_doc),		
			'all_doc' => to_dot($pay_amount),
		'amount_doc' => $pay_type,
		  
		 'total_qty' => $total_qty,
		 'total_vat' => to_dot($total_vat),		
		 'total_sum' => to_dot($total_sum),
		'total_cost' => to_dot($total_cost)
						);
	return $data;
	}	

/* ------------------------------------------ other ----------------------------- */
	public function get_document_title($mode)
	{
	$receipt_title = $this->lang->line('sales_receipt');
			switch ($mode) 
				{
				case 'invoice': 		$receipt_title = $this->lang->line('sales_receipt_invoice');		break;
				case 'invoice_ki':	$receipt_title = $this->lang->line('sales_receipt_invoice_ki');	break;
				case 'invoice_di':	$receipt_title = $this->lang->line('sales_receipt_invoice_di');	break;
				case 'invoice_pr':	$receipt_title = $this->lang->line('sales_receipt_invoice_pr');	break;
				default: 				$receipt_title = $this->lang->line('sales_receipt');
				}
	return $receipt_title;
	}

	public function get_document($mode)
	{
	$doc_number = 'doc-1';
			switch ($mode) 
				{
				case 'invoice': 		$doc_number = '0';  break;
				case 'invoice_ki': 	$doc_number = '0';  break;
				case 'invoice_di': 	$doc_number = '0';  break;
				case 'invoice_pr': 	$doc_number = '0';  break;
				default: 				$doc_number = 'doc-1';
				}
	return $doc_number;
	}


}
?>
