<?php class Item extends CI_Model
{
	function exists($item_id, $key=0)
	{
      $location = $this->BiSOFT_Model->get_location();
      $db_items = $this->get_db_items_location();
      if($key==1) {$db_items='items';}

		$this->db->from($db_items);
		$this->db->where('item_id',$item_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function exists_item_in_shop($item_id)
	{
		$this->db->from('sklad');
		$this->db->where('item_id',$item_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function exists_by_number($item_number)
	{
		$location = $this->BiSOFT_Model->get_location();
		$this->db->from('sklad');
		$this->db->where('inum',$item_number);
		$this->db->where('skl',$location);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}


	function exists_by_number_gpr($item_number)
	{
		$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function exists_in_shop($inum, $shop_id)
	{
		$this->db->from('sklad');
		$this->db->where('inum', $inum);
		$this->db->where('skl', $shop_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function exists_in_any_sklad($inum)
	{
		$this->db->from('sklad');
		$this->db->where('inum', $inum);
		$query = $this->db->get();
		return ($query->num_rows()>0);
	}	
	

	function exists_doc_number($doc_number, $vedom)
	{
		$this->db->from($vedom);
		$this->db->where('doc_number',$doc_number);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}


	function get_all($limit=10000, $offset=0)
	{
		$this->db->from('items');
		$this->db->where('deleted',0);
		$this->db->order_by('item_number', 'asc');
		$this->db->limit($limit);
		$this->db->offset($offset);
	return $this->db->get();
	}

	function get_all_items($limit)
	{
		$this->db->from('items');
		$this->db->where('deleted',0);	
		$this->db->order_by('item_number', 'asc');
		$this->db->limit($limit);
   return $this->db->get()->result_array();
	}

	function get_all_shop($shop)
	{
		$this->db->from('sklad');
		$this->db->where('skl', $shop);
		$this->db->where('del',0);
		$query = $this->db->get();
		if($query->num_rows()>0)
			{ return $query->result_array();}
		else
			{ return 0;}
	}

	
	function get_all_real($category=0,$collection=0, $limit=100, $offset=0)
	{
		$this->db->from('items');
		$this->db->where('deleted',0);
		
	if ( $category != '0' ) //	отсява категорията ...
		{ $this->db->where('category', $category);}

	if ( $collection != '0' ) //	отсява колекциите ...
		{ $this->db->where('collection', $collection);}

		$this->db->order_by('item_number', 'asc');
		$this->db->limit($limit);
		$this->db->offset($offset);
		return $this->db->get();
	}

	function count_all($skl='-1')
	{
		if($skl=='-1'){$skl=$this->BiSOFT_Model->get_user_mode_client();}
		$this->db->from('sklad');
		$this->db->where('del',0);
		$this->db->where('skl',$skl);
	return $this->db->count_all_results();
	}


	public function get_pages($skl=0,$cat=0,$coll=0)
	{
		$this->db->from('sklad');
		$this->db->where('skl',$skl);
		$this->db->where('del',0);
		
		if ( $cat != '0' )
			{ $this->db->where('cat', $cat);}

		if ( $coll==0 )
			{$this->db->where('qty > 0');}
		else
			{$this->db->where('coll',$coll);}
			
		$this->db->order_by('inum', 'asc');
		return $this->db->count_all_results();
	}	
	
	
	function get_info($item_id, $key=0)
	{
		$this->db->from('sklad');
		$this->db->where('item_id',$item_id);
		$query = $this->db->get();

		if($query->num_rows()==1)
			{ return $query->row();}
		else
			{ $item_obj=new stdClass();
			  $fields = $this->db->list_fields($db_items);
			  foreach ($fields as $field) {$item_obj->$field='';}
			return $item_obj;
			}
	}
	
	
	function get_item_picDir($item)
	{
		$picDir = '_0x/';
		if($item > 9999 and $item < 100000)
		{
		  $item_1st_L = substr($item,0,1);
		  switch($item_1st_L)
		  {
			 case '1': $picDir = '_1x/'; break;
			 case '2': $picDir = '_2x/'; break;
			 case '3': $picDir = '_3x/'; break;
			 case '4': $picDir = '_4x/'; break;
			 case '5': $picDir = '_5x/'; break;
			 case '6': $picDir = '_6x/'; break;
			 case '7': $picDir = '_7x/'; break;
			 case '8': $picDir = '_8x/'; break;
			 case '9': $picDir = '_9x/'; break;
		  }
		}
	return $picDir;
	}
	
	
/* ==== FAST EXTRACT ==== */	
	function get_blanka_info($item_number)
	{
		$this->db->select(	
				  'item_number,
					name,
					collection,
					category,
					description,
					supplier,
					qmin,qmax,
					allow_sizes',false);

		$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row();}
		else
			{ return 0;}
	}

	function get_inum_name($item_number)
	{
		$this->db->select(	
				  'item_number,
					name',false);
		$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row()->name;}
		else
			{ return '';}
	}

	function get_item_info($item_number)
	{
		$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row();}
		else
			{ $item_obj=new stdClass();
			  $fields = $this->db->list_fields('items');
			  foreach ($fields as $field) {$item_obj->$field='';}
           return $item_obj;
			}
	}
	
	
	function get_inum_group_color($item_number)
	{
		$this->db->select(	
				  'item_number,
					item_color',false);
		$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ 
				$rgb_color = $query->row()->item_color;
				if($rgb_color)
				{
					$this->db->select('rgb,group_id',false);
					$this->db->from('colors');
					$this->db->where('rgb',$rgb_color);
					$color_query = $this->db->get();
					if($color_query->num_rows()==1)
						{ return $color_query->row()->group_id;}
					else {return 0;}
				}
				return 0;
			}
		else
			{ return 0;}
	}
	
	
	function get_all_kits()
	{
		$this->db->from('items');
		$this->db->where('category','kits');
		$this->db->where('deleted',0);
		$this->db->order_by("item_number", "asc");
		return $this->db->get();
	}	
	
	
/* === СКЛАД ==== */
	function exists_in_items($item_number)
	{	$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function exists_in_sklad($inum,$skl='-1')
	{	if($skl=='-1'){$skl=$this->BiSOFT_Model->get_user_mode_client();}
		$this->db->from('sklad');
		$this->db->where('inum',$inum);
		$this->db->where('skl',$skl);
		$query=$this->db->get();
	return ($query->num_rows()==1);
	}

	function exists_idx($item_id)
	{	$this->db->from('sklad');$this->db->where('item_id',$item_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

 	function get_sklad_info($inum,$skl='-1')
	{	if($skl=='-1'){$skl=$this->BiSOFT_Model->get_user_mode_client();}
		$this->db->from('sklad');$this->db->where('inum',$inum);$this->db->where('skl',$skl);
		$query = $this->db->get();
		if($query->num_rows()==1){return $query->row();}
		else{return 0;}
	}

	function get_sklad_idx($item_id)
	{	$this->db->from('sklad');
		$this->db->where('item_id',$item_id);
		$query = $this->db->get();
		if($query->num_rows()==1){return $query->row();}
		else{return false;}
	}

	function get_sklad_item_id($item_id)
	{	$this->db->from('sklad');
		$this->db->where('item_id',$item_id);
		$this->db->where('del',0);$query = $this->db->get();
		if($query->num_rows()==1){return $query->row();}
		else{return 0;}
	}

	function get_all_sklad($skl='-1', $limit=30, $offset=0)
	{	if($skl=='-1'){$skl=$this->BiSOFT_Model->get_user_mode_client();}
		$this->db->from('sklad');$this->db->where('skl',$skl);$this->db->where('del',0);
		$this->db->order_by('inum','asc');$this->db->limit($limit);$this->db->offset($offset);
	return $this->db->get();
	}	
	

	function get_real_sklad($skl='-1',$cat=0,$coll=0,$limit=30,$offset=0)
	{	if($skl=='-1'){$skl=$this->BiSOFT_Model->get_user_mode_client();}
		$location=$this->Employee->get_logged_in_employee_info()->location;
		$this->db->from('sklad');$this->db->where('skl',$skl);
			if($cat!=0){$this->db->where('cat',$cat);}
			if($coll==0){$this->db->where('qty > 0');}
			else{$this->db->where('coll',$coll);}
		$this->db->where('del',0);
		$this->db->offset($offset);
		$this->db->limit($limit);
		$this->db->order_by('inum','asc');
	return $this->db->get();
	}
	
	
	function get_sgp_sklad($skl=0)
	{	
		$this->db->select('item_id,inum,skl,qty,q1,q2,q3,q4,q5,q6,q7,q8,q9,q10,price_2,price_3,del',false);
		$this->db->from('sklad');
		$this->db->where('skl',$skl);
		$this->db->where('del',0);
		$this->db->where('qty > 0');
		$this->db->order_by('inum','asc');
	return $this->db->get()->result_array();
	}	
	
	

	function get_name($inum)
	{	$this->db->select('item_number,name',false);$this->db->from('items');
		$this->db->where('item_number',$inum);$query=$this->db->get();
		if($query->num_rows()==1){return $query->row()->name;}
		else{return '';}
	}

	
	function get_names($inum)
	{	$this->db->select('item_number,name,description',false);$this->db->from('items');
		$this->db->where('item_number',$inum);$query=$this->db->get();
		if($query->num_rows()==1){$desc=$query->row()->description;
		if(!empty($desc)){$desc=','.$query->row()->description;}else{$desc='';}
			return $query->row()->name.$desc;}
		else{return '';}
	}
	

	function get_allow_sizes($inum)
	{	$this->db->select('item_number,allow_sizes',false);$this->db->from('items');
		$this->db->where('item_number',$inum);$query=$this->db->get();
		if($query->num_rows()==1){return $query->row()->allow_sizes;}
		else{return 0;}
	}
	

	function get_collection_id($inum)
	{	$this->db->select('item_number,collection',false);$this->db->from('items');
		$this->db->where('item_number',$inum);$query=$this->db->get();
		if($query->num_rows()==1){return $query->row()->collection;}
		else{return 0;}
	}
	

	function get_items_collection($coll_id)
	{	$this->db->select('item_number,name,allow_sizes',false);
      $this->db->from('items');
		$this->db->where('collection',$coll_id);
		$this->db->where('deleted',0);
		$query = $this->db->get();
		if($query->num_rows()>0){return $query->result_array();}
		else{return 0;}
	}
	

	function save_sklad(&$item_data)
	{	
		$inum=$item_data['inum'];$skl=$item_data['skl'];

		if($item_data and !$this->exists_in_sklad($inum,$skl))
		{	return $this->db->insert('sklad',$item_data); }
		elseif($item_data)
		{
			$this->db->where('inum',$inum);$this->db->where('skl',$skl);
			return $this->db->update('sklad',$item_data);
		}
		return false;
	}


	function update_sklad($item_data)
	{	$inum=$item_data['inum'];$skl=$item_data['skl'];
		if (!$this->exists_in_sklad($inum,$skl)){return false;}
		$this->db->where('inum',$inum);$this->db->where('skl',$skl);
	return $this->db->update('sklad',$item_data);
	}
	
	function save_all_sklads(&$item_data)
	{	$inum=$item_data['inum'];
		$this->db->where('inum',$inum);
	return $this->db->update('sklad',$item_data);
	}

	function save_STYLER_shops($item_data)
	{	$inum=$item_data['inum'];
		$skl=$item_data['skl'];
		if (!$this->exists_in_sklad($inum,$skl)){return false;}
		$this->db->where('inum',$inum);
		$this->db->where('skl',$skl);
	return $this->db->update('sklad',$item_data);
	}
	
/* === SKLAD R === */
	function exists_in_sklad_R($inum,$skl='-1')
	{	if($skl=='-1'){$skl=$this->BiSOFT_Model->get_user_mode_client();}
		$this->db->from('sklad_R');$this->db->where('inum',$inum);
		$this->db->where('skl',$skl);
		$query=$this->db->get();
	return ($query->num_rows()==1);
	}
	

	function get_sklad_R_info($inum,$skl='-1')
	{	if($skl=='-1'){$skl=$this->BiSOFT_Model->get_user_mode_client();}
		$this->db->from('sklad_R');$this->db->where('inum',$inum);$this->db->where('skl',$skl);
		$query = $this->db->get();
		if($query->num_rows()==1){return $query->row();}
		else{return 0;}
	}
	

	function save_sklad_R(&$item_data)
	{	$inum=$item_data['inum'];$skl=$item_data['skl'];
		if(!$this->exists_in_sklad_R($inum,$skl))
			{return $this->db->insert('sklad_R',$item_data);}
		$this->db->where('inum',$inum);$this->db->where('skl',$skl);
	return $this->db->update('sklad_R',$item_data);
	}


	function update_sklad_R($item_data)
	{	$inum=$item_data['inum'];$skl=$item_data['skl'];
		if (!$this->exists_in_sklad_R($inum,$skl)){return false;}
		$this->db->where('inum',$inum);$this->db->where('skl',$skl);
	return $this->db->update('sklad_R',$item_data);
	}
	

	function save_item($item_data,$item_number=false)
	{	if(!$item_number or !$this->exists_in_items($item_number))
		{if($this->db->insert('items',$item_data)){return true;}return false;}
		$this->db->where('item_number', $item_number);
	return $this->db->update('items',$item_data);
	}
	

	function update_item($item_data,$item_number=false)
	{	if(!$this->exists_in_items($item_number)){return false;}
		$this->db->where('item_number', $item_number);
	return $this->db->update('items',$item_data);
	}
	
/* ------------------ Onlines ---------------- */
	function exists_in_onlines($item_number)
	{	
		$this->db->from('eShop_online_items');
		$this->db->where('item_number',$item_number);
		$query=$this->db->get();
	return ($query->num_rows()==1);
	}

	function update_online_item($item_data)
	{	$item_number=$item_data['item_number'];
		if (!$this->exists_in_onlines($item_number)) {return false;}
		$this->db->where('item_number',$item_number);
	return $this->db->update('eShop_online_items',$item_data);
	}


/* ------------------ Planning ---------------- */
	function exists_in_item_plan($inum)
	{	
		$this->db->from('items_plan');
		$this->db->where('inum',$inum);
		$query=$this->db->get();
	return ($query->num_rows()>0);
	}
	
	function update_item_plan($plan_data)
	{	$inum = $plan_data['inum'];
		if (!$this->exists_in_item_plan($inum)) {return false;}
		$this->db->where('inum',$inum);
	return $this->db->update('items_plan',$plan_data);
	}	
	
	


/* ------------------ TDO ---------------- */
	function exists_in_item_tdo($inum)
	{	
		$this->db->from('tdo_PH');
		$this->db->where('inum',$inum);
		$query=$this->db->get();
	return ($query->num_rows()>0);
	}
	
	function update_item_tdo($tdo_data)
	{	$inum = $tdo_data['inum'];
		if (!$this->exists_in_item_tdo($inum)) {return false;}
		$this->db->where('inum',$inum);
	return $this->db->update('tdo_PH',$tdo_data);
	}	
	

	function get_all_consignees()
	{
		$this->db->from('consignees');
		$this->db->where('deleted',0);
		$this->db->order_by("bisoft_id", "asc");
	return $this->db->get();		
	}
	

	function get_item_from_vedoms($item_number,$sklad='-1',$doc_date=0)
	{
		$location = $this->BiSOFT_Model->get_location();
		if($doc_date)
			{ $period = date('ym',strtotime($doc_date));}
		else 
			{ $period = '1401';} 

		$limit  = date('ym');
		$arr_1  = array();

		do
		{	$vedom ='V'.$period.'_items';
			$this->db->select('
					mode_id,
					doc_number,
					doc_date,
					item_number,
					item_name,
					item_qty,
					client_id,
					supplier_id,
					location', false);

			if($this->db->table_exists($vedom))
			{
				$this->db->from($vedom);
				$this->db->where('item_number',$item_number);
				$this->db->where('deleted',0);
				if($doc_date) {$this->db->where('doc_date BETWEEN "'.date('Y-m-d',strtotime($doc_date)).'" and "'.date('Y-m-d').'"');}
				if($sklad!='-1') {$this->db->where('location',$sklad);}
				$this->db->order_by("doc_date","asc");
				
				$arr_2 = $this->db->get()->result_array();
				$result = array_merge($arr_1,$arr_2);
				$arr_1  = $result;
			}
			
			$period++;
			if(substr($period,-2)==13) {$period+=88;}
	
		} while($period<=$limit);
	
	return $result;		
	}
	
	

	function get_magazin_from_vedoms($sklad='-1')
	{
		$location = $this->BiSOFT_Model->get_location();
		$period_1 = (int)date('ym')-1;if(substr($period_1,2)=='00') {$period_1-=88;}
		$period = (int)date('ym');

		$arr_1  = $arr_2 = array();
		if(date('d') < 7)
		{  // предният месец
			$vedom ='V'.$period_1.'_items';
			$this->db->select('
					mode_id,
					doc_date,
					item_number,
					item_name,
					item_qty,
					client_id,
					deleted,
					location', false);
			if($this->db->table_exists($vedom))
			{
				$this->db->from($vedom);
				$this->db->where('mode_id','SE');
				$this->db->where('deleted',0);
				if($sklad!='-1') {$this->db->where('location',$sklad);}
				$this->db->order_by("item_number","asc");
				$arr_1 = $this->db->get()->result_array();
			}
		}
         // този месец
			$vedom ='V'.$period.'_items';
			$this->db->select('
					mode_id,
					doc_date,
					item_number,
					item_name,
					item_qty,
					client_id,
					deleted,
					location', false);
			if($this->db->table_exists($vedom))
			{
				$this->db->from($vedom);
				$this->db->where('mode_id','SE');
				$this->db->where('deleted',0);
				if($sklad!='-1') {$this->db->where('location',$sklad);}
				$this->db->order_by("item_number","asc");
				$arr_2 = $this->db->get()->result_array();
			}
			
			$result = array_merge($arr_1,$arr_2);

	return $result;		
	}
	
	
/* === End SUPER FAST Extracts === */
	function get_info_from_shop($item_id)
	{
		$this->db->from('shops');
		$this->db->where('item_id',$item_id);
		$query = $this->db->get();
	if($query->num_rows()==1) { return $query->row();}
	}


/* === СКЛАД SHOPS === */
	function exists_in_shops($inum,$skl='-1')
	{	if($skl=='-1'){return 0;}
		$this->db->from('shops');$this->db->where('inum',$inum);$this->db->where('skl',$skl);
		$query=$this->db->get();
	return ($query->num_rows()==1);
	}

	function exists_shops_idx($item_id)
	{	$this->db->from('shops');$this->db->where('item_id',$item_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function get_shop_info($inum,$skl)
	{	$this->db->from('shops');$this->db->where('inum',$inum);$this->db->where('skl',$skl);
		$query = $this->db->get();
		if($query->num_rows()==1){return $query->row();}
		else{return 0;}
	}
	
	function get_shop_idx($item_id)
	{	$this->db->from('shops');
		$this->db->where('item_id',$item_id);
		$query = $this->db->get();
		if($query->num_rows()==1){return $query->row();}
		else{return false;}
	}
	
	function get_shop_item_id($item_id)
	{	$this->db->from('shops');
		$this->db->where('item_id',$item_id);
		$this->db->where('del',0);$query = $this->db->get();
		if($query->num_rows()==1){return $query->row();}
		else{return 0;}
	}
	
	function get_all_shops($skl, $limit=50, $offset=0)
	{	$this->db->from('shops');$this->db->where('skl',$skl);$this->db->where('del',0);
		$this->db->order_by('inum','asc');$this->db->limit($limit);$this->db->offset($offset);
	return $this->db->get();
	}	


	function save_shop(&$item_data)
	{	$inum=$item_data['inum'];$skl=$item_data['skl'];
		if(!$this->exists_in_shops($inum,$skl))
			{return $this->db->insert('shops',$item_data);}
		$this->db->where('inum',$inum);$this->db->where('skl',$skl);
	return $this->db->update('shops',$item_data);
	}


	function update_shop($item_data)
	{	$inum=$item_data['inum'];$skl=$item_data['skl'];
		if (!$this->exists_in_shops($inum,$skl)){return false;}
		$this->db->where('inum',$inum);$this->db->where('skl',$skl);
	return $this->db->update('shops',$item_data);
	}
	
	
/* ==== PATTERNS ==== */	
	function exists_pattern($inum)
	{
		$this->db->from('patt_items');
		$this->db->where('item_number',$inum);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function get_info_pattern($inum)
	{  
		$this->db->from('patt_items');
		$this->db->where('item_number',$inum);
		$this->db->where('deleted',0);
		$query = $this->db->get();
	if($query->num_rows()==1) 
		{return $query->row();}
	else 
		{return 0;}
	}
	
	function save_pattern($inum, $patt_item_data)
	{ 
		if (!$inum or !$this->exists_pattern($inum))
		{
			if($this->db->insert('patt_items',$patt_item_data))
            { return 1;}
         else  
            { return 0;}
		}
		$this->db->where('item_number', $inum);
	return $this->db->update('patt_items',$patt_item_data);
	}
	
	
	
// ---- END of Patterns --- //	
	
	
/* ==== OTHERS ==== */
	function get_info_from_sgp($item_number)
	{
		$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
	if($query->num_rows()==1) { return $query->row();}
	}


	function get_from_sklad($item_number)
	{
		$location = $this->BiSOFT_Model->get_location();
		$this->db->from('sklad');
		$this->db->where('inum',$item_number);
		$this->db->where('skl',$location);
		$this->db->where('del',0);
		$query = $this->db->get();
		if($query->num_rows()==1)
				{ return $query->row(); }
		else 	{ return false; }
	}


	function get_all_info($item_number)
	{
		$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
		if($query->num_rows()==1)
				{ return $query->row();}
		else 	{ return false; }
	}


	function get_info_invoice($item_id)
	{
		$this->db->from('invoices_db');
		$this->db->where('item_id',$item_id);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row();}
		else
			{ return 0;}
	}


	function get_item_id($inum)
	{
		$location = $this->BiSOFT_Model->get_location();
		$this->db->from('sklad');
		$this->db->where('inum',$inum);
		$this->db->where('skl',$location);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row()->item_id;}
	return false;
	}


	function get_item_id_invoice($item_id)
	{
		$this->db->from('invoices_db');
		$this->db->where('item_id',$item_id);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row()->item_id;}
	return false;
	}


	function get_item_number($item_number)
	{
		$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
		if($query->num_rows()==1)
		{ return $query->row();}
	return false;
	}


	function get_multiple_info($item_ids)
	{
		$this->db->from('sklad');
		$this->db->where_in('item_id',$item_ids);
		$this->db->order_by("item_id", "asc");
	return $this->db->get();
	}

	function get_collections()
	{
		$this->db->from('collections');
		$this->db->where('deleted = 0');
		$this->db->order_by("key", "asc");
	return $this->db->get();		
	}

	function get_info_collection($collection_id)
	{
		$this->db->from('collections');	
		$this->db->where('key',$collection_id);
		$query = $this->db->get();	
		if($query->num_rows()==1)
			{ return $query->row();}
		else	
			{ return false;}			
	}


	function get_colors($lang='bg')
	{
		$this->db->from('colors');
		$this->db->where('deleted = 0');
		$this->db->order_by("color_".$lang, "asc");
	return $this->db->get();		
	}

/*	--- Assortment ---- */
	function get_all_assorts()
	{
		$this->db->from('assortment');
		$this->db->order_by("key", "asc");
	return $this->db->get();		
	}
	
	function get_item_categories()
	{
		$this->db->from('category');
		$this->db->order_by("category_bg", "asc");
	return $this->db->get();		
	}

	function get_category($lang='bg')
	{
		$this->db->from('category');
		$this->db->where('deleted = 0');
		$this->db->order_by("category_".$lang, "asc");
	return $this->db->get();		
	}
	
	function get_cat_id($cat='0')
	{
		$this->db->from('category');
		$this->db->where('key',$cat);
		$this->db->where('deleted = 0');
		$query = $this->db->get();
		if($query->num_rows()==1)
		{ return $query->row()->cat_id;}
	return false;
	}	
	
	
	function get_cat_name($cat_id='0')
	{
		if($cat_id>0)
		{
			$this->db->from('category');
			$this->db->where('cat_id',$cat_id);
			$this->db->where('deleted = 0');
			$query = $this->db->get();
			if($query->num_rows()==1)
				  { return $query->row()->category_bg;}
			else { return '';}
		}
		else { return '';}
	}
	
	function get_cat_name_en($cat_id='0')
	{
		if($cat_id>0)
		{
			$this->db->from('category');
			$this->db->where('cat_id',$cat_id);
			$this->db->where('deleted = 0');
			$query = $this->db->get();
			if($query->num_rows()==1)
				  { return $query->row()->category_en;}
			else { return '';}
		}
		else { return '';}
	}
	
	function get_cat_label($cat_id='0')
	{
		if($cat_id>0)
		{
			$this->db->from('category');
			$this->db->where('cat_id',$cat_id);
			$this->db->where('deleted = 0');
			$query = $this->db->get();
			if($query->num_rows()==1)
				  { return $query->row()->label_bg;}
			else { return '';}
		}
		else { return '';}
	}
	
	function get_cat_label_en($cat_id='0')
	{
		if($cat_id>0)
		{
			$this->db->from('category');
			$this->db->where('cat_id',$cat_id);
			$this->db->where('deleted = 0');
			$query = $this->db->get();
			if($query->num_rows()==1)
				  { return $query->row()->label_en;}
			else { return '';}
		}
		else { return '';}
	}	
	
	
	function get_cat_name_by_key($cat='0')
	{
		$this->db->from('category');
		$this->db->where('key',$cat);
		$this->db->where('deleted = 0');
		$query = $this->db->get();
		if($query->num_rows()==1)
		{ return $query->row()->category_bg;}
	return 0;
	}
	
	
	function get_cat_name_by_key_en($cat='0')
	{
		$this->db->from('category');
		$this->db->where('key',$cat);
		$this->db->where('deleted = 0');
		$query = $this->db->get();
		if($query->num_rows()==1)
		{ return $query->row()->category_en;}
	return 0;
	}
	
	
	function get_cat_id_by_key($key='0')
	{
		$this->db->from('category');
		$this->db->where('key',$key);
		$this->db->where('deleted = 0');
		$query = $this->db->get();
		if($query->num_rows()==1)
		{ return $query->row()->cat_id;}
	return false;
	}	
	
/*	--- Dropdowns --- */	
	function get_all_dropdowns(&$data)
	{  // определяме езика ?!
		$language = $this->Appconfig->get('language');
		if($language == 'bulgarian') { $lang='bg';}
		elseif ( $language == 'english' ) { $lang='en';}
		$data['lang'] = $lang;
		
		$data['valutas'] = array(
			'1' => $this->lang->line('kaca_BGN'),
			'2' => 'EUR',
			'3' => 'GBP',
			'4' => 'USD');
			
		// третиране	
      $data['all_cares'] = array(
			'0'     => $this->lang->line('cares_notreatment'),
			'gDLHU' => $this->lang->line('cares_cotton_wool'),
			'dDLHU' => $this->lang->line('cares_jacket_nowash'),
			'cDLHU' => $this->lang->line('cares_viscose_merino'),
			'gCLHU' => $this->lang->line('cares_polyester'),
			'dCLHU' => $this->lang->line('cares_poleuretan'),
			'dEHL'  => $this->lang->line('cares_vest_ties'),
			'XdCH'  => $this->lang->line('cares_belts') );

		if ( $lang == 'bg' ) 
			{
				$collections[0] = $categories[''] = $colors[''] = $no_size = '-- няма --';

				foreach ( $this->get_collections()->result() as $collection)
						  { $collections[$collection->key] = $collection->collection_bg;}

				foreach ( $this->get_category($lang)->result() as $category)
						  { $categories[$category->key] = $category->category_bg; }
						  
				foreach ( $this->get_colors($lang)->result() as $color)
						  { $colors[$color->rgb] = $color->color_bg;}
				$collections['-1'] = $categories['-1'] = $colors['-1'] = $n_a = 'N/A';
			}
		elseif ( $lang == 'en' )
			{
				$collections[0] = $categories[''] = $colors[''] = $no_size = '-- none --';
				foreach ( $this->get_collections()->result() as $collection)
						  { $collections[$collection->key] = $collection->collection_en;}
						  
				foreach ( $this->get_category($lang)->result() as $category)
						  { $categories[$category->key] = $category->category_en;}
						  
				foreach ( $this->get_colors($lang)->result() as $color)
						  { $colors[$color->rgb] = $color->color_en;}
				$collections['-1'] = $categories['-1'] = $colors['-1'] = $n_a = 'N/A';
			}

		$data['collection'] = isset($data['item_info']->collection) ? $data['item_info']->collection : 100;
			if($data['collection']>99 and $data['collection']<300) {}
			else {$data['collection']=101;}
		$data['collections'] = $collections;
		$data['category'] 	= isset($data['item_info']->category) ? $data['item_info']->category : NULL;
		$data['categories']  = $categories; 
		$data['color']  		= isset($data['item_info']->item_color) ? $data['item_info']->item_color : NULL;
		$data['colors'] 		= $colors;
		
		$allow_sizes = isset($data['item_info']->allow_sizes) ? $data['item_info']->allow_sizes : 0;
		if($allow_sizes==null or empty($allow_sizes)) {$allow_sizes=0;} // $allow_sizes=='105'
		
		$data['allow_sizes'] = $allow_sizes;
		$data['group_sizes'] = array(
			 'S' => 'S-7XL',
         'XS' => 'S-6XL,=XS=',
			'28' => '30-46,=28=',
			'30' => '30-46,max',
			 'J' => 'Jeans-30,31,32',
			'40' => '40-56,max',
		  'c46' => 'c46-c64',
			'48' => '50-64,=48=',
			'50' => '50-66,max',
			'92' => '92-188,max',
		  '105' => '105-160.k',
		  'b40' => 'b40-b49',
			'EU' => 'EU',
			'UK' => 'UK',
			 '0' => $no_size,
			'-1' => 'N/A' );
			 
		$data['size_qmin'] = isset($data['item_info']->qmin) ? $data['item_info']->qmin : 0;
		$data['size_qmax'] = isset($data['item_info']->qmax) ? $data['item_info']->qmax : 10;
		$data['size_range'] = array(
			'1' => 'S.min',
			'2' => 'M/32',
			'3' => 'L/34',
			'4' => 'XL/36',
			'5' => '2XL/38',
			'6' => '3XL/40',
			'7' => '4XL/42',
			'8' => '5XL/44',
		   '9' => '6XL/46',
		  '10' => 'max' );
		  
		$data['modes_prices']=array(
			99	=> $this->lang->line('sales_unit_price'),
			1	=> $this->lang->line('sales_price').'-I',
			2	=> $this->lang->line('sales_price').'-II',
			3	=> $this->lang->line('sales_price').'-III',
			4	=> $this->lang->line('sales_price').'-IV',
			5	=> $this->lang->line('sales_price').'-V' );

	return $data;	
	}	
	
	
/*	================================ GET SIZES ============================ */
	function get_sizes($item_number)
	{
      $sizes = array();
      if(!$item_number) {return $sizes;}
		$group = $allow_sizes = 0;
		
		$sizes['allow']=$sizes['qmin']=$sizes['qmax']=0;
		
		$item_info = $this->get_blanka_info($item_number);
		if(!$item_info) {return $sizes;}
		
		if($item_number<4000 or ($item_number>98000 and $item_number!=98180 
																  and $item_number!=98181 
																  and $item_number!=98182 
																  and $item_number!=98183
																  and $item_number!=98184
																  and $item_number!=98190
																  and $item_number!=98191
																  and $item_number!=98192
																  and $item_number!=98193
																  and $item_number!=98194 ) ) 	{$allow_sizes=0;}
		else {$group = $allow_sizes = $item_info->allow_sizes;}

		$sizes = array (
						'1'	=> '',
						'2'	=> '',
						'3'	=> '',
						'4'	=> '',
						'5'	=> '',
						'6'	=> '',
						'7'	=> '',
						'8'	=> '',
						'9'	=> '',
						'10'	=> '' );

		if ($allow_sizes)
		{ 
			if ( $group=='S' or $group=='s' ) 
				{ $sizes = array (
						'1'	=> 'S',
						'2'	=> 'M',
						'3'	=> 'L',
						'4'	=> 'XL',
						'5'	=> '2XL',
						'6'	=> '3XL',
						'7'	=> '4XL',
						'8'	=> '5XL',
						'9'	=> '6XL',
						'10'	=> '7XL' ); 
				}
			elseif ( $group=='XS' or $group=='xs' ) 
				{ $sizes = array (
						'1'	=> 'S',
						'2'	=> 'M',
						'3'	=> 'L',
						'4'	=> 'XL',
						'5'	=> '2XL',
						'6'	=> '3XL',
						'7'	=> '4XL',
						'8'	=> '5XL',
						'9'	=> '6XL',
						'10'	=> 'XS' ); 
				}
			elseif ( $group=='J' or $group=='j' ) 
				{ $sizes = array (
						'1'	=> '30',
						'2'	=> '31',
						'3'	=> '32',
						'4'	=> '33',
						'5'	=> '34',
						'6'	=> '36',
						'7'	=> '38',
						'8'	=> '40',
						'9'	=> '42',
						'10'	=> '44' ); 
				}
			elseif ( $group=='c46' ) 
				{ $sizes = array (
						'1'	=> '46',
						'2'	=> '48',
						'3'	=> '50',
						'4'	=> '52',
						'5'	=> '54',
						'6'	=> '56',
						'7'	=> '58',
						'8'	=> '60',
						'9'	=> '62',
						'10'	=> '64' ); 
				}
			else
				{  $ctr = 2;
					switch ($group) 
						{
							case 'UK': $size = 6;  break;	 		
							case 'EN': $size = 36; break;
							case '6':  $size = 6; break;
							case '8':  $size = 8; break;
							case '28': $size = 30; break;
							case '30': $size = 30; break;
							case '40': $size = 40; break;
							case 'c46': $size = 46; break;
							case '48': $size = 50; break;
							case '50': $size = 50; break;
							case '60': $size = 60; break;
							case '92': $size = 92; $ctr = 12; break;
							case '105': $size = 105; $ctr = 5; break;
							case 'b40': $size = 40; $ctr = 1; break;
							default  : $size = 40; break;
						}
						
					if($group=='b40') // само ОБУВКИ !?
					{
						for($k=1;$k<11;$k++)	{$sizes[$k]=$size+$ctr*($k-1);}
					}
					elseif($group=='28') // само където 28=max !?
					{
						for($k=1;$k<10;$k++)	{$sizes[$k]=$size+$ctr*($k-1);}
						$sizes[10]='28';
					}
					elseif($group=='48') // само където 48=max !?
					{
						for($k=1;$k<10;$k++)	{$sizes[$k]=$size+$ctr*($k-1);}
						$sizes[10]='48';
					}
					elseif($group == 105) // само КОЛАНИ //
					{
						for($k=1;$k<8;$k++)	{$sizes[$k]=$size+$ctr*($k-1);}
						$sizes[8]  ='140';
						$sizes[9]  ='150';
						$sizes[10] ='160';
					}
					else 
					{ 
						for($k=1;$k<10;$k++)	{$sizes[$k]=$size+$ctr*($k-1);}
						$sizes[10]='max';
					}
				}
				
         $sizes['allow']= $allow_sizes;
         $sizes['qmin'] = $item_info->qmin;
         $sizes['qmax'] = $item_info->qmax;
		}
		else {$sizes['allow']=$sizes['qmin']=$sizes['qmax']=0;}

	return $sizes;
	}

/*	==== CALCULATE SIZES ==== */
	
	function sizes1_plus_sizes2($sizes1,$sizes2)
	{
		$sizes=array();$all_sizes=0;
		for($i=1;$i<10;$i++)
			{
				$qty = 'qty_'.$i; 
				$sizes[$qty]=$sizes1[$qty]+$sizes2[$qty];
				$all_sizes+=$sizes[$qty];
				if(!$sizes[$qty]) {$sizes[$qty]='';}
			}
		$sizes['qty_max']=$sizes1['qty_max']+$sizes2['qty_max'];
		$all_sizes+=$sizes['qty_max'];
		if(!$sizes['qty_max']) {$sizes['qty_max']='';}
		$sizes['item_qty']=$sizes1['item_qty']+$sizes2['item_qty'];
		$sizes['quantity']=$all_sizes;

		if($all_sizes!=$sizes['item_qty']) 
				{$sizes['error']=1;}
		else  {$sizes['error']=0;}

	return $sizes;
	}

	
	function sizes1_minus_sizes2($sizes1,$sizes2)
	{
		$sizes=array();$all_sizes=0;
		for($i=1;$i<10;$i++)
			{
				$qty = 'qty_'.$i; 
				$sizes[$qty]=$sizes1[$qty]-$sizes2[$qty];
				$all_sizes+=$sizes[$qty];
				if(!$sizes[$qty]) {$sizes[$qty]='';}
			}
		$sizes['qty_max']=$sizes1['qty_max']-$sizes2['qty_max'];
		$all_sizes+=$sizes['qty_max'];
		if(!$sizes['qty_max']) {$sizes['qty_max']='';}
		$sizes['item_qty']=$sizes1['item_qty']-$sizes2['item_qty'];
		$sizes['quantity']=$all_sizes;
	
		if($all_sizes!=$sizes['item_qty']) 
				{$sizes['error']=1;}
		else  {$sizes['error']=0;}

	return $sizes;
	}

/*	==== END GET SIZES ==== */



/* -------------------------- Save pack ------------------------- */
	function save_sklad_pack($input_data)
	{
		$success  = 1;
		$skl_info = false;
		$firma_key  = $this->BiSOFT_Model->get_firma_key();
		$styler_key = $firma_key['styler'];

		$item_id	 = $input_data['item_id'];
		$inum     = $input_data['inum'];
		$location = $this->Employee->get_logged_in_employee_info()->location;
		$sklad 	 = $this->BiSOFT_Model->get_user_mode_client();
		if($item_id!='-1') {$skl_info = $this->get_sklad_idx($item_id);}
		$item_data = array();
		
		if($skl_info and $skl_info->skl==0)
		{  // кройки и MK (БКК)
         $pattern  = $input_data['pattern'];
         if($pattern)
         {
            $patt_data = array(
               'item_number'=>$inum,
               'patt'=>$pattern,
               'MK'  =>(int)$input_data['pattern_MK'],
               'name'=>$this->get_name($inum),
               'deleted'=>0);
            $success *= $this->save_pattern($inum,$patt_data);
         }
      }

	$this->db->trans_start();
		
		if($location==0 and $sklad==0 and $item_id=='-1')
		{ // Нов Артикул
         $item_data = array(
				'item_number'    => $input_data['inum'],
				'name'           => $input_data['name'],
				'collection'     => $input_data['coll'],
				'category'       => $input_data['category'],
				'kit_1'          => $input_data['kit_1'],
				'kit_2'          => $input_data['kit_2'],
				'kit_3'          => $input_data['kit_3'],
				'item_discount'  => $input_data['dsc'],	
				'allow_sizes'    => $input_data['allow'],
				'qmin'           => $input_data['qmin'],
				'qmax'           => $input_data['qmax'],
				'description'    => $input_data['opis'],
				'supplier'       => $input_data['supplier'],
				'item_contents'  => $input_data['contents'],
				'item_care'      => $input_data['item_care'],
				'item_color'     => $input_data['color'],
				'item_currency'  => $input_data['currency'],
				'deleted' => 0 );
			// запис в централната DB
			$success *= $this->save_item($item_data,$input_data['inum']);
					
			$skl_data = array(
					'inum' => $input_data['inum'],
					 'skl' => $sklad,
					 'qty' => $input_data['qty'],
					  'q1' => $input_data['q1'],'q2' => $input_data['q2'],'q3' => $input_data['q3'],
					  'q4' => $input_data['q4'],'q5' => $input_data['q5'],'q6' => $input_data['q6'],
					  'q7' => $input_data['q7'],'q8' => $input_data['q8'],'q9' => $input_data['q9'],
					 'q10' => $input_data['q10'],
				  'price' => $input_data['price'],
				'price_2' => $input_data['price_2'],
				'price_3' => $input_data['price_3'],
				'price_4' => $input_data['price_4'],
				'price_5' => $input_data['price_5'],
				'price_6' => $input_data['price_6'],
					'cost' => $input_data['cost'],
					 'dsc' => $input_data['dsc'],
					 'cat' => $input_data['cat'],
					'coll' => $input_data['coll'],				 
					 'del' => 0 );
			// запис в Склада
			$success *= $this->save_sklad($skl_data);

		}  // end ... нов артикул
		elseif($location==0 and $sklad==0 and $item_id>0)
		{  // update на съществуващ артикул в Склад-ГП
			$item_data = array(
				'item_number' => $input_data['inum'],
				'name'        => $input_data['name'],
				'collection'  => $input_data['coll'],
				'category'    => $input_data['category'],
				'kit_1'       => $input_data['kit_1'],
				'kit_2'       => $input_data['kit_2'],
				'kit_3'       => $input_data['kit_3'],

				'item_discount'  => $input_data['dsc'],	
				'allow_sizes'    => $input_data['allow'],
				'qmin'           => $input_data['qmin'],
				'qmax'           => $input_data['qmax'],

				'description'    => $input_data['opis'],
				'supplier'       => $input_data['supplier'],
				'item_contents'  => $input_data['contents'],
				'item_care'      => $input_data['item_care'],
				'item_color'     => $input_data['color'],
				'item_currency'  => $input_data['currency'],
				'deleted'        => $input_data['del'] );
				
			// запис в централната DB
			$success *= $this->save_item($item_data,$input_data['inum']);
					
			$skl_data = array(
				'item_id' => $item_id,
					'inum' => $input_data['inum'],
					 'skl' => $sklad,
					 'qty' => $input_data['qty'],
					  'q1' => $input_data['q1'],'q2' => $input_data['q2'],'q3' => $input_data['q3'],
					  'q4' => $input_data['q4'],'q5' => $input_data['q5'],'q6' => $input_data['q6'],
					  'q7' => $input_data['q7'],'q8' => $input_data['q8'],'q9' => $input_data['q9'],
					 'q10' => $input_data['q10'],
				  'price' => $input_data['price'],
				'price_2' => $input_data['price_2'],
				'price_3' => $input_data['price_3'],
				'price_4' => $input_data['price_4'],
				'price_5' => $input_data['price_5'],
				'price_6' => $input_data['price_6'],
					'cost' => $input_data['cost'],
					 'dsc' => $input_data['dsc'],
					 'cat' => $input_data['cat'],
					'coll' => $input_data['coll'],
					 'del' => $input_data['del']	);
					 
			// запис в Склад
			$success *= $this->save_sklad($skl_data);
		
			// update online_item
			if($this->exists_in_onlines($input_data['inum']))
			{
				if($input_data['allow'])
				{
					$itemSizes = $input_data['allow'].','.
							$input_data['q1'].','.$input_data['q2'].','.$input_data['q3'].','.
							$input_data['q4'].','.$input_data['q5'].','.$input_data['q6'].','.
							$input_data['q7'].','.$input_data['q8'].','.$input_data['q9'].','.$input_data['q10'];

					$online_data = array(
				  'item_number' => $input_data['inum'],
							 'qty' => $input_data['qty'],
						  'sizes' => $itemSizes,
						'price_2' => $input_data['price_2'],
						'price_3' => $input_data['price_3'],
							 'cat' => $input_data['cat'],
							'coll' => $input_data['coll'],
						'deleted' => $input_data['del']	);
				}
				else // безразмерни
				{
					$online_data = array(
				  'item_number' => $input_data['inum'],
							 'qty' => $input_data['qty'],
						  'sizes' => 0,
						'price_2' => $input_data['price_2'],
						'price_3' => $input_data['price_3'],
							 'cat' => $input_data['cat'],
							'coll' => $input_data['coll'],
						'deleted' => $input_data['del']	);
				}
				
				$success *= $this->update_online_item($online_data);
			}
			
/* ================= нова функция Update Planning + TO =================== */			
			if($styler_key)
			{	
				$plan_data = array(
				  'inum' => $input_data['inum'],
				  'coll' => $input_data['coll'] );
			//	$this->update_item_plan($plan_data); // спряно за сега
			
				$tdo_data = array(
						'inum' => $input_data['inum'],
				  'category' => $input_data['cat'],
				'collection' => $input_data['coll'] );
				$this->update_item_tdo($tdo_data);
			}
			
/* ================= нова функция STYLER -> актуализира магазините =================== */
			if($styler_key) // само за 1 и 10 магазини на STYLER
			{ //  and ($sklad==1 or $sklad==10)
				$price_2 = $input_data['price_2'];
				$price_3 = $input_data['price_3'];
				if( $price_3 > 0 and $price_3 < $price_2 ) 
				{ $price = $price_3;}
				else 
				{ $price = $price_2;}
				$price_2 = $price_3 = $price_4 = $price_5 = $price_6 = 0;

				$other_skl_data = array(
						 'skl' => 1,  // 1-ви STYLER Shop
						'inum' => $input_data['inum'],
						 'cat' => $input_data['cat'],
						'coll' => $input_data['coll'],
						 'dsc' => 0,
						'cost' => $price,
					  'price' => $price,
					'price_2' => $price_2,
					'price_3' => $price_3,
					'price_4' => $price_4,
					'price_5' => $price_5,
					'price_6' => $price_6 );



				// запис в 1 Магазин STYLER
				$this->save_STYLER_shops($other_skl_data);

				// запис в Златинис -112
				$other_skl_data['skl'] = 112;
				$this->save_STYLER_shops($other_skl_data);
				
				// запис в 18 ВАЛЕНСИЯ
				$other_skl_data['skl'] = 18;
				$this->save_STYLER_shops($other_skl_data);
				
/*  20.05.2022 Силвия спира временно магазините / пускам САМО магазин 1 - 04-юли-2022 Бисер го пуска				
				// запис в 810 ТИМ OUTLET
				$other_skl_data['skl'] = 810;
				$this->save_STYLER_shops($other_skl_data);
*/
			}
			else
			{
				$other_skl_data = array(
						'inum' => $input_data['inum'],
						 'cat' => $input_data['cat'],
						'coll' => $input_data['coll'] );
				// запис във ВСИЧКИ Складове
				$success *= $this->save_all_sklads($other_skl_data);
			}

		}
		elseif($location==0 and $sklad!=0 and $item_id>0) 
		{  // update на артикул от База-0 в Магазин
			$mCost=$input_data['cost'];$mPrice=$input_data['price'];$mDsc=$input_data['dsc'];
			if($mCost>0 and $mCost<$mPrice) 
				{ $mDsc=100*round(($mPrice-$mCost)/$mPrice,4);}
			elseif($mDsc>0 and $mCost==0)
				{ $mCost=round((100-$mDsc)*$mPrice/100,2);}
			elseif($mDsc==0 and $mCost==0)
				{ $mCost=$mPrice;}
			
			$skl_data = array(
				'item_id' => $item_id,
					'inum' => $input_data['inum'],
					 'skl' => $sklad,
					 'qty' => $input_data['qty'],
					  'q1' => $input_data['q1'],'q2' => $input_data['q2'],'q3' => $input_data['q3'],
					  'q4' => $input_data['q4'],'q5' => $input_data['q5'],'q6' => $input_data['q6'],
					  'q7' => $input_data['q7'],'q8' => $input_data['q8'],'q9' => $input_data['q9'],
					 'q10' => $input_data['q10'],
				  'price' => $mPrice,
				'price_2' => $input_data['price_2'],
				'price_3' => $input_data['price_3'],
				'price_4' => $input_data['price_4'],
				'price_5' => $input_data['price_5'],
				'price_6' => $input_data['price_6'],
					'cost' => $mCost,
					 'dsc' => $mDsc,
					 'cat' => $input_data['cat'],
					'coll' => $input_data['coll'],
					 'del' => $input_data['del']  );
			// запис в Склад
			$success *= $this->save_sklad($skl_data);
		}
		elseif($location!=0 and $sklad!=0 and $item_id>0)
		{  // update на артикул от Магазина
			$skl_data = array(
				'item_id' => $item_id,
					'inum' => $input_data['inum'],
					 'skl' => $sklad,
				'price_2' => $input_data['price_2'],
				'price_3' => $input_data['price_3'],
				'price_4' => $input_data['price_4'],
				'price_5' => $input_data['price_5'],
				'price_6' => $input_data['price_6']	 );
			// запис в Склад
			$success *= $this->save_sklad($skl_data);
		}
		else // има някаква грешка ?!!
		{ $success=0;$skl_data=array();$item_data=array();}
					 
	$this->db->trans_complete();
	if ($this->db->trans_status()===FALSE)	{return -1;}
				
		$data=array('sklad' => $skl_data,
						 'item' => $item_data,
					 'success' => $success );			 
	return $data;
	}
	
	// ===== new Save pack in Shops ==== //
	function save_shops_pack($input_data)
	{
		$success  = 1;
		$item_id	 = $input_data['item_id'];
		$location = $this->Employee->get_logged_in_employee_info()->location;
		$skl      = $input_data['skl'];
		$skl_info = $this->get_shop_idx($item_id);
		$item_data = array();

		$this->db->trans_start();
         if($item_id>0) // update на артикул
         {
            $skl_data = array(
               'item_id' => $item_id,
                  'inum' => $input_data['inum'],
                   'skl' => $skl,
                   'qty' => $input_data['qty'],
                    'q1' => $input_data['q1'],'q2' => $input_data['q2'],'q3' => $input_data['q3'],
                    'q4' => $input_data['q4'],'q5' => $input_data['q5'],'q6' => $input_data['q6'],
                    'q7' => $input_data['q7'],'q8' => $input_data['q8'],'q9' => $input_data['q9'],
                   'q10' => $input_data['q10'],
                 'price' => $input_data['price'],
                  'cat'  => $input_data['cat'],
                  'coll' => $input_data['coll'],
                  'del'  => 0 );

            // запис в Склад
            $success *= $this->save_shop($skl_data);
         }
         else // има някаква грешка ?!!
         {$success=0;$skl_data=array();$item_data=array();}
					 
		$this->db->trans_complete();
		if ($this->db->trans_status()===FALSE)	{return -1;}

		$data=array('sklad' => $skl_data,
						 'item' => $item_data,
					 'success' => $success );			 
	return $data;
	}


	function save_vedom( &$vedom_data, $doc_number, $item_id, $vedom_to_push='_docs_items' )
	{	
		return $this->db->insert($vedom_to_push,$vedom_data);
	}


	function update_multiple($item_data,$item_ids)
	{
		$db_items = 'sklad';
		$this->db->where_in('item_id',$item_ids);
	return $this->db->update($db_items,$item_data);
	}


	function delete_inum($inum=0,$skl='-1')
	{
      if($inum and $skl!='-1')
      {
         $this->db->trans_start();
            $this->db->delete( 'sklad', array('inum'=>$inum,'skl'=>$skl)); 
         $this->db->trans_complete();
         return $this->db->trans_status();
		}
		else { return false;}
	}	
	
	
	function delete($item_id)
	{
		$db_items = 'sklad';
		$this->db->where('item_id', $item_id);
	return $this->db->update($db_items, array('del' => 1));
	}


	function delete_list($item_ids)
	{
		$db_items = 'sklad';
		$this->db->where_in('item_id',$item_ids);
	return $this->db->update($db_items, array('del' => 1));
 	}

	function move_item_info($inum)
	{
		$success = $sklad = 0;
		$this->db->from('items');
		$this->db->where_in('item_number',$inum);
		$query=$this->db->get();
		$success = ($query->num_rows()==1) ? 1 : 0;
	
		if($success)
		{
			$this->db->from('sklad');
			$this->db->where_in('inum',$inum);
			$query = $this->db->get();
			$sklad = ($query->num_rows()>0) ? $query->result_array() : 0;
		}
		
		$data = array(
			'inum' => $inum,
		'success' => $success,
		  'sklad' => $sklad );
		
	return $data;
	}
	
	
	function update_move_item($old_inum,$new_inum)
	{
		$this->db->trans_start();
		
		// items + plan
		$this->db->delete( 'items', array('item_number' => $new_inum) );
		$this->db->where_in('item_number', $old_inum);
		$this->db->update('items', array('item_number' => $new_inum));
		
		$this->db->delete( 'items_plan', array('inum' => $new_inum) );
		$this->db->where_in('inum', $old_inum);
		$this->db->update('items_plan', array('inum' => $new_inum));
	
		// sklad
		$this->db->delete( 'sklad', array('inum' => $new_inum) );
		$this->db->where_in('inum', $old_inum);
		$this->db->update('sklad', array('inum' => $new_inum));
		
		// techno
		$this->db->delete( 'techno', array('item_number' => $new_inum) );
		$this->db->where_in('item_number', $old_inum);
		$this->db->update('techno', array('item_number' => $new_inum, 'tech_date' => date('Y-m-d') ));		
		
		// tech_X
		if( (int)substr($old_inum,0,1) == (int)substr($new_inum,0,1) )
		{
			$tech_N = (int)substr($new_inum,0,1);
			$this->db->delete( "tech_$tech_N", array('item_number' => $new_inum) );
			$this->db->where_in('item_number', $old_inum);
			$this->db->update("tech_$tech_N", array('item_number' => $new_inum));
		}

		// tdo
		$this->db->where_in('inum', $old_inum);
		$this->db->update('tdo_PH', array('inum' => $new_inum));
		
		// online items
		$this->db->where_in('item_number', $old_inum);
		$this->db->update('eShop_online_items', array('item_number' => $new_inum));
		// BG
		$this->db->where_in('item_number', $old_inum);
		$this->db->update('eShop_online_items_bg', array('item_number' => $new_inum));
		// EN
		$this->db->where_in('item_number', $old_inum);
		$this->db->update('eShop_online_items_en', array('item_number' => $new_inum));
		// GR
		$this->db->where_in('item_number', $old_inum);
		$this->db->update('eShop_online_items_gr', array('item_number' => $new_inum));
		// RO
		$this->db->where_in('item_number', $old_inum);
		$this->db->update('eShop_online_items_ro', array('item_number' => $new_inum));
		
		// ...
		
		$this->db->trans_complete();
	return $this->db->trans_status();
	}
 	
	function update_move_item_orders($old_inum,$new_inum)
	{
		$this->db->trans_start();
		
		// 2010
		$this->db->delete( 'orders_2010', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2010', array('inum' => $new_inum));
		
		// 2011
		$this->db->delete( 'orders_2011', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2011', array('inum' => $new_inum));
		
		// 2012
		$this->db->delete( 'orders_2012', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2012', array('inum' => $new_inum));
		
		// 2014
		$this->db->delete( 'orders_2014', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2014', array('inum' => $new_inum));
		
		// 2015
		$this->db->delete( 'orders_2015', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2015', array('inum' => $new_inum));
		
		// 2016
		$this->db->delete( 'orders_2016', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2016', array('inum' => $new_inum));
		
		// 2017
		$this->db->delete( 'orders_2017', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2017', array('inum' => $new_inum));
		
		// 2018
		$this->db->delete( 'orders_2018', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2018', array('inum' => $new_inum));
		
		// 2019
		$this->db->delete( 'orders_2019', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2019', array('inum' => $new_inum));
		
		// 2020
		$this->db->delete( 'orders_2020', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2020', array('inum' => $new_inum));
		
		// 2021
		$this->db->delete( 'orders_2021', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2021', array('inum' => $new_inum));
		
		// 2022
		$this->db->delete( 'orders_2022', array('inum' => $new_inum));
		$this->db->where_in('inum', $old_inum);
		$this->db->update('orders_2022', array('inum' => $new_inum));
		
		// ....
	
		$this->db->trans_complete();
	return $this->db->trans_status();
	} 	
 	
	function update_move_item_vedoms($old_inum,$new_inum)
	{
		$this->db->trans_start();
		
		/* ============================ 2014 =========================== */
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1401_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1402_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1403_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1404_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1405_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1406_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1407_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1408_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1409_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1410_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1411_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1412_items', array('item_number' => $new_inum));
		
		/* ============================ 2015 =========================== */
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1501_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1502_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1503_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1504_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1505_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1506_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1507_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1508_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1509_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1510_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1511_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1512_items', array('item_number' => $new_inum));

		/* ============================ 2016 =========================== */
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1601_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1602_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1603_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1604_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1605_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1606_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1607_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1608_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1609_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1610_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1611_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1612_items', array('item_number' => $new_inum));	

		/* ============================ 2017 =========================== */
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1701_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1702_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1703_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1704_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1705_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1706_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1707_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1708_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1709_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1710_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1711_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1712_items', array('item_number' => $new_inum));
		
		/* ============================ 2018 =========================== */
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1801_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1802_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1803_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1804_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1805_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1806_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1807_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1808_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1809_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1810_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1811_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1812_items', array('item_number' => $new_inum));
		
		/* ============================ 2019 =========================== */
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1901_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1902_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1903_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1904_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1905_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1906_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1907_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1908_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1909_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1910_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1911_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V1912_items', array('item_number' => $new_inum));
		
		/* ============================ 2020 =========================== */
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2001_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2002_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2003_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2004_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2005_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2006_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2007_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2008_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2009_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2010_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2011_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2012_items', array('item_number' => $new_inum));	
		
		/* ============================ 2021 =========================== */
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2101_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2102_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2103_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2104_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2105_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2106_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2107_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2108_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2109_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2110_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2111_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2112_items', array('item_number' => $new_inum));	

		/* ============================ 2022 =========================== */
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2201_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2202_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2203_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2204_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2205_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2206_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2207_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2208_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2209_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2210_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2211_items', array('item_number' => $new_inum));
		$this->db->where_in('item_number', $old_inum); $this->db->update('V2212_items', array('item_number' => $new_inum));
	
		// .....
		
		$this->db->trans_complete();
	return $this->db->trans_status();
	}
 	
 	
/* ====== SUGGESTIONS ====== */
	function get_search_suggestions($search,$limit=10)
	{
		$location = $this->Employee->get_logged_in_employee_info()->location;
		$skl=$this->BiSOFT_Model->get_user_mode_client();
		$suggestions = array();
		
		$this->db->from('sklad');
		$this->db->where('skl',$skl);		
		$this->db->like('inum', $search);
		$this->db->order_by("inum", "asc");
		$by_item_number = $this->db->get();
		foreach($by_item_number->result() as $row) { $suggestions[]=$row->inum;}

	if($location!=0)
		{
			$this->db->from('sklad');
			$this->db->where('skl',0);		
			$this->db->like('inum', $search);
			$this->db->order_by("inum", "asc");
			$by_item_number = $this->db->get();
			foreach($by_item_number->result() as $row) { $suggestions[]=$row->inum;}
		}

		if(count($suggestions > $limit))
			{ $suggestions = array_slice($suggestions, 0, $limit);}
			
	return $suggestions;
	}


	function get_item_search_suggestions($search,$limit=10)
	{
		$location = $this->Employee->get_logged_in_employee_info()->location;
		$skl=$this->BiSOFT_Model->get_user_mode_client();
		$suggestions = array();
		
		$this->db->from('sklad');
		$this->db->like('inum',$search);
		$this->db->where('skl',$skl);
		$this->db->order_by("inum","asc");
		$by_item_number = $this->db->get();
		foreach($by_item_number->result() as $row) { $suggestions[]=$row->item_id.'|'.$row->inum;}
			
	if($location!=0)
		{
			$this->db->from('sklad');
			$this->db->like('inum', $search);
			$this->db->where('skl',0);
			$this->db->order_by("inum","asc");
			$by_item_number = $this->db->get();
			foreach($by_item_number->result() as $row)
				{ $suggestions[]=$row->item_id.'|'.$row->inum;}
		}	

		if(count($suggestions > $limit)) { $suggestions = array_slice($suggestions, 0, $limit);}
			
	return $suggestions;
	}


	function search($search)
	{
		$location = $this->Employee->get_logged_in_employee_info()->location;
		if(!$location) {$skl=$this->BiSOFT_Model->get_user_mode_client();}
		else {$skl=$location;}

		if($search=='') {return false;} // if($search=='' and $skl==0)
		$this->db->from('sklad');
		$this->db->where('skl',$skl);
		$this->db->where("(inum LIKE '%".$this->db->escape_like_str($search)."%')");
		$this->db->order_by("inum","asc");
		$query = $this->db->get();
		if($query->num_rows()>0)
			{ return $query; }
	return 0;
	}


/* ==== Мои функции ===== */
	function check_item_sizes($item_number,$item_data,$mode='invoice') 
	{   // за някои режими просто няма смисъл да се проверяват количествата ...
	    if(	$mode == 'sale_return' or $mode == 'consi_return' or $mode == 'shop_return' or $mode == 'recv' or
				$mode == 'manu') {return true;}	

	    $item_id = $this->Item->get_item_id($item_number);
	    $key_for_error = 0;
	    $allow_sizes = $this->Item->get_info($item_id)->allow_sizes;

     if ( $allow_sizes == 1 ) 
     {   // поверка на РАЗМЕРНИ АРТИКУЛИ ...
         $item_store = array(
            'quantity'  => (int)$this->Item->get_info($item_id)->quantity,
            'qty_1'	   => (int)$this->Item->get_info($item_id)->qty_1,
            'qty_2'	   => (int)$this->Item->get_info($item_id)->qty_2,
            'qty_3'	   => (int)$this->Item->get_info($item_id)->qty_3,
            'qty_4'	   => (int)$this->Item->get_info($item_id)->qty_4,
            'qty_5'	   => (int)$this->Item->get_info($item_id)->qty_5,
            'qty_6'	   => (int)$this->Item->get_info($item_id)->qty_6,
            'qty_7'	   => (int)$this->Item->get_info($item_id)->qty_7,
            'qty_8'	   => (int)$this->Item->get_info($item_id)->qty_8,
            'qty_9'	   => (int)$this->Item->get_info($item_id)->qty_9,
            'qty_max'   => (int)$this->Item->get_info($item_id)->qty_max );

         if ($item_store['quantity'] < (int)$item_data['quantity']) { $key_for_error=1;}
         if ($item_store['qty_1'] < (int)$item_data['qty_1'])     	{ $key_for_error=1;}
         if ($item_store['qty_2'] < (int)$item_data['qty_2'])     	{ $key_for_error=1;}
         if ($item_store['qty_3'] < (int)$item_data['qty_3'])     	{ $key_for_error=1;}
         if ($item_store['qty_4'] < (int)$item_data['qty_4'])     	{ $key_for_error=1;}
         if ($item_store['qty_5'] < (int)$item_data['qty_5'])     	{ $key_for_error=1;}
         if ($item_store['qty_6'] < (int)$item_data['qty_6'])     	{ $key_for_error=1;}
         if ($item_store['qty_7'] < (int)$item_data['qty_7'])     	{ $key_for_error=1;}
         if ($item_store['qty_8'] < (int)$item_data['qty_8'])     	{ $key_for_error=1;}
         if ($item_store['qty_9'] < (int)$item_data['qty_9'])     	{ $key_for_error=1;}
         if ($item_store['qty_max'] < (int)$item_data['qty_max']) 	{ $key_for_error=1;}
      } 
      else
      { // поверка само на БЕЗРАЗМЕРНИ ...
		  $qtty = $this->Item->get_info($item_id)->quantity;
		  if( (int)$qtty < (int)$item_data['quantity']) { $key_for_error=1;} 
		}

	if ($key_for_error==1) {return false;}
	return true;
	}


	function check_qty_to_sizes($item_data) 
	{
		$key_error = 0;
		if ($item_data['allow_sizes'])
		{
			$sizes_suma =  (int)$item_data['qty_1'] + (int)$item_data['qty_2'] + (int)$item_data['qty_3'] + (int)$item_data['qty_4'] +
								(int)$item_data['qty_5'] + (int)$item_data['qty_6'] + (int)$item_data['qty_7'] + (int)$item_data['qty_8'] +
								(int)$item_data['qty_9'] + (int)$item_data['qty_max'];
			if ($item_data['quantity']<0) {$key_error = 'QTY';}
			elseif ($sizes_suma != (int)$item_data['quantity']) {$key_error = (int)$item_data['quantity'] - (int)$sizes_suma;}
			elseif ((int)$item_data['qty_1']<0 or (int)$item_data['qty_2']<0 or (int)$item_data['qty_3']<0 or (int)$item_data['qty_4']<0 or
					  (int)$item_data['qty_5']<0 or (int)$item_data['qty_6']<0 or (int)$item_data['qty_7']<0 or(int) $item_data['qty_8']<0 or 
					  (int)$item_data['qty_9']<0 or (int)$item_data['qty_max']<0) {$key_error = 'SIZE';}
		}

	return $key_error;
	}

// --- BarCode  ---- //
	
	function is_valid_item_number($barcode_item) 
	{
	   if (!is_numeric($barcode_item)) { return false; }
	   $lenBarcode = strlen($barcode_item);
	   if ($lenBarcode <  4 or $lenBarcode > 7 ) { return false; }
	return true;
	}


	function is_valid_barcode($barcode_item)
	{
		if (!is_numeric($barcode_item)) { return false; }	
		$lenBarcode = strlen($barcode_item);
		if ($lenBarcode <  8) { return false; }
		if ($lenBarcode >  8 and $lenBarcode < 12) { return false; }
		if ($lenBarcode > 13) { return false; }
	return true;
	}


	function add_item_barcode($barcode_item, $mode="sale")
	{
      $lenBarcode = strlen($barcode_item);
      $item_number = 0;
      $barcode = substr($barcode_item,0,-1);
      $quantity = $mode=="sale" ? 1:-1;

      $qty = array();
         $qty[1] = 0; $qty[2] = 0; $qty[3] = 0; $qty[4] = 0; $qty[5] = 0;
         $qty[6] = 0; $qty[7] = 0; $qty[8] = 0; $qty[9] = 0; $qty[0] = 0;

		// EAN-13 Code table
		if ($lenBarcode == 13 ) 
		{
		// checks 380 = Bulgaria Code table
		   $barcode_380 = substr($barcode_item,0,3);
		   if ($barcode_380 == '380') { $item_number = (int) substr($barcode_item,-6,-1); }
		   else { // else 380
			// Normal 13 bit code
			$barcode = substr($barcode_item,1,-1);
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 10) { $qty[$size_qty] = $quantity;}
			elseif ($size_qty == 10) { $qty[0] = $quantity; }
			else {   // различните размерни групи .....
                  if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
                  if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
                  if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
                  if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

                  if ($size_qty > 10 and $size_qty < 100) 
                     {$size_qty = floor($size_qty/2) - $sizeQty;}

                  if ($size_qty > 9) { $qty[0] = $quantity; }
                  elseif ($size_qty == 0) { }
                  else { $qty[$size_qty] = $quantity; }
			     }
			} // end of else 380
		}

		// BiSOFT internal Code table 12 (-leading 0)
		if ($lenBarcode == 12 ) {
			$item_number = (int) substr($barcode,0,-4);
			$size_qty = (int) substr($barcode,9,10);
			$sizeQty = 0;

			if ($size_qty > 0 and $size_qty < 10) { $qty[$size_qty] = $quantity;}
			elseif ($size_qty == 10) { $qty[0] = $quantity; }
			else {   // различните размерни групи .....
                  if ($size_qty > 10 and $size_qty < 40 ) { $sizeQty = -1;}
                  if ($size_qty > 39 and $size_qty < 60 ) { $sizeQty = 19;}
                  if ($size_qty > 59 and $size_qty < 80 ) { $sizeQty = 29;}
                  if ($size_qty > 79 and $size_qty < 100) { $sizeQty = 39;}

                  if ($size_qty > 10 and $size_qty < 100) 
                     {$size_qty = floor($size_qty/2) - $sizeQty;}

                  if ($size_qty > 9) { $qty[0] = $quantity; }
                  elseif ($size_qty == 0) { }
                  else { $qty[$size_qty] = $quantity; }
			     }
		}
	
	$data = array (
		'inum' => $item_number,
		'qty' => $quantity,
		'q1' => $qty[1],
		'q2' => $qty[2],
		'q3' => $qty[3],
		'q4' => $qty[4],
		'q5' => $qty[5],
		'q6' => $qty[6],
		'q7' => $qty[7],
		'q8' => $qty[8],
		'q9' => $qty[9],
		'q10' => $qty[0]);

	return $data;
	}

// end of my stuff 
	function get_item_id_invoice_db($item_number)
	{
		$this->db->from('invoices_db');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row()->item_id;}
	return false;
	}

	function save_invoice_db( &$item_data, $item_id=false )
	{	
		if (!$item_id or !$this->exists($item_id))
		{
			if($this->db->insert('invoices_db',$item_data))
			{ $item_data['item_id']=$this->db->insert_id();
			  return true;
			}
		return false;
		}
		$this->db->where('item_id', $item_id);
	return $this->db->update('invoices_db',$item_data);
	}

// ----------------------------------------------------------------------------------
	function get_db_items_inv_location()
	{
		return '';
	}

	function get_db_items_outv_location()
	{
		return '';
	}

	function get_db_items_location()
	{
		$db_items = 'sklad';
	return $db_items;
	}

/* ===================== PLANNING ===================== */
	function get_all_items_plan()
	{
		$this->db->select('	
				plan_id,
				inum,
				coll,
				deleted', false);
		$this->db->from('items_plan');
		$this->db->order_by('inum, plan_id', 'asc');
		$query = $this->db->get();
		if($query->num_rows()>0)
			{ return $query->result_array(); }
	return false;
	}
	
	function check_item_plan($inum=0)
	{
		if($inum>14000 and $inum<98000)
		{
			$this->db->from('items_plan');
			$this->db->where('inum',$inum);
			$query = $this->db->get();
			if($query->num_rows()>1)
				{ return TRUE; } // $query->row();
		}
	return FALSE;
	}
	
	function get_collection_name($key)
	{
		/*
		$this->db->select('	
				key,
				collection_bg,
				deleted', false);
		*/		
		$this->db->from('collections');
		$this->db->where('key',$key);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row()->collection_bg; }
	return 0;
	}

	
	
	
	
/* ==== REBUILD FUNCTIONS === */
	function get_sklad_now($skl)
	{
		$this->db->select('	
				item_id,
				inum,
				skl,
				qty,
				del', false);
		$this->db->from('sklad');
		$this->db->where('skl', $skl);
		$this->db->order_by('inum', 'asc');
		
   return $this->db->get()->result_array();
	}
	
	function get_sklad_discounts($skl=0)
	{
		$this->db->select('	
				item_id,
				inum,
				skl,
				qty,
				price,
				price_2,
				price_3,
				del', false);
		$this->db->from('sklad');
		$this->db->where('skl', $skl);
		$this->db->where('qty > 0');
		if($skl==0) { $this->db->where('price_3 > 0'); }
		else { $this->db->where('price > 0'); }
		$this->db->order_by('inum', 'asc');
		
   return $this->db->get()->result_array();
	}
	
	function delete_item_from_sklad_now($item_id,$skl)
	{
		$this->db->trans_start();
            $this->db->delete( 'sklad', array('item_id'=>$item_id,'skl'=>$skl)); 
      $this->db->trans_complete();
   return $this->db->trans_status();
	}


	
	function exists_old_item($item_id)
	{
		$this->db->from('items_old');
		$this->db->where('item_id',$item_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function get_info_old($item_id)
	{
		$this->db->from('items_old');
		$this->db->where('item_id',$item_id);
		$query = $this->db->get();
	if($query->num_rows()==1) { return $query->row();}
	}
	
	
	function get_all_old_items($group)
	{
		$prev_group = 1000 * $group - 1;	
		$next_group = 1000 * ($group + 1);

		$this->db->select('	
				item_number,
				name,
				category, 
				collection', false);
		$this->db->from('items_old');
		$this->db->where('deleted',0);
		$this->db->where("item_number > $prev_group AND item_number < $next_group");
		$this->db->order_by('item_number', 'asc');
		
   return $this->db->get()->result_array();
	}

	
	function save_old_item(&$item_data,$item_id=false)
	{	
		$db_items = 'items_old';
		if (!$item_id or !$this->exists_old_item($item_id))
		{
			if($this->db->insert($db_items,$item_data))
			{  $item_data['item_id']=$this->db->insert_id();
				return true;
			}
		return false;
		}
		$this->db->where('item_id', $item_id);
	return $this->db->update($db_items,$item_data);
	}	
	
/* ==== SHOPS ==== */
	function get_all_items_from_old_items($db_type='items')
	{
		$this->db->select(
					  'item_number,
						location,
						quantity,
						qty_1,qty_2,qty_3,qty_4,qty_5,
						qty_6,qty_7,qty_8,qty_9,qty_max,						
						unit_price,
						unit_price_2,
						unit_price_3,
						unit_price_4,
						unit_price_5,
						cost_price,
						collection,
						category,
						deleted', false);
		$this->db->from($db_type);
		$this->db->where('deleted',0);
		$this->db->order_by('item_number','asc');
   return $this->db->get()->result_array();
	}
	

	function get_prices_from_old_items($db_type='items')
	{
		$this->db->select(
					  'item_number,
						location,					
						unit_price,
						unit_price_2,
						unit_price_3,
						unit_price_4,
						unit_price_5,
						cost_price,
						deleted', false);
		$this->db->from($db_type);
		$this->db->where('deleted',0);
		$this->db->order_by('item_number','asc');
   return $this->db->get()->result_array();
	}
	
	
	function get_sizes_from_old_vedom($vedom='V1512')
	{
		$this->db->select(
					  'doc_id,
					   mode_id,
						line,
					   item_number,
						item_qty,					
						qty_1,qty_2,qty_3,qty_4,qty_5,
						qty_6,qty_7,qty_8,qty_9,qty_max,
						client,
						deleted', false);
		$this->db->from($vedom.'_items');
		$this->db->where('deleted',0);
		$this->db->order_by('doc_id','asc');
   return $this->db->get()->result_array();
	}
	

	function update_vedom_items($vedom,$item_data)
	{	$doc_id=$item_data['doc_id'];$line=$item_data['line'];$inum=$item_data['item_number'];
		$this->db->where('doc_id',$doc_id);
		$this->db->where('line',$line);
		$this->db->where('item_number',$inum);
	return $this->db->update($vedom.'_items',$item_data);
	}	

	
	function get_all_items_from_new_shops()
	{
		$this->db->select(
					  'item_id,
					   inum,
					   skl,
					   coll,
						cat,
						del', false);
		$this->db->from('shops');
		$this->db->where('del',0);
		$this->db->order_by('item_id','asc');
   return $this->db->get()->result_array();
	}
	
	
	function update_an_item_in_new_shops($item_data)
	{
      $item_id=$item_data['item_id'];
      $inum=$item_data['inum'];
		$this->db->where('item_id',$item_id);
		$this->db->where('inum',$inum);
	return $this->db->update('shops',$item_data);
	}
	
	
	function compare_sklad_items($sklad='sklad_old')
	{
		$this->db->select(
					  'inum,
						qty,
						price_2,
						price_3,
						del', false);
		$this->db->from($sklad);
		$this->db->where('qty > 0');
		$this->db->where('inum > 11000');
		$this->db->where('skl',0);
		$this->db->where('del',0);
		$this->db->order_by('inum','asc');
   return $this->db->get()->result_array();
	}	
	
/*========================= KITS ========================== */

	function exists_item_kit($inum)
	{
		$this->db->from('item_kits');
		$this->db->where('inum',$inum);
		$this->db->where('del',0);
		$query = $this->db->get();
		if($query->num_rows()==1) { return 1;}
		else { return 0; }
	}

	function get_all_item_kits()
	{
		$this->db->from('item_kits');
		$this->db->where('del',0);
		$this->db->order_by('inum','asc');
	return $this->db->get()->result_array();

	}

	function get_item_kit($inum)
	{
		$this->db->from('item_kits');
		$this->db->where('inum',$inum);
		$this->db->where('del',0);
		$query = $this->db->get();
	if($query->num_rows()==1) { return $query->row();}
	else { return 0; }
	}

	function save_item_kit(&$kit_data, $inum)
	{	
		if (!$inum or !$this->exists_item_kit($inum))
		{
			if($this->db->insert('item_kits',$kit_data))
			{ 
				$kit_data['kit_id']=$this->db->insert_id();
			   return true;
			}
			else { return false; }
		}
		$this->db->where('inum', $inum);
		return $this->db->update('item_kits',$kit_data);
	}

	function update_item_kit($kit_data,$inum)
	{
		if (!$this->exists_item_kit($inum)) { return false; }
		$this->db->where('inum', $inum);
		return $this->db->update('item_kits',$kit_data);
	}


/*========================= KITS End ========================== */




	
/*========================= REBUILDs ========================== */	
	function get_9810x($inum,$vedom)
	{
		$this->db->select(
					  'doc_id,
					   doc_number,
					   mode_id,
					   item_number,
						location,
						deleted', false);
		$this->db->from($vedom.'_items');
			$this->db->where('mode_id','MK');
			$this->db->where('item_number',$inum);
			$this->db->where('location',0);
			$this->db->where('deleted',0);
		$this->db->order_by('doc_id','asc');
   return $this->db->get()->result_array();
	}
	
	function delete_9810x($inum,$vedom,$doc_id=0)
	{
		$this->db->trans_start();
			
			$this->db->delete( $vedom.'_items', 
									 array('doc_id'=>$doc_id,'mode_id'=>'MK','item_number'=>$inum) );
									
			$this->db->delete( $vedom, 
									 array('doc_id'=>$doc_id,'mode_id'=>'MK','location'=>0) );		

      $this->db->trans_complete();
   return $this->db->trans_status();
	}
	
	
	function HelpMe($data)
	{
		echo '<!DOCTYPE HTML>
		<html lang="en-US">
		<head>
			<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		</head>
		<body style="margin-left:20px;">';
		print_r($data);
		die();
	}

} ?>
