<?php
class Label extends CI_Model 
{

	function exists_label($label_id)
	{	$this->db->from('labels');
		$this->db->where('label_id',$label_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function get_all_labels()
	{
      $this->db->from('labels');
		$this->db->order_by('label_id','asc');
	return $this->db->get();
	}

	
	function get_label($label_id)
   {
      $this->db->from('labels');
		$this->db->where('label_id',$label_id);
		$query = $this->db->get();
		if($query->num_rows()==1){return $query->row();}
		else{return 0;}
	}	

	function save_label(&$label_data)
	{	$label_id=$label_data['label_id'];
		if(!$this->exists_label($label_id))
			{return $this->db->insert('labels',$label_data);}
		$this->db->where('label_id',$label_id);
	return $this->db->update('labels',$label_data);
	}
	
	function update_label($label_data)
	{	$label_id=$label_data['label_id'];
		if(!$this->exists_label($label_id)){return false;}
		$this->db->where('label_id',$label_id);
	return $this->db->update('labels',$label_data);
	}
	
	
	function exists_plan_item($inum=0)
	{	$this->db->from('items_plan');
		$this->db->where('inum',$inum);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}	
	
	function update_plan_item($plan_data,$plan_id,$vedom)
	{  
		$this->db->where('plan_id',$plan_id);
		$success = $this->db->update( $vedom, $plan_data );
	return $success;
	}
	
	
/* ------------------------------------ BiCODE EAN-8 ------------------------------ */
	public function barcode_bicode_8($barcode_8)
	{
	$barcode_in = str_pad($barcode_8, 7, "0", STR_PAD_LEFT);
	// проверка за цифра и по-голяма от 

	$bar_1 	= array( '0' => 'p', '1' => 'q', '2' => 'w', '3' => 'e', '4' => 'r',
							'5' => 't', '6' => 'z',	'7' => 'u',	'8' => 'i',	'9' => 'o');

	$bar_2 	= array( '0' => '-', '1' => 'y', '2' => 'x', '3' => 'c',	'4' => 'v',
							'5' => 'b', '6' => 'n', '7' => 'm', '8' => ',', '9' => '.');

	$bar_S8 	= array( '0'=>3, '1'=>1, '2'=>3, '3'=>1, '4'=>3, '5'=>1, '6'=>3, '7'=>1);

		$bar_left 	= '*'; 
		$bar_right 	= '';
		$bar_suma 	= 0;
		$barcode 	= 0;

			// лявата част = 4 символа
			for($k=0;$k<4;$k++)
			{
				$num = substr($barcode_in, $k, 1);
				$bar_left .= $bar_1[$num];
				$bar_suma += $num * $bar_S8[$k];
			}

			// дясната част = 3 символа
			for($k=4;$k<7;$k++)
			{
				$num = substr($barcode_in, $k, 1);
				$bar_right .= $bar_2[$num];
				$bar_suma  += $num * $bar_S8[$k];
			}

		$bar_symbol = $bar_2[substr( (10-substr($bar_suma,-1)) ,-1)];
		$barcode = $bar_left.'#'.$bar_right.$bar_symbol.'*';

	return $barcode;
	}


/* ------------------------------------ BarCODE UPC12 BiSOFT font:BC-10 ----------------------------- */
	public function barcode_bicode_12($barcode_12)
	{
		$barcode_in = str_pad($barcode_12, 11, "0", STR_PAD_LEFT);
		// проверка за чифра и по-голяма от 

		$bar1_10 	= array( '0' => 'a', '1' => 'b', '2' => 'c', '3' => 'd', '4' => 'e',
									 '5' => 'f', '6' => 'g',	'7' => 'h',	'8' => 'i',	'9' => 'j');

		$bar1_10_H 	= array( '0' => 'k', '1' => 'l', '2' => 'm', '3' => 'n', '4' => 'o',
									 '5' => 'p',	'6' => 'q',	'7' => 'r',	'8' => 's', '9' => 't');

		$bar2_10_H 	= array( '0' => 'u', '1' => 'v', '2' => 'w', '3' => 'x',	'4' => 'y',
									 '5' => 'z', '6' => '-', '7' => '_', '8' => ',', '9' => '.');

		$barS_10 	= array( '0'=>3, '1'=>1, '2'=>3, '3'=>1, '4'=>3, '5'=>1, '6'=>3,
									 '7'=>1, '8'=>3, '9'=>1,'10'=>3,'11'=>1,'12'=>3);

		$bar_left 	= '*'; 
		$bar_right 	= '';
		$bar_suma 	= 0;
		$barcode 	= 0;

			// лявата част = 6 символа
			for($k=0;$k<6;$k++)
			{
				$num = substr($barcode_in, $k, 1);
				$bar_left .= $bar1_10[$num];
				$bar_suma += $num * $barS_10[$k];
			}

			// дясната част = 5 символа
			for($k=6;$k<11;$k++)
			{
				$num = substr($barcode_in, $k, 1);
				$bar_right .= $num;
				$bar_suma  += $num * $barS_10[$k];
			}

		$bar_symbol = substr( (10-substr($bar_suma,-1)) ,-1) ;
		$barcode = $bar_left.'#'.$bar_right.$bar_symbol.'*';

	return $barcode;
	}


/* ------------------------------------ BarCODE EAN-13 BiSOFT font:BC-20 ----------------------------- */
	public function barcode_ean_20($barcode_20)
	{
		$barcode_in = str_pad($barcode_20, 12, "0", STR_PAD_LEFT);
		// проверка за чифра и по-голяма от 

		$bar1_20 	= array( '0' => 'p', '1' => 'q', '2' => 'w', '3' => 'e', '4' => 'r',
									 '5' => 't', '6' => 'y',	'7' => 'u',	'8' => 'i',	'9' => 'o');
									 
		$bar1_20b 	= array( '0' => 'ö', '1' => 'a', '2' => 's', '3' => 'd', '4' => 'f',
									 '5' => 'g', '6' => 'h',	'7' => 'j',	'8' => 'k',	'9' => 'l');
									 
		$bar2_20 	= array( '0' => '-', '1' => 'y', '2' => 'x', '3' => 'c', '4' => 'v',
									 '5' => 'b', '6' => 'n',	'7' => 'm',	'8' => ',',	'9' => '.');

		$barS_20 	= array( '0'=>3, '1'=>1, '2'=>3, '3'=>1, '4'=>3, '5'=>1, '6'=>3,
									 '7'=>1, '8'=>3, '9'=>1,'10'=>3,'11'=>1,'12'=>3);

		$bar_left 	= '2*'; 
		$bar_right 	= '';
		$bar_suma 	= 0;
		$barcode 	= 0;

			// лявата част = 6 символа
			for($k=0;$k<=1;$k++)
			{
				$num = substr($barcode_in, $k, 1);
				$bar_left .= $bar1_20[$num];
				$bar_suma += $num * $barS_20[$k];
			}
			
			for($k=2;$k<=3;$k++)
			{
				$num = substr($barcode_in, $k, 1);
				$bar_left .= $bar1_20b[$num];
				$bar_suma += $num * $barS_20[$k];
			}
			
				$num = substr($barcode_in, 4, 1);
				$bar_left .= $bar1_20[$num];
				$bar_suma += $num * $barS_20[4];
				
				$num = substr($barcode_in, 5, 1);
				$bar_left .= $bar1_20b[$num];
				$bar_suma += $num * $barS_20[5];

			// дясната част = 5 символа
			for($k=6;$k<11;$k++)
			{
				$num = substr($barcode_in, $k, 1);
				$bar_right .= $bar2_20[$num];
				$bar_suma  += $num * $barS_20[$k];
			}
			
				$num = substr($barcode_in, 11, 1);
				$bar_right .= $bar2_20[$num];

		$bar_symbol = substr( (10-substr($bar_suma,-1)) ,-1) ;
		$barcode = $bar_left.'#'.$bar_right.'*';

	return $barcode;
	}
	
	
/* ------------------------------------ BarCODE EAN-13 BiSOFT font:BC-20 ----------------------------- */
	public function barcode_ean_9($barcode_in)
	{
		// използва се за БКК - кодова таблица №9 фонт = ean.ttf

		$bar1_20 	= array( '0' => 'p', '1' => 'q', '2' => 'w', '3' => 'e', '4' => 'r',
									 '5' => 't', '6' => 'z',	'7' => 'u',	'8' => 'i',	'9' => 'o');
									 
		$bar1_20b 	= array( '0' => 'ö', '1' => 'a', '2' => 's', '3' => 'd', '4' => 'f',
									 '5' => 'g', '6' => 'h',	'7' => 'j',	'8' => 'k',	'9' => 'l');
									 
		$bar2_20 	= array( '0' => '-', '1' => 'y', '2' => 'x', '3' => 'c', '4' => 'v',
									 '5' => 'b', '6' => 'n',	'7' => 'm',	'8' => ',',	'9' => '.');

		$barS_20 	= array( '0'=>3, '1'=>1, '2'=>3, '3'=>1, '4'=>3, '5'=>1, '6'=>3,
									 '7'=>1, '8'=>3, '9'=>1,'10'=>3,'11'=>1,'12'=>3);

		$bar_left 	= '9*'; 
		$bar_right 	= '';
		$bar_suma 	= 0;
		$barcode 	= 0;

			// лявата част = 6 символа
			$num = substr($barcode_in, 0, 1);
			$bar_left .= $bar1_20[$num];
			$bar_suma += $num * $barS_20[0];
		
			for($k=1;$k<=2;$k++)
			{
				$num = substr($barcode_in, $k, 1);
				$bar_left .= $bar1_20b[$num];
				$bar_suma += $num * $barS_20[$k];
			}
		
			$num = substr($barcode_in, 3, 1);
			$bar_left .= $bar1_20[$num];
			$bar_suma += $num * $barS_20[3];
			
			$num = substr($barcode_in, 4, 1);
			$bar_left .= $bar1_20b[$num];
			$bar_suma += $num * $barS_20[4];

			$num = substr($barcode_in, 5, 1);
			$bar_left .= $bar1_20[$num];
			$bar_suma += $num * $barS_20[5];

			// дясната част = 5 символа
			for($k=6;$k<11;$k++)
			{
				$num = substr($barcode_in, $k, 1);
				$bar_right .= $bar2_20[$num];
				$bar_suma  += $num * $barS_20[$k];
			}
			
			$bar_suma  += 9; // заради кода '9' ?!
		
		$bar_symbol = $bar2_20[substr( (10-substr($bar_suma,-1)) ,-1)] ;
		$barcode = $bar_left.'#'.$bar_right.$bar_symbol.'*';

	return $barcode;
	}	
	
/* -------------------------------------- BarCODE 2 from 5 ----------------------------- */
	public function barcode_bicode_25($barcode_25)
	{
      $barcode_in = '99'.str_pad($barcode_25, 12, "0", STR_PAD_LEFT);
      // проверка за цифра и по-голяма от 14

      $bar_25 	= array( '00'=>'!', '01'=>'"', '02'=>'#', '03'=>'$', '04'=>'%', 
                        '05'=>'&', '06'=>'\'', '07'=>'(', '08'=>')', '09'=>'*',

                        '10'=>'+', '11'=>',', '12'=>'-','13'=>'.', '14'=>'/',
                        '15'=>'0', '16'=>'1','17'=>'2', '18'=>'3','19'=>'4',
                        
                        '20'=>'5', '21'=>'6', '22'=>'7','23'=>'8', '24'=>'9',
                        '25'=>':', '26'=>';','27'=>'<', '28'=>'=','29'=>'>',
                        
                        '30'=>'?', '31'=>'@', '32'=>'A','33'=>'B', '34'=>'C',
                        '35'=>'D', '36'=>'E','37'=>'F', '38'=>'G','39'=>'H',
                        
                        '40'=>'I', '41'=>'J', '42'=>'K','43'=>'L', '44'=>'M',
                        '45'=>'N', '46'=>'O','47'=>'P', '48'=>'Q','49'=>'R',
                        
                        '50'=>'S', '51'=>'T', '52'=>'U','53'=>'V', '54'=>'W',
                        '55'=>'X', '56'=>'Y','57'=>'Z', '58'=>'[','59'=>'\\',
                        
                        '60'=>']', '61'=>'^', '62'=>'_','63'=>'`', '64'=>'a',
                        '65'=>'b', '66'=>'c','67'=>'d', '68'=>'e','69'=>'f',
                        
                        '70'=>'g', '71'=>'h', '72'=>'i','73'=>'j', '74'=>'k',
                        '75'=>'l', '76'=>'m','77'=>'n', '78'=>'o','79'=>'p',
                        
                        '80'=>'q', '81'=>'r', '82'=>'s','83'=>'t', '84'=>'u',
                        '85'=>'v', '86'=>'w','87'=>'x', '88'=>'y','89'=>'z',
                        
                        '90'=>'{', '91'=>'|', '92'=>'}', '93'=>'~', '94'=>'Ä',
                        '95'=>'Å', '96'=>'Æ', '97'=>'Ç', '98'=>'È', '99'=>'É');

      // 'Ê' // Ë
      $bar_left  = 'Ê'; 
      $bar_right = 'Ë';
		$bar = '';				
		for($k=0;$k<14;$k+=2)
		{
			$num = substr($barcode_in, $k, 2);
			$bar .= $bar_25[$num];
		}					
	
		$barcode = $bar_left.$bar.$bar_right;   // 'ÄÅÆÇÈÉ'
		
	return $barcode;
	}

}
?>
