<?php
class Material extends CI_Model 
{
	/*	Determines if a given mat_id is an mat */
	function exists($mat_id, $key)
	{
		$this->db->from('materials');
		$this->db->where('mat_id',$mat_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	
	/*	Determines if a given mat_NUMBER is an mat	*/
	function exists_by_number($mat_number)
	{
		$this->db->from('materials');
		$this->db->where('mat_number',$mat_number);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}


	/*	Determines if a given doc_NUMBER is in the Vedom	*/
	function exists_doc_number($doc_number, $vedom)
	{
		$this->db->from($vedom);
		$this->db->where('doc_number',$doc_number);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	

	/*	Determines if a given doc_NUMBER is in the Vedom	*/
	function get_document($doc_id, $vedom)
	{
		$this->db->from($vedom);
		$this->db->where('doc_id',$doc_id);
		$query = $this->db->get();
		if($query->num_rows()==1) 
			  { return $query->row();}
		else { return 0;} 
	}
	
	
	function update_document($doc_data, $doc_id, $vedom)
	{
		$this->db->where('doc_id', $doc_id);
	return $this->db->update( $vedom, $doc_data);
	}


	/* Returns all the materials */
	function get_all($limit=50000, $offset=0)
	{
		$this->db->from('materials');
		$this->db->where('deleted',0);
		$this->db->order_by('mat_number', 'asc');
		$this->db->limit($limit);
		$this->db->offset($offset);
	return $this->db->get();
	}


	/*	Returns all REAL materials */
	function get_all_real($limit=50000, $offset=0)
	{
		$this->db->from('materials');
		$this->db->where('deleted',0);
		$this->db->where('quantity > 0');
		$this->db->order_by('mat_number', 'asc');
		$this->db->limit($limit);
		$this->db->offset($offset);
	return $this->db->get();
	}

	/* Returns all the materials by assort */
	function get_all_assort($assort,$limit=50000, $offset=0)
	{
		$this->db->from('materials');
		$this->db->where('deleted',0);
		if($assort!=0) {$this->db->where('mat_assort',$assort);}
		$this->db->order_by('mat_number', 'asc');
		$this->db->limit($limit);
		$this->db->offset($offset);
	return $this->db->get();
	}
	
	
	function count_all($assort)
	{
		$this->db->from('materials');
		$this->db->where('deleted',0);
		if( $assort != '0' )
		{ $this->db->where('mat_assort', $assort); }
	return $this->db->count_all_results();
	}
	
	function get_name($mat_number)
	{
		$this->db->from('materials');
		$this->db->where('mat_number',$mat_number);
		$query = $this->db->get();
		if($query->num_rows()==1) 
			  { return $query->row()->name;}
		else { return '';} 
	}
	
	function get_blanka($mat_number)
	{
		$this->db->select('mat_number,name,mat_color,mat_width,mat_measure,supplier_id,deleted');
		$this->db->from('materials');
		$this->db->where('mat_number',$mat_number);
		$query = $this->db->get();
		if($query->num_rows()==1) 
			  { return $query->row();}
		else { return '';} 
	}

	function getVedomData($vedom,$mode_id)
	{
		$this->db->select('doc_id,mode,mode_id,doc_number,doc_date,mat_number,
								top_1,top_2,top_3,top_4,top_5,top_6,top_7,top_8,top_9,top_10,
								quantity,kgs,meters,employee_id,deleted');
		$this->db->from($vedom);
		if($mode_id) {$this->db->where('mode_id', $mode_id);}
		$this->db->where('deleted', 0);
		$this->db->order_by('doc_date', 'desc');
	return $this->db->get()->result_array();	
	}
	
	function getVedomColumns()
	{
		$mode_id = $this->mat_lib->get_mode_id();
		$suppl 	= $this->lang->line('mats_supplier');
		if($mode_id=='prM') {$suppl='подизпълнител';}
		return array( ' ',
					$this->lang->line('reports_document'), 
					$this->lang->line('reports_date'), 
					$this->lang->line('mats_number'), 
					$this->lang->line('mats_name'),
					$suppl,
					$this->lang->line('mats_meters'),
					$this->lang->line('mats_kgs_short'), 
					$this->lang->line('reports_quantity'),
					'т-1','т-2','т-3','т-4','т-5',
					'т-6','т-7','т-8','т-9','т-10',
					$this->lang->line('reports_type'),
					'DEL' );
	}
	

	function get_all_filtered($low_inventory,$no_description,$allow_sizes_key)
	{
		$this->db->from('materials');
		if ($low_inventory != 0 )
		{
			 $this->db->where('quantity > ', 0);
		}
		if ($no_description != 0 )
		{
			$this->db->where('description','');
		}
		if ($allow_sizes_key != 0 )
		{
			$this->db->where('allow_sizes',1);
		}
		$this->db->where('deleted',0);
		$this->db->order_by("name", "asc");
	return $this->db->get();
	}

/*	-------------------------------- Assortment ------------------------------- */
	function get_all_assorts()
	{
		$this->db->from('mat_table');
		$this->db->order_by("key", "asc");
	return $this->db->get();		
	}

	
	/*	Gets information about a particular material */
	function get_info($mat_id)
	{
		$this->db->from('materials');
		$this->db->where('mat_id',$mat_id);
		$query = $this->db->get();

		if($query->num_rows()==1)
		{ return $query->row();}
		else
		{	//Get empty base parent object, as $mat_id is NOT an mat
			$mat_obj=new stdClass();

			//Get all the fields from materials table
			$fields = $this->db->list_fields('materials');

			foreach ($fields as $field)
            { $mat_obj->$field='';}

		return $mat_obj;
		}
	}

// my info
//	Gets information from central DB about mat_id for any mat by NUMBER
	function get_all_info($mat_number)
	{
		$this->db->from('materials');
		$this->db->where('mat_number',$mat_number);
		$query = $this->db->get();

		if($query->num_rows()==1)
				{ return $query->row()->mat_id;}
		else 	{ return false; }
	}
	
	function get_kgs_lmeter($mat_number)
	{
		$this->db->from('materials');
		$this->db->where('mat_number',$mat_number);
		$query = $this->db->get();
		if($query->num_rows()==1)
				{ return $query->row()->kgs_lmeter;}
		else 	{ return false; }
	}
	
	function get_matwidth($mat_number)
	{
		$this->db->from('materials');
		$this->db->where('mat_number',$mat_number);
		$query = $this->db->get();
		if($query->num_rows()==1)
				{ return $query->row()->mat_width;}
		else 	{ return false; }
	}	


	/*	Get an mat id given an mat number */
	function get_mat_id($mat_number)
	{
		$this->db->from('materials');
		$this->db->where('mat_number',$mat_number);
		$query = $this->db->get();
		if($query->num_rows()==1)
		{ return $query->row()->mat_id;}
	return false;
	}


	/*	Get an mat id given an mat number */
	function get_mat_number($mat_number)
	{
		$this->db->from('materials');
		$this->db->where('mat_number',$mat_number);

		$query = $this->db->get();

		if($query->num_rows()==1)
		{
			return $query->row()->mat_id;
		}

	return false;
	}


	/* Gets information about multiple materials */
	function get_multiple_info($mat_ids)
	{
		$this->db->from('materials');
		$this->db->where_in('mat_id',$mat_ids);
		$this->db->order_by("mat", "asc");
	return $this->db->get();
	}


	/*	Inserts or updates a mat to any store	*/
	function save(&$mat_data,$mat_id)
	{	
		if (!$mat_id or !$this->exists($mat_id))
		{
			if($this->db->insert('materials',$mat_data))
			{
				$mat_data['mat_id']=$this->db->insert_id();
				$this->db->insert('materials_R',$mat_data);
				return true;
			}
		return false;
		}
		$this->db->where('mat_id', $mat_id);
	return $this->db->update('materials',$mat_data);
	}

	
	/*	Inserts or updates a mat by BiSOFT NUMBER */
	function save_mat_number( &$mat_data, $mat_number)
	{
		if (!$mat_number or !$this->exists_by_number($mat_number))
		{
			if($this->db->insert( 'materials', $mat_data))
			{
				$mat_data['mat_id']=$this->db->insert_id();
				$this->db->insert('materials_R',$mat_data);
				return true;
			}
		return false;
		}
		$this->db->where('mat_number', $mat_number);
	return $this->db->update( 'materials', $mat_data);
	}

	/*	Updates multiple materials at once */
	function update_multiple($mat_data,$mat_ids)
	{
		$this->db->where_in('mat_id',$mat_ids);
	return $this->db->update('materials',$mat_data);
	}

	/*	Inserts or updates a mat to any store	*/
	function save_vedom(&$doc_data,$vedom,$doc_id)
	{	
		if (!$doc_id)
		{
			if($this->db->insert($vedom,$doc_data))
			{
				return $doc_data['doc_id']=$this->db->insert_id();
			}
		return false;
		}
		$this->db->where('doc_id', $doc_id);
	return $this->db->update($vedom,$doc_data);
	}


	/*	Deletes one mat */
	function delete($mat_id)
	{
	//	$this->db->where('mat_id', $mat_id);
	//	$this->db->update('materials_R', array('deleted' => 1));
		$this->db->where('mat_id', $mat_id);
	return $this->db->update('materials', array('deleted' => 1));
	}

	/*	Deletes a list of materials */
	function delete_list($mat_ids)
	{
		$this->db->where_in('mat_id',$mat_ids);
	return $this->db->update('materials', array('deleted' => 1));
 	}

 	
	function exists_supplier($bisoft_id)
	{
		$this->db->from('suppliers');
		$this->db->where('bisoft_id',$bisoft_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
 	
	/*	Get search suggestions to find materials */
	function get_search_suggestions($search,$limit=25)
	{
		$suggestions = array();
	
		$this->db->from('materials');
		$this->db->like('name', $search);
		$this->db->where('deleted',0);
		$this->db->order_by("name", "asc");
		$by_name = $this->db->get();
		foreach($by_name->result() as $row)
         { $suggestions[]=$row->name;}

		$this->db->from('materials');
		$this->db->like('mat_number', $search);
		$this->db->where('deleted',0);
		$this->db->order_by("mat_number", "asc");
		$by_mat_number = $this->db->get();
		foreach($by_mat_number->result() as $row)
         { $suggestions[]=$row->mat_number;}

		//only return $limit suggestions
		if(count($suggestions > $limit))
         { $suggestions = array_slice($suggestions, 0,$limit);}
	return $suggestions;
	}


	function get_mat_search_suggestions($search,$limit=25)
	{
		$suggestions = array();
		$this->db->from('materials');
		$this->db->where('deleted',0);
		$this->db->like('name', $search);
		$this->db->order_by("name", "asc");
		$by_name = $this->db->get();
		foreach($by_name->result() as $row)
         { $suggestions[]=$row->mat_id.'|'.$row->name;}
	
		$this->db->from('materials');
		$this->db->where('deleted',0);
		$this->db->like('mat_number', $search);
		$this->db->order_by("mat_number", "asc");
		$by_mat_number = $this->db->get();
		foreach($by_mat_number->result() as $row)
         { $suggestions[]=$row->mat_id.'|'.$row->mat_number;}

		//only return $limit suggestions
		if(count($suggestions > $limit))
         { $suggestions = array_slice($suggestions, 0,$limit);}
         
   return $suggestions;
	}

	function get_category_suggestions($search)
	{
		$suggestions = array();
	return $suggestions;
	}


	/* Preform a search on materials */
	function search($search)
	{
		$this->db->from('materials');
		$this->db->where("(name LIKE '%".$this->db->escape_like_str($search)."%' or 
		mat_number LIKE '%".$this->db->escape_like_str($search)."%') and deleted=0");
		$this->db->order_by("name", "asc");
	return $this->db->get();
	}

	
	function get_categories()
	{
		$this->db->select('category');
		$this->db->from('materials');
		$this->db->where('deleted',0);
		$this->db->distinct();
		$this->db->order_by("category", "asc");
	return $this->db->get();
	}


// ------------------------------- BarCode  ------------------------------------- //
	function is_valid_mat_number($barcode_mat) 
	{
	   if (!is_numeric($barcode_mat)) { return false; }
	   $lenBarcode = strlen($barcode_mat);
	   if ($lenBarcode <  11 or $lenBarcode > 13 ) { return false; }
	return true;
	}

	function is_valid_barcode($barcode_mat)
	{ //barCode validation
		if (!is_numeric($barcode_mat)) { return false; }	
		$lenBarcode = strlen($barcode_mat);
	   if ($lenBarcode <  11 or $lenBarcode > 13 ) { return false; }
	return true;
	}

	function add_mat_barcode($barcode_mat, $mode="sale")
	{ //barCode #
	$lenBarcode = strlen($barcode_mat);
	$mat_number = 0;
	$barcode = substr($barcode_mat,0,-1);

	$quantity = $mode=="sale" ? 1:-1;



	$mat_id = $this->get_mat_id($mat_number);
	
	$data = array (
		'mat_number' => $mat_id,
		'quantity' => $quantity );

	return $data;
	}

// end of my stuff --------------------------------------------------------------------------
	function get_db_materials_inv_location()
	{
      return '';
	}

	function get_db_materials_outv_location()
	{
      return '';
	}

	/*	Get location from user  моя функция */
	function get_db_materials_location()
	{
		return 'materials';
	}

}
?>
