<?php class Person extends CI_Model 
{
	/* Determines whether the given person exists */
	function exists($person_id)
	{
		$this->db->from('people');	
		$this->db->where('people.person_id',$person_id);
		$query = $this->db->get();
		
	return ($query->num_rows()==1);
	}
	
	/* Gets all people */
	function get_all()
	{
		$this->db->from('people');
		$this->db->order_by("first_name", "asc");
	return $this->db->get();		
	}
	
	function count_all()
	{
		$this->db->from('people');
		$this->db->where('deleted',0);
	return $this->db->count_all_results();
	}
	
	/* Gets information about a person as an array. */
	function get_info($person_id)
	{
		$query = $this->db->get_where('people', array('person_id' => $person_id), 1);
		if($query->num_rows()==1) {return $query->row();}
		else
		{	//create object with empty properties.
			$fields = $this->db->list_fields('people');
			$person_obj = new stdClass;
			foreach ($fields as $field) {$person_obj->$field='';}
		return $person_obj;
		}
	}

	function get_info_by_bisoft_id($bisoft_id)
	{
		$this->db->from('people');	
		$this->db->where('people.bisoft_id',$bisoft_id);
		$query = $this->db->get();
		if($query->num_rows()==1) {return $query->row();}
		else {return 0;}			
	}

	/*	Get people with specific ids */
	function get_multiple_info($person_ids)
	{
		$this->db->from('people');
		$this->db->where_in('person_id',$person_ids);
		$this->db->order_by("first_name", "asc");
		return $this->db->get();		
	}
	
	/*	Inserts or updates a person  function save(&$person_data,$person_id=false) */
	function save_person(&$person_data,$person_id=false)
	{		
		if (!$person_id or !$this->exists($person_id))
		{
			if ($this->db->insert('people',$person_data))
			{
				$person_data['person_id']=$this->db->insert_id();
				return true;
			}
		return false;
		}
		$this->db->where('person_id', $person_id);
	return $this->db->update('people',$person_data);
	}
	
	/* Deletes one Person (doesn't actually do anything) */
	function delete($person_id)
	{ return true;}
	
	/*	Deletes a list of people (doesn't actually do anything) */
	function delete_list($person_ids)
	{ return true;}
 	
	function get_status_info($type=0)
	{
		$status_base = array(
				'0' => '',
				'client'  => 'клиент',
				'cliento' => 'клиент т.о.',
			 'clientvat' => 'клиент (+ДДС)',
				'online'	 => 'online клиент',
            'onlineto'=> 'online т.о.',
				'invoice' => 'само фактури',
			  'supplier' => 'доставчик',
			'supplierto' => 'дост т.о.',
			 'principle' => 'възложител',
				'subcont' => 'подизпълнител',
			'subcont_GP' => 'доставчик-ГП',
				'shop'	 => 'магазин',
				'comis'	 => 'комисионер',
				'distro'	 => 'дистрибутор',
				'outlet'	 => 'outlet' );
				
		$status = $status_base[$type];	
				
	return $status;
	}
	
}
?>
