<?php
class Production extends CI_Model 
{

	function exists($doc_id, $vedomPack)
	{  
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}


	public function get_info($doc_id, $vedomPack, $mode='manu_db')
	{  
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
	return $this->db->get();
	}

	public function get_info_line($doc_id, $line, $vedomPack)
	{  
		$this->db->from($vedomPack.'_items');
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
	return $this->db->get();
	}

	function get_item_info($item_number)
	{
		$this->db->from('items');
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
	if($query->num_rows()==1)
		{ return $query->row();}
	else
		{ return false;}
	}
	

	function get_item_exp($item_number,$vedomPack)
	{
      $this->db->select('	
				item_number,
				mode_id,
				doc_date,
				sum(item_qty) as qty, 
				deleted,
				location',	false);
		$this->db->from($vedomPack);
		$this->db->where('item_number',$item_number);
		$this->db->where('mode_id in ("E", "BE", "ED")');
		$this->db->group_by('item_number');
		
		$query = $this->db->get();
	if($query->num_rows()>0)
		{ return $query->row();}  // result_array()
	else
		{ return false;}
	}
	
	
/* ============================= DBMANU datebase ==========================  */
	function manu_id_exists($manu_id)
	{	
		$this->db->from('dbmanu');
		$this->db->where('manu_id',$manu_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function dbmanu_item_exists($inum)
	{	
		$this->db->from('dbmanu');
		$this->db->where('inum',$inum);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function get_manu_id($manu_id)
	{  
		$this->db->from('dbmanu');
		$this->db->where('manu_id',$manu_id);
		$query = $this->db->get();

	if($query->num_rows()==1)
			{ return $query;}
	else 	{ return false; }
	}
	
	function get_manu_id_by_inum($inum)
	{  
		$this->db->from('dbmanu');
		$this->db->where('inum',$inum);
		$this->db->where('deleted',0);
		$query = $this->db->get();

	if($query->num_rows()==1)
			{ return $query->row()->manu_id;}
	else 	{ return false; }
	}

	
	function save_manu_id( $manu_id, $manu_data )
	{
		if (!$this->manu_id_exists($manu_id) or !$manu_id) // нов запис
			{
				$this->db->trans_start();
					$success = $this->db->insert('dbmanu', $manu_data );
				$this->db->trans_complete();
			}
		else  // само актуализира
			{
				$this->db->trans_start();
					$this->db->where('manu_id', $manu_id);
					$success = $this->db->update('dbmanu', $manu_data );
				$this->db->trans_complete();
			}
	return $success;
	}
	
	
	function update_manu_id($manu_id, $manu_data)
	{
		if (!$this->manu_id_exists($manu_id)) // нов запис
			{ return false; }
		else  // само актуализира
			{
				$this->db->trans_start();
					$this->db->where('manu_id', $manu_id);
					$success = $this->db->update('dbmanu', $manu_data );
				$this->db->trans_complete();
			}
	return $success;
	}

	
	function get_all_dbmanu_items($select_mode,$inum,$from_period,$to_period)
	{  
		$this->db->from('dbmanu');
		if($inum>999 and $inum<100000)  // item
         { $this->db->where('inum',$inum);}
      elseif($inum>0 and $inum<99)    // group
         {
            $start_group = 1000*$inum;
            $end_group   = 1000*(1+$inum);if($end_group==100000){$end_group=99000;}
            $this->db->where("inum > $start_group AND inum < $end_group");
         }
      
      $select_date = 'plan_date';
      if($select_mode)
      {
         switch($select_mode)
         {
            case 'plan': $select_date = 'plan_date'; break;
            case 'patt': $select_date = 'patt_date'; break;
            case 'ceh':  $select_date = 'mk_date'; break;
            case 'dost': $select_date = 'dost_date'; break;
            case 'sklad': $select_date = 'sgp_date'; break;
            case 'exp':  $select_date = 'exp_date'; break;
         }
      }
      
      if($from_period and $to_period)
      {
         $start_date = date("Y-$from_period-01");
         
         $veryEnd = 31;
         $nowYear = date("Y");
         switch($to_period)
            {
               case '02': $veryEnd = 28; break;
               case '04': $veryEnd = 30; break;
               case '06': $veryEnd = 30; break;
               case '09': $veryEnd = 30; break;
               case '11': $veryEnd = 30; break;
            }
         if($nowYear==2020 or $nowYear==2024 or $nowYear==2028 or $nowYear==2032 or $nowYear==2036 or $nowYear==2040) 
            {$veryEnd = 29;} // стига толкова - вече ще съм на пенсия :)
         $end_date = date("Y-$to_period-$veryEnd");
      
         $this->db->where( $select_date.' BETWEEN "'.$start_date.'" AND "'.$end_date.'"');
      }

		$this->db->where('deleted',0);
		$this->db->order_by('inum');
	return $this->db->get()->result_array();
	}


/* ============================= END DBMANU datebase ==========================  */	
	
	
	
	
	// брилянтна функция за разделяне на артикул и вид //
	public function get_item_and_type($item)
	{
		$type=1;$key=1;$type=0;$item_number=0;
		if(!is_numeric($item))	
		  { 
			 $item = str_replace('-', '', $item);
		  }
		$len_item = strlen($item);
		
		if(!is_numeric($item) or $len_item<4 or $len_item>6) {return 0;}

		if($len_item==6)
		{
		  $item_number = (int) substr($item,0,5);
  		  $type = substr($item,-1);
		}
		elseif($len_item==5)
		{
		  $item_number = $item;
		  $type=0;$key=0;
		}		

		$item_data = array(
					'item' => $item_number,
					'type' => $type,
					 'key' => $key );
				
	return $item_data;
	}

/* ========================== КРОЯЛНИ КАРТИ ===================== */
	function exists_bkk($bkk_id)
	{
		$this->db->from('BKK');
		$this->db->where('bkk_id',$bkk_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function get_bkk_info($bkk_id)
	{
		$this->db->from('BKK');
		$this->db->where('bkk_id',$bkk_id);
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{return $query->row();}
		else 
			{return 0;}
	}
	
	function get_bkk_item($item_number,$mk)
	{
		$this->db->from('BKK');
		$this->db->where('item_number',$item_number);
		$this->db->where('MK',$mk);		
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{return $query->row();}
		else 
			{return 0;}	
	}
	
	function get_bkk_id($item_number,$mk)
	{
		$this->db->from('BKK');
		$this->db->where('item_number',$item_number);
		$this->db->where('MK',$mk);		
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{return $query->row()->bkk_id;}
		else 
			{return 0;}	
	}
	
	function get_all_bkk($item_number=0,$period=0)
	{
		$level = 3;
		$limit = 100;
		$mEnd  = 0;
		
		$now_year = $this->BiSOFT_Model->get_user_mode_year();
		
		if($period)
		{
			$mEnd = 31;
			if($period==4 or $period==6 or $period==9 or $period==11) {$mEnd = 30;}
			elseif($period==2) 
				{  $mEnd = 28;
					if($now_year==2020 or $now_year==2024 or $now_year==2028 or $now_year==2032 or $now_year==2036 or $now_year==2040
											 or $now_year==2044 or $now_year==2048 or $now_year==2052 or $now_year==2056 or $now_year==2060 )
						{$mEnd = 29;} 
				}
			else {$mEnd = 31;}

			$period_2 = str_pad($period, 2, "0", STR_PAD_LEFT);
			$start_date = $now_year.'-'.$period_2.'-01';
			$end_date = $now_year.'-'.$period_2.'-'.$mEnd;
		}

		$this->db->from('BKK');
		$this->db->where('level < '.$level);
		$this->db->where('deleted',0);		
		if($item_number)
		  {
			 $this->db->where('item_number',$item_number);
			 $this->db->order_by('item_number, MK, pattern');
			 $this->db->limit($limit);
			 $this->db->order_by('start_date', "desc");
		  }
		elseif($period!=0 and $mEnd!=0)
		  {
			 $this->db->where('start_date BETWEEN "'.$start_date. '" and "'.$end_date.'"');
			 $this->db->order_by('item_number', "acs");
		  }
		else // вади последните 100 БKK-та
		  {
			 $this->db->limit($limit);
			 $this->db->order_by("start_date","desc");
		  }	  

	return $this->db->get()->result_array();
	}

	
	function get_min_bkk_id()
	{
		$this->db->select('min(bkk_id) as min_bkk', false);
		$this->db->from('BKK');
		$this->db->where('level', 0);
		$this->db->where('deleted', 0);
		$rezult = $this->db->get()->result_array();
		$min_value = $rezult['0']['min_bkk'];
	return $min_value;
	}

	function get_max_bkk_id()
	{
		$this->db->select('max(bkk_id) as max_bkk', false);
		$this->db->from('BKK');
		$this->db->where('deleted',0);
		$rezult = $this->db->get()->result_array();
		$max_value = 1 + $rezult['0']['max_bkk'];
		if($max_value=='1' or $max_value=='10000')
			{ $max_value=false; }
	return $max_value;
	}

	
	function get_free_bkk_id()
	{
      $bkk_id=1001;
      while($bkk_id < 10000)
      {
         if($this->exists_bkk($bkk_id))
         {
            $bkk_info = $this->get_bmk_info($bkk_id);
            $limit_Y = 0;
            $start_date = $bkk_info->start_date;
            if($start_date!=0 and $start_date!=null)
               {$limit_Y=date('Y',strtotime($start_date));}
            if($limit_Y<date('Y')) // delete
               {
                  $this->db->trans_start();
                    $this->db->delete( 'BKK', array('bkk_id'=>$bkk_id)); 
                  $this->db->trans_complete();
                  break;
               }
         }
         else {break;}
      $bkk_id++;
      } // while < 10000
      
	return $bkk_id;
	}


	function get_item_max_bkk($item_number=0)
	{
		$this->db->select('start_date, max(MK) as item_max_mk', false);
		$this->db->from('BKK');
		$this->db->where('item_number',$item_number);
		$this->db->where('deleted',0);
	return $this->db->get()->result_array();
	}
	
	
	function get_item_qty_BKK($inum=0)
	{  
      $result = 0;
      if($inum)
      {
         $this->db->select('	
               bkk_id, 
               item_number, 
               sum(start_qty)   as qty, 
               deleted', false);

         $this->db->from('BKK');
         $this->db->where('inum',$inum);
         $this->db->where('deleted',0);
         $result = $this->db->get()->result_array();
      }

	return $result;	
   }	
	
	
	function save_bkk(&$bkk_data,$bkk_id=false)
	{
		if (!$bkk_id or !$this->exists_bkk($bkk_id))
		{
			if($this->db->insert('BKK',$bkk_data))
			{
				$bkk_data['bkk_id']=$this->db->insert_id();
				return true;
			}
		return false;
		}
		$this->db->where('bkk_id', $bkk_id);
	return $this->db->update('BKK',$bkk_data);
	}
	
	function update_bkk($bkk_data,$bkk_id)
	{
		if (!$bkk_id or !$this->exists_bkk($bkk_id)) { return false;}
		$this->db->where('bkk_id', $bkk_id);
	return $this->db->update('BKK',$bkk_data);
	}

	
	function find_uncompleted_bkk($limit=20)
	{
		$uncompleted = array();
		$all_bkk = $this->get_all_bkk(0,0,$limit);
		if(count($all_bkk)>0)
		{
		  foreach ($all_bkk as $tech_array)
			 {
				$item_number = $tech_array['item_number'];
				$type = 1;			
				$check = $this->Techno->uncompleted_techno($item_number,$type);
				if(!$check) { $uncompleted[] = $tech_array;} // натрупва грешните БKК-та ...
			 }
		}
	return $uncompleted;
	}

	
	function get_calcKroiki($vedom)
	{
      $this->db->select('
            trz_id,
				period,
				KK,
            deleted', false);
	
		$this->db->from($vedom);
		$this->db->where('deleted',0);
		$this->db->where('period > 10000');
		$this->db->where('KK IS NOT NULL');
		$this->db->order_by('period');
	return $this->db->get()->result_array();	
	}
	
	function update_calcKroiki($vedom,$trz_id,$data)
	{
		$this->db->from($vedom);
		$this->db->where('deleted',0);
      $this->db->where('trz_id',$trz_id);
	return $this->db->update($vedom,$data);
	}
	
	
/* ========================== БАЗА КРОЙКИ ШАБЛОНИ ===================== */
	function exists_pattern($pattern)
	{
		$this->db->from('patterns');
		$this->db->where('pattern',$pattern);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function get_pattern($pattern=0)
	{  
		$this->db->from('patterns');
		$this->db->where('pattern',$pattern);
		$query = $this->db->get();
	if($query->num_rows()==1) 
		{return $query->row();}
	else 
		{return false;}
	}
	
	function get_all_patterns()
	{  
		$this->db->from('patterns');
		$this->db->where('deleted',0);
		$this->db->order_by('pattern');
	return $this->db->get()->result_array();
	}

	
	function save_pattern(&$pattern_data,$pattern)
	{
		if (!$pattern or !$this->exists_pattern($pattern))
		{
			if($this->db->insert('patterns',$pattern_data))
			{
				$pattern_data['pattern']=$this->db->insert_id();
				return true;
			}
		return false;
		}
		$this->db->where('pattern', $pattern);
	return $this->db->update('patterns',$pattern_data);
	}
	
	
	function update_pattern($pattern_data, $pattern)
	{  
		$this->db->where('pattern', $pattern);
		$this->db->where('deleted',0);
		$success = $this->db->update( 'patterns', $pattern_data );
	return $success;
	}

	function delete_pattern($pattern)
	{
		$this->db->trans_start();
		$this->db->delete('patterns', array('pattern' => $pattern ) );
		$this->db->trans_complete();
	return $this->db->trans_status();
	}		
	
	public function get_db_patts($patt_mode)
	{  
		$this->db->from('patt_db');
		$this->db->where('deleted',0);
		if($patt_mode==100) 
         {$this->db->where('patt_id > '.$patt_mode);}
		$this->db->order_by('patt_id');
	return $this->db->get()->result_array();
	}
	
	function get_info_patt_id($patt_id)
	{  
		$this->db->from('patt_db');
		$this->db->where('patt_id',$patt_id);
		$this->db->where('deleted',0);
		$query = $this->db->get();
	if($query->num_rows()==1) 
		{return $query->row();}
	else 
		{return '';}
	}
	
/* ========================== БАЗА КРОЙКИ ПО АРТИКУЛИ ===================== */
	function exists_patt_item($inum)
	{
		$this->db->from('patt_items');
		$this->db->where('item_number',$inum);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function get_all_patt_items()
	{  
		$this->db->from('patt_items');
		$this->db->where('deleted',0);
		$this->db->order_by('item_id');
	return $this->db->get()->result_array();
	}	
	
	function get_info_patt_item($inum)
	{  
		$this->db->from('patt_items');
		$this->db->where('item_number',$inum);
		$this->db->where('deleted',0);
		$query = $this->db->get();
	if($query->num_rows()==1) 
		{return $query->row();}
	else 
		{return '';}
	}
	
	function save_patt_item($inum,$patt_item_data)
	{ 
		if (!$inum or !$this->exists_patt_item($inum))
		{
			if($this->db->insert('patt_items',$patt_item_data))
            { return 1;}
         else  
            { return 0;}
		}
		$this->db->where('item_number', $inum);
	return $this->db->update('patt_items',$patt_item_data);
	}
	
/* ========================== МАРШРУТНИ КАРТИ ===================== */
	function exists_bmk($bmk_id)
	{
		$this->db->from('BMK');
		$this->db->where('bmk_id',$bmk_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function get_bmk_info($bmk_id)
	{
		$this->db->from('BMK');
		$this->db->where('bmk_id',$bmk_id);
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{return $query->row();}
		else 
			{return 0;}
	}
	
	function get_bmk_item($item_number,$type,$mk)
	{
		$this->db->from('BMK');
		$this->db->where('item_number',$item_number);
		$this->db->where('type',$type);
		$this->db->where('MK',$mk);		
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{return $query->row();}
		else 
			{return 0;}	
	}
	
	function get_bmk_id($item_number,$type,$mk)
	{
		$this->db->from('BMK');
		$this->db->where('item_number',$item_number);
		$this->db->where('type',$type);
		$this->db->where('MK',$mk);		
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{return $query->row()->bmk_id;}
		else 
			{return 0;}	
	}
	
	function get_all_bmk($item_number,$type,$period)
	{  
		$level = 10;
		$limit = 100;
		$mEnd  = 0;
		
		if($period)
		{
			$mEnd = 31;
			if($period==4 or $period==6 or $period==9 or $period==11) {$mEnd = 30;}
			elseif($period==2) 
				{  $mEnd = 28;
					if(date('Y')==2020 or date('Y')==2024 or date('Y')==2028 or date('Y')==2032 or date('Y')==2036 or date('Y')==2040)
						{$mEnd = 29;} 
				}
			else {$mEnd = 31;}

			$period_2 = str_pad($period, 2, "0", STR_PAD_LEFT);
			$start_date = date('Y').'-'.$period_2.'-01';
			$end_date = date('Y').'-'.$period_2.'-'.$mEnd;
		}

		$this->db->from('BMK');
		$this->db->where('level < '.$level);
		$this->db->where('deleted',0);
		
		if($item_number)
		  {
			 if($type)
			 {
				$this->db->where('item_number',$item_number);
				$this->db->where('type',$type);
				$this->db->limit($limit);
				$this->db->order_by('item_number, type, MK');
			 }
			 else
			 {
				$this->db->where('item_number',$item_number);
				$this->db->limit($limit);
				$this->db->order_by('item_number, type, MK');			 
			 }
			 
		  }
		elseif($period!=0 and $mEnd!=0)
		  {
			 $this->db->where('start_date BETWEEN "'.$start_date. '" and "'.$end_date.'"');
			 $this->db->order_by('item_number', "acs");
		  }
		else // вади последните 100 БМК-та
		  {
			 $this->db->limit($limit);
			 $this->db->order_by('bmk_id', "desc");
		  }

	return $this->db->get()->result_array();
	}

	function get_made_bmk($item_number,$period)
	{  
		$level = 9;
		$mEnd  = 0;
		
		if($period)
		{
			$mEnd = 31;
			if($period==4 or $period==6 or $period==9 or $period==11) {$mEnd = 30;}
			elseif($period==2) 
				{  $mEnd = 28;
					if(date('Y')==2020 or date('Y')==2024 or date('Y')==2028 or date('Y')==2032 or date('Y')==2036 or date('Y')==2040)
						{$mEnd = 29;} 
				}
			else {$mEnd = 31;}

			$period_2 = str_pad($period, 2, "0", STR_PAD_LEFT);
			$start_date = date('Y').'-'.$period_2.'-01';
			$end_date = date('Y').'-'.$period_2.'-'.$mEnd;
		}

		$this->db->from('BMK');
		$this->db->where('level',9);
		$this->db->where('deleted',0);
		
		if($item_number)
		  {
				$this->db->where('item_number',$item_number);
				$this->db->order_by('item_number');
		  }
		  
		if($period!=0 and $mEnd!=0)
		  {
			 $this->db->where('start_date BETWEEN "'.$start_date. '" and "'.$end_date.'"');
			 $this->db->order_by('item_number', "acs");
		  }
		else // вади последните 100 БМК-та
		  { $this->db->order_by('bmk_id', "desc"); }

	return $this->db->get()->result_array();
	}	
	
	
	function get_min_bmk_id()
	{
		$this->db->select('min(bmk_id) as min_bmk', false);
		$this->db->from('BMK');
		$this->db->where('level', 0);
		$this->db->where('deleted', 0);
		$rezult = $this->db->get()->result_array();
		$min_value = $rezult['0']['min_bmk'];
	return $min_value;
	}
	

	function get_max_bmk_id()
	{
		$this->db->select('max(bmk_id) as max_bmk', false);
		$this->db->from('BMK');
		$this->db->where('deleted',0);
		$rezult = $this->db->get()->result_array();
		$max_value = 1 + $rezult['0']['max_bmk'];
		if($max_value=='1' or $max_value=='10000')
			{ $max_value=false; }
	return $max_value;
	}

	function get_free_bmk_id()
	{
      $bmk_id=1001;
      while($bmk_id < 10000)
      {
         if($this->exists_bmk($bmk_id))
         {
            $bmk_info = $this->get_bmk_info($bmk_id);
            $level = $bmk_info->level;
            $limit_Y = 0;
            $end_date = $bmk_info->end_date;
            if($end_date!=0 and $end_date!=null)
               {$limit_Y=date('Y',strtotime($end_date));}
            if($limit_Y<date('Y') and $level==9) // delete
               {
                  $this->db->trans_start();
                    $this->db->delete( 'BMK', array('bmk_id'=>$bmk_id)); 
                  $this->db->trans_complete();
                  break;
               }
         }
         else {break;}
      $bmk_id++;
      } // while < 10000
      
	return $bmk_id;
	}	
	
	function get_item_max_bmk($item_number)
	{
		$this->db->select('start_date, max(MK) as item_max_mk', false);
		$this->db->from('BMK');
		$this->db->where('item_number',$item_number);
		$this->db->where('deleted',0);
	return $this->db->get()->result_array();
	}	
	
	function save_bmk(&$bmk_data,$bmk_id=false)
	{
		if (!$bmk_id or !$this->exists_bmk($bmk_id))
		{
			if($this->db->insert('BMK',$bmk_data))
			{
				$bmk_data['bmk_id']=$this->db->insert_id();
				return true;
			}
		return false;
		}
		$this->db->where('bmk_id', $bmk_id);
	return $this->db->update('BMK',$bmk_data);
	}
	
	function update_bmk($bmk_data,$bmk_id=0)
	{
		if (!$bmk_id or !$this->exists_bmk($bmk_id))
			{ return false; }

		$this->db->trans_start();	
			$this->db->where('bmk_id', $bmk_id);
			$success = $this->db->update('BMK',$bmk_data);
		$this->db->trans_complete();
		if ($this->db->trans_status() === FALSE)	
			{ return false; }
	return $success;
	}
	

	function find_uncompleted_bmk($limit)
	{
		$uncompleted = array();
		$all_bmk = $this->get_all_bmk(0,0,$limit);
		if(count($all_bmk)>0)
		{
		  foreach ($all_bmk as $tech_array)
			 {
				$item_number = $tech_array['item_number'];
				$type = $tech_array['type'];			
				$check = $this->Techno->uncompleted_techno($item_number,$type);
				if(!$check) { $uncompleted[] = $tech_array;} // натрупва грешните БМК-та ...
			 }
		}
	return $uncompleted;
	}

/* ========================== OTKK ===================== */
	function exists_otkk_id($date,$otkk_id)
	{
		$vedom = "OTKK_".date('Y',strtotime($date));
		$this->db->from($vedom);
		$this->db->where('date',$date);
		$this->db->where('otkk_id',$otkk_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function exists_otkk($date,$inum)
	{
		$vedom = "OTKK_".date('Y',strtotime($date));
		$this->db->from($vedom);
		$this->db->where('date',$date);
		$this->db->where('inum',$inum);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function get_otkk_id($date,$otkk_id)
	{
		if($date===0) { $date = "OTKK_".date('Y-m-d'); }
		$vedom = "OTKK_".date('Y',strtotime($date));
		$this->db->from($vedom);
		$this->db->where('otkk_id',$otkk_id);
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{return $query->row();}
		else 
			{return 0;}
	}
	
	function get_otkk($date)
	{
		if($date===0) { $date = "OTKK_".date('Y',strtotime( $this->BiSOFT_Model->get_user_mode_date())); }
		$vedom = "OTKK_".date('Y',strtotime($date));
		$this->db->from($vedom);
		$this->db->where('date',$date);
		$query = $this->db->get();
		if ($query->num_rows()>0)
			{return $query->result_array();}
		else 
			{return 0;}
	}
	
	function get_otkk_item($date,$inum)
	{
		if($date===0) { $date = date('Y-m-d'); }
		$vedom = "OTKK_".date('Y',strtotime($date));
		$this->db->from($vedom);
		$this->db->where('date',$date);
		$this->db->where('inum',$inum);
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{return $query->row();}
		else 
			{return 0;}
	}
	
	function get_otkk_period($date,$key)
	{
		if($date===0) { $date = "OTKK_".date('Y',strtotime( $this->BiSOFT_Model->get_user_mode_date())); }
		$vedom = "OTKK_".date('Y',strtotime($date));
		
		$this->db->select('	
				otkk_id, 
				date,
				inum,
				sum(qty) 	as qty, 
				sum(q1)		as q1,
				sum(q2)		as q2,
				sum(q3)		as q3,
				sum(q4)		as q4,
				sum(q5)		as q5,
				sum(q6)		as q6,
				sum(q7)		as q7,
				sum(q8)		as q8,
				sum(q9)		as q9,
				sum(q10)		as q10,
				del',	false);
		$this->db->from($vedom);
		
		if($key==7) // този месец
		{
			$from_date = date('Y-m-01',strtotime($date));
			$this->db->where('date BETWEEN "'.$from_date. '" and "'.$date.'"');
		}
		elseif($key==8) // предния месец
		{
			$last_m = date('m',strtotime($date))-1;
			if(!$last_m) {$last_m=1;}
			
				$last_mday = 31;
				if((int)$last_m==4 or (int)$last_m==6 or (int)$last_m==9 or (int)$last_m==11)
				{ $last_mday = 30; }
				elseif((int)$last_m==2)
				{ $last_mday = 28;
				  $now_year = date('Y');
					if($now_year==2020 or $now_year==2024 or $now_year==2028 or $now_year==2032 or $now_year==2036 or
					   $now_year==2040 or $now_year==2044 or $now_year==2048 or $now_year==2052 or $now_year==2056 or $now_year=2060)
					  { $last_mday = 29; }
				}

			$from_date = date("Y-$last_m-01",strtotime($date));
			$to_date = date("Y-$last_m-$last_mday",strtotime($date));;
			$this->db->where('date BETWEEN "'.$from_date. '" and "'.$to_date.'"');
		}
		elseif($key==9) // тази година
		{
			$from_date = date('Y-01-01',strtotime($date));
			$this->db->where('date BETWEEN "'.$from_date. '" and "'.$date.'"');
		}
		
		$this->db->group_by('inum');
		$this->db->order_by('inum', 'asc');
		
		$query = $this->db->get();
		if ($query->num_rows()>0)
			{return $query->result_array();}
		else 
			{return 0;}
	}

	function save_otkk(&$otkk_data,$otkk_id)
	{
		$date = $otkk_data['date'];
		if($date) { $vedom = "OTKK_".date('Y',strtotime($date)); }
		else { $date = date('Y-m-d');$vedom = "OTKK_".date('Y',strtotime($date)); }

		if (!$otkk_id or !$this->exists_otkk_id($date,$otkk_id))
		{
			if($this->db->insert($vedom,$otkk_data))
			{
				$otkk_data['otkk_id']=$this->db->insert_id();
				return true;
			}
		return false;
		}
		$this->db->where('otkk_id', $otkk_id);
	return $this->db->update($vedom,$otkk_data);
	}
	
	function update_otkk($otkk_data,$otkk_id)
	{
		$date = $otkk_data['date'];
		if($date) { $vedom = "OTKK_".date('Y',strtotime($date)); }
		if (!$otkk_id or !$this->exists_otkk_id($date,$otkk_id))
			{ return false; }

		$this->db->trans_start();	
			$this->db->where('otkk_id', $otkk_id);
			$success = $this->db->update($vedom,$otkk_data);
		$this->db->trans_complete();
		if ($this->db->trans_status() === FALSE)	
			{ return false; }
	return $success;
	}

/* ========================== END OTKK ===================== */

	
/* ========================== БАЗА МИНУТНИ РАЦЕНКИ ===================== */
	public function get_all_tech_HB()
	{  
		$this->db->select('
					job_id,
					job_name, 
					job_min,
					salary',	false);

		$this->db->from('tech_HB');
		$this->db->where('job_id > 10000');
		$this->db->where('deleted',0);
		$this->db->order_by('job_id');
	return $this->db->get()->result_array();
	}

	public function get_tech_HB($job_id=0)
	{  
		$this->db->from('tech_HB');
		$this->db->where('job_id',$job_id);
		$query = $this->db->get();
	if($query->num_rows()==1) 
		{return $query->row();}
	else 
		{return false;}
	}

	function update_tech_HB($job_data, $job_id=0)
	{  
		$this->db->where('job_id', $job_id);
		$this->db->where('deleted',0);
		$success = $this->db->update( 'tech_HB', $job_data );
	return $success;
	}

	function delete_tech_HB($job_id)
	{
		$this->db->trans_start();
		$this->db->delete('tech_HB', array('job_id' => $job_id ) );
		$this->db->trans_complete();
	return $this->db->trans_status();
	}


/* ============================= Category ============================ */
	public function get_all_category()
	{  
		$this->db->select('job_id,
                         job_name',	false);

		$this->db->from('tech_HB');
		$this->db->where('job_id < 100');
		$this->db->where('deleted',0);
		$this->db->order_by('job_id');
	return $this->db->get();
	}

// ==================== КРАЙ БАЗА МИНУТНИ РАЦЕНКИ ===================== //



// =============================== ПУСКАЧ ============================= //
	function get_plan_item($inum,$coll)
	{  
		$this->db->from('items_plan');
		$this->db->where('inum',$inum);
		$this->db->where('coll',$coll);
		$query = $this->db->get();
	if($query->num_rows()==1) 
		{return $query->row();}
	else 
		{return 0;}
	}


	function update_plan_item($plan_data,$plan_id,$vedom)
	{  
		$this->db->where('plan_id',$plan_id);
		$success = $this->db->update( $vedom, $plan_data );
	return $success;
	}

// ========================== БАЗА ТЕХН.ОПЕРАЦИИ ===================== //
	public function get_all_tech_DB($db_cat,$techno=0)
	{  
		$this->db->select('
					tech_id,
					tech_old,
					tech_name,
					pm,
					job_id,
					HB_0,
					HB_1,
					HB_2,
					HB_3,
					HB_4,
					HB_5,
					HB_6,
					HB_7,
					HB_8,
					HB_9,
					doc_id',	false);

		$this->db->from('tech_DB');

		if(!$techno)
		{
		  switch ($db_cat) 
		  {
		  case '1': // 3000-3500 пластрон,илик
				  $this->db->where('tech_id > 3000 and tech_id < 3501'); 
				  break;

		  case '2': // 3501-4000 яки,джоб,рамо
				  $this->db->where('tech_id > 3500 and tech_id < 4001'); 
				  break;

		  case '3': // 4001-4500 лицеви,странични
				  $this->db->where('tech_id > 4000 and tech_id < 4501'); 
				  break;

		  case '4': // 4501-5000 снадки,мостри
				  $this->db->where('tech_id > 4500 and tech_id < 5001'); 
				  break;

		  case '5': // 5001-5500 подгъви,ципове,цепки
				  $this->db->where('tech_id > 5000 and tech_id < 5501'); 
				  break;

		  case '6': // 5501-6000 ленти,акценти
				  $this->db->where('tech_id > 5500 and tech_id < 6001'); 
				  break;

		  case '7': // 6001-6500 вратовръзки,шалове
				  $this->db->where('tech_id > 6000 and tech_id < 6501'); 
				  break;

		  case '8': // 6501-7000 елеци,престилки
				  $this->db->where('tech_id > 6500 and tech_id < 7001'); 
				  break;

		  case '9': // 7001-9000 други
				  $this->db->where('tech_id > 7000 and tech_id < 9001'); 
				  break;

		  default: $this->db->where('tech_id',0);
		  } // End of Switch.
		}
		else // търси индивидуална Техн.манипулация $techno
		{ $this->db->where('tech_id',$techno);}

		$this->db->where('deleted',0);
		$this->db->order_by('tech_id');
	return $this->db->get()->result_array();
	}

	public function get_tech_DB($tech_id=0)
	{  
		$this->db->from('tech_DB');
		$this->db->where('tech_id',$tech_id);
		$query = $this->db->get();
	if($query->num_rows()==1) 
		{return $query->row();}
	else 
		{return false;}
	}

	public function exists_tech_DB($tech_id=0)
	{  
		$this->db->from('tech_DB');
		$this->db->where('tech_id',$tech_id);
		$query = $this->db->get();
	if($query->num_rows()==1) 
		{return 1;}
	else 
		{return 0;}
	}	
	
	function update_tech_DB($tech_data, $tech_id=0)
	{ 
		$this->db->where('tech_id', $tech_id);
		$this->db->where('deleted',0);
		$success = $this->db->update( 'tech_DB', $tech_data );
	return $success;
	}

	function delete_tech_DB($tech_id)
	{
		$this->db->trans_start();
		$this->db->delete('tech_DB', array('tech_id' => $tech_id ) );
		$this->db->trans_complete();
	return $this->db->trans_status();
	}

	/* Get search suggestions to find techno manipulations */
	function get_techno_search_suggestions($search,$limit=10)
	{
		$suggestions = array();

		$this->db->from('tech_DB');
		$this->db->where('deleted', 0);
		$this->db->like("tech_id",$search);
		$this->db->order_by("tech_id", "asc");		
		$by_tech_id = $this->db->get();
		
		foreach($by_tech_id->result() as $row)
		{
			$suggestions[]=$row->tech_id.'|'.'<b style="color:#22a;">'.$row->tech_id.'</b> - '.$row->tech_name;
		}
		
		$this->db->from('tech_DB');
		$this->db->where('deleted', 0);
		$this->db->where("(tech_name LIKE '%".$this->db->escape_like_str($search)."%') and deleted=0");
		$this->db->order_by("tech_id", "asc");		
		$by_name = $this->db->get();

		foreach($by_name->result() as $row)
		{
			$suggestions[]=$row->tech_id.'|'.'<b style="color:#707;">'.$row->tech_id.'</b> - '.$row->tech_name;
		}
		
		//only return $limit suggestions
		if(count($suggestions > $limit))	{ $suggestions = array_slice($suggestions, 0,$limit);}

	return $suggestions;
	}
	
	
	
// ==================== КРАЙ БАЗА ТЕХН.ОПЕРАЦИИ ===================== //




// ================================= СТАРО =========================== //

	function update($doc_data, $doc_id, $vedomPack)
	{  
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update( $vedomPack, $doc_data );
	return $success;
	}

	function update_items($items_data, $doc_id, $vedomItems)
	{  
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update( $vedomItems, $items_data );
	return $success;
	}

	function update_line_item($items_data, $doc_id, $line, $vedomPack)
	{  
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
		$success = $this->db->update( $vedomPack.'_items', $items_data );
	return $success;
	}

	
	// --------------------------------- БЪРЗА РЕГИСТРАЦИЯ MK -------------------------------//
	function save_MK( $inum, $qty )
	{
		// определям къде се намират DB за пълнене - ГОДИНА ...
		$vedom = $this->BiSOFT_Model->get_vedom();
		$mode='manu';
		$mode_id='MK';

    	$db_ved = 'V'.date('ym', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$db_ved_items = $db_ved."_items";
		
		$doc_date 	= $this->BiSOFT_Model->get_user_mode_date();
		$doc_number = $this->BiSOFT_Model->get_document_number($mode);
		$doc_name	= $this->BiSOFT_Model->get_document_title($mode);
		
		$total = $cost = $all_qty = 0;
		$skl_info = $this->Item->get_sklad_info($inum,0);
		if($skl_info) 
			{
				$cost  = $skl_info->cost;
				$total = $qty * $cost;
				$all_qty = $qty + $skl_info->qty;
			}
		
		$employee_id = $this->Employee->get_logged_in_employee_info()->person_id;
		$employee_name	=	$this->Employee->get_id_names($employee_id);
		$comment = 'БМК: #'.$inum;
	
		// зареждам основните параметри на Главния документ ......
		$manu_data = array(
				'mode'				=> $mode,
				'mode_id'			=> $mode_id,
				'doc_number'		=> $doc_number,
				'doc_date' 			=> $doc_date,
				'total_qty'			=> $qty,
				'total_sum'			=> to_dot($total),
				'total_discount'	=> 0,
				'taxed'				=> 0,
				'pay_group'			=> '',
				'pay_type'			=> '',
				'pay_amount'		=> to_dot($total),
				'client_id'			=> 0,
				'client'				=> '',
				'supplier_id'		=> 0,
				'supplier'			=> '',
				'employee_id'		=> $employee_id,
				'employee'			=> $employee_name,
				'comment'			=> $comment,
				'location'			=> 0 );

//------------------------ записва в Базите Данни ---------------------- //
		$this->db->trans_start(); // --> отваря запис към БАЗАТА ...-->> 
			// вкарва данните на Главният Документ в База Данни 'V2004' //
			$this->db->insert( $db_ved, $manu_data );
			$doc_id = $this->db->insert_id();  // взимам си номер на документа
	
			$manu_items_data = array(
				'doc_id'			=> $doc_id,
				'line'			=> 1,
				'mode_id' 		=> $mode_id,
				'doc_number' 	=> $doc_number,
				'doc_date' 		=> $doc_date,
				'item_number'	=> $inum,
				'item_name'		=> "$qty,,,,,,,,,,",
				'item_qty'		=> $qty,
				'item_unit_price'	=> to_dot($cost),
				'item_discount'	=> 0,
				'item_taxes'	=> 0,
				'client_id'		=> 0,
				'supplier_id'	=> 0,
				'location'		=> 0 );

			$this->db->insert( $db_ved_items, $manu_items_data);
					
			if($skl_info) 
			{
				$item_data = array(
				  'inum' => $inum,
					'skl'	=> 0,	// само Склад-ГП '0'
					'qty'	=> $all_qty,
					'q1'	=> '','q2'=>'','q3'=>'','q4'=>'','q5'=>'','q6'=>'','q7'=>'','q8'=>'','q9'=>'','q10'=>'',
					'del' => 0 );
			
				$this->Item->save_sklad($item_data);
			}

		$this->db->trans_complete();
		
		if($this->db->trans_status() === FALSE)	
			{ return FALSE; }
		else
			{ return TRUE; }
	}

	
	
	
	
	
	// -------------------------------------- РЕГИСТРАЦИЯ ------------------------------------//
	function save( $items, $mode, $total_qty, $subtotal, $doc_number, $doc_name, 
			$bisoft_id, $supplier_discount, $employee_id, $payments, $comment)
	{
		 $doc_id = false;
		if(count($items)==0)
			{ return -1; }

		// определям къде се намират DB за пълнене - ГОДИНА ...
		$vedom = $this->BiSOFT_Model->get_vedom();

		// определям къде е location ...
		$location = 0;

		// определям имената на Базите Данни ...
    	$db_recvs 		 = 'V'.date('ym', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
		$db_recvs_items = $db_recvs . '_items';

			$db_delivers 			= 'delivers';
			$db_delivers_items 	= $db_delivers . '_items';

		//Зареждаме данни за Базата с Доставката ...
		$doc_date 	= $this->BiSOFT_Model->get_user_mode_date();
		$doc_name	= $this->BiSOFT_Model->get_document_title($mode);	 // заглавието
		$mode_id 	= $this->BiSOFT_Model->get_pay_group($mode);			 // index-a 'Е', 'P'

			//Изчисляване плащането и групата за плащане .. index-a
			$pay_group = '';
			$pay_type = '';
			$payment_types ='';
			$total_sum = $subtotal;

		// зареждаме имената на Клиента според режима 'mode' ......
		$client_name 		= '';
		$supplier_name 	= ''; $supplier_id = 0;

		if(empty($bisoft_id)) { $bisoft_id = $this->BiSOFT_Model->get_mode_location();}

		if ( $mode=='manu' or $mode=='stock' or $mode=='brak') 
			{ $bisoft_id = 0; $client_name = '';}

		elseif ( $mode=='balance' or $mode=='revision' ) 
			{ 	
				if( $location!=0 ) 
				{ 
					$client_name = $this->Consignee->get_info_by_bisoft_id($location)->company_name;
				}
			}

		elseif ( $mode=='shop_sgp' ) 
			{ 	$bisoft_id = $location; 
				$client_name = $this->Consignee->get_info_by_bisoft_id($bisoft_id)->company_name;
			}

		elseif ( $bisoft_id > 0 )
			{ 
					if ( $mode=='manu_db' or $mode=='recv_return')  // Доставчик САМО
						{ $client_name 	= $this->Supplier->get_info_by_bisoft_id($bisoft_id)->company_name; // това ще отпадне ...
						  $supplier_name	= $this->Supplier->get_info_by_bisoft_id($bisoft_id)->company_name;
						  $supplier_id		= $bisoft_id;
						  $this->BiSOFT_Model->supplier_rating($bisoft_id,$subtotal);
						}

					elseif ( $mode=='consi' or $mode=='consi_return')  // Магазин САМО
						{ $client_name = $this->Consignee->get_info_by_bisoft_id($bisoft_id)->company_name;}

			} // end elseif 'bisoft_id' > 0 ...


		// зареждаме имената на Оператора ......
		$employee_name	=	$this->Employee->get_info($employee_id)->first_name .' '. 
								$this->Employee->get_info($employee_id)->last_name;

		$total_discount = $supplier_discount;

		// върната стока и всички (-) като цяло ...
		if ( $mode=='consi_return' or $mode=='recv_return' or $mode=='shop_sgp' or $mode=='brak')
			{ 
				$total_qty = -abs($total_qty);
				$total_sum = -abs($total_sum);
				$subtotal  = -abs($subtotal);
				if($mode!='brak')	
					{ $pay_type = $this->lang->line('reports_returns');}
				else 
					{ $pay_type = $this->lang->line('reports_braked');}
			}

		// зареждам основните параметри на Главния документ ......
		$recvs_data = array(
				'mode'				=> $mode,
				'mode_id'			=> $mode_id,
				'doc_number'		=> $doc_number,
				'doc_date' 			=> $doc_date,
				'total_qty'			=> $total_qty,
				'total_sum'			=> $subtotal,
				'total_discount'	=> $total_discount,
				'taxed'				=> 0,
				'pay_group'			=> '',
				'pay_type'			=> $pay_type,
				'pay_amount'		=> $total_sum,
				'client_id'			=> $bisoft_id,
				'client'				=> $client_name,
				'supplier_id'		=> $supplier_id,
				'supplier'			=> $supplier_name,
				'employee_id'		=> $employee_id,
				'employee'			=> $employee_name,
				'comment'			=> $comment,
				'location'			=> $location_id );
		
		// само за ВЪРНАТА Склад-ГП от Магазина ?!
		$recvs_delivery = $recvs_data;
		if ( $mode=='shop_sgp' and $location != 0)
			{ $recvs_delivery['mode'] = 'consi_return';
			  $recvs_delivery['mode_id'] = 'BC';
			  $recvs_delivery['total_qty'] = abs($total_qty);
			  $recvs_delivery['total_sum'] = abs($subtotal);
			  $recvs_delivery['pay_amount'] = abs($total_sum);
			  $recvs_delivery['location'] = 0; }


		//------------------------ записва в Базите Данни ---------------------- //
		$this->db->trans_start(); // --> отваря запис към БАЗАТА ...-->> 

			// вкарва данните на Главният Документ в База Данни 'V1401' //
			$this->db->insert( $db_recvs, $recvs_data);
			$doc_id = $this->db->insert_id();  // взимам си номерчето на документа

			$delivery_id = 0;
			if ( $mode == 'shop_sgp' and $location != 0)
				{
					$this->db->insert( $db_delivers, $recvs_delivery);
					$delivery_id = $this->db->insert_id();  // взимам номер от буфера
				}

// =================== започва обработка на всички артикули от количката =================== //
	$this->load->library('production_lib');
	$mode_price = $this->production_lib->get_mode_price();

	foreach($items as $line=>$item)  // сканира количката за всеки един артикул ...
	{
			$cur_item_info = $this->Item->get_info($item['item_id']);  // зарежда от НУЖНАТА База //

			// оправям ЦЕНИТЕ ...
			$item_price = $item['price'];
				if ($mode_price==1) { $item_price = $cur_item_info->unit_price;}
				if ($mode_price==2) { $item_price = $cur_item_info->unit_price_2;}
				if ($mode_price==3) { $item_price = $cur_item_info->unit_price_3;}
				if ($mode_price==4) { $item_price = $cur_item_info->unit_price_4;}
				if ($mode_price==5) { $item_price = $cur_item_info->unit_price_5;}

			$modeK = 1;
			// обслужвам си '0'-те и (-) ...
			if ( $mode=='consi_return' or $mode=='recv_return' or $mode=='shop_sgp' or $mode=='brak') 
			{ 
				$modeK = -1;
				$quantity = $modeK * abs($item['quantity']);
				$qty_1 = $modeK * abs($item['qty_1']); if($qty_1==0) { $qty_1='';}
				$qty_2 = $modeK * abs($item['qty_2']); if($qty_2==0) { $qty_2='';}
				$qty_3 = $modeK * abs($item['qty_3']); if($qty_3==0) { $qty_3='';}
				$qty_4 = $modeK * abs($item['qty_4']); if($qty_4==0) { $qty_4='';}
				$qty_5 = $modeK * abs($item['qty_5']); if($qty_5==0) { $qty_5='';}
				$qty_6 = $modeK * abs($item['qty_6']); if($qty_6==0) { $qty_6='';}
				$qty_7 = $modeK * abs($item['qty_7']); if($qty_7==0) { $qty_7='';}
				$qty_8 = $modeK * abs($item['qty_8']); if($qty_8==0) { $qty_8='';}
				$qty_9 = $modeK * abs($item['qty_9']); if($qty_9==0) { $qty_9='';}
				$qty_max = $modeK * abs($item['qty_max']); if($qty_max==0) { $qty_max='';}
			}
			elseif ($mode=='balance' or $mode=='revision')
			{
				$quantity = $item['quantity'];
				$qty_1 = $item['qty_1']; if($qty_1==0) { $qty_1='';}
				$qty_2 = $item['qty_2']; if($qty_2==0) { $qty_2='';}
				$qty_3 = $item['qty_3']; if($qty_3==0) { $qty_3='';}
				$qty_4 = $item['qty_4']; if($qty_4==0) { $qty_4='';}
				$qty_5 = $item['qty_5']; if($qty_5==0) { $qty_5='';}
				$qty_6 = $item['qty_6']; if($qty_6==0) { $qty_6='';}
				$qty_7 = $item['qty_7']; if($qty_7==0) { $qty_7='';}
				$qty_8 = $item['qty_8']; if($qty_8==0) { $qty_8='';}
				$qty_9 = $item['qty_9']; if($qty_9==0) { $qty_9='';}
				$qty_max = $item['qty_max']; if($qty_max==0) { $qty_max='';}
			}
			else
			{
				$quantity = abs($item['quantity']);
				$qty_1 = $modeK * abs($item['qty_1']); if($qty_1==0) { $qty_1='';}
				$qty_2 = $modeK * abs($item['qty_2']); if($qty_2==0) { $qty_2='';}
				$qty_3 = $modeK * abs($item['qty_3']); if($qty_3==0) { $qty_3='';}
				$qty_4 = $modeK * abs($item['qty_4']); if($qty_4==0) { $qty_4='';}
				$qty_5 = $modeK * abs($item['qty_5']); if($qty_5==0) { $qty_5='';}
				$qty_6 = $modeK * abs($item['qty_6']); if($qty_6==0) { $qty_6='';}
				$qty_7 = $modeK * abs($item['qty_7']); if($qty_7==0) { $qty_7='';}
				$qty_8 = $modeK * abs($item['qty_8']); if($qty_8==0) { $qty_8='';}
				$qty_9 = $modeK * abs($item['qty_9']); if($qty_9==0) { $qty_9='';}
				$qty_max = $modeK * abs($item['qty_max']); if($qty_max==0) { $qty_max='';}
			}

			$recvs_items_data = array(
				'doc_id'			=> $doc_id,
				'line'			=> $item['line'],
				'mode_id' 		=> $mode_id,
				'doc_number' 	=> $doc_number,
				'doc_date' 		=> $doc_date,
				'item_number'	=> $item['item_number'],
				'item_name'		=> $item['name'],

				'item_qty'		=> $quantity,
			'item_unit_price'	=> abs($item_price),
			'item_discount'	=> $item['item_discount'],
				'item_taxes'	=> 0,
				'client_id'		=> $bisoft_id,
				'client'			=> $client_name,
				'supplier_id'	=> $supplier_id,
				'supplier'		=> $supplier_name,
				'location'		=> $location_id );

		// ЗАПИС в _items База за всички документи.
		$this->db->insert( $db_recvs_items, $recvs_items_data);

		// само ВЪРНАТА Склад-ГП
		$recvs_items_delivers = array();
		if ( $mode=='shop_sgp' and $location  != 0)
			{
				$recvs_items_delivers = array(
					'doc_id'			=> $delivery_id,
					'item_id'		=> 0,
					'line'			=> $item['line'],
					'mode_id' 		=> 'BC',
					'doc_number' 	=> $doc_number,
					'doc_date' 		=> $doc_date,
					'item_number'	=> $item['item_number'],
					'item_name'		=> $item['name'],
					'item_qty'		=> abs($quantity),
				'item_unit_price'	=> abs($item['price']),
				'item_discount'	=> abs($item['item_discount']),
					'item_taxes'	=> 0,
					'client_id'		=> $bisoft_id,
					'location'		=> $location );

			// ЗАПИС на items в База 'DELIVERS' за върната стока.
			$this->db->insert( $db_delivers_items, $recvs_items_delivers);
			}


		if ( $mode=='consi' )
		{	// Начисляване в База Данни -'shops'

			//make sure item exists in the local items 'Shops' ?
			if (!$this->Item->exists_in_shop( $item['item_number'], $bisoft_id) and $location == 0) // и сме в СГП
				{
					$shops_data = array(
							'item_number'		=> $item['item_number'],   // от количката
							'name'				=> $item['name'],				// от количката
							'allow_sizes'		=> $cur_item_info->allow_sizes,

								'quantity'		=> $quantity,

							'unit_price'		=> round( $item_price * (100 - $item['item_discount']) / 100 , 2 ),
							'item_currency'	=> $cur_item_info->item_currency,
							'description'		=> $cur_item_info->description,
							'category'			=> $cur_item_info->category,
							'collection'		=> $cur_item_info->collection,
							'item_contents'	=> $cur_item_info->item_contents,

							'location' 			=> $bisoft_id );

					// записва в БАЗАТА на Магазина -->>
					if ( $this->db->insert('shops', $shops_data) ) { $shops_data['item_id']=$this->db->insert_id();} 
					else { echo 'ERROR SHOP-DB'.$bisoft_id; die();} // има някаква грешка
				} // край на 'ако го няма в склада' ...
			else
				{
					$shops_item_id = $this->Item->get_item_id_shop($item['item_number'],$bisoft_id);
					$old_shops_data = $this->Item->get_info_from_shop($shops_item_id);

				// обслужвам си '0'-те и (-) в Склада на Магазина ...
				$shop_qty_1 = $old_shops_data->qty_1 + $qty_1; if($shop_qty_1==0) { $shop_qty_1='';}
				$shop_qty_2 = $old_shops_data->qty_2 + $qty_2; if($shop_qty_2==0) { $shop_qty_2='';}
				$shop_qty_3 = $old_shops_data->qty_3 + $qty_3; if($shop_qty_3==0) { $shop_qty_3='';}
				$shop_qty_4 = $old_shops_data->qty_4 + $qty_4; if($shop_qty_4==0) { $shop_qty_4='';}
				$shop_qty_5 = $old_shops_data->qty_5 + $qty_5; if($shop_qty_5==0) { $shop_qty_5='';}
				$shop_qty_6 = $old_shops_data->qty_6 + $qty_6; if($shop_qty_6==0) { $shop_qty_6='';}
				$shop_qty_7 = $old_shops_data->qty_7 + $qty_7; if($shop_qty_7==0) { $shop_qty_7='';}
				$shop_qty_8 = $old_shops_data->qty_8 + $qty_8; if($shop_qty_8==0) { $shop_qty_8='';}
				$shop_qty_9 = $old_shops_data->qty_9 + $qty_9; if($shop_qty_9==0) { $shop_qty_9='';}
				$shop_qty_max = $old_shops_data->qty_max + $qty_max; if($shop_qty_max==0) { $shop_qty_max='';}

					$shops_data = array(
							'item_number'		=> $item['item_number'],   // от количката
							'name'				=> $item['name'],				// от количката
							'allow_sizes'		=> $cur_item_info->allow_sizes,
								'quantity'		=> $old_shops_data->quantity + $quantity,
							'unit_price'		=> round( $item_price * (100 - $item['item_discount']) / 100 , 2 ),
							'item_currency'	=> $cur_item_info->item_currency,
							'description'		=> $cur_item_info->description,
							'category'			=> $cur_item_info->category,
							'collection'		=> $cur_item_info->collection,
							'item_contents'	=> $cur_item_info->item_contents,
							'location' 			=> $bisoft_id );

					// актуализира БАЗАТА на Магазина <<-->> //
					$this->db->where('item_id', $shops_item_id);
					$this->db->where('location', $bisoft_id);
					$this->db->update('shops', $shops_data);
				}

		} // край на 'consi'

		elseif ( $mode=='consi_return' )
		{	// Отчисляване от База Данни - 'shops'

			//make sure item exists in the local items 'Shops' ?
			if ($this->Item->exists_in_shop( $item['item_number'], $bisoft_id) and $location == 0) // и сме в СГП
				{
					$shops_item_id = $this->Item->get_item_id_shop($item['item_number'],$bisoft_id);
					$old_shops_data = $this->Item->get_info_from_shop($shops_item_id);

					// обслужвам си '0'-те и (-) в Склада на Магазина ...
					$shop_qty_1 = $old_shops_data->qty_1 - abs($qty_1); if($shop_qty_1==0) { $shop_qty_1='';}
					$shop_qty_2 = $old_shops_data->qty_2 - abs($qty_2); if($shop_qty_2==0) { $shop_qty_2='';}
					$shop_qty_3 = $old_shops_data->qty_3 - abs($qty_3); if($shop_qty_3==0) { $shop_qty_3='';}
					$shop_qty_4 = $old_shops_data->qty_4 - abs($qty_4); if($shop_qty_4==0) { $shop_qty_4='';}
					$shop_qty_5 = $old_shops_data->qty_5 - abs($qty_5); if($shop_qty_5==0) { $shop_qty_5='';}
					$shop_qty_6 = $old_shops_data->qty_6 - abs($qty_6); if($shop_qty_6==0) { $shop_qty_6='';}
					$shop_qty_7 = $old_shops_data->qty_7 - abs($qty_7); if($shop_qty_7==0) { $shop_qty_7='';}
					$shop_qty_8 = $old_shops_data->qty_8 - abs($qty_8); if($shop_qty_8==0) { $shop_qty_8='';}
					$shop_qty_9 = $old_shops_data->qty_9 - abs($qty_9); if($shop_qty_9==0) { $shop_qty_9='';}
					$shop_qty_max = $old_shops_data->qty_max - abs($qty_max); if($shop_qty_max==0) { $shop_qty_max='';}

					$shops_data = array(
								'quantity'		=> $old_shops_data->quantity - abs($quantity),
								'qty_1'			=> $shop_qty_1,
								'qty_2'			=> $shop_qty_2,
								'qty_3'			=> $shop_qty_3,
								'qty_4'			=> $shop_qty_4,
								'qty_5'			=> $shop_qty_5,
								'qty_6'			=> $shop_qty_6,
								'qty_7'			=> $shop_qty_7,
								'qty_8'			=> $shop_qty_8,
								'qty_9'			=> $shop_qty_9,
								'qty_max'		=> $shop_qty_max,
							'location' 			=> $bisoft_id );

					// актуализира БАЗАТА на Магазина <<-->> //
					$this->db->where('item_id', $shops_item_id);
					$this->db->where('location', $bisoft_id);
					$this->db->update('shops', $shops_data);
				} // край на актуализацията на Магазина.
			else
				{
			//		echo 'DB ERROR ?!?!? < ITEM DOES NOT EXISTS > in SHOP: # ' .$bisoft_id; die();
				}

		} // край на 'consi_return'

			// обслужвам ПРИБАВЯНЕТО към СКЛАДА и '0'-те ... за всички останали доставки
			if ( $mode=='consi' or $mode=='recv_return' or $mode=='brak') 
			{ 
				$modeK = -1;
				$newAllQty = $cur_item_info->quantity + $modeK*abs($item['quantity']);
				$newQty_1 = $cur_item_info->qty_1 + $modeK*abs($item['qty_1']); if($newQty_1 ==0) {$newQty_1 = '';}
				$newQty_2 = $cur_item_info->qty_2 + $modeK*abs($item['qty_2']); if($newQty_2 ==0) {$newQty_2 = '';}
				$newQty_3 = $cur_item_info->qty_3 + $modeK*abs($item['qty_3']); if($newQty_3 ==0) {$newQty_3 = '';}
				$newQty_4 = $cur_item_info->qty_4 + $modeK*abs($item['qty_4']); if($newQty_4 ==0) {$newQty_4 = '';}
				$newQty_5 = $cur_item_info->qty_5 + $modeK*abs($item['qty_5']); if($newQty_5 ==0) {$newQty_5 = '';}
				$newQty_6 = $cur_item_info->qty_6 + $modeK*abs($item['qty_6']); if($newQty_6 ==0) {$newQty_6 = '';}
				$newQty_7 = $cur_item_info->qty_7 + $modeK*abs($item['qty_7']); if($newQty_7 ==0) {$newQty_7 = '';}
				$newQty_8 = $cur_item_info->qty_8 + $modeK*abs($item['qty_8']); if($newQty_8 ==0) {$newQty_8 = '';}
				$newQty_9 = $cur_item_info->qty_9 + $modeK*abs($item['qty_9']); if($newQty_9 ==0) {$newQty_9 = '';}
				$newQty_max = $cur_item_info->qty_max + $modeK*abs($item['qty_max']); 
					if($newQty_max ==0) {$newQty_max = '';}
			}
			elseif ($mode=='balance' or $mode=='revision')
			{
				$newAllQty = $cur_item_info->quantity + $item['quantity'];
				$newQty_1 = $cur_item_info->qty_1 + $item['qty_1']; if($newQty_1 ==0) {$newQty_1 = '';}
				$newQty_2 = $cur_item_info->qty_2 + $item['qty_2']; if($newQty_2 ==0) {$newQty_2 = '';}
				$newQty_3 = $cur_item_info->qty_3 + $item['qty_3']; if($newQty_3 ==0) {$newQty_3 = '';}
				$newQty_4 = $cur_item_info->qty_4 + $item['qty_4']; if($newQty_4 ==0) {$newQty_4 = '';}
				$newQty_5 = $cur_item_info->qty_5 + $item['qty_5']; if($newQty_5 ==0) {$newQty_5 = '';}
				$newQty_6 = $cur_item_info->qty_6 + $item['qty_6']; if($newQty_6 ==0) {$newQty_6 = '';}
				$newQty_7 = $cur_item_info->qty_7 + $item['qty_7']; if($newQty_7 ==0) {$newQty_7 = '';}
				$newQty_8 = $cur_item_info->qty_8 + $item['qty_8']; if($newQty_8 ==0) {$newQty_8 = '';}
				$newQty_9 = $cur_item_info->qty_9 + $item['qty_9']; if($newQty_9 ==0) {$newQty_9 = '';}
				$newQty_max = $cur_item_info->qty_max + $item['qty_max']; 
					if($newQty_max ==0) {$newQty_max = '';}
			}
			else
			{
				$newAllQty = $cur_item_info->quantity + abs($item['quantity']);
				$newQty_1 = $cur_item_info->qty_1 + abs($item['qty_1']); if($newQty_1 ==0) {$newQty_1 = '';}
				$newQty_2 = $cur_item_info->qty_2 + abs($item['qty_2']); if($newQty_2 ==0) {$newQty_2 = '';}
				$newQty_3 = $cur_item_info->qty_3 + abs($item['qty_3']); if($newQty_3 ==0) {$newQty_3 = '';}
				$newQty_4 = $cur_item_info->qty_4 + abs($item['qty_4']); if($newQty_4 ==0) {$newQty_4 = '';}
				$newQty_5 = $cur_item_info->qty_5 + abs($item['qty_5']); if($newQty_5 ==0) {$newQty_5 = '';}
				$newQty_6 = $cur_item_info->qty_6 + abs($item['qty_6']); if($newQty_6 ==0) {$newQty_6 = '';}
				$newQty_7 = $cur_item_info->qty_7 + abs($item['qty_7']); if($newQty_7 ==0) {$newQty_7 = '';}
				$newQty_8 = $cur_item_info->qty_8 + abs($item['qty_8']); if($newQty_8 ==0) {$newQty_8 = '';}
				$newQty_9 = $cur_item_info->qty_9 + abs($item['qty_9']); if($newQty_9 ==0) {$newQty_9 = '';}
				$newQty_max = $cur_item_info->qty_max + abs($item['qty_max']); 
					if($newQty_max ==0) {$newQty_max = '';}
			}


			//Update  Stock Quantity - за всички режими ...
			$item_data = array(
				'quantity'	=> $newAllQty,
				'qty_1'		=> $newQty_1,
				'qty_2'		=> $newQty_2,
				'qty_3'		=> $newQty_3,
				'qty_4'		=> $newQty_4,
				'qty_5'		=> $newQty_5,
				'qty_6'		=> $newQty_6,
				'qty_7'		=> $newQty_7,
				'qty_8'		=> $newQty_8,
				'qty_9'		=> $newQty_9,
				'qty_max'	=> $newQty_max,
				'location'	=> $location );

			//--------------- записва в База 'items' Склад-ГП ---------------- //
			if ( $mode != 'shop_sgp' and $mode != 'stock' and $mode !='protocol') 
				{ $this->Item->save( $item_data, $item['item_id']);}


// -------------------------------------- Update ORDERS --------------------------------------- // 
				// зареждам от БД данни
					$collection_id = $cur_item_info->collection;
					$item_number 	= $item['item_number'];
					if ($item_plan_info = $this->Order->get_item_plan_by_collection($item_number,$collection_id))
							{ $plan_Key = true;}
					else  { $plan_Key = false;} // $cur_item_info->item_number

			// всички произведени ...
			if ( $mode == 'manu' and $collection_id!='')
				{
               if ($plan_Key)
                  {
                     $i_qty_1 = $item_plan_info->i_qty_1 + $qty_1; if(!$i_qty_1) {$i_qty_1='';}		
                     $i_qty_2 = $item_plan_info->i_qty_2 + $qty_2; if(!$i_qty_2) {$i_qty_2='';}
                     $i_qty_3 = $item_plan_info->i_qty_3 + $qty_3; if(!$i_qty_3) {$i_qty_3='';}
                     $i_qty_4 = $item_plan_info->i_qty_4 + $qty_4; if(!$i_qty_4) {$i_qty_4='';}
                     $i_qty_5 = $item_plan_info->i_qty_5 + $qty_5; if(!$i_qty_5) {$i_qty_5='';}
                     $i_qty_6 = $item_plan_info->i_qty_6 + $qty_6; if(!$i_qty_6) {$i_qty_6='';}
                     $i_qty_7 = $item_plan_info->i_qty_7 + $qty_7; if(!$i_qty_7) {$i_qty_7='';}
                     $i_qty_8 = $item_plan_info->i_qty_8 + $qty_8; if(!$i_qty_8) {$i_qty_8='';}
                     $i_qty_9 = $item_plan_info->i_qty_9 + $qty_9; if(!$i_qty_9) {$i_qty_9='';}
                     $i_qty_max = $item_plan_info->i_qty_max + $qty_max; if(!$i_qty_max) {$i_qty_max='';}
                  }
               else
                  { $i_qty_1 = $i_qty_2 = $i_qty_3 = $i_qty_4 = $i_qty_5 = $i_qty_6 = $i_qty_7 = $i_qty_8 = $i_qty_9 = $i_qty_max = '';}
			
               $all_i_qty = $i_qty_1 + $i_qty_2 + $i_qty_3 + $i_qty_4 + $i_qty_5 + $i_qty_6 + $i_qty_7 + $i_qty_8 + $i_qty_9 + $i_qty_max;

               $item_data = array(
						'item_number' 		=> $item_number,
						'collection_id' 	=> $collection_id,

						'item_iqty' 		=> $all_i_qty,
						'i_qty_1' 			=> $i_qty_1,
						'i_qty_2' 			=> $i_qty_2,
						'i_qty_3' 			=> $i_qty_3,
						'i_qty_4' 			=> $i_qty_4,
						'i_qty_5' 			=> $i_qty_5,
						'i_qty_6' 			=> $i_qty_6,
						'i_qty_7' 			=> $i_qty_7,
						'i_qty_8' 			=> $i_qty_8,
						'i_qty_9' 			=> $i_qty_9,
						'i_qty_max'			=> $i_qty_max );

				$this->Order->save_plan_item($item_number, $item_data, $collection_id);
				} // END ORDERS - за всички произведени

			//  всички доставки ...
			if ( $mode == 'manu_db' and $collection_id!='' )
				{
               if ($plan_Key)
                  {
                     $d_qty_1 = $item_plan_info->d_qty_1 + $qty_1; if(!$d_qty_1) {$d_qty_1='';}			
                     $d_qty_2 = $item_plan_info->d_qty_2 + $qty_2; if(!$d_qty_2) {$d_qty_2='';}
                     $d_qty_3 = $item_plan_info->d_qty_3 + $qty_3; if(!$d_qty_3) {$d_qty_3='';}
                     $d_qty_4 = $item_plan_info->d_qty_4 + $qty_4; if(!$d_qty_4) {$d_qty_4='';}
                     $d_qty_5 = $item_plan_info->d_qty_5 + $qty_5; if(!$d_qty_5) {$d_qty_5='';}
                     $d_qty_6 = $item_plan_info->d_qty_6 + $qty_6; if(!$d_qty_6) {$d_qty_6='';}
                     $d_qty_7 = $item_plan_info->d_qty_7 + $qty_7; if(!$d_qty_7) {$d_qty_7='';}
                     $d_qty_8 = $item_plan_info->d_qty_8 + $qty_8; if(!$d_qty_8) {$d_qty_8='';}
                     $d_qty_9 = $item_plan_info->d_qty_9 + $qty_9; if(!$d_qty_9) {$d_qty_9='';}
                     $d_qty_max = $item_plan_info->d_qty_max + $qty_max; if(!$d_qty_max) {$d_qty_max='';}
                  }
               else
                  { $d_qty_1 = $d_qty_2 = $d_qty_3 = $d_qty_4 = $d_qty_5 = $d_qty_6 = $d_qty_7 = $d_qty_8 = $d_qty_9 = $d_qty_max = '';}
			
					$all_d_qty = $d_qty_1 + $d_qty_2 + $d_qty_3 + $d_qty_4 + $d_qty_5 + $d_qty_6 + $d_qty_7 + $d_qty_8 + $d_qty_9 + $d_qty_max;

					$item_data = array(
						'item_number' 		=> $item_number,
						'collection_id' 	=> $collection_id,
						'item_dqty' 		=> $all_d_qty,
						'd_qty_1' 			=> $d_qty_1,
						'd_qty_2' 			=> $d_qty_2,
						'd_qty_3' 			=> $d_qty_3,
						'd_qty_4' 			=> $d_qty_4,
						'd_qty_5' 			=> $d_qty_5,
						'd_qty_6' 			=> $d_qty_6,
						'd_qty_7' 			=> $d_qty_7,
						'd_qty_8' 			=> $d_qty_8,
						'd_qty_9' 			=> $d_qty_9,
						'd_qty_max'			=> $d_qty_max );

				$this->Order->save_plan_item($item_number, $item_data, $collection_id);
				} // END ORDERS - за всички доставки

	}  // край на цикъла за артикулите ...


		$this->db->trans_complete();
		if ($this->db->trans_status() === FALSE)	{ return -1;}

	return $doc_id;
	}


	function delete($doc_id,$vedomPack)
	{
    $db_docs 				= $vedomPack;
    $db_docs_items 		= $vedomPack . '_items';

		$this->db->trans_start();
			$this->db->delete( $db_docs_items, array('doc_id' => $doc_id));
			$this->db->delete( $db_docs, array('doc_id' => $doc_id)); 
		$this->db->trans_complete();

	return $this->db->trans_status();
	}

	function delete_line_item($doc_id, $line, $vedomPack)
	{
		$this->db->trans_start();
		$this->db->delete( $vedomPack.'_items', array('doc_id' => $doc_id, 'line' => $line));
		$this->db->trans_complete();
	return $this->db->trans_status();
	}

	
	function get_manu_items($doc_id, $vedomPack, $mode='manu_db')
	{
	$db_recvs_items = $vedomPack . '_items';

		$this->db->from($db_recvs_items);
		$this->db->where('doc_id',$doc_id);
	return $this->db->get();
	}

	function get_employee($doc_id, $vedomPack)
	{
	$db_manu = $vedomPack;
		$this->db->from($db_manu);
		$this->db->where('doc_id',$doc_id);
	return $this->Employee->get_info($this->db->get()->row()->person_id);
	}
	
	/*	Returns all the workers */
	function get_all_norma_workers()
	{
		$this->db->from('people');
		$this->db->where('norma > 7');
		$this->db->where('bisoft_id > 6000');
		$this->db->order_by("first_name", "asc");
	return $this->db->get();		
	}

}
?>
