<?php

class Sale extends CI_Model
{
	public function get_info($doc_id,$vedomPack)
	{  
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
	return $this->db->get();
	}

	public function get_info_by_vedom($doc_id,$vedom)
	{  
		$db_main = $this->BiSOFT_Model->get_db_main($mode);
		$db_sales = $vedom . $db_main; 
		$this->db->from($db_sales);
		$this->db->where('doc_id',$doc_id);
	return $this->db->get();
	}

	public function get_info_line($doc_id, $line, $vedomPack)
	{  
		$this->db->from($vedomPack.'_items');
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
	return $this->db->get();
	}

	public function get_info_invoice($doc_number,$vedomPack)
	{ 
		$this->db->from($vedomPack);
		$this->db->where('doc_number',$doc_number);
		$this->db->where('deleted = 0');
	return $this->db->get();
	}

	function exists($doc_id)
	{  
		$db_sales = $this->get_db_sales_location();
		$this->db->from($db_sales);
		$this->db->where('doc_id',$doc_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	function exists_item_in_prep($doc_id,$vedomPack,$inum)
	{  
		$this->db->from($vedomPack.'_items');
		$this->db->where('doc_id',$doc_id);
		$this->db->where('item_number',$inum);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}
	
	
	public function get_all_docs($vedomPack)
	{  
		$this->db->from($vedomPack);
		$this->db->where('deleted = 0');
	return $this->db->get()->result_array();
	}	
	

	function update($doc_data, $doc_id, $vedomPack)
	{  
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update( $vedomPack, $doc_data );
	return $success;
	}

	function update_items($items_data, $doc_id, $vedom)
	{  
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update( $vedom, $items_data );
	return $success;
	}

	function update_line_item($items_data, $doc_num, $line)
	{  
		$vedomPack = 'V'.substr($doc_num,0,4).'_items';
		$this->db->where('doc_number', $doc_num);
		$this->db->where('line', $line);
		$success = $this->db->update( $vedomPack, $items_data );
	return $success;
	}



	// ==================================== БЛАНКА ==============================  //
	public function exists_in_blanka($user, $mode_id, $line, $item_number)
	{  
		$this->db->from('blanka');
		$this->db->where('user',$user);
		$this->db->where('mode_id',$mode_id);
		$this->db->where('line',$line);
		$this->db->where('item_number',$item_number);
		$query = $this->db->get();
	return ($query->num_rows()>0);
	}
	
	function get_blanka($user, $mode_id)
	{  
		$this->db->from('blanka');
		$this->db->where('user',$user);
		$this->db->where('mode_id',$mode_id);
		if($query->num_rows()>0)
			{ return $this->db->get()->result_array();}
		else
			{ return 0;}
	}
	
	/*	Inserts or updates an item in BLANKA Store */
	function add_to_blanka(&$item_data, $user)
	{	
		$item_number = $item_data['item_number'];
		$mode_id  	 = $item_data['mode_id'];
		$line  	 	 = $item_data['line'];
		
		if (!$this->exists_in_blanka($user, $mode_id, $line, $item_number))
		{
			if($this->db->insert('blanka',$item_data))
			{
				// $item_data['item_id']=$this->db->insert_id();
				return true;
			}
		return false;
		}

		$this->db->where('user',$user);
		$this->db->where('mode_id',$mode_id);
		$this->db->where('item_number',$item_number);
		$this->db->where('line',$line);
		
	return $this->db->update('blanka',$item_data);
	}	
	// ==================================== КРАЙ НА БЛАНКА ==============================  //
		
		
		
	/* ================== КЛИЕНТИ НАЧ.САЛДА =================== */
	function exists_customer_due($client_id,$period)
	{
		if($period>2017) 
		{
			$this->db->from('saldo');
			$this->db->where('client_id',$client_id);
			$this->db->where('period',$period);
			$query = $this->db->get();
			return ($query->num_rows()==1);
		}
		else { return '0';}
	}
	
	function get_all_customers_due($period)
	{
		if($this->db->table_exists('saldo'))
		{
			$this->db->from('saldo');
			if($period>2017) {$this->db->where('period',$period);}
			$this->db->where('client_id > 0');
			$this->db->where('deleted',0);
			$query = $this->db->get();
			if($query->num_rows()>0)
				{ return $query->result_array();}
			else	{ return '0';}
		}
		else { return '0';}
	}

	function get_customer_due($client_id,$period)
	{
		if($this->db->table_exists('saldo'))
		{
			$this->db->from('saldo');
			$this->db->where('client_id',$client_id);
			if($period>2017) {$this->db->where('period',$period);}
			$this->db->where('deleted',0);
			$query = $this->db->get();
			if($query->num_rows()==1)
				{ return $query->row();}
			else	{ return '0';}
		}
		else { return '0';}
	}
	
	function save_customer_due(&$due_data)
	{	
		$client_id=$due_data['client_id'];$period=$due_data['period'];
		if($this->db->table_exists('saldo'))
		{
			if(!$this->exists_customer_due($client_id,$period))
				{	return $this->db->insert('saldo',$due_data); }
			else
				{
					$this->db->where('client_id',$client_id);
					$this->db->where('period',$period);
					return $this->db->update('saldo',$due_data);
				}
		}
		return '0';
	}
	

	/* ================== КОНСИГНАТОРИ НАЧ.САЛДА =================== */
	function exists_consignee_due($consignee_id,$period)
	{
		if($period>2017) 
		{
			$this->db->from('saldo');
			$this->db->where('consignee_id',$consignee_id);
			$this->db->where('period',$period);
			$query = $this->db->get();
			return ($query->num_rows()==1);
		}
		else { return '0';}
	}
	
	
	function get_all_consignees_due($period)
	{
		if($this->db->table_exists('saldo'))
		{
			$this->db->from('saldo');
			if($period>2017) {$this->db->where('period',$period);}
			$this->db->where('consignee_id > 0');
			$this->db->where('deleted',0);
			$query = $this->db->get();
			if($query->num_rows()>0)
				{ return $query->result_array();}
			else	{ return '0';}
		}
		else { return '0';}
	}
	
	function get_consignee_due($bisoft_id,$period)
	{
		if($this->db->table_exists('saldo'))
		{
			$this->db->from('saldo');
			$this->db->where('consignee_id',$bisoft_id);
			if($period>2017) {$this->db->where('period',$period);}
			$this->db->where('deleted',0);
			$query = $this->db->get();
			if($query->num_rows()==1)
				{ return $query->row();}
			else	{ return '0';}
		}
		else { return '0';}
	}
	
	function save_consignee_due(&$due_data)
	{	$consignee_id=$due_data['consignee_id'];$period=$due_data['period'];
		if($this->db->table_exists('saldo'))
		{
			if(!$this->exists_consignee_due($consignee_id,$period))
				{return $this->db->insert('saldo',$due_data);}
			$this->db->where('consignee_id',$consignee_id);$this->db->where('period',$period);
			return $this->db->update('saldo',$due_data);
		}
		return '0';
	}
	

	/* ==================================== РЕГИСТРАЦИЯ ==================================== */
	function save( $items, $mode, $total_qty, $subtotal, $doc_number, $doc_name,
			$bisoft_id, $client_name, $customer_discount, $employee_id, $payments, $comment)
	{
		if(count($items)==0) {return -1;}
		$location = $this->BiSOFT_Model->get_mode_location();
		if(null===$mode) { $mode='sale'; }
		$doc_id = false;
		$brand  = 1; // основна фирма

		$this->load->library('sale_lib');
		$client_data = '';
		
		// НОВО Клиента има право на ДОСТАВКА ?!
		$client_ShopKey = $client_person_id = 0;
		$client_status = $client_taxable = $onlineTO = 0;

      if($mode=='sale' or $mode=='sale_return')
         {	
            if($bisoft_id>0)
            {
					$cust_info = $this->Customer->get_info_by_bisoft_id($bisoft_id);
					if($cust_info)
					{
							$client_person_id = $cust_info->person_id;
							$client_status  	= $cust_info->status;
							$onlineTO 			= (float)$cust_info->discount;
							
							if($client_status=='onlineto' and $onlineTO>0) { $client_taxable=$cust_info->taxable; }
							// Brand ?
							$brand = $this->BiSOFT_Model->is_brand($bisoft_id);
					}
            }
            
            if($this->Customer->get_info($client_person_id))
            {
               $client_ShopKey = $this->Customer->get_info($client_person_id)->norma;
               if($client_ShopKey==3) { $client_ShopKey=1; }
            }
         }
		
		$commision = $commision_L = 0;

		$vedom = $this->BiSOFT_Model->get_vedom();
		$bank_mode = 1;

		// Определям дали Операторът има право на ОТЧЕТИ ?!?
		$person_report = 1;
		if(!$this->Employee->has_permission('reports',$this->Employee->get_logged_in_employee_info()->person_id))
			{ $person_report = 0; }

		$items_type = '_items';

	    	$db_sales = 'V'.date('ym', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
			$db_sales_items 			= $db_sales . '_items';
			$db_sales_payments 		= $db_sales;
				$db_suspended 			= 'suspended';
				$db_suspended_items 	= $db_suspended . '_items';
				$db_delivers 			= 'delivers';
				$db_delivers_items 	= $db_delivers . '_items';
				
			$db_shops = 'S'.date('ym', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
			$db_shops_items 			= $db_shops . '_items';	

		//Зареждам Покупката ...
		$doc_date = $this->BiSOFT_Model->get_user_mode_date();
		$doc_name = $this->BiSOFT_Model->get_document_title($mode);	 // това си е вече заглавието...
		$mode_id  = $this->BiSOFT_Model->get_pay_group($mode);		 // index-a 'Е', 'SE' ..

				//групата за плащане .. index-a
				$pay_groups=$payment_types='';
				$total_sum = 0;
				$payK = 1;
				if ($mode=='sale_return' or $mode=='shop_return' or $mode=='online_return') { $payK = -1;}

					foreach($payments as $payment_id=>$payment)
					{
						$pay_groups 	= $payment['payment_type'];			
						$payment_types	= $payment_types.$payment['payment_type'].': '.
											to_currency($payK * $payment['payment_amount']).';';
						$total_sum	+=	$payment['payment_amount'];
					}
					
					$total_sum_text = to_currency($total_sum);

      //Разпределяме коеф.-те на index-ите на плащане за покупката ..
		$pay_type = 'H';$pay_type_txt='непл';
		switch ($pay_groups) 
				{
					case $this->lang->line('sales_not_paid'):	$pay_type = 'H';  break;
					case $this->lang->line('sales_returned_goods'): $pay_type = 'BP'; $pay_type_txt='върната';  break;
					case $this->lang->line('sales_cash'): 		$pay_type = 'P'; $pay_type_txt = 'брой'; break;
					case $this->lang->line('sales_by_bank'):	$pay_type = 'T'; $pay_type_txt = 'банка-1'; $bank_mode = 1; break;
					case $this->lang->line('sales_by_bank').'2':	$pay_type = 'T'; $pay_type_txt = 'банка-2'; $bank_mode = 2; break;
					case $this->lang->line('sales_not_paid_bank'):	$pay_type = 'HT'; $pay_type_txt = 'непл.банка'; break;
					case $this->lang->line('sales_check'):		$pay_type = 'Ch'; $pay_type_txt = 'чек'; break; 
					case $this->lang->line('sales_debit'):		$pay_type = 'dC'; $pay_type_txt = 'деб.карта'; break;
					case $this->lang->line('sales_credit'):	$pay_type = 'kC'; $pay_type_txt = 'кр.карта';break;
					case $this->lang->line('sales_epay'):		$pay_type = 'eP'; $pay_type_txt = 'ePay';break; 
               case $this->lang->line('sales_paypal'):	$pay_type = 'PP'; $pay_type_txt = 'PayPal'; break;
					case $this->lang->line('sales_offer_price'):	$pay_type = 'Of'; $pay_type_txt = 'оферта'; break;
					default: $pay_type = 'H';$pay_type_txt='непл.';
				}

		if ( $bisoft_id != 0 )
		{
			if (  $mode=='shop_sale' or $mode=='consi_sale')
				{  $client_name = $this->Consignee->get_info_by_bisoft_id($bisoft_id)->company_name;}
		elseif ( $mode=='shop_sgp' ) 
				{ 	$bisoft_id = $location; 
					$client_name = $this->Consignee->get_info_by_bisoft_id($bisoft_id)->company_name;
				}				
			else
				{ 
					if($bisoft_id==1000)
					{
						$cName = $this->sale_lib->get_client_name();
						$cSurname = $this->sale_lib->get_client_surname();
							$client_name = $this->Customer->get_info_by_bisoft_id($bisoft_id)->company_name;
							$client_name .= ' - '.$cName.' '.$cSurname;
							$client_data = $this->sale_lib->get_client_data();
							$order_id 	 = $this->sale_lib->get_order();
					}
					elseif( $bisoft_id != 1000000 )
					{
						$client_name = $this->Customer->get_info_by_bisoft_id($bisoft_id)->company_name;
						$this->BiSOFT_Model->customer_rating($bisoft_id,$subtotal);
					}
				}
		}

		$employee_name	=	$this->Employee->get_id_names($employee_id);

		// ВАЛУТИ
		$now_valuta_rate = '1.0000'; $now_valuta = $this->config->item('currency');

		// изчисляваме ДДС-то ......
		$this->load->library('sale_lib');
		$mode_price = $this->sale_lib->get_mode_price();

		$tax_VAT = 0;
		$taxed	= 0;
		if ($mode_price == 100 or $mode_price == 102) { $taxed = 1;}  // vat=100, export_vat 102

		$tax_VAT = $taxed	= $total_discount = 0;
		if($customer_discount) {$total_discount = $customer_discount;}
		
		$total_amount = round($subtotal * (100 - $total_discount)/100, 6);
		
         // спец. Online Clients // ?!?!?!?!?!?!??!?!
         if($location==0 and $client_taxable and $client_status=='onlineto') 
           { 
               $taxed=1;
               $tax_VAT = round($subtotal/6,6);
               $total_amount = $subtotal - $tax_VAT;
            }
         elseif($location==0 and ($mode=='online_sale' or $mode=='online_return'))
            {  // ново - само за СГП
               $taxed=1;
               $tax_VAT = round(0.2*$subtotal,6);
               $total_amount = $subtotal + $tax_VAT;
            }
         else
            {  $total_amount += $tax_VAT; }

		if($pay_type == 'Of') { $comment .= $this->lang->line('sales_offer_price').': '.$mode_price.'гр.';}	
		
		// знаците на totals ...
		$giftcard = $giftvalue = $giftprocent = 0; $gift_info = array();
		if ($mode=='sale' or $mode=='shop_sale' or $mode=='online_sale')
			{ 
				if($location > 0 and $mode!='online_sale' and $mode!='online_return') // само магазини
				{
				  // Giftcards on shops
				  $giftcard = $this->sale_lib->get_giftcard();
				  if($giftcard)
					 {
						$gift_info = $this->Giftcard->get_giftcard_by_code($giftcard);
						if($gift_info->procent!=0)
						{
							$giftprocent  = $gift_info->procent;
							$total_amount = round($total_amount * (100 - $giftprocent)/100, 6);
							$payment_types	.= ' ('.$gift_info->type.'%)';
							$client_name = $gift_info->owner.' ('.$gift_info->type.'%)';
						}
						else // стойностен Ваучер.
						{
							if($total_sum>0) {$giftvalue = round(100*$gift_info->value/($total_sum+$gift_info->value),6);}
							else {$giftvalue = 100;}
							$payment_types	.= ' v-'.$gift_info->value;
							$client_name = $gift_info->owner.' (v'.$gift_info->value.')';
							$giftprocent=0;
						}
						// странна нова корекция //
						$total_sum = abs($subtotal);
					 }
              elseif($total_discount)
					 { $total_amount = round($total_sum * (100 - $total_discount)/100, 6);}
              elseif($client_status=='onlineto')
                {
                  $tax_VAT = round($subtotal/6,6);
                  $total_amount = $subtotal - $tax_VAT;
                }
              else
					 { $total_amount = $total_sum; $total_sum = abs($subtotal); } 
				}
				elseif($mode=='online_sale')
				{
				  // Giftcards on online-shop
				  $giftcard = $this->sale_lib->get_giftcard();
				  if($giftcard)
					 {
						$gift_info = $this->Giftcard->get_giftcard_by_code($giftcard);
						if($gift_info->procent!=0)
						{
							$giftprocent = $gift_info->procent;
							$total_amount = round($subtotal * (100 - $giftprocent)/100, 6);
							$payment_types	.= ' '.$gift_info->type.'%';
							$client_name = $gift_info->owner.' ('.$gift_info->type.'%)';
						}
						else // стойностен Ваучер.
						{
							if($subtotal>0) {$giftvalue = round(100*$gift_info->value/($subtotal+$gift_info->value),6);}
							else {$giftvalue = 100;}
							$payment_types	.= ' v-'.$gift_info->value;
							$client_name = $gift_info->owner.' (v'.$gift_info->value.')';
							$giftprocent=0;
						}
					 }
               // странна нова корекция - без ДДС //
               $total_sum = abs(1.2*$subtotal);
				}
				elseif($mode=='sale')
				{ $total_sum = abs($subtotal); }
			}
		elseif ($mode=='sale_return' or $mode=='shop_return' or $mode=='shop_sgp') // върната стока като цяло ...
			{ 
				$total_qty 		= -abs($total_qty);
				$total_sum 		= -abs($subtotal);
				$total_amount 	= -abs($total_amount);
				$pay_type 		= 'BP';
				
				// Giftcards on shops returns
				$giftcard = $this->sale_lib->get_giftcard();
				if($giftcard)
				  {
					 $gift_info = $this->Giftcard->get_giftcard_by_code($giftcard);
						if($gift_info->procent!=0 and $gift_info->cost==0)
						{
							$giftprocent = $gift_info->procent;
							$total_amount = round($subtotal * (100 - $giftprocent)/100, 6);
							$payment_types .= ' -'.$gift_info->type.'%';
							$client_name = $gift_info->type.'%-'.$gift_info->owner;
						}
						else // стойностен Ваучер.
						{
							if($subtotal>0) {$giftvalue = round(100*$gift_info->value/($subtotal+$gift_info->value),6);}
							else {$giftvalue = 100;}
							$payment_types	.= ' v-'.$gift_info->value;
							$client_name = $gift_info->owner.' (v'.$gift_info->value.')';
							$giftprocent=0;
						}
				  }
				 elseif($total_discount)
					{ $total_amount = round($total_sum * (100 - $total_discount)/100, 6);}
			}
		elseif($mode=='online_return')
			{
				$total_qty 		= -abs($total_qty);
				$total_sum 		= -abs(1.2*$subtotal);
				$total_amount 	= -abs($total_amount);
				$tax_VAT       = -abs($tax_VAT);
				$pay_type 		= 'OMB';
				$comment		  .= " (".$this->lang->line('sales_online_return').")";
			}
		else // за други ...
			{ $total_sum = $subtotal;}

      // оформям отчитането на консигнациите ...
		$mode_sale 		 = $mode;
		$mode_id_sale 	 = $mode_id;
		$client_id_sale = $bisoft_id;
		$client_sale 	 = $client_name;

		if ( $mode=='consi_sale' ) 
			{ 
				$mode_sale 		= 'shop_sale';
				$mode_id_sale 	= 'SE';
			}
		elseif( $mode=='online_sale' )
			{ 
				$mode_sale 		= 'online_sale';
				$mode_id_sale 	= 'OM';
			}
		elseif( $mode=='online_return' )
			{ 
				$mode_sale 		= 'online_return';
				$mode_id_sale 	= 'OMB';
			}
	
      // само за играта 3 за 2
		$location_lock = 0;
		// разрешава на ВСИЧКИ Магазини без Красьо да играят 3 за 2.
		$allow_three4two = $this->OnLine->allow_three4two();

		if($location>0 and $location<11 and $location!=7) 
         {$location_lock = 1;} // само без Красьо=7 ?!

		$three4two = $due_sum = $three4two_suma = 0;
      $order_id  = null;
		if($allow_three4two and $location_lock and $this->OnLine->get_three4two() and count($items)>2)
         {
            $three4two = 1;
            $order_id='three4two';
            $due_sum = $three4two_suma = $this->sale_lib->get_three4two_discount();
            $payment_types .= ' (three4two='.$due_sum.'лв)';
         }
         
      $pay_sale = $total_amount;
      if($pay_type=='H' or $pay_type=='HT') { $pay_sale = 0; }
      
      // спец. Online Clients // ?!?!?!
      $dostavka = $giftowner = 0;
      if($client_taxable and $client_status=='onlineto') //  and $onlineTO>0
         {  
      		$pay_sale = round($total_amount*(100-1.2*$onlineTO)/100,6); // това не го разбирам, точно как става ???
      		$total_amount = round($total_sum/1.2,6); 
            $payment_types = $this->lang->line('reports_costsale');
            $pay_type_txt = 'отчет';
         }
      elseif( $mode=='online_sale' or $mode=='online_return' )
         {
            $pay_sale = 0;
            $giftowner = $client_name;
            $dostavka 	= $this->OnLine->get_text('delivery_cost');
            $limit_cost = $this->OnLine->get_text('limit_cost');
				$total_amount = round($total_sum/1.2,6); 
				if($total_sum > $limit_cost) 	{ $dostavka=0; }
				if($mode=='online_return') 	{ $dostavka=0; }
         }
         
		// if($comment==0 or empty(trim($comment))) {$comment='';}

		// зареждам основните параметри на Главния документ ......
		$sales_data = array(
				'mode'				=> $mode_sale,
				'mode_id'			=> $mode_id_sale,
				'mode_price'		=> $bank_mode,
				'doc_number'		=> $doc_number,
				'doc_date' 			=> $doc_date,
				'total_qty'			=> $total_qty,
				'total_sum'			=> $total_sum,
				'total_discount'	=> $total_discount,
				'taxed'				=> $taxed,
				'total_taxes'		=> $tax_VAT,
				'brand'				=> $brand,
				'delivery'			=> $dostavka,
				'giftowner'			=> $giftowner,
				'giftcard'			=> $giftcard,
				'giftvalue'			=> $giftvalue,
				'giftprocent'		=> $giftprocent,
				'pay_group'			=> $pay_type,
				'pay_type'			=> $pay_type_txt, // $payment_types,
				'pay_amount'		=> $total_amount,
				'pay_sale'			=> $pay_sale,
				'due_sum'         => $due_sum,
				'order_id'        => $order_id,
				'currency'			=> $now_valuta,
				'currency_rate'	=> $now_valuta_rate,
				'client_id'			=> $client_id_sale,
				'client'				=> $client_sale,
				'client_data' 		=> $client_data,
				'employee_id'		=> $employee_id,
				'employee'			=> $employee_name,
				'comment'			=> $comment,
				'location'			=> $location );	

		$shops_data = array();		
		if($client_ShopKey)
		{
         $shops_data = array(
               'mode'				=> $mode_sale,
               'mode_id'			=> $mode_id_sale,
               'mode_price'		=> 1,
               'doc_number'		=> $doc_number,
               'doc_date' 			=> $doc_date,
               'total_qty'			=> $total_qty,
               'total_sum'			=> $total_sum,
               'total_discount'	=> $total_discount,
               'taxed'				=> $taxed,
               'total_taxes'		=> $tax_VAT,
               'giftcard'			=> 0,
               'giftvalue'			=> 0,
               'giftprocent'		=> 0,
               'pay_group'			=> $pay_type,
               'pay_type'			=> $pay_type_txt, // $payment_types,
               'pay_amount'		=> $total_amount,
               'pay_sale'			=> $total_amount,
               'currency'			=> $now_valuta,
               'currency_rate'	=> $now_valuta_rate,
               'client_id'			=> $client_id_sale,
               'client'				=> $client_sale,
               'employee_id'		=> $employee_id,
               'employee'			=> $employee_name,
               'location'			=> $client_id_sale );
		}
				
		// само за ВЪРНАТА Склад-ГП от Магазина ?!
		$recvs_delivery = $sales_data;
		if ( $mode=='shop_sgp' and $location != 0)
			{ $recvs_delivery['mode'] 			= 'consi_return';
			  $recvs_delivery['mode_id'] 		= 'BC';
			  $recvs_delivery['total_qty']  	= abs($total_qty);
			  $recvs_delivery['total_sum']  	= abs($subtotal);
			  $recvs_delivery['pay_amount'] 	= abs($total_sum);
			  $recvs_delivery['client_id']  	= $location; 
			}
			
		// само за Giftcards
		if( ($mode=='shop_sale' or $mode=='shop_return') and $location != 0 and $giftcard)
		  {
          // да си оправим нашата ведомост
          if($giftprocent)
          {
            $total_amount = $this->sale_lib->get_total($mode,$customer_discount,0);
            $sales_data['pay_amount'] = $sales_data['pay_sale'] = $total_amount;
          }
		  
          // промяна на ведомостта с картите
			 $gift_info = $this->Giftcard->get_giftcard_by_code($giftcard);
			 $giftcard_id = $gift_info->giftcard_id;
			 $gift_total  = $gift_info->total + $total_amount;
			 
			 $gift_data = array( 'giftcard_id' => $giftcard_id,
                              'total'	=> $gift_total );
					 
          $this->Giftcard->save($gift_data,$giftcard_id);
		  }


//------------------------ записва в Базите Данни ---------------------- //
	$this->db->trans_start(); // --> отваря запис към БАЗАТА ... -->> 
		
	$doc_id = $doc_shop_id = $delivery_id = 0;
	if ( $mode == 'shop_sgp' and $location != 0)
		{
			$this->db->insert( $db_delivers, $recvs_delivery);
			$delivery_id = $this->db->insert_id();  // взимам номер от буфера
		}
	else
		{	// вкарва данните от Документа в Месечната База Данни ... //
			$this->db->insert( $db_sales, $sales_data);
			$doc_id = $this->db->insert_id();  // от тук си взимам номер
			
			//само за НОВО Клиента ?! //
			if($client_ShopKey)
			{
            $this->db->insert( $db_shops, $shops_data);
            $doc_shop_id = $this->db->insert_id();
			}
		}

// =================== обработка на всички артикули от количката =================== //
$mag_all_qty = $mag_costs = $mag_total = $sale_total = $gift_total = 0;

if($items)
{
	foreach($items as $line=>$item)  // сканира количката ...
	{
		$inum=$item['inum'];$skl=$item['skl'];$mode_price=$item['mprice'];
		$name='Н-Е-И-З-В-Е-С-Т-Е-Н __ А-Р-Т-И-К-У-Л';$allow_sizes=0;
		$skl_info  = $this->Item->get_sklad_info($inum,$skl);
		$item_info = $this->Item->get_blanka_info($inum);
		if($item_info)
		{
			$name = $this->Item->get_name($inum);
			$allow_sizes=$item_info->allow_sizes;
			if($allow_sizes=='105') {$allow_sizes=0;}
		}

		$order_sizes = $shops_items_data = array();
	
			// ЦЕНИ за Регистрация
			$item_discount = (int)$item['dsc'];
			$item_price = $costsale = (float)$item['price']; // по default
			if ($person_report)
				{
					$item_price = $payK * $item['price'];
					switch ($mode_price) 
						{
							case '1': $item_price = (float)$skl_info->price;   break;
							case '2': $item_price = (float)$skl_info->price_2; break;
							case '3': $item_price = (float)$skl_info->price_3; break;
							case '4': $item_price = (float)$skl_info->price_4; break;
							case '5': $item_price = (float)$skl_info->price_5; break;
							default:  $item_price = (float)$item['price'];
						}
					$costsale=$payK*$item_price;
					// странно обслужване на последователност от отстъпки ...
					if($item_discount>0) {$costsale = $payK*round($item_price*(100-$item_discount)/100,8);}	
					if($customer_discount>0) {$costsale = $payK*round($costsale*(100-$customer_discount)/100,8);}
					if($giftprocent>0) { $costsale = round($costsale*(100-$giftprocent)/100,8);}
				}
			else // за МАГАЗИНИ, които нямат право на ОТЧЕТИ, или "охлювите" ?!?
				{   
					$item_discount=0;
					$item_price = $costsale = $payK*round($skl_info->cost*(100-$giftprocent)/100,8);
					if ($item_price == 0) { $item_price = $costsale = $payK*$item['price']; }
				}

			$modeK = 1;
			if( $mode=='sale_return' or $mode=='shop_return' or $mode=='online_return' or $mode=='shop_sgp') 
				{ $modeK = -1; }

			if ($allow_sizes)
			{ 
				$qty=$item['qty'];
				$all_qty = $modeK * abs($qty);
				$qty_1 = (!$item['q1']) ? '' : $modeK * abs($item['q1']); $q1 = (int)$qty_1;
				$qty_2 = (!$item['q2']) ? '' : $modeK * abs($item['q2']); $q2 = (int)$qty_2;
				$qty_3 = (!$item['q3']) ? '' : $modeK * abs($item['q3']); $q3 = (int)$qty_3;
				$qty_4 = (!$item['q4']) ? '' : $modeK * abs($item['q4']); $q4 = (int)$qty_4;
				$qty_5 = (!$item['q5']) ? '' : $modeK * abs($item['q5']); $q5 = (int)$qty_5;
				$qty_6 = (!$item['q6']) ? '' : $modeK * abs($item['q6']); $q6 = (int)$qty_6;
				$qty_7 = (!$item['q7']) ? '' : $modeK * abs($item['q7']); $q7 = (int)$qty_7;
				$qty_8 = (!$item['q8']) ? '' : $modeK * abs($item['q8']); $q8 = (int)$qty_8;
				$qty_9 = (!$item['q9']) ? '' : $modeK * abs($item['q9']); $q9 = (int)$qty_9;
				$qty_max = (!$item['q10']) ? '' : $modeK * abs($item['q10']); $q10 = (int)$qty_max;
				
				$sizeQty=$q1+$q2+$q3+$q4+$q5+$q6+$q7+$q8+$q9+$q10;
			}
			else 
			{
				$q1=$q2=$q3=$q4=$q5=$q6=$q7=$q8=$q9=$q10=0;
				$qty_1=$qty_2=$qty_3=$qty_4=$qty_5=$qty_6=$qty_7=$qty_8=$qty_9=$qty_max='';
				$all_qty=$sizeQty=$qty=$modeK*abs($item['qty']);
			}

         // само при 3 за 2 ...
         if($three4two and $location_lock and count($items)>2 and abs($three4two_suma)==$item['price'])
         {  
				$costsale = $taxed = 0;
            $item_discount = 100;
            $three4two_suma=0;
         }
               
            // специалните клиенти и върнатата online
            if($client_taxable and $client_status=='onlineto' and $onlineTO>0)          
               {
                  $taxed = round($item_price/6,8);
                  $item_price = round($item_price/1.2,8);
                  $costsale = round($item_price*(100-1.2*$onlineTO)/100,8);
               }
            elseif($mode=='online_return')
               {
                  $taxed = abs(round(0.2*$item_price,8));
                  $costsale = $item_price;
               }

			$sales_items_data = array(
						'doc_id'			=> $doc_id,
						'line'			=> $item['line'],
						'mode_id' 		=> $mode_id_sale,
						'doc_number' 	=> $doc_number,
						'doc_date' 		=> $doc_date,
						'item_number'	=> $inum,
						'item_name'		=> $sizeQty.','.$qty_1.','.$qty_2.','.$qty_3.
															','.$qty_4.','.$qty_5.','.$qty_6.
															','.$qty_7.','.$qty_8.','.$qty_9.','.$qty_max,
						'item_qty'		=> $all_qty,
					'item_unit_price'	=> abs($item_price),
					'item_discount'	=> abs($item_discount),
							'costsale'  => abs($costsale),
						'item_taxes'	=> $taxed,
						'client_id'		=> $client_id_sale,
						'brand'			=> $brand,
						'location'		=> $skl );
		
						
				  if($mode=='online_sale' or $mode=='online_return')
						{ $sales_items_data['item_name'] = $sizeQty.','.$qty_1.','.$qty_2.','.$qty_3.
																  ','.$qty_4.','.$qty_5.','.$qty_6.
																  ','.$qty_7.','.$qty_8.','.$qty_9.','.$qty_max.','.$client_sale;
						}
						
               //само за НОВО Клиента ?! //
               if($client_ShopKey) 
                  { 
                     $shops_items_data = array(
                        'doc_id'			=> $doc_shop_id,
                        'line'			=> $item['line'],
                        'mode_id' 		=> $mode_id_sale,
                        'doc_number' 	=> $doc_number,
                        'doc_date' 		=> $doc_date,
                        'item_number'	=> $inum,
                        'item_name'		=> $sizeQty.','.$qty_1.','.$qty_2.','.$qty_3.
                                                   ','.$qty_4.','.$qty_5.','.$qty_6.
                                                   ','.$qty_7.','.$qty_8.','.$qty_9.','.$qty_max,
                        'item_qty'		=> $all_qty,
                     'item_unit_price'	=> abs($item['price']),
                     'item_discount'	=> abs($item['dsc']),
                           'costsale'  => abs(round((float)$item['price']*(100-(int)$item['dsc'])/100,8)),
                        'item_taxes'	=> 0,
                        'client_id'		=> $client_id_sale,
                        'location'		=> $client_id_sale );
                  }

					$order_sizes=array(
						'q1'	=> $qty_1,
						'q2'	=> $qty_2,
						'q3'	=> $qty_3,
						'q4'	=> $qty_4,
						'q5'	=> $qty_5,
						'q6'	=> $qty_6,
						'q7'	=> $qty_7,
						'q8'	=> $qty_8,
						'q9'	=> $qty_9,
						'q10' => $qty_max,
						'qty' => $all_qty	);

			// само ВЪРНАТА Склад-ГП
			$sales_items_delivers = array();
			if ( $mode=='shop_sgp' and $location != 0)
				{
					$sales_items_delivers = array(
							'doc_id'			=> $delivery_id,
							'line'			=> $item['line'],
							'mode_id' 		=> 'BC',
							'doc_number' 	=> $doc_number,
							'doc_date' 		=> $doc_date,
							'item_number'	=> $inum,
							'item_name'		=> abs($sizeQty).','.abs($q1).','.abs($q2).','.abs($q3).','.abs($q4).
																	  ','.abs($q5).','.abs($q6).','.abs($q7).','.abs($q8).
																	  ','.abs($q9).','.abs($q10),
							'item_qty'		=> abs($qty),
						'item_unit_price'	=> abs($item['price']),
						'item_discount'	=> abs($item['dsc']),
							'item_taxes'	=> 0,
							'client_id'		=> $location,
							'location'		=> $location );

					// ЗАПИС на items в База 'DELIVERS' за върната стока.
					$this->db->insert( $db_delivers_items, $sales_items_delivers);
				}
						
			// събирам данни за restricted магазини ...
			$mag_all_qty += $all_qty;
			$mag_total 	 += $all_qty*$item_price;
			$sale_total  += $all_qty*$costsale;
			
			$mag_costs   += $all_qty*$costsale;
			
			// giftcards
			$new_giftvalue = 0;
			if($giftprocent > 0)
				{ $new_giftvalue = $item_price*(100-$giftprocent)/100;}
			$gift_total += $all_qty*$new_giftvalue*(100-$item_discount)/100;

// ======== ОТНЕМАНЕ от СКЛАДА и '0'-те ==================== //
			$result_qty = 0;
			$shop_info = $item_shop_data = array();
			if($skl_info)
			{
				if ( $mode=='sale' or $mode=='shop_sale' or $mode=='online_sale' or $mode=='consi_sale')
				{
					$newQty_1 = (int)$skl_info->q1 - (int)$item['q1'];
					$newQty_2 = (int)$skl_info->q2 - (int)$item['q2'];
					$newQty_3 = (int)$skl_info->q3 - (int)$item['q3'];
					$newQty_4 = (int)$skl_info->q4 - (int)$item['q4'];
					$newQty_5 = (int)$skl_info->q5 - (int)$item['q5'];
					$newQty_6 = (int)$skl_info->q6 - (int)$item['q6'];
					$newQty_7 = (int)$skl_info->q7 - (int)$item['q7'];
					$newQty_8 = (int)$skl_info->q8 - (int)$item['q8'];
					$newQty_9 = (int)$skl_info->q9 - (int)$item['q9'];
					$newQty_10 = (int)$skl_info->q10 - (int)$item['q10'];
				
					//Update stock quantity
					$result_qty = $skl_info->qty - $qty;
					$item_data = array(
						'inum'	=> $inum,
						'skl'		=> $skl,
						'qty'		=> $result_qty,
						'q1'		=> (!$newQty_1) ? '' : $newQty_1,
						'q2'		=> (!$newQty_2) ? '' : $newQty_2,
						'q3'		=> (!$newQty_3) ? '' : $newQty_3,
						'q4'		=> (!$newQty_4) ? '' : $newQty_4,
						'q5'		=> (!$newQty_5) ? '' : $newQty_5,
						'q6'		=> (!$newQty_6) ? '' : $newQty_6,
						'q7'		=> (!$newQty_7) ? '' : $newQty_7,
						'q8'		=> (!$newQty_8) ? '' : $newQty_8,
						'q9'		=> (!$newQty_9) ? '' : $newQty_9,
						'q10'		=> (!$newQty_10) ? '' : $newQty_10,
						'del'		=> 0 );
						
					//само за НОВО Клиента ?! //
					if($client_ShopKey)
					{
						$shop_info = $this->Item->get_shop_info($inum,$client_id_sale);
						if($shop_info)
						{
							$shopQty_1 = (int)$shop_info->q1 + (int)$item['q1'];
							$shopQty_2 = (int)$shop_info->q2 + (int)$item['q2'];
							$shopQty_3 = (int)$shop_info->q3 + (int)$item['q3'];
							$shopQty_4 = (int)$shop_info->q4 + (int)$item['q4'];
							$shopQty_5 = (int)$shop_info->q5 + (int)$item['q5'];
							$shopQty_6 = (int)$shop_info->q6 + (int)$item['q6'];
							$shopQty_7 = (int)$shop_info->q7 + (int)$item['q7'];
							$shopQty_8 = (int)$shop_info->q8 + (int)$item['q8'];
							$shopQty_9 = (int)$shop_info->q9 + (int)$item['q9'];
							$shopQty_10 = (int)$shop_info->q10 + (int)$item['q10'];

							// UPDATE stock quantity
							$result_shop_qty = $shop_info->qty + $qty;
							$item_shop_data = array(
								'inum'	=> $inum,
								'skl'		=> $client_id_sale,
								'qty'		=> $result_shop_qty,
								'q1'		=> (!$shopQty_1) ? '' : $shopQty_1,
								'q2'		=> (!$shopQty_2) ? '' : $shopQty_2,
								'q3'		=> (!$shopQty_3) ? '' : $shopQty_3,
								'q4'		=> (!$shopQty_4) ? '' : $shopQty_4,
								'q5'		=> (!$shopQty_5) ? '' : $shopQty_5,
								'q6'		=> (!$shopQty_6) ? '' : $shopQty_6,
								'q7'		=> (!$shopQty_7) ? '' : $shopQty_7,
								'q8'		=> (!$shopQty_8) ? '' : $shopQty_8,
								'q9'		=> (!$shopQty_9) ? '' : $shopQty_9,
								'q10'		=> (!$shopQty_10) ? '' : $shopQty_10,
								'del'		=> 0 );
						}
						else
						{  // NEW stock quantity
							$result_shop_qty = $qty;
							$item_shop_data = array(
								'inum'	=> $inum,
								'skl'		=> $client_id_sale,
								'price'  => abs($item_price),
								'dsc'    => abs($item_discount),
								'cost'   => abs($costsale),
								'coll'   => $skl_info->coll,
								'cat'    => $skl_info->cat,
								'qty'		=> $result_shop_qty,
								'q1'		=> (!$item['q1']) ? '' : $item['q1'],
								'q2'		=> (!$item['q2']) ? '' : $item['q2'],
								'q3'		=> (!$item['q3']) ? '' : $item['q3'],
								'q4'		=> (!$item['q4']) ? '' : $item['q4'],
								'q5'		=> (!$item['q5']) ? '' : $item['q5'],
								'q6'		=> (!$item['q6']) ? '' : $item['q6'],
								'q7'		=> (!$item['q7']) ? '' : $item['q7'],
								'q8'		=> (!$item['q8']) ? '' : $item['q8'],
								'q9'		=> (!$item['q9']) ? '' : $item['q9'],
								'q10'		=> (!$item['q10']) ? '' : $item['q10'],
								'del'		=> 0 );
						}
					}
				}
				elseif ( $mode=='sale_return' or $mode=='shop_return' or $mode=='online_return')
				{
					// ПРИБАВЯНЕ към СКЛАДА и '0'-те ... за всички останали доставки
					$newQty_1 = (int)$skl_info->q1 + (int)$item['q1'];
					$newQty_2 = (int)$skl_info->q2 + (int)$item['q2'];
					$newQty_3 = (int)$skl_info->q3 + (int)$item['q3'];
					$newQty_4 = (int)$skl_info->q4 + (int)$item['q4'];
					$newQty_5 = (int)$skl_info->q5 + (int)$item['q5'];
					$newQty_6 = (int)$skl_info->q6 + (int)$item['q6'];
					$newQty_7 = (int)$skl_info->q7 + (int)$item['q7'];
					$newQty_8 = (int)$skl_info->q8 + (int)$item['q8'];
					$newQty_9 = (int)$skl_info->q9 + (int)$item['q9'];
					$newQty_10 = (int)$skl_info->q10 + (int)$item['q10'];

					//Update stock quantity
					
					if($mode=='sale_return' and !$allow_sizes)
					{ $result_qty = $skl_info->qty + abs($qty); }
					else
					{ $result_qty = (int)$skl_info->qty + $qty; }
					
					$item_data = array(
						'inum'	=> $inum,
						'skl'		=> $skl,
						'qty'		=> $result_qty,
						'q1'		=> (!$newQty_1) ? '' : $newQty_1,
						'q2'		=> (!$newQty_2) ? '' : $newQty_2,
						'q3'		=> (!$newQty_3) ? '' : $newQty_3,
						'q4'		=> (!$newQty_4) ? '' : $newQty_4,
						'q5'		=> (!$newQty_5) ? '' : $newQty_5,
						'q6'		=> (!$newQty_6) ? '' : $newQty_6,
						'q7'		=> (!$newQty_7) ? '' : $newQty_7,
						'q8'		=> (!$newQty_8) ? '' : $newQty_8,
						'q9'		=> (!$newQty_9) ? '' : $newQty_9,
						'q10'		=> (!$newQty_10) ? '' : $newQty_10,
						'del'		=> 0 );
						
					//само за НОВО Клиента ?! //
					if($client_ShopKey)
					{
						$shop_info = $this->Item->get_shop_info($inum,$client_id_sale);
						if($shop_info)
						{  // UPDATE stock quantity
							$shopQty_1 = (int)$shop_info->q1 - (int)$item['q1'];
							$shopQty_2 = (int)$shop_info->q2 - (int)$item['q2'];
							$shopQty_3 = (int)$shop_info->q3 - (int)$item['q3'];
							$shopQty_4 = (int)$shop_info->q4 - (int)$item['q4'];
							$shopQty_5 = (int)$shop_info->q5 - (int)$item['q5'];
							$shopQty_6 = (int)$shop_info->q6 - (int)$item['q6'];
							$shopQty_7 = (int)$shop_info->q7 - (int)$item['q7'];
							$shopQty_8 = (int)$shop_info->q8 - (int)$item['q8'];
							$shopQty_9 = (int)$shop_info->q9 - (int)$item['q9'];
							$shopQty_10 = (int)$shop_info->q10 - (int)$item['q10'];
						}
						else
						{  // NEW stock quantity
							$shopQty_1  = -(int)$item['q1'];
							$shopQty_2  = -(int)$item['q2'];
							$shopQty_3  = -(int)$item['q3'];
							$shopQty_4  = -(int)$item['q4'];
							$shopQty_5  = -(int)$item['q5'];
							$shopQty_6  = -(int)$item['q6'];
							$shopQty_7  = -(int)$item['q7'];
							$shopQty_8  = -(int)$item['q8'];
							$shopQty_9  = -(int)$item['q9'];
							$shopQty_10 = -(int)$item['q10'];
						}
						
						$result_shop_qty = $shop_info->qty - $qty;
						
						$item_shop_data = array(
							'inum'	=> $inum,
							'skl'		=> $client_id_sale,
							'qty'		=> $result_shop_qty,
							'q1'		=> (!$shopQty_1) ? '' : $shopQty_1,
							'q2'		=> (!$shopQty_2) ? '' : $shopQty_2,
							'q3'		=> (!$shopQty_3) ? '' : $shopQty_3,
							'q4'		=> (!$shopQty_4) ? '' : $shopQty_4,
							'q5'		=> (!$shopQty_5) ? '' : $shopQty_5,
							'q6'		=> (!$shopQty_6) ? '' : $shopQty_6,
							'q7'		=> (!$shopQty_7) ? '' : $shopQty_7,
							'q8'		=> (!$shopQty_8) ? '' : $shopQty_8,
							'q9'		=> (!$shopQty_9) ? '' : $shopQty_9,
							'q10'		=> (!$shopQty_10) ? '' : $shopQty_10,
							'del'		=> 0 );
					}	
						
				}
				else { $item_data = array('inum'=>$inum,'skl'=>$skl); $result_qty = 1; }
			} // if($skl_info)
			else // нямало го е в склада ... $skl_info = 0
			{
				if ( $mode=='sale_return' or $mode=='shop_return' or $mode=='online_return')
				{  // ПРИБАВЯНЕ към СКЛАДА и '0'-те ... за всички останали доставки
					if($mode=='sale_return' and !$allow_sizes)
						{ $result_qty = abs($qty); }
					else
						{ $result_qty = $qty; }

					$item_data = array(
						'inum'	=> $inum,
						'skl'		=> $skl,
						'qty'		=> $result_qty,
						'q1'		=> (!$item['q1']) ? '' : $item['q1'],
						'q2'		=> (!$item['q2']) ? '' : $item['q2'],
						'q3'		=> (!$item['q3']) ? '' : $item['q3'],
						'q4'		=> (!$item['q4']) ? '' : $item['q4'],
						'q5'		=> (!$item['q5']) ? '' : $item['q5'],
						'q6'		=> (!$item['q6']) ? '' : $item['q6'],
						'q7'		=> (!$item['q7']) ? '' : $item['q7'],
						'q8'		=> (!$item['q8']) ? '' : $item['q8'],
						'q9'		=> (!$item['q9']) ? '' : $item['q9'],
						'q10'		=> (!$item['q10']) ? '' : $item['q10'],
						'del'		=> 0 );
						
					//само за НОВО Клиента ?! //
					if($client_ShopKey)
					{
						$shop_info = $this->Item->get_shop_info($inum,$client_id_sale);
						if($shop_info)
						{  // UPDATE stock quantity
							$shopQty_1  = (int)$shop_info->q1 - (int)$item['q1'];
							$shopQty_2  = (int)$shop_info->q2 - (int)$item['q2'];
							$shopQty_3  = (int)$shop_info->q3 - (int)$item['q3'];
							$shopQty_4  = (int)$shop_info->q4 - (int)$item['q4'];
							$shopQty_5  = (int)$shop_info->q5 - (int)$item['q5'];
							$shopQty_6  = (int)$shop_info->q6 - (int)$item['q6'];
							$shopQty_7  = (int)$shop_info->q7 - (int)$item['q7'];
							$shopQty_8  = (int)$shop_info->q8 - (int)$item['q8'];
							$shopQty_9  = (int)$shop_info->q9 - (int)$item['q9'];
							$shopQty_10 = (int)$shop_info->q10 - (int)$item['q10'];
						}
						else
						{  // NEW stock quantity
							$shopQty_1  = -(int)$item['q1'];
							$shopQty_2  = -(int)$item['q2'];
							$shopQty_3  = -(int)$item['q3'];
							$shopQty_4  = -(int)$item['q4'];
							$shopQty_5  = -(int)$item['q5'];
							$shopQty_6  = -(int)$item['q6'];
							$shopQty_7  = -(int)$item['q7'];
							$shopQty_8  = -(int)$item['q8'];
							$shopQty_9  = -(int)$item['q9'];
							$shopQty_10 = -(int)$item['q10'];
						}
						
						$result_shop_qty = (int)$shop_info->qty - $qty;
						
						$item_shop_data = array(
							'inum'	=> $inum,
							'skl'		=> $client_id_sale,
							'qty'		=> $result_shop_qty,
							'q1'		=> (!$shopQty_1) ? '' : $shopQty_1,
							'q2'		=> (!$shopQty_2) ? '' : $shopQty_2,
							'q3'		=> (!$shopQty_3) ? '' : $shopQty_3,
							'q4'		=> (!$shopQty_4) ? '' : $shopQty_4,
							'q5'		=> (!$shopQty_5) ? '' : $shopQty_5,
							'q6'		=> (!$shopQty_6) ? '' : $shopQty_6,
							'q7'		=> (!$shopQty_7) ? '' : $shopQty_7,
							'q8'		=> (!$shopQty_8) ? '' : $shopQty_8,
							'q9'		=> (!$shopQty_9) ? '' : $shopQty_9,
							'q10'		=> (!$shopQty_10) ? '' : $shopQty_10,
							'del'		=> 0 );
					}	
						
				}

			}
		
			//------------------------ записва в '_items' на Базите Данни ----------------------------- //
			switch ($mode) 
			{
            case 'sale':  // Експедиция (6)
                     $this->db->insert( $db_sales_items, $sales_items_data);
                     $this->Item->save_sklad($item_data);
                     // отчита ПОРЪЧКА по артикул //
                     $this->Order->save_sale_order($inum, $this->Item->get_item_info($inum)->collection, 
                                 $client_id_sale, $order_sizes, 1);  // 1 - mode=1
                                 
                     //само за НОВО Клиента ?! //
                     if($client_ShopKey)
                        { 
                           $this->db->insert( $db_shops_items, $shops_items_data);
                           $this->Item->save_shop($item_shop_data); 
                        }
                  break;

            case 'sale_return':  // Върната Стока от Клиент (4)
                     $this->db->insert( $db_sales_items, $sales_items_data);
                     $this->Item->save_sklad($item_data);
                     //само за НОВО Клиента ?! //
                     if($client_ShopKey)
                        { 
                           $this->db->insert( $db_shops_items, $shops_items_data);
                           $this->Item->save_shop($item_shop_data); 
                        }
                  break;

            case 'consi_sale':  // Продажба
                     $this->db->insert( $db_sales_items, $sales_items_data);
                     $this->Item->save_sklad($item_data);
                  break;

            // ----------------------------------- МАГАЗИН -> Продава ----------------------------- //
            case 'shop_sale':  // Продажба
                     $this->db->insert( $db_sales_items, $sales_items_data);
                     $this->Item->save_sklad($item_data);
                     // магазини -> изчистване при = 0 работи , но СПРЯНО ============================================ //
                     // if($location>0 and $result_qty==0) {$this->db->delete('sklad',$item_data);}
                  break;

            case 'shop_return':  // Върната Стока от Клиент при Продажба
                     $this->db->insert( $db_sales_items, $sales_items_data);
                     $this->Item->save_sklad($item_data);
                  break;
                  
            // ------------------------------- ОНЛАЙН МАГАЗИН -> Продава -------------------------- //
            case 'online_sale':   // Продажба
                     $this->db->insert( $db_sales_items, $sales_items_data); // годишна База
                     $this->Item->save_sklad($item_data);
                  break;

            case 'online_return':  // Върната Стока от Онлайн Продажба
                     $this->db->insert( $db_sales_items, $sales_items_data); // годишна База
                     $this->Item->save_sklad($item_data);
                  break;
			} // --------------------------- Край на записите в Базите Данни ----------------------//

	}  // foreach($items  ... край на цикъла за артикулите ...
} // if($items)


		if ( $mode != 'shop_sgp' )
		{  // Добавям данни за продажбата ...
			if (!$person_report)
				{
					$mag_data = array(
							'total_qty'			=> $mag_all_qty,
							'total_sum'			=> $mag_total,
							'pay_group'			=> $pay_type,
							'pay_sale'			=> $payK * $mag_total,
							'comment'			=> 'по стойност',
							'location'			=> $location );

					$this->update_items($mag_data, $doc_id, $db_sales);
				}

			// САМО СГП - при намаления на артикулите - корекция на тотал сумата	
			if ($mode=='sale' and $client_status!='onlineto' and $location==0)
				{
					$sgp_data = array(
							'pay_amount' => $sale_total,
							'location'	 => $location );
					$this->update_items($sgp_data, $doc_id, $db_sales);
				}
		}
		

		// само за отчет на консигнатори ... H - дава КАСОВ запис - Росица 3-05-2022г.
		if($mode=='consi_sale' and $location!=0) // ($mode=='shop_sale' or 
		{
         $mag_data = array(
				'pay_sale'			=> $mag_costs,
				'location'			=> $location );
			$this->update_items($mag_data, $doc_id, $db_sales);
		}

		$this->db->trans_complete();
		if ($this->db->trans_status() === FALSE)	{ return -1;}

	return $doc_id;
	}
	

/* ================================= ПОДГОТОВКА ЗА ЕКСПЕДИЦИЯ ================================= */
   function exists_prep($doc_id)
   {
		$this->db->from('suspended');
		$this->db->where('doc_id',$doc_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
   }

	function get_prep_customer($doc_id)
	{
      $customer = 0;
		$this->db->from('suspended');
		$this->db->where('doc_id',$doc_id);
         $query = $this->db->get();
         if($query->num_rows()==1) {$customer = $this->Customer->get_info_by_bisoft_id($query->row()->client_id);}
	return $customer;
	}
	
	function get_prep_items($bisoft_id)
	{
		$this->db->from('suspended_items');
		$this->db->where('client_id',$bisoft_id);
		$this->db->where('mode_id','EE');
	return $this->db->get()->result_array();
	}
	
	function exists_prep_client($bisoft_id)
	{
      $result=0;
      $this->db->from('suspended');
		$this->db->where('client_id',$bisoft_id);
		$this->db->where('mode_id','EE');
		$query = $this->db->get();
         if($query->num_rows()==1) { $result=1; }
	return $result;
	}
	
	function get_prep_info($bisoft_id)
	{
      $doc_info=array();
      $this->db->from('suspended');
		$this->db->where('client_id',$bisoft_id);
		$this->db->where('mode_id','EE');
		$query = $this->db->get();
         if($query->num_rows()==1) 
            { foreach($query->result_array() as $doc) 
               {
                  $doc_info=array(
                     'doc_id' => $doc['doc_id'],
                     'doc_number' => $doc_num=$doc['doc_number']); 
               } 
            }
	return $doc_info;
	}	

	
	function delete($doc_id,$vedomPack)
	{
		$this->db->trans_start();
			$this->db->delete( $vedomPack.'_items', array('doc_id' => $doc_id));
			$this->db->delete( $vedomPack, array('doc_id' => $doc_id)); 
		$this->db->trans_complete();
	return $this->db->trans_status();
	}


	function delete_line_item($doc_num, $line)
	{
		$vedomPack = 'V'.substr($doc_num,0,4).'_items';
		$this->db->trans_start();
			$this->db->delete( $vedomPack, array('doc_number' => $doc_num, 'line' => $line));
		$this->db->trans_complete();
	return $this->db->trans_status();
	}


	function get_sale_items($doc_id,$vedomPack)
	{
		$this->db->from($vedomPack.'_items');
		$this->db->where('doc_id',$doc_id);
		$this->db->where('deleted',0);
	return $this->db->get();
	}

	function get_sale_payments($doc_id,$vedomPack)
	{
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
	return $this->db->get();
	}

	function get_customer($doc_id,$vedomPack)
	{
      $customer = 0;
		$this->db->from($vedomPack);
		$this->db->where('doc_id',$doc_id);
         $query = $this->db->get();
         if($query->num_rows()==1) {$customer = $this->Customer->get_info($query->row()->client_id);}
	return $customer;
	}


/* ------------------------------------------ other ----------------------------- */
	public function get_document_title($mode)
	{
		$receipt_title = $this->lang->line('sales_receipt');
		switch ($mode) 
			{
				case 'sale':	 		$receipt_title = $this->lang->line('sales_receipt_sale');			break;
				case 'sale_return':	$receipt_title = $this->lang->line('sales_receipt_return_sale');	break; 
				case 'consi':	 		$receipt_title = $this->lang->line('sales_receipt_consi');			break;
				case 'consi_sale':	$receipt_title = $this->lang->line('sales_receipt_consi_sale');	break;
				case 'consi_return':	$receipt_title = $this->lang->line('sales_receipt_return_consi');	break;
				case 'online_sale':	$receipt_title = $this->lang->line('sales_online_sale');				break;
				case 'online_return':$receipt_title = $this->lang->line('sales_online_return');			break;
				case 'invoice': 		$receipt_title = $this->lang->line('sales_receipt_invoice');		break;
				case 'invoice_ki':	$receipt_title = $this->lang->line('sales_receipt_invoice_ki');	break;
				case 'invoice_di':	$receipt_title = $this->lang->line('sales_receipt_invoice_di');	break;
				case 'invoice_pr':	$receipt_title = $this->lang->line('sales_receipt_invoice_pr');	break;
				default: 				$receipt_title = $this->lang->line('sales_receipt');
			}
	return $receipt_title;
	}

	public function get_document($mode)
	{
		$doc_number = 'doc-1';
			switch ($mode) 
				{
				case 'sale':	 		$doc_number = date('ym').'600000';  break;
				case 'sale_return':	$doc_number = date('ym').'400000';  break; 
				case 'consi':	 		$doc_number = date('ym').'700000';  break;
				case 'consi_sale':	$doc_number = date('ym').'800000';  break; 
				case 'consi_return':	$doc_number = date('ym').'500000';  break;
				case 'online_sale':	$doc_number = date('ym').'600000';  break;
				case 'online_return':$doc_number = date('ym').'400000';  break;
				case 'invoice': 		$doc_number = '0';  break;
				case 'invoice_ki': 	$doc_number = '0';  break;
				case 'invoice_di': 	$doc_number = '0';  break;
				case 'invoice_pr': 	$doc_number = '0';  break;
				default: 				$doc_number = 'doc-1';
				}
	return $doc_number;
	}


	function get_db_sales_payments_location($mode='sale')
	{
		$location = $this->Employee->get_logged_in_employee_info()->location;
		$vedom = $this->BiSOFT_Model->get_vedom();
		$db_sales_payments = $vedom . 'sales';
	return $db_sales_payments;
	}


	function get_db_sales_temp_location($mode='sale')
	{
		$vedom = $this->config->item('vedom_pack');
		$db_sales_temp = $vedom . '_sales';
		return $db_sales_temp;
	}

	
// ======================================== SPECIAL FUNCTIONS for Locator =============================

	function get_db_sales_location()
	{ return 'V'.date('ym');}

	
	function get_db_sales_items_location()
	{ $db_sales = $this->get_db_sales_location(); return $db_sales . '_items';}

}
?>
