<?php class Subcont extends Person
{	
	function exists($person_id)
	{
		$this->db->from('subconts');	
		$this->db->join('people', 'people.person_id = subconts.person_id');
		$this->db->where('subconts.person_id',$person_id);
		$query = $this->db->get();
		return ($query->num_rows()==1);
	}
	
	function account_number_exists($account_number)
	{
		$this->db->from('subconts');	
		$this->db->where('subconts.account_number',$account_number);
		$query = $this->db->get();
		return ($query->num_rows()==1);
	}

	function bisoft_id_exists($bisoft_id)
	{
		$this->db->from('subconts');	
		$this->db->where('subconts.bisoft_id',$bisoft_id);
		$query = $this->db->get();
		return ($query->num_rows()==1);
	}


	function get_max_bisoft_id()
	{
		$this->db->select('max(bisoft_id) as max_bisoft', false);
		$this->db->from('subconts');
		$rezult = $this->db->get()->result_array();
	return $rezult['0']['max_bisoft'];
	}


	function get_all($limit=10000, $offset=0)
	{
		$this->db->from('subconts');
		$this->db->join('people','subconts.person_id=people.person_id');			
		$this->db->where('deleted',0);
		$this->db->order_by("company_name", "asc");
		$this->db->limit($limit);
		$this->db->offset($offset);
		return $this->db->get();		
	}
	
	function get_all_subcaonts()
	{
		$this->db->from('subconts');
		$this->db->join('people','subconts.person_id=people.person_id');			
		$this->db->where('deleted',0);
		$this->db->where('status','subcont');
		$this->db->order_by("company_name", "asc");
		return $this->db->get();		
	}

	
	function get_all_top()
	{
		$this->db->from('subconts');
		$this->db->join('people','subconts.person_id=people.person_id');			
		$this->db->where('deleted',0);
		$this->db->order_by("company_name", "asc");
		return $this->db->get();		
	}
	
	function get_dropdown_1()
	{
		$this->db->from('subconts');
		$this->db->where('rating > 50');
		$this->db->where('deleted',0);
		$this->db->order_by("company_name", "asc");
	return $this->db->get();		
	}
	
	function get_dropdown_2()
	{
		$this->db->from('subconts');
		$this->db->where('rating > 0 AND rating <= 50');
		$this->db->where('deleted',0);
		$this->db->order_by("company_name", "asc");
	return $this->db->get();		
	}
	
	function count_all()
	{
		$this->db->from('subconts');
		$this->db->where('deleted',0);
		return $this->db->count_all_results();
	}

	function get_info($supplier_id)
	{
		$this->db->from('subconts');	
		$this->db->join('people', 'people.person_id = subconts.person_id');
		$this->db->where('subconts.person_id',$supplier_id);
		$query = $this->db->get();
		
		if($query->num_rows()==1)
		{ return $query->row();}
		else
		{  $person_obj=parent::get_info(-1);
			$fields = $this->db->list_fields('subconts');
			foreach ($fields as $field) { $person_obj->$field='';}
			return $person_obj;
		}
	}
	
	function get_multiple_info($supplier_ids)
	{
		$this->db->from('subconts');
		$this->db->join('people', 'people.person_id = subconts.person_id');		
		$this->db->where_in('subconts.person_id',$supplier_ids);
		$this->db->order_by("company_name", "asc");
		return $this->db->get();		
	}
	
	function get_info_by_bisoft_id($bisoft_id)
	{
		$this->db->from('subconts');	
		$this->db->where('subconts.bisoft_id',$bisoft_id);
		$query = $this->db->get();
		if($query->num_rows()==1) { return $query->row();}
		else { return false;}			
	}

	function get_supplier_name($bisoft_id)
	{
		$this->db->from('subconts');
		$this->db->where('subconts.bisoft_id',$bisoft_id);
		$this->db->where('deleted',0);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row()->company_name;}
		else	{return '';}	
	}

	function save(&$person_data, &$supplier_data,$supplier_id=false)
	{
		$success=false;
		$this->db->trans_start();
		
		if(parent::save_person($person_data,$supplier_id))
		{
			if (!$supplier_id or !$this->exists($supplier_id))
			{
				$supplier_data['person_id'] = $person_data['person_id'];
				$success = $this->db->insert('subconts',$supplier_data);				
			}
			else
			{
				$this->db->where('person_id', $supplier_id);
				$success = $this->db->update('subconts',$supplier_data);
			}
			
		}
		
		$this->db->trans_complete();		
		return $success;
	}

	function delete($supplier_id)
	{
		$this->db->where('person_id', $supplier_id);
		return $this->db->update('subconts', array('deleted' => 1));
	}

	function delete_list($supplier_ids)
	{
		$this->db->where_in('person_id',$supplier_ids);
		return $this->db->update('subconts', array('deleted' => 1));
 	}

	function get_search_suggestions($search,$limit=25)
	{
		$suggestions = array();

		$this->db->from('subconts');
		$this->db->join('people','subconts.person_id=people.person_id');	
		$this->db->where('deleted', 0);
		$this->db->like("company_name",$search);
		$this->db->order_by("company_name", "asc");		
		$by_company_name = $this->db->get();
		foreach($by_company_name->result() as $row)
			{ $suggestions[]=$row->company_name;}

		if(count($suggestions > $limit)) { $suggestions = array_slice($suggestions, 0,$limit);}
		return $suggestions;
	
	}

	
	function get_supplier_search_suggestions($search,$limit=25)
	{
		$suggestions = array();
		$this->db->from('subconts');
		$this->db->join('people','subconts.person_id=people.person_id');	
		$this->db->where('deleted', 0);
		$this->db->like("company_name",$search);
		$this->db->order_by("company_name", "asc");		
		$by_company_name = $this->db->get();
		foreach($by_company_name->result() as $row)
         { $suggestions[]=$row->person_id.'|'.$row->company_name.' <i>('.$row->first_name.' '.$row->last_name.')</i>';}

		$this->db->from('subconts');
		$this->db->join('people','subconts.person_id=people.person_id');	
		$this->db->where("(first_name LIKE '%".$this->db->escape_like_str($search)."%' or 
		last_name LIKE '%".$this->db->escape_like_str($search)."%' or 
		CONCAT(`first_name`,' ',`last_name`) LIKE '%".$this->db->escape_like_str($search)."%') and deleted=0");
		$this->db->order_by("last_name", "asc");		
		$by_name = $this->db->get();
		foreach($by_name->result() as $row)
		 { $suggestions[]=$row->person_id.'|'.$row->company_name.' <i>('.$row->first_name.' '.$row->last_name.')</i>';}

		if(count($suggestions) > $limit)
       { $suggestions = array_slice($suggestions, 0,$limit);}
		return $suggestions;
	}

	
	function search($search)
	{
		$this->db->from('subconts');
		$this->db->join('people','subconts.person_id=people.person_id');		
		$this->db->where("(first_name LIKE '%".$this->db->escape_like_str($search)."%' or 
		last_name LIKE '%".$this->db->escape_like_str($search)."%' or 
		company_name LIKE '%".$this->db->escape_like_str($search)."%' or 
		CONCAT(`first_name`,' ',`last_name`) LIKE '%".$this->db->escape_like_str($search)."%') and deleted=0");		
		$this->db->order_by("last_name", "asc");
		return $this->db->get();
	}

}
?>
