<?php class Suspended extends CI_Model
{
	function get_all()
	{
      $location = $this->BiSOFT_Model->get_location();
		$this->db->from('suspended');
		$this->db->where('location',$location);
		$this->db->order_by('doc_id');
		return $this->db->get();
	}
	
	public function get_info($doc_id)
	{
		$this->db->from('suspended');
		$this->db->where('doc_id',$doc_id);
		return $this->db->get();
	}

	function exists($doc_id)
	{
		$this->db->from('suspended');
		$this->db->where('doc_id',$doc_id);
		$query = $this->db->get();
      return ($query->num_rows()==1);
	}
	
	function update($sale_data, $doc_id)
	{
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update('suspended',$sale_data);
		return $success;
	}
	
	

	function save( $items, $mode, $all_qty, $subtotal, $doc_number, $doc_name,
						$bisoft_id, $customer_discount, $employee_id, $taxed, $order_No, $order_date, $comment)
	{
		if(count($items)==0) {return -1;}
		if(null===$mode) { $mode='sale'; }
		$doc_id = false;

		// Определяме къде се намират DB за пълнене ...
		$location = $this->BiSOFT_Model->get_location();
		$vedom	 = $this->BiSOFT_Model->get_vedom();
		$items_type = '_items';
		
         $db_sales = 'V'.date('ym', strtotime( $this->BiSOFT_Model->get_user_mode_date() ));
			$db_sales_items 			= $db_sales . '_items';
			$db_sales_payments 		= $db_sales;
	    	$db_suspended = 'suspended';
			$db_suspended_items = $db_suspended . $items_type;

		//Зареждаме данни за Базата с Покупката ...
		$doc_date 	= date('Y-m-d');
		if($order_date) {$doc_date=$order_date;}
		$doc_name	= $this->BiSOFT_Model->get_document_title($mode);	 // това си е вече заглавието...
		$mode_id 	= $this->BiSOFT_Model->get_pay_group($mode);			 // index-a 'Е', 'P' ..

		//Изчисляване плащането и групата за плащане .. index-a
		$pay_groups = '';
		$payment_types ='';
		$total_sum = $subtotal;
		$total_qty = $all_qty;
		$pay_type = 'H';

		$client_name 	= '';
		if ( $bisoft_id != 0 )
		{
			if ( $mode=='consi_sale' )
				{ $client_name = $this->Consignee->get_info_by_bisoft_id($bisoft_id)->company_name;}
			else
				{ $client_name = $this->Customer->get_info_by_bisoft_id($bisoft_id)->company_name;}
		}

		$employee_name	=	$this->Employee->get_info($employee_id)->first_name .' '. 
								$this->Employee->get_info($employee_id)->last_name;

		// изчисляваме ДДС-то ......
		$this->load->library('sale_lib');
		$mode_price = $this->sale_lib->get_mode_price();

		$invoice_export = 0;
		if ($mode_price == 101) { $invoice_export = 1; $pay_type = 'Ex';}
		if ($mode_price == 102) { $invoice_export = 2; $pay_type = 'ExV';}

		$tax_VAT 	= 0;
		// $taxed	= 0;
		if($mode_price == 100 or $mode_price == 102) { $taxed = 1;}  // vat=100, export_vat 102
		else { $taxed	= 0;}

		$total_discount = $customer_discount;

		if ( $mode == 'invoice' or $mode == 'invoice_ki' or $mode == 'invoice_di' or $mode == 'invoice_pr' 
			or $mode == 'proforma' )
			{ 
				$total_amount = $subtotal;
				$total_discount = 0 ;

				if ( $taxed == 1 )
					{ $tax_VAT 	= round( 20 * $subtotal / 100 , 4);}
				else
					{ $tax_VAT 	= 0;}
			}
		else
			{  $total_amount 	= round($subtotal * (100 - $customer_discount)/100, 2);
				$tax_VAT 		= 0;
			}

		$total_amount += $tax_VAT;

		if($invoice_export == 1) { $comment = $comment . $this->lang->line('sales_export_no_vat');}
		if($invoice_export == 2) { $comment = $comment . $this->lang->line('sales_export_vat');}
		if($pay_type == 'Of') { $comment = $comment . $this->lang->line('sales_offer_price').': '.$mode_price.'гр.';}
		

		// знаците на totals ...
		if ($mode=='sale' or $mode=='shop_sale')
			{ 
				$total_sum = abs($subtotal);
			}
		elseif ($mode=='sale_return' or $mode=='shop_return') // върната стока като цяло ...
			{ 
				$total_qty 		= -abs($total_qty);
				$total_sum 		= -abs($subtotal);
				$total_amount 	= -abs($total_amount);
			}
		else // за фактури.
			{ $total_sum = $subtotal;}


		// зареждам основните параметри на Главния документ ......
		$sales_data = array(
				'mode'				=> $mode,
				'mode_id'			=> $mode_id,
				'doc_number'		=> $doc_number,
				'doc_date' 			=> $doc_date,
				'total_qty'			=> $all_qty,
				'total_sum'			=> $subtotal,
				'total_discount'	=> $total_discount,
				'taxed'				=> $taxed,
				'total_taxes'		=> $tax_VAT,
				'pay_group'			=> $pay_type,
				'pay_type'			=> $payment_types,
				'pay_amount'		=> $total_amount,
				'client_id'			=> $bisoft_id,
				'client'				=> $client_name,
				'order_id'			=> $order_No,
				'employee_id'		=> $employee_id,
				'employee'			=> $employee_name,
				'comment'			=> $comment,
				'location'			=> $location );


		//Run these queries as a transaction, we want to make sure we do all or nothing
		$this->db->trans_start();
			$this->db->insert( $db_suspended, $sales_data );
			$doc_id = $this->db->insert_id();
      $this->db->trans_complete();

		// започва да сканира количката за всеки един артикул ...
		foreach($items as $line=>$item)
		{
         $inum=$item['inum'];$skl=$item['skl'];$mode_price=$item['mprice'];
         $inv_name  = (isset($item['inv'])) ? $item['inv'] : '';
         $skl_info  = $this->Item->get_sklad_info($inum,$skl);
         $item_info = $this->Item->get_blanka_info($inum);
            $name = $this->Item->get_name($inum);
            $allow_sizes=$item_info->allow_sizes;
            if($allow_sizes=='105') {$allow_sizes=0;}

         $Qty=array();
         $qty=$item['qty'];
         if ($allow_sizes)
         {
            $Qty[1] = (!$item['q1']) ? '' : $item['q1'];
            $Qty[2] = (!$item['q2']) ? '' : $item['q2'];
            $Qty[3] = (!$item['q3']) ? '' : $item['q3'];
            $Qty[4] = (!$item['q4']) ? '' : $item['q4'];
            $Qty[5] = (!$item['q5']) ? '' : $item['q5'];
            $Qty[6] = (!$item['q6']) ? '' : $item['q6'];
            $Qty[7] = (!$item['q7']) ? '' : $item['q7'];
            $Qty[8] = (!$item['q8']) ? '' : $item['q8'];
            $Qty[9] = (!$item['q9']) ? '' : $item['q9'];
            $Qty[10] = (!$item['q10']) ? '' : $item['q10'];
         }
         else { $Qty[1]=$Qty[2]=$Qty[3]=$Qty[4]=$Qty[5]=$Qty[6]=$Qty[7]=$Qty[8]=$Qty[9]=$Qty[10]=''; }		

			$suspended_data = array(
				'doc_id'			=> $doc_id,
				'line'			=> $item['line'],
				'mode_id' 		=> $mode_id,
				'doc_number' 	=> $doc_number,
				'doc_date' 		=> $doc_date,
				'item_number'	=> $inum,
				'item_qty'     => $qty,
				'item_name'		=> $qty.','.$Qty[1].','.$Qty[2].','.$Qty[3].','.$Qty[4].','.$Qty[5].','.
										$Qty[6].','.$Qty[7].','.$Qty[8].','.$Qty[9].','.$Qty[10],
										
            'invoice_name' => $inv_name,
			'item_unit_price'	=> $item['price'],
			'item_discount'	=> $item['dsc'],
				'item_taxes'	=> $taxed,
				'order_id'		=> $order_No,
				'mode_price'   => $mode_price,
				'costsale' 		=> 0,
				'client_id'		=> $bisoft_id,
				'supplier_id'	=> 0,
				'location'		=> $location );

         $this->db->trans_start();
            $this->db->insert( $db_suspended_items, $suspended_data );
			$this->db->trans_complete();
			
         // ======== ОТНЕМАНЕ от СКЛАДА и '0'-те ==================== //
			$result_qty = 0;
			if ( $mode=='prep_sale' )
			{	//Update stock quantity
				$item_data = array(
					'inum'	=> $inum,
					'skl'		=> $skl,
					'qty'		=> $skl_info->qty - $qty,
					'q1'		=> ($skl_info->q1-$Qty[1]!=0) ? $skl_info->q1-$Qty[1] : '',
					'q2'		=> ($skl_info->q1-$Qty[2]!=0) ? $skl_info->q1-$Qty[2] : '',
					'q3'		=> ($skl_info->q1-$Qty[3]!=0) ? $skl_info->q1-$Qty[3] : '',
					'q4'		=> ($skl_info->q1-$Qty[4]!=0) ? $skl_info->q1-$Qty[4] : '',
					'q5'		=> ($skl_info->q1-$Qty[5]!=0) ? $skl_info->q1-$Qty[5] : '',
					'q6'		=> ($skl_info->q1-$Qty[6]!=0) ? $skl_info->q1-$Qty[6] : '',
					'q7'		=> ($skl_info->q1-$Qty[7]!=0) ? $skl_info->q1-$Qty[7] : '',
					'q8'		=> ($skl_info->q1-$Qty[8]!=0) ? $skl_info->q1-$Qty[8] : '',
					'q9'		=> ($skl_info->q1-$Qty[9]!=0) ? $skl_info->q1-$Qty[9] : '',
					'q10'		=> ($skl_info->q1-$Qty[10]!=0) ? $skl_info->q1-$Qty[10] : '',
					'del'		=> 0 );
			$this->Item->save_sklad($item_data);
         }
		}  // край на цикъла за артикулите ...

		if ($this->db->trans_status() === FALSE) 
			{ return -1;}

	return $doc_id;
	}
	
	
	function save_invoice( $items, $mode, $all_qty, $subtotal, $doc_number, $doc_name,
								  $bisoft_id, $customer_discount, $employee_id, $payments, $comment)
	{
		if(count($items)==0) {return -1;}
		$doc_id = false;

		// Определяме къде се намират DB за пълнене ...
		$location = $this->BiSOFT_Model->get_location();
		$vedom	 = $this->BiSOFT_Model->get_vedom();
		$items_type = '_items';
	    	$db_suspended = 'suspended';
			$db_suspended_items = $db_suspended . $items_type;

		//Зареждаме данни за Базата с Покупката ...
		$doc_date 	= date('Y-m-d');
		$doc_name	= $this->BiSOFT_Model->get_document_title($mode);	 // това си е вече заглавието...
		$mode_id 	= $this->BiSOFT_Model->get_pay_group($mode);			 // index-a 'Е', 'P' ..

				//Изчисляване плащането и групата за плащане .. index-a
				$pay_groups = '';
				$payment_types ='';
				$total_sum = 0;
				$total_qty = 0;

				$payK = 1;
				foreach($payments as $payment_id=>$payment)
					{
						$pay_groups 	= $payment['payment_type'];			
						$payment_types	= $payment_types.$payment['payment_type'].': '.
											to_currency($payK * $payment['payment_amount']).';';
						$total_sum	+=	$payment['payment_amount'];
					}
				$total_sum_text = to_currency($total_sum);

				//Разпределяме коеф.-те на index-ите на плащане за покупката ..
				$pay_type = 'H';
				switch ($pay_groups) 
					{
						case $this->lang->line('sales_not_paid'):	$pay_type = 'H';  break;
						case $this->lang->line('sales_returned_goods'): $pay_type = 'BP';  break;
						case $this->lang->line('sales_cash'): 		$pay_type = 'P';  break;
						case $this->lang->line('sales_by_bank'):	$pay_type = 'T';  break; 
						case $this->lang->line('sales_check'):		$pay_type = 'Ch'; break; 
						case $this->lang->line('sales_debit'):		$pay_type = 'dC'; break;
						case $this->lang->line('sales_credit'):	$pay_type = 'kC'; break;
						case $this->lang->line('sales_epay'):		$pay_type = 'eP'; break; 
						case $this->lang->line('sales_paypal'):	$pay_type = 'PP'; break;
						case $this->lang->line('sales_offer_price'):	$pay_type = 'Of'; break;

						default: 	$pay_type = 'H';
					}

		// зареждаме имената на Клиента и Оператора ......
		// $bisoft_id = $this->Customer->exists($customer_id) ? $customer_id : '';
		$client_name 	= '';
		if ( $bisoft_id != 0 )
			{ $client_name = $this->Customer->get_info_by_bisoft_id($bisoft_id)->company_name;}

		$employee_name	=	$this->Employee->get_info($employee_id)->first_name .' '. 
								$this->Employee->get_info($employee_id)->last_name;

		// изчисляваме ДДС-то ......
		$this->load->library('sale_lib');
		$mode_price = $this->sale_lib->get_mode_price();

		$invoice_export = 0;
		if ($mode_price == 101) { $invoice_export = 1; $pay_type = 'Ex';}
		if ($mode_price == 102) { $invoice_export = 2; $pay_type = 'ExV';}

		$tax_VAT 	= 0;
		$taxed	 	= 0;
		if($mode_price == 100 or $mode_price == 102) { $taxed = 1;}  // vat=100, export_vat 102
		else { $taxed	= 0;}

		$total_discount = $customer_discount;
		$total_amount = $subtotal;
		$total_discount = 0 ;
		if ( $taxed == 1 )
			{ $tax_VAT 	= round( 20 * $subtotal / 100 , 4);}
		else
			{ $tax_VAT 	= 0;}

		$total_amount += $tax_VAT;

		if($invoice_export == 1) { $comment = $comment . $this->lang->line('sales_export_no_vat');}
		if($invoice_export == 2) { $comment = $comment . $this->lang->line('sales_export_vat');}
		if($pay_type == 'Of') { $comment = $comment . $this->lang->line('sales_offer_price').': '.$mode_price.'гр.';}
		$total_sum = $subtotal;

		// зареждам основните параметри на Главния документ ......
		$sales_data = array(
				'mode'				=> $mode,
				'mode_id'			=> $mode_id,
				'doc_number'		=> $doc_number,
				'doc_date' 			=> $doc_date,
				'total_qty'			=> $all_qty,
				'total_sum'			=> $subtotal,
				'total_discount'	=> $total_discount,
				'taxed'				=> $taxed,
				'total_taxes'		=> $tax_VAT,
				'pay_group'			=> $pay_type,
				'pay_type'			=> $payment_types,
				'pay_amount'		=> $total_amount,
				'client_id'			=> $bisoft_id,
				'client'				=> $client_name,
				'employee_id'		=> $employee_id,
				'employee'			=> $employee_name,
				'comment'			=> $comment,
				'location'			=> $location );

		//Run these queries as a transaction, we want to make sure we do all or nothing
		$this->db->trans_start();
			$this->db->insert( $db_suspended, $sales_data );
			$doc_id = $this->db->insert_id();

		// започва да сканира количката за всеки един артикул ...
		foreach($items as $line=>$item)
		{
			$item_info = $this->Item->get_info_invoice($item['id']);
			$item_number = $item_info->item_number;

			$sales_items_data = array(
						'doc_id'			=> $doc_id,
						'item_id'		=> $item['id'],
						'line'			=> $item['line'],
						'mode_id' 		=> $mode_id,
						'doc_number' 	=> $doc_number,
						'doc_date' 		=> $doc_date,
						'item_number'	=> $item_number,
						'item_name'		=> $item['name'],
						'item_qty'		=> $item['qty'],
					'item_unit_price'	=> $item['price'],
					'item_discount'	=> $item['disc'],
						'item_taxes'	=> $taxed,
						'client_id'		=> $bisoft_id,
						'client'			=> $client_name,
						'location'		=> $location );

			$this->db->insert( $db_suspended_items, $sales_items_data );
		}  // край на цикъла за артикулите ...

		$this->db->trans_complete();
		if ($this->db->trans_status() === FALSE) 
			{ return -1;}
		
	return $doc_id;
	}

	
	function delete($doc_id)
	{
		$this->db->trans_start();
			$this->db->delete( 'suspended_items', array('doc_id' => $doc_id)); 
			$this->db->delete( 'suspended', array('doc_id' => $doc_id)); 
		$this->db->trans_complete();
	return $this->db->trans_status();
	}


	function get_sale_items($doc_id)
	{
      if($this->exists($doc_id))
      {
         $this->db->from('suspended_items');
         $this->db->where('doc_id',$doc_id);
         $this->db->where('deleted',0);
         return $this->db->get();
      }
      else {return false;}
	}

	function get_sale_payments($doc_id)
	{
      if($this->exists($doc_id))
      {
         $this->db->from('suspended');
         $this->db->where('doc_id',$doc_id);
         return $this->db->get()->row()->pay_type;
      }
      else {return false;}
	}

	function get_customer($doc_id)
	{
      if($this->exists($doc_id))
      {
         $this->db->from('suspended');
         $this->db->where('doc_id',$doc_id);
         return $this->db->get()->row()->client_id;
      }
      else {return false;}
	}
	
	function get_mode($doc_id)
	{
      if($this->exists($doc_id))
      {
         $this->db->from('suspended');
         $this->db->where('doc_id',$doc_id);
         return $this->db->get()->row()->mode;
      }
      else {return false;}
	}
	
	function get_order($doc_id)
	{
      if($this->exists($doc_id))
      {
         $this->db->from('suspended');
         $this->db->where('doc_id',$doc_id);
         return $this->db->get()->row()->order_id;
      }
      else {return false;}
	}
	
	function get_order_date($doc_id)
	{
      if($this->exists($doc_id))
      {
         $this->db->from('suspended');
         $this->db->where('doc_id',$doc_id);
         return $this->db->get()->row()->doc_date;
      }
      else {return false;}
	}
	
	function get_mode_id($doc_id)
	{
      if($this->exists($doc_id))
      {
         $this->db->from('suspended');
         $this->db->where('doc_id',$doc_id);
         return $this->db->get()->row()->mode_id;
      }
      else {return false;}
	}

	function get_comment($doc_id)
	{
      if($this->exists($doc_id))
      {
         $this->db->from('suspended');
         $this->db->where('doc_id',$doc_id);
         return $this->db->get()->row()->comment;
      }
      else {return false;}
	}

}
?>
