<?php class TRZ extends Person 
{
	function exists($person_id)
	{
		$this->db->from('employees');	
		$this->db->join('people', 'people.person_id = employees.person_id');
		$this->db->where('employees.person_id',$person_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}

	function get_all($limit=200, $offset=0)
	{
		$this->db->from('employees');
		$this->db->where('deleted',0);
		$this->db->where('job_id > 0');	// само хора от фирмата със служебен код ...
		$this->db->join('people','employees.person_id=people.person_id');			
		$this->db->order_by("first_name", "asc");
		$this->db->limit($limit);
		$this->db->offset($offset);
	return $this->db->get();		
	}

	function get_all_class_id($class_id='all',$firma=1,$limit=200, $offset=0)
	{
		$this->db->from('employees');
		$this->db->where('firma', $firma);
		$this->db->where('job_id > 0');	// само хора от фирмата със служебен код ...
		$this->db->where('deleted = 0');
		$this->db->join('people','employees.person_id=people.person_id');
		$this->db->where('egn_id > 0');
			
		switch($class_id) 
		{
			case 'all':		  $this->db->where("norma in ('1','5','7','8','9')"); break;
			case 'admins':   $this->db->where("norma in ('1', '9')"); break;
			case 'workers':  $this->db->where("norma in ('5', '7', '8')"); break;
			case 'shoppers': $this->db->where('norma', '3'); break;
			case 'fired': 	  $this->db->where('norma', '0'); break;
			case 'others':   $this->db->where("norma in ('2','4','6')"); break;
		}

		$this->db->order_by("first_name", "asc");
		$this->db->limit($limit);
		$this->db->offset($offset);
		return $this->db->get();
	}	
	
	function count_all()
	{
		$this->db->from('employees');
		$this->db->where('deleted',0);
		return $this->db->count_all_results();
	}

	function get_info($employee_id)
	{
		$this->db->from('employees');	
		$this->db->join('people', 'people.person_id = employees.person_id');
		$this->db->where('employees.person_id',$employee_id);
		$query = $this->db->get();
		
		if($query->num_rows()==1)
		{ return $query->row(); }
		else
		{
			$person_obj=parent::get_info(-1);
			$fields = $this->db->list_fields('employees');

			foreach ($fields as $field)
			{ $person_obj->$field=''; }
			
		return $person_obj;
		}
	}
	
	function get_multiple_info($employee_ids)
	{
		$this->db->from('employees');
		$this->db->join('people', 'people.person_id = employees.person_id');		
		$this->db->where_in('employees.person_id',$employee_ids);
		$this->db->order_by("first_name", "asc");
	return $this->db->get();	
	}
	
	function get_info_bisoft_id($bisoft_id)
	{
		$this->db->from('employees');	
		$this->db->where('bisoft_id',$bisoft_id);
		$query = $this->db->get();
		if($query->num_rows()==1) { return $query->row();}
		else { return 0;}
	}

	function save_bisoft_id($person_data,$bisoft_id)
	{
		$success=false;
		$this->db->trans_start();

			$this->db->where('bisoft_id', $bisoft_id);
			$success = $this->db->update('employees',$person_data);
	
		$this->db->trans_complete();		
	return $success;
	}
	
//====================================== ТРЗ VEDOM =============================== //
	function exists_trz($bisoft_id,$vedom,$period)
	{
		$result=0;
		if($this->db->table_exists($vedom))
		{
			$this->db->from($vedom);	
			$this->db->where('bisoft_id',$bisoft_id);
			$this->db->where('period',$period);
			$query = $this->db->get();
			if($query->num_rows()==1) {$result=1;}
		}
	return $result;
	}	

	function get_info_trz($bisoft_id,$vedom,$period)
	{
		if($bisoft_id==-1) { return 0;}
		$result=0;
		if($this->db->table_exists($vedom))
		{
			$this->db->from($vedom);	
			$this->db->where('bisoft_id',$bisoft_id);
			$this->db->where('period',$period);
			$this->db->where('deleted',0);
			$query = $this->db->get();
			if($query->num_rows()==1) { return $query->row();}
			else { return 0;}
		}
		else
		{ return 0; }
	}

	function get_day_trzved($bisoft_id,$vedom,$period)
	{
		$result=0;
		if($this->db->table_exists($vedom))
		{
			if($bisoft_id==-1) { return 0;}
			$this->db->from($vedom);	
			$this->db->where('bisoft_id',$bisoft_id);
			$this->db->where('period',$period);
			$this->db->where('deleted',0);
			$query = $this->db->get();
			if($query->num_rows()==1) { return $query->row()->PM;}
			else { return 0;}
		}
		else
		{ return 0; }
	}

	function get_total_trz($period)
	{
		$vedom = 'T'.$period;
		$this->db->select('	
				sum(Avance) as avance, 
				sum(Salary) as salary',	false);
		if($this->db->table_exists($vedom))
		{
			$this->db->from($vedom);	
			$this->db->where('period',$period);
			$this->db->where('deleted',0);
			$query = $this->db->get();
			if($query->num_rows()==1) { return $query->row();}
			else { return false;}
		}
		else
		{ return false; }
	}	
	
	
	function save_work(&$trz_data,$bisoft_id,$vedom,$period)
	{
		$success=false;
		$this->db->trans_start();

			if (!$bisoft_id or !$this->exists_trz($bisoft_id,$vedom,$period))
			{ $success = $this->db->insert($vedom,$trz_data); }
			else
			{
				$this->db->where('bisoft_id', $bisoft_id);
				$this->db->where('period',$period);
				$success = $this->db->update($vedom,$trz_data);
			}
	
		$this->db->trans_complete();		
	return $success;
	}
	

	function get_vedom_presence($bisoft_id,$vedom,$period)
	{
		if($bisoft_id==-1) { return 0;}
		$days_Pre = array();
		$month = (int) substr($vedom,3,2);
		$year  = (int) substr($vedom,1,2);
		$m_limit = $this->BiSOFT_Model->get_month_limit($month,$year);
		
		$all_data = $this->get_day_trzved($bisoft_id,$vedom,$period);
		if($all_data) 
		{
			$data_PR = json_decode($all_data);
			for($k=1;$k<=$m_limit;$k++)
				{
					if(isset($data_PR->$k))
						{ $days_Pre[$k] = $data_PR->$k;}
					else
						{ echo '<b style="color:red;font-size:200%">ERROR: # '.$bisoft_id.'</b>
								 <br>Грешно въведени данни във ведомост ПРИСЪСТВИЕ ?!<br>';die();
						}
				}
		}
		else // празен месец
		{
			for($k=1;$k<=$m_limit;$k++)
				{ $days_Pre[$k] = '';}
		}

	return $days_Pre;	
	}
	

	function get_all_presence($bisoft_id,$vedom)
	{
		if($bisoft_id==-1) { return 0;}
		$days_Pre = array();
		$month = (int) substr($vedom,3,2);
		$year  = (int) substr($vedom,1,2);
		$m_limit = $this->BiSOFT_Model->get_month_limit($month,$year);
		$period_R = substr($vedom,1,4);
		
		for($k=1;$k<=$m_limit;$k++) 
		{
		  $period = $period_R.str_pad($k,2,"0",STR_PAD_LEFT);
		  $pre = isset($this->get_info_trz($bisoft_id,$vedom,$period)->Pre) ? round($this->get_info_trz($bisoft_id,$vedom,$period)->Pre/60,1) : 0;
		  if(!$pre) {$pre = '';}
		  $days_Pre[] = $pre;
		}
	
	return $days_Pre;	
	}
	

	function get_all_effect($bisoft_id,$vedom)
	{
		if($bisoft_id==-1) { return 0;}
		$days_Effect = array();
		$month = (int) substr($vedom,3,2);
		$year  = (int) substr($vedom,1,2);
		$day_limit = $this->BiSOFT_Model->get_month_limit($month,$year);
		$period_R = substr($vedom,1,4);
		
		for($k=1;$k<=$day_limit;$k++) 
		{
		  $period = $period_R.str_pad($k,2,"0",STR_PAD_LEFT);
		  $eff = isset($this->get_info_trz($bisoft_id,$vedom,$period)->Effect) ? $this->get_info_trz($bisoft_id,$vedom,$period)->Effect : 0;
		  if(!$eff) {$eff = '';}
		  $days_Effect[] = $eff;
		}
	
	return $days_Effect;	
	}	


	function get_all_suma($bisoft_id,$vedom,$rnd=2)
	{
		if($bisoft_id==-1) { return 0;}
		$days_SUMA = array();
		$month = (int) substr($vedom,3,2);
		$year  = (int) substr($vedom,1,2);
		$day_limit = $this->BiSOFT_Model->get_month_limit($month,$year);
		$period_R = substr($vedom,1,4);
		
		for($k=1;$k<=$day_limit;$k++) 
		{
		  $period = $period_R.str_pad($k,2,"0",STR_PAD_LEFT);
		  $suma = isset($this->get_info_trz($bisoft_id,$vedom,$period)->all_SUMA) ? $this->get_info_trz($bisoft_id,$vedom,$period)->all_SUMA : 0;
		  $suma = round($suma,$rnd);
		  if(!$suma) {$suma = '';}
		  $days_SUMA[] = $suma;
		}
	
	return $days_SUMA;	
	}

	
	function save_techno_M($trz_data,$bisoft_id,$vedom,$period)
	{ }
	

	function check_free_bisoft_id($bisoft_id,$bisoft_id_max)
	{ 
      $result=0;
      if($bisoft_id)
      {
         $this->db->select('max(bisoft_id) as max_bisoft', false);
         $this->db->from('employees');
         $this->db->where('bisoft_id BETWEEN "'.$bisoft_id.'" AND "'.$bisoft_id_max.'"');
         $result = $this->db->get()->result_array();
         return 1 + $result['0']['max_bisoft'];      
      }
		return $result;
	}
//====================================== END ТРЗ VEDOM =============================== //
	
	

// =================================== SAVES ================================= //
	function save(&$person_data, &$employee_data,$employee_id=false)
	{
		$success=false;
		$this->db->trans_start();

		if(parent::save_person($person_data,$employee_id))
		{
			if (!$employee_id or !$this->exists($employee_id))
			{
				$employee_data['person_id'] = $employee_id = $person_data['person_id'];
				$success = $this->db->insert('employees',$employee_data);
			}
			else
			{
				$this->db->where('person_id', $employee_id);
				$this->db->update('people', $person_data);

				$this->db->where('person_id', $employee_id);
				$success = $this->db->update('employees',$employee_data);
			}
		}
	
		$this->db->trans_complete();		
		return $success;
	}


	function save_modes($modes_data,$person_id=0)
	{
	  $success=false;
	  $this->db->trans_start();

			if (!$this->exists($person_id)) { $success=false; }
			else
			{
				$this->db->from('employees');	
				$this->db->where('person_id', $person_id);
				$success = $this->db->update('employees', $modes_data);		
			}

	$this->db->trans_complete();		
	return $success;
	}
	

	function delete($employee_id)
	{
		$success=false;

		if($employee_id==$this->get_logged_in_employee_info()->person_id)
			{ return false; }

		$this->db->trans_start();

		if($this->db->delete('permissions', array('person_id' => $employee_id)))
		{	
			$this->db->where('person_id', $employee_id);
			$success = $this->db->update('employees', array('deleted' => 1));
		}
		$this->db->trans_complete();		
		return $success;
	}
	

	function delete_list($employee_ids)
	{
		$success=false;

		if(in_array($this->Employee->get_logged_in_employee_info()->person_id,$employee_ids))
			{ return false; }

		$this->db->trans_start();
			$this->db->where_in('person_id',$employee_ids);
			if ($this->db->delete('permissions'))
			{
				$this->db->where_in('person_id',$employee_ids);
				$success = $this->db->update('employees', array('deleted' => 1));
			}
		$this->db->trans_complete();		
		return $success;
 	}

 	
// ================================== CALCULATE LOADS =================================== //
	function calculate_load_data($bisoft_id,$period,$presence_input=0,$trz_input=0)
	{	
		$vedom   = 'T'.$period; $result = array();
		$month   = substr($period,-2);
		$year    = substr($period,0,2);
		$all_mDAYS = $this->BiSOFT_Model->get_month_all_workdays($month,$year);
		$holiday   = $this->BiSOFT_Model->get_month_holidays($month,$year);
		
		// малко инфо за Работника
		$person_info = $this->get_info_bisoft_id($bisoft_id);
		$person_id = $person_info->person_id;
			$norma = $this->get_info($person_id)->norma;
			$job_time = $person_info->job_time; if($job_time < 4) {$job_time=8;}
			
		// малко сметки по Договорените (базови) заплати
		if($person_info->base_salary > 0)
		  { $base_salary = $person_info->base_salary;}
		else
		  {
			 if($person_info->doc_salary > 0) { $base_salary = $person_info->doc_salary;}
			 else { $base_salary = '';}
		  }			
		
		// зареждаме от месечната Ведомост ...
 		$trz_vedom = $this->get_info_trz($bisoft_id, $vedom, $period);
			$result['trz_data'] = json_decode($trz_vedom->TM);
			if($presence_input==0) { $result['presence'] = json_decode($trz_vedom->PM);}
			else { $result['presence'] = $presence_input;}			
			
		// сега СУМИТЕ ...
		if($trz_input==0 and $result['trz_data'])
		{	  
			if($result['trz_data']->base_salary > 0)
			{ $base_salary = $result['trz_data']->base_salary; }

		  $trz_class	= $result['trz_data']->trz_class;
		  $trz_plus		= $result['trz_data']->trz_plus;
		  $trz_minus	= $result['trz_data']->trz_minus;
		  $trz_taxes 	= $result['trz_data']->trz_taxes;
		
		  $trz_prevod  = $result['trz_data']->trz_prevod;  
		  $trz_travel	= $result['trz_data']->trz_travel;
		  $onHours		= $result['trz_data']->onHours;
		  $sickSum		= $result['trz_data']->sickSum;
		  $avance		= $result['trz_data']->avance;
		  $comment		= $result['trz_data']->comment;
		  
		  // new $trz_saturday
		  if(isset($result['trz_data']->trz_saturday)) { $trz_saturday = $result['trz_data']->trz_saturday; }
		  else { $trz_saturday = 0; }
		  
		}
		else // $trz_input!=0 дали няма промени в trz_input ?
		{
		  $base_salary = $trz_input['base_salary']; 
		  $trz_class	= $trz_input['trz_class'];
		  $trz_plus		= $trz_input['trz_plus'];
		  $trz_minus	= $trz_input['trz_minus'];
		  $trz_taxes 	= $trz_input['trz_taxes'];
		$trz_saturday 	= $trz_input['trz_saturday'];
		  $trz_prevod  = $trz_input['trz_prevod'];  
		  $trz_travel	= $trz_input['trz_travel'];
		  $onHours		= $trz_input['onHours'];
		  $sickSum		= $trz_input['sickSum'];
		  $avance		= $trz_input['avance'];
		  $comment		= $trz_input['comment'];
		}
		
		// малко обработка
		if($base_salary=='') 	{$base_salary=0;}
		if($trz_class=='')  		{$trz_class=0;}
		if($trz_plus=='')   		{$trz_plus=0;}
		if($trz_minus=='')  		{$trz_minus=0;}
		if($trz_taxes=='')  		{$trz_taxes=0;}
		if($trz_saturday=='')  	{$trz_saturday=0;}
		if($trz_prevod=='') 		{$trz_prevod=0;}
		if($trz_travel=='') 		{$trz_travel=0;}
		if($onHours=='') 			{$onHours=0;}
		if($sickSum=='') 			{$sickSum=0;}
		if($avance=='')  			{$avance=0;}
		
		$trz_days = $addHours = $all_Hours = $subHours = $holiDays = $sickDays = $offDays = 0;
		if(isset($result['presence']) && $result['presence'])
		{
			foreach ($result['presence'] as $day=>$pre) 
			{
				if( isset($holiday[$day]) and (int)$holiday[$day] == 0 ) // нормален Работен Ден
				{
					if(is_numeric($pre) and (float)$pre > 0)
					{
						$trz_days++;
						$all_Hours += (float)$pre;
							
						$dayHours = (float)$pre - (float)$job_time; // +- раб.време
						if( $dayHours > 0 )
							{ $addHours += $dayHours; }
						else
							{ $subHours += abs($dayHours);}
					}
					else
					{
						if($pre=='о' or $pre=='o' or $pre=='h' or $pre=='H') {$holiDays++;}
						if($pre=='б' or $pre=='Б' or $pre=='b' or $pre=='B') {$sickDays++;}
						if($pre=='но' or $pre=='НО') {$offDays++;}
					}			
				}
				else // Празничен Ден
				{ 
               if( is_numeric($pre) and (float)$pre > 0 ) {$addHours += (float)$pre;}
            }

			} // foreach ($result['presence']
			
		}
		else { $result['presence']=array(); }

		$addHours -= $subHours; // компенсира, ако може по-малко доп.часове
		$addHours  = round($addHours,1); // закръгляме до 1 знак. заради случая с Таня Матова 2018-10 ?!
		
		$trz_worked = ''; $trz_oneDay = ''; $trz_oneHour = '';
		if ($norma==8) // нормени работници
			{
				$trz_worked  = $result['trz_data']->trz_worked;
				$addHourSum  = $result['trz_data']->addHourSum;
				$trz_oneHour = ($all_Hours!=0) ? ((float)$trz_worked/$all_Hours) : 0;
				$trz_oneDay  = (float)$trz_oneHour * $job_time;
			}
		else // всички останали + служители
			{
				$trz_oneDay  = ( (float)$base_salary + (float)$trz_class ) / $all_mDAYS;
				$trz_oneHour = (float)$trz_oneDay / $job_time;
				$trz_worked  = (int)$trz_days * (float)$trz_oneDay;
				if($job_time >= 8)
               { 
						if($addHours>0)
							{ $addHourSum = round( 1.5 * (float)$addHours * (float)$trz_oneHour , 2); }
						else
							{ $addHourSum = round( (float)$addHours * (float)$trz_oneHour , 2); }
					}
            else
               { $addHourSum = round( $addHours * (float)$trz_oneHour , 2); }
			}		
			
		$trz_LastDay = $this->get_vedom_LastDay($bisoft_id,$period);
		if(isset($trz_LastDay) and $trz_LastDay==0) { $trz_LastDay = (float)$trz_oneDay;}
				
		//други
		$holiSum   = round( (int)$holiDays * ( (float)$trz_oneDay + (float)$trz_LastDay ) / 2 ,2);
		$onHourSum = round( (float)$trz_oneHour * (float)$onHours ,2);
		
// echo 	"$bisoft_id / $trz_oneHour * $addHours = $addHourSum";
// die();		
		
		// Калкулираме вече ...	
		$all_PLUS = (float)$trz_worked; // основа е СУМАТА по отраб.време
					
		// добавяме отпуски + болнични + доп.часове + на.час
		$all_PLUS += (float)$holiSum + (float)$sickSum + (float)$addHourSum + (float)$onHourSum;
					
		// добавяме всички останали ДОБАВКИ
		$all_PLUS += (float)$trz_travel + (float)$trz_plus;
			
		// изваждаме всички УДРЪЖКИ
		$all_MINUS = (float)$trz_taxes + (float)$trz_prevod + (float)$avance + (float)$trz_minus + (float)$trz_saturday;
					
		// окончателно смятаме ЗАПЛАТАТА
		$salary = round( $all_PLUS - $all_MINUS, 2 );

		 // филтър ....
		 $trz_LastDay = round( (float)$trz_LastDay, 3 );
		 $trz_oneHour = round( (float)$trz_oneHour, 3 );
		 
		 if($trz_days==0) {$trz_days ='';}
		 if($addHours==0) {$addHours ='';}
		 if($onHours ==0) {$onHours  ='';}
		 if($holiDays==0) {$holiDays ='';}
		 if($sickDays==0) {$sickDays ='';}
		 if($offDays==0)  {$offDays  ='';}

		 if((float)$base_salary==0) {$base_salary='';}
			 else {$base_salary=round($base_salary,2);}
		 if((float)$trz_class==0) {$trz_class='';}
			 else {$trz_class=to_dot($trz_class);}
		 if((float)$trz_worked==0) {$trz_worked='';}
			 else {$trz_worked=round($trz_worked,2);}
		 if((float)$trz_oneDay==0) {$trz_oneDay='';}		 
			 else {$trz_oneDay=round($trz_oneDay,3);}
		 if((float)$trz_plus==0) {$trz_plus='';}
			 else {$trz_plus=to_dot($trz_plus);}
		 if((float)$trz_minus==0) {$trz_minus='';}
			 else  {$trz_minus=to_dot($trz_minus);}
		 if((float)$trz_taxes==0) {$trz_taxes='';}
			 else {$trz_taxes=to_dot($trz_taxes);}
		 if((float)$trz_saturday==0) {$trz_saturday='';}
			 else {$trz_saturday=to_dot($trz_saturday);}
		 if((float)$trz_prevod==0) {$trz_prevod='';}
			 else {$trz_prevod=to_dot($trz_prevod);}
		 if((float)$trz_travel==0) {$trz_travel='';}
			 else {$trz_travel=to_dot($trz_travel);}
		 if((float)$addHourSum==0) {$addHourSum='';}
			 else {$addHourSum=to_dot($addHourSum);}
		 if((float)$onHourSum==0) {$onHourSum='';}
			 else {$onHourSum=to_dot($onHourSum);}
		 if((float)$holiSum==0) {$holiSum='';}
			 else {$holiSum=to_dot($holiSum);}
		 if((float)$sickSum==0) {$sickSum='';}
			 else {$sickSum=to_dot($sickSum);}
		 if((float)$avance==0) {$avance='';}
			 else {$avance=round($avance,0);}
		 if((float)$salary==0) {$salary='';}
			 else {$salary=round($salary,1);}		
		
		$result['trz_data']->base_salary = $base_salary;
		$result['trz_data']->trz_class	= $trz_class;
		$result['trz_data']->trz_days 	= $trz_days;
		$result['trz_data']->job_time 	= $job_time;

		$result['trz_data']->trz_LastDay = $trz_LastDay;
		$result['trz_data']->trz_oneDay  = $trz_oneDay;
		$result['trz_data']->trz_oneHour = $trz_oneHour;
		$result['trz_data']->trz_worked  = $trz_worked;

		$result['trz_data']->addHours 	= $addHours;
		$result['trz_data']->addHourSum	= $addHourSum;
		$result['trz_data']->onHours		= $onHours;
		$result['trz_data']->onHourSum	= $onHourSum;
		$result['trz_data']->holiDays 	= $holiDays;
		$result['trz_data']->holiSum 		= $holiSum;
		$result['trz_data']->sickDays 	= $sickDays;
		$result['trz_data']->sickSum 		= $sickSum;
		$result['trz_data']->offDays 	   = $offDays;

		$result['trz_data']->trz_taxes 	= $trz_taxes;
		$result['trz_data']->trz_saturday 	= $trz_saturday;
		$result['trz_data']->trz_plus 	= $trz_plus;
		$result['trz_data']->trz_minus 	= $trz_minus;
		$result['trz_data']->trz_prevod 	= $trz_prevod;
		$result['trz_data']->trz_travel 	= $trz_travel;
		
		$result['trz_data']->all_mDAYS	= $all_mDAYS;
		$result['trz_data']->comment 		= $comment;
		$result['trz_data']->avance 		= $avance;		
		$result['trz_data']->salary		= $salary;	

	return $result;
	}

	/* взима сумата от предходният ср.притеглен раб.ден */
	function get_vedom_LastDay($bisoft_id,$period)
	{
		$trz_LastDay=0;
	
	return $trz_LastDay;
	}

// ================================== CALCULATE PRESENCE =================================== //	
	function load_presence($person_id,&$data)
	{
		$user_date = strtotime( $this->BiSOFT_Model->get_user_mode_date() );
		$data['Month']  = date('m', $user_date);
		$data['Year']   = date('Y', $user_date);
		$data['period'] = $period = date('ym', $user_date);
		$data['vedom'] = $vedom = 'T'.date('ym', $user_date);
		$dateSt = '20'.substr($period,0,2).'-'.substr($period,-2).'-';

		$data['m_limit'] = $this->BiSOFT_Model->get_month_limit($data['Month'],$data['Year']);
		// всички РАБОТНИ дни на месеца.
		$data['all_mDAYS'] = $this->BiSOFT_Model->get_month_all_workdays($data['Month'],$data['Year']);

		$data['person_info'] = $person_info = $this->get_info($person_id);
		$data['bisoft_id'] = $bisoft_id = $person_info->bisoft_id;
		$data['name'] = $person_info->first_name.' '.$person_info->last_name;
		$data['user_id'] = $this->BiSOFT_Model->get_person();

		$data['presence'] = $data['trz_data'] = array();
		if($this->exists_trz($bisoft_id, $vedom, $period))
		  {
				$result = $this->calculate_load_data($bisoft_id,$period);
					$data['presence'] = $result['presence'];
					$data['trz_data'] = $result['trz_data'];
		  }
		return $data;
	}

	
	function calculate_presence($person_id,$period,$presence_input,$other_data)
	{
		$vedom  = 'T'.$period;
		$month  = substr($period,-2);
		$year   = substr($period,0,2);
		$all_mDAYS = $this->BiSOFT_Model->get_month_all_workdays($month,$year);
		  $onHours = $other_data['onHours'];
		  $comment = $other_data['comment'];
		  
		// инфо за служителя
		$person_info = $this->get_info($person_id);
		$bisoft_id = $person_info->bisoft_id;
		$job_time = $person_info->job_time; if($job_time < 4) {$job_time=8;}
		  
		if($this->exists_trz($bisoft_id, $vedom, $period))
			{ $result = $this->calculate_load_data($bisoft_id,$period,$presence_input);}
		else
			{	// събирам останалите данни
				$result['presence'] = $presence_input;
				$result['trz_data'] = array(
						'base_salary' => '',
							'job_time' => $job_time,
						  'trz_class' => '',
						  'trz_taxes' => '',		
							'trz_plus' => '',
						  'trz_minus' => '',
						 'trz_worked' => '',
							'trz_days' => '',
						 'trz_prevod' => '',
						 'trz_travel' => '',
						'trz_oneHour' => '',
						 'trz_oneDay' => '',
						'trz_LastDay' => '',
							'addHours' => '',
						 'addHourSum' => '',
							 'onHours' => '',
						  'onHourSum' => '',
							'holiDays' => '',
							 'holiSum' => '',
							'sickDays' => '',
							 'sickSum' => '',
						  'all_mDAYS' => $all_mDAYS,
							 'comment' => $comment,
							  'avance' => '',
							  'salary' => ''	);
			}
		return $result;
	}

 	
// ================================== CALCULATE SALARY =================================== //
	function load_salary($person_id,&$data)
	{
		$user_date = strtotime( $this->BiSOFT_Model->get_user_mode_date() );
		$data['Month']  = date('m', $user_date);
		$data['Year']   = date('Y', $user_date);
		$data['period'] = $period = date('ym', $user_date);
		$data['vedom']  = $vedom = 'T'.date('ym', $user_date);
		$month  = substr($period,-2); 
		$year	  = substr($period,0,2); 
		$dateSt = '20'.substr($period,0,2).'-'.substr($period,-2).'-';

		$data['person_info'] = $person_info = $this->TRZ->get_info($person_id);
		$data['bisoft_id'] = $bisoft_id = $person_info->bisoft_id;
		$data['name'] = $name = $person_info->first_name.' '.$person_info->last_name;
		$data['user_id'] = $this->BiSOFT_Model->get_person();
		$norma = $person_info->norma;
		
		$data['all_HB'] = $data['all_SUMA'] = $data['Pre'] = $data['all_DAYS'] = $data['Effect'] = 0;
		
		$data['m_limit']  = $m_limit = $this->BiSOFT_Model->get_month_limit($data['Month'],$data['Year']);
		$data['all_mDAYS']= $all_mDAYS = $this->BiSOFT_Model->get_month_all_workdays($data['Month'],$data['Year']);

		$data['all_SUMA'] = $data['all_DAYS'] = 0; $data['trz_data'] = array();
		$data['presence'] = $data['trz_data'] = array();
		if($this->exists_trz($bisoft_id, $vedom, $period))
		  {
				$result = $this->calculate_load_data($bisoft_id,$period);
					$data['presence'] = $result['presence'];
					$data['trz_data'] = $result['trz_data'];
		  }
		  
		// малко сметки по Договорените (базови) заплати
		$data['base_salary'] = '';
		if(isset($data['trz_data']->base_salary) and (float)$data['trz_data']->base_salary > 0)
		  { $data['base_salary'] = $data['trz_data']->base_salary;}
		else
		  {
			 if($person_info->doc_salary > 0) { $data['base_salary'] = (float)$person_info->doc_salary;}
			 else { $data['base_salary'] = '';}
		  }
		$data['comment'] = isset($data['trz_data']->comment) ? $data['trz_data']->comment : '';

		return $data;
	}

	
	function calculate_salary($person_id,$trz_input,$period)
	{
		$success = 1;$result['trz_data']=array();
		$person_info = $this->get_info($person_id);
		$bisoft_id = $person_info->bisoft_id;
		$vedom  = 'T'.$period;
	
		if($this->exists_trz($bisoft_id, $vedom, $period))
			{	$result = $this->calculate_load_data($bisoft_id,$period,0,$trz_input);}
		else
			{	// събирам останалите данни
				$result['trz_data'] = array(
						'base_salary' => '',
							'job_time' => '',
						  'trz_class' => '',
						  'trz_taxes' => '',
					  'trz_saturday' => '',
							'trz_plus' => '',
						  'trz_minus' => '',
						 'trz_worked' => '',
							'trz_days' => '',
						 'trz_prevod' => '',
						 'trz_travel' => '',
						'trz_oneHour' => '',
						 'trz_oneDay' => '',
						'trz_LastDay' => '',
							'addHours' => '',
						 'addHourSum' => '',
							 'onHours' => '',
						  'onHourSum' => '',
							'holiDays' => '',
							 'holiSum' => '',
							'sickDays' => '',
							 'sickSum' => '',
						  'all_mDAYS' => '',
							 'comment' => '',
							  'avance' => '',
							  'salary' => ''	);
			}
		return $result['trz_data'];
	}	


   /* зарежда данни от ПРОИЗВОДСТВО ======================================== */ 
	function send_to_TRZ($presence_data)
	{
		$success = 1; $presence = array();
		$bisoft_id = $presence_data['bisoft_id'];
		$name 	  = $presence_data['name'];
		$person_id = $this->Employee->get_employee_bisoft($bisoft_id)->person_id;
		  $person_info = $this->get_info($person_id);
		  $norma = $person_info->norma;
		  $job_time = $person_info->job_time;

		if($norma!=8) { return 0;} // САМО за Нормени Работници
		
		$vedom	  = $presence_data['vedom'];
		$period	  = substr($vedom,-4);
		  $year	  = substr($period,0,2);
		  $month	  = substr($period,-2);
		  $all_mDAYS = $this->BiSOFT_Model->get_month_all_workdays($month,$year);
		  $m_limit = $this->BiSOFT_Model->get_month_limit($month,$year);
		
		$Pre = $presence_data['Pre'];
		$addHours 	= $presence_data['addHours']; 	if($addHours==0) 	 { $addHours='';}
		$addHourSum = $presence_data['addHourSum'];	if($addHourSum==0) { $addHourSum='';}
		$all_DAYS	= $trz_days = $presence_data['all_DAYS'];
		$all_HB		= $presence_data['all_HB'];
		$all_SUMA 	= $trz_worked = round($presence_data['all_SUMA'], 2);
		$Effect		= $presence_data['Effect'];
		// масив с присъствието
		$preHours = $presence_data['preHours'];

		if(!$this->exists_trz($bisoft_id,$vedom,$period))
		  {   // събирам данните
				$trz_data=array(
				 'base_salary' => $person_info->base_salary,
					 'job_time' => $job_time,
				   'trz_class' => '',
				   'trz_taxes' => '',		
					 'trz_plus' => '',
				   'trz_minus' => '',
				  'trz_worked' => $trz_worked,
					 'trz_days' => $trz_days,
				  'trz_prevod' => '',
				  'trz_travel' => '',
				  'trz_oneDay' => '',  // 1 раб.ден от месеца ЗАРАБОТКА
				 'trz_LastDay' => '',  // 1 раб.ден от Предходен Месец ?!?!
					 'addHours' => $addHours,
				  'addHourSum' => $addHourSum,
					  'onHours' => '',
				   'onHourSum' => '',
					 'holiDays' => '',
					  'holiSum' => '',
					 'sickDays' => '',
					  'sickSum' => '',
				   'all_mDAYS' => $all_mDAYS,
					  'comment' => '',
						'avance' => '',
						'salary' => ''	 );
						
			// приготвя ПРИСЪСТВИЕ на празно
			for($k=1;$k<=$m_limit;$k++) { $presence[$k]=$preHours[$k];}
		}
		else
		{
			 $trz_vedom = $this->get_info_trz($bisoft_id,$vedom,$period);
			 $trz_data  = json_decode( $trz_vedom->TM );
				 if($person_info->base_salary)
				 {  $trz_data->base_salary = $person_info->base_salary; }
				 else
				 {  $trz_data->base_salary = 100; }
					 $trz_data->job_time   	= $job_time;
					 $trz_data->trz_worked 	= $trz_worked;
					 $trz_data->trz_days	  	= $trz_days;
					 $trz_data->addHours	  	= $addHours;
					 $trz_data->addHourSum 	= $addHourSum;
					 $trz_data->all_mDAYS  	= $all_mDAYS;

			 $oldPRE  = json_decode( $trz_vedom->PM );
			 // приготвя ПРИСЪСТВИЕ с допълване
			 for($k=1;$k<=$m_limit;$k++) 
				 {
					if(isset($preHours[$k]) && (float)$preHours[$k]>0)
						{ $presence[$k]=$preHours[$k];}
					else
						{ 
							if(isset($oldPRE->$k)) {$presence[$k]=$oldPRE->$k;}
							else {$presence[$k]="";}
						}
				 }
		  } // !if(!$this->exists_trz

		$data = array(
		   'bisoft_id' => $bisoft_id,
				'period' => $period,
				  'name' => $name,
					 'PM' => json_encode($presence),
					 'TM' => json_encode($trz_data),
			 'all_SUMA' => $all_SUMA,	 
				'all_HB' => $all_HB,
			 'all_DAYS' => $all_DAYS,
				   'Pre' => $Pre,
				'Effect' => $Effect );

		// записваме в Централната Ведомост за Месеца ...
		$success *= $this->save_work($data,$bisoft_id,$vedom,$period);
		return $success;
	}	

	
// ========================================== SEARCH =================================== //	
	function get_search_suggestions($search,$limit=10)
	{
		$suggestions = array();
		
		$this->db->from('employees');
		$this->db->join('people','employees.person_id=people.person_id');	
		$this->db->where("(first_name LIKE '%".$this->db->escape_like_str($search)."%' or 
		last_name LIKE '%".$this->db->escape_like_str($search)."%' or 
		CONCAT(`first_name`,' ',`last_name`) LIKE '%".$this->db->escape_like_str($search)."%') and deleted=0");
		$this->db->where('job_id > 0');	// само хора от фирмата със служебен код ...
		$this->db->order_by("first_name", "asc");		
		$by_name = $this->db->get();
		foreach($by_name->result() as $row)
			{ $suggestions[]=$row->first_name.' '.$row->last_name; }

		if(count($suggestions > $limit))
		{ $suggestions = array_slice($suggestions, 0,$limit); }

		return $suggestions;
	}
	

	function search($search)
	{
		$this->db->from('employees');
		$this->db->join('people','employees.person_id=people.person_id');		
		$this->db->where("(first_name LIKE '%".$this->db->escape_like_str($search)."%' or 
		last_name LIKE '%".$this->db->escape_like_str($search)."%' or 
		CONCAT(`first_name`,' ',`last_name`) LIKE '%".$this->db->escape_like_str($search)."%') and deleted=0");

		$this->db->where('job_id > 0');	// само хора от фирмата със служебен код ...
		$this->db->order_by("last_name", "asc");
		
		return $this->db->get();	
	}

} ?>
