<?php class Techno extends CI_Model
{

	function exists($doc_id, $technoPack)
	{  
		$this->db->from($technoPack);
		$this->db->where('doc_id',$doc_id);
		$query = $this->db->get();
	return ($query->num_rows()==1);
	}


	public function get_info($doc_id, $technoPack, $mode='manu')
	{  
		$this->db->from($technoPack);
		$this->db->where('doc_id',$doc_id);
	return $this->db->get();
	}

	public function get_info_line($doc_id, $line, $technoPack)
	{  
		$this->db->from($technoPack.'_items');
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
	return $this->db->get();
	}

	function update($doc_data, $doc_id, $technoPack)
	{  
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update( $technoPack, $doc_data );
	return $success;
	}

	function update_items($items_data, $doc_id, $technoPack)
	{  
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update( $technoPack, $items_data );
	return $success;
	}

	function update_line_item($items_data, $doc_id, $line, $technoPack)
	{  
		$this->db->where('doc_id', $doc_id);
		$this->db->where('line', $line);
		$success = $this->db->update( $technoPack.'_items', $items_data );
	return $success;
	}


/* ========================== БАЗА МИНУТНИ РАЦЕНКИ ===================== */
	function exists_job_id($job_id)
	{  
		$this->db->from('tech_HB');
		$this->db->where('job_id', $job_id);
		$this->db->where('deleted', 0);
		$query = $this->db->get();
	return($query->num_rows()==1);
	}

	function get_all_jobs_id()
	{  
		$this->db->select('
					job_id,
					job_name, 
					job_min,
					salary',	false);

		$this->db->from('tech_HB');
		$this->db->where('job_id > 10000');
		$this->db->where('deleted',0);
		$this->db->order_by('job_id');
	return $this->db->get()->result_array();
	}

	function get_job_id($job_id=0)
	{  
		$this->db->from('tech_HB');
		$this->db->where('job_id',$job_id);
		$query = $this->db->get();
	if($query->num_rows()==1) 
		{return $query->row();}
	else 
		{return false;}
	}

	function update_job_id($job_data, $job_id=0)
	{  
		$this->db->where('job_id', $job_id);
		$this->db->where('deleted',0);
		$success = $this->db->update( 'tech_HB', $job_data );
	return $success;
	}

	function delete_job_id($job_id)
	{
		$this->db->trans_start();
		$this->db->delete('tech_HB', array('job_id' => $job_id ) );
		$this->db->trans_complete();
	return $this->db->trans_status();
	}


	// ----------------------------- БАЗА ДАННИ ТЕХНОЛОГИЧНИ МАНИПУЛАЦИИ ------------------------//
	function exists_techdb($tech_id)
	{  
		$this->db->from('tech_DB');
		$this->db->where('tech_id', $tech_id);
		$this->db->where('deleted', 0);
		$query = $this->db->get();
	return($query->num_rows()==1);
	}

	function get_techdb($tech_id)
	{  
		$this->db->from('tech_DB');
		$this->db->where('tech_id', $tech_id);
		$this->db->where('deleted', 0);
		$query = $this->db->get();
		if($query->num_rows()==1)
			{ return $query->row();}
		else
			{ return false;}
	}

	function get_tech_old($tech_old)
	{  
		$this->db->from('tech_DB');
		$this->db->where('tech_old', $tech_old);
		$this->db->where('deleted', 0);
		$query = $this->db->get();
		if	($query->num_rows()==1)
			{ return $query->row()->tech_id;}
		else
			{ return false;}
	}


	function get_tech_HB($tech_id,$HB=0)
	{
		$this->db->from('tech_DB');
		$this->db->where('tech_id', $tech_id);
		$this->db->where('deleted', 0);
		$query = $this->db->get();

		$HB_x	= 0;
		if ($query->num_rows()>0)
		{ 
		switch ($HB)
			{
				case '0': $HB_x = $query->row()->HB_0; break;
				case '1': $HB_x = $query->row()->HB_1; break;
				case '2': $HB_x = $query->row()->HB_2; break;
				case '3': $HB_x = $query->row()->HB_3; break;
				case '4': $HB_x = $query->row()->HB_4; break;
				case '5': $HB_x = $query->row()->HB_5; break;
				case '6': $HB_x = $query->row()->HB_6; break;
				case '7': $HB_x = $query->row()->HB_7; break;
				case '8': $HB_x = $query->row()->HB_8; break;
				case '9': $HB_x = $query->row()->HB_9; break;
				default:  $HB_x = $query->row()->HB_0;
			}
		}
	return $HB_x;
	}


	function save_db( &$data, $tech_id=0 )
	{
		if (!$tech_id or !$this->exists_techdb($tech_id))
		{
			if ($this->db->insert('tech_DB',$data))
				{ $tech_data['tech_id']=$this->db->insert_id(); return 1;}
		return 0;
		}
		$this->db->where('tech_id', $tech_id);
	return $this->db->update('tech_DB',$tech_id);
	}


	// ----------------------------------- TECHIOLOGIES-MAIN --------------------------------//
	function exists_techno($item_number,$type=1)
	{	$group=$this->get_group($item_number);
		$this->db->from('tech_'.$group);
		$this->db->where('item_number', $item_number);
		$this->db->where('type', $type);
		$this->db->where('deleted', '0');
		$query = $this->db->get();
	return($query->num_rows()==1);
	}

	function get_group($item_number)
	{	$group=0;
		if ($item_number>9999) 
			{$group=substr($item_number,0,1);}
	return $group;
	}

	/* ---- взима цялата технология по item_number и type ---- */
	function get_techno($item_number,$type=1)
	{	$group=$this->get_group($item_number);
		$this->db->from('tech_'.$group);
		$this->db->where('item_number', $item_number);
		$this->db->where('type', $type);
		$this->db->where('deleted', '0');
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{ return $query->row();}
		else
			{ return 0;}
	}

	function get_techno_PM($item_number,$type=1)
	{	$group=$this->get_group($item_number);
		$this->db->from('tech_'.$group);
		$this->db->where('item_number', $item_number);
		$this->db->where('type', $type);
		$this->db->where('deleted', '0');
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{ return $query->row()->PM;}
		else
			{ return 0;}
	}

	function check_techno_PM($item_number,$type=1,$PM=1)
	{	$group=$this->get_group($item_number);
		$this->db->from('tech_'.$group);
		$this->db->where('item_number', $item_number);
		$this->db->where('type', $type);
		$this->db->where('deleted', '0');
		$query=$this->db->get();
		$success=0;
		if ($query->num_rows()==1)
			{	$PMs = json_decode($query->row()->PM);
				foreach ($PMs as $line=>$pm)
				{ if($line==$PM){$success=1;} }
			return $success;
			}
		else {return 0;}
	}

	/* --- only SAVES Technology --- */
	function save_techno( &$data,$item_number,$type=1)
	{	$group=$this->get_group($item_number);
		if (!$item_number or !$this->exists_techno($item_number,$type))
		{
			if ($this->db->insert('tech_'.$group,$data))
				{ $data['tech_id']=$this->db->insert_id();return 1;}
		return 0;
		}
		$this->db->where('item_number', $item_number);
		$this->db->where('type', $type);
	return $this->db->update('tech_'.$group,$data);
	}

	/* --- data=[PM],[PM_pos],[manu] --- */
	function add_techno_PM($data,$item_number,$type=1)
	{
		$PM  = $data['PM']; $PM_pos = $data['PM_pos']; 
		$manu = $data['manu'];
		$PMs = json_decode($this->get_techno_PM($item_number,$type));

		$PMs_new = array();
		foreach ($PMs as $line=>$pm)
			{
				if($PM<$line) {$PMs_new[$PM] = array(0=>$manu);}
				$PMs_new[$line] = $pm;
			}

		$data = array(
			'item_number' => $item_number,
					 'type' => $type,
						'PM' => json_encode($PMs_new),
			  'tech_date' => date('Y-m-d')
						);

			 $this->save_techno($data,$item_number,$type);
	return $this->calculate_techno($item_number,$type);
	}

	/* --- data=[PM],[PM_pos],[manu] --- */
	function change_techno_PM($data,$item_number,$type=1)
	{	
		if(!$item_number) {return 0;}
		$PM  = $data['PM']; $PM_pos = $data['PM_pos']; 
		$manu = $data['manu'];
		$PMs = json_decode($this->get_techno_PM($item_number,$type));

		$PMs_new = array();
		foreach ($PMs as $line=>$pm)
		{
			foreach ($pm as $row=>$code)
			{ 
				if ($line==$PM && $row==$PM_pos && $manu>9999)
					{ $PMs_new[$line][$row] = $manu;}
				else
					{ $PMs_new[$line][$row] = $code;}
			}
			if($line==$PM && $manu==-1) { $PMs_new[$line][] = 0;}
		}

		$data = array(
			'item_number' => $item_number,
					 'type' => $type,
						'PM' => json_encode($PMs_new),
			  'tech_date' => date('Y-m-d') );

			 $this->save_techno($data,$item_number,$type);
	return $this->calculate_techno($item_number,$type);
	}

	function delete_techno_PM($data,$item_number,$type=1)
	{	
		if(!$item_number) {return 0;}
		$success = 0;
		$PM  = $data['PM']; $PM_pos = $data['PM_pos']; 
		$manu = $data['manu'];
		$PMs = json_decode($this->get_techno_PM($item_number,$type));

		$PMs_new = array();
		foreach ($PMs as $line=>$pm)
		{
			foreach ($pm as $row=>$code)
			{ 
				if($line==$PM && $row==$PM_pos) {} // пропускам това, което се трие ...
				else { $PMs_new[$line][$row] = $code;} // останалото просто копирам ...
			}
		}

		$data = array(
			'item_number' => $item_number,
					 'type' => $type,
						'PM' => json_encode($PMs_new),
			  'tech_date' => date('Y-m-d') );

			 $this->save_techno($data,$item_number,$type);
	return $this->calculate_techno($item_number,$type);
	}

	function calculate_techno($item_number,$type=1,$date_save=1)
	{
		if(!$item_number) {return 0;}
		$all_HB = $all_SUMA = $success = 0;
		$name = $this->get_techno($item_number,$type)->name;

		if ($this->exists_techno($item_number,$type)==1)
			{  $PMs = json_decode($this->get_techno_PM($item_number,$type));
				foreach ($PMs as $line=>$pm)
				{
					foreach ($pm as $row=>$code)
					{ 
						$code_M	= substr($code,0,-1);				
						$code_T	= substr($code,-1);
						$HB		= $this->get_tech_HB($code_M,$code_T);
						$seria	= $this->get_techno($item_number,$type)->seria;
     
						if($code_M) 
                     {
                        if($this->exists_techdb($code_M))
                        {
                           $job_id	= $this->get_techdb($code_M)->job_id;
                           $job_min	= $this->Production->get_tech_HB($job_id)->job_min;
                        }
                        else { $job_id = $job_min = 0;}
                     }
						else { $job_id = $job_min = 0;}
						
						if($code>9999 && $HB>0)	{ $all_HB += $HB; $all_SUMA += round($job_min*$HB,3);}
						
						// актуализира техн. БД
						if($this->Production->exists_tech_DB($code_M))
						{
						  $tech_data = array(
								  'tech_id' => $code_M,
										 'pm' => $line );
						  $this->Production->update_tech_DB($tech_data, $code_M);
						}
						// в бъдеще може да махнем това ?!?!
					}
				}

			$all_SUMA = round((100+$seria)*$all_SUMA/100,3);
			$data = array(
				'item_number' => $item_number,
						 'type' => $type,
						 'name' => $name,
					  'all_HB' => $all_HB,
					'all_SUMA' => $all_SUMA );
					
         if($date_save) {$data['tech_date']=date('Y-m-d');}
			$success = $this->save_techno($data,$item_number,$type);
			
			$techlist = array(
				'item_number'=>$item_number,
						 'type'=>$type,
              'tech_date'=>date('Y-m-d'),
					 'deleted'=>0 );
					 
         $success *= $this->save_item_techlist($techlist,$item_number,$type);
			}
	return $success;
	}



/* =========================== TECHNOLIST ================================ */
	function exists_in_techlist($item_number,$type=1)
	{
		$this->db->from('techno');
		$this->db->where('item_number', $item_number);
		$this->db->where('type', $type);
		$query = $this->db->get();
	return($query->num_rows()==1);
	}

	function get_techlist($limit=1000)
	{  
		$this->db->from('techno');
		$this->db->where('deleted','0');
		$this->db->limit($limit);
		$this->db->order_by('top_id', 'desc');
	return $this->db->get()->result_array();
	}
	
	function get_short_techlist($limit=200)
	{  
		$this->db->from('techno');
		$this->db->where('deleted','0');
		$this->db->where('item_number > 9999');		
		$this->db->limit($limit);
		$this->db->order_by('item_number', 'asc');
	return $this->db->get()->result_array();
	}
	
	function get_last_techlist($limit=35)
	{  
		$this->db->from('techno');
		$this->db->where('deleted','0');
	//	$this->db->where('item_number > 9999');		
		$this->db->limit($limit);
		$this->db->order_by('tech_date', 'desc');
	return $this->db->get()->result_array();
	}	

	/* ---- взима цялата технология по item_number и type ---- */
	function get_item_techlist($item_number,$type=1)
	{
		$this->db->from('techno');
		$this->db->where('item_number', $item_number);
		$this->db->where('type', $type);
		$this->db->where('deleted', '0');
		$query = $this->db->get();
		if ($query->num_rows()==1)
			{ return $query->row();}
		else
			{ return 0;}
	}

	function save_item_techlist( &$data,$item_number,$type=1)
	{	$group=$this->get_group($item_number);
		if (!$item_number or !$this->exists_in_techlist($item_number,$type))
		{
			if($this->db->insert('techno',$data))
			{ $data['top_id']=$this->db->insert_id();	return 1;}
		return 0;
		}
		$this->db->where('item_number', $item_number);
		$this->db->where('type', $type);
	return $this->db->update('techno',$data);
	}
		
	function reduce_tech_name($name,$reduce=60)
	{
	  $r_name = str_replace(array('=',';',':','-','+','\'',',','.','/','|','\\','%','^','#','"','&','!','$','*','(',')','~'), ' ', $name);
	return character_limiter($r_name,$reduce);
	}

	
	function uncompleted_techno($item_number,$type=1)
	{
		$success = 1;
		if( $this->exists_techno($item_number,$type) )
		{
			$techno = json_decode($this->get_techno($item_number,$type)->PM);
			if($techno)
			{
				foreach ($techno as $pm=>$manu_array)
				  {
					 foreach ($manu_array as $line=>$manu)
						{
						  if(!$manu) {$success=0;}
						}
				  } // foreach ($techno

			} // if($techno)
			else // няма манипулации изобщо
			{$success=0;}
		}
		else // няма технология
		{$success=0;}

	return $success;
	}	
	
	

/* =========================== BISOFT IMPORT TECHO DB =========================*/

	function bisoft_import_techno_db()
   {
		$msg = "bisoft_import_techno";
		$failCodes = null;
		$successCode = null;

			$myFile = 'DB-TEH.xls';

		// get BiSOFT path
		$bisoft_path = $this->BiSOFT_Model->get_path();

		$this->load->library('spreadsheetexcelreader');
      $this->spreadsheetexcelreader->setOutputEncoding('CP1251'); // Set output Encoding

		$sRoot = $_SERVER['DOCUMENT_ROOT'];
		$file_to_read = $sRoot.'/'.$bisoft_path.'/'.$myFile;
	
	// Load file from BiSOFT ....
	if (!is_readable($file_to_read))
     	{ // ГРЕШКА - връщаме се в началото на controller-a ...
			$msg = $this->lang->line('common_error_import');
			$data['error'] = $msg;
			$this->refresh($data);
     	}
	else 
		{ // тук вече зарежда нормално от BiSOFT  ... - >

		$data_file = new Spreadsheetexcelreader($file_to_read, false);
		$rowCount = $data_file->rowcount(0);

      if($rowCount > 1)
			{  // #2 if row > 1

				for($i = 2; $i<=$rowCount; $i++) 
				{  // #3 for i=1 and on ...

				  $tech_id 	 = intval( $data_file->val($i, 'A') );
				  $tech_data = array(
					'tech_id'	=> $tech_id,
					'tech_name'	=> $data_file->val($i, 'B'),
					'job_id'		=> $data_file->val($i, 'C'),
					'HB_1'		=> $data_file->val($i, 'D'),
					'tech_old'	=> $data_file->val($i, 'E')
										);

					// update of DataBase sklads - работи !!!
						if ($tech_id > 0) { if (!$this->save_db( $tech_data, $tech_id )) { $failCodes[] = $tech_id; } }

// --------------------------------------- loop
	      	} //  #3  End of every item row  FOR i= ...
	   	}
		}  //  #2 if row >1 else ...

	return 1;
	} // end #0 of BiSOFT Import


/* =========================== BISOFT IMPORT TECHO =========================*/

	function import_techno($item_number,$type=1)
   {
		if(!$item_number) {return false;}
		$msg = "import_techno";
		$failCodes = null;
		$successCode = null;

		$techno_file = '_'.str_pad(trim($item_number).$type, 8, "0", STR_PAD_LEFT).'.bls';

		// get BiSOFT path
		$bisoft_path = $this->BiSOFT_Model->get_path();
		$employee_id = $this->Employee->get_logged_in_employee_info()->person_id;

		$this->load->library('spreadsheetexcelreader');
      $this->spreadsheetexcelreader->setOutputEncoding('CP1251'); // Set output Encoding

		$sRoot = $_SERVER['DOCUMENT_ROOT'];
		$file_to_read = $sRoot.'/'.$bisoft_path.'/TEH/TECH/'.$techno_file;

	// Load file from BiSOFT ....
	if (!is_readable($file_to_read))
     	{ // ГРЕШКА ...
			$msg = $this->lang->line('common_error_import');
			$data['error'] = $msg;
			header("Location: ".BISOFT."index.php/Productions");
     	}
	else 
		{
			$data_file = new Spreadsheetexcelreader($file_to_read, false);
			$rowCount  = $data_file->rowcount(0);
			$tech_data = array();

      if($rowCount > 1)
			{
				$seria = intval( 100 * $data_file->val(4,'D') );	// $D4 = seria
				$all_HB = $data_file->val(2,'D'); 	 			// $D2 = all_HB
				$all_SUMA = $data_file->val(2,'G');				// $G2 = all_SUMA

				for($i = 6; $i<=$rowCount; $i++) 
				{  // #3 for i=1 and on ...
				  $tech_PM 	 = intval( $data_file->val($i,'A') );
				  $tech_old  = intval( $data_file->val($i,'B') );
				  if ( $tech_PM>0 ) 
						{ $tech_id=0;
							if ($this->get_tech_old($tech_old))
								{$tech_id = $this->get_tech_old($tech_old).'1';}
							$tech_data[$tech_PM][] = $tech_id;
						}
	      	} //  #3  End of FOR i= ...

				$name = '';
				if($item_number>999) 
					{
						$item_info = $this->Item->get_info_from_sgp($item_number);
						$name = $item_info->name;
					}

				$data = array(
					'item_number' => $item_number,
							 'type' => $type,
							 'name' => $name,
						  'all_HB' => $all_HB,
						'all_SUMA' => $all_SUMA,
							'seria' => $seria,
					'employee_id' => $employee_id,
					  'tech_date' => date('Y-m-d'),
						 'comment' => '',
						 		'PM' => json_encode($tech_data)
								 );

			// update of DataBase 
			if (!$this->save_techno($data,$item_number,$type)) {$failCodes[]=$item_number;}
	   	} //  #2 if row >1 else ...

		$this->calculate_techno($item_number,$type);
		} // if (!is_readable...

	return 1;
	} // end #0 of BiSOFT Import


} ?>
