<?php require_once("Analyse.php");

class Profits extends Analyse
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function get_allOnlineItems()
	{
		$this->db->select('item_number',	false);
		$this->db->from('eShop_online_items');
		$this->db->where('item_number BETWEEN 10000 and 98000');
		$this->db->where('qty > 0');
		$this->db->where('deleted',0);
		$this->db->order_by('item_number', 'acs');
	return $this->db->get()->result_array();
	}
	
	public function get_skladItems()
	{
		$this->db->select('
						inum,
						skl,
						qty,
						del',	false);
						
		$this->db->from('sklad');
		$this->db->where('inum BETWEEN 10000 and 98000');
		$this->db->where('skl',0);
		$this->db->where('qty > 0');
		$this->db->where('del',0);
		$this->db->order_by('inum', 'acs');
	return $this->db->get()->result_array();
	}
	
	public function getDataColumns($type='sale')
	{
		return array(
				$this->lang->line('reports_date_period'),	// 1
				$this->lang->line('reports_item'),	// 2
				$this->lang->line('reports_item_name'),			// 3
				$this->lang->line('reports_quantity'),		// 4
				$this->lang->line('reports_suma'),			// 5
				$this->lang->line('reports_invoice_vat'),	// 6
				$this->lang->line('reports_customer').' / '.$this->lang->line('reports_supplier'),		// 7
		//		$this->lang->line('reports_profit'),		
				$this->lang->line('reports_type')			// 8
				);
	}
	
	public function getData(array $inputs)
	{	
		$mode  = $inputs['type'];
		$join_groups = $inputs['join_groups'];
		
		$brand = $inputs['brand'];
		$vedom = $inputs['vedom'];
		
		$db_sales 		 = 'V'.$vedom;
		$db_sales_items = $db_sales . '_items';
		$item_range = $this->get_range($inputs['item']);
		
		$group = 0;
		if($inputs['item']=='styler')        { $group = 'styler'; }
		elseif($inputs['item']=='macka')     { $group = 'macka'; }
		elseif($inputs['item']=='fenotag')   { $group = 'fenotag'; }
		elseif($inputs['item']=='ties')      { $group = 'ties'; }
		elseif($inputs['item']=='bowties')   { $group = 'bowties'; }
		elseif($inputs['item']=='belts')     { $group = 'belts'; }
		elseif($inputs['item']=='accs')      { $group = 'accs'; }
		elseif($inputs['item']=='oldaccs')   { $group = 'oldaccs'; }
		elseif($inputs['item']=='old')       { $group = 'old'; }
		elseif($inputs['item']=='vitality')  { $group = 'vitality'; }
		elseif(is_numeric($inputs['item']) and strlen($inputs['item'])==2)
		{ $group = (int)$inputs['item']; }
		
		
		$this->db->select('
						line,
						mode_id,
						doc_number,
						doc_date,
						item_number,
						item_name, 
						brand, 
					sum(item_qty) 		             as all_qty,
					sum(item_unit_price*item_qty)  as subtotal, 
					sum(item_taxes*0.2*item_qty*item_unit_price)	as tax,
                  order_id,
						client_id,
						supplier_id,
						location',	false);

		$this->db->from($db_sales_items);
		$this->db->where('deleted',0);
		
		if($brand>0 and $vedom>1800) // само за BRANDS
		{
			$this->db->where("brand",$brand);
			switch ($mode) 
				{
					case 'all_sale':		$this->db->where('mode_id in ("E", "BE")'); break;
					case 'sale':			$this->db->where('mode_id in ("E", "BE")'); break;
					case 'macka_sale':	$this->db->where('mode_id in ("E", "BE")'); break;
					case 'fenotag':		$this->db->where('mode_id in ("E", "BE")'); break;
					case 'invoice': 		$this->db->where('mode_id in ("F", "Ki", "Di")'); break;
				}
		}
		else // всички останали
		{
			switch ($mode) 
				{
					case 'all_sale':		$this->db->where('mode_id in ("E", "BE", "SE", "BP", "OM", "OMi", "OMB")'); break;
					case 'sale':			$this->db->where('mode_id in ("E", "BE")'); break;
					case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');	break;
					case 'online':			$this->db->where('mode_id in ("OM", "OMi", "OMB")'); break;
					case 'macka_sale':	$this->db->where('mode_id in ("E", "BE")'); break;
					case 'fenotag':		$this->db->where('mode_id in ("E", "BE")'); break;
					case 'all_recv':		$this->db->where('mode_id in ("MK", "D", "BD")');	break;
					case 'manu':			$this->db->where('mode_id', 'MK');				break;
					case 'macka':			$this->db->where('mode_id', 'MSK');				break;
					case 'recv':			$this->db->where("mode_id in ('D', 'BD')"); 	break;
					case 'invoice': 		$this->db->where('mode_id in ("F", "Ki", "Di", "Pr")'); break;
				}
		}

		
		if(is_numeric($group) and $group>6 and $group<99)  // значи е ГРУПА диапазон xx-000 - xx-999 ...
			{ $this->db->where('item_number BETWEEN "'.$item_range['item_min'].'" and "'.$item_range['item_max'].'"'); }
		
		elseif($item_range['item']>999 and $item_range['item']<99000) // значи е само АРТИКУЛ
			{ $this->db->where('item_number',$inputs['item']); }	
			
      // маски
		elseif($mode=="macka_sale" or $mode=="macka") { $this->db->where('item_number BETWEEN "98100" and "98300"'); }
		
      // fenotags
		elseif($mode=="fenotag")   { $this->db->where('item_number BETWEEN "7000" and "7999"'); }	
			
      // спомагателни:
      elseif($group=="styler")   { $this->db->where('item_number BETWEEN "10000" and "98000"'); } 	// STYLER Clothes
      
      elseif($group=="macka")    { $this->db->where('item_number BETWEEN "98100" and "98300"'); } 	// маски
      elseif($group=="fenotag")  { $this->db->where('item_number BETWEEN "7000" and "7999"');   } 	// fenotags  //  die('FENO');
      
      elseif($group=="ties")     { $this->db->where('item_number BETWEEN "10000" and "10249"'); }
      elseif($group=="bowties")  { $this->db->where('item_number BETWEEN "10250" and "10300"'); }
      elseif($group=="belts")    { $this->db->where('item_number BETWEEN "20000" and "20999"'); }
      elseif($group=="accs")     { $this->db->where('item_number BETWEEN "10000" and "10599"'); }
      elseif($group=="vitality") { $this->db->where('item_number BETWEEN "22000" and "23999"'); }
      
      elseif($group=="oldaccs")  { $this->db->where('item_number BETWEEN "98001" and "98050"'); }
		elseif($group=="old")    	{ $this->db->where('item_number BETWEEN "98065" and "98097"'); }
		
		elseif($mode=='invoice') // значи е само Фактура ...
			{ $this->db->where('item_number',$inputs['item']); }		
		
		elseif($item_range['item']==-1) {} // значи  ALL *
		
		
		if($inputs['customer'])  { $this->db->where('client_id',$inputs['customer']); }
		if($inputs['consignee']) { $this->db->where('client_id',$inputs['consignee']); }
		if($inputs['supplier'])  { $this->db->where('supplier_id',$inputs['supplier']); }

		// спец. задарения САМО ЗА БЧК - при по-добра идея да се премахне ?!
		if($inputs['customer']!='1345' and ($mode=='sale' or $mode=='all_sale') ) // БЧК
		{ $this->db->where("client_id!=1345"); }
		
		$this->db->group_by('item_number, mode_id');
		$this->db->order_by('item_number', 'asc');

	return $this->db->get()->result_array();
	}
	

	public function getSummaryData(array $inputs)
	{
		$mode = $inputs['type'];
		$db_sales 		 = 'V'.$inputs['vedom'];
		$db_sales_items = $db_sales . '_items';
		$item_range = $this->get_range($inputs['item'],$mode);
		
		$group = 0;
		if($inputs['item']=='styler')     { $group = 'styler'; }
		elseif($inputs['item']=='macka')  { $group = 'macka'; }
		elseif($inputs['item']=='ties')   { $group = 'ties'; }
		elseif($inputs['item']=='bowties')   { $group = 'bowties'; }
		elseif($inputs['item']=='belts')  { $group = 'belts'; }
		elseif($inputs['item']=='accs')   { $group = 'accs'; }
		elseif($inputs['item']=='oldaccs')   { $group = 'oldaccs'; }
		elseif($inputs['item']=='old')    { $group = 'old'; }
		elseif($inputs['item']=='vitality') { $group = 'vitality'; }
		elseif(is_numeric($inputs['item']) and strlen($inputs['item'])==2)
		{ $group = (int)$inputs['item']; }

		$this->db->select('sum(item_qty) as all_quantity, sum(item_qty*item_unit_price*(100-item_discount)/100) as total');
		$this->db->from($db_sales_items);
		$this->db->where('deleted',0);

			switch ($mode) 
				{
					case 'all_sale':		$this->db->where('mode_id in ("E", "BE", "SE", "BP", "OM", "OMi", "OMB")');	break;
					case 'sale':			$this->db->where('mode_id in ("E", "BE")'); break;
					case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');	break;
					case 'online':			$this->db->where('mode_id in ("OM", "OMi")'); break;
					case 'all_recv':		$this->db->where('mode_id in ("MK", "D", "BD")');	break;
					case 'manu':			$this->db->where('mode_id', 'MK');
					case 'macka':			$this->db->where('mode_id', 'MSK');		break;
					case 'recv':			$this->db->where("mode_id in ('D', 'BD')"); 	break;
					case 'invoice': 		$this->db->where('mode_id in ("F", "Ki", "Di", "Pr")'); break;
				}

		if($item_range['item']==-1) {} // значи  ALL *
		elseif ($item_range['item']>0 or $mode=='invoice') // значи е само АРТИКУЛ или Фактура ...
			{ $this->db->where('item_number',$inputs['item']); }
			
		elseif($group>9 and $group<99)  // значи е ГРУПА диапазон xx-000 - xx-999 ...
			{ $this->db->where('item_number BETWEEN "'.$item_range['item_min'].'" and "'.$item_range['item_max'].'"'); }
			
      elseif($mode=="macka_sale" or $mode=="macka") { $this->db->where('item_number BETWEEN "98100" and "98300"'); }
      
      // спомагателни:
      elseif($group=="styler")   { $this->db->where('item_number BETWEEN "10000" and "98000"'); } // STYLER Clothes
      elseif($group=="macka")    { $this->db->where('item_number BETWEEN "10600" and "10800"'); } // пакети маски
      elseif($group=="ties")     { $this->db->where('item_number BETWEEN "10000" and "10249"'); }
      elseif($group=="bowties")  { $this->db->where('item_number BETWEEN "10250" and "10300"'); }
      elseif($group=="belts")    { $this->db->where('item_number BETWEEN "20000" and "20999"'); }
      elseif($group=="accs")     { $this->db->where('item_number BETWEEN "10250" and "10599"'); }
      
      elseif($group=="oldaccs")  { $this->db->where('item_number BETWEEN "98001" and "98050"'); }
		elseif($group=="old")      { $this->db->where('item_number BETWEEN "98065" and "98097"'); }

		if($inputs['customer'])  { $this->db->where('client_id',$inputs['customer']); }
		if($inputs['consignee']) { $this->db->where('client_id',$inputs['consignee']); }
		if($inputs['supplier'])  { $this->db->where('supplier_id',$inputs['supplier']); }
		
	return $this->db->get()->row_array();	
	}

	function get_range($item=0,$mode='sale')
	{
		if($item=='macka') // само за маски
		{
			$item_min = 98100;
			$item_max = 98300; // да се промени ако надвиши 98300 ?!
		}
		elseif($item=='styler') // само за STYLER дрехи
		{
			$item_min = 10000;
			$item_max = 98000;
		}
		elseif($item=='vitality') // само за Vitality дрехи
		{
			$item_min = 22000;
			$item_max = 23999;
		}
		elseif(is_numeric($item)) // за нормалните извадки $item!='all'
		{
			$leng = strlen($item);
			if ($leng ==2 and $mode!='invoice')  // значи е ГРУПА
				{
					$item_min = 1000 * $item;
					$item_max = 1000 * $item + 999;
					$item = 0;
				}
			elseif ($leng < 3 and $mode=='invoice')  // значи е фактура
				{
					$item_min = $item_max = 0;
					// $item = 0;
				}
			else // значи е АРТИКУЛ
				{  $item_min = $item_max = 0; }
		}

		else // само за "ALL"
		{ $item_min = $item_max = 0; $item = -1;}

		$data = array( 'item' => $item,
							'item_min' => $item_min,
							'item_max' => $item_max	);
	return $data;
	}
	
	
/* ========================== ONLINES ======================= */
	public function getOnlinesColumns($join_groups=0)
	{
		if($join_groups)
		{
			return array(
				'група',												// 1
				$this->lang->line('reports_item_name'),	// 2
				$this->lang->line('reports_instock'),		// 3
				$this->lang->line('reports_sold_to'),		// 4
				$this->lang->line('reports_aver_price'),	// 5
				$this->lang->line('reports_suma'),			// 6
				
						);
		}
		else
		{
			return array(
				$this->lang->line('reports_item'),			// 1
				$this->lang->line('reports_item_name'),	// 2
				$this->lang->line('reports_instock'),		// 3
				$this->lang->line('reports_sold_to'),		// 4
				$this->lang->line('reports_aver_price'),	// 5
				$this->lang->line('reports_suma'),			// 6
				
				
						);
		}
	}
	
	public function getOnlinesData(array $inputs)
	{	
		$mode  = $inputs['type'];
		$vedom = $inputs['vedom'];
		
		$db_sales 		 = 'V'.$vedom;
		$db_sales_items = $db_sales . '_items';
		$item_range = $this->get_range($inputs['item']);

		$this->db->select('
						line,
						mode_id,
						doc_number,
						doc_date,
						item_number,
						item_name,
						item_unit_price,
					sum(item_qty) 		             as all_qty,
					sum(item_unit_price*item_qty)  as subtotal, 
						location',	false);
		
		$this->db->from($db_sales_items);
		$this->db->where('mode_id in ("OM", "OMi", "OMB")'); // , "OMB"
		$this->db->where('deleted',0);
		$this->db->where('location',0);

		if($item_range['item']==-1 or $item_range['item']=='styler') 
			{ $this->db->where('item_number BETWEEN 18000 and 98000'); } // значи  ALL *
		elseif ($item_range['item']>0) // значи е само АРТИКУЛ ...
			{ $this->db->where('item_number',$inputs['item']); }
		else  // значи е ГРУПА диапазон xx-000 - xx-999 ...
			{ $this->db->where('item_number BETWEEN "'.$item_range['item_min'].'" and "'.$item_range['item_max'].'"'); }

		$this->db->group_by('item_number');
		$this->db->order_by('item_number', 'asc');

	return $this->db->get()->result_array();
	}



} ?>
