<?php require_once("Report.php");

class Daily_sales extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
		// взимам си размерите ...
		$size_table = $this->BiSOFT_Model->get_sizes('grid_2');

		return array(
						$this->lang->line('reports_item_number'), 
						$this->lang->line('reports_name'),
						'(1)','(2)','(3)','(4)','(5)',
						'(6)','(7)','(8)','(9)','(10)',
						$this->lang->line('reports_items_qty'), 
						$this->lang->line('reports_unit_price'), 
						$this->lang->line('reports_disc'), 
						$this->lang->line('reports_daily_price'), 
						$this->lang->line('reports_suma'),
						$this->lang->line('reports_report'),
						$this->lang->line('reports_shop_pay'),
						$this->lang->line('reports_type'),
						$this->lang->line('reports_magazin')
					);
	}
	
	public function getData(array $inputs)
	{
		// Взима правилната DB ... по обекти ...
		$location = $this->BiSOFT_Model->get_location();
		$daily_date = date('Y-m-d', strtotime( $inputs['start_date'] ));

			$vedom	 	 	 = date('ym', strtotime( $inputs['start_date'] ));
			$db_sales 		 = 'V'.$vedom;
			$db_sales_items = $db_sales . '_items';

		$this->db->select('
					doc_id,
					mode_id,
					doc_number,
					doc_date,
					item_number,
					item_name,
					item_qty, 
					item_unit_price, 
					item_discount,
					item_taxes,
					costsale,
					location',	false);

		$this->db->from( $db_sales_items);

		if ( $location == 0 ) 
		{ 
			switch ($inputs['sale_type']) 
				{
					case 'all':	$this->db->where("mode_id in ('E', 'BE', 'SE', 'BP', 'OM', 'OMi')");	break;
					case 'all_sgp': $this->db->where("mode_id in ('E', 'BE')");	break;
					case 'sale':			$this->db->where("mode_id in ('E', 'BE')");	break;
					case 'sale_return':	$this->db->where('mode_id', 'BE');	break;
					case 'online_sale': 	$this->db->where("mode_id in ('OM', 'OMi')");	break;
					case 'all_shop': 		$this->db->where("mode_id in ('SE', 'BP')");	break;
					case 'shop_sale':		$this->db->where("mode_id in ('SE', 'BP')");	break;
					case 'shop_return':	$this->db->where('mode_id', 'BP');	break;
				}
		}
		else
		{
			$this->db->where('location', $location);
			switch ($inputs['sale_type']) 
				{
					case 'all':	$this->db->where("mode_id in ('SE', 'BP')");	break;
					case 'shop_sale':		$this->db->where('mode_id', 'SE');	break;
					case 'shop_return':	$this->db->where('mode_id', 'BP');	break;
				}
		}

		$this->db->where('doc_date', $daily_date);
		$this->db->where('deleted = 0');
		$this->db->order_by('doc_id');

	return $this->db->get()->result_array();
	}
	
	
	public function getKacaColumns()
	{
		return array(
				$this->lang->line('reports_doc').' No', 
				$this->lang->line('reports_customer'),
				$this->lang->line('reports_kaca_name').' / '.$this->lang->line('reports_description'),
				$this->lang->line('kaca_total'),
				$this->lang->line('reports_payments'),
				$this->lang->line('reports_Pay_Sale') );
	}
	
	// SALDO
	public function exists_saldo($daily_date)
	{	
		$vedomPack = 'K'.date('Y', strtotime( $daily_date ));
		$this->db->from( $vedomPack);
		$this->db->where('doc_date',$daily_date);
		$this->db->where('mode_id','SD');
		$this->db->where('deleted = 0');
		$query = $this->db->get();
	return ($query->num_rows()>0);
	}

	public function get_saldo($daily_date)
	{
		if(null!=$daily_date)
		{ $vedomPack = 'K'.date('Y', strtotime( $daily_date ));}
		else { $vedomPack = 'K'.date('Y'); }
		
		$this->db->from( $vedomPack);
		$this->db->where('doc_date', $daily_date);
		$this->db->where('mode_id','SD');
		$this->db->where('deleted', 0);
		$query = $this->db->get();
		if($query->num_rows()==1)
		{ return $query->row();}
		else {return 0;}
	}
	
	public function save_saldo($daily_date,$saldo_data)
	{
		$vedomPack = 'K'.date('Y', strtotime( $daily_date ));
		if(!$this->exists_saldo($daily_date))
			{ 	return $this->db->insert($vedomPack,$saldo_data);}
		else	
			{ 
				$this->db->where('doc_date',$daily_date);
				$this->db->where('mode_id','SD');
				return $this->db->update($vedomPack,$saldo_data);
			}
	}
	
	public function update_saldo($daily_date,$saldo_data)
	{
		$vedomPack = 'K'.date('Y', strtotime( $daily_date ));
		if($this->exists_saldo($daily_date))
		{
			$this->db->where('doc_date',$daily_date);
			$this->db->where('mode_id','SD');
			return $this->db->update($vedomPack,$saldo_data);
		}
		else {return 0;}
	}
	
	
	public function getKacaSales($daily_date)
	{
		$location = $this->BiSOFT_Model->get_location();
		if(null!=$daily_date)
		{$vedom	 = date('ym', strtotime( $daily_date ));}
		else {$vedom = date('ym');}
		$db_sales = 'V'.$vedom;

		$this->db->from( $db_sales);
		$this->db->where("mode_id in ('E', 'BE')");
		$this->db->where('doc_date', $daily_date);
		$this->db->where('deleted = 0');
		$this->db->order_by('doc_id');

	return $this->db->get()->result_array();
	}
	
	public function getKACA($daily_date)
	{
		$location = $this->BiSOFT_Model->get_location();
		if(null!=$daily_date)
		{$db_KACA = 'K'.date('Y', strtotime( $daily_date ));}
		else {$db_KACA = 'K'.date('Y');}

		$this->db->from($db_KACA);
		$this->db->where("mode_id in ('KPr', 'KRz')");
		$this->db->where('doc_date', $daily_date);
		$this->db->where('deleted = 0');
		$this->db->order_by('doc_id');

	return $this->db->get()->result_array();
	}
	
	public function save_dKACA(&$doc_data,$daily_date)
	{
		if(null!=$daily_date)
		{$vedomPack = 'K'.date('Y',strtotime($daily_date));}
		else {$vedomPack = 'K'.date('Y');}
		$this->db->trans_start();
			$this->db->insert( $vedomPack, $doc_data);
			$doc_id = $this->db->insert_id();
		$this->db->trans_complete();

		if ($this->db->trans_status() === FALSE)	{ return -1;}
	return $doc_id;
	}
	
	public function update_dKACA($doc_data,$daily_date,$doc_id)
	{
		if(null!=$daily_date)
		{ $vedomPack = 'K'.date('Y',strtotime($daily_date));}
		else {$vedomPack = 'K'.date('Y');}
		$this->db->where('doc_id', $doc_id);
		$success = $this->db->update( $vedomPack, $doc_data );
	return $success;
	}
	
	public function delete_dKACA_row($vedomPack,$doc_id)
	{
		$this->db->trans_start();
         $this->db->delete( $vedomPack, array('doc_id'=>$doc_id)); 
      $this->db->trans_complete();
      return $this->db->trans_status();
	}
	

	// Сумарна информация ...............
	public function getSummaryData(array $inputs)
	{
		$result = 0;
		$mode = $inputs['sale_type'];
		$start_date = $inputs['start_date'];
		$vedom = 'V'.date('ym',strtotime($start_date));

		if($mode=='shop_sale' or $mode=='online_sale')
		{
			$this->db->from($vedom);
			$this->db->where("mode_id in ('OM', 'OMi')");
			$this->db->where('doc_date', $start_date);
			$this->db->where('deleted = 0');
			$query = $this->db->get();
			$result = $query->num_rows();
		}
	return $result;
	}


	public function getPayment(array $inputs)
	{
		// Взима правилната DB ... по обекти ...
		$daily_date = date('Y-m-d', strtotime( $inputs['start_date'] ));
			$vedom	 	 	 = date('ym', strtotime( $inputs['start_date'] ));
			$db_sales 		 = 'V'.$vedom;

		$this->db->select('pay_type',	false);
		$this->db->from( $db_sales);
		$this->db->where('doc_id', $inputs['doc_id']);

	return $this->db->get()->result_array();
	}
	
	public function getGiftprocent($doc_id,$start_date)
	{
		// Взима правилната DB ... по обекти ...
		$daily_date = date('Y-m-d', strtotime( $start_date ));
			$vedom	 	 	 = date('ym', strtotime( $start_date ));
			$db_sales 		 = 'V'.$vedom;
		$this->db->select('giftprocent',false);
		$this->db->from( $db_sales);
		$this->db->where('doc_id', $doc_id);
		$query = $this->db->get();
		if($query->num_rows()==1)
		{ return $query->row()->giftprocent;}
	return 0;
	}
	
	public function getGiftvalue($doc_id,$start_date)
	{
		// Взима правилната DB ... по обекти ...
		$daily_date = date('Y-m-d', strtotime( $start_date ));
			$vedom	 	 	 = date('ym', strtotime( $start_date ));
			$db_sales 		 = 'V'.$vedom;
		$this->db->select('giftvalue',false);
		$this->db->from( $db_sales);
		$this->db->where('doc_id', $doc_id);
		$query = $this->db->get();
		if($query->num_rows()==1)
		{ return $query->row()->giftvalue;}
	return 0;
	}

} ?>
