<?php require_once("Report.php");

class Detailed_invoices extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
	// взимам си размерите ...
	$size_table = $this->BiSOFT_Model->get_sizes('grid_2');

	return array(	
			'summary' => array(
					'inv_id'	=> $this->lang->line('reports_invoice_id'),	// 1
					'date' 	=> $this->lang->line('reports_date'), 			// 2
					'suma' 	=> $this->lang->line('reports_suma'),			// 3
					'vat' 	=> $this->lang->line('reports_invoice_vat'),	// 4
					'total' 	=> $this->lang->line('reports_total'),			// 5
					'pay' 	=> $this->lang->line('reports_pay'),			// 6
				 'payments' => $this->lang->line('reports_payments'),		// 7
					'client' => $this->lang->line('reports_customer'),		// 8
					'sold_by'=> $this->lang->line('reports_employee'),		// 9
					'type' 	=> $this->lang->line('reports_type'),			// 10
				  'comment' => $this->lang->line('reports_comments')),	// 11

			'details' => array(
								'',
								$this->lang->line('reports_line'),
								$this->lang->line('reports_item_number'), 
								$this->lang->line('reports_name'), 
								$this->lang->line('reports_quantity_purchased'), 
								$this->lang->line('reports_unit_price'), 
								$this->lang->line('reports_disc'), 
								$this->lang->line('reports_daily_price'),
								$this->lang->line('reports_suma')
								)
				);		
	}
	

	public function getData(array $inputs)
	{
		$mode = 'invoice';

		// Взима правилната DB ... по обекти ...
		$location = $this->BiSOFT_Model->get_location();
		$firma	 = $inputs['firma'];
		
			$daily_YEAR 	 = date('ym', strtotime( $inputs['end_date'] ));
			$db_sales 		 = 'V'.$daily_YEAR ;
			$db_sales_items = $db_sales . '_items';

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('location',$firma);
		$this->db->where('deleted',0);

			switch ($inputs['sale_type']) 
				{
					case 'all': $this->db->where('mode_id in ("F", "Ki", "Di", "Pr")');	break;
					case 'invoice':		$this->db->where('mode_id = "F"');	break;
					case 'invoice_ki':	$this->db->where('mode_id = "Ki"');	break;
					case 'invoice_di':	$this->db->where('mode_id = "Di"');	break;
					case 'invoice_pr':	$this->db->where('mode_id = "Pr"');	break;
					case 'proforma':		$this->db->where('mode_id = "PF"');	break;
				}

		$this->db->group_by('doc_id');
		$this->db->order_by('doc_number', 'asc');

		$data = array();
		$data['summary'] = $this->db->get()->result_array();

		// тук теглим детайлите .....
		$data['details'] = array();
		foreach($data['summary'] as $key=>$value)
		{
			$this->db->select('
					line,
					mode_id,
					doc_number,
					doc_date,
					item_number, 
					item_name,
					invoice_name,
					item_qty, 
					item_unit_price, 
					item_discount,
					item_taxes,
					costsale,
					client_id,
					location',	false);

			$this->db->from($db_sales_items);
			$this->db->where('doc_id',$value['doc_id']);
			$this->db->where('location',$firma);
			$this->db->where('deleted',0);
			$data['details'][$key] = $this->db->get()->result_array();
		}
	return $data;
	}


	// Сумарна информация ...............
	public function getSummaryData(array $inputs)
	{
		$mode = 'invoice';
		$firma = $inputs['firma'];

		// Взима правилната DB ... по обекти ...
		$location = $this->BiSOFT_Model->get_location();

			$daily_YEAR 	 = date('ym', strtotime( $inputs['end_date'] ));
			$db_sales 		 = 'V'.$daily_YEAR ;
			$db_sales_items = $db_sales . '_items';

		$this->db->select('
				sum(total_qty) as total_qty,
				sum(total_sum) as total_sum,
				sum(total_taxes) as total_vat,
				sum(pay_sale) as total_cost,
				sum(due_sum) as total_due,
				sum(pay_amount) as total_all');

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('location',$firma);
		$this->db->where('deleted',0);

			switch ($inputs['sale_type']) 
				{
				case 'all': $this->db->where('mode_id in ("F", "Ki", "Di", "Pr")');	break;
				case 'invoice':		$this->db->where('mode_id = "F"');	break;
				case 'invoice_ki':	$this->db->where('mode_id = "Ki"');	break;
				case 'invoice_di':	$this->db->where('mode_id = "Di"');	break;
				case 'invoice_pr':	$this->db->where('mode_id = "Pr"');	break;
				case 'proforma':		$this->db->where('mode_id', 'PF');	break;
				}
		
	return $this->db->get()->row_array();
	}

} ?>
