<?php require_once("Report.php");

class Detailed_recvs extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
	// взимам си размерите ...
	$size_table = $this->BiSOFT_Model->get_sizes('grid_2');

		return array('summary' => array(
				$this->lang->line('reports_receiving_id'), // 1
				$this->lang->line('reports_date'), // 2
				$this->lang->line('reports_items_qty'),  // 3
				$this->lang->line('reports_suma'),  // 4
				$this->lang->line('reports_discount'), // 5
				$this->lang->line('reports_total'),  // 6
				$this->lang->line('reports_supplied_by'), // 7
				$this->lang->line('reports_received_by'),  // 8
				$this->lang->line('reports_type'),  // 9
				$this->lang->line('reports_location')  // 10
						),
	
			'details' => array(
								$this->lang->line('reports_line'),
								$this->lang->line('reports_item_number'), 
								$this->lang->line('reports_name'), 
								$this->lang->line('reports_items_qty'),
								$this->lang->line('reports_unit_price'), 
									 	$size_table->size_1, 
										$size_table->size_2, 
										$size_table->size_3,
										$size_table->size_4,
										$size_table->size_5,
										$size_table->size_6,
										$size_table->size_7,
										$size_table->size_8,
										$size_table->size_9,
										$size_table->size_max,
								)
			);		
	}
	

	public function getData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_recvs = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_recvs_items = $db_recvs . '_items';

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number,
				doc_date,
				total_qty, 
				total_sum, 
				total_discount,
				taxed,
				total_taxes,
				pay_group,
				pay_type,
				pay_amount,
				pay_sale,
				due_sum,
				client_id,
				supplier_id,
				employee_id,
				comment,
				location',	false);

		$this->db->from($db_recvs);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

		if ( $location == 0 ) 
		{ 
			switch ($mode) 
				{
					case 'manu':			$this->db->where('mode_id', 'MK');				break;
					case 'macka':			$this->db->where('mode_id', 'MSK');				break;
					case 'recv':			$this->db->where("mode_id in ('D', 'BD')"); 	break;
					case 'consi':			$this->db->where("mode_id in ('C', 'CB')"); 	break;
				}
		}
		else
		{
			$this->db->where('location', $location);
			switch ($mode)  
				{
					case 'all':				$this->db->where("mode_id in ('C', 'CB')"); 		break;
					case 'balance':		$this->db->where('mode_id in ("BL", "SBL")');	break;
					case 'brak':			$this->db->where('mode_id', 'AB');					break;
					case 'revision':		$this->db->where('mode_id', 'R');					break;
				}
		}

		$this->db->group_by('doc_id');
		$this->db->order_by('doc_date, doc_id', 'asc');

		$data = array();
		$data['summary'] = $this->db->get()->result_array();

		$data['details'] = array();
		foreach($data['summary'] as $key=>$value)
		{
		$this->db->select('
					line,
					mode_id,
					doc_number,
					doc_date,
					item_number,
					item_name,
					item_qty, 
					item_unit_price, 
					item_discount,
					item_taxes,
					costsale,
					location',	false);

			$this->db->from($db_recvs_items);
			$this->db->where('doc_id = '.$value['doc_id']);
			$data['details'][$key] = $this->db->get()->result_array();
		}
	return $data;
	}


	
	public function getSummaryData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_recvs = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_recvs_items = $db_recvs . '_items';

		$this->db->select('
				sum(total_qty) as total_qty,
				sum(total_sum) as total_sub,
				sum(total_taxes) as total_vat,
				sum(pay_sale) as total_cost,
				sum(due_sum) as total_due,
				sum(pay_amount) as total_sum');

		$this->db->from($db_recvs);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

		if ( $location == 0 ) 
		{ 
			switch ($mode) 
				{
					case 'manu':			$this->db->where('mode_id', 'MK');				break;
					case 'macka':			$this->db->where('mode_id', 'MSK');				break;
					case 'recv':			$this->db->where("mode_id in ('D', 'BD')"); 	break;
					case 'consi':			$this->db->where("mode_id in ('C', 'CB')"); 	break;
				}
		}
		else
		{
			$this->db->where('location', $location);
			switch ($mode)  
				{
					case 'all':				$this->db->where("mode_id in ('C', 'CB')"); 		break;
					case 'balance':		$this->db->where('mode_id in ("BL", "SBL")');	break;
					case 'brak':			$this->db->where('mode_id', 'AB');					break;
					case 'revision':		$this->db->where('mode_id', 'R');					break;
				}
		}

	return $this->db->get()->row_array();
	}

} ?>
