<?php require_once("Report.php");

class Detailed_sales extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
	// взимам си размерите ...
	$size_table = $this->BiSOFT_Model->get_sizes('grid_2');

	return array(	
			'summary' => array(
					$this->lang->line('reports_sale_id'), 		// 1
					$this->lang->line('reports_date'), 			// 2
					$this->lang->line('reports_items_qty'),  	// 3
					$this->lang->line('reports_SUMA'),			// 4
					$this->lang->line('reports_discount'), 	// 5
					$this->lang->line('reports_invoice_vat'), // 6
					$this->lang->line('reports_gros_sales'),  // 7
					$this->lang->line('reports_pay_sale'),		// 8
					$this->lang->line('reports_payments'), 	// 9
					$this->lang->line('reports_sold_to'), 		// 10
					$this->lang->line('reports_brands'),  		// 11
					$this->lang->line('reports_sold_by'),  	// 12
					$this->lang->line('reports_doc')  	      // 13
						),

			'details' => array(
								'',
								$this->lang->line('reports_line'),
								$this->lang->line('reports_item_number'), 
								$this->lang->line('reports_name'), 
								$this->lang->line('reports_items_qty'), 
								$this->lang->line('reports_unit_price'), 
								$this->lang->line('reports_disc'), 
								$this->lang->line('reports_daily_price'),
								$this->lang->line('reports_costsale'),
									 	$size_table->size_1, 
										$size_table->size_2, 
										$size_table->size_3,
										$size_table->size_4,
										$size_table->size_5,
										$size_table->size_6,
										$size_table->size_7,
										$size_table->size_8,
										$size_table->size_9,
										$size_table->size_max,
								)
				);		
	}
	

	public function getData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_sales = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		if(!$this->BiSOFT_Model->is_database_exists($db_sales))
			{echo 'STOPPED! NOT EXISTS --> DB: '.$db_sales;die();}
			
      $firma = $this->BiSOFT_Model->get_firma_key();

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted',0);

		if ( $location == 0 ) 
		{ 
			switch ($mode) 
				{
               case 'all_sales':	   $this->db->where("mode_id in ('E', 'BE', 'SE', 'BP','OM', 'OMi', 'OMB')");	
                                    if($firma['styler'])
                                    { $this->db->where("client_id != '1359' AND client_id != '1180' AND client_id != '1262' AND client_id != '1226'"); }
                                    break;
               case 'all_total':	   $this->db->where("mode_id in ('E', 'BE', 'SE', 'BP','OM', 'OMi', 'OMB')");	break;
               case 'sale':			$this->db->where("mode_id in ('E', 'BE')");		
                                    if($firma['styler'])
                                    { $this->db->where("client_id != '1359' AND client_id != '1180' AND client_id != '1262' AND client_id != '1226'"); }
												break;
               case 'shop_sale':		$this->db->where("mode_id in ('SE', 'BP')");		break;
               case 'online_sale':	$this->db->where("mode_id in ('OM', 'OMi', 'OMB')");	break;
      //       case 'mackas':			$this->db->where("mode_id in ('E', 'BE')");		break; // изместено другаде
      //       case 'fenotags':		$this->db->where("mode_id in ('E', 'BE')");		break; // изместено другаде
               case 'online_return':$this->db->where("mode_id in ('OMB')");	      break;
				}
		}
		else
		{
			$this->db->where('location', $location);
			switch ($mode) 
				{
					case 'all_shops':	   $this->db->where("mode_id in ('SE', 'BP')");	break;
					case 'shop_sale':		$this->db->where('mode_id', 'SE'); break;
					case 'shop_return':	$this->db->where('mode_id', 'BP'); break;
				}
		}

		$this->db->group_by('doc_id');
		$this->db->order_by('doc_date, doc_id', 'asc');

		$data = $data['mackas'] = $data['fenotags'] = array();
		
		if($mode=="all_sales") // продажба САМО ДРЕХИ
		{
         // тук теглим детайлите .....
         $data['summary'] = $data['details'] = array();
         $all_data = $this->db->get()->result_array(); // $data['summary']
         
         foreach($all_data as $key=>$value)
         {
            $this->db->select('
                     doc_id,
                     line,
                     mode_id,
                     doc_number,
                     doc_date,
                     item_number,
                     item_name,
                     item_qty, 
                     item_unit_price, 
                     item_discount,
                     item_taxes,
                     costsale,
                     location', false);

            $this->db->from($db_sales_items);
            $this->db->where('doc_id = '.$value['doc_id']);
   //			$this->db->where("item_number BETWEEN '10000' and '97999'"); // само дрехи
            $this->db->where('deleted',0);
            
            $clothes_rows = $this->db->get()->result_array();
            if(count($clothes_rows)>0)
            { 
               if($firma['styler'])
               {
                  $keyClothes = 0;
                  foreach($clothes_rows as $iRow)
                  {
                     $inum = $iRow['item_number'];
                     if($inum > 10000 and $inum < 97999)  { $keyClothes = 1; }
                  }
               }
               else { $keyClothes = 1; }

               if($keyClothes)
               {
                  $data['summary'][$key] = $value; 
                  $data['details'][$key] = $clothes_rows; 
               }
            }
         }	// foreach($all_data	

      }
      else // всички други
      {
         $data['summary'] = $this->db->get()->result_array();
         $data['details'] = array();
         foreach($data['summary'] as $key=>$value)
         {
            $this->db->select('
                     doc_id,
                     line,
                     mode_id,
                     doc_number,
                     doc_date,
                     item_number,
                     item_name,
                     item_qty, 
                     item_unit_price, 
                     item_discount,
                     item_taxes,
                     costsale,
                     location', false);

            $this->db->from($db_sales_items);
            $this->db->where('doc_id = '.$value['doc_id']);
            $this->db->where('deleted',0);
            
            $data['details'][$key] = $this->db->get()->result_array();
         }
		}
        
	return $data;
	}
	
	
	public function getMackaData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = 'mackas';
		$db_sales = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		if(!$this->BiSOFT_Model->is_database_exists($db_sales))
			{echo 'STOPPED! NOT EXISTS --> DB: '.$db_sales;die();}

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where("mode_id in ('E', 'BE')");
		$this->db->where('deleted',0);

		$this->db->group_by('doc_id');
		$this->db->order_by('doc_date, doc_id', 'asc');

		$data = $all_mackas = array();
		$all_data = $this->db->get()->result_array(); // $data['summary']

		// тук теглим детайлите .....
		$data['summary'] = $data['details'] = $macka_row = array();
		foreach($all_data as $key=>$value)
		{
         $macka_row = array();
			$this->db->select('
						doc_id,
						line,
						mode_id,
						doc_number,
						doc_date,
						item_number,
						item_name,
						item_qty, 
						item_unit_price, 
						item_discount,
						item_taxes,
						costsale,
						location', false);

			$this->db->from($db_sales_items);
			$this->db->where('doc_id = '.$value['doc_id']);
//			$this->db->where("item_number BETWEEN '98100' and '98300'");
			$this->db->where('deleted',0);
			

			$macka_rows = $this->db->get()->result_array();
			
         if(count($macka_rows)>0)
         { 
            $keyMacka = 0;
            foreach($macka_rows as $mRow)
            {
               $inum = $mRow['item_number'];
               if($inum > 98099 and $inum < 98300)  { $keyMacka = 1; }
            }

            if($keyMacka)
            {
               $data['summary'][$key] = $value; 
               $data['details'][$key] = $macka_rows; 
            }
         }
		}

	return $data;
	}

	
	
	public function getFenoData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = 'fenotags';
		$db_sales = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		if(!$this->BiSOFT_Model->is_database_exists($db_sales))
			{echo 'STOP! NOT EXISTS --> DB: '.$db_sales;die();}

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where("mode_id in ('E', 'BE')");
		$this->db->where('client_id',1359); // спец. за STYLER -> SAS FENOTAG
		$this->db->where('deleted',0);

		$this->db->group_by('doc_id');
		$this->db->order_by('doc_date, doc_id', 'asc');

		$data = array();
		$all_data = $this->db->get()->result_array(); // $data['summary']

		// тук теглим детайлите .....
		$data['summary'] = $data['details'] = $feno_row = array();
		foreach($all_data as $key=>$value)
		{
         $feno_row = array();
			$this->db->select('
						doc_id,
						line,
						mode_id,
						doc_number,
						doc_date,
						item_number,
						item_name,
						item_qty, 
						item_unit_price, 
						item_discount,
						item_taxes,
						costsale,
						location', false);

			$this->db->from($db_sales_items);
			$this->db->where('doc_id = '.$value['doc_id']);
			$this->db->where('deleted',0);
	
			$feno_rows = $this->db->get()->result_array();
			
         if(count($feno_rows)>0)
         { 
            $keyFeno = 0;
            foreach($feno_rows as $mRow)
            {
               $inum = $mRow['item_number'];
               if($inum >= 7000 and $inum < 7999)  { $keyFeno = 1; }
            }

            if($keyFeno)
            {
               $data['summary'][$key] = $value; 
               $data['details'][$key] = $feno_rows; 
            }
         }
		}

	return $data;
	}

	// Сумарна информация ...............
	public function getSummaryData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_sales = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';
		
		$firma = $this->BiSOFT_Model->get_firma_key();

		$this->db->select('
				sum(total_qty) 	as total_qty,
				sum(total_sum) 	as total_sum,
				sum(total_taxes) 	as total_vat,
				sum(pay_amount) 	as total_pay,
				sum(pay_sale) 		as total_cost,
				sum(due_sum) 		as total_due,
				total_discount'
                        );

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('total_discount != 100'); // специално за БЧК и отстъпките.
		$this->db->where('deleted',0);

		if ( $location == 0 ) 
		{ 
			switch ($mode) 
				{
               case 'all_sales':	   $this->db->where("mode_id in ('E', 'BE', 'SE', 'BP','OM', 'OMi', 'OMB')");
                                    if($firma['styler'])
                                    { $this->db->where("client_id != '1359' AND client_id != '1180' AND client_id != '1262' AND client_id != '1226'"); }
                                    break;
               case 'all_total':	   $this->db->where("mode_id in ('E', 'BE', 'SE', 'BP','OM', 'OMi', 'OMB')");	break;
               case 'all':	         $this->db->where("mode_id in ('E', 'BE', 'SE', 'BP','OM', 'OMi', 'OMB')");	break;
               case 'sale':			$this->db->where("mode_id in ('E', 'BE')");
                                    if($firma['styler'])
                                    { $this->db->where("client_id != '1359' AND client_id != '1180' AND client_id != '1262' AND client_id != '1226'"); }
                                    break;
               case 'shop_sale':		$this->db->where("mode_id in ('SE', 'BP')");		break;
               case 'online_sale':	$this->db->where("mode_id in ('OM', 'OMi', 'OMB')");	break;
               case 'online_return':$this->db->where("mode_id in ('OMB')");	      break;
               
               case 'kaca':			$this->db->where("mode_id in ('KPr')");
												$this->db->where("pay_group in ('P', 'T')"); break;
				}
		}
		else
		{
			$this->db->where('location', $location);
			switch ($mode) 
				{
               case 'all_shops':	   $this->db->where("mode_id in ('SE', 'BP')");	break;
               case 'shop_sale':		$this->db->where('mode_id', 'SE'); break;
               case 'shop_return':	$this->db->where('mode_id', 'BP'); break;
				}
		}

	return $this->db->get()->row_array();
	}
	
	
/* ====================================== Допълнителни Функции ======================================= */	
	
	/* ------ специална функция за рекалкулиране на ведмостта -------------- */
	function get_vedom_ids($vedom,$start_date,$end_date)
	{
		$db_sales = 'V'.$vedom;
		$this->db->select('doc_id, doc_date, mode_id');
		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $start_date . '" and "'. $end_date .'"');
		$this->db->where("mode_id in ('E', 'BE', 'SE', 'BP','OM', 'OMi', 'OMB')");
		$this->db->where('deleted = 0');
	
	return $this->db->get()->result_array();
	}
	
	
	/* ------ извадка на BRANDS -*/
	function get_vedom_ids_brands($vedom,$start_date,$end_date)
	{
		$db_sales = 'V'.$vedom;
		$this->db->select('doc_id, doc_number, mode_id, client_id, brand, location');
		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $start_date . '" and "'. $end_date .'"');
		$this->db->where("mode_id in ('E', 'BE', 'F', 'Ki', 'Di', 'KPr')");
		$this->db->where('location = 0');
		$this->db->where('deleted = 0');
	
	return $this->db->get()->result_array();
	}
	
	/* -- добавяне на BRANDS --*/
	function update_vedom_brands($vedom,$data)
	{
		$success = 1;
		$db_sales = 'V'.$vedom;
		$db_items = 'V'.$vedom.'_items';
		$doc_id = $data['doc_id'];
		
		$this->db->where('doc_id',$doc_id);
		$this->db->where('brand = 1');
		$success *= $this->db->update($db_sales,$data);
		
		$this->db->where('doc_id',$doc_id);
		$this->db->where('brand = 1');
		$success *= $this->db->update($db_items,$data);
		
		return $success;
	}
	
	public function recalc_vedom($vedom,$start_date,$end_date,$sale_type='sale')
	{
		$all_vedom_ids = $this->get_vedom_ids($vedom,$start_date,$end_date);
		foreach($all_vedom_ids as $row=>$doc)
		{
			$doc_id = $doc['doc_id'];
			$doc_idx = $doc_id.$vedom.'999';
			$this->BiSOFT_Model->recalc_document($doc_idx);
		}

	/*  изважда определени Клиенти и update-ва БД Ведомости...
		$all_vedom_ids = $this->get_vedom_ids_brands($vedom,$start_date,$end_date);
		foreach($all_vedom_ids as $client)
		{
			$our_Client = $client['client_id'];
			if($our_Client==595 or $our_Client==655 or $our_Client==761 or $our_Client==924)
			{
				$success = 0;
				$data = array(
				'doc_id' => $client['doc_id'],
				 'brand' => $our_Client );
		
				$success = $this->update_vedom_brands($vedom,$data);

				echo $our_Client.' ('.$success.') ==>> ';
				print_r($client);
				echo '<br>';
			}
		}
		die();
	*/

	return 1;
	}

} ?>
