<?php
require_once("Report.php");
class Export_invoice_table extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
		return array(
					$this->lang->line('reports_invoice_id'),
					$this->lang->line('reports_date'),
					$this->lang->line('reports_document'),
					$this->lang->line('reports_customer'),
					$this->lang->line('common_account_number'),
					$this->lang->line('reports_suma'),
					$this->lang->line('reports_invoice_vat'),
					$this->lang->line('reports_subtotal'),
					$this->lang->line('reports_free_bills'),
					$this->lang->line('reports_export_no_vat'),
					$this->lang->line('reports_export_vat'),
					$this->lang->line('reports_comments')
					);
	}
	
	public function getData(array $inputs)
	{
	$invoices = 'V'.date('ym', strtotime( $inputs['end_date'] ));

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				total_qty, 
				total_sum, 
				total_discount,
				taxed,
				total_taxes,
				pay_group,
				pay_type,
				pay_amount,
				client_id, 
				client, 
				employee_id,
				employee,
				comment,
				location',	false);

		$this->db->from($invoices);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

			switch ($inputs['sale_type']) 
				{
				case 'all': $this->db->where('mode_id in ("F", "Ki", "Di", "Pr")');	break;
				case 'invoice':		$this->db->where('mode_id = "F"');	break;
				case 'invoice_ki':	$this->db->where('mode_id = "Ki"');	break;
				case 'invoice_di':	$this->db->where('mode_id = "Di"');	break;
				case 'invoice_pr':	$this->db->where('mode_id = "Pr"');	break;
				}

		$this->db->group_by('doc_id');
		$this->db->order_by('doc_number');

	return $this->db->get()->result_array();
	}
	

}
?>
