<?php require_once("Report.php");
class Shops_daily_sales extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
      // взимам си размерите ...
      $size_table = $this->BiSOFT_Model->get_sizes('grid_2');

      return array(
					$this->lang->line('reports_item_number'), 
					$this->lang->line('reports_name'),
					'(1)','(2)','(3)','(4)','(5)',
					'(6)','(7)','(8)','(9)','(10)',
					$this->lang->line('reports_items_qty'), 
					$this->lang->line('reports_unit_price'), 
					$this->lang->line('reports_disc'), 
					$this->lang->line('reports_daily_price'), 
					$this->lang->line('reports_suma'),
					$this->lang->line('reports_report'),
					$this->lang->line('reports_shop_pay'),
					$this->lang->line('reports_type'),
					$this->lang->line('reports_magazin')
					);
	}
	

	public function getData(array $inputs)
	{
		// Взима правилната DB ... по обекти ...
		$location = $this->Employee->get_logged_in_client_info()->location;
		$daily_date = date('Y-m-d', strtotime( $inputs['start_date'] ));

		$vedom = 'S'.date('ym', strtotime( $inputs['start_date'])).'_items';

		$this->db->select('
					doc_id,
					mode_id,
					doc_number,
					doc_date,
					item_number,
					item_name,
					item_qty, 
					item_unit_price, 
					item_discount,
					item_taxes,
					costsale,
					location',	false);

		$this->db->from( $vedom);		
      $this->db->where('location', $location);
      switch ($inputs['sale_type']) 
         {
				case 'all':	$this->db->where("mode_id in ('SE', 'BP')");	break; // , 'E', 'BE'
				case 'shop_sale':		$this->db->where('mode_id', 'SE');	break;
				case 'shop_return':	$this->db->where('mode_id', 'BP');	break;
				case 'sale':		   $this->db->where('mode_id', 'E');	break;
				case 'sale_return':	$this->db->where('mode_id', 'BE');	break;
         }

		$this->db->where('doc_date', $daily_date);
		$this->db->where('deleted = 0');
		$this->db->order_by('doc_id');

	return $this->db->get()->result_array();
	}	
	
	
	public function getMonthColumns()
	{
      // взимам си размерите ...
      $size_table = $this->BiSOFT_Model->get_sizes('grid_2');

      return array(
               $this->lang->line('reports_date'),
					$this->lang->line('reports_item_number'), 
					$this->lang->line('reports_name'),
					'(1)','(2)','(3)','(4)','(5)',
					'(6)','(7)','(8)','(9)','(10)',
					$this->lang->line('reports_items_qty'), 
					$this->lang->line('reports_unit_price'), 
					$this->lang->line('reports_suma'),
					$this->lang->line('reports_shop_pay'),
					$this->lang->line('reports_type') );
	}	
	
	public function getMonthData(array $inputs)
	{  // Взима правилната DB ... по обекти ...
		$location = $this->Employee->get_logged_in_client_info()->location;
		$daily_date = date('Y-m-d', strtotime( $inputs['start_date'] ));

		$vedom = 'S'.date('ym', strtotime( $inputs['start_date'])).'_items';

		$this->db->select('
					doc_id,
					mode_id,
					doc_number,
					doc_date,
					item_number,
					item_name,
					item_qty, 
					item_unit_price, 
					item_discount,
					item_taxes,
					costsale,
					location',	false);

		$this->db->from( $vedom);		
      $this->db->where('location', $location);
      $this->db->where("mode_id in ('SE', 'BP')");
		$this->db->where('deleted = 0');
		$this->db->order_by('item_number');

	return $this->db->get()->result_array();
	}	
	
	
	public function getMonthDostavki(array $inputs)
	{  // Взима правилната DB ... по обекти ...
		$location = $this->Employee->get_logged_in_client_info()->location;
		$daily_date = date('Y-m-d', strtotime( $inputs['start_date'] ));

		$vedom = 'S'.date('ym', strtotime( $inputs['start_date'])).'_items';

		$this->db->select('
					doc_id,
					mode_id,
					doc_number,
					doc_date,
					item_number,
					item_name,
					item_qty, 
					item_unit_price, 
					item_discount,
					item_taxes,
					costsale,
					location',	false);

		$this->db->from( $vedom);		
      $this->db->where('location', $location);
      $this->db->where("mode_id in ('E', 'BC')");
		$this->db->where('deleted = 0');
		$this->db->order_by('item_number');

	return $this->db->get()->result_array();
	}	
	
	// Сумарна информация ...............
	public function getSummaryData(array $inputs)
	{ return true;}

	public function getPayment(array $inputs)
	{ // Взима правилната DB ... по обекти ...
		$daily_date = date('Y-m-d', strtotime( $inputs['start_date'] ));
			$vedom	 	 	 = date('ym', strtotime( $inputs['start_date'] ));
			$db_shops 		 = 'S'.$vedom;

		$this->db->select('pay_type',	false);
		$this->db->from( $db_shops);
		$this->db->where('doc_id', $inputs['doc_id']);

	return $this->db->get()->result_array();
	}

	
} ?>
