<?php
require_once("Report.php");
class Silvia_invoices extends Report
{
	function __construct()
	{
		parent::__construct();
	}

	public function getDataColumns()
	{
		return array(
					$this->lang->line('reports_invoice_id'), // 1
					$this->lang->line('reports_date'), // 2
					$this->lang->line('reports_type'), // 3
					$this->lang->line('reports_customer'), //4

								$this->lang->line('reports_item_number'), 
								$this->lang->line('reports_name'), 
								$this->lang->line('reports_quantity'),
								$this->lang->line('reports_unit_price'),
								$this->lang->line('reports_suma'), 
						);
	}
	

	public function getData(array $inputs)
	{
		$invoices 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$invoices_items = $invoices . '_items';
		$firma = $inputs['firma'];

		$this->db->select('
					mode_id,
					doc_number,
					doc_date,
					item_number, 
					item_name, 
					item_qty, 
					item_unit_price, 
					client_id,
					location', false);


		$this->db->from($invoices_items);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');
		$this->db->where('location',$firma);
		$this->db->where('item_number',$inputs['item']);

			switch ($inputs['sale_type']) 
				{
               case 'all': $this->db->where('mode_id in ("F", "Ki", "Di", "Pr")');	break;
               case 'invoice':		$this->db->where('mode_id = "F"');	break;
               case 'invoice_ki':	$this->db->where('mode_id = "Ki"');	break;
               case 'invoice_di':	$this->db->where('mode_id = "Di"');	break;
               case 'invoice_pr':	$this->db->where('mode_id = "Pr"');	break;
				}

		$this->db->order_by('doc_number', 'asc');

	return $this->db->get()->result_array();
	}
	
	
	public function getMonthsData(array $inputs)
	{
		$vedom = $inputs['vedom'];
		$firma = $inputs['firma'];
		$item  = $inputs['item'];

		$this->db->select('
					mode_id,
					doc_number,
					doc_date,
					item_number, 
					item_name, 
					item_qty, 
					item_unit_price, 
					client_id,
					location', false);

		$this->db->from($vedom);
		$this->db->where('deleted', 0);
		$this->db->where('location', $firma);
		$this->db->where('item_number', $item);

			switch ($inputs['sale_type']) 
				{
               case 'all': $this->db->where('mode_id in ("F", "Ki", "Di", "Pr")');	break;
               case 'invoice':		$this->db->where('mode_id = "F"');	break;
               case 'invoice_ki':	$this->db->where('mode_id = "Ki"');	break;
               case 'invoice_di':	$this->db->where('mode_id = "Di"');	break;
               case 'invoice_pr':	$this->db->where('mode_id = "Pr"');	break;
				}

		$this->db->order_by('doc_number', 'asc');

	return $this->db->get()->result_array();
	}
	

	public function getSummaryData(array $inputs)
	{
		$invoices 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$invoices_items = $invoices . '_items';
		$firma = $inputs['firma'];
		
		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				total_qty, 
				total_sum, 
				total_discount,
				taxed,
				total_taxes,
				pay_group,
				pay_type,
				pay_amount,
				client_id, 
				client, 
				employee_id,
				employee,
				comment,
				location',	false);

		$this->db->from($invoices);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');
		$this->db->where('location',$firma);
			
			switch ($inputs['sale_type']) 
				{
               case 'all': $this->db->where('mode_id in ("F", "Ki", "Di", "Pr")');	break;
               case 'invoice':		$this->db->where('mode_id = "F"');		break;
               case 'invoice_ki':	$this->db->where('mode_id = "Ki"');	break;
               case 'invoice_di':	$this->db->where('mode_id = "Di"');	break;
               case 'invoice_pr':	$this->db->where('mode_id = "Pr"');	break;
				}

		$this->db->group_by('item_number');
		$this->db->order_by('item_number', 'asc');		

	return $this->db->get()->row_array();	
	}

} ?>
