<?php require_once("Report.php");

class Specific_consignee extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
	// взимам си размерите ...
	$size_table = $this->BiSOFT_Model->get_sizes('grid_2');

	return array(	
			'summary' => array(
					$this->lang->line('reports_sale_id'), 		// 1
					$this->lang->line('reports_date'), 			// 2
					$this->lang->line('reports_items_purchased'),  // 3
					$this->lang->line('reports_SUMA'),  		// 4
					$this->lang->line('reports_discount'), 	// 5
					$this->lang->line('reports_gros_sales'),  // 6
					$this->lang->line('reports_pay_sale'),		// 7
					$this->lang->line('reports_payments'), 	// 8
					$this->lang->line('reports_Discount'),		// 9 $this->lang->line('reports_due_sum'),
					$this->lang->line('reports_sold_to'),  	// 10
					$this->lang->line('reports_sold_by'),  	// 11
					$this->lang->line('reports_location'),  	// 13
					),

			'details' => array(
								$this->lang->line('reports_line'),
								$this->lang->line('reports_item_number'), 
								$this->lang->line('reports_name'), 
								$this->lang->line('reports_quantity_purchased'), 
								$this->lang->line('reports_unit_price'), 
								$this->lang->line('reports_disc'), 
								$this->lang->line('reports_daily_price'),
									 	$size_table->size_1, 
										$size_table->size_2, 
										$size_table->size_3,
										$size_table->size_4,
										$size_table->size_5,
										$size_table->size_6,
										$size_table->size_7,
										$size_table->size_8,
										$size_table->size_9,
										$size_table->size_max 
								)
				);		
	}

	public function getData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$bisoft_id = $inputs['bisoft_id'];

		$db_sales 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';
/*
		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				total_qty, 
				total_sum, 
				total_discount,
				taxed,
				total_taxes,
				pay_group,
				pay_type,
				pay_amount,
				pay_sale,
				due_sum,
				order_id,
				giftowner,
				giftprocent,
				giftvalue,
				client_id, 
				client, 
				employee_id,
				employee,
				comment,
				date_start,
				location',	false);
*/
		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'" and location='.$bisoft_id);
	
		switch ($mode) 
				{
				case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');	break;
				case 'daily_sale':	$this->db->where('mode_id in ("SE", "BP")');	break;
				case 'groups':			$this->db->where('mode_id in ("SE", "BP")');	break;
				case 'consi':			$this->db->where('mode_id in ("C", "CB")');	break;
				case 'revision':		$this->db->where('mode_id', 'R');				break;
				}

		if ($mode!='daily_sale') { $this->db->group_by('doc_id');}
		else { $this->db->group_by('doc_date');}

		$this->db->order_by('doc_date');

		$data = array();
		$data['summary'] = $this->db->get()->result_array();

		// тук теглим детайлите .....
		$data['details'] = array();
		foreach($data['summary'] as $key=>$value)
		{
		$this->db->select('
					line,
					mode_id,
					doc_number,
					doc_date,
					item_number,
					item_name,
					item_qty,
					item_unit_price,
					item_discount,
					item_taxes,
					costsale,
					client_id,
					location', false);

			$this->db->from($db_sales_items);
			$this->db->where('doc_id = '.$value['doc_id']);

			$data['details'][$key] = $this->db->get()->result_array();
		}
	return $data;
	}

// --------------------------------------- DAILY REPORTS --------------------------------- //
	public function getDailyColumns()
	{
	return array(

					$this->lang->line('reports_date'), 			// 1
					$this->lang->line('reports_items_purchased'),  // 2
					$this->lang->line('reports_suma'),  		// 3
					$this->lang->line('reports_discount'), 	// 4
					$this->lang->line('reports_total'),   		// 5
					$this->lang->line('reports_pay_sale'),		// 6
					$this->lang->line('reports_due_sum'),		// 7
					$this->lang->line('reports_sold_by'),  	// 8
					$this->lang->line('reports_location'), 	// 9
					$this->lang->line('reports_comments') 		// 10
					);		
	}

	public function getDaily(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$bisoft_id = $inputs['bisoft_id'];

		$db_sales 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) as total_qty, 
				sum(total_sum) as total_sub, 
				total_discount,
				taxed,
				sum(total_taxes) as total_vat,
				pay_group,
				pay_type,
				sum(pay_amount) as total_sum,
				sum(pay_sale) as total_cost,
				sum(due_sum) as total_due,
				giftowner,
				giftprocent,
				giftvalue,
				client_id, 
				client, 
				employee_id,
				employee,
				comment,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'" and location='.$bisoft_id);
	
		$this->db->where('mode_id in ("SE", "BP")');
		$this->db->group_by('doc_date');
		$this->db->order_by('doc_date');

		$data = array();
		$data['summary'] = $this->db->get()->result_array();

		// тук теглим детайлите .....
		$data['details'] = array();
		foreach($data['summary'] as $key=>$value)
		{
		$this->db->select('
					line,
					mode_id,
					doc_number,
					doc_date,
					item_number, 
					item_name, 
					item_qty, 
					item_unit_price, 
					item_discount,
					item_taxes,
					costsale,
					client_id,
					location',	false);

			$this->db->from($db_sales_items);
			$this->db->where('doc_id = '.$value['doc_id']);

			$data['details'][$key] = $this->db->get()->result_array();
		}
	return $data;
	}


// ----------------------------------------- GROUPS ----------------------------------------- //
	public function getGroupColumns()
	{
	// взимам си размерите ...
	$size_table = $this->BiSOFT_Model->get_sizes('grid_2');

	return array(
					$this->lang->line('reports_item_number'), 
					$this->lang->line('reports_name'), 
						$size_table->size_1, 
						$size_table->size_2, 
						$size_table->size_3,
						$size_table->size_4,
						$size_table->size_5,
						$size_table->size_6,
						$size_table->size_7,
						$size_table->size_8,
						$size_table->size_9,
						$size_table->size_max,
					$this->lang->line('reports_items_purchased'),
					$this->lang->line('reports_daily_price'),
					$this->lang->line('reports_discount'),
					$this->lang->line('reports_suma')
					);
	}
	
	public function getGroups(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = 'groups';
		$bisoft_id = $inputs['bisoft_id'];

		$item_from 	= 1000 * $inputs['item'];
		$item_to 	= $item_from + 1000;

		$db_sales 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		$this->db->select('
					doc_id,
					mode_id,
					doc_number,
					doc_date,
					item_number, 
					item_name,
					item_qty,  
					item_unit_price, 
					item_discount,
					item_taxes,
					costsale,
					client_id,
					location',	false);

		$this->db->from( $db_sales_items);
		$this->db->where("mode_id in ('SE', 'BP')");
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'" and item_number BETWEEN "'.$item_from. '" and "'.$item_to.'" and location='.$bisoft_id);

		$this->db->where('deleted = 0');

		$this->db->order_by('item_number');

	return $this->db->get()->result_array();
	}
	

	//  ---------------------------------- Сумарна Информация --------------------------- //
	public function getSummaryData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$bisoft_id = $inputs['bisoft_id'];

		$db_sales 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		$this->db->select('
				sum(total_qty) as total_qty,
				sum(total_sum) as total_sum,
				sum(total_taxes) as total_vat,
				sum(pay_sale) as total_cost,
				sum(due_sum) as total_due,
				sum(pay_amount) as total_pay');

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'" and location='.$inputs['bisoft_id']);

		switch ($mode) 
				{
				case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');	break;
				case 'daily_sale':	$this->db->where('mode_id in ("SE", "BP")');	break;
				case 'groups':			$this->db->where('mode_id in ("SE", "BP")');	break;
				case 'consi':			$this->db->where('mode_id in ("C", "CB")');	break;
				case 'revision':		$this->db->where('mode_id', 'R');				break;
				}

	return $this->db->get()->row_array();
	}
}
?>
