<?php require_once("Report.php");
class Summary_consignees extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
		return array(
				$this->lang->line('reports_date_period'),
				$this->lang->line('reports_item_number'),
				$this->lang->line('reports_customer'),
				$this->lang->line('reports_quantity'),
				$this->lang->line('reports_SUMA'),
				$this->lang->line('reports_gros_sales'),
				$this->lang->line('reports_pay_sale'),
				$this->lang->line('reports_Discount'),
				'Отст.(%)' );
	}
	
	public function getData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$client_id = $inputs['client_id'];
		$db_sales 		 = 'V'.$inputs['vedom']; // 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) 		as all_qty, 
				sum(total_sum) 		as subtotal, 
				sum(total_discount) 	as discount,
				sum(total_taxes) 		as tax,
				sum(pay_amount) 		as total,
				sum(pay_sale) 			as pay_sale,
				sum(due_sum) 			as due_sum,
				client_id, 
				client, 
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');
		if($client_id)
			{ $this->db->where('location',$client_id);}
		else 
			{ $this->db->where('location != 0');}

			switch ($inputs['sale_type']) 
				{
					case 'all':				$this->db->where('mode_id in ("SE", "BP")');		break;
					case 'consi':			$this->db->where('mode_id in ("C", "CB")');		break;
					case 'balance':		$this->db->where('mode_id in ("BL", "SBL")'); 	break;
					case 'brak':			$this->db->where('mode_id = "AB"');					break;
					case 'revision':		$this->db->where('mode_id = "R"');					break;
				}

		$this->db->group_by('location');
		$this->db->order_by('location', 'asc');

	return $this->db->get()->result_array();
	}
	
	
	/* ===========  Duties ============= */
	public function getDueColumns()
	{
		return array(
				$this->lang->line('reports_item_number'),
				$this->lang->line('reports_customer'),
				$this->lang->line('kaca_start_saldo'),
				$this->lang->line('reports_SALES'),
				$this->lang->line('reports_INVOICES'),
				$this->lang->line('reports_edit_paid'),
				$this->lang->line('reports_due_sum')
						);
	}
	
	
	public function getDueConsiData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['mode'];
		$db_sales = 'V'.$inputs['vedom'];

		$this->db->select('
				mode,
				mode_id,
				doc_date,
				pay_group,
				sum(total_sum) 		as total,
				sum(total_taxes) 		as tax,
				sum(pay_amount) 		as amount,
				sum(pay_sale) 			as paid,
				sum(pay_vat) 			as vat,
				sum(due_sum) 			as due,
				total_discount,
				client_id,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');

		switch ($mode) 
		{
			case 'sales':	$this->db->where('mode_id in ("SE", "BP")');break;
			case 'paid':	$this->db->where('mode_id', 'KPr');break;
		}		
		
		$this->db->where('location > 0');
		$this->db->where(' client_id = location ');
		$this->db->where('total_discount != 100');
		$this->db->where('deleted',0);

		$this->db->group_by('client_id');
		$this->db->order_by('client_id', 'asc');

	return $this->db->get()->result_array();
	}
	
	
	
	public function getGraphData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$client_id = $inputs['client_id'];
		$db_sales 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) 		as all_qty, 
				sum(total_sum) 		as subtotal, 
				sum(total_discount) 	as discount,
				sum(total_taxes) 		as tax,
				sum(pay_amount) 		as total,
				sum(pay_sale) 			as pay_sale,
				sum(due_sum) 			as due_sum,
				client_id, 
				client, 
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');
		if($client_id)
			{ $this->db->where('location',$client_id);}
		else 
			{ $this->db->where('location != 0');}

			switch ($inputs['sale_type']) 
				{
				case 'all':				$this->db->where('mode_id in ("SE", "BP")');		break;
				case 'consi':			$this->db->where('mode_id in ("C", "CB")');		break;
				case 'balance':		$this->db->where('mode_id in ("BL", "SBL")'); 	break;
				case 'brak':			$this->db->where('mode_id = "AB"');					break;
				case 'revision':		$this->db->where('mode_id = "R"');					break;
				}

		$this->db->group_by('location');
		$this->db->order_by('location', 'asc');

	return $this->db->get()->result_array();
	}

	public function getSummaryData(array $inputs)
	{
		$mode = $inputs['sale_type'];

		$db_sales 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		$this->db->select('sum(total_qty) as all_quantity, sum(total_sum) as total');
		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');
		$this->db->where('location != 0');

			switch ($inputs['sale_type']) 
				{
				case 'all':				$this->db->where('mode_id in ("SE", "BP")');		break;
				case 'consi':			$this->db->where('mode_id in ("C", "CB")');		break;
				case 'balance':		$this->db->where('mode_id in ("BL", "SBL")'); 	break;
				case 'brak':			$this->db->where('mode_id = "AB"');					break;
				case 'revision':		$this->db->where('mode_id = "R"');					break;
				}
		
	return $this->db->get()->row_array();	
	}

} ?>
