<?php require_once("Report.php");

class Summary_customers extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
		return array(
				$this->lang->line('reports_date_period'),
				$this->lang->line('reports_item_number'),
				$this->lang->line('reports_customer'),
				$this->lang->line('reports_quantity'),
				$this->lang->line('reports_SUMA'),
				$this->lang->line('reports_gros_sales'),
				$this->lang->line('reports_pay_sale'),
				$this->lang->line('reports_Discount'),
				'Отст.(%)' );
	}
	
	public function getInvoiceColumns()
	{
		return array(
				$this->lang->line('reports_date_period'),
				$this->lang->line('reports_item_number'),
				$this->lang->line('reports_customer'),
				$this->lang->line('reports_quantity'),
				$this->lang->line('reports_SUMA'),
				$this->lang->line('reports_invoice_vat'),
				$this->lang->line('reports_total'),
				$this->lang->line('reports_invoice_error')
						);
	}
	
	
	public function getDueColumns()
	{
		return array(
				$this->lang->line('reports_item_number'),
				$this->lang->line('reports_customer'),
				$this->lang->line('kaca_start_saldo'),
				$this->lang->line('reports_SALES'),
				$this->lang->line('reports_INVOICES'),
				$this->lang->line('reports_edit_paid'),
				$this->lang->line('reports_due_sum'),
				$this->lang->line('customers_add_vat')
						);
	}
	
	public function getData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$client_id = $inputs['client_id'];
		$firma = $inputs['firma'];
		$db_sales 		 = 'V'.$inputs['vedom'];

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) 		as all_qty, 
				sum(total_sum) 		as subtotal, 
				sum(total_discount) 	as discount,
				sum(total_taxes) 		as tax,
				sum(pay_amount) 		as total,
				sum(pay_sale) 			as pay_sale,
				sum(due_sum) 			as due_sum,
				client_id, 
				client,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');
		if(!$firma) {$this->db->where('location',0);}
		else {$this->db->where('location',$firma);}
		
		if($client_id) { $this->db->where('client_id', $client_id);}

			switch ($mode) 
				{
					case 'all':				$this->db->where('mode_id in ("E", "BE", "ED")'); break;
					case 'invoice':		$this->db->where('mode_id in ("F", "Ki", "Di", "Pr")'); break;
					case 'sale':			$this->db->where('mode_id', 'E'); break;
					case 'sale_return':	$this->db->where('mode_id', 'BE'); break;
					case 'discount':	   $this->db->where('mode_id', 'ED'); break;
				}

		$this->db->group_by('client_id');
		$this->db->order_by('client_id', 'asc');

	return $this->db->get()->result_array();
	}
	
	
	public function getDueClients(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$db_sales = 'V'.$inputs['vedom'];

		$this->db->select('
				mode_id,
				doc_date,
				client_id,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('location',0);		
		$this->db->where('mode_id in ("KPr", "E", "BE", "ED", "F", "Ki", "Di", "Pr")');
		$this->db->where('deleted',0);

		$this->db->group_by('client_id');
		$this->db->order_by('client_id', 'asc');

	return $this->db->get()->result_array();
	}
	
	
	public function getDueClientsData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['mode'];
		$db_sales = 'V'.$inputs['vedom'];

		$this->db->select('
				mode,
				mode_id,
				doc_date,
				pay_group,
				sum(total_sum) 		as total,
				sum(total_taxes) 		as tax,
				sum(pay_amount) 		as amount,
				sum(pay_sale) 			as paid,
				sum(pay_vat) 			as vat,
				sum(due_sum) 			as due,
				total_discount,
				client_id,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
			
		// $this->db->where('mode_id in ("KPr", "E", "BE", "ED", "F", "Ki", "Di", "Pr")');
		switch ($mode) 
		{
			case 'sales':	$this->db->where('mode_id in ("E", "BE", "ED")'); break;
			case 'invs':	$this->db->where('mode_id in ("F", "Ki", "Pr")'); break; // , "Ki", "Di"
			case 'paid':	$this->db->where('mode_id', 'KPr'); break;
			case 'razhod':	$this->db->where('mode_id', 'KRz'); break;
			
			case 'macka':	$this->db->where('mode in ("prihod_macka_zags")'); break;
		}		
		
		$this->db->where('location',0);	
		$this->db->where('total_discount != 100');	
		$this->db->where('deleted',0);

		$this->db->group_by('client_id');
		$this->db->order_by('client_id', 'asc');

	return $this->db->get()->result_array();
	}
	
	public function getGraphData(array $inputs)
	{
		$mode = $inputs['sale_type'];
		$db_sales 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) 		as all_qty, 
				sum(total_sum) 		as subtotal, 
				sum(total_discount) 	as discount,
				sum(total_taxes) 		as tax,
				sum(pay_amount) 		as total,
				sum(pay_sale) 			as pay_sale,
				sum(due_sum) 			as due_sum,
				client_id, 
				client,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

			switch ($mode) 
				{
					case 'all':				$this->db->where('mode_id in ("E", "BE", "ED")'); break;
					case 'invoice':		$this->db->where('mode_id in ("F", "Ki", "Di", "Pr")'); break;
					case 'sale':			$this->db->where('mode_id', 'E'); break;
					case 'sale_return':	$this->db->where('mode_id', 'BE'); break;
					case 'discount':	   $this->db->where('mode_id', 'ED'); break;
				}

		$this->db->group_by('client');
		$this->db->order_by('client', 'asc');

	return $this->db->get()->result_array();
	}
	
	public function getInvoices(array $inputs)
	{
		$client_id = $inputs['client_id'];
		$db_sales  = 'V'.$inputs['vedom'];
		$db_sales_items = $db_sales . '_items';

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) 		as total_qty, 
				sum(total_sum) 		as total_sum, 
				sum(total_taxes) 		as total_taxes,
				sum(pay_amount) 		as pay_amount,
				client_id, 
				client,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');
		$this->db->where('location', 0);
		if($client_id) { $this->db->where('client_id', $client_id);}

		$this->db->where('mode_id in ("F", "Ki", "Di", "Pr")');

		$this->db->group_by('client_id');
		$this->db->order_by('client_id', 'asc');

	return $this->db->get()->result_array();
	}

	
	public function getSummaryData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_sales 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		$this->db->select('sum(total_qty) as all_quantity, sum(total_sum) as total');
		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted', 0);
		$this->db->where('location', 0);

			switch ($mode) 
				{
					case 'all':				$this->db->where('mode_id in ("E", "BE")'); break;
					case 'invoice':		$this->db->where('mode_id in ("F", "Ki", "Di", "Pr")'); break;
					case 'sale':			$this->db->where('mode_id', 'E'); break;
					case 'sale_return':	$this->db->where('mode_id', 'BE'); break;
				}
		
	return $this->db->get()->row_array();	
	}
	
/* =============================== ONLINE CLIENTS ================================ */
	public function getOnlineColumns()
	{
		return array(
				$this->lang->line('reports_date_period'),
				$this->lang->line('reports_item_number'),
				$this->lang->line('reports_customer'),
				$this->lang->line('reports_quantity'),
				$this->lang->line('reports_SUMA'),
				$this->lang->line('reports_vat'),
				$this->lang->line('reports_total'),
				$this->lang->line('reports_pay_sale')
						);
	}

	public function getOnlineData(array $inputs)
	{
		$client_id = $inputs['client_id'];
		$db_sales 		 = 'V'.$inputs['vedom'];

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) 		as all_qty, 
				sum(total_sum) 		as subtotal, 
				sum(total_discount) 	as discount,
				sum(total_taxes) 		as tax,
				sum(pay_amount) 		as total,
				sum(pay_sale) 			as pay_sale,
				client_id, 
				client,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');
		
		if($client_id==1) // 1 - online shop
			{ 
			  $this->db->where('mode_id in ("OM", "OMi", "OMB")');
			}
		elseif($client_id>1) // other Online Client
			{ 
			  $this->db->where('client_id', $client_id);
			  $this->db->where('mode_id in ("E", "BE")');
			  $this->db->group_by('client_id');
			}
		else // това е грешка.
			{
			  $this->db->where('mode_id in ("E", "BE")');
			  $this->db->group_by('client_id');
			}

	return $this->db->get()->result_array();
	}

} ?>
