<?php
require_once("Report.php");
class Summary_employees extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
		return array(
            $this->lang->line('reports_item_number'),
				$this->lang->line('reports_employee'),
				$this->lang->line('reports_quantity'),
				$this->lang->line('reports_all'),
				$this->lang->line('reports_gros_sales'),
				$this->lang->line('reports_location') );
	}
	
	public function getData(array $inputs)
	{
      $mode = $inputs['sale_type'];
      if ($mode == 'all') {$mode = 'sale';}

		// Взима правилната DB ... по обекти ...
		$location = $this->BiSOFT_Model->get_location();
      $daily_YEAR = date('ym', strtotime( $inputs['end_date'] ));
		$db_sales   = 'V'.$daily_YEAR;

		$this->db->select('	
				doc_id, 
				mode_id,
				sum(total_qty)  as total_qty, 
				sum(total_sum)  as total_sum, 
				sum(pay_amount) as pay_amount,
				employee_id,
				employee,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

		switch ($inputs['sale_type']) 
			{
				case 'all':				$this->db->where('mode_id in ("E", "BE", "SE", "BP")');break;
				case 'sale':			$this->db->where('mode_id in ("E", "BE")');		break;
				case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');		break;
			}

		$this->db->group_by('employee_id');
		$this->db->order_by('employee', 'asc');

	return $this->db->get()->result_array();
	}
	


	public function getSummaryData(array $inputs)
	{
	$mode = $inputs['sale_type'];
	if ($mode == 'all') {$mode = 'sale';}

		// Взима правилната DB ... по обекти ...
		$location = $this->BiSOFT_Model->get_location();

			$daily_YEAR 	 = date('ym', strtotime( $inputs['end_date'] ));
			$db_sales 		 = 'V'.$daily_YEAR ;

		$this->db->select('sum(total_sum) as total_sum, sum(pay_amount) as pay_amount, sum(total_qty) as total_qty');
		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

		switch ($inputs['sale_type']) 
			{
				case 'all':				$this->db->where('mode_id in ("E", "BE", "SE", "BP")'); break;
				case 'sale':			$this->db->where('mode_id in ("E", "BE")');  break;
				case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');	break;
			}
		
	return $this->db->get()->row_array();	
	}

}
?>
