<?php require_once("Report.php");

class Summary_items extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
		return array(
            $this->lang->line('reports_date_period'),
				$this->lang->line('reports_item'),
				$this->lang->line('reports_description'),
				$this->lang->line('reports_quantity'),
				$this->lang->line('reports_total')
				);
	}
	
	public function getData(array $inputs)
	{	
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$group = $inputs['group'];
         $minGR = 1000*$group;
         $maxGR = 1000*($group+1)-1;
		
		$db_sales_items = 'V'.$inputs['vedom'].'_items';

		$this->db->select('
					line,
					mode_id,
					doc_number,
					doc_date,
					item_number,
				sum(item_qty) 		as all_qty,
				sum(item_qty*item_unit_price*(100-item_discount)/100) as total, 
				sum(item_taxes) as tax,
				sum(costsale)	 as all_costsale,				
					location',	false);

		$this->db->from($db_sales_items);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');
	
		if($group)
		{ $this->db->where('item_number BETWEEN "'.$minGR. '" and "'.$maxGR.'"'); }
		
			switch ($mode) 
				{
					case 'all': $this->db->where('mode_id in ("E","BE","SE","BP","OM","OMi","OMB")'); break;
					case 'sale':			$this->db->where('mode_id in ("E", "BE")');	break;
					case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');	break;
					case 'online_sale':	$this->db->where('mode_id in ("OM", "OMi", "OMB")'); break;
					case 'manu':			$this->db->where('mode_id', 'MK');	break;
					case 'recv':			$this->db->where('mode_id in ("D", "BD")'); break;
					case 'consi':			$this->db->where('mode_id in ("C", "CB")'); break;
				}

		$this->db->group_by('item_number, mode_id');
		$this->db->order_by('item_number', 'asc');

	return $this->db->get()->result_array();
	}

	
	public function getSummaryData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_sales_items = 'V'.$inputs['vedom'].'_items';

		$this->db->select('sum(item_qty) as all_quantity, sum(item_qty*item_unit_price*(100-item_discount)/100) as total');
		$this->db->from($db_sales_items);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

			switch ($inputs['sale_type']) 
				{
					case 'all': $this->db->where('mode_id in ("E","BE","SE","BP","OM","OMi","OMB")'); break;
					case 'sale':			$this->db->where('mode_id in ("E", "BE")');	break;
					case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');	break;
					case 'online_sale':	$this->db->where('mode_id in ("OM", "OMi")'); break;
					case 'manu':			$this->db->where('mode_id', 'MK');	break;
					case 'recv':			$this->db->where('mode_id in ("D", "BD")');	break;
					case 'consi':			$this->db->where('mode_id in ("C", "CB")');	break;
				}
		
	return $this->db->get()->row_array();	
	}
	
} ?>
