<?php
require_once("Report.php");
class Summary_profits extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
		return array(
				$this->lang->line('items_item_number'),	// 1
				$this->lang->line('reports_item'),			// 2
				$this->lang->line('reports_quantity'),		// 4
				$this->lang->line('items_cost_price'),		// 3
				$this->lang->line('reports_suma'),			// 6
				$this->lang->line('reports_sales'),			// 5
				$this->lang->line('reports_profit')			// 7
				);
	}
	
	public function getData(array $inputs)
	{	
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_sales 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		$this->db->select('
					line,
					mode_id,
					doc_number,
					doc_date,
					item_number, 
					item_name, 
				sum(item_qty) 		as all_qty,
				sum(item_unit_price*item_qty) as total, 
				sum(item_taxes)	as tax,
					location',	false);

		$this->db->from($db_sales_items);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

			switch ($inputs['sale_type']) 
				{
				case 'all':				$this->db->where('mode_id in ("E", "BE", "SE", "BP")'); break;
				case 'sale':			$this->db->where('mode_id in ("E", "BE")'); break;
				case 'online':			$this->db->where('mode_id in ("OM", "OMi", "OMB")'); break;
				case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")'); break;
				}

		$this->db->group_by('item_number, mode_id');
		$this->db->order_by('item_number', 'asc');

	return $this->db->get()->result_array();
	}

	
	public function getSummaryData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_sales = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_sales_items = $db_sales . '_items';

		$this->db->select('sum(item_qty) as all_quantity, sum(item_qty*item_unit_price*(100-item_discount)/100) as total');
		$this->db->from($db_sales_items);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

			switch ($inputs['sale_type']) 
				{
				case 'all':				$this->db->where('mode_id in ("E", "BE", "SE", "BP")');	break;
				case 'sale':			$this->db->where('mode_id in ("E", "BE")');	break;
				case 'online':			$this->db->where('mode_id in ("OM", "OMi", "OMB")'); break;
				case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');	break;
				}
		
	return $this->db->get()->row_array();	
	}

} ?>