<?php
require_once("Report.php");
class Summary_recvs extends Report
{
	function __construct()
	{
		parent::__construct();
	}

	public function getDataColumns()
	{
		return array(
				$this->lang->line('reports_date'),
				$this->lang->line('reports_quantity'),
				$this->lang->line('reports_suma'),
				$this->lang->line('reports_discount'),
				$this->lang->line('reports_tax'),
				$this->lang->line('reports_total')
				);
	}
	

	public function getData(array $inputs)
	{	
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_recvs = 'V'.date('ym', strtotime( $inputs['end_date'] ));

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) 		as all_qty, 
				sum(total_sum) 		as subtotal, 
				sum(total_discount) 	as discount,
				total_discount,
				sum(total_taxes) as tax,
				sum(pay_amount) as total,
				client_id, 
				client, 
				location',	false);

		$this->db->from($db_recvs);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('total_discount != 100');	
		$this->db->where('deleted',0);

			switch ($mode) 
				{
					case 'manu':			$this->db->where('mode_id = "MK"');				break;
					case 'macka':			$this->db->where('mode_id = "MSK"');			break;
					case 'recv':			$this->db->where('mode_id in ("D", "BD")');	break;
					case 'consi':			$this->db->where('mode_id in ("C", "CB")');	break;
					case 'offer':			$this->db->where('mode_id', 'Of');				break;
					case 'balance':		$this->db->where('mode_id in ("BL", "SBL")'); break;
					case 'brak':			$this->db->where('mode_id = "AB"');				break;
					case 'revision':		$this->db->where('mode_id = "R"');				break;
				}

		$this->db->group_by('doc_date');
		$this->db->order_by('doc_date', 'asc');

	return $this->db->get()->result_array();
	}
	

	public function getSummaryData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_recvs = 'V'.date('ym', strtotime( $inputs['end_date'] ));

		$this->db->select('sum(total_qty) as all_quantity, sum(pay_amount) as total');
		$this->db->from($db_recvs);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

			switch ($mode) 
				{
					case 'manu':			$this->db->where('mode_id = "MK"');				break;
					case 'macka':			$this->db->where('mode_id = "MSK"');			break;
					case 'recv':			$this->db->where('mode_id in ("D", "BD")');	break;
					case 'consi':			$this->db->where('mode_id in ("C", "CB")');	break;
					case 'offer':			$this->db->where('mode_id', 'Of');				break;
					case 'balance':		$this->db->where('mode_id in ("BL", "SBL")'); break;
					case 'brak':			$this->db->where('mode_id = "AB"');				break;
					case 'revision':		$this->db->where('mode_id = "R"');				break;
				}
		
	return $this->db->get()->row_array();	
	}

} ?>
