<?php require_once("Report.php");

class Summary_sales extends Report
{
	function __construct()
	{
		parent::__construct();
	}

	public function getDataColumns($sale_type='sale')
	{
		if($sale_type!='giftcards')
		{ return array(
				$this->lang->line('reports_date'),
				$this->lang->line('reports_quantity'),
				$this->lang->line('reports_SUMA'),
				$this->lang->line('reports_discount'),
				$this->lang->line('reports_invoice_vat'),
				$this->lang->line('reports_total'),
				$this->lang->line('reports_comments')	);
		}
		else // само за с ваучери
		{ return array(
				$this->lang->line('giftcards_giftcard'),
				$this->lang->line('giftcards_card_owner'),
				$this->lang->line('reports_discount'),
				$this->lang->line('reports_suma'),
				$this->lang->line('reports_comments')	);
		}
	}
	

	public function getData(array $inputs)
	{	
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_sales = 'V'.$inputs['vedom'];

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) 		as all_qty, 
				sum(total_sum) 		as subtotal, 
				sum(total_discount) 	as discount,
				total_discount,
				taxed,
				sum(total_taxes) 		as tax,
				pay_group,
				pay_type,
				sum(pay_amount) 		as total,
				giftcard,
				giftvalue,
				client_id, 
				client,
				employee_id,
				employee,
				comment,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'.$inputs['start_date'].'" and "'.$inputs['end_date'].'"');
		$this->db->where('total_discount != 100');	
		$this->db->where('deleted',0);

		switch ($mode) 
			{
				case 'all':				$this->db->where('mode_id in ("E", "BE", "SE", "BP", "OM", "OMi")');	break;
				case 'sale':			$this->db->where('mode_id in ("E", "BE")');	break;
				case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');	break;
				case 'online_sale':	$this->db->where('mode_id in ("OM", "OMi")');	break;
				case 'giftcards':		$this->db->where('giftcard > 0');	break;
			}

      $this->db->order_by('doc_date', 'asc');
		if($mode=='giftcards')
			{ $this->db->group_by('giftcard');}
		else
			{ $this->db->group_by('doc_date');}

	return $this->db->get()->result_array();
	}
	

	public function getSummaryData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_sales = 'V'.date('ym', strtotime( $inputs['end_date'] ));

		$this->db->select('sum(total_qty) as all_quantity,
								 sum(total_taxes) as invoice_vat,
								 sum(giftvalue) as giftvalue,
								 sum(pay_amount) as total');

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('deleted = 0');

		switch ($mode) 
			{
				case 'all':				$this->db->where('mode_id in ("E", "BE", "SE", "BP", "OM", "OMi")');	break;
				case 'sale':			$this->db->where('mode_id in ("E", "BE")');	break;
				case 'shop_sale':		$this->db->where('mode_id in ("SE", "BP")');	break;
				case 'online_sale':	$this->db->where('mode_id in ("OM", "OMi")');	break;
				case 'giftcards':		$this->db->where('giftcard > 0');	break;
			}
		
	return $this->db->get()->row_array();	
	}

}
?>
