<?php require_once("Report.php");
class Summary_suppliers extends Report
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function getDataColumns()
	{
		return array(
				$this->lang->line('reports_date_period'),
				$this->lang->line('reports_item_number'),
				$this->lang->line('reports_supplier'),
				$this->lang->line('reports_quantity'),
				$this->lang->line('reports_SUMA'),
				$this->lang->line('reports_Discount'),
				$this->lang->line('reports_total')
						);
	}
	
	public function getDueColumns()
	{
		return array(
				$this->lang->line('reports_item_number'),
				$this->lang->line('reports_supplier'),
				$this->lang->line('kaca_start_saldo'),
				$this->lang->line('reports_RECV'),
				$this->lang->line('reports_kaca_favours'),
				$this->lang->line('reports_edit_payments'),
				$this->lang->line('reports_kaca_saldo')
						);
	}
	
	public function getData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$supplier_id = $inputs['supplier_id'];
		$db_recvs 		 = 'V'.$inputs['vedom']; // 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_recvs_items = $db_recvs . '_items';

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) 		as all_qty, 
				sum(total_sum) 		as subtotal, 
				sum(total_discount) 	as discount,
				sum(total_taxes) 		as tax,
				sum(pay_amount) 		as total,
				supplier_id, 
				supplier, 
				comment,
				location',	false);

		$this->db->from($db_recvs);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('supplier_id > 0');
		$this->db->where('deleted = 0');
		if($supplier_id) { $this->db->where('supplier_id', $supplier_id);}

			switch ($inputs['sale_type']) 
				{
					case 'all':	$this->db->where("mode_id in ('D','DY','BD')");	break;
					case 'recv':			$this->db->where('mode_id', 'D');	break;
					case 'recv_return':	$this->db->where('mode_id', 'BD');	break;
					case 'usluga':			$this->db->where('mode_id', 'DY');	break;
				}

		$this->db->group_by('supplier_id');
		$this->db->order_by('supplier_id', 'asc');

	return $this->db->get()->result_array();
	}
	
	
	
	public function getDueSuppliers(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$db_sales = 'V'.$inputs['vedom'];

		$this->db->select('
				mode_id,
				doc_date,
				supplier_id,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('location',0);		
		$this->db->where('mode_id in ("KPr", "KRz", "D", "BD", "DY")');
		$this->db->where('supplier_id > 0');
		$this->db->where('deleted',0);

		$this->db->group_by('supplier_id');
		$this->db->order_by('supplier_id', 'asc');

	return $this->db->get()->result_array();
	}
	
	

	public function getDueSuppliersData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['mode'];
		$db_sales = 'V'.$inputs['vedom'];

		$this->db->select('
				mode,
				mode_id,
				doc_date,
				pay_group,
				sum(total_sum) 		as total,
				sum(total_taxes) 		as tax,
				sum(pay_amount) 		as amount,
				sum(pay_sale) 			as paid,
				sum(pay_vat) 			as vat,
				sum(due_sum) 			as due,
				total_discount,
				supplier_id,
				location',	false);

		$this->db->from($db_sales);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('location',0);
		switch ($mode) 
		{
			case 'recvs':	$this->db->where('mode_id in ("D", "BD")'); break;
		//	case 'usluga':	$this->db->where('mode','razhod_due');$this->db->where('mode_id','KRz');break;
			case 'usluga':	$this->db->where('mode_id','DY');break;
			case 'paid':	$this->db->where('mode_id','KPr'); break;
			case 'razhod':	$this->db->where('mode_id','KRz'); break;
		}		
		
		$this->db->where('total_discount != 100');
		$this->db->where('deleted',0);

		$this->db->group_by('supplier_id');
		$this->db->order_by('supplier_id', 'asc');

	return $this->db->get()->result_array();
	}
	
	
	public function getGraphData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_recvs 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_recvs_items = $db_recvs . '_items';

		$this->db->select('	
				doc_id, 
				mode,
				mode_id,
				doc_number, 
				doc_date,
				sum(total_qty) 		as all_qty, 
				sum(total_sum) 		as subtotal, 
				sum(total_discount) 	as discount,
				sum(total_taxes) 		as tax,
				sum(pay_amount) 		as total,
				supplier_id, 
				supplier, 
				comment,
				location',	false);

		$this->db->from($db_recvs);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('supplier_id > 0');
		$this->db->where('deleted = 0');
		if($supplier_id) { $this->db->where('supplier_id', $supplier_id);}

			switch ($inputs['sale_type']) 
				{
					case 'all':	$this->db->where("mode_id in ('D','BD','DY')");	break;
					case 'recv':			$this->db->where('mode_id', 'D');	break;
					case 'recv_return':	$this->db->where('mode_id', 'BD');	break;
					case 'usluga':			$this->db->where('mode_id', 'DY');	break;
				}

		$this->db->group_by('supplier_id');
		$this->db->order_by('supplier_id', 'asc');

	return $this->db->get()->result_array();
	}

	public function getSummaryData(array $inputs)
	{
		$location = $this->BiSOFT_Model->get_location();
		$mode = $inputs['sale_type'];
		$db_recvs 		 = 'V'.date('ym', strtotime( $inputs['end_date'] ));
		$db_recvs_items = $db_recvs . '_items';

		$this->db->select('sum(total_sum) as total');
		$this->db->from($db_recvs);
		$this->db->where('doc_date BETWEEN "'. $inputs['start_date']. '" and "'. $inputs['end_date'].'"');
		$this->db->where('supplier_id > 0');
		$this->db->where('deleted = 0');

			switch ($inputs['sale_type']) 
				{
					case 'all':	$this->db->where("mode_id in ('D','BD','DY')");	break;
					case 'recv':			$this->db->where('mode_id', 'D');	break;
					case 'recv_return':	$this->db->where('mode_id', 'BD');	break;
					case 'usluga':			$this->db->where('mode_id', 'DY');	break;
				}
		
	return $this->db->get()->row_array();	
	}

}
?>
