//	==========================================================================
//	settingsManager:
// Отговорност за дефиниране на променливите и функционалностите
//	==========================================================================
var settingsManager = (function($,BrowserDetect) 
{

    // ---------------------------------------
    // VARIABLES
    // ---------------------------------------
    var $body = $('body');
    var windowWidth = $(window).width();
    var w_phone = '768'; // Phone
    //var w_tablet = '992'; // Tablet
    var w_ldesktop = '2100'; // Large Desktop
    var is_Mobile = false;
    var is_Tablet = false;
    var is_Desktop = false;
    var is_LDesktop = false;
    var iDevice = false;
    var aDevice = false;
    var wDevice = false;
    var bDevice = false;

    var navegador = BrowserDetect.browser;
    var vers = BrowserDetect.version;

    // ---------------------------------------
    // FUNCTIONS
    // ---------------------------------------

    function init() {
        _osDeviceDetection();
        _typeDeviceDetection();
        _injectCustomCSS();
    //    _setCookieBanner();
    }

    function _osDeviceDetection() {

        if (navigator) {
            var ua = navigator.userAgent;
            // iPhone+iPod+iPad
            if (ua.match(/(iPhone|iPod|iPad)/) !== null) iDevice = true;
            // Android
            if (ua.match(/(Android)/) !== null) aDevice = true;
            // Windows Phone
            if (ua.match(/(Windows Phone|Windows CE)/) !== null) wDevice = true;
            // Blackberry
            if (ua.match(/(BlackBerry|BB10)/) !== null) bDevice = true;
        }
    }

    function _typeDeviceDetection() {

        if (windowWidth < w_phone) {
            if (iDevice || aDevice || wDevice || bDevice) {
                is_Mobile = true;
            }
        } else if (windowWidth >= w_phone) {
            if (iDevice || aDevice || wDevice || bDevice) {
                is_Tablet = true;
            } else {
                is_Desktop = true;
                if (windowWidth > w_ldesktop) is_LDesktop = true;
            }
        }
    }

    function _injectCustomCSS() {

        if (iDevice) $body.addClass('iDevice');
        else $body.addClass('notiDevice');

        if (aDevice) $body.addClass('aDevice');
        else $body.addClass('notaDevice');

        if (wDevice) $body.addClass('wDevice');
        else $body.addClass('notwDevice');

        if (bDevice) $body.addClass('bDevice');
        else $body.addClass('notbDevice');

        if (is_Mobile) {
            $body.addClass('isMobile');
        } else if (is_Tablet) {
            $body.addClass('isTablet');
        } else if (is_Desktop) {
            $body.addClass('isDesktop');
            if (is_LDesktop) $body.addClass('isLDesktop');
        }

        if(navigator.userAgent.indexOf('Android')>0 && navigator.userAgent.indexOf('GT-')>0 && navigator.userAgent.indexOf('Mobile Safari')>0 && $(window).width()<'703'){
            $body.addClass('sIII');
        }

        $body.addClass(navegador.toLowerCase());
        $body.addClass(navegador.toLowerCase()+vers.toString());
    }
/*    
    function _setCookieBanner() {
    	 document.cookie="mangoShopBannerCookiesShown=true; expires=Thu, 18 Dec 2020 12:00:00 UTC; path=/";
    }
*/
    function isMobile() 
    { return is_Mobile;}

    function isTablet() 
    { return is_Tablet;}

    function isDesktop() 
    { return is_Desktop;}

    function existsHeader() 
    { return $('header').length > 0;}

    return {
        init: init,
        isMobile: isMobile,
        isTablet: isTablet,
        isDesktop: isDesktop,
        existsHeader: existsHeader
    };

})(jQuery,BrowserDetect);


// ==========================================================================
// Ready
// ==========================================================================
$(document).ready(function() 
{

    var sm = settingsManager;
    sm.init();
/*    
    if (sm.isMobile() || sm.isTablet() || (sm.isDesktop() && $("html").hasClass("outlet"))) phSliderCtrl.init();
    phFormCtrl.init();
*/
});

// ==========================================================================
// Load
// ==========================================================================
$(window).load(function() 
{

    var sm = settingsManager;
    if (sm.isDesktop() && !$("html").hasClass("outlet")) {
        var $video = $("#phVideo");
        $video.addClass("play");
        $video.get(0).play();
    }
/*    
    countryInfoDetected = $('.countrySelect').find("option:selected");
    countryIdDetected = countryInfoDetected.val();
	 countryNameDetected = countryInfoDetected.html();
    phFormCtrl.gaShowPreHome(countryIdDetected, countryNameDetected);
*/
    
});
